/*************************************************************************
 *
 *  $RCSfile: treeopt.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:25:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _BASEDLGS_HXX //autogen
#include <bf_sfx2/basedlgs.hxx>
#endif
#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif
#ifndef _SVTREEBOX_HXX //autogen
#include <svtools/svtreebx.hxx>
#endif
#ifndef _TOOLS_RESARY_HXX
#include <tools/resary.hxx>
#endif
#ifndef _SV_IMAGE_HXX //autogen
#include <vcl/image.hxx>
#endif
#ifndef _SV_FIXBRD_HXX //autogen
#include <vcl/fixbrd.hxx>
#endif
namespace binfilter {

#define NUMBER_OF_OPTION_PAGES  12
class SfxModule;
class SfxShell;
struct OptionsPageInfo;

//STRIP001 class OfaOptionsTreeListBox : public SvTreeListBox
//STRIP001 {
//STRIP001 private:
//STRIP001 	BOOL 			bInCollapse;
//STRIP001 
//STRIP001 public:
//STRIP001 	OfaOptionsTreeListBox(Window* pParent, const ResId& rResId) :
//STRIP001 		SvTreeListBox( pParent, rResId ), bInCollapse(FALSE) {}
//STRIP001 
//STRIP001 	virtual BOOL    Collapse( SvLBoxEntry* pParent );
//STRIP001 	BOOL			IsInCollapse()const {return bInCollapse;}
//STRIP001 };

/* -----------------11.02.99 07:51-------------------
 *
 * --------------------------------------------------*/
//STRIP001 class OfaTreeOptionsDialog : public SfxModalDialog
//STRIP001 {
//STRIP001 private:
//STRIP001 	OKButton		aOkPB;
//STRIP001 	CancelButton    aCancelPB;
//STRIP001 	HelpButton 		aHelpPB;
//STRIP001 	PushButton 		aBackPB;
//STRIP001 
//STRIP001 	FixedBorder		aHiddenGB;
//STRIP001 	FixedText 		aPageTitleFT;
//STRIP001 	FixedLine		aLine1FL;
//STRIP001 	FixedText		aHelpFT;
//STRIP001 	FixedImage 		aHelpImg;
//STRIP001 
//STRIP001     ImageList       aPageImages;
//STRIP001     ImageList       aPageImagesHC;
//STRIP001 
//STRIP001 	ResStringArray	aHelpTextsArr;
//STRIP001 
//STRIP001 	OfaOptionsTreeListBox	aTreeLB;
//STRIP001 
//STRIP001 	String 			sTitle;
//STRIP001 	String			sHintTitle;
//STRIP001 	String			sNotLoadedError;
//STRIP001 
//STRIP001 	const OptionsPageInfo*	pHintInfo;
//STRIP001 	SvLBoxEntry*			pCurrentPageEntry;
//STRIP001 
//STRIP001 	// for the ColorTabPage
//STRIP001 	SfxItemSet*		pColorPageItemSet;
//STRIP001 	XColorTable*	pColorTab;
//STRIP001 	USHORT			nChangeType;
//STRIP001 	USHORT 			nUnknownType;
//STRIP001 	USHORT			nUnknownPos;
//STRIP001 	BOOL			bIsAreaTP;
//STRIP001 
//STRIP001 	BOOL			bForgetSelection;
//STRIP001 	BOOL			bExternBrowserActive;
//STRIP001 	BOOL			bImageResized;
//STRIP001 
//STRIP001 	Timer			aHintTimer;
//STRIP001 	Timer			aSelectTimer;
//STRIP001 
//STRIP001 	static USHORT 	nLastDialogPageId;
//STRIP001 
//STRIP001 	void			StartHint( const OptionsPageInfo* pInfo, const XubString& rTitle );
//STRIP001 	void			ShowHint();
//STRIP001 
//STRIP001 protected:
//STRIP001 		DECL_LINK(ExpandedHdl_Impl, SvTreeListBox* );
//STRIP001 		DECL_LINK(ShowPageHdl_Impl, SvTreeListBox* );
//STRIP001 		DECL_LINK(BackHdl_Impl, PushButton* );
//STRIP001 		DECL_LINK( OKHdl_Impl, Button * );
//STRIP001 		DECL_LINK( HintHdl_Impl, Timer * );
//STRIP001 		DECL_LINK( SelectHdl_Impl, Timer * );
//STRIP001 
//STRIP001 		virtual long	Notify( NotifyEvent& rNEvt );
//STRIP001 		virtual void 	DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 
//STRIP001 public:
//STRIP001 		OfaTreeOptionsDialog(Window* pParent);
//STRIP001 		~OfaTreeOptionsDialog();
//STRIP001 
//STRIP001 		void	AddTabPage( USHORT nId,	const String& rPageName, USHORT nGroup);
//STRIP001 		USHORT	AddGroup(const String& rGroupName,	SfxShell* pCreateShell,
//STRIP001 									SfxModule* pCreateModule, USHORT nDialogId);
//STRIP001 		void	ActivateLastSelection();
//STRIP001 		void	ActivatePage(USHORT nResId);
//STRIP001 		void	ApplyItemSets();
//STRIP001 
//STRIP001 
//STRIP001 	USHORT					GetColorChanged() const { return nChangeType; }
//STRIP001 	XColorTable*			GetColorTable() { return pColorTab; }
//STRIP001 };
/* -----------------11.02.99 15:49-------------------
 *
 * --------------------------------------------------*/
//STRIP001 class OfaPageResource : public Resource
//STRIP001 {
//STRIP001 	ResStringArray		aGeneralDlgAry;
//STRIP001 	ResStringArray	 	aInetDlgAry;
//STRIP001     ResStringArray      aLangDlgAry;
//STRIP001     ResStringArray      aTextDlgAry;
//STRIP001 	ResStringArray		aHTMLDlgAry;
//STRIP001 	ResStringArray		aCalcDlgAry;
//STRIP001 	ResStringArray		aStarMathDlgAry;
//STRIP001 	ResStringArray		aImpressDlgAry;
//STRIP001 	ResStringArray		aDrawDlgAry;
//STRIP001 	ResStringArray		aChartDlgAry;
//STRIP001 	ResStringArray		aFilterDlgAry;
//STRIP001 	ResStringArray		aDatasourcesDlgAry;
//STRIP001 
//STRIP001 public:
//STRIP001 	OfaPageResource();
//STRIP001 
//STRIP001 	ResStringArray& GetGeneralArray() 		{return aGeneralDlgAry;}
//STRIP001 	ResStringArray& GetInetArray() 			{return aInetDlgAry;}
//STRIP001     ResStringArray& GetLangArray()			{return aLangDlgAry;}
//STRIP001 	ResStringArray& GetTextArray() 			{return aTextDlgAry;}
//STRIP001 	ResStringArray& GetHTMLArray() 			{return aHTMLDlgAry;}
//STRIP001 	ResStringArray& GetCalcArray() 			{return aCalcDlgAry;}
//STRIP001 	ResStringArray& GetStarMathArray()		{return aStarMathDlgAry;}
//STRIP001 	ResStringArray& GetImpressArray() 		{return aImpressDlgAry;}
//STRIP001 	ResStringArray& GetDrawArray() 			{return aDrawDlgAry;}
//STRIP001 	ResStringArray& GetChartArray()			{return aChartDlgAry;}
//STRIP001 	ResStringArray& GetFilterArray() 		{return aFilterDlgAry;}
//STRIP001 	ResStringArray& GetDatasourcesArray()	{return aDatasourcesDlgAry;}
//STRIP001 };


} //namespace binfilter