/*************************************************************************
 *
 *  $RCSfile: sc_drawsh5.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/01/11 11:31:20 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

//------------------------------------------------------------------

// auto strip #include <bf_svx/eeitem.hxx>

// auto strip #include <bf_sfx2/request.hxx>
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #include <tools/urlobj.hxx>
// auto strip #include <bf_svx/dlgname.hxx>
// auto strip #include <bf_svx/fmglob.hxx>
// auto strip #include <bf_svx/hlnkitem.hxx>
// auto strip #include <bf_svx/fontwork.hxx>
// auto strip #include <bf_svx/svdoole2.hxx>
#include <bf_svx/svdouno.hxx>
// auto strip #include <bf_svx/xdef.hxx>
// auto strip #include <bf_svx/xftsfit.hxx>
// auto strip #include <vcl/msgbox.hxx>

// auto strip #include <com/sun/star/form/FormButtonType.hpp>
// auto strip #include <com/sun/star/beans/XPropertySet.hpp>
// auto strip #include <com/sun/star/beans/XPropertySetInfo.hpp>
// auto strip #include <com/sun/star/awt/XControlModel.hpp>

// auto strip #include "drawsh.hxx"
// auto strip #include "drawview.hxx"
// auto strip #include "viewdata.hxx"
// auto strip #include "tabvwsh.hxx"
// auto strip #include "docsh.hxx"
// auto strip #include "strindlg.hxx"
// auto strip #include "scresid.hxx"
// auto strip #include "undotab.hxx"
// auto strip #include "drwlayer.hxx"

#include "bf_sc.hrc"
#include "so3/staticbaseurl.hxx"
namespace binfilter {

using namespace ::com::sun::star;

//------------------------------------------------------------------

//STRIP001 void ScDrawShell::GetHLinkState( SfxItemSet& rSet )             //  Hyperlink
//STRIP001 {
//STRIP001     ScDrawView* pView = pViewData->GetScDrawView();
//STRIP001     const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001     ULONG nMarkCount = rMarkList.GetMarkCount();
//STRIP001 
//STRIP001         //  Hyperlink
//STRIP001 
//STRIP001     SvxHyperlinkItem aHLinkItem;
//STRIP001 
//STRIP001     if ( nMarkCount == 1 )              // URL-Button markiert ?
//STRIP001     {
//STRIP001         SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001         SdrUnoObj* pUnoCtrl = PTR_CAST(SdrUnoObj, pObj);
//STRIP001         if (pUnoCtrl && FmFormInventor == pUnoCtrl->GetObjInventor())
//STRIP001         {
//STRIP001             uno::Reference<awt::XControlModel> xControlModel = pUnoCtrl->GetUnoControlModel();
//STRIP001             DBG_ASSERT( xControlModel.is(), "UNO-Control ohne Model" );
//STRIP001             if( !xControlModel.is() )
//STRIP001                 return;
//STRIP001 
//STRIP001             uno::Reference< beans::XPropertySet > xPropSet( xControlModel, uno::UNO_QUERY );
//STRIP001             uno::Reference< beans::XPropertySetInfo > xInfo = xPropSet->getPropertySetInfo();
//STRIP001 
//STRIP001             ::rtl::OUString sPropButtonType  = ::rtl::OUString::createFromAscii( "ButtonType" );
//STRIP001             ::rtl::OUString sPropTargetURL   = ::rtl::OUString::createFromAscii( "TargetURL" );
//STRIP001             ::rtl::OUString sPropTargetFrame = ::rtl::OUString::createFromAscii( "TargetFrame" );
//STRIP001             ::rtl::OUString sPropLabel       = ::rtl::OUString::createFromAscii( "Label" );
//STRIP001 
//STRIP001             if(xInfo->hasPropertyByName( sPropButtonType ))
//STRIP001             {
//STRIP001                 uno::Any aAny = xPropSet->getPropertyValue( sPropButtonType );
//STRIP001                 form::FormButtonType eTmp;
//STRIP001                 if ( (aAny >>= eTmp) && eTmp == form::FormButtonType_URL )
//STRIP001                 {
//STRIP001                     ::rtl::OUString sTmp;
//STRIP001                     // Label
//STRIP001                     if(xInfo->hasPropertyByName( sPropLabel ))
//STRIP001                     {
//STRIP001                         aAny = xPropSet->getPropertyValue( sPropLabel );
//STRIP001                         if ( (aAny >>= sTmp) && sTmp.getLength() )
//STRIP001                         {
//STRIP001                             aHLinkItem.SetName(sTmp);
//STRIP001                         }
//STRIP001                     }
//STRIP001                     // URL
//STRIP001                     if(xInfo->hasPropertyByName( sPropTargetURL ))
//STRIP001                     {
//STRIP001                         aAny = xPropSet->getPropertyValue( sPropTargetURL );
//STRIP001                         if ( (aAny >>= sTmp) && sTmp.getLength() )
//STRIP001                         {
//STRIP001                             aHLinkItem.SetURL(sTmp);
//STRIP001                         }
//STRIP001                     }
//STRIP001                     // Target
//STRIP001                     if(xInfo->hasPropertyByName( sPropTargetFrame ))
//STRIP001                     {
//STRIP001                         aAny = xPropSet->getPropertyValue( sPropTargetFrame );
//STRIP001                         if ( (aAny >>= sTmp) && sTmp.getLength() )
//STRIP001                         {
//STRIP001                             aHLinkItem.SetTargetFrame(sTmp);
//STRIP001                         }
//STRIP001                     }
//STRIP001                     aHLinkItem.SetInsertMode(HLINK_BUTTON);
//STRIP001                 }
//STRIP001             }
//STRIP001         }
//STRIP001     }
//STRIP001 
//STRIP001     rSet.Put(aHLinkItem);
//STRIP001 }

//STRIP001 void ScDrawShell::ExecuteHLink( SfxRequest& rReq )
//STRIP001 {
//STRIP001     const SfxItemSet* pReqArgs = rReq.GetArgs();
//STRIP001 
//STRIP001     USHORT nSlot = rReq.GetSlot();
//STRIP001     switch ( nSlot )
//STRIP001     {
//STRIP001         case SID_HYPERLINK_SETLINK:
//STRIP001             if( pReqArgs )
//STRIP001             {
//STRIP001                 const SfxPoolItem* pItem;
//STRIP001                 if ( pReqArgs->GetItemState( SID_HYPERLINK_SETLINK, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001                 {
//STRIP001                     const SvxHyperlinkItem* pHyper = (const SvxHyperlinkItem*) pItem;
//STRIP001                     const String& rName     = pHyper->GetName();
//STRIP001                     const String& rURL      = pHyper->GetURL();
//STRIP001                     const String& rTarget   = pHyper->GetTargetFrame();
//STRIP001                     SvxLinkInsertMode eMode = pHyper->GetInsertMode();
//STRIP001 
//STRIP001                     BOOL bDone = FALSE;
//STRIP001                     if ( eMode == HLINK_DEFAULT || eMode == HLINK_BUTTON )
//STRIP001                     {
//STRIP001                         ScDrawView* pView = pViewData->GetScDrawView();
//STRIP001                         const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001                         if ( rMarkList.GetMarkCount() == 1 )
//STRIP001                         {
//STRIP001                             SdrUnoObj* pUnoCtrl = PTR_CAST(SdrUnoObj, rMarkList.GetMark(0)->GetObj());
//STRIP001                             if (pUnoCtrl && FmFormInventor == pUnoCtrl->GetObjInventor())
//STRIP001                             {
//STRIP001                                 uno::Reference<awt::XControlModel> xControlModel =
//STRIP001                                                         pUnoCtrl->GetUnoControlModel();
//STRIP001                                 DBG_ASSERT( xControlModel.is(), "UNO-Control ohne Model" );
//STRIP001                                 if( !xControlModel.is() )
//STRIP001                                     return;
//STRIP001 
//STRIP001                                 uno::Reference< beans::XPropertySet > xPropSet( xControlModel, uno::UNO_QUERY );
//STRIP001                                 uno::Reference< beans::XPropertySetInfo > xInfo = xPropSet->getPropertySetInfo();
//STRIP001 
//STRIP001                                 ::rtl::OUString sPropTargetURL =
//STRIP001                                     ::rtl::OUString::createFromAscii( "TargetURL" );
//STRIP001 
//STRIP001                                 // Darf man eine URL an dem Objekt setzen?
//STRIP001                                 if (xInfo->hasPropertyByName( sPropTargetURL ))
//STRIP001                                 {
//STRIP001                                     // Ja!
//STRIP001 
//STRIP001                                     ::rtl::OUString sPropButtonType =
//STRIP001                                         ::rtl::OUString::createFromAscii( "ButtonType" );
//STRIP001                                     ::rtl::OUString sPropTargetFrame =
//STRIP001                                         ::rtl::OUString::createFromAscii( "TargetFrame" );
//STRIP001                                     ::rtl::OUString sPropLabel =
//STRIP001                                         ::rtl::OUString::createFromAscii( "Label" );
//STRIP001 
//STRIP001                                     uno::Any aAny;
//STRIP001                                     aAny <<= ::rtl::OUString(rName);
//STRIP001                                     xPropSet->setPropertyValue( sPropLabel, aAny );
//STRIP001 
//STRIP001                                     aAny <<= ::rtl::OUString(so3::StaticBaseUrl::RelToAbs(rURL));
//STRIP001                                     xPropSet->setPropertyValue( sPropTargetURL, aAny );
//STRIP001 
//STRIP001                                     if( rTarget.Len() )
//STRIP001                                     {
//STRIP001                                         aAny <<= ::rtl::OUString(rTarget);
//STRIP001                                         xPropSet->setPropertyValue( sPropTargetFrame, aAny );
//STRIP001                                     }
//STRIP001 
//STRIP001                                     form::FormButtonType eButtonType = form::FormButtonType_URL;
//STRIP001                                     aAny <<= eButtonType;
//STRIP001                                     xPropSet->setPropertyValue( sPropButtonType, aAny );
//STRIP001 
//STRIP001                                     //! Undo ???
//STRIP001                                     pViewData->GetDocShell()->SetDocumentModified();
//STRIP001                                     bDone = TRUE;
//STRIP001                                 }
//STRIP001                             }
//STRIP001                         }
//STRIP001                     }
//STRIP001 
//STRIP001                     if (!bDone)
//STRIP001                         pViewData->GetViewShell()->
//STRIP001                             InsertURL( rName, rURL, rTarget, (USHORT) eMode );
//STRIP001 
//STRIP001                     //  InsertURL an der ViewShell schaltet bei "Text" die DrawShell ab !!!
//STRIP001                 }
//STRIP001             }
//STRIP001             break;
//STRIP001         default:
//STRIP001             DBG_ERROR("falscher Slot");
//STRIP001     }
//STRIP001 }

USHORT ScGetFontWorkId();       // wegen CLOOKs - in drtxtob2

//------------------------------------------------------------------

//
//          Funktionen auf Drawing-Objekten
//

//STRIP001 void ScDrawShell::ExecDrawFunc( SfxRequest& rReq )
//STRIP001 {
//STRIP001     SfxBindings& rBindings = pViewData->GetBindings();
//STRIP001     ScTabView*   pTabView  = pViewData->GetView();
//STRIP001     ScDrawView*  pView     = pTabView->GetScDrawView();
//STRIP001     Window*      pWin      = pTabView->GetActiveWin();
//STRIP001     const SfxItemSet *pArgs = rReq.GetArgs();
//STRIP001     USHORT nSlotId = rReq.GetSlot();
//STRIP001 
//STRIP001     //!!!
//STRIP001     // wer weiss, wie lange das funktioniert? (->vom Abreisscontrol funktioniert es)
//STRIP001     //
//STRIP001     if (nSlotId == SID_OBJECT_ALIGN && pArgs)
//STRIP001         nSlotId = SID_OBJECT_ALIGN + ((SfxEnumItem&)pArgs->Get(SID_OBJECT_ALIGN)).GetValue() + 1;
//STRIP001 
//STRIP001     switch (nSlotId)
//STRIP001     {
//STRIP001         case SID_OBJECT_HEAVEN:
//STRIP001             pView->SetMarkedToLayer( SC_LAYER_FRONT );
//STRIP001             rBindings.Invalidate(SID_OBJECT_HEAVEN);
//STRIP001             rBindings.Invalidate(SID_OBJECT_HELL);
//STRIP001             break;
//STRIP001         case SID_OBJECT_HELL:
//STRIP001             pView->SetMarkedToLayer( SC_LAYER_BACK );
//STRIP001             rBindings.Invalidate(SID_OBJECT_HEAVEN);
//STRIP001             rBindings.Invalidate(SID_OBJECT_HELL);
//STRIP001             //  leave draw shell if nothing selected (layer may be locked)
//STRIP001             if ( pView->GetMarkList().GetMarkCount() == 0 )
//STRIP001                 pViewData->GetViewShell()->SetDrawShell( FALSE );
//STRIP001             break;
//STRIP001 
//STRIP001         case SID_FRAME_TO_TOP:
//STRIP001             pView->PutMarkedToTop();
//STRIP001             break;
//STRIP001         case SID_FRAME_TO_BOTTOM:
//STRIP001             pView->PutMarkedToBtm();
//STRIP001             break;
//STRIP001         case SID_FRAME_UP:
//STRIP001             pView->MovMarkedToTop();
//STRIP001             break;
//STRIP001         case SID_FRAME_DOWN:
//STRIP001             pView->MovMarkedToBtm();
//STRIP001             break;
//STRIP001 
//STRIP001         case SID_GROUP:
//STRIP001             pView->GroupMarked();
//STRIP001             break;
//STRIP001         case SID_UNGROUP:
//STRIP001             pView->UnGroupMarked();
//STRIP001             break;
//STRIP001         case SID_ENTER_GROUP:
//STRIP001             pView->EnterMarkedGroup();
//STRIP001             break;
//STRIP001         case SID_LEAVE_GROUP:
//STRIP001             pView->LeaveOneGroup();
//STRIP001             break;
//STRIP001 
//STRIP001         case SID_MIRROR_HORIZONTAL:
//STRIP001             pView->MirrorAllMarkedHorizontal();
//STRIP001             break;
//STRIP001         case SID_MIRROR_VERTICAL:
//STRIP001             pView->MirrorAllMarkedVertical();
//STRIP001             break;
//STRIP001 
//STRIP001         case SID_OBJECT_ALIGN_LEFT:
//STRIP001             if (pView->IsAlignPossible())
//STRIP001                 pView->AlignMarkedObjects(SDRHALIGN_LEFT, SDRVALIGN_NONE);
//STRIP001             break;
//STRIP001         case SID_OBJECT_ALIGN_CENTER:
//STRIP001             if (pView->IsAlignPossible())
//STRIP001                 pView->AlignMarkedObjects(SDRHALIGN_CENTER, SDRVALIGN_NONE);
//STRIP001             break;
//STRIP001         case SID_OBJECT_ALIGN_RIGHT:
//STRIP001             if (pView->IsAlignPossible())
//STRIP001                 pView->AlignMarkedObjects(SDRHALIGN_RIGHT, SDRVALIGN_NONE);
//STRIP001             break;
//STRIP001         case SID_OBJECT_ALIGN_UP:
//STRIP001             if (pView->IsAlignPossible())
//STRIP001                 pView->AlignMarkedObjects(SDRHALIGN_NONE, SDRVALIGN_TOP);
//STRIP001             break;
//STRIP001         case SID_OBJECT_ALIGN_MIDDLE:
//STRIP001             if (pView->IsAlignPossible())
//STRIP001                 pView->AlignMarkedObjects(SDRHALIGN_NONE, SDRVALIGN_CENTER);
//STRIP001             break;
//STRIP001         case SID_OBJECT_ALIGN_DOWN:
//STRIP001             if (pView->IsAlignPossible())
//STRIP001                 pView->AlignMarkedObjects(SDRHALIGN_NONE, SDRVALIGN_BOTTOM);
//STRIP001             break;
//STRIP001 
//STRIP001         case SID_DELETE:
//STRIP001         case SID_DELETE_CONTENTS:
//STRIP001             pView->DeleteMarked();
//STRIP001             if (!pTabView->IsDrawSelMode())
//STRIP001                 pViewData->GetViewShell()->SetDrawShell( FALSE );
//STRIP001             break;
//STRIP001 
//STRIP001         case SID_CUT:
//STRIP001             pView->DoCut();
//STRIP001             if (!pTabView->IsDrawSelMode())
//STRIP001                 pViewData->GetViewShell()->SetDrawShell( FALSE );
//STRIP001             break;
//STRIP001 
//STRIP001         case SID_COPY:
//STRIP001             pView->DoCopy();
//STRIP001             break;
//STRIP001 
//STRIP001         case SID_PASTE:
//STRIP001             DBG_ERROR( "SdrView::PasteClipboard not supported anymore" );
//STRIP001             // pView->PasteClipboard( pWin );
//STRIP001             break;
//STRIP001 
//STRIP001         case SID_SELECTALL:
//STRIP001             pView->MarkAll();
//STRIP001             break;
//STRIP001 
//STRIP001         case SID_ANCHOR_PAGE:
//STRIP001             pView->SetAnchor( SCA_PAGE );
//STRIP001             rBindings.Invalidate( SID_ANCHOR_PAGE );
//STRIP001             rBindings.Invalidate( SID_ANCHOR_CELL );
//STRIP001             break;
//STRIP001 
//STRIP001         case SID_ANCHOR_CELL:
//STRIP001             pView->SetAnchor( SCA_CELL );
//STRIP001             rBindings.Invalidate( SID_ANCHOR_PAGE );
//STRIP001             rBindings.Invalidate( SID_ANCHOR_CELL );
//STRIP001             break;
//STRIP001 
//STRIP001         case SID_ANCHOR_TOGGLE:
//STRIP001             {
//STRIP001                 switch( pView->GetAnchor() )
//STRIP001                 {
//STRIP001                     case SCA_CELL:
//STRIP001                     pView->SetAnchor( SCA_PAGE );
//STRIP001                     break;
//STRIP001                     default:
//STRIP001                     pView->SetAnchor( SCA_CELL );
//STRIP001                     break;
//STRIP001                 }
//STRIP001             }
//STRIP001             rBindings.Invalidate( SID_ANCHOR_PAGE );
//STRIP001             rBindings.Invalidate( SID_ANCHOR_CELL );
//STRIP001             break;
//STRIP001 
//STRIP001         case SID_OBJECT_ROTATE:
//STRIP001             {
//STRIP001                 SdrDragMode eMode;
//STRIP001                 if (pView->GetDragMode() == SDRDRAG_ROTATE)
//STRIP001                     eMode = SDRDRAG_MOVE;
//STRIP001                 else
//STRIP001                     eMode = SDRDRAG_ROTATE;
//STRIP001                 pView->SetDragMode( eMode );
//STRIP001                 rBindings.Invalidate( SID_OBJECT_ROTATE );
//STRIP001                 rBindings.Invalidate( SID_OBJECT_MIRROR );
//STRIP001                 if (eMode == SDRDRAG_ROTATE && !pView->IsFrameDragSingles())
//STRIP001                 {
//STRIP001                     pView->SetFrameDragSingles( TRUE );
//STRIP001                     rBindings.Invalidate( SID_BEZIER_EDIT );
//STRIP001                 }
//STRIP001             }
//STRIP001             break;
//STRIP001         case SID_OBJECT_MIRROR:
//STRIP001             {
//STRIP001                 SdrDragMode eMode;
//STRIP001                 if (pView->GetDragMode() == SDRDRAG_MIRROR)
//STRIP001                     eMode = SDRDRAG_MOVE;
//STRIP001                 else
//STRIP001                     eMode = SDRDRAG_MIRROR;
//STRIP001                 pView->SetDragMode( eMode );
//STRIP001                 rBindings.Invalidate( SID_OBJECT_ROTATE );
//STRIP001                 rBindings.Invalidate( SID_OBJECT_MIRROR );
//STRIP001                 if (eMode == SDRDRAG_MIRROR && !pView->IsFrameDragSingles())
//STRIP001                 {
//STRIP001                     pView->SetFrameDragSingles( TRUE );
//STRIP001                     rBindings.Invalidate( SID_BEZIER_EDIT );
//STRIP001                 }
//STRIP001             }
//STRIP001             break;
//STRIP001         case SID_BEZIER_EDIT:
//STRIP001             {
//STRIP001                 BOOL bOld = pView->IsFrameDragSingles();
//STRIP001                 pView->SetFrameDragSingles( !bOld );
//STRIP001                 rBindings.Invalidate( SID_BEZIER_EDIT );
//STRIP001                 if (bOld && pView->GetDragMode() != SDRDRAG_MOVE)
//STRIP001                 {
//STRIP001                     pView->SetDragMode( SDRDRAG_MOVE );
//STRIP001                     rBindings.Invalidate( SID_OBJECT_ROTATE );
//STRIP001                     rBindings.Invalidate( SID_OBJECT_MIRROR );
//STRIP001                 }
//STRIP001             }
//STRIP001             break;
//STRIP001 
//STRIP001         case SID_FONTWORK:
//STRIP001         {
//STRIP001             USHORT nId = ScGetFontWorkId();
//STRIP001             SfxViewFrame* pViewFrm = pViewData->GetViewShell()->GetViewFrame();
//STRIP001 
//STRIP001             if ( rReq.GetArgs() )
//STRIP001                 pViewFrm->SetChildWindow( nId,
//STRIP001                                            ((const SfxBoolItem&)
//STRIP001                                             (rReq.GetArgs()->Get(SID_FONTWORK))).
//STRIP001                                                 GetValue() );
//STRIP001             else
//STRIP001                 pViewFrm->ToggleChildWindow( nId );
//STRIP001 
//STRIP001             rBindings.Invalidate( SID_FONTWORK );
//STRIP001             rReq.Done();
//STRIP001         }
//STRIP001         break;
//STRIP001 
//STRIP001         case SID_ORIGINALSIZE:
//STRIP001             pView->SetMarkedOriginalSize();
//STRIP001             break;
//STRIP001 
//STRIP001 		case SID_ENABLE_HYPHENATION:
//STRIP001 			{
//STRIP001 				SFX_REQUEST_ARG( rReq, pItem, SfxBoolItem, SID_ENABLE_HYPHENATION, FALSE);
//STRIP001 				if( pItem )
//STRIP001 				{
//STRIP001 					SfxItemSet aSet( GetPool(), EE_PARA_HYPHENATE, EE_PARA_HYPHENATE );
//STRIP001 					BOOL bValue = ( (const SfxBoolItem*) pItem)->GetValue();
//STRIP001 					aSet.Put( SfxBoolItem( EE_PARA_HYPHENATE, bValue ) );
//STRIP001 					pView->SetAttributes( aSet );
//STRIP001 				}
//STRIP001 				rReq.Done();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_RENAME_OBJECT:
//STRIP001 			{
//STRIP001 				const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 				if ( rMarkList.GetMarkCount() == 1 )
//STRIP001 				{
//STRIP001 					SdrObject* pObj = rMarkList.GetMark( 0 )->GetObj();
//STRIP001 					UINT16 nObjType = pObj->GetObjIdentifier();
//STRIP001 					if ( nObjType == OBJ_OLE2 || nObjType == OBJ_GRAF || nObjType == OBJ_GRUP )
//STRIP001 					{
//STRIP001 						// PersistName is used to identify object in Undo
//STRIP001 						String aPersistName;
//STRIP001 						if ( nObjType == OBJ_OLE2 )
//STRIP001 							aPersistName = static_cast<SdrOle2Obj*>(pObj)->GetPersistName();
//STRIP001 
//STRIP001 						String aOldName = pObj->GetName();
//STRIP001                         String aTitle(ScResId(SCSTR_RENAMEOBJECT));
//STRIP001                         String aDesc(ScResId(SCSTR_NAME));
//STRIP001 
//STRIP001                         SvxNameDialog* pDlg = new SvxNameDialog( NULL, aOldName, aDesc );
//STRIP001                         pDlg->SetEditHelpId( HID_SC_DRAW_RENAME );
//STRIP001                         pDlg->SetText( aTitle );
//STRIP001                         pDlg->SetCheckNameHdl( LINK( this, ScDrawShell, NameObjectHdl ) );
//STRIP001 
//STRIP001 						USHORT nRet = pDlg->Execute();
//STRIP001 						if ( nRet == RET_OK )
//STRIP001 						{
//STRIP001 							String aNewName;
//STRIP001 							pDlg->GetName( aNewName );
//STRIP001 							if ( aNewName != aOldName )
//STRIP001 							{
//STRIP001 								if ( nObjType == OBJ_GRAF && aNewName.Len() == 0 )
//STRIP001 								{
//STRIP001 									//	graphics objects must have names
//STRIP001 									//	(all graphics are supposed to be in the navigator)
//STRIP001 									ScDrawLayer* pModel = pViewData->GetDocument()->GetDrawLayer();
//STRIP001 									if ( pModel )
//STRIP001 										aNewName = pModel->GetNewGraphicName();
//STRIP001 								}
//STRIP001 
//STRIP001 								pObj->SetName( aNewName );				// set new name
//STRIP001 
//STRIP001 								ScDocShell* pDocSh = pViewData->GetDocShell();
//STRIP001 
//STRIP001 								//	An undo action for renaming is missing in svdraw (99363).
//STRIP001 								//	For OLE objects (which can be identified using the persist name),
//STRIP001 								//	ScUndoRenameObject can be used until there is a common action for all objects.
//STRIP001 								if ( aPersistName.Len() )
//STRIP001 								{
//STRIP001 									pDocSh->GetUndoManager()->AddUndoAction(
//STRIP001 												new ScUndoRenameObject( pDocSh, aPersistName, aOldName, aNewName ) );
//STRIP001 								}
//STRIP001 
//STRIP001 								pDocSh->SetDrawModified();
//STRIP001 							}
//STRIP001 						}
//STRIP001 						delete pDlg;
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001         default:
//STRIP001             break;
//STRIP001     }
//STRIP001 }

//STRIP001 IMPL_LINK( ScDrawShell, NameObjectHdl, SvxNameDialog*, pDialog )
//STRIP001 {
//STRIP001     String aName;
//STRIP001 
//STRIP001     if( pDialog )
//STRIP001         pDialog->GetName( aName );
//STRIP001 
//STRIP001 	ScDrawLayer* pModel = pViewData->GetDocument()->GetDrawLayer();
//STRIP001 	if ( aName.Len() && pModel )
//STRIP001 	{
//STRIP001 		USHORT nDummyTab;
//STRIP001 		if ( pModel->GetNamedObject( aName, 0, nDummyTab ) )
//STRIP001 		{
//STRIP001 			// existing object found -> name invalid
//STRIP001 			return 0;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001     return 1;	// name is valid
//STRIP001 }

//------------------------------------------------------------------

//STRIP001 void ScDrawShell::ExecFormText(SfxRequest& rReq)
//STRIP001 {
//STRIP001     ScDrawView*         pDrView     = pViewData->GetScDrawView();
//STRIP001     const SdrMarkList&  rMarkList   = pDrView->GetMarkList();
//STRIP001 
//STRIP001     if ( rMarkList.GetMarkCount() == 1 && rReq.GetArgs() )
//STRIP001     {
//STRIP001         const SfxItemSet& rSet = *rReq.GetArgs();
//STRIP001         const SfxPoolItem* pItem;
//STRIP001 
//STRIP001         if ( pDrView->IsTextEdit() )
//STRIP001             pDrView->ScEndTextEdit();
//STRIP001 
//STRIP001         if (    SFX_ITEM_SET ==
//STRIP001                 rSet.GetItemState(XATTR_FORMTXTSTDFORM, TRUE, &pItem)
//STRIP001              && XFTFORM_NONE !=
//STRIP001                 ((const XFormTextStdFormItem*) pItem)->GetValue() )
//STRIP001         {
//STRIP001 
//STRIP001             USHORT nId              = SvxFontWorkChildWindow::GetChildWindowId();
//STRIP001             SfxViewFrame* pViewFrm  = pViewData->GetViewShell()->GetViewFrame();
//STRIP001             SvxFontWorkDialog* pDlg = (SvxFontWorkDialog*)
//STRIP001                                        (pViewFrm->
//STRIP001                                             GetChildWindow(nId)->GetWindow());
//STRIP001 
//STRIP001             pDlg->CreateStdFormObj(*pDrView, *pDrView->GetPageViewPvNum(0),
//STRIP001                                     rSet, *rMarkList.GetMark(0)->GetObj(),
//STRIP001                                    ((const XFormTextStdFormItem*) pItem)->
//STRIP001                                    GetValue());
//STRIP001         }
//STRIP001         else
//STRIP001             pDrView->SetAttributes(rSet);
//STRIP001     }
//STRIP001 }







}
