/*************************************************************************
 *
 *  $RCSfile: sc_scenwnd.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:08:08 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

//------------------------------------------------------------------

// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #include <svtools/slstitm.hxx>
// auto strip #include <svtools/stritem.hxx>
// auto strip #include <vcl/msgbox.hxx>

// auto strip #include "navipi.hxx"
// auto strip #include "popmenu.hxx"
// auto strip #include "scresid.hxx"
#include "bf_sc.hrc"
#include "globstr.hrc"
namespace binfilter {

//------------------------------------------------------------------------


//========================================================================
// class ScScenarioWindow ------------------------------------------------
//========================================================================

// -----------------------------------------------------------------------

//STRIP001 ScScenarioListBox::ScScenarioListBox( Window* pParent )
//STRIP001 	:	ListBox	( pParent, WB_BORDER ),
//STRIP001 		rParent ( (ScScenarioWindow&)*pParent ),
//STRIP001 		pAccel	( NULL )
//STRIP001 {
//STRIP001 	Font aFont( GetFont() );
//STRIP001 	aFont.SetTransparent( TRUE );
//STRIP001 	aFont.SetWeight( WEIGHT_LIGHT );
//STRIP001 	SetFont( aFont );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 __EXPORT ScScenarioListBox::~ScScenarioListBox()
//STRIP001 {
//STRIP001 	ClearEntryList();
//STRIP001 	delete pAccel;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void ScScenarioListBox::UpdateEntries( List* pNewEntryList )
//STRIP001 {
//STRIP001 	ClearEntryList();
//STRIP001 	Clear();
//STRIP001 
//STRIP001 	if ( pNewEntryList )
//STRIP001 	{
//STRIP001 		if ( pNewEntryList->Count() > 1 )
//STRIP001 		{
//STRIP001 			CopyEntryList( *pNewEntryList );
//STRIP001 			SetUpdateMode( FALSE );
//STRIP001 
//STRIP001 			String* pEntry = (String*)aEntryList.First();
//STRIP001 
//STRIP001 			while ( pEntry )
//STRIP001 			{
//STRIP001 				InsertEntry( *pEntry, LISTBOX_APPEND );
//STRIP001 				aEntryList.Next(); // Kommentar ueberspringen
//STRIP001 				pEntry = (String*)aEntryList.Next();
//STRIP001 			}
//STRIP001 
//STRIP001 			SetUpdateMode( TRUE );
//STRIP001 			SetNoSelection();
//STRIP001 			rParent.SetComment( EMPTY_STRING );
//STRIP001 		}
//STRIP001 		else if ( pNewEntryList->Count() == 1 )
//STRIP001 			// Tabelle ist Scenario-Tabelle: nur Kommentar
//STRIP001 			rParent.SetComment( *((String*)pNewEntryList->First()) );
//STRIP001 		else
//STRIP001 			rParent.SetComment( EMPTY_STRING );		// normale Tabelle ohne Szenarien
//STRIP001 	}
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void ScScenarioListBox::ClearEntryList()
//STRIP001 {
//STRIP001 	String* pEntry = (String*)aEntryList.First();
//STRIP001 
//STRIP001 	while ( pEntry )
//STRIP001 	{
//STRIP001 		delete pEntry;
//STRIP001 		pEntry = (String*)aEntryList.Next();
//STRIP001 	}
//STRIP001 	aEntryList.Clear();
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void ScScenarioListBox::CopyEntryList( List& rNewList )
//STRIP001 {
//STRIP001 	if ( aEntryList.Count() > 0 )
//STRIP001 		ClearEntryList();
//STRIP001 
//STRIP001 	String* pEntry = (String*)rNewList.First();
//STRIP001 
//STRIP001 	while ( pEntry )
//STRIP001 	{
//STRIP001 		aEntryList.Insert( new String( *pEntry ), LIST_APPEND );
//STRIP001 		pEntry = (String*)rNewList.Next();
//STRIP001 	}
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void __EXPORT ScScenarioListBox::Select()
//STRIP001 {
//STRIP001 	String*	pEntry = (String*)aEntryList.GetObject( (GetSelectEntryPos()*2)+1 );
//STRIP001 
//STRIP001 	if ( pEntry )
//STRIP001 		rParent.SetComment( *pEntry );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void __EXPORT ScScenarioListBox::DoubleClick()
//STRIP001 {
//STRIP001 	SfxStringItem aStringItem( SID_SELECT_SCENARIO, GetSelectEntry() );
//STRIP001 
//STRIP001 	SfxViewFrame* pViewFrm = SfxViewFrame::Current();
//STRIP001 	if (pViewFrm)
//STRIP001 		pViewFrm->GetDispatcher()->Execute( SID_SELECT_SCENARIO,
//STRIP001 							  SFX_CALLMODE_SLOT | SFX_CALLMODE_RECORD,
//STRIP001 							  &aStringItem, 0L, 0L );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void __EXPORT ScScenarioListBox::GetFocus()
//STRIP001 {
//STRIP001 	pAccel = new Accelerator;
//STRIP001 
//STRIP001 	pAccel->InsertItem( 1, KeyCode( KEY_RETURN ) );
//STRIP001 	pAccel->InsertItem( 2, KeyCode( KEY_ESCAPE ) );
//STRIP001 	pAccel->SetSelectHdl( LINK( this, ScScenarioListBox, AccelSelectHdl ) );
//STRIP001 
//STRIP001 	Application::InsertAccel( pAccel );
//STRIP001 	aCurText = GetText();
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void __EXPORT ScScenarioListBox::LoseFocus()
//STRIP001 {
//STRIP001 	Application::RemoveAccel( pAccel );
//STRIP001 	delete pAccel;
//STRIP001 	pAccel = NULL;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 IMPL_LINK( ScScenarioListBox, AccelSelectHdl, Accelerator *, pAccel )
//STRIP001 {
//STRIP001 	if ( !pAccel ) return 0;
//STRIP001 
//STRIP001 	switch ( pAccel->GetCurKeyCode().GetCode() )
//STRIP001 	{
//STRIP001 		case KEY_RETURN:
//STRIP001 			Select();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case KEY_ESCAPE:
//STRIP001 			SelectEntry( aCurText );
//STRIP001 			Select();
//STRIP001 			break;
//STRIP001 
//STRIP001 		default:
//STRIP001 		break;
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

//STRIP001 long __EXPORT ScScenarioListBox::Notify( NotifyEvent& rNEvt )
//STRIP001 {
//STRIP001 	ListBox::Notify( rNEvt );
//STRIP001 	long nHandled = 0;
//STRIP001 
//STRIP001 	if ( rNEvt.GetType() == EVENT_COMMAND && GetSelectEntryCount() )
//STRIP001 	{
//STRIP001 		const CommandEvent* pCEvt = rNEvt.GetCommandEvent();
//STRIP001 		if ( pCEvt && pCEvt->GetCommand() == COMMAND_CONTEXTMENU )
//STRIP001 		{
//STRIP001 			ScPopupMenu aPopup( ScResId( RID_POPUP_NAVIPI_SCENARIO ) );
//STRIP001 			aPopup.Execute( this, pCEvt->GetMousePosPixel() );
//STRIP001 			if (aPopup.WasHit())
//STRIP001 			{
//STRIP001 				String aName = GetSelectEntry();
//STRIP001 				USHORT nId = aPopup.GetSelected();
//STRIP001 				if ( nId == RID_NAVIPI_SCENARIO_DELETE )
//STRIP001 				{
//STRIP001 					short nRes = QueryBox( NULL, WinBits( WB_YES_NO | WB_DEF_YES ),
//STRIP001 									ScGlobal::GetRscString(STR_QUERY_DELSCENARIO) ).Execute();
//STRIP001 					if ( nRes == RET_YES )
//STRIP001 					{
//STRIP001 						SfxStringItem aStringItem( SID_DELETE_SCENARIO, aName );
//STRIP001 						SfxViewFrame* pViewFrm = SfxViewFrame::Current();
//STRIP001 						if (pViewFrm)
//STRIP001 							pViewFrm->GetDispatcher()->Execute( SID_DELETE_SCENARIO,
//STRIP001 													SFX_CALLMODE_SLOT | SFX_CALLMODE_RECORD,
//STRIP001 													&aStringItem, 0L, 0L );
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else if ( nId == RID_NAVIPI_SCENARIO_EDIT )
//STRIP001 				{
//STRIP001 					SfxStringItem aStringItem( SID_EDIT_SCENARIO, aName );
//STRIP001 					SfxViewFrame* pViewFrm = SfxViewFrame::Current();
//STRIP001 					if (pViewFrm)
//STRIP001 						pViewFrm->GetDispatcher()->Execute( SID_EDIT_SCENARIO,
//STRIP001 												SFX_CALLMODE_SLOT | SFX_CALLMODE_RECORD,
//STRIP001 												&aStringItem, 0L, 0L );
//STRIP001 				}
//STRIP001 			}
//STRIP001 			nHandled = 1;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return nHandled;
//STRIP001 }


//========================================================================
// class ScScenarioWindow ------------------------------------------------
//========================================================================

//STRIP001 ScScenarioWindow::ScScenarioWindow( Window* pParent,const String& aQH_List,
//STRIP001 									const String& aQH_Comment)
//STRIP001 	:	Window		( pParent ),
//STRIP001 		aLbScenario	( this ),
//STRIP001 		aEdComment	( this,  WB_BORDER | WB_LEFT
//STRIP001 						   | WB_READONLY | WB_VSCROLL )
//STRIP001 {
//STRIP001 	Font aFont( GetFont() );
//STRIP001 	aFont.SetTransparent( TRUE );
//STRIP001 	aFont.SetWeight( WEIGHT_LIGHT );
//STRIP001 	aEdComment.SetFont( aFont );
//STRIP001 	aEdComment.SetMaxTextLen( 512 );
//STRIP001 	aLbScenario.SetPosPixel( Point(0,0) );
//STRIP001 	aLbScenario.SetHelpId(HID_SC_SCENWIN_TOP);
//STRIP001 	aEdComment.SetHelpId(HID_SC_SCENWIN_BOTTOM);
//STRIP001 	aLbScenario.Show();
//STRIP001 	aEdComment.Show();
//STRIP001 
//STRIP001 	aLbScenario.SetQuickHelpText(aQH_List);
//STRIP001 	aEdComment.SetQuickHelpText(aQH_Comment);
//STRIP001 	aEdComment.SetBackground( Color( COL_LIGHTGRAY ) );
//STRIP001 
//STRIP001 	SfxViewFrame* pViewFrm = SfxViewFrame::Current();
//STRIP001 	if (pViewFrm)
//STRIP001 	{
//STRIP001 		SfxBindings& rBindings = pViewFrm->GetBindings();
//STRIP001 		rBindings.Invalidate( SID_SELECT_SCENARIO );
//STRIP001 		rBindings.Update( SID_SELECT_SCENARIO );
//STRIP001 	}
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 __EXPORT ScScenarioWindow::~ScScenarioWindow()
//STRIP001 {
//STRIP001 }

//STRIP001 void ScScenarioWindow::Paint( const Rectangle& rRec )
//STRIP001 {
//STRIP001 	const StyleSettings& rStyleSettings = Application::GetSettings().GetStyleSettings();
//STRIP001 	Color aBgColor = rStyleSettings.GetFaceColor();
//STRIP001 
//STRIP001 	SetBackground( aBgColor );
//STRIP001 
//STRIP001 	Window::Paint( rRec );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void ScScenarioWindow::NotifyState( const SfxPoolItem* pState )
//STRIP001 {
//STRIP001 	if( pState )
//STRIP001 	{
//STRIP001 		aLbScenario.Enable();
//STRIP001 
//STRIP001 		if ( pState->ISA(SfxStringItem) )
//STRIP001 		{
//STRIP001 			String aNewEntry( ((const SfxStringItem*)pState)->GetValue() );
//STRIP001 
//STRIP001 			if ( aNewEntry.Len() > 0 )
//STRIP001 				aLbScenario.SelectEntry( aNewEntry );
//STRIP001 			else
//STRIP001 				aLbScenario.SetNoSelection();
//STRIP001 		}
//STRIP001 		else if ( pState->ISA(SfxStringListItem) )
//STRIP001 		{
//STRIP001 			aLbScenario.UpdateEntries( ((SfxStringListItem*)pState)->GetList() );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aLbScenario.Disable();
//STRIP001 		aLbScenario.SetNoSelection();
//STRIP001 	}
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void ScScenarioWindow::SetSizePixel( const Size& rNewSize )
//STRIP001 {
//STRIP001 	Size aSize( rNewSize );
//STRIP001 	long nHeight = aSize.Height() / 2;
//STRIP001 
//STRIP001 	Window::SetSizePixel( aSize );
//STRIP001 
//STRIP001 	aSize.Height() = nHeight;
//STRIP001 	aLbScenario.SetSizePixel( aSize );
//STRIP001 
//STRIP001 	aSize.Height() -= 4;
//STRIP001 	aEdComment.SetPosSizePixel(	Point( 0, nHeight+4 ), aSize );
//STRIP001 }




}
