/*************************************************************************
 *
 *  $RCSfile: sc_undoutil.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:18:24 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// System - Includes -----------------------------------------------------

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif


// INCLUDE ---------------------------------------------------------------

// auto strip #include "undoutil.hxx"

// auto strip #include "docsh.hxx"
// auto strip #include "tabvwsh.hxx"
// auto strip #include "document.hxx"
// auto strip #include "dbcolect.hxx"
#include "globstr.hrc"
// auto strip #include "global.hxx"
namespace binfilter {

//STRIP001 void ScUndoUtil::MarkSimpleBlock( ScDocShell* pDocShell,
//STRIP001 								USHORT nStartX, USHORT nStartY, USHORT nStartZ,
//STRIP001 								USHORT nEndX, USHORT nEndY, USHORT nEndZ )
//STRIP001 {
//STRIP001 	ScTabViewShell* pViewShell = ScTabViewShell::GetActiveViewShell();
//STRIP001 	if (pViewShell)
//STRIP001 	{
//STRIP001 		USHORT nViewTab = pViewShell->GetViewData()->GetTabNo();
//STRIP001 		if ( nViewTab < nStartZ || nViewTab > nEndZ )
//STRIP001 			pViewShell->SetTabNo( nStartZ );
//STRIP001 
//STRIP001 		pViewShell->DoneBlockMode();
//STRIP001 		pViewShell->MoveCursorAbs( nStartX, nStartY, SC_FOLLOW_JUMP, FALSE, FALSE );
//STRIP001 		pViewShell->InitOwnBlockMode();
//STRIP001 		pViewShell->GetViewData()->GetMarkData().
//STRIP001 				SetMarkArea( ScRange( nStartX, nStartY, nStartZ, nEndX, nEndY, nEndZ ) );
//STRIP001 	}
//STRIP001 }


//STRIP001 void ScUndoUtil::MarkSimpleBlock( ScDocShell* pDocShell,
//STRIP001 								const ScTripel& rBlockStart,
//STRIP001 								const ScTripel& rBlockEnd )
//STRIP001 {
//STRIP001 	MarkSimpleBlock( pDocShell, rBlockStart.GetCol(), rBlockStart.GetRow(), rBlockStart.GetTab(),
//STRIP001 								rBlockEnd.GetCol(), rBlockEnd.GetRow(), rBlockEnd.GetTab() );
//STRIP001 }


//STRIP001 void ScUndoUtil::MarkSimpleBlock( ScDocShell* pDocShell,
//STRIP001 								const ScRange& rRange )
//STRIP001 {
//STRIP001 	MarkSimpleBlock( pDocShell, rRange.aStart.Col(), rRange.aStart.Row(), rRange.aStart.Tab(),
//STRIP001 								rRange.aEnd.Col(),   rRange.aEnd.Row(),   rRange.aEnd.Tab()   );
//STRIP001 }



//STRIP001 ScDBData* ScUndoUtil::GetOldDBData( ScDBData* pUndoData, ScDocument* pDoc, USHORT nTab,
//STRIP001 									USHORT nCol1, USHORT nRow1, USHORT nCol2, USHORT nRow2 )
//STRIP001 {
//STRIP001 	ScDBData* pRet = pDoc->GetDBAtArea( nTab, nCol1, nRow1, nCol2, nRow2 );
//STRIP001 
//STRIP001 	if (!pRet)
//STRIP001 	{
//STRIP001 		BOOL bWasTemp = FALSE;
//STRIP001 		if ( pUndoData )
//STRIP001 		{
//STRIP001 			String aName;
//STRIP001 			pUndoData->GetName( aName );
//STRIP001 			if ( aName == ScGlobal::GetRscString( STR_DB_NONAME ) )
//STRIP001 				bWasTemp = TRUE;
//STRIP001 		}
//STRIP001 		if (!bWasTemp)
//STRIP001 			DBG_ERROR("Undo: DB-Bereich nicht gefunden");
//STRIP001 
//STRIP001 		USHORT nIndex;
//STRIP001 		ScDBCollection* pColl = pDoc->GetDBCollection();
//STRIP001 		if (pColl->SearchName( ScGlobal::GetRscString( STR_DB_NONAME ), nIndex ))
//STRIP001 			pRet = (*pColl)[nIndex];
//STRIP001 		else
//STRIP001 		{
//STRIP001 			pRet = new ScDBData( ScGlobal::GetRscString( STR_DB_NONAME ), nTab,
//STRIP001 								nCol1,nRow1, nCol2,nRow2, TRUE,
//STRIP001 								pDoc->HasColHeader( nCol1,nRow1,nCol2,nRow2,nTab ) );
//STRIP001 			pColl->Insert( pRet );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return pRet;
//STRIP001 }


//STRIP001 void ScUndoUtil::PaintMore( ScDocShell* pDocShell,
//STRIP001 								const ScRange& rRange )
//STRIP001 {
//STRIP001 	USHORT nCol1 = rRange.aStart.Col();
//STRIP001 	USHORT nRow1 = rRange.aStart.Row();
//STRIP001 	USHORT nCol2 = rRange.aEnd.Col();
//STRIP001 	USHORT nRow2 = rRange.aEnd.Row();
//STRIP001 	if (nCol1) --nCol1;
//STRIP001 	if (nRow1) --nRow1;
//STRIP001 	if (nCol2<MAXCOL) ++nCol2;
//STRIP001 	if (nRow2<MAXROW) ++nRow2;
//STRIP001 
//STRIP001 	pDocShell->PostPaint( nCol1,nRow1,rRange.aStart.Tab(),
//STRIP001 						  nCol2,nRow2,rRange.aEnd.Tab(), PAINT_GRID );
//STRIP001 }
}
