/*************************************************************************
 *
 *  $RCSfile: sc_tabsplit.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:35:21 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// System - Includes -----------------------------------------------------

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

// INCLUDE ---------------------------------------------------------------

#include "tabsplit.hxx"
// auto strip #include "viewdata.hxx"
// auto strip #include "dbfunc.hxx"
namespace binfilter {

//==================================================================

/*N*/ ScTabSplitter::ScTabSplitter( Window* pParent, WinBits nWinStyle, ScViewData* pData ) :
/*N*/ 	Splitter( pParent, nWinStyle ),
/*N*/ 	pViewData(pData)
/*N*/ {
/*N*/ 	SetFixed(FALSE);
/*N*/ }


/*N*/ ScTabSplitter::~ScTabSplitter()
/*N*/ {
/*N*/ }

//STRIP001 void __EXPORT ScTabSplitter::MouseMove( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	if (bFixed)
//STRIP001 		Window::MouseMove( rMEvt );
//STRIP001 	else
//STRIP001 		Splitter::MouseMove( rMEvt );
//STRIP001 }

//STRIP001 void __EXPORT ScTabSplitter::MouseButtonUp( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	if (bFixed)
//STRIP001 		Window::MouseButtonUp( rMEvt );
//STRIP001 	else
//STRIP001 		Splitter::MouseButtonUp( rMEvt );
//STRIP001 }

//STRIP001 void __EXPORT ScTabSplitter::MouseButtonDown( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	if (bFixed)
//STRIP001 		Window::MouseButtonDown( rMEvt );
//STRIP001 	else
//STRIP001 		Splitter::MouseButtonDown( rMEvt );
//STRIP001 }

//STRIP001 void __EXPORT ScTabSplitter::Splitting( Point& rSplitPos )
//STRIP001 {
//STRIP001 	Window* pParent = GetParent();
//STRIP001 	Point aScreenPos = pParent->OutputToScreenPixel( rSplitPos );
//STRIP001 	pViewData->GetView()->SnapSplitPos( aScreenPos );
//STRIP001 	Point aNew = pParent->ScreenToOutputPixel( aScreenPos );
//STRIP001 	if ( IsHorizontal() )
//STRIP001 		rSplitPos.X() = aNew.X();
//STRIP001 	else
//STRIP001 		rSplitPos.Y() = aNew.Y();
//STRIP001 }


/*N*/ void ScTabSplitter::SetFixed(BOOL bSet)
/*N*/ {
/*N*/ 	bFixed = bSet;
/*N*/ 	if (bSet)
/*N*/ 		SetPointer(POINTER_ARROW);
/*N*/ 	else if (IsHorizontal())
/*N*/ 		SetPointer(POINTER_HSPLIT);
/*N*/ 	else
/*N*/ 		SetPointer(POINTER_VSPLIT);
/*N*/ }



}
