/*************************************************************************
 *
 *  $RCSfile: sch_axisgrid.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:32:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFX_HRC
#include <bf_sfx2/sfx.hrc>
#endif
// header for SfxBoolItem
#ifndef _SFXENUMITEM_HXX
#include <svtools/eitem.hxx>
#endif
// header for SAL_STATIC_CAST
#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif

#include "schdll.hxx"
#include "schresid.hxx"
#include "axisgrid.hxx"
#include "axisgrid.hrc"
namespace binfilter {

//==============================
//
// SchAxisDlg
//
//==============================

//STRIP001 SchAxisDlg::SchAxisDlg( Window* pWindow, const SfxItemSet& rInAttrs,
//STRIP001 						BOOL b3D, BOOL bNet,
//STRIP001 						BOOL bSecondaryX, BOOL bSecondaryY ) :
//STRIP001 		ModalDialog( pWindow, SchResId( DLG_AXIS )),
//STRIP001 
//STRIP001 		aFlPrimary( this, ResId( FL_PRIMARY_AXIS )),
//STRIP001 		aCbPrimaryX( this, ResId( CB_X_PRIMARY )),
//STRIP001 		aCbPrimaryY( this, ResId( CB_Y_PRIMARY )),
//STRIP001 		aCbPrimaryZ( this, ResId( CB_Z_PRIMARY )),
//STRIP001 
//STRIP001 		aFlSecondary( this, ResId( FL_SECONDARY_AXIS )),
//STRIP001 		aCbSecondaryX( this, ResId( CB_X_SECONDARY )),
//STRIP001 		aCbSecondaryY( this, ResId( CB_Y_SECONDARY )),
//STRIP001 
//STRIP001 		aPbOK( this, ResId( PB_OK )),
//STRIP001 		aPbCancel( this, ResId( PB_CANCEL )),
//STRIP001 		aPbHelp( this, ResId( PB_HELP )),
//STRIP001 
//STRIP001 		rOutAttrs( rInAttrs )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aCbPrimaryX.Enable( !bNet );
//STRIP001 	aCbSecondaryX.Enable( !bNet && bSecondaryX );
//STRIP001 	aCbSecondaryY.Enable( bSecondaryY );
//STRIP001 	aCbPrimaryZ.Enable( b3D );
//STRIP001 
//STRIP001 	Reset();
//STRIP001 }
//STRIP001 
//STRIP001 SchAxisDlg::~SchAxisDlg()
//STRIP001 {
//STRIP001 }

//--------------------
// initialize
//--------------------

//STRIP001 void SchAxisDlg::Reset()
//STRIP001 {
//STRIP001 	const SfxPoolItem *pPoolItem = NULL;
//STRIP001 
//STRIP001 	if( aCbPrimaryX.IsEnabled() &&
//STRIP001 		rOutAttrs.GetItemState( CHATTR_AXISGRID_SHOW_X_AXIS, TRUE, &pPoolItem) == SFX_ITEM_SET )
//STRIP001 	{
//STRIP001 		bOldShowX = SAL_STATIC_CAST( const SfxBoolItem*, pPoolItem)->GetValue();
//STRIP001 		aCbPrimaryX.Check( bOldShowX );
//STRIP001 	}
//STRIP001 	
//STRIP001 	if( aCbPrimaryY.IsEnabled() &&
//STRIP001 		rOutAttrs.GetItemState( CHATTR_AXISGRID_SHOW_Y_AXIS, TRUE, &pPoolItem) == SFX_ITEM_SET )
//STRIP001 	{
//STRIP001 		bOldShowY = SAL_STATIC_CAST( const SfxBoolItem*, pPoolItem)->GetValue();
//STRIP001 		aCbPrimaryY.Check( bOldShowY );
//STRIP001 	}
//STRIP001 
//STRIP001 	if( aCbPrimaryZ.IsEnabled() &&
//STRIP001 		rOutAttrs.GetItemState( CHATTR_AXISGRID_SHOW_Z_AXIS, TRUE, &pPoolItem) == SFX_ITEM_SET )
//STRIP001 	{
//STRIP001 		bOldShowZ = SAL_STATIC_CAST( const SfxBoolItem*, pPoolItem)->GetValue();
//STRIP001 		aCbPrimaryZ.Check( bOldShowZ );
//STRIP001 	}
//STRIP001 
//STRIP001 	if( aCbSecondaryX.IsEnabled() &&
//STRIP001 		rOutAttrs.GetItemState( CHATTR_AXISGRID_SHOW_2X_AXIS, TRUE, &pPoolItem) == SFX_ITEM_SET )
//STRIP001 	{
//STRIP001 		bOldShow2X = SAL_STATIC_CAST( const SfxBoolItem*, pPoolItem)->GetValue();
//STRIP001 		aCbSecondaryX.Check( bOldShow2X );
//STRIP001 	}
//STRIP001 
//STRIP001 	if( aCbSecondaryY.IsEnabled() &&
//STRIP001 		rOutAttrs.GetItemState( CHATTR_AXISGRID_SHOW_2Y_AXIS, TRUE, &pPoolItem) == SFX_ITEM_SET )
//STRIP001 	{
//STRIP001 		bOldShow2Y = SAL_STATIC_CAST( const SfxBoolItem*, pPoolItem)->GetValue();
//STRIP001 		aCbSecondaryY.Check( bOldShow2Y );
//STRIP001 	}
//STRIP001 }

//---------------------
// fill result item set
//---------------------

//STRIP001 void SchAxisDlg::GetAttr(SfxItemSet& rOutAttrs)
//STRIP001 {
//STRIP001 	if( aCbPrimaryX.IsEnabled() &&
//STRIP001 		bOldShowX != aCbPrimaryX.IsChecked() )
//STRIP001 	{
//STRIP001 		rOutAttrs.Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_X_AXIS,  aCbPrimaryX.IsChecked()) );
//STRIP001 		rOutAttrs.Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_X_DESCR, aCbPrimaryX.IsChecked()) );
//STRIP001 	}
//STRIP001 
//STRIP001 	if( aCbPrimaryY.IsEnabled() &&
//STRIP001 		bOldShowY != aCbPrimaryY.IsChecked() )
//STRIP001 	{
//STRIP001 		rOutAttrs.Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_Y_AXIS,  aCbPrimaryY.IsChecked()) );
//STRIP001 		rOutAttrs.Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_Y_DESCR, aCbPrimaryY.IsChecked()) );
//STRIP001 	}
//STRIP001 
//STRIP001 	if( aCbPrimaryZ.IsEnabled()  &&
//STRIP001 		bOldShowZ != aCbPrimaryZ.IsChecked() )
//STRIP001 	{
//STRIP001 		rOutAttrs.Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_Z_AXIS,  aCbPrimaryZ.IsChecked()) );
//STRIP001 		rOutAttrs.Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_Z_DESCR, aCbPrimaryZ.IsChecked()) );
//STRIP001 	}
//STRIP001 
//STRIP001 	if( aCbSecondaryX.IsEnabled() &&
//STRIP001 		bOldShow2X != aCbSecondaryX.IsChecked() )
//STRIP001 	{
//STRIP001 		rOutAttrs.Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_2X_AXIS,  aCbSecondaryX.IsChecked()) );
//STRIP001 		rOutAttrs.Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_2X_DESCR, aCbSecondaryX.IsChecked()) );
//STRIP001 	}
//STRIP001 
//STRIP001 	if( aCbSecondaryY.IsEnabled() &&
//STRIP001 		bOldShow2Y != aCbSecondaryY.IsChecked() )
//STRIP001 	{
//STRIP001 		rOutAttrs.Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_2Y_AXIS,  aCbSecondaryY.IsChecked()) );
//STRIP001 		rOutAttrs.Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_2Y_DESCR, aCbSecondaryY.IsChecked()) );
//STRIP001 	}
//STRIP001 }

//==============================
//
// SchGridDlg
//
//==============================

//STRIP001 SchGridDlg::SchGridDlg( Window* pWindow, const SfxItemSet& rInAttrs,
//STRIP001 						BOOL b3D, BOOL bNet,
//STRIP001 						BOOL bSecondaryX, BOOL bSecondaryY ) :
//STRIP001 		ModalDialog( pWindow, SchResId( DLG_GRID )),
//STRIP001 
//STRIP001 		aFlMain( this, ResId( FL_MAIN_GRID )),
//STRIP001 		aCbMainX( this, ResId( CB_X_MAIN )),
//STRIP001 		aCbMainY( this, ResId( CB_Y_MAIN )),
//STRIP001 		aCbMainZ( this, ResId( CB_Z_MAIN )),
//STRIP001 
//STRIP001 		aFlHelp( this, ResId( FL_HELP_GRID )),
//STRIP001 		aCbHelpX( this, ResId( CB_X_HELP )),
//STRIP001 		aCbHelpY( this, ResId( CB_Y_HELP )),
//STRIP001 		aCbHelpZ( this, ResId( CB_Z_HELP )),
//STRIP001 
//STRIP001 		aPbOK( this, ResId( PB_OK )),
//STRIP001 		aPbCancel( this, ResId( PB_CANCEL )),
//STRIP001 		aPbHelp( this, ResId( PB_HELP )),
//STRIP001 
//STRIP001 		rOutAttrs( rInAttrs )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aCbMainX.Enable( !bNet );
//STRIP001 	aCbHelpX.Enable( !bNet );
//STRIP001 
//STRIP001 	aCbMainZ.Enable( b3D );
//STRIP001 	aCbHelpZ.Enable( b3D );
//STRIP001 
//STRIP001 	Reset();
//STRIP001 }
//STRIP001 
//STRIP001 SchGridDlg::~SchGridDlg()
//STRIP001 {
//STRIP001 }

//--------------------
// initialize
//--------------------

//STRIP001 void SchGridDlg::Reset()
//STRIP001 {
//STRIP001 	const SfxPoolItem *pPoolItem = NULL;
//STRIP001 
//STRIP001 	// Note: the CHATTRs for X-grids contain Y and vice versa !
//STRIP001 	if( aCbMainX.IsEnabled() &&
//STRIP001 		rOutAttrs.GetItemState( CHATTR_AXISGRID_SHOW_Y_MAIN, TRUE, &pPoolItem) == SFX_ITEM_SET )
//STRIP001 		aCbMainX.Check( SAL_STATIC_CAST( const SfxBoolItem*, pPoolItem)->GetValue() );
//STRIP001 
//STRIP001 	if( aCbMainY.IsEnabled() &&
//STRIP001 		rOutAttrs.GetItemState( CHATTR_AXISGRID_SHOW_X_MAIN, TRUE, &pPoolItem) == SFX_ITEM_SET )
//STRIP001 		aCbMainY.Check( SAL_STATIC_CAST( const SfxBoolItem*, pPoolItem)->GetValue() );
//STRIP001 
//STRIP001 	if( aCbMainZ.IsEnabled() &&
//STRIP001 		rOutAttrs.GetItemState( CHATTR_AXISGRID_SHOW_Z_MAIN, TRUE, &pPoolItem) == SFX_ITEM_SET )
//STRIP001 		aCbMainZ.Check( SAL_STATIC_CAST( const SfxBoolItem*, pPoolItem)->GetValue() );
//STRIP001 
//STRIP001 
//STRIP001 	if( aCbHelpX.IsEnabled() &&
//STRIP001 		rOutAttrs.GetItemState( CHATTR_AXISGRID_SHOW_Y_HELP, TRUE, &pPoolItem) == SFX_ITEM_SET )
//STRIP001 		aCbHelpX.Check( SAL_STATIC_CAST( const SfxBoolItem*, pPoolItem)->GetValue() );
//STRIP001 
//STRIP001 	if( aCbHelpY.IsEnabled() &&
//STRIP001 		rOutAttrs.GetItemState( CHATTR_AXISGRID_SHOW_X_HELP, TRUE, &pPoolItem) == SFX_ITEM_SET )
//STRIP001 		aCbHelpY.Check( SAL_STATIC_CAST( const SfxBoolItem*, pPoolItem)->GetValue() );
//STRIP001 
//STRIP001 	if( aCbHelpZ.IsEnabled() &&
//STRIP001 		rOutAttrs.GetItemState( CHATTR_AXISGRID_SHOW_Z_HELP, TRUE, &pPoolItem) == SFX_ITEM_SET )
//STRIP001 		aCbHelpZ.Check( SAL_STATIC_CAST( const SfxBoolItem*, pPoolItem)->GetValue() );
//STRIP001 }

//---------------------
// fill result item set
//---------------------

//STRIP001 void SchGridDlg::GetAttr(SfxItemSet& rOutAttrs)
//STRIP001 {
//STRIP001 	// Note: the CHATTRs for X-grids contain Y and vice versa !
//STRIP001 	if( aCbMainX.IsEnabled() )
//STRIP001 		rOutAttrs.Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_Y_MAIN, aCbMainX.IsChecked()) );
//STRIP001 
//STRIP001 	if( aCbMainY.IsEnabled() )
//STRIP001 		rOutAttrs.Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_X_MAIN, aCbMainY.IsChecked()) );
//STRIP001 
//STRIP001 	if( aCbMainZ.IsEnabled() )
//STRIP001 		rOutAttrs.Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_Z_MAIN, aCbMainZ.IsChecked()) );
//STRIP001 
//STRIP001 
//STRIP001 	if( aCbHelpX.IsEnabled() )
//STRIP001 		rOutAttrs.Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_Y_HELP, aCbHelpX.IsChecked()) );
//STRIP001 
//STRIP001 	if( aCbHelpY.IsEnabled() )
//STRIP001 		rOutAttrs.Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_X_HELP, aCbHelpY.IsChecked()) );
//STRIP001 
//STRIP001 	if( aCbHelpZ.IsEnabled() )
//STRIP001 		rOutAttrs.Put( SfxBoolItem( CHATTR_AXISGRID_SHOW_Z_HELP, aCbHelpZ.IsChecked()) );
//STRIP001 }




}
