/*************************************************************************
 *
 *  $RCSfile: sch_undgraut.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:01:40 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#include "schattr.hxx"
#define ITEMID_CHARTLEGENDPOS	SCHATTR_LEGEND_POS

#ifndef _SFXENUMITEM_HXX
#include <svtools/eitem.hxx>
#endif

// auto strip #include <bf_svx/chrtitem.hxx>

// auto strip #ifndef _CHTMODEL_HXX
// auto strip #include "chtmodel.hxx"
// auto strip #endif
// auto strip #include "undgraut.hxx"
namespace binfilter {

//STRIP001 TYPEINIT1(SchUndoDiagramAutoPilot, SchUndoAction);


/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

//STRIP001 SchUndoDiagramAutoPilot::~SchUndoDiagramAutoPilot()
//STRIP001 {
//STRIP001     // if there was no change, both pointers may point to the same object
//STRIP001     if (pOldPieSegOfs == pNewPieSegOfs)
//STRIP001         delete[] pOldPieSegOfs;
//STRIP001     else
//STRIP001     {
//STRIP001         delete[] pOldPieSegOfs;        
//STRIP001         delete[] pNewPieSegOfs;
//STRIP001     }
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchUndoDiagramAutoPilot::Undo()
//STRIP001 {
//STRIP001 
//STRIP001 	for (short i = 0; i < nOldPieSegCount; i++)
//STRIP001 		rDoc.SetPieSegOfs( i, pOldPieSegOfs[ i ] );
//STRIP001 
//STRIP001 	rDoc.ShowMainTitle ()  = bOldShowMainTitle;
//STRIP001 	rDoc.MainTitle ()      = aOldMainTitle;
//STRIP001 	rDoc.ShowSubTitle ()   = bOldShowSubTitle;
//STRIP001 	rDoc.SubTitle ()       = aOldSubTitle;
//STRIP001 	rDoc.ShowXAxisTitle () = bOldShowXAxisTitle;
//STRIP001 	rDoc.XAxisTitle ()     = aOldXAxisTitle;
//STRIP001 	rDoc.ShowYAxisTitle () = bOldShowYAxisTitle;
//STRIP001 	rDoc.YAxisTitle ()     = aOldYAxisTitle;
//STRIP001 	rDoc.ShowZAxisTitle () = bOldShowZAxisTitle;
//STRIP001 	rDoc.ZAxisTitle ()     = aOldZAxisTitle;
//STRIP001 	rDoc.ShowXAxis(bOldShowXAxis);
//STRIP001 	rDoc.ShowXGridMain ()  = bOldShowXGridMain;
//STRIP001 	rDoc.ShowXGridHelp ()  = bOldShowXGridHelp;
//STRIP001 	rDoc.ShowXDescr(bOldShowXDescr);
//STRIP001 	rDoc.ShowYAxis (bOldShowYAxis);
//STRIP001 	rDoc.ShowYGridMain ()  = bOldShowYGridMain;
//STRIP001 	rDoc.ShowYGridHelp ()  = bOldShowYGridHelp;
//STRIP001 	rDoc.ShowYDescr (bOldShowYDescr);
//STRIP001 	rDoc.ShowZAxis (bOldShowZAxis);
//STRIP001 	rDoc.ShowZGridMain ()  = bOldShowZGridMain;
//STRIP001 	rDoc.ShowZGridHelp ()  = bOldShowZGridHelp;
//STRIP001 	rDoc.ShowZDescr (bOldShowZDescr);
//STRIP001 	rDoc.SetSwitchData (bOldSwitchData);
//STRIP001 
//STRIP001 	SfxItemSet aAttr(rDoc.GetLegendAttr());
//STRIP001 	aAttr.Put(SvxChartLegendPosItem(eOldLegendPos));
//STRIP001 	rDoc.PutLegendAttr(aAttr);
//STRIP001 
//STRIP001 	//#54870# ChangeChart MUSS! aufgerufen werden!!!
//STRIP001 	rDoc.ChangeChart( eOldStyle );
//STRIP001 	rDoc.BuildChart(FALSE);
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchUndoDiagramAutoPilot::Redo()
//STRIP001 {
//STRIP001 
//STRIP001 	for (short i = 0; i < nNewPieSegCount; i++)
//STRIP001 		rDoc.SetPieSegOfs( i, pNewPieSegOfs[ i ] );
//STRIP001 
//STRIP001 	rDoc.ShowMainTitle ()  = bNewShowMainTitle;
//STRIP001 	rDoc.MainTitle ()      = aNewMainTitle;
//STRIP001 	rDoc.ShowSubTitle ()   = bNewShowSubTitle;
//STRIP001 	rDoc.SubTitle ()       = aNewSubTitle;
//STRIP001 	rDoc.ShowXAxisTitle () = bNewShowXAxisTitle;
//STRIP001 	rDoc.XAxisTitle ()     = aNewXAxisTitle;
//STRIP001 	rDoc.ShowYAxisTitle () = bNewShowYAxisTitle;
//STRIP001 	rDoc.YAxisTitle ()     = aNewYAxisTitle;
//STRIP001 	rDoc.ShowZAxisTitle () = bNewShowZAxisTitle;
//STRIP001 	rDoc.ZAxisTitle ()     = aNewZAxisTitle;
//STRIP001 	rDoc.ShowXAxis (bNewShowXAxis);
//STRIP001 	rDoc.ShowXGridMain ()  = bNewShowXGridMain;
//STRIP001 	rDoc.ShowXGridHelp ()  = bNewShowXGridHelp;
//STRIP001 	rDoc.ShowXDescr (bNewShowXDescr);
//STRIP001 	rDoc.ShowYAxis (bNewShowYAxis);
//STRIP001 	rDoc.ShowYGridMain ()  = bNewShowYGridMain;
//STRIP001 	rDoc.ShowYGridHelp ()  = bNewShowYGridHelp;
//STRIP001 	rDoc.ShowYDescr (bNewShowYDescr);
//STRIP001 	rDoc.ShowZAxis (bNewShowZAxis);
//STRIP001 	rDoc.ShowZGridMain ()  = bNewShowZGridMain;
//STRIP001 	rDoc.ShowZGridHelp ()  = bNewShowZGridHelp;
//STRIP001 	rDoc.ShowZDescr (bNewShowZDescr);
//STRIP001 	rDoc.SetSwitchData (bNewSwitchData);
//STRIP001 
//STRIP001 	//#54870# ChangeChart muss aufgerufen werden!
//STRIP001 	rDoc.ChangeChart( eNewStyle );
//STRIP001 	rDoc.BuildChart(FALSE);
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 BOOL SchUndoDiagramAutoPilot::CanRepeat(SfxRepeatTarget& rView) const
//STRIP001 {
//STRIP001 	return FALSE;
//STRIP001 }



}
