/*************************************************************************
 *
 *  $RCSfile: sch_viewshe2.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:26:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif

// auto strip #ifndef _SFX_TOPFRM_HXX //autogen wg. SfxTopViewFrame
// auto strip #include <bf_sfx2/topfrm.hxx>
// auto strip #endif

// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif

//svdraw.hxx
#define _SDR_NOITEMS
#define _SDR_NOTOUCH
#define _SDR_NOTRANSFORM
#define _SI_NOSBXCONTROLS
#define _SI_NOOTHERFORMS
#define _SI_NOCONTROL
#define _SI_NOSBXCONTROLS


#pragma hdrstop

#define ITEMID_LRSPACE          EE_PARA_LRSPACE
#define ITEMID_ULSPACE          EE_PARA_ULSPACE

#ifndef _SFX_HRC
#include <bf_sfx2/sfx.hrc>
#endif
#include <svtools/style.hrc>

#include <bf_svx/dialogs.hrc>

#include "schattr.hxx"
#define ITEMID_CHARTLEGENDPOS   SCHATTR_LEGEND_POS

// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif



#include "app.hrc"
#include "strings.hrc"
// auto strip #include "schresid.hxx"
#include "glob.hrc"
// auto strip #include "viewshel.hxx"
// auto strip #include "schview.hxx"
#include "fudatrow.hxx"
// auto strip #include "fudgrlin.hxx"
// auto strip #include "uninstit.hxx"
// auto strip #include "uninsleg.hxx"
// auto strip #include "uninsaxi.hxx"
// auto strip #include "unswitch.hxx"
// auto strip #include "objid.hxx"
// auto strip #include "dgrdata.hxx"
// auto strip #include "fu3d.hxx"
// auto strip #include "fuchrmap.hxx"

// auto strip #include "chaxis.hxx"
// auto strip #include "memchrt.hxx"
namespace binfilter {


/*************************************************************************
|*
|* SfxRequests fuer temporaere Funktionen
|*
\************************************************************************/

//STRIP001 void SchViewShell::FuTemporary(SfxRequest &rReq)
//STRIP001 {
//STRIP001 	USHORT nSlotId = rReq.GetSlot();
//STRIP001 
//STRIP001 	if( nSlotId == SID_CONTEXT ||		// #67998# double clicked on status bar: do not deactivate current function
//STRIP001 		nSlotId == SID_CONTEXT_TYPE )
//STRIP001 	{
//STRIP001 		return;
//STRIP001 	}
//STRIP001 	
//STRIP001 	ChartModel* pChDoc = &pChView->GetDoc();
//STRIP001 
//STRIP001 	if (pFuActual)
//STRIP001 	{
//STRIP001 		if( nSlotId != SID_DIAGRAM_DATA &&
//STRIP001 			nSlotId != SID_CHARMAP )
//STRIP001 		{
//STRIP001 			pFuActual->Deactivate();
//STRIP001 			if (pFuActual != pFuOld) delete pFuActual;
//STRIP001 			pFuActual = NULL;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	switch( nSlotId )
//STRIP001 	{
//STRIP001 		case SID_RELOAD:
//STRIP001 		{
//STRIP001 			SfxViewFrame* pFrame = GetViewFrame();
//STRIP001 
//STRIP001 			// nur wenn wir nicht IP sind
//STRIP001 			if (pFrame->IsA(TYPE(SfxTopViewFrame)))
//STRIP001 			{
//STRIP001 				GetViewFrame()->GetDispatcher()->Execute( SID_TOOL_SELECT, SFX_CALLMODE_SYNCHRON );
//STRIP001 
//STRIP001 				// normale Weiterleitung an ViewFrame zur Ausfuehrung
//STRIP001 				const SfxPoolItem *pBaseRet = pFrame->ExecuteSlot(rReq);
//STRIP001 				const SfxBoolItem *pRet = PTR_CAST(SfxBoolItem, pBaseRet);
//STRIP001 
//STRIP001 				if (pRet && ((const SfxBoolItem *)pRet)->GetValue())
//STRIP001 				{
//STRIP001 					// Undo-Manager leeren
//STRIP001 
//STRIP001 					pFrame->GetObjectShell()->GetUndoManager()->Clear();
//STRIP001 
//STRIP001 					// sofort zurueckkehren, da diese ViewShell nicht mehr
//STRIP001 					// gueltig ist
//STRIP001 					return;
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_DIAGRAM_DATA:
//STRIP001 			if (rReq.GetArgs())
//STRIP001 			{
//STRIP001 				GetViewFrame()->SetChildWindow
//STRIP001 					(SchDiagramDataWrapper::GetChildWindowId(),
//STRIP001 					 ((const SfxBoolItem&)(rReq.GetArgs()->
//STRIP001 						Get(SID_DIAGRAM_DATA))).GetValue());
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				GetViewFrame()->ToggleChildWindow
//STRIP001 					(SchDiagramDataWrapper::GetChildWindowId());
//STRIP001 			}
//STRIP001 
//STRIP001 			Invalidate();
//STRIP001 			rReq.Done();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_DIAGRAM_OBJECTS:
//STRIP001 		case SID_ATTR_CHAR_FONT:
//STRIP001 		case SID_ATTR_CHAR_FONTHEIGHT:
//STRIP001 		case SID_ATTR_CHAR_COLOR:
//STRIP001 		case SID_ATTR_CHAR_WEIGHT:
//STRIP001 		case SID_ATTR_CHAR_POSTURE:
//STRIP001 		case SID_ATTR_CHAR_UNDERLINE:
//STRIP001 		case SID_ATTR_CHAR_CONTOUR:
//STRIP001 		case SID_ATTR_CHAR_STRIKEOUT:
//STRIP001 		case SID_ATTR_CHAR_SHADOWED:
//STRIP001 		{
//STRIP001 			if (pChView->HasMarkedObj())
//STRIP001 			{
//STRIP001 				const SdrMarkList& rMarkList = pChView->GetMarkList();
//STRIP001 
//STRIP001 				if (rMarkList.GetMarkCount() >= 1)
//STRIP001 				{
//STRIP001 					SdrMark* pMark = rMarkList.GetMark(0);
//STRIP001 					SdrObject* pObj = pMark->GetObj();
//STRIP001 
//STRIP001 					SchObjectId* pObjId = GetObjectId(*pObj);
//STRIP001 
//STRIP001 					if (pObjId)
//STRIP001 					{
//STRIP001 						USHORT nId = 0;
//STRIP001 						switch( pObjId->GetObjId() )
//STRIP001 						{
//STRIP001 							case CHOBJID_DIAGRAM_TITLE_X_AXIS :
//STRIP001 								nId = SID_DIAGRAM_TITLE_X;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_TITLE_Y_AXIS :
//STRIP001 								nId = SID_DIAGRAM_TITLE_Y;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_TITLE_Z_AXIS :
//STRIP001 								nId = SID_DIAGRAM_TITLE_Z;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_TITLE_MAIN :
//STRIP001 								nId = SID_DIAGRAM_TITLE_MAIN;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_TITLE_SUB :
//STRIP001 								nId = SID_DIAGRAM_TITLE_SUB;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_FLOOR :
//STRIP001 								nId = SID_DIAGRAM_FLOOR;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_WALL :
//STRIP001 							case CHOBJID_DIAGRAM :
//STRIP001 								if (pChDoc->IsAxisChart () && !pChDoc->IsNetChart ()) nId = SID_DIAGRAM_WALL;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_LEGEND :
//STRIP001 								nId = SID_LEGEND;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_X_GRID_MAIN :
//STRIP001 							case CHOBJID_DIAGRAM_X_GRID_MAIN_GROUP :
//STRIP001 								nId = SID_DIAGRAM_GRID_X_MAIN;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_X_GRID_HELP :
//STRIP001 							case CHOBJID_DIAGRAM_X_GRID_HELP_GROUP :
//STRIP001 								nId = SID_DIAGRAM_GRID_X_HELP;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_Y_GRID_MAIN :
//STRIP001 							case CHOBJID_DIAGRAM_Y_GRID_MAIN_GROUP :
//STRIP001 								nId = SID_DIAGRAM_GRID_Y_MAIN;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_Y_GRID_HELP :
//STRIP001 							case CHOBJID_DIAGRAM_Y_GRID_HELP_GROUP :
//STRIP001 								nId = SID_DIAGRAM_GRID_Y_HELP;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_Z_GRID_MAIN :
//STRIP001 							case CHOBJID_DIAGRAM_Z_GRID_MAIN_GROUP :
//STRIP001 								nId = SID_DIAGRAM_GRID_Z_MAIN;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_Z_GRID_HELP :
//STRIP001 							case CHOBJID_DIAGRAM_Z_GRID_HELP_GROUP :
//STRIP001 								nId = SID_DIAGRAM_GRID_Z_HELP;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_X_AXIS :
//STRIP001 								nId = SID_DIAGRAM_AXIS_X;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_Y_AXIS :
//STRIP001 								nId = SID_DIAGRAM_AXIS_Y;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_Z_AXIS :
//STRIP001 								nId = SID_DIAGRAM_AXIS_Z;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_A_AXIS :
//STRIP001 								nId = SID_DIAGRAM_AXIS_A;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_B_AXIS :
//STRIP001 								nId = SID_DIAGRAM_AXIS_B;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_C_AXIS :
//STRIP001 								nId = SID_DIAGRAM_AXIS_C;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_AREA:
//STRIP001 							case CHOBJID_AREA :
//STRIP001 								nId = SID_DIAGRAM_AREA;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_STACKEDGROUP:
//STRIP001 								 DBG_TRACE("Chart (TVM) neue SID");
//STRIP001 							case CHOBJID_DIAGRAM_DATA :
//STRIP001 							case CHOBJID_DIAGRAM_SPECIAL_GROUP :
//STRIP001 							case CHOBJID_DIAGRAM_ROWGROUP :
//STRIP001 							case CHOBJID_DIAGRAM_ROWSLINE :
//STRIP001 							case CHOBJID_LEGEND_SYMBOL_ROW :
//STRIP001 							case CHOBJID_LEGEND_SYMBOL_COL :
//STRIP001 								nId = SID_DATA_ROW_POINT;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_STOCKLOSS_GROUP:
//STRIP001 								nId = SID_DIAGRAM_STOCK_LOSS;
//STRIP001 								break;
//STRIP001 							case CHOBJID_DIAGRAM_STOCKPLUS_GROUP:
//STRIP001 								nId = SID_DIAGRAM_STOCK_PLUS;
//STRIP001 								break;
//STRIP001 							//case CHOBJID_DIAGRAM_STOCKLINE:
//STRIP001 							case CHOBJID_DIAGRAM_STOCKLINE_GROUP:
//STRIP001 								nId = SID_DIAGRAM_STOCK_LINE;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_STATISTICS_GROUP :
//STRIP001 								nId = SID_DIAGRAM_ERROR;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_AVERAGEVALUE :
//STRIP001 								nId = SID_DIAGRAM_AVERAGEVALUE;
//STRIP001 								break;
//STRIP001 
//STRIP001 							case CHOBJID_DIAGRAM_REGRESSION :
//STRIP001 								nId = SID_DIAGRAM_REGRESSION;
//STRIP001 								break;
//STRIP001 
//STRIP001 
//STRIP001 							default :
//STRIP001 								DBG_TRACE1( "Unhandled CHOBJID in object properties: %ld", pObjId->GetObjId() );
//STRIP001 								nId = 0;
//STRIP001 								break;
//STRIP001 
//STRIP001 						}
//STRIP001 						if( nId > 0 )
//STRIP001 						{
//STRIP001 							SfxRequest aReq( nId, SFX_CALLMODE_SLOT, GetPool() );
//STRIP001 							if (rReq.GetArgs()) aReq.SetArgs( *rReq.GetArgs() );
//STRIP001 							ExecuteSlot( aReq );
//STRIP001 						}
//STRIP001 						else
//STRIP001 						{
//STRIP001 							Invalidate ();
//STRIP001 							Cancel ();
//STRIP001 						}
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{
//STRIP001 						Invalidate ();
//STRIP001 						Cancel ();
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					Invalidate ();
//STRIP001 					Cancel ();
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				Invalidate ();
//STRIP001 				Cancel ();
//STRIP001 			}
//STRIP001 
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_DIAGRAM_STOCK_LINE:
//STRIP001 		case SID_DIAGRAM_ERROR :
//STRIP001 		case SID_DIAGRAM_AVERAGEVALUE :
//STRIP001 		case SID_DIAGRAM_REGRESSION :
//STRIP001 			pFuActual = new SchFuLine(this, GetWindow(), pChView, pChDoc, rReq, aMDPos);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_DATA_ROW_POINT:
//STRIP001 			pFuActual = new SchFuDataRowPoint(this, GetWindow(), pChView,
//STRIP001 											  pChDoc, rReq, aMDPos);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_3D_VIEW:
//STRIP001 			pFuActual = new SchFu3D (this, GetWindow(), pChView, pChDoc, rReq);
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 // 		case SID_HAS_MAIN_TITLE:
//STRIP001 // 		case SID_HAS_SUB_TITLE:
//STRIP001 		case SID_TOGGLE_TITLE:
//STRIP001 		{
//STRIP001 			GetViewFrame()->GetDispatcher()->Execute(SID_TOOL_SELECT, SFX_CALLMODE_SYNCHRON);
//STRIP001 
//STRIP001 			BOOL bOldShowMain   = pChDoc->ShowMainTitle();
//STRIP001 			String aOldMain     = pChDoc->MainTitle();
//STRIP001 			BOOL bOldShowSub    = pChDoc->ShowSubTitle();
//STRIP001 			String aOldSub      = pChDoc->SubTitle();
//STRIP001 			BOOL bOldShowXAxis  = pChDoc->ShowXAxisTitle();
//STRIP001 			String aOldXAxis    = pChDoc->XAxisTitle();
//STRIP001 			BOOL bOldShowYAxis  = pChDoc->ShowYAxisTitle();
//STRIP001 			String aOldYAxis    = pChDoc->YAxisTitle();
//STRIP001 			BOOL bOldShowZAxis  = pChDoc->ShowZAxisTitle();
//STRIP001 			String aOldZAxis    = pChDoc->ZAxisTitle();
//STRIP001 
//STRIP001             BOOL bNewShow = ! ( bOldShowMain || bOldShowSub );
//STRIP001 
//STRIP001 			pChDoc->ChangeTitle(bNewShow, aOldMain, bNewShow,
//STRIP001 								aOldSub, bOldShowXAxis, aOldXAxis,
//STRIP001 								bOldShowYAxis, aOldYAxis, bOldShowZAxis,
//STRIP001 								aOldZAxis);
//STRIP001 			SchUndoInsertTitle* pUndo =
//STRIP001 				new SchUndoInsertTitle(*pChDoc, bOldShowMain, aOldMain,
//STRIP001 									   bOldShowSub, aOldSub, bOldShowXAxis,
//STRIP001 									   aOldXAxis, bOldShowYAxis, aOldYAxis,
//STRIP001 									   bOldShowZAxis, aOldZAxis, bNewShow,
//STRIP001 									   aOldMain, bNewShow, aOldSub,
//STRIP001 									   bOldShowXAxis, aOldXAxis,
//STRIP001 									   bOldShowYAxis, aOldYAxis,
//STRIP001 									   bOldShowZAxis, aOldZAxis);
//STRIP001 			pUndo->SetComment(String(SchResId(STR_UNDO_TOGGLE_TITLE)));
//STRIP001 
//STRIP001 			GetViewFrame()->GetObjectShell()->
//STRIP001 				GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 
//STRIP001 			rReq.Done();
//STRIP001 			Invalidate();
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_TOGGLE_LEGEND:
//STRIP001 		{
//STRIP001 			GetViewFrame()->GetDispatcher()->Execute(SID_TOOL_SELECT, SFX_CALLMODE_SYNCHRON);
//STRIP001 
//STRIP001 			SfxItemSet aAttr = pChDoc->GetLegendAttr();
//STRIP001 			const SfxPoolItem *pPoolItem = NULL;
//STRIP001 			SvxChartLegendPos ePos = (aAttr.GetItemState(SCHATTR_LEGEND_POS, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 										 ? ((const SvxChartLegendPosItem*)pPoolItem)->GetValue()
//STRIP001 										 : CHLEGEND_RIGHT;
//STRIP001 			BOOL bOldVisibility = pChDoc->GetShowLegend ();
//STRIP001 			BOOL bNewVisibility = ! bOldVisibility;
//STRIP001 
//STRIP001 			pChDoc->SetShowLegend (bNewVisibility);
//STRIP001 
//STRIP001 			SchUndoInsertLegend* pUndo = new SchUndoInsertLegend(*pChDoc, ePos, ePos, bOldVisibility, bNewVisibility);
//STRIP001 			pUndo->SetComment(String(SchResId(STR_UNDO_TOGGLE_LEGEND)));
//STRIP001 
//STRIP001 			GetViewFrame()->GetObjectShell()->GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 
//STRIP001 			rReq.Done();
//STRIP001 			Invalidate();
//STRIP001 			pChDoc->BuildChart (FALSE);
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_HAS_X_DESCR:
//STRIP001 		case SID_HAS_Y_DESCR:
//STRIP001 		case SID_HAS_Z_DESCR:
//STRIP001 		{
//STRIP001             DBG_ERROR( "Deprecated?" );
//STRIP001 			GetViewFrame()->GetDispatcher()->Execute(SID_TOOL_SELECT, SFX_CALLMODE_SYNCHRON);
//STRIP001 
//STRIP001 			BOOL bOldXAxis      = pChDoc->ShowXAxis();
//STRIP001 			BOOL bOldXGridMain  = pChDoc->ShowXGridMain();
//STRIP001 			BOOL bOldXGridHelp  = pChDoc->ShowXGridHelp();
//STRIP001 			BOOL bOldXDescr     = pChDoc->ShowXDescr();
//STRIP001 			BOOL bOldYAxis      = pChDoc->ShowYAxis();
//STRIP001 			BOOL bOldYGridMain  = pChDoc->ShowYGridMain();
//STRIP001 			BOOL bOldYGridHelp  = pChDoc->ShowYGridHelp();
//STRIP001 			BOOL bOldYDescr     = pChDoc->ShowYDescr();
//STRIP001 			BOOL bOldZAxis      = pChDoc->ShowZAxis();
//STRIP001 			BOOL bOldZGridMain  = pChDoc->ShowZGridMain();
//STRIP001 			BOOL bOldZGridHelp  = pChDoc->ShowZGridHelp();
//STRIP001 			BOOL bOldZDescr     = pChDoc->ShowZDescr();
//STRIP001 
//STRIP001 			BOOL bOld2YAxis  = pChDoc->GetAxisByUID(CHART_AXIS_SECONDARY_Y)->IsVisible();
//STRIP001 			BOOL bOld2YDescr = pChDoc->GetAxisByUID(CHART_AXIS_SECONDARY_Y)->HasDescription();
//STRIP001 			BOOL bOld2XAxis  = pChDoc->GetAxisByUID(CHART_AXIS_SECONDARY_X)->IsVisible();
//STRIP001 			BOOL bOld2XDescr = pChDoc->GetAxisByUID(CHART_AXIS_SECONDARY_X)->HasDescription();
//STRIP001 
//STRIP001 			SFX_REQUEST_ARG( rReq, pXItem, SfxBoolItem, SID_HAS_X_DESCR, FALSE );
//STRIP001 			SFX_REQUEST_ARG( rReq, pYItem, SfxBoolItem, SID_HAS_Y_DESCR, FALSE );
//STRIP001 			SFX_REQUEST_ARG( rReq, pZItem, SfxBoolItem, SID_HAS_Z_DESCR, FALSE );
//STRIP001 			BOOL bNewXDescr     = pXItem ? pXItem->GetValue() : bOldXDescr;
//STRIP001 			BOOL bNewYDescr     = pYItem ? pYItem->GetValue() : bOldYDescr;
//STRIP001 			BOOL bNewZDescr     = pZItem ? pZItem->GetValue() : bOldZDescr;
//STRIP001 
//STRIP001 			pChDoc->ChangeAxis( bOldXAxis, bNewXDescr,
//STRIP001 								bOldYAxis, bNewYDescr,
//STRIP001 								bOldZAxis, bNewZDescr,
//STRIP001 								bOld2YAxis,bOld2YDescr,
//STRIP001 								bOld2XAxis,bOld2XDescr, TRUE );
//STRIP001 
//STRIP001 			SchUndoInsertAxis* pUndo =
//STRIP001 				new SchUndoInsertAxis( *pChDoc,
//STRIP001 									   bOldXAxis, bOldXDescr,
//STRIP001 									   bOldYAxis, bOldYDescr,
//STRIP001 									   bOldZAxis, bOldZDescr,
//STRIP001 									   bOld2YAxis,bOld2YDescr,
//STRIP001 									   bOld2XAxis,bOld2XDescr,
//STRIP001 
//STRIP001 									   bOldXAxis, bNewXDescr,
//STRIP001 									   bOldYAxis, bNewYDescr,
//STRIP001 									   bOldZAxis, bNewZDescr,
//STRIP001 									   bOld2YAxis,bOld2YDescr,
//STRIP001 									   bOld2XAxis,bOld2XDescr );
//STRIP001 
//STRIP001 			pUndo->SetComment(String(SchResId(STR_UNDO_TOGGLE_AXIS_DESCR)));
//STRIP001 
//STRIP001 			GetViewFrame()->GetObjectShell()->
//STRIP001 				GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 
//STRIP001 			if( pXItem )
//STRIP001 				rReq.AppendItem( SfxBoolItem( SID_HAS_X_DESCR, bNewXDescr ) );
//STRIP001 			if( pYItem )
//STRIP001 				rReq.AppendItem( SfxBoolItem( SID_HAS_Y_DESCR, bNewYDescr ) );
//STRIP001 			if( pZItem )
//STRIP001 				rReq.AppendItem( SfxBoolItem( SID_HAS_Z_DESCR, bNewZDescr ) );
//STRIP001 			rReq.Done();
//STRIP001 			Invalidate();
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 // 		case SID_HAS_X_TITLE:
//STRIP001 // 		case SID_HAS_Y_TITLE:
//STRIP001 // 		case SID_HAS_Z_TITLE:
//STRIP001 		case SID_TOGGLE_AXIS_TITLE:
//STRIP001 		{
//STRIP001 			GetViewFrame()->GetDispatcher()->Execute(SID_TOOL_SELECT, SFX_CALLMODE_SYNCHRON);
//STRIP001 
//STRIP001 			BOOL bOldShowMain   = pChDoc->ShowMainTitle();
//STRIP001 			String aOldMain     = pChDoc->MainTitle();
//STRIP001 			BOOL bOldShowSub    = pChDoc->ShowSubTitle();
//STRIP001 			String aOldSub      = pChDoc->SubTitle();
//STRIP001 			BOOL bOldShowXAxis  = pChDoc->ShowXAxisTitle();
//STRIP001 			String aOldXAxis    = pChDoc->XAxisTitle();
//STRIP001 			BOOL bOldShowYAxis  = pChDoc->ShowYAxisTitle();
//STRIP001 			String aOldYAxis    = pChDoc->YAxisTitle();
//STRIP001 			BOOL bOldShowZAxis  = pChDoc->ShowZAxisTitle();
//STRIP001 			String aOldZAxis    = pChDoc->ZAxisTitle();
//STRIP001 
//STRIP001             BOOL bNewShow = ! ( bOldShowXAxis || bOldShowYAxis ||
//STRIP001                                 (pChDoc->Is3DChart() && bOldShowZAxis) );
//STRIP001 
//STRIP001 			pChDoc->ChangeTitle(bOldShowMain, aOldMain, bOldShowSub,
//STRIP001 								aOldSub, bNewShow, aOldXAxis,
//STRIP001 								bNewShow, aOldYAxis, bNewShow, aOldZAxis);
//STRIP001 			SchUndoInsertTitle* pUndo =
//STRIP001 				new SchUndoInsertTitle(*pChDoc, bOldShowMain, aOldMain,
//STRIP001 									   bOldShowSub, aOldSub, bOldShowXAxis,
//STRIP001 									   aOldXAxis, bOldShowYAxis, aOldYAxis,
//STRIP001 									   bOldShowZAxis, aOldZAxis, bOldShowMain,
//STRIP001 									   aOldMain, bOldShowSub, aOldSub,
//STRIP001 									   bNewShow, aOldXAxis, bNewShow,
//STRIP001 									   aOldYAxis, bNewShow, aOldZAxis);
//STRIP001 			pUndo->SetComment(String(SchResId(STR_UNDO_TOGGLE_AXIS_TITLE)));
//STRIP001 
//STRIP001 			GetViewFrame()->GetObjectShell()->
//STRIP001 				GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 
//STRIP001 			rReq.Done();
//STRIP001 			Invalidate();
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_TOGGLE_AXIS_DESCR:
//STRIP001 		{
//STRIP001 			GetViewFrame()->GetDispatcher()->Execute(SID_TOOL_SELECT, SFX_CALLMODE_SYNCHRON);
//STRIP001 
//STRIP001 			BOOL bOldXAxis      = pChDoc->ShowXAxis();
//STRIP001 			BOOL bOldXDescr     = pChDoc->ShowXDescr();
//STRIP001 			BOOL bOldYAxis      = pChDoc->ShowYAxis();
//STRIP001 			BOOL bOldYDescr     = pChDoc->ShowYDescr();
//STRIP001 			BOOL bOldZAxis      = pChDoc->ShowZAxis();
//STRIP001 			BOOL bOldZDescr     = pChDoc->ShowZDescr();
//STRIP001 
//STRIP001 			BOOL bOld2YAxis  = pChDoc->GetAxisByUID(CHART_AXIS_SECONDARY_Y)->IsVisible();
//STRIP001 			BOOL bOld2YDescr = pChDoc->GetAxisByUID(CHART_AXIS_SECONDARY_Y)->HasDescription();
//STRIP001 			BOOL bOld2XAxis  = pChDoc->GetAxisByUID(CHART_AXIS_SECONDARY_X)->IsVisible();
//STRIP001 			BOOL bOld2XDescr = pChDoc->GetAxisByUID(CHART_AXIS_SECONDARY_X)->HasDescription();
//STRIP001 
//STRIP001 			BOOL bNewDescr      = ! ( bOldXDescr || bOldYDescr || bOldZDescr );
//STRIP001 
//STRIP001 			pChDoc->ChangeAxis( bOldXAxis, bNewDescr,
//STRIP001 								bOldYAxis, bNewDescr,
//STRIP001 								bOldZAxis, bNewDescr,
//STRIP001 								bOld2YAxis,bOld2YDescr,
//STRIP001 								bOld2XAxis,bOld2XDescr );
//STRIP001 
//STRIP001 			SchUndoInsertAxis* pUndo =
//STRIP001 				new SchUndoInsertAxis( *pChDoc,
//STRIP001 									   bOldXAxis, bOldXDescr,
//STRIP001 									   bOldYAxis, bOldYDescr,
//STRIP001 									   bOldZAxis, bOldZDescr,
//STRIP001 									   bOld2YAxis,bOld2YDescr,
//STRIP001 									   bOld2XAxis,bOld2XDescr,
//STRIP001 
//STRIP001 									   bOldXAxis, bNewDescr,
//STRIP001 									   bOldYAxis, bNewDescr,
//STRIP001 									   bOldZAxis, bNewDescr,
//STRIP001 									   bOld2YAxis,bOld2YDescr,
//STRIP001 									   bOld2XAxis,bOld2XDescr );
//STRIP001 
//STRIP001 			pUndo->SetComment(String(SchResId(STR_UNDO_TOGGLE_AXIS_DESCR)));
//STRIP001 
//STRIP001 			GetViewFrame()->GetObjectShell()->
//STRIP001 				GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 
//STRIP001 			rReq.Done();
//STRIP001 			Invalidate();
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_TOGGLE_GRID_HORZ:
//STRIP001 		{
//STRIP001 			GetViewFrame()->GetDispatcher()->Execute(SID_TOOL_SELECT, SFX_CALLMODE_SYNCHRON);
//STRIP001 
//STRIP001 			BOOL bOldXGridMain  = pChDoc->ShowXGridMain();
//STRIP001 			BOOL bOldXGridHelp  = pChDoc->ShowXGridHelp();
//STRIP001 			BOOL bOldYGridMain  = pChDoc->ShowYGridMain();
//STRIP001 			BOOL bOldYGridHelp  = pChDoc->ShowYGridHelp();
//STRIP001 			BOOL bOldZGridMain  = pChDoc->ShowZGridMain();
//STRIP001 			BOOL bOldZGridHelp  = pChDoc->ShowZGridHelp();
//STRIP001 
//STRIP001 			BOOL bNewXGridMain  = ! bOldXGridMain;
//STRIP001 
//STRIP001 			pChDoc->ChangeGrid( bNewXGridMain, bOldXGridHelp,
//STRIP001 								bOldYGridMain, bOldYGridHelp,
//STRIP001 								bOldZGridMain, bOldZGridHelp );
//STRIP001 
//STRIP001 			SchUndoInsertGrid* pUndo =
//STRIP001 				new SchUndoInsertGrid( *pChDoc,
//STRIP001 									   bOldXGridMain, bOldXGridHelp,
//STRIP001 									   bOldYGridMain, bOldYGridHelp,
//STRIP001 									   bOldZGridMain, bOldZGridHelp,
//STRIP001 									   bNewXGridMain, bOldXGridHelp,
//STRIP001 									   bOldYGridMain, bOldYGridHelp,
//STRIP001 									   bOldZGridMain, bOldZGridHelp );
//STRIP001 
//STRIP001 			pUndo->SetComment(String(SchResId(STR_UNDO_TOGGLE_GRID_HORZ)));
//STRIP001 
//STRIP001 			GetViewFrame()->GetObjectShell()->
//STRIP001 				GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 
//STRIP001 			rReq.Done();
//STRIP001 			Invalidate();
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_TOGGLE_GRID_VERT:
//STRIP001 		{
//STRIP001 			GetViewFrame()->GetDispatcher()->Execute(SID_TOOL_SELECT, SFX_CALLMODE_SYNCHRON);
//STRIP001 
//STRIP001 			BOOL bOldXGridMain  = pChDoc->ShowXGridMain();
//STRIP001 			BOOL bOldXGridHelp  = pChDoc->ShowXGridHelp();
//STRIP001 			BOOL bOldYGridMain  = pChDoc->ShowYGridMain();
//STRIP001 			BOOL bOldYGridHelp  = pChDoc->ShowYGridHelp();
//STRIP001 			BOOL bOldZGridMain  = pChDoc->ShowZGridMain();
//STRIP001 			BOOL bOldZGridHelp  = pChDoc->ShowZGridHelp();
//STRIP001 
//STRIP001 			BOOL bNewYGridMain  = ! bOldYGridMain;
//STRIP001 
//STRIP001 			pChDoc->ChangeGrid( bOldXGridMain, bOldXGridHelp,
//STRIP001 								bNewYGridMain, bOldYGridHelp,
//STRIP001 								bOldZGridMain, bOldZGridHelp );
//STRIP001 
//STRIP001 			SchUndoInsertGrid* pUndo =
//STRIP001 				new SchUndoInsertGrid( *pChDoc,
//STRIP001 									   bOldXGridMain, bOldXGridHelp,
//STRIP001 									   bOldYGridMain, bOldYGridHelp,
//STRIP001 									   bOldZGridMain, bOldZGridHelp,
//STRIP001 
//STRIP001 									   bOldXGridMain, bOldXGridHelp,
//STRIP001 									   bNewYGridMain, bOldYGridHelp,
//STRIP001 									   bOldZGridMain, bOldZGridHelp );
//STRIP001 
//STRIP001 			pUndo->SetComment(String(SchResId(STR_UNDO_TOGGLE_GRID_VERT)));
//STRIP001 
//STRIP001 			GetViewFrame()->GetObjectShell()->
//STRIP001 				GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 
//STRIP001 			rReq.Done();
//STRIP001 			Invalidate();
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_DATA_IN_ROWS:
//STRIP001 		{
//STRIP001 			if(pChDoc->GetChartData()->GetTranslation()!=TRANS_NONE)
//STRIP001 			{
//STRIP001 				InfoBox aInfoBox(NULL, String(SchResId(STR_TRANSLATED)));
//STRIP001 				aInfoBox.Execute();
//STRIP001 				bUserKnowsTranslation=TRUE;
//STRIP001 				rReq.Done();
//STRIP001 				Cancel();
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				GetViewFrame()->GetDispatcher()->Execute(SID_TOOL_SELECT, SFX_CALLMODE_SYNCHRON);
//STRIP001 
//STRIP001 				BOOL bOldSwitch = pChDoc->IsSwitchData();
//STRIP001 				if (pChDoc->ChangeSwitchData(FALSE))
//STRIP001 				{
//STRIP001 					SchUndoSwitchData* pUndo =
//STRIP001 						new SchUndoSwitchData(*pChDoc, bOldSwitch, FALSE);
//STRIP001 					pUndo->SetComment(String(SchResId(STR_UNDO_DATA_IN_ROWS)));
//STRIP001 
//STRIP001 					GetViewFrame()->GetObjectShell()->
//STRIP001 						GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 				}
//STRIP001 				rReq.Done();
//STRIP001 				Invalidate();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_DATA_IN_COLUMNS:
//STRIP001 		{
//STRIP001 			if(pChDoc->GetChartData()->GetTranslation()!=TRANS_NONE)
//STRIP001 			{
//STRIP001 				InfoBox aInfoBox(NULL, String(SchResId(STR_TRANSLATED)));
//STRIP001 				aInfoBox.Execute();
//STRIP001 				bUserKnowsTranslation=TRUE;
//STRIP001 				rReq.Done();
//STRIP001 				Cancel();
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				GetViewFrame()->GetDispatcher()->Execute(SID_TOOL_SELECT, SFX_CALLMODE_SYNCHRON);
//STRIP001 
//STRIP001 				BOOL bOldSwitch = pChDoc->IsSwitchData();
//STRIP001 				if (pChDoc->ChangeSwitchData(TRUE))
//STRIP001 				{
//STRIP001 					SchUndoSwitchData* pUndo =
//STRIP001 						new SchUndoSwitchData(*pChDoc, bOldSwitch, TRUE);
//STRIP001 					pUndo->SetComment(String(SchResId(STR_UNDO_DATA_IN_COLUMNS)));
//STRIP001 
//STRIP001 					GetViewFrame()->GetObjectShell()->
//STRIP001 						GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 				}
//STRIP001 				rReq.Done();
//STRIP001 				Invalidate();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_SET_DEFAULT:
//STRIP001 		{
//STRIP001 			GetViewFrame()->GetDispatcher()->Execute(SID_TOOL_SELECT, SFX_CALLMODE_SYNCHRON);
//STRIP001 
//STRIP001 			pChView->SetDefault();
//STRIP001 			pChDoc->BuildChart(FALSE);
//STRIP001 			rReq.Done();
//STRIP001 			Invalidate();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_CHARMAP:
//STRIP001 			pFuActual = new SchFuCharMap( this, GetWindow(), pChView, pChDoc, rReq );
//STRIP001 			Invalidate();
//STRIP001 			Cancel();
//STRIP001 			break;
//STRIP001 
//STRIP001 		default:
//STRIP001 			FuTemp2(rReq);
//STRIP001 			break;
//STRIP001 	}
//STRIP001 }


}
