/*************************************************************************
 *
 *  $RCSfile: sd_docprev.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:37:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _SFX_OBJSH_HXX // SfxObjectShell
// auto strip #include <bf_sfx2/objsh.hxx>
// auto strip #endif

// auto strip #ifndef _SV_GDIMTF_HXX // GDIMetaFile
// auto strip #include <vcl/gdimtf.hxx>
// auto strip #endif

// auto strip #ifndef _SV_VIRDEV_HXX // class VirtualDevice
// auto strip #include <vcl/virdev.hxx>
// auto strip #endif

// auto strip #ifndef _COM_SUN_STAR_PRESENTATION_FADEEFFECT_HPP_
// auto strip #include <com/sun/star/presentation/FadeEffect.hpp>
// auto strip #endif

#ifndef _SD_FADEDEF_H // enum FadeSpeed
#include <fadedef.h>
#endif

// auto strip #ifndef _SV_CTRL_HXX // class Control
// auto strip #include <vcl/ctrl.hxx>
// auto strip #endif

// auto strip #ifndef _SVDOUTL_HXX
// auto strip #include <bf_svx/svdoutl.hxx>
// auto strip #endif
// auto strip #ifndef _SVDPAGV_HXX
// auto strip #include <bf_svx/svdpagv.hxx>
// auto strip #endif
// auto strip #ifndef _SVDORECT_HXX
// auto strip #include <bf_svx/svdorect.hxx>
// auto strip #endif

// auto strip #ifndef _SD_FADER_HXX
// auto strip #include "fader.hxx"
// auto strip #endif

// auto strip #include "docprev.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "docshell.hxx"
// auto strip #include "viewshel.hxx"
// auto strip #include "showview.hxx"
// auto strip #include "drawview.hxx"
#include "sdpage.hxx"
namespace binfilter {

using namespace ::com::sun::star;

//STRIP001 const int SdDocPreviewWin::FRAME = 4;

//STRIP001 void SdDocPreviewWin::SetObjectShell( SfxObjectShell* pObj, sal_uInt16 nShowPage )
//STRIP001 {
//STRIP001 	mpObj = pObj;
//STRIP001 	mnShowPage = nShowPage;
//STRIP001 
//STRIP001 	updateViewSettings();
//STRIP001 }

//STRIP001 IMPL_LINK( SdDocPreviewWin, PaintProc, SdrPaintProcRec *, pRecord )
//STRIP001 {
//STRIP001 	SdrObject* pObj = pRecord->pObj;
//STRIP001 	if( !pObj->IsEmptyPresObj() )
//STRIP001 	{
//STRIP001 		pObj->Paint( pRecord->rOut, pRecord->rInfoRec );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		// sad but true, background shapes are also empty presentation objects
//STRIP001 		// so we need to check if this is one
//STRIP001 		if( pObj->GetPage()->IsMasterPage() && (pObj->GetPage() == pObj->GetObjList()) && (pObj->GetOrdNum() == 0) && pObj->ISA( SdrRectObj ) )
//STRIP001 		{
//STRIP001 			pObj->Paint( pRecord->rOut, pRecord->rInfoRec );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }

//STRIP001 SdDocPreviewWin::SdDocPreviewWin( Window* pParent, const ResId& rResId )
//STRIP001 : Control(pParent, rResId), pMetaFile( 0 ), bInEffect(FALSE), mpObj(NULL), mnShowPage(0)
//STRIP001 {
//STRIP001     SetBorderStyle( WINDOW_BORDER_MONO );
//STRIP001     svtools::ColorConfig aColorConfig;
//STRIP001     SetBackground( Wallpaper( Color( aColorConfig.GetColorValue( svtools::APPBACKGROUND ).nColor ) ) );
//STRIP001 }

//STRIP001 SdDocPreviewWin::SdDocPreviewWin( Window* pParent )
//STRIP001 : Control(pParent, 0 ), pMetaFile( 0 ), bInEffect(FALSE), mpObj(NULL), mnShowPage(0)
//STRIP001 {
//STRIP001     SetBorderStyle( WINDOW_BORDER_MONO );
//STRIP001     svtools::ColorConfig aColorConfig;
//STRIP001     SetBackground( Wallpaper( Color( aColorConfig.GetColorValue( svtools::APPBACKGROUND ).nColor ) ) );
//STRIP001 	Resize();
//STRIP001 	Show();
//STRIP001 }
//STRIP001 
//STRIP001 void SdDocPreviewWin::Resize()
//STRIP001 {
//STRIP001 	Invalidate();
//STRIP001 }
//STRIP001 
//STRIP001 void SdDocPreviewWin::SetGDIFile( GDIMetaFile* pFile )
//STRIP001 {
//STRIP001 	delete pMetaFile;
//STRIP001 	pMetaFile = pFile;
//STRIP001 	Invalidate();
//STRIP001 }
//STRIP001 
//STRIP001 void SdDocPreviewWin::CalcSizeAndPos( GDIMetaFile* pFile, Size& rSize, Point& rPoint )
//STRIP001 {
//STRIP001 	Size aTmpSize = pFile ? pFile->GetPrefSize() : Size(1,1 );
//STRIP001 	long nWidth = rSize.Width() - 2*FRAME;
//STRIP001 	long nHeight = rSize.Height() - 2*FRAME;
//STRIP001 	if( nWidth < 0 ) nWidth = 0;
//STRIP001 	if( nHeight < 0 ) nHeight = 0;
//STRIP001 
//STRIP001 	double dRatio=((double)aTmpSize.Width())/aTmpSize.Height();
//STRIP001 	double dRatioPreV=((double) nWidth ) / nHeight;
//STRIP001 
//STRIP001 	if (dRatio>dRatioPreV)
//STRIP001 	{
//STRIP001 		rSize=Size(nWidth, (USHORT)(nWidth/dRatio));
//STRIP001 		rPoint=Point( 0, (USHORT)((nHeight-rSize.Height())/2));
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		rSize=Size((USHORT)(nHeight*dRatio), nHeight);
//STRIP001 		rPoint=Point((USHORT)((nWidth-rSize.Width())/2),0);
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void SdDocPreviewWin::ImpPaint( GDIMetaFile* pFile, OutputDevice* pVDev )
//STRIP001 {
//STRIP001 	Point aPoint;
//STRIP001 	Size aSize = pVDev->GetOutputSize();
//STRIP001 	Point bPoint(aSize.Width()-2*FRAME, aSize.Height()-2*FRAME );
//STRIP001 	CalcSizeAndPos( pFile, aSize, aPoint );
//STRIP001 	bPoint -= aPoint;
//STRIP001 	aPoint += Point( FRAME, FRAME );
//STRIP001 
//STRIP001     svtools::ColorConfig aColorConfig;
//STRIP001 
//STRIP001 	pVDev->SetLineColor();
//STRIP001     pVDev->SetFillColor( Color( aColorConfig.GetColorValue( svtools::APPBACKGROUND ).nColor ) );
//STRIP001 	pVDev->DrawRect(Rectangle( Point(0,0 ), pVDev->GetOutputSize()));
//STRIP001 	if( pFile )
//STRIP001 	{
//STRIP001 		pVDev->SetFillColor( maDocumentColor );
//STRIP001 		pVDev->DrawRect(Rectangle(aPoint, aSize));
//STRIP001 		pFile->WindStart();
//STRIP001 		pFile->Play( pVDev, aPoint, aSize  );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void SdDocPreviewWin::Paint( const Rectangle& rRect )
//STRIP001 {
//STRIP001 	SvtAccessibilityOptions aAccOptions;
//STRIP001 	bool bUseContrast = aAccOptions.GetIsForPagePreviews() && Application::GetSettings().GetStyleSettings().GetHighContrastMode();
//STRIP001 	SetDrawMode( bUseContrast ? OUTPUT_DRAWMODE_CONTRAST : OUTPUT_DRAWMODE_COLOR );
//STRIP001 
//STRIP001 	ImpPaint( pMetaFile, (VirtualDevice*)this );
//STRIP001 }
//STRIP001 
//STRIP001 void SdDocPreviewWin::ShowEffect( presentation::FadeEffect eEffect, FadeSpeed eSpeed )
//STRIP001 {
//STRIP001 	if(bInEffect || !pMetaFile)
//STRIP001 		return;
//STRIP001 
//STRIP001 	bInEffect = TRUE;
//STRIP001 
//STRIP001     svtools::ColorConfig aColorConfig;
//STRIP001 
//STRIP001 	SetLineColor();
//STRIP001     SetFillColor( Color( aColorConfig.GetColorValue( svtools::APPBACKGROUND ).nColor ) );
//STRIP001 	DrawRect(Rectangle( Point(0,0 ), GetOutputSize()));
//STRIP001 
//STRIP001 	Point aPoint;
//STRIP001 	Size aSize( GetOutputSize() );
//STRIP001 	Point bPoint(aSize.Width()-2*FRAME, aSize.Height()-2*FRAME );
//STRIP001 	CalcSizeAndPos( pMetaFile, aSize, aPoint );
//STRIP001 	bPoint -= aPoint;
//STRIP001 	aPoint += Point( FRAME, FRAME );
//STRIP001 
//STRIP001 	// virtuelle Devices anlegen
//STRIP001 
//STRIP001 	VirtualDevice* pVDev = new VirtualDevice(*this);
//STRIP001 	pVDev->SetOutputSize( GetOutputSize() );
//STRIP001 	pVDev->SetFillColor( maDocumentColor );
//STRIP001 	pVDev->DrawRect(Rectangle(aPoint, aSize));
//STRIP001 
//STRIP001 	pVDev->SetLineColor();
//STRIP001     pVDev->SetFillColor( Color( aColorConfig.GetColorValue( svtools::APPBACKGROUND ).nColor ) );
//STRIP001 	pVDev->DrawRect(Rectangle( Point(0,0 ), pVDev->GetOutputSize()));
//STRIP001 	if( pMetaFile )
//STRIP001 	{
//STRIP001 		pVDev->SetFillColor( maDocumentColor );
//STRIP001 		pVDev->DrawRect(Rectangle(aPoint, aSize));
//STRIP001 		pMetaFile->WindStart();
//STRIP001 		pMetaFile->Play( pVDev, aPoint, aSize  );
//STRIP001 	}
//STRIP001 
//STRIP001 	// ein Fader zum Ueberblenden
//STRIP001 	Fader* pFader = new Fader(this);
//STRIP001 	pFader->SetEffect( eEffect );
//STRIP001 	pFader->SetSpeed( eSpeed );
//STRIP001 	pFader->SetSource(Rectangle(aPoint, aSize));
//STRIP001 	pFader->SetTarget(Rectangle(aPoint, aSize));
//STRIP001 
//STRIP001 	// virtuelle Devices an Fader uebergeben
//STRIP001 	pFader->SetNewVirtualDevice(pVDev);
//STRIP001 
//STRIP001 	// ueberblenden
//STRIP001 	pFader->Fade();
//STRIP001 
//STRIP001 	delete pFader;
//STRIP001 
//STRIP001 //	DrawOutDev( Point( 0,0 ), GetOutputSize(), Point( 0,0 ), GetOutputSize(), *pVDev );
//STRIP001 
//STRIP001 	delete pVDev;
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 /*
//STRIP001 	Point aPoint;
//STRIP001 	Size aSize = GetOutputSize();
//STRIP001 	Point bPoint( aSize.Width() - 2*FRAME, aSize.Height() - 2*FRAME );
//STRIP001 	CalcSizeAndPos( pMetaFile, aSize, aPoint );
//STRIP001 	bPoint -= aPoint;
//STRIP001 
//STRIP001 	aPoint += Point( FRAME, FRAME );
//STRIP001 	bPoint += Point( FRAME, FRAME );
//STRIP001 
//STRIP001     svtools::ColorConfig aColorConfig;
//STRIP001 
//STRIP001 	// Hintergrund Schwarz
//STRIP001 	SetLineColor();
//STRIP001     SetFillColor( Color( aColorConfig.GetColorValue( svtools::APPBACKGROUND ).nColor ) );
//STRIP001 	DrawRect(Rectangle( Point(0,0 ), GetOutputSize()));
//STRIP001 
//STRIP001 	// korrigierte Seitengroesse, sonst kommt die letzte Pixelreihe(spalte)
//STRIP001 	// nicht mit
//STRIP001 	Size aPixelSize = PixelToLogic(Size(1,1));
//STRIP001 	aSize.Width()	+= aPixelSize.Width();
//STRIP001 	aSize.Height() += aPixelSize.Height();
//STRIP001 
//STRIP001 */
//STRIP001 
//STRIP001 	bInEffect = FALSE;
//STRIP001 }
//STRIP001 
//STRIP001 long SdDocPreviewWin::Notify( NotifyEvent& rNEvt )
//STRIP001 {
//STRIP001 	if ( rNEvt.GetType() == EVENT_MOUSEBUTTONDOWN )
//STRIP001 	{
//STRIP001 		const MouseEvent* pMEvt = rNEvt.GetMouseEvent();
//STRIP001 		if ( pMEvt->IsLeft() )
//STRIP001 		{
//STRIP001 			if( rNEvt.GetWindow() == this )
//STRIP001 			{
//STRIP001 				if(aClickHdl.IsSet())
//STRIP001 					aClickHdl.Call(this);
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return Control::Notify( rNEvt );
//STRIP001 }


//STRIP001 void SdDocPreviewWin::updateViewSettings()
//STRIP001 {
//STRIP001 	SdDrawDocShell* pDocShell = PTR_CAST(SdDrawDocShell,mpObj);
//STRIP001 	SdDrawDocument* pDoc = pDocShell?pDocShell->GetDoc():NULL;
//STRIP001 
//STRIP001 	SvtAccessibilityOptions aAccOptions;
//STRIP001 	bool bUseWhiteColor = !aAccOptions.GetIsForPagePreviews() && GetSettings().GetStyleSettings().GetHighContrastMode();
//STRIP001 	if( bUseWhiteColor )
//STRIP001 	{
//STRIP001 		maDocumentColor = Color( COL_WHITE );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001         svtools::ColorConfig aColorConfig;
//STRIP001         maDocumentColor = Color( aColorConfig.GetColorValue( svtools::DOCCOLOR ).nColor );
//STRIP001 	}
//STRIP001 
//STRIP001 	GDIMetaFile* pMtf = NULL;
//STRIP001 
//STRIP001 	if(pDoc)
//STRIP001 	{
//STRIP001 		SdrOutliner& rOutl = pDoc->GetDrawOutliner();
//STRIP001 		Color aOldBackgroundColor = rOutl.GetBackgroundColor();
//STRIP001 		rOutl.SetBackgroundColor( maDocumentColor );
//STRIP001 
//STRIP001 		pMtf = new GDIMetaFile;
//STRIP001 		SdPage * pPage = pDoc->GetSdPage( mnShowPage, PK_STANDARD );
//STRIP001 
//STRIP001 		VirtualDevice		aVDev;
//STRIP001 
//STRIP001 		const Fraction		aFrac( pDoc->GetScaleFraction() );
//STRIP001 		const MapMode 		aMap( pDoc->GetScaleUnit(), Point(), aFrac, aFrac );
//STRIP001 
//STRIP001 		aVDev.SetMapMode( aMap );
//STRIP001 
//STRIP001         // #109058# Disable output, as we only want to record a metafile
//STRIP001         aVDev.EnableOutput( FALSE );
//STRIP001 
//STRIP001 		pMtf->Record( &aVDev );
//STRIP001 
//STRIP001 		SdDrawView* pView = new SdDrawView(pDocShell, this, NULL);
//STRIP001 
//STRIP001 
//STRIP001 		const Size aSize( pPage->GetSize() );
//STRIP001 
//STRIP001 		pView->SetBordVisible( FALSE );
//STRIP001 		pView->SetPageVisible( FALSE );
//STRIP001 		pView->ShowPage( pPage, Point() );
//STRIP001 
//STRIP001 		const Point	aNewOrg( pPage->GetLftBorder(), pPage->GetUppBorder() );
//STRIP001 		const Size aNewSize( aSize.Width() - pPage->GetLftBorder() - pPage->GetRgtBorder(),
//STRIP001 							  aSize.Height() - pPage->GetUppBorder() - pPage->GetLwrBorder() );
//STRIP001 		const Rectangle aClipRect( aNewOrg, aNewSize );
//STRIP001 		MapMode			aVMap( aMap );
//STRIP001 
//STRIP001 		SdrPageView* pPageView	= pView->GetPageView( pPage );
//STRIP001 
//STRIP001 		aVDev.Push();
//STRIP001 		aVMap.SetOrigin( Point( -aNewOrg.X(), -aNewOrg.Y() ) );
//STRIP001 		aVDev.SetRelativeMapMode( aVMap );
//STRIP001 		aVDev.IntersectClipRegion( aClipRect );
//STRIP001 		const Link aPaintProcLink( LINK(this, SdDocPreviewWin, PaintProc ) );
//STRIP001 
//STRIP001 		for (USHORT i=0; i<pView->GetPageViewCount(); i++)
//STRIP001 		{
//STRIP001 			SdrPageView* pPV=pView->GetPageViewPvNum(i);
//STRIP001 			pPV->InitRedraw(&aVDev,Region( Rectangle( Point(), aNewSize ) ),0,&aPaintProcLink );
//STRIP001 		}
//STRIP001 
//STRIP001 		aVDev.Pop();
//STRIP001 
//STRIP001 		pMtf->Stop();
//STRIP001 		pMtf->WindStart();
//STRIP001 		pMtf->SetPrefMapMode( aMap );
//STRIP001 		pMtf->SetPrefSize( aNewSize );
//STRIP001 
//STRIP001 		rOutl.SetBackgroundColor( aOldBackgroundColor );
//STRIP001 
//STRIP001 		delete pView;
//STRIP001 	}
//STRIP001 
//STRIP001 	delete pMetaFile;
//STRIP001 	pMetaFile = pMtf;
//STRIP001 
//STRIP001 	Invalidate();
//STRIP001 }

//STRIP001 void SdDocPreviewWin::SFX_NOTIFY(SfxBroadcaster& rBC, const TypeId& rBCType, const SfxHint& rHint, const TypeId& rHintType)
//STRIP001 {
//STRIP001 	if( rHint.ISA( SfxSimpleHint ) && ( (SfxSimpleHint&) rHint ).GetId() == SFX_HINT_COLORS_CHANGED )
//STRIP001 	{
//STRIP001 		updateViewSettings();
//STRIP001 	}
//STRIP001 }
//STRIP001 void SdDocPreviewWin::DataChanged( const DataChangedEvent& rDCEvt )
//STRIP001 {
//STRIP001 	Control::DataChanged( rDCEvt );
//STRIP001 
//STRIP001 	if ( (rDCEvt.GetType() == DATACHANGED_SETTINGS) && (rDCEvt.GetFlags() & SETTINGS_STYLE) )
//STRIP001 	{
//STRIP001 		updateViewSettings();
//STRIP001 	}
//STRIP001 }
}
