/*************************************************************************
 *
 *  $RCSfile: sd_effect.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:38:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <string> // HACK: prevent conflict between STLPORT and Workshop headers

// auto strip #ifndef _COM_SUN_STAR_PRESENTATION_ANIMATIONEFFECT_HPP_
// auto strip #include <com/sun/star/presentation/AnimationEffect.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_PRESENTATION_ANIMATIONSPEED_HPP_
// auto strip #include <com/sun/star/presentation/AnimationSpeed.hpp>
// auto strip #endif

#define ITEMID_COLOR SID_COLOR_TABLE

// auto strip #include <bf_svx/gallery.hxx>
// auto strip #include <bf_svx/colritem.hxx>
#ifndef _SFXDISPATCH_HXX //autogen
#include <bf_sfx2/dispatch.hxx>
#endif
// auto strip #ifndef _AEITEM_HXX //autogen
// auto strip #include <svtools/aeitem.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif

// auto strip #include "sdattr.hxx"
#ifdef MAC
#ifdef ITEMID_COLOR
#undef ITEMID_COLOR
#endif
#endif

//STRIP001 #define ITEMID_COLOR		ATTR_ANIMATION_COLOR
//STRIP001 
//STRIP001 #define VALUESET_BACKGROUND	Color( 255, 255, 255 )

#include "effect.hxx"
//STRIP001 #include "slidechg.hxx"	// fuer PreviewController
#include "effect.hrc"
#include "app.hrc"
#include "strings.hrc"
#include "res_bmp.hrc"
// auto strip #include "sdresid.hxx"
// auto strip #include "sdview.hxx"
// auto strip #include "drawdoc.hxx"
namespace binfilter {

using namespace ::com::sun::star;

/*N*/ SFX_IMPL_DOCKINGWINDOW( SdEffectChildWindow, SID_EFFECT_WIN)

//STRIP001 /*************************************************************************
//STRIP001 |*	SdAnimationWin - FloatingWindow
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdEffectWin::SdEffectWin( SfxBindings* pInBindings,
//STRIP001 				SfxChildWindow *pCW, Window* pParent, const SdResId& rSdResId ) :
//STRIP001 		SfxDockingWindow    ( pInBindings, pCW, pParent, rSdResId ),
//STRIP001 
//STRIP001 		aBtnVTEffect	( this, SdResId( BTN_VT_EFFECT ) ),
//STRIP001 		aBtnVTTextEffect( this, SdResId( BTN_VT_TEXT_EFFECT ) ),
//STRIP001 		aBtnVTExtras	( this, SdResId( BTN_VT_EXTRAS ) ),
//STRIP001 		aBtnVTOrder		( this, SdResId( BTN_VT_ORDER ) ),
//STRIP001 		aBtnPreview		( this, SdResId( BTN_PREVIEW ) ),
//STRIP001 		aBtnUpdate		( this, SdResId( BTN_UPDATE ) ),
//STRIP001 		aBtnAssign		( this, SdResId( BTN_ASSIGN ) ),
//STRIP001 
//STRIP001 		aLbEffect		( this, SdResId( LB_EFFECT ) ),
//STRIP001 		aCtlEffect		( this, SdResId( CTL_EFFECT ) ),
//STRIP001 		aLbSpeed		( this, SdResId( LB_SPEED ) ),
//STRIP001 		aGrpEffect		( this, SdResId( GRP_EFFECT ) ),
//STRIP001 
//STRIP001 		aLbTextEffect	( this, SdResId( LB_TEXT_EFFECT ) ),
//STRIP001 		aCtlTextEffect	( this, SdResId( CTL_TEXT_EFFECT ) ),
//STRIP001 
//STRIP001 		aBtnInvisible	( this, SdResId( BTN_INVISIBLE ) ),
//STRIP001 		aBtnFadeOut   	( this, SdResId( BTN_FADEOUT ) ),
//STRIP001 		aLbFadeOutColor	( this, SdResId( LB_FADEOUT_COLOR ) ),
//STRIP001 		aBtnSound   	( this, SdResId( BTN_SOUND ) ),
//STRIP001 		aBtnPlayFull  	( this, SdResId( BTN_PLAY_FULL ) ),
//STRIP001 		aBtnSearch    	( this, SdResId( BTN_SEARCH ) ),
//STRIP001 		aLbSound     	( this, SdResId( LB_SOUND ) ),
//STRIP001 
//STRIP001 		aTlbOrder    	( this, SdResId( TLB_ORDER ), pInBindings ),
//STRIP001 
//STRIP001 		bBreakEven		( FALSE ),
//STRIP001 		bUpdate			( FALSE ),
//STRIP001 		bPathEffectAvailable( FALSE ),
//STRIP001 		bCount			( FALSE ),
//STRIP001 		eViewType		( VIEWTYPE_EFFECT ),
//STRIP001 
//STRIP001 		pBindings		( pInBindings ),
//STRIP001 		ppStringIdList	( NULL ),
//STRIP001 		ppStringIdListTE( NULL ),
//STRIP001 		ppBitmapIdList	( NULL ),
//STRIP001 		ppBitmapIdListTE( NULL ),
//STRIP001 		pSoundList		( NULL ),
//STRIP001 		bTextEffectsAllowed( FALSE )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	// set high contrast images
//STRIP001 	
//STRIP001 	aBtnVTEffect.SetModeImage( Image( SdResId( IMG_EFFECT_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	aBtnVTTextEffect.SetModeImage( Image( SdResId( IMG_TEXT_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	aBtnVTExtras.SetModeImage( Image( SdResId( IMG_EXTRAS_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	aBtnVTOrder.SetModeImage( Image( SdResId( IMG_EFFECT_ORDER_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	aBtnPreview.SetModeImage( Image( SdResId( IMG_PREVIEW_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	aBtnUpdate.SetModeImage( Image( SdResId( IMG_PIPETTE_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	aBtnAssign.SetModeImage( Image( SdResId( IMG_APPLY_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	aBtnInvisible.SetModeImage( Image( SdResId( IMG_INVISIBLE_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	aBtnFadeOut.SetModeImage( Image( SdResId( IMG_FADEOUT_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	aBtnSound.SetModeImage( Image( SdResId( IMG_SOUND_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	aBtnPlayFull.SetModeImage( Image( SdResId( IMG_PLAYFULL_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 	aBtnSearch.SetModeImage( Image( SdResId( IMG_BROWSE_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 
//STRIP001 	pControllerItem = new SdEffectCtrlItem( SID_EFFECT_STATE, this, pBindings );
//STRIP001 	pEffectPrevCtrlItem = new SdEffectPrevCtrlItem( SID_PREVIEW_WIN, this, pBindings );
//STRIP001 
//STRIP001 	Link aLink( LINK( this, SdEffectWin, ClickViewTypeHdl ) );
//STRIP001 	aBtnVTEffect.SetClickHdl( aLink );
//STRIP001 	aBtnVTTextEffect.SetClickHdl( aLink );
//STRIP001 	aBtnVTExtras.SetClickHdl( aLink );
//STRIP001 	aBtnVTOrder.SetClickHdl( aLink );
//STRIP001 
//STRIP001 	aBtnPreview.SetClickHdl( LINK( this, SdEffectWin, ClickPreviewHdl ) );
//STRIP001 	aBtnAssign.SetClickHdl( LINK( this, SdEffectWin, ClickAssignHdl ) );
//STRIP001 	aBtnUpdate.SetClickHdl( LINK( this, SdEffectWin, ClickUpdateHdl ) );
//STRIP001 
//STRIP001 	// Effekte
//STRIP001 	aLbEffect.SetSelectHdl( LINK( this, SdEffectWin, SelectEffectHdl ) );
//STRIP001 	aCtlEffect.SetSelectHdl( LINK( this, SdEffectWin, SelectEffectHdl ) );
//STRIP001 	aCtlEffect.SetDoubleClickHdl( LINK( this, SdEffectWin, DoubleClickHdl ) );
//STRIP001 
//STRIP001 	// TextEffekte
//STRIP001 	aLbTextEffect.SetSelectHdl( LINK( this, SdEffectWin, SelectTextEffectHdl ) );
//STRIP001 	aCtlTextEffect.SetSelectHdl( LINK( this, SdEffectWin, SelectTextEffectHdl ) );
//STRIP001 	aCtlTextEffect.SetDoubleClickHdl( LINK( this, SdEffectWin, DoubleClickHdl ) );
//STRIP001 
//STRIP001 	// Extras
//STRIP001 	aBtnInvisible.SetClickHdl( LINK( this, SdEffectWin, ClickInvisibleHdl ) );
//STRIP001 	aBtnFadeOut.SetClickHdl( LINK( this, SdEffectWin, ClickFadeOutHdl ) );
//STRIP001 	aBtnSound.SetClickHdl( LINK( this, SdEffectWin, ClickSoundHdl ) );
//STRIP001 	aBtnSearch.SetClickHdl( LINK( this, SdEffectWin, ClickSearchHdl ) );
//STRIP001 	aLbSound.SetSelectHdl( LINK( this, SdEffectWin, SelectSoundHdl ) );
//STRIP001 
//STRIP001 	// "normale" CheckButtons
//STRIP001 	aBtnPlayFull.SetClickHdl( LINK( this, SdEffectWin, ClickImageButtonHdl ) );
//STRIP001 
//STRIP001 	aSize = GetOutputSizePixel();
//STRIP001 	SetMinOutputSizePixel( aSize );
//STRIP001 
//STRIP001 	aValueSetHeight = (USHORT) aCtlEffect.GetOutputSizePixel().Height();
//STRIP001 	// Hoehe der Extras-Gruppe berechnen
//STRIP001 	aExtrasHeight = aLbSound.GetPosPixel().Y() + 18 + 20;
//STRIP001 	aBreakEvenHeight = aSize.Height() + aExtrasHeight;
//STRIP001 
//STRIP001 	// Y-Position der Extras-Controls
//STRIP001 	aBtnInvisiblePosY = (USHORT) aBtnInvisible.GetPosPixel().Y();
//STRIP001 	aBtnFadeOutPosY = (USHORT) aBtnFadeOut.GetPosPixel().Y();
//STRIP001 	aLbFadeOutColorPosY = (USHORT) aLbFadeOutColor.GetPosPixel().Y();
//STRIP001 	aBtnSoundPosY = (USHORT) aBtnSound.GetPosPixel().Y();
//STRIP001 	aBtnPlayFullPosY = (USHORT) aBtnPlayFull.GetPosPixel().Y();
//STRIP001 	aBtnSearchPosY = (USHORT) aBtnSearch.GetPosPixel().Y();
//STRIP001 	aLbSoundPosY = (USHORT) aLbSound.GetPosPixel().Y();
//STRIP001 
//STRIP001 	Construct();
//STRIP001 
//STRIP001 	// ViewType-Button initialisieren
//STRIP001 	ClickViewTypeHdl( NULL );
//STRIP001 
//STRIP001 	Reset();
//STRIP001 
//STRIP001 	// Initiierung der Initialisierung der ColorLBs
//STRIP001 	SfxBoolItem aItem( SID_EFFECT_INIT, TRUE );
//STRIP001 	GetBindings().GetDispatcher()->Execute( 
//STRIP001 		SID_EFFECT_INIT, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD, &aItem, 0L );
//STRIP001 
//STRIP001 	// set to default
//STRIP001 	ClickViewTypeHdl( &aBtnVTEffect );
//STRIP001 	aBtnVTExtras.Enable( FALSE );
//STRIP001 	aBtnVTOrder.Enable( FALSE );
//STRIP001 	aBtnVTTextEffect.Enable( FALSE );
//STRIP001 
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SdEffectWin::~SdEffectWin()
//STRIP001 {
//STRIP001 	delete pControllerItem;
//STRIP001 	delete pEffectPrevCtrlItem;
//STRIP001 
//STRIP001 	// Listen bereinigen
//STRIP001 	List* pList;
//STRIP001 	ULONG i;
//STRIP001 
//STRIP001 	for( pList = (List*) ppStringIdList->First();
//STRIP001 		 pList;
//STRIP001 		 pList = (List*) ppStringIdList->Next() )
//STRIP001 	{
//STRIP001 		pList->Clear();
//STRIP001 		// identische Zeiger werden entfernt
//STRIP001 		ppStringIdListTE->Remove( pList );
//STRIP001 
//STRIP001 		delete pList;
//STRIP001 	}
//STRIP001 	ppStringIdList->Clear();
//STRIP001 
//STRIP001 	// TextListen koennen andere Listen besitzen (siehe Sonstiges)
//STRIP001 	ULONG nCount = ppStringIdListTE->Count();
//STRIP001 	if( nCount > 0 )
//STRIP001 	{
//STRIP001 		for( i = 0, pList = (List*) ppStringIdListTE->First();
//STRIP001 			 i < nCount;
//STRIP001 			 i++, pList = (List*) ppStringIdListTE->Next() )
//STRIP001 		{
//STRIP001 			if( pList )
//STRIP001 			{
//STRIP001 				pList->Clear();
//STRIP001 				delete pList;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	ppStringIdListTE->Clear();
//STRIP001 
//STRIP001 	for( pList = (List*) ppBitmapIdList->First();
//STRIP001 		 pList;
//STRIP001 		 pList = (List*) ppBitmapIdList->Next() )
//STRIP001 	{
//STRIP001 		pList->Clear();
//STRIP001 		// identische Zeiger werden entfernt
//STRIP001 		ppBitmapIdListTE->Remove( pList );
//STRIP001 
//STRIP001 		delete pList;
//STRIP001 	}
//STRIP001 	ppBitmapIdList->Clear();
//STRIP001 
//STRIP001 	for( pList = (List*) ppHCBitmapIdList->First();
//STRIP001 		 pList;
//STRIP001 		 pList = (List*) ppHCBitmapIdList->Next() )
//STRIP001 	{
//STRIP001 		pList->Clear();
//STRIP001 		// identische Zeiger werden entfernt
//STRIP001 		ppHCBitmapIdListTE->Remove( pList );
//STRIP001 
//STRIP001 		delete pList;
//STRIP001 	}
//STRIP001 	ppHCBitmapIdList->Clear();
//STRIP001 
//STRIP001 	// TextListen koennen andere Listen besitzen (siehe Sonstiges)
//STRIP001 	nCount = ppBitmapIdListTE->Count();
//STRIP001 	if( nCount > 0 )
//STRIP001 	{
//STRIP001 		for( i = 0, pList = (List*) ppBitmapIdListTE->First();
//STRIP001 			 i < nCount;
//STRIP001 			 i++, pList = (List*) ppBitmapIdListTE->Next() )
//STRIP001 		{
//STRIP001 			if( pList )
//STRIP001 			{
//STRIP001 				pList->Clear();
//STRIP001 				delete pList;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	ppBitmapIdListTE->Clear();
//STRIP001 
//STRIP001 	// --
//STRIP001 	nCount = ppHCBitmapIdListTE->Count();
//STRIP001 	if( nCount > 0 )
//STRIP001 	{
//STRIP001 		for( i = 0, pList = (List*) ppHCBitmapIdListTE->First();
//STRIP001 			 i < nCount;
//STRIP001 			 i++, pList = (List*) ppHCBitmapIdListTE->Next() )
//STRIP001 		{
//STRIP001 			if( pList )
//STRIP001 			{
//STRIP001 				pList->Clear();
//STRIP001 				delete pList;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	ppHCBitmapIdListTE->Clear();
//STRIP001 
//STRIP001 
//STRIP001 	// Soundliste
//STRIP001 	ClearSoundList();
//STRIP001 
//STRIP001 	delete ppStringIdList;
//STRIP001 	delete ppBitmapIdList;
//STRIP001 	delete ppStringIdListTE;
//STRIP001 	delete ppBitmapIdListTE;
//STRIP001 	delete pSoundList;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SdEffectWin::Construct()
//STRIP001 {
//STRIP001 	// Listen aufbauen
//STRIP001 	ppStringIdList = new List();
//STRIP001 	ppBitmapIdList = new List();
//STRIP001 	ppHCBitmapIdList = new List();
//STRIP001 
//STRIP001 	// Listen fuer TextEffekte
//STRIP001 	ppStringIdListTE = new List();
//STRIP001 	ppBitmapIdListTE = new List();
//STRIP001 	ppHCBitmapIdListTE = new List();
//STRIP001 
//STRIP001 	// Kein Effekt (Jetzt Favoriten (nur fuer Effekte))
//STRIP001 	List* pStringList = new List();
//STRIP001 	ppStringIdList->Insert( pStringList, LIST_APPEND );
//STRIP001 
//STRIP001 	List* pBitmapList = new List();
//STRIP001 	ppBitmapIdList->Insert( pBitmapList, LIST_APPEND );
//STRIP001 	
//STRIP001 	List* pHCBitmapList = new List();
//STRIP001 	ppHCBitmapIdList->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_FAVOURITES), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_NONE), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_NONE), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_NONE_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_FROM_L), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_L), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_L_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_LASER_FROM_UR), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_LASER_FROM_UR), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_LASER_FROM_UR_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_PATH), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_PATH), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_PATH_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_FROM_T), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_T), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_T_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_FROM_T), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_TEXTEFFECT_DISCARD_FROM_T), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_TEXTEFFECT_DISCARD_FROM_T_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISSOLVE), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISSOLVE), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISSOLVE_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_FADE_FROM_CENTER), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_CENTER), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_CENTER_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_FADE_FROM_CENTER), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_TEXTEFFECT_FADE_FROM_CENTER), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_TEXTEFFECT_FADE_FROM_CNTR_H), LIST_APPEND );
//STRIP001 
//STRIP001 	// Kein Effekt (nur fuer Texteffekte)
//STRIP001 	pStringList = new List();
//STRIP001 	ppStringIdListTE->Insert( pStringList, LIST_APPEND );
//STRIP001 
//STRIP001 	pBitmapList = new List();
//STRIP001 	ppBitmapIdListTE->Insert( pBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pHCBitmapList = new List();
//STRIP001 	ppHCBitmapIdListTE->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_NONE), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	
//STRIP001 	for( USHORT i = 1; i <= 9; i++ )
//STRIP001 	{
//STRIP001 		pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 		pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 		pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	}
//STRIP001 
//STRIP001 	// Ueberblenden
//STRIP001 	pStringList = new List();
//STRIP001 	ppStringIdList->Insert( pStringList, LIST_APPEND );
//STRIP001 	ppStringIdListTE->Insert( pStringList, LIST_APPEND );
//STRIP001 
//STRIP001 	pBitmapList = new List();
//STRIP001 	ppBitmapIdList->Insert( pBitmapList, LIST_APPEND );
//STRIP001 	ppBitmapIdListTE->Insert( pBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pHCBitmapList = new List();
//STRIP001 	ppHCBitmapIdList->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 	ppHCBitmapIdListTE->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_FADEFROM), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_FADE_FROM_UL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_UL), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_UL_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_FADE_FROM_T), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_T), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_T_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_FADE_FROM_UR), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_UR), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_UR_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_FADE_FROM_L), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_L), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_L_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_FADE_FROM_R), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_R), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_R_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_FADE_FROM_LL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_LL), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_LL_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_FADE_FROM_B), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_B), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_B_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_FADE_FROM_LR), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_LR), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_LR_H), LIST_APPEND );
//STRIP001 
//STRIP001 	// Aufdecken (Jetzt auch TextEffekt)
//STRIP001 	pStringList = new List();
//STRIP001 	ppStringIdList->Insert( pStringList, LIST_APPEND );
//STRIP001 	ppStringIdListTE->Insert( pStringList, LIST_APPEND );
//STRIP001 
//STRIP001 	pBitmapList = new List();
//STRIP001 	ppBitmapIdList->Insert( pBitmapList, LIST_APPEND );
//STRIP001 	ppBitmapIdListTE->Insert( pBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pHCBitmapList = new List();
//STRIP001 	ppHCBitmapIdList->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 	ppHCBitmapIdListTE->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_FROM_UL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_UL), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_UL_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_FROM_T), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_T), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_T_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_FROM_UR), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_UR), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_UR_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_FROM_L), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_L), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_L_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_FROM_R), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_R), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_R_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_FROM_LL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_LL), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_LL_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_FROM_B), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_B), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_B_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_FROM_LR), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_LR), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_FROM_LR_H), LIST_APPEND );
//STRIP001 
//STRIP001 	// verkuerzt Aufdecken (auch TextEffekt)
//STRIP001 	pStringList = new List();
//STRIP001 	ppStringIdList->Insert( pStringList, LIST_APPEND );
//STRIP001 	ppStringIdListTE->Insert( pStringList, LIST_APPEND );
//STRIP001 
//STRIP001 	pBitmapList = new List();
//STRIP001 	ppBitmapIdList->Insert( pBitmapList, LIST_APPEND );
//STRIP001 	ppBitmapIdListTE->Insert( pBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pHCBitmapList = new List();
//STRIP001 	ppHCBitmapIdList->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 	ppHCBitmapIdListTE->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_SHORT), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_S_FROM_UL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_S_FROM_UL), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_S_FROM_UL_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_S_FROM_T), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_S_FROM_T), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_S_FROM_T_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_S_FROM_UR), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_S_FROM_UR), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_S_FROM_UR_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_S_FROM_L), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_S_FROM_L), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_S_FROM_L_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_S_FROM_R), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_S_FROM_R), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_S_FROM_R_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_S_FROM_LL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_S_FROM_LL), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_S_FROM_LL_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_S_FROM_B), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_S_FROM_B), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_S_FROM_B_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISCARD_S_FROM_LR), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_S_FROM_LR), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISCARD_S_FROM_LR_H), LIST_APPEND );
//STRIP001 
//STRIP001 	// Dehnen (auch TextEffekt)
//STRIP001 	pStringList = new List();
//STRIP001 	ppStringIdList->Insert( pStringList, LIST_APPEND );
//STRIP001 	ppStringIdListTE->Insert( pStringList, LIST_APPEND );
//STRIP001 
//STRIP001 	pBitmapList = new List();
//STRIP001 	ppBitmapIdList->Insert( pBitmapList, LIST_APPEND );
//STRIP001 	ppBitmapIdListTE->Insert( pBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pHCBitmapList = new List();
//STRIP001 	ppHCBitmapIdList->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 	ppHCBitmapIdListTE->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_STRTCH), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_STRTCH_FROM_UL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_FROM_UL), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_FROM_UL_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_STRTCH_FROM_T), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_FROM_T), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_FROM_T_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_STRTCH_FROM_UR), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_FROM_UR), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_FROM_UR_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_STRTCH_FROM_L), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_FROM_L), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_FROM_L_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_STRTCH_FROM_R), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_FROM_R), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_FROM_R_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_STRTCH_FROM_LL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_FROM_LL), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_FROM_LL_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_STRTCH_FROM_B), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_FROM_B), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_FROM_B_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_STRTCH_FROM_LR), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_FROM_LR), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_FROM_LR_H), LIST_APPEND );
//STRIP001 
//STRIP001 	// Dehnen und Rotieren (auch TextEffekt)
//STRIP001 	pStringList = new List();
//STRIP001 	ppStringIdList->Insert( pStringList, LIST_APPEND );
//STRIP001 	ppStringIdListTE->Insert( pStringList, LIST_APPEND );
//STRIP001 
//STRIP001 	pBitmapList = new List();
//STRIP001 	ppBitmapIdList->Insert( pBitmapList, LIST_APPEND );
//STRIP001 	ppBitmapIdListTE->Insert( pBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pHCBitmapList = new List();
//STRIP001 	ppHCBitmapIdList->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 	ppHCBitmapIdListTE->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_STRTCH_ROTATE), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_STRTCH_HORIZONTAL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_HORIZONTAL), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_HORIZONTAL_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_STRTCH_VERTICAL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_VERTICAL), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_STRTCH_VERTICAL_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_ROTATE_HORIZONTAL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_ROTATE_HORIZONTAL), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_ROTATE_HORIZONTAL_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_ROTATE_VERTICAL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_ROTATE_VERTICAL), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_ROTATE_VERTICAL_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 
//STRIP001 	// Blenden
//STRIP001 	pStringList = new List();
//STRIP001 	ppStringIdList->Insert( pStringList, LIST_APPEND );
//STRIP001 	ppStringIdListTE->Insert( pStringList, LIST_APPEND );
//STRIP001 
//STRIP001 	pBitmapList = new List();
//STRIP001 	ppBitmapIdList->Insert( pBitmapList, LIST_APPEND );
//STRIP001 	ppBitmapIdListTE->Insert( pBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pHCBitmapList = new List();
//STRIP001 	ppHCBitmapIdList->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 	ppHCBitmapIdListTE->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_FADE), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_FADE_TO_CENTER), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_TO_CENTER), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_TO_CENTER_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_FADE_FROM_CENTER), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_CENTER), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_FADE_FROM_CENTER_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_VERTICAL_STRIPES), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_VERTICAL_STRIPES), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_VERTICAL_STRIPES_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_HORIZONTAL_STRIPES), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_HORIZONTAL_STRIPES), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_HORIZONTAL_STRIPES_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_CLOCKWISE), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_CLOCKWISE), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_CLOCKWISE_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_COUNTERCLOCKWISE), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_COUNTERCLOCKWISE), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_COUNTERCLOCKWISE_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 
//STRIP001 	// Oeffnen / Schliessen
//STRIP001 	pStringList = new List();
//STRIP001 	ppStringIdList->Insert( pStringList, LIST_APPEND );
//STRIP001 	ppStringIdListTE->Insert( pStringList, LIST_APPEND );
//STRIP001 
//STRIP001 	pBitmapList = new List();
//STRIP001 	ppBitmapIdList->Insert( pBitmapList, LIST_APPEND );
//STRIP001 	ppBitmapIdListTE->Insert( pBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pHCBitmapList = new List();
//STRIP001 	ppHCBitmapIdList->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 	ppHCBitmapIdListTE->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_OPEN_CLOSE), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_OPEN_VERTICAL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_OPEN_VERTICAL), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_OPEN_VERTICAL_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_OPEN_HORIZONTAL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_OPEN_HORIZONTAL), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_OPEN_HORIZONTAL_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_CLOSE_VERTICAL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_CLOSE_VERTICAL), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_CLOSE_VERTICAL_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_CLOSE_HORIZONTAL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_CLOSE_HORIZONTAL), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_CLOSE_HORIZONTAL_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 
//STRIP001 	// Schlangenlinie
//STRIP001 	pStringList = new List();
//STRIP001 	ppStringIdList->Insert( pStringList, LIST_APPEND );
//STRIP001 	ppStringIdListTE->Insert( pStringList, LIST_APPEND );
//STRIP001 
//STRIP001 	pBitmapList = new List();
//STRIP001 	ppBitmapIdList->Insert( pBitmapList, LIST_APPEND );
//STRIP001 	ppBitmapIdListTE->Insert( pBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pHCBitmapList = new List();
//STRIP001 	ppHCBitmapIdList->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 	ppHCBitmapIdListTE->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_WAVYLINE), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_WAVYLINE_FROM_T), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_WAVYLINE_FROM_T), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_WAVYLINE_FROM_T_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_WAVYLINE_FROM_L), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_WAVYLINE_FROM_L), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_WAVYLINE_FROM_L_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_WAVYLINE_FROM_R), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_WAVYLINE_FROM_R), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_WAVYLINE_FROM_R_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_WAVYLINE_FROM_B), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_WAVYLINE_FROM_B), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_WAVYLINE_FROM_B_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 
//STRIP001 	// Spirale
//STRIP001 	pStringList = new List();
//STRIP001 	ppStringIdList->Insert( pStringList, LIST_APPEND );
//STRIP001 	ppStringIdListTE->Insert( pStringList, LIST_APPEND );
//STRIP001 
//STRIP001 	pBitmapList = new List();
//STRIP001 	ppBitmapIdList->Insert( pBitmapList, LIST_APPEND );
//STRIP001 	ppBitmapIdListTE->Insert( pBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pHCBitmapList = new List();
//STRIP001 	ppHCBitmapIdList->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 	ppHCBitmapIdListTE->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_SPIRAL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_SPIRALIN_L), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_SPIRALIN_L), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_SPIRALIN_L_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_SPIRALIN_R), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_SPIRALIN_R), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_SPIRALIN_R_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_SPIRALOUT_L), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_SPIRALOUT_L), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_SPIRALOUT_L_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_SPIRALOUT_R), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_SPIRALOUT_R), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_SPIRALOUT_R_H), LIST_APPEND );
//STRIP001 
//STRIP001 	// Laser (nur TextEffekt (zumindest fuer den Benutzer) )
//STRIP001 	pStringList = new List();
//STRIP001 	ppStringIdListTE->Insert( pStringList, LIST_APPEND );
//STRIP001 
//STRIP001 	pBitmapList = new List();
//STRIP001 	ppBitmapIdListTE->Insert( pBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pHCBitmapList = new List();
//STRIP001 	ppHCBitmapIdListTE->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_LASER), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_LASER_FROM_UL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_LASER_FROM_UL), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_LASER_FROM_UL_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_LASER_FROM_T), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_LASER_FROM_T), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_LASER_FROM_T_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_LASER_FROM_UR), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_LASER_FROM_UR), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_LASER_FROM_UR_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_LASER_FROM_L), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_LASER_FROM_L), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_LASER_FROM_L_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_LASER_FROM_R), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_LASER_FROM_R), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_LASER_FROM_R_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_LASER_FROM_LL), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_LASER_FROM_LL), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_LASER_FROM_LL_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_LASER_FROM_B), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_LASER_FROM_B), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_LASER_FROM_B_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_LASER_FROM_LR), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_LASER_FROM_LR), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_LASER_FROM_LR_H), LIST_APPEND );
//STRIP001 
//STRIP001 	// Extras ("An Kurve entlang" und "Automatisch" nicht fuer TextEffekt)
//STRIP001 	pStringList = new List();
//STRIP001 	ppStringIdList->Insert( pStringList, LIST_APPEND );
//STRIP001 
//STRIP001 	pBitmapList = new List();
//STRIP001 	ppBitmapIdList->Insert( pBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pHCBitmapList = new List();
//STRIP001 	ppHCBitmapIdList->Insert( pHCBitmapList, LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_EXTRA), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) 0), LIST_APPEND );
//STRIP001 
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_VERTICAL_LINES), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_VERTICAL_LINES), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_VERTICAL_LINES_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_HORIZONTAL_LINES), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_HORIZONTAL_LINES), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_HORIZONTAL_LINES_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_DISSOLVE), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISSOLVE), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_DISSOLVE_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_VERTICAL_CHECKERBOARD), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_VERTICAL_CHECKERBOARD), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_VERT_CHECKBRD_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_HORIZONTAL_CHECKERBOARD), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_HORIZONTAL_CHECKERBOARD), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_HOR_CHECKBRD_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_APPEAR), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_APPEAR), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_APPEAR_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_HIDE), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_HIDE), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_HIDE_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_PATH), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_PATH), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_PATH_H), LIST_APPEND );
//STRIP001 	pStringList->Insert( (void*) ((ULONG) STR_EFFECT_RANDOM), LIST_APPEND );
//STRIP001 	pBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_RANDOM), LIST_APPEND );
//STRIP001 	pHCBitmapList->Insert( (void*) ((ULONG) BMP_EFFECT_RANDOM_H), LIST_APPEND );
//STRIP001 
//STRIP001 	// Extras fuer Texteffekte
//STRIP001 	List* pStringListTE = new List( *pStringList );
//STRIP001 	List* pBitmapListTE = new List( *pBitmapList );
//STRIP001 	List* pHCBitmapListTE = new List( *pHCBitmapList );
//STRIP001 
//STRIP001 	pStringListTE->Replace( (void*) ((ULONG) 0), 7 ); // Ausblenden
//STRIP001 	pBitmapListTE->Replace( (void*) ((ULONG) 0), 7 );
//STRIP001 	pHCBitmapListTE->Replace( (void*) ((ULONG) 0), 7 );
//STRIP001 	pStringListTE->Replace( (void*) ((ULONG) 0), 8 ); // Pfad
//STRIP001 	pBitmapListTE->Replace( (void*) ((ULONG) 0), 8 );
//STRIP001 	pHCBitmapListTE->Replace( (void*) ((ULONG) 0), 8 );
//STRIP001 	pStringListTE->Replace( (void*) ((ULONG) 0), 9 ); // Automatisch
//STRIP001 	pBitmapListTE->Replace( (void*) ((ULONG) 0), 9 );
//STRIP001 	pHCBitmapListTE->Replace( (void*) ((ULONG) 0), 9 );
//STRIP001 
//STRIP001 	ppStringIdListTE->Insert( pStringListTE, LIST_APPEND );
//STRIP001 	ppBitmapIdListTE->Insert( pBitmapListTE, LIST_APPEND );
//STRIP001 	ppHCBitmapIdListTE->Insert( pHCBitmapListTE, LIST_APPEND );
//STRIP001 
//STRIP001 	const Color aValueSetColor( VALUESET_BACKGROUND ); 
//STRIP001 
//STRIP001 	// ValueSet Effect
//STRIP001 	aCtlEffect.SetStyle( aCtlEffect.GetStyle() | WB_3DLOOK | WB_ITEMBORDER | WB_DOUBLEBORDER | WB_FLATVALUESET | WB_NAMEFIELD );
//STRIP001 //	aCtlEffect.SetBackground( Wallpaper( aValueSetColor ) );
//STRIP001 //	aCtlEffect.SetControlBackground( aValueSetColor );
//STRIP001 //	aCtlEffect.SetColor( aValueSetColor );
//STRIP001 	aCtlEffect.SetColCount( 3 );
//STRIP001 	aCtlEffect.SetLineCount( 3 );
//STRIP001 	aCtlEffect.SetExtraSpacing( 2 );
//STRIP001 	aCtlEffect.Show();
//STRIP001 
//STRIP001 	// Listbox Effect
//STRIP001 	for( i = 0; i < ppStringIdList->Count(); i++ )
//STRIP001 		aLbEffect.InsertEntry( String( SdResId( GetStringId( 0, i, &aCtlEffect ) ) ) );
//STRIP001 
//STRIP001 	// ValueSet TextEffect
//STRIP001 	aCtlTextEffect.SetStyle( aCtlTextEffect.GetStyle() | WB_3DLOOK | WB_ITEMBORDER | WB_DOUBLEBORDER | WB_FLATVALUESET | WB_NAMEFIELD );
//STRIP001 //	aCtlTextEffect.SetBackground( Wallpaper( aValueSetColor ) );
//STRIP001 //	aCtlTextEffect.SetControlBackground( aValueSetColor );
//STRIP001 //	aCtlTextEffect.SetColor( aValueSetColor );
//STRIP001 	aCtlTextEffect.SetColCount( 3 );
//STRIP001 	aCtlTextEffect.SetLineCount( 3 );
//STRIP001 	aCtlTextEffect.SetExtraSpacing( 2 );
//STRIP001 	//aCtlTextEffect.Show();
//STRIP001 
//STRIP001 	// Listbox TextEffect
//STRIP001 	for( i = 0; i < ppStringIdListTE->Count(); i++ )
//STRIP001 		aLbTextEffect.InsertEntry( String( SdResId( GetStringId( 0, i, &aCtlTextEffect ) ) ) );
//STRIP001 
//STRIP001 	// Sound-Namenliste aufbauen
//STRIP001 	pSoundList = new List();
//STRIP001 	FillSoundListAndBox();
//STRIP001 
//STRIP001     // Set the quick help text as accessibility name.  This avoids changing
//STRIP001     // the resource.  This, by copying QuickHelpText to Text, should be done
//STRIP001     // sometime in the future.
//STRIP001     aBtnVTEffect.SetAccessibleName (aBtnVTEffect.GetQuickHelpText());
//STRIP001     aBtnVTTextEffect.SetAccessibleName (aBtnVTTextEffect.GetQuickHelpText());
//STRIP001     aBtnVTExtras.SetAccessibleName (aBtnVTExtras.GetQuickHelpText());
//STRIP001     aBtnVTOrder.SetAccessibleName (aBtnVTOrder.GetQuickHelpText());
//STRIP001     aBtnUpdate.SetAccessibleName (aBtnUpdate.GetQuickHelpText());
//STRIP001     aBtnAssign.SetAccessibleName (aBtnAssign.GetQuickHelpText());
//STRIP001     aBtnPreview.SetAccessibleName (aBtnPreview.GetQuickHelpText());
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SdEffectWin::Reset()
//STRIP001 {
//STRIP001 	ClickUpdateHdl( NULL );
//STRIP001 
//STRIP001 	aLbSpeed.SelectEntryPos( 1 );
//STRIP001 	aLbEffect.SelectEntryPos( 0 );
//STRIP001 	aLbTextEffect.SelectEntryPos( 0 );
//STRIP001 
//STRIP001 	SelectEffectHdl( NULL );
//STRIP001 	SelectTextEffectHdl( NULL );
//STRIP001 	//ClickAnimationHdl( NULL );
//STRIP001 	ClickInvisibleHdl( NULL );
//STRIP001 	ClickFadeOutHdl( NULL );
//STRIP001 	ClickSoundHdl( NULL );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SdEffectWin::Update( SfxItemSet& rAttrs )
//STRIP001 {
//STRIP001 	presentation::AnimationEffect   eAE = presentation::AnimationEffect_NONE;
//STRIP001 	presentation::AnimationEffect   eTE = presentation::AnimationEffect_NONE;
//STRIP001 	presentation::AnimationSpeed    eAS;
//STRIP001 
//STRIP001 	// *** Effekt ***
//STRIP001 	if( rAttrs.GetItemState( ATTR_ANIMATION_EFFECT ) != SFX_ITEM_UNKNOWN &&
//STRIP001         rAttrs.GetItemState( ATTR_ANIMATION_EFFECT ) != SFX_ITEM_DONTCARE &&
//STRIP001         rAttrs.GetItemState( ATTR_ANIMATION_EFFECT ) != SFX_ITEM_DISABLED )
//STRIP001 	{
//STRIP001 		eAE = (presentation::AnimationEffect) ( ( const SfxAllEnumItem& ) rAttrs.Get( ATTR_ANIMATION_EFFECT ) ).GetValue();
//STRIP001 
//STRIP001 		if( eAE != presentation::AnimationEffect_NONE )
//STRIP001 		{
//STRIP001 			// Animation (ja/nein) wird jetzt hier ausgewertet und ueber Effekte dargestellt
//STRIP001 			if( rAttrs.GetItemState( ATTR_ANIMATION_ACTIVE ) != SFX_ITEM_UNKNOWN &&
//STRIP001                 rAttrs.GetItemState( ATTR_ANIMATION_ACTIVE ) != SFX_ITEM_DONTCARE &&
//STRIP001 				!(( const SfxBoolItem& ) rAttrs.Get( ATTR_ANIMATION_ACTIVE )).GetValue() )
//STRIP001             {
//STRIP001 				eAE = presentation::AnimationEffect_NONE;
//STRIP001             }
//STRIP001 		}
//STRIP001 		
//STRIP001         SetAnimationEffect( eAE, &aCtlEffect );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aLbEffect.SetNoSelection();
//STRIP001 		aCtlEffect.Hide();
//STRIP001 	}
//STRIP001 
//STRIP001 	// *** TextEffekt ***
//STRIP001 	if( rAttrs.GetItemState( ATTR_ANIMATION_TEXTEFFECT ) != SFX_ITEM_UNKNOWN &&
//STRIP001         rAttrs.GetItemState( ATTR_ANIMATION_TEXTEFFECT ) != SFX_ITEM_DONTCARE &&
//STRIP001         rAttrs.GetItemState( ATTR_ANIMATION_TEXTEFFECT ) != SFX_ITEM_DISABLED &&
//STRIP001         rAttrs.GetItemState( ATTR_ANIMATION_ACTIVE ) != SFX_ITEM_UNKNOWN &&
//STRIP001 		rAttrs.GetItemState( ATTR_ANIMATION_ACTIVE ) != SFX_ITEM_DONTCARE  &&
//STRIP001 		rAttrs.GetItemState( ATTR_ANIMATION_ACTIVE ) != SFX_ITEM_DISABLED )
//STRIP001 	{
//STRIP001 		eTE = (presentation::AnimationEffect) ( ( const SfxAllEnumItem& ) rAttrs.Get( ATTR_ANIMATION_TEXTEFFECT ) ).GetValue();
//STRIP001 
//STRIP001 		if( eTE != presentation::AnimationEffect_NONE )
//STRIP001 		{
//STRIP001 			// Animation (ja/nein) wird jetzt hier ausgewertet und ueber Effekte dargestellt
//STRIP001 			if( rAttrs.GetItemState( ATTR_ANIMATION_ACTIVE ) != SFX_ITEM_UNKNOWN &&
//STRIP001                 rAttrs.GetItemState( ATTR_ANIMATION_ACTIVE ) != SFX_ITEM_DONTCARE &&
//STRIP001 				!(( const SfxBoolItem& ) rAttrs.Get( ATTR_ANIMATION_ACTIVE )).GetValue() )
//STRIP001             {
//STRIP001 				eTE = presentation::AnimationEffect_NONE;
//STRIP001             }
//STRIP001 		}
//STRIP001 		
//STRIP001         SetAnimationEffect( eTE, &aCtlTextEffect );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aLbTextEffect.SetNoSelection();
//STRIP001 		aCtlTextEffect.Hide();
//STRIP001 	}
//STRIP001 
//STRIP001 	if( ( eAE != presentation::AnimationEffect_NONE ) || ( eTE != presentation::AnimationEffect_NONE ) )
//STRIP001 	{
//STRIP001 		// Animation Speed
//STRIP001 		if( rAttrs.GetItemState( ATTR_ANIMATION_SPEED ) != SFX_ITEM_DONTCARE )
//STRIP001 		{
//STRIP001 			eAS = (presentation::AnimationSpeed) ( ( const SfxAllEnumItem& ) rAttrs.Get( ATTR_ANIMATION_SPEED ) ).GetValue();
//STRIP001 
//STRIP001 			aLbSpeed.SelectEntryPos( eAS );
//STRIP001 		}
//STRIP001 		else
//STRIP001 			aLbSpeed.SetNoSelection();
//STRIP001 
//STRIP001 		/*** Extras ***/
//STRIP001 
//STRIP001 		// Ausblenden (ja/nein)
//STRIP001 		if( rAttrs.GetItemState( ATTR_ANIMATION_FADEOUT ) != SFX_ITEM_DONTCARE )
//STRIP001 			aBtnFadeOut.Check( ( ( const SfxBoolItem& ) rAttrs.Get( ATTR_ANIMATION_FADEOUT ) ).GetValue() );
//STRIP001 		else
//STRIP001 			aBtnFadeOut.SetState( STATE_DONTKNOW );
//STRIP001 
//STRIP001 		// Unsichtbar
//STRIP001 		if( rAttrs.GetItemState( ATTR_ANIMATION_INVISIBLE ) != SFX_ITEM_DONTCARE )
//STRIP001 			aBtnInvisible.Check( ( ( const SfxBoolItem& ) rAttrs.Get( ATTR_ANIMATION_INVISIBLE ) ).GetValue() );
//STRIP001 		else
//STRIP001 			aBtnInvisible.SetState( STATE_DONTKNOW );
//STRIP001 
//STRIP001 		// unsichtbare Farbe
//STRIP001 		const SfxPoolItem* pPoolItem;
//STRIP001 		if( SFX_ITEM_DONTCARE != rAttrs.GetItemState( ATTR_ANIMATION_COLOR, FALSE, &pPoolItem ) )
//STRIP001 		{
//STRIP001 			Color aColor = ( ( const SvxColorItem* ) pPoolItem )->GetValue();
//STRIP001 			aLbFadeOutColor.SelectEntry( aColor );
//STRIP001 		}
//STRIP001 		else
//STRIP001 			aLbFadeOutColor.SetNoSelection();
//STRIP001 
//STRIP001 		// Klang (ja/nein)
//STRIP001 		if( rAttrs.GetItemState( ATTR_ANIMATION_SOUNDON ) != SFX_ITEM_DONTCARE )
//STRIP001         {
//STRIP001             const BOOL bSoundOn = ( ( const SfxBoolItem& ) rAttrs.Get( ATTR_ANIMATION_SOUNDON ) ).GetValue();
//STRIP001 			aBtnSound.Check( bSoundOn );
//STRIP001         }
//STRIP001 		else
//STRIP001 			aBtnSound.SetState( STATE_DONTKNOW );
//STRIP001 
//STRIP001 		if( rAttrs.GetItemState( ATTR_ANIMATION_SOUNDFILE ) != SFX_ITEM_DONTCARE )
//STRIP001 		{
//STRIP001 			String aStr( ( ( const SfxStringItem& ) rAttrs.Get( ATTR_ANIMATION_SOUNDFILE ) ).GetValue() );
//STRIP001 			if( aStr.Len() )
//STRIP001 			{
//STRIP001 				long nPos = GetSoundObject( aStr );
//STRIP001 				if( nPos < 0 )
//STRIP001 				{
//STRIP001 					ClearSoundList();
//STRIP001 					aLbSound.Clear();
//STRIP001 
//STRIP001 					GalleryExplorer::InsertURL( GALLERY_THEME_USERSOUNDS, aStr );
//STRIP001 					FillSoundListAndBox();
//STRIP001 					nPos = GetSoundObject( aStr );
//STRIP001 					DBG_ASSERT( nPos >= 0, "Sound nicht in Liste!" );
//STRIP001 				}
//STRIP001 				if( nPos >= 0 )
//STRIP001 					aLbSound.SelectEntryPos( (USHORT) nPos );
//STRIP001 			}
//STRIP001 			else
//STRIP001 				aLbSound.SetNoSelection();
//STRIP001 		}
//STRIP001 		else
//STRIP001 			aLbSound.SetNoSelection();
//STRIP001 
//STRIP001 		// vollstaendig abspielen
//STRIP001 		if( SFX_ITEM_DONTCARE != rAttrs.GetItemState( ATTR_ANIMATION_PLAYFULL, FALSE, &pPoolItem ) )
//STRIP001 			aBtnPlayFull.Check( ( ( const SfxBoolItem& ) rAttrs.Get( ATTR_ANIMATION_PLAYFULL ) ).GetValue() );
//STRIP001 		else
//STRIP001 			aBtnPlayFull.SetState( STATE_DONTKNOW );
//STRIP001 
//STRIP001         if( !aBtnVTOrder.IsChecked() )
//STRIP001         {
//STRIP001             if( eAE != presentation::AnimationEffect_NONE )
//STRIP001     		    ClickViewTypeHdl( &aBtnVTEffect );
//STRIP001             else
//STRIP001     		    ClickViewTypeHdl( &aBtnVTTextEffect );
//STRIP001         }
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		if( !aBtnVTOrder.IsChecked() )
//STRIP001 			ClickViewTypeHdl( &aBtnVTEffect );
//STRIP001 	}
//STRIP001 
//STRIP001     const BOOL bEnableExtras = ( eAE != presentation::AnimationEffect_NONE ) || ( eTE != presentation::AnimationEffect_NONE );
//STRIP001 
//STRIP001 	aBtnVTExtras.Enable( bEnableExtras );
//STRIP001 	Resize(); // Because perhaps the elements of the extra paper are shown/not shown
//STRIP001 	aBtnVTOrder.Enable( bEnableExtras );
//STRIP001 
//STRIP001 	bTextEffectsAllowed = ( rAttrs.GetItemState( ATTR_ANIMATION_TEXTEFFECT ) != SFX_ITEM_DISABLED );
//STRIP001 
//STRIP001 	//ClickAnimationHdl( NULL );
//STRIP001 	SelectEffectHdl( &aCtlEffect );
//STRIP001 	ClickInvisibleHdl( NULL );
//STRIP001 	ClickFadeOutHdl( NULL );
//STRIP001 	ClickSoundHdl( NULL );
//STRIP001 
//STRIP001 	if( ( eAE != presentation::AnimationEffect_NONE && eViewType == VIEWTYPE_EFFECT ) ||
//STRIP001 		( eTE != presentation::AnimationEffect_NONE && eViewType == VIEWTYPE_TEXT ) )
//STRIP001 	{
//STRIP001 		SelectSoundHdl( NULL );
//STRIP001 
//STRIP001 		// Sicht wird geprueft und ggfs. geaendert
//STRIP001 		// Text-Sicht ist aktiv aber kein Texteffekt aber ein normaler Effekt
//STRIP001 		if( eTE == presentation::AnimationEffect_NONE && eViewType == VIEWTYPE_TEXT &&
//STRIP001 			eAE != presentation::AnimationEffect_NONE )
//STRIP001 		{
//STRIP001 			if( !aBtnVTOrder.IsChecked() )
//STRIP001 				ClickViewTypeHdl( &aBtnVTEffect );
//STRIP001 		}
//STRIP001 		else if( eAE == presentation::AnimationEffect_NONE && eTE != presentation::AnimationEffect_NONE )
//STRIP001 		{
//STRIP001 			USHORT nPos = aLbEffect.GetSelectEntryPos();
//STRIP001 			// Favorit ?
//STRIP001 			if( nPos == 0  )
//STRIP001 			{
//STRIP001 				USHORT nId  = aCtlEffect.GetSelectItemId();
//STRIP001 				// Text-Favorit ?
//STRIP001 				if( eViewType == VIEWTYPE_EFFECT && nId == 1 )
//STRIP001 				{
//STRIP001 					if( !aBtnVTOrder.IsChecked() )
//STRIP001 						ClickViewTypeHdl( &aBtnVTTextEffect );
//STRIP001 				}
//STRIP001 				if( eViewType == VIEWTYPE_TEXT && nId > 1 ) // ausgew. Favorit
//STRIP001 				{
//STRIP001 					if( !aBtnVTOrder.IsChecked() )
//STRIP001 						ClickViewTypeHdl( &aBtnVTEffect );
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001     if( aBtnVTOrder.IsChecked() )
//STRIP001         aTlbOrder.Update();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SdEffectWin::GetAttr( SfxItemSet& rAttrs )
//STRIP001 {
//STRIP001 	TriState eAE = STATE_DONTKNOW;
//STRIP001 	TriState eTAE= STATE_DONTKNOW;
//STRIP001 
//STRIP001 	// Effekt
//STRIP001 	USHORT nPos = aLbEffect.GetSelectEntryPos();
//STRIP001 	USHORT nId  = aCtlEffect.GetSelectItemId();
//STRIP001 
//STRIP001 	// Favorit ?
//STRIP001 	if( nPos == 0 && nId != 1 )
//STRIP001 	{
//STRIP001 		presentation::AnimationEffect eTmp = GetAnimationEffect( &aCtlEffect);
//STRIP001 		switch( nId ) // Effekt
//STRIP001 		{
//STRIP001 			case 2:
//STRIP001 			case 4:
//STRIP001 			case 5:
//STRIP001 			case 7:
//STRIP001 			case 8:
//STRIP001 				// Effekt ohne Texteffekt mit Sound
//STRIP001 				rAttrs.Put( SfxAllEnumItem( ATTR_ANIMATION_EFFECT, eTmp ) );
//STRIP001 				rAttrs.Put( SfxAllEnumItem( ATTR_ANIMATION_TEXTEFFECT, presentation::AnimationEffect_NONE ) );
//STRIP001 				eAE = STATE_CHECK;
//STRIP001 			break;
//STRIP001 
//STRIP001 			case 3:
//STRIP001 			case 6:
//STRIP001 			case 9:
//STRIP001 				// Texteffekt ohne Effekt mit Sound
//STRIP001 				rAttrs.Put( SfxAllEnumItem( ATTR_ANIMATION_TEXTEFFECT, eTmp ) );
//STRIP001 				rAttrs.Put( SfxAllEnumItem( ATTR_ANIMATION_EFFECT, presentation::AnimationEffect_NONE ) );
//STRIP001 				eTAE = STATE_CHECK;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		// Effekt
//STRIP001 		if( aBtnVTEffect.IsEnabled() && aLbEffect.GetSelectEntryCount() )
//STRIP001 		{
//STRIP001 			presentation::AnimationEffect eTmp = GetAnimationEffect( &aCtlEffect);
//STRIP001 			rAttrs.Put( SfxAllEnumItem( ATTR_ANIMATION_EFFECT, eTmp ) );
//STRIP001 			if( eTmp == presentation::AnimationEffect_NONE )
//STRIP001 			{
//STRIP001 				eAE = STATE_NOCHECK;
//STRIP001 				// Hier wird jetzt der Sound zurueckgenommen, da dies
//STRIP001 				// bei den Favoriten keinen Sinn macht (?!)
//STRIP001 				//aBtnSound.SetState( STATE_NOCHECK );
//STRIP001 				//aLbSound.SetNoSelection();
//STRIP001 				//aLbSound.Enable( FALSE ); ...
//STRIP001 				ClickSoundHdl( NULL );
//STRIP001 			}
//STRIP001 			else
//STRIP001 				eAE = STATE_CHECK;
//STRIP001 		}
//STRIP001 		else
//STRIP001 			rAttrs.InvalidateItem( ATTR_ANIMATION_EFFECT );
//STRIP001 
//STRIP001 		// TextEffekt
//STRIP001 		if( aBtnVTTextEffect.IsEnabled() && aLbTextEffect.GetSelectEntryCount() )
//STRIP001 		{
//STRIP001 			presentation::AnimationEffect eTmp = GetAnimationEffect( &aCtlTextEffect );
//STRIP001 			rAttrs.Put( SfxAllEnumItem( ATTR_ANIMATION_TEXTEFFECT, eTmp ) );
//STRIP001 			if( eTmp == presentation::AnimationEffect_NONE )
//STRIP001 				eTAE = STATE_NOCHECK;
//STRIP001 			else
//STRIP001 				eTAE = STATE_CHECK;
//STRIP001 		}
//STRIP001 		else
//STRIP001 			rAttrs.InvalidateItem( ATTR_ANIMATION_TEXTEFFECT );
//STRIP001 	}
//STRIP001 	// Animation (ja/nein) wird jetzt ueber Effekte ausgewertet
//STRIP001 	if( eAE == STATE_NOCHECK && eAE == eTAE )
//STRIP001 		rAttrs.Put( SfxBoolItem( ATTR_ANIMATION_ACTIVE, FALSE ) );
//STRIP001 	else if( eAE == STATE_CHECK || eTAE == STATE_CHECK )
//STRIP001 		rAttrs.Put( SfxBoolItem( ATTR_ANIMATION_ACTIVE, TRUE ) );
//STRIP001 	else
//STRIP001 		rAttrs.InvalidateItem( ATTR_ANIMATION_ACTIVE );
//STRIP001 
//STRIP001 
//STRIP001 	// EffektSpeed
//STRIP001 	nPos = aLbSpeed.GetSelectEntryPos();
//STRIP001 	if( nPos == LISTBOX_ENTRY_NOTFOUND )
//STRIP001 		rAttrs.InvalidateItem( ATTR_ANIMATION_SPEED );
//STRIP001 	else
//STRIP001 		rAttrs.Put( SfxAllEnumItem( ATTR_ANIMATION_SPEED, (presentation::AnimationSpeed) nPos ) );
//STRIP001 
//STRIP001 	// Ausblenden (ja/nein)
//STRIP001 	if( aBtnFadeOut.GetState() == STATE_DONTKNOW )
//STRIP001 		rAttrs.InvalidateItem( ATTR_ANIMATION_FADEOUT );
//STRIP001 	else
//STRIP001 		rAttrs.Put( SfxBoolItem( ATTR_ANIMATION_FADEOUT, aBtnFadeOut.IsChecked() ) );
//STRIP001 
//STRIP001 	// Unsichtbar
//STRIP001 	if( aBtnInvisible.GetState() == STATE_DONTKNOW )
//STRIP001 		rAttrs.InvalidateItem( ATTR_ANIMATION_INVISIBLE );
//STRIP001 	else
//STRIP001 		rAttrs.Put( SfxBoolItem( ATTR_ANIMATION_INVISIBLE, aBtnInvisible.IsChecked() ) );
//STRIP001 
//STRIP001 	// unsichtbare Farbe
//STRIP001 	if( aLbFadeOutColor.GetSelectEntryCount()  )
//STRIP001 	{
//STRIP001 		SvxColorItem aColorItem( aLbFadeOutColor.GetSelectEntryColor(),
//STRIP001 								 ATTR_ANIMATION_COLOR );
//STRIP001 		rAttrs.Put( aColorItem );
//STRIP001 	}
//STRIP001 	else
//STRIP001 		rAttrs.InvalidateItem( ATTR_ANIMATION_COLOR );
//STRIP001 
//STRIP001 	// Klang (ja/nein)
//STRIP001 	if( aBtnSound.GetState() == STATE_DONTKNOW )
//STRIP001 		rAttrs.InvalidateItem( ATTR_ANIMATION_SOUNDON );
//STRIP001 	else
//STRIP001 		rAttrs.Put( SfxBoolItem( ATTR_ANIMATION_SOUNDON, aBtnSound.IsChecked() ) );
//STRIP001 
//STRIP001 	// Klang Name
//STRIP001 	nPos = aLbSound.GetSelectEntryPos();
//STRIP001 	if( nPos != LISTBOX_ENTRY_NOTFOUND )
//STRIP001 	{
//STRIP001 		String aName( *(String*)pSoundList->GetObject( (long)nPos ) );
//STRIP001 		rAttrs.Put( SfxStringItem( ATTR_ANIMATION_SOUNDFILE, aName ) );
//STRIP001 	}
//STRIP001 	else
//STRIP001 		rAttrs.InvalidateItem( ATTR_ANIMATION_SOUNDFILE );
//STRIP001 
//STRIP001 	// vollstaendig abspielen
//STRIP001 	if( aBtnPlayFull.GetState() == STATE_DONTKNOW )
//STRIP001 		rAttrs.InvalidateItem( ATTR_ANIMATION_PLAYFULL );
//STRIP001 	else
//STRIP001 		rAttrs.Put( SfxBoolItem( ATTR_ANIMATION_PLAYFULL, aBtnPlayFull.IsChecked() ) );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SdEffectWin::Resize()
//STRIP001 {
//STRIP001 	if ( !IsFloatingMode() ||
//STRIP001 		 !GetFloatingWindow()->IsRollUp() )
//STRIP001 	{
//STRIP001 		Size aWinSize( GetOutputSizePixel() ); // vorher rSize im Resizing()
//STRIP001 
//STRIP001 		if( aWinSize.Height() >= GetMinOutputSizePixel().Height() &&
//STRIP001 			aWinSize.Width() >= GetMinOutputSizePixel().Width() )
//STRIP001 		{
//STRIP001             const BOOL bShowAll = aWinSize.Height() > aBreakEvenHeight;
//STRIP001 
//STRIP001 			// Wenn mehr als eine Sicht angezeigt werden kann und
//STRIP001 			// "Extras" aktiv ist, wird auf "Effekt" umgeschaltet
//STRIP001 			if( bShowAll && eViewType == VIEWTYPE_EXTRAS )
//STRIP001 				eViewType = VIEWTYPE_EFFECT;
//STRIP001 
//STRIP001 			const BOOL  bCtlEffectVisible = ( VIEWTYPE_EFFECT == eViewType ) && aCtlEffect.IsVisible();
//STRIP001 			const BOOL  bCtlTextEffectVisible = ( VIEWTYPE_TEXT == eViewType ) && aCtlTextEffect.IsVisible();
//STRIP001 
//STRIP001 			Size aDiffSize;
//STRIP001 			aDiffSize.Width() = aWinSize.Width() - aSize.Width();
//STRIP001 			aDiffSize.Height() = aWinSize.Height() - aSize.Height();
//STRIP001 
//STRIP001 			Point aXPt;
//STRIP001 			Point aYPt;
//STRIP001 			aXPt.X() = aDiffSize.Width();
//STRIP001 			aYPt.Y() = aDiffSize.Height();
//STRIP001 
//STRIP001 			// Verschieben der anderen Controls
//STRIP001 			Size aObjSize;
//STRIP001 
//STRIP001 			aBtnVTEffect.Hide();
//STRIP001 			aBtnVTTextEffect.Hide();
//STRIP001 			aBtnVTExtras.Hide();
//STRIP001 			aBtnVTOrder.Hide();
//STRIP001 			aBtnPreview.Hide();
//STRIP001 			aBtnUpdate.Hide();
//STRIP001 			aBtnAssign.Hide();
//STRIP001 			aLbEffect.Hide();
//STRIP001 			aCtlEffect.Hide();
//STRIP001 			aLbSpeed.Hide();
//STRIP001 			aGrpEffect.Hide();
//STRIP001 
//STRIP001 			aLbTextEffect.Hide();
//STRIP001 			aCtlTextEffect.Hide();
//STRIP001 
//STRIP001 			aBtnInvisible.Hide();
//STRIP001 			aBtnFadeOut.Hide();
//STRIP001 			aLbFadeOutColor.Hide();
//STRIP001 			aBtnSound.Hide();
//STRIP001 			aBtnPlayFull.Hide();
//STRIP001 			aBtnSearch.Hide();
//STRIP001 			aLbSound.Hide();
//STRIP001 
//STRIP001 			aTlbOrder.Hide();
//STRIP001 
//STRIP001 			aBtnPreview.SetPosPixel( aBtnPreview.GetPosPixel() + aXPt );
//STRIP001 			aBtnUpdate.SetPosPixel( aBtnUpdate.GetPosPixel() + aXPt );
//STRIP001 			aBtnAssign.SetPosPixel( aBtnAssign.GetPosPixel() + aXPt );
//STRIP001 			aBtnSearch.SetPosPixel( aBtnSearch.GetPosPixel() + aXPt );
//STRIP001 
//STRIP001 			/*** TextEffekte ***/
//STRIP001 			// LB TextEffect
//STRIP001 			aObjSize = aLbTextEffect.GetOutputSizePixel();
//STRIP001 			aObjSize.Width() += aDiffSize.Width();
//STRIP001 			aLbTextEffect.SetOutputSizePixel( aObjSize );
//STRIP001 			// ValueSet Effect
//STRIP001 			aObjSize = aCtlTextEffect.GetOutputSizePixel();
//STRIP001 			aObjSize.Width() += aDiffSize.Width();
//STRIP001 			aObjSize.Height() += aDiffSize.Height();
//STRIP001 			if( bBreakEven != bShowAll )
//STRIP001 			{
//STRIP001 				if( bShowAll )
//STRIP001 					aObjSize.Height() -= aExtrasHeight;
//STRIP001 				else
//STRIP001 					aObjSize.Height() += aExtrasHeight;
//STRIP001 			}
//STRIP001 			// Um die minimale Groesse nicht zu unterschreiten
//STRIP001 			if( aObjSize.Height() < aValueSetHeight )
//STRIP001 			{
//STRIP001 				long nTmp = aValueSetHeight - aObjSize.Height();
//STRIP001 				aObjSize.Height() = aValueSetHeight;
//STRIP001 			}
//STRIP001 			aCtlTextEffect.SetOutputSizePixel( aObjSize );
//STRIP001 
//STRIP001 			/*** Effekte ***/
//STRIP001 			// LB Effect
//STRIP001 			aObjSize = aLbEffect.GetOutputSizePixel();
//STRIP001 			aObjSize.Width() += aDiffSize.Width();
//STRIP001 			aLbEffect.SetOutputSizePixel( aObjSize );
//STRIP001 			// ValueSet Effect
//STRIP001 			aObjSize = aCtlEffect.GetOutputSizePixel();
//STRIP001 			aObjSize.Width() += aDiffSize.Width();
//STRIP001 			aObjSize.Height() += aDiffSize.Height();
//STRIP001 			if( bBreakEven != bShowAll )
//STRIP001 			{
//STRIP001 				if( bShowAll )
//STRIP001 				{
//STRIP001 					aObjSize.Height() -= aExtrasHeight;
//STRIP001 					aYPt.Y() -= aExtrasHeight;
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					aObjSize.Height() += aExtrasHeight;
//STRIP001 					aYPt.Y() += aExtrasHeight;
//STRIP001 				}
//STRIP001 			}
//STRIP001 			// Um die minimale Groesse nicht zu unterschreiten
//STRIP001 			if( aObjSize.Height() < aValueSetHeight )
//STRIP001 			{
//STRIP001 				long nTmp = aValueSetHeight - aObjSize.Height();
//STRIP001 				aObjSize.Height() = aValueSetHeight;
//STRIP001 				aDiffSize.Height() += nTmp;
//STRIP001 				aYPt.Y() = aDiffSize.Height();
//STRIP001 			}
//STRIP001 			aCtlEffect.SetOutputSizePixel( aObjSize );
//STRIP001 
//STRIP001 			// LB Speed
//STRIP001 			aObjSize = aLbSpeed.GetOutputSizePixel();
//STRIP001 			aObjSize.Width() += aDiffSize.Width();
//STRIP001 			aLbSpeed.SetPosPixel( aLbSpeed.GetPosPixel() + aYPt );
//STRIP001 			aLbSpeed.SetOutputSizePixel( aObjSize );
//STRIP001 
//STRIP001 			// TLB Order
//STRIP001 			aObjSize = aTlbOrder.GetSizePixel();
//STRIP001 			aObjSize.Width() += aDiffSize.Width();
//STRIP001 			aObjSize.Height() += aDiffSize.Height();
//STRIP001 			aTlbOrder.SetSizePixel( aObjSize );
//STRIP001 
//STRIP001 			// GroupBox Effect
//STRIP001 			aObjSize = aGrpEffect.GetOutputSizePixel();
//STRIP001 			aObjSize.Width() += aDiffSize.Width();
//STRIP001 			aGrpEffect.SetOutputSizePixel( aObjSize );
//STRIP001 
//STRIP001 
//STRIP001 			if( bShowAll )
//STRIP001 			{
//STRIP001 				//aYPt.Y() = aCtlEffect.GetSizePixel().Height() - aValueSetHeight;
//STRIP001 				//aYPt.Y() += aExtrasHeight;
//STRIP001 				// Hoehe der Effekte-Gruppe berechnen
//STRIP001 				USHORT aEffectsHeight = ( aLbSpeed.GetPosPixel().Y() -
//STRIP001 								aLbEffect.GetPosPixel().Y() ) +
//STRIP001 								aLbSpeed.GetSizePixel().Height() +
//STRIP001 								20;
//STRIP001 				aYPt.Y() = aEffectsHeight;
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				aYPt.Y() = 0;
//STRIP001 			}
//STRIP001 
//STRIP001 			/*** Extras ***/
//STRIP001 			// LB FadeOutColor
//STRIP001 			aObjSize = aLbFadeOutColor.GetOutputSizePixel();
//STRIP001 			aObjSize.Width() += aDiffSize.Width();
//STRIP001 			aLbFadeOutColor.SetOutputSizePixel( aObjSize );
//STRIP001 			// Edit Sound
//STRIP001 			aObjSize = aLbSound.GetSizePixel();
//STRIP001 			aObjSize.Width() += aDiffSize.Width();
//STRIP001 			aLbSound.SetSizePixel( aObjSize );
//STRIP001 
//STRIP001 			// Y-Position der Extras Controls
//STRIP001 			aBtnInvisible.SetPosPixel( Point(
//STRIP001 				aBtnInvisible.GetPosPixel().X(), aBtnInvisiblePosY + aYPt.Y() ) );
//STRIP001 			aBtnFadeOut.SetPosPixel( Point(
//STRIP001 				aBtnFadeOut.GetPosPixel().X(), aBtnFadeOutPosY + aYPt.Y() ) );
//STRIP001 			aLbFadeOutColor.SetPosPixel( Point(
//STRIP001 				aLbFadeOutColor.GetPosPixel().X(), aLbFadeOutColorPosY + aYPt.Y() ) );
//STRIP001 			aBtnSound.SetPosPixel( Point(
//STRIP001 				aBtnSound.GetPosPixel().X(), aBtnSoundPosY + aYPt.Y() ) );
//STRIP001 			aBtnPlayFull.SetPosPixel( Point(
//STRIP001 				aBtnPlayFull.GetPosPixel().X(), aBtnPlayFullPosY + aYPt.Y() ) );
//STRIP001 			aLbSound.SetPosPixel( Point(
//STRIP001 				aLbSound.GetPosPixel().X(), aLbSoundPosY + aYPt.Y() ) );
//STRIP001 			aBtnSearch.SetPosPixel( Point(
//STRIP001 				aBtnSearch.GetPosPixel().X(), aBtnSearchPosY + aYPt.Y() ) );
//STRIP001 
//STRIP001 
//STRIP001 			if( eViewType == VIEWTYPE_ORDER )
//STRIP001 			{
//STRIP001 				aTlbOrder.Show();
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				if( eViewType == VIEWTYPE_EFFECT )//|| bShowAll )
//STRIP001 				{
//STRIP001 					aLbEffect.Show();
//STRIP001 
//STRIP001                     if( bCtlEffectVisible )
//STRIP001 					    aCtlEffect.Show();
//STRIP001 
//STRIP001 					aLbSpeed.Show();
//STRIP001 				}
//STRIP001 				if( eViewType == VIEWTYPE_TEXT )//|| bShowAll )
//STRIP001 				{
//STRIP001 					aLbTextEffect.Show();
//STRIP001 
//STRIP001                     if( bCtlTextEffectVisible )
//STRIP001     					aCtlTextEffect.Show();
//STRIP001 
//STRIP001 					aLbSpeed.Show(); // mal sehen...
//STRIP001 				}
//STRIP001 				if( eViewType == VIEWTYPE_EXTRAS || ( bShowAll && aBtnVTExtras.IsEnabled() ) )
//STRIP001 				{
//STRIP001 					aBtnInvisible.Show();
//STRIP001 					aBtnFadeOut.Show();
//STRIP001 					aLbFadeOutColor.Show();
//STRIP001 					aBtnSound.Show();
//STRIP001 					aBtnPlayFull.Show();
//STRIP001 					aBtnSearch.Show();
//STRIP001 					aLbSound.Show();
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			//if( !bShowAll )
//STRIP001 			aBtnVTEffect.Show();
//STRIP001 			aBtnVTTextEffect.Show();
//STRIP001 			aBtnVTExtras.Show();
//STRIP001 			aBtnVTOrder.Show();
//STRIP001 			aBtnPreview.Show();
//STRIP001 			aBtnUpdate.Show();
//STRIP001 			aBtnAssign.Show();
//STRIP001 			aGrpEffect.Show();
//STRIP001 
//STRIP001 			// Wurde der Zustand der Sichten geaendert
//STRIP001 			if( bBreakEven != bShowAll )
//STRIP001 			{
//STRIP001 				String aStr;
//STRIP001 				if( bShowAll && eViewType != VIEWTYPE_ORDER )
//STRIP001 				{
//STRIP001 					aStr  = String( SdResId( GetViewTypeResId( eViewType ) ) );
//STRIP001 					aStr.AppendAscii( RTL_CONSTASCII_STRINGPARAM( " + " ) );
//STRIP001 					aStr += String( SdResId( GetViewTypeResId( VIEWTYPE_EXTRAS ) ) );
//STRIP001 				}
//STRIP001 				else
//STRIP001 					aStr  = String( SdResId( GetViewTypeResId( eViewType ) ) );
//STRIP001 
//STRIP001 				aGrpEffect.SetText( aStr );
//STRIP001 			}
//STRIP001 
//STRIP001 			bBreakEven = bShowAll;
//STRIP001 
//STRIP001 			aSize = aWinSize;
//STRIP001 
//STRIP001 			ClickViewTypeHdl( NULL );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	SfxDockingWindow::Resize();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL SdEffectWin::Close()
//STRIP001 {
//STRIP001 	return( SfxDockingWindow::Close() );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Ableitung vom SfxChildWindow als "Behaelter" fuer Effekte
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
SdEffectChildWindow::SdEffectChildWindow( Window* pParent,
														 USHORT nId,
														 SfxBindings* pBindings,
														 SfxChildWinInfo* pInfo ) :
	SfxChildWindow( pParent, nId )
{
DBG_BF_ASSERT(0, "STRIP");//STRIP001 	SdEffectWin* pAnimWin = new SdEffectWin( pBindings, this, pParent,
//STRIP001 										SdResId( FLT_WIN_EFFECT ) );
//STRIP001 	pWindow = pAnimWin;
//STRIP001 
//STRIP001 	eChildAlignment = SFX_ALIGN_NOALIGNMENT;
//STRIP001 
//STRIP001 	pAnimWin->Initialize( pInfo );
}
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* ControllerItem fuer EffectStatus
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdEffectCtrlItem::SdEffectCtrlItem( USHORT nId,
//STRIP001 								SdEffectWin* pWin,
//STRIP001 								SfxBindings* pBindings) :
//STRIP001 	SfxControllerItem( nId, *pBindings ),
//STRIP001 	pEffectWin( pWin )
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SdEffectCtrlItem::StateChanged( USHORT nSId,
//STRIP001 						SfxItemState eState, const SfxPoolItem* pItem )
//STRIP001 {
//STRIP001 	if( eState >= SFX_ITEM_AVAILABLE && nSId == SID_EFFECT_STATE )
//STRIP001 	{
//STRIP001 		const SfxUInt32Item* pStateItem = PTR_CAST( SfxUInt32Item, pItem );
//STRIP001 		DBG_ASSERT( pStateItem, "SfxUInt32Item erwartet");
//STRIP001 		UINT32 nState = pStateItem->GetValue();
//STRIP001 
//STRIP001 		pEffectWin->bCount = (BOOL) (nState & EFFECT_COUNT);
//STRIP001 		pEffectWin->bPathEffectAvailable = (BOOL) (nState & EFFECT_PATH);
//STRIP001 
//STRIP001 		pEffectWin->SelectEffectHdl( &pEffectWin->aCtlEffect );
//STRIP001 		pEffectWin->SelectTextEffectHdl( &pEffectWin->aCtlTextEffect );
//STRIP001 
//STRIP001 		// Reihenfolge updaten
//STRIP001 		pEffectWin->aTlbOrder.Update();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* ControllerItem fuer Preview
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdEffectPrevCtrlItem::SdEffectPrevCtrlItem( USHORT nId,
//STRIP001 								SdEffectWin* pInWin,
//STRIP001 								SfxBindings* pBindings) :
//STRIP001 	SfxControllerItem	( nId, *pBindings ),
//STRIP001 	pWin				( pInWin )
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SdEffectPrevCtrlItem::StateChanged( USHORT nSId,
//STRIP001 						SfxItemState eState, const SfxPoolItem* pItem )
//STRIP001 {
//STRIP001 	if( eState >= SFX_ITEM_AVAILABLE && nSId == SID_PREVIEW_WIN )
//STRIP001 	{
//STRIP001 		const SfxBoolItem* pStateItem = PTR_CAST( SfxBoolItem, pItem );
//STRIP001 		DBG_ASSERT( pStateItem, "SfxBoolItem erwartet");
//STRIP001 		BOOL bState = pStateItem->GetValue();
//STRIP001 
//STRIP001 		pWin->aBtnPreview.Check( bState );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 void SdEffectWin::DataChanged( const DataChangedEvent& rDCEvt )
//STRIP001 {
//STRIP001 	if ( (rDCEvt.GetType() == DATACHANGED_SETTINGS) && (rDCEvt.GetFlags() & SETTINGS_STYLE) )
//STRIP001 	{
//STRIP001 		if( eViewType == VIEWTYPE_EFFECT )
//STRIP001 		{
//STRIP001 			FillValueSet( &aCtlEffect );
//STRIP001 		}
//STRIP001 		else if( eViewType == VIEWTYPE_TEXT )
//STRIP001 		{
//STRIP001 			FillValueSet( &aCtlTextEffect );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001     SfxDockingWindow::DataChanged( rDCEvt );
//STRIP001 }
}
