/*************************************************************************
 *
 *  $RCSfile: sd_docshel3.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:43:53 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include "app.hrc"

#define ITEMID_FONTLIST         SID_ATTR_CHAR_FONTLIST
#define ITEMID_COLOR_TABLE      SID_COLOR_TABLE
#define ITEMID_GRADIENT_LIST    SID_GRADIENT_LIST
#define ITEMID_HATCH_LIST       SID_HATCH_LIST
#define ITEMID_BITMAP_LIST      SID_BITMAP_LIST
#define ITEMID_DASH_LIST        SID_DASH_LIST
#define ITEMID_LINEEND_LIST     SID_LINEEND_LIST
#define ITEMID_SEARCH           SID_SEARCH_ITEM

#ifndef _SVXIDS_HRC
#include <bf_svx/svxids.hrc>
#endif
#ifndef _SVX_DIALOGS_HRC
#include <bf_svx/dialogs.hrc>
#endif
// auto strip #ifndef _OFF_OFAITEM_HXX //autogen
// auto strip #include <bf_offmgr/ofaitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVXERR_HXX
// auto strip #include <bf_svx/svxerr.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_DIALMGR_HXX
// auto strip #include <bf_svx/dialmgr.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_SRCHITEM_HXX
// auto strip #include <bf_svx/srchitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_SRCHDLG_HXX
// auto strip #include <bf_svx/srchdlg.hxx>
// auto strip #endif
#ifdef _OUTLINER_HXX
// auto strip #include <bf_svx/outliner.hxx>
#endif
// auto strip #ifndef _OFA_OSPLCFG_HXX
// auto strip #include <bf_offmgr/osplcfg.hxx>
// auto strip #endif
// auto strip #ifndef _OFF_APP_HXX
// auto strip #include <bf_offmgr/app.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
#ifndef _SFXSTYLE_HXX //autogen
#include <svtools/style.hxx>
#endif
// auto strip #ifndef _SVX_DRAWITEM_HXX //autogen
// auto strip #include <bf_svx/drawitem.hxx>
// auto strip #endif
// auto strip #ifndef _UNO_LINGU_HXX
// auto strip #include <bf_svx/unolingu.hxx>
// auto strip #endif

#pragma hdrstop

#include "strings.hrc"
#include "glob.hrc"
#include "res_bmp.hrc"

// auto strip #include "app.hxx"
// auto strip #include "docshell.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "sdpage.hxx"
// auto strip #include "sdattr.hxx"
// auto strip #include "fuspell.hxx"
// auto strip #include "fusearch.hxx"
// auto strip #include "viewshel.hxx"
// auto strip #include "sdview.hxx"
// auto strip #include "fuslshow.hxx"
namespace binfilter {

#define POOL_BUFFER_SIZE		(USHORT)32768
#define BASIC_BUFFER_SIZE		(USHORT)8192
#define DOCUMENT_BUFFER_SIZE	(USHORT)32768

/*************************************************************************
|*
|* SFX-Requests bearbeiten
|*
\************************************************************************/

//STRIP001 void SdDrawDocShell::Execute( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	if (pViewShell)
//STRIP001 	{
//STRIP001 		FuSlideShow* pFuSlideShow = pViewShell->GetSlideShow();
//STRIP001 
//STRIP001 		if (pFuSlideShow && !pFuSlideShow->IsLivePresentation())
//STRIP001 		{
//STRIP001 			// Waehrend einer Native-Diashow wird nichts ausgefuehrt!
//STRIP001 			return;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	switch ( rReq.GetSlot() )
//STRIP001 	{
//STRIP001 		case SID_SPELLING:
//STRIP001 		{
//STRIP001 			if ( pViewShell )
//STRIP001 			{
//STRIP001 				SfxErrorContext aContext(ERRCTX_SVX_LINGU_SPELLING, String(),
//STRIP001 					GetWindow(), RID_SVXERRCTX, DIALOG_MGR() );
//STRIP001 
//STRIP001 				{
//STRIP001 					SdView* pView = pViewShell->GetView();
//STRIP001 
//STRIP001 					if ( pView->IsTextEdit() )
//STRIP001 					{
//STRIP001 						pView->EndTextEdit();
//STRIP001 					}
//STRIP001 
//STRIP001 					delete pFuActual;
//STRIP001 					pFuActual = new FuSpell( pViewShell,
//STRIP001 					pViewShell->GetActiveWindow(), pView, pDoc, rReq );
//STRIP001 					( (FuSpell*) pFuActual)->StartSpelling();
//STRIP001 					delete pFuActual;
//STRIP001 					pFuActual = NULL;
//STRIP001 				}
//STRIP001 			}
//STRIP001 			rReq.Done();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_SEARCH_ITEM:
//STRIP001 		{
//STRIP001 			const SfxItemSet* pReqArgs = rReq.GetArgs();
//STRIP001 
//STRIP001 			if (pReqArgs)
//STRIP001 			{
//STRIP001 				const SvxSearchItem* pSearchItem =
//STRIP001 				(const SvxSearchItem*) &pReqArgs->Get(ITEMID_SEARCH);
//STRIP001 
//STRIP001 				// ein Zuweisungsoperator am SearchItem waer nicht schlecht...
//STRIP001 				SvxSearchItem* pAppSearchItem = SD_MOD()->GetSearchItem();
//STRIP001 				delete pAppSearchItem;
//STRIP001 				pAppSearchItem = (SvxSearchItem*) pSearchItem->Clone();
//STRIP001 				SD_MOD()->SetSearchItem(pAppSearchItem);
//STRIP001 			}
//STRIP001 
//STRIP001 			rReq.Done();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case FID_SEARCH_ON:
//STRIP001 		{
//STRIP001 			// Keine Aktion noetig
//STRIP001 			rReq.Done();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case FID_SEARCH_OFF:
//STRIP001 		{
//STRIP001 			if ( pFuActual && pFuActual->ISA(FuSearch) )
//STRIP001 			{
//STRIP001 				// Suchen&Ersetzen in allen DocShells beenden
//STRIP001 				SfxObjectShell* pFirstShell = SfxObjectShell::GetFirst();
//STRIP001 				SfxObjectShell* pShell = pFirstShell;
//STRIP001 
//STRIP001 				while (pShell)
//STRIP001 				{
//STRIP001 					if (pShell->ISA(SdDrawDocShell))
//STRIP001 					{
//STRIP001 						( (SdDrawDocShell*) pShell)->CancelSearching();
//STRIP001 					}
//STRIP001 
//STRIP001 					pShell = SfxObjectShell::GetNext(*pShell);
//STRIP001 
//STRIP001 					if (pShell == pFirstShell)
//STRIP001 					{
//STRIP001 						pShell = NULL;
//STRIP001 					}
//STRIP001 				}
//STRIP001 
//STRIP001 				delete pFuActual;
//STRIP001 				pFuActual = NULL;
//STRIP001 				Invalidate();
//STRIP001 				rReq.Done();
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case FID_SEARCH_NOW:
//STRIP001 		{
//STRIP001 			const SfxItemSet* pReqArgs = rReq.GetArgs();
//STRIP001 
//STRIP001 			if ( pReqArgs )
//STRIP001 			{
//STRIP001 				if ( !pFuActual || !pFuActual->ISA(FuSearch) )
//STRIP001 				{
//STRIP001 					delete pFuActual;
//STRIP001 					SdView* pView = pViewShell->GetView();
//STRIP001 					pFuActual = new FuSearch( pViewShell, pViewShell->GetActiveWindow(),
//STRIP001 											  pView, pDoc, rReq );
//STRIP001 				}
//STRIP001 
//STRIP001 				if ( pFuActual && pFuActual->ISA(FuSearch) )
//STRIP001 				{
//STRIP001 					const SvxSearchItem* pSearchItem =
//STRIP001 					(const SvxSearchItem*) &pReqArgs->Get(ITEMID_SEARCH);
//STRIP001 
//STRIP001 					// ein Zuweisungsoperator am SearchItem waer nicht schlecht...
//STRIP001 					SvxSearchItem* pAppSearchItem = SD_MOD()->GetSearchItem();
//STRIP001 					delete pAppSearchItem;
//STRIP001 					pAppSearchItem = (SvxSearchItem*)pSearchItem->Clone();
//STRIP001 					SD_MOD()->SetSearchItem(pAppSearchItem);
//STRIP001 
//STRIP001 					( (FuSearch*) pFuActual)->SearchAndReplace(pSearchItem);
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			rReq.Done();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_CLOSEDOC:
//STRIP001 		{
//STRIP001 //            SfxObjectShell::DoClose();
//STRIP001 			ExecuteSlot(rReq, SfxObjectShell::GetInterface());
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_GET_COLORTABLE:
//STRIP001 		{
//STRIP001 			//	passende ColorTable ist per PutItem gesetzt worden
//STRIP001 			SvxColorTableItem* pColItem = (SvxColorTableItem*) GetItem( SID_COLOR_TABLE );
//STRIP001 			XColorTable* pTable = pColItem->GetColorTable();
//STRIP001 			rReq.SetReturnValue( OfaPtrItem( SID_GET_COLORTABLE, pTable ) );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_VERSION:
//STRIP001 		{
//STRIP001 			const ULONG nOldSwapMode = pDoc->GetSwapGraphicsMode();
//STRIP001 
//STRIP001 			pDoc->SetSwapGraphicsMode( SDR_SWAPGRAPHICSMODE_TEMP );
//STRIP001 			ExecuteSlot( rReq, SfxObjectShell::GetInterface() );
//STRIP001 			pDoc->SetSwapGraphicsMode( nOldSwapMode );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		default:
//STRIP001 		break;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Suchmaske fuer Organizer
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdDrawDocShell::SetOrganizerSearchMask(SfxStyleSheetBasePool* pBasePool) const
//STRIP001 {
//STRIP001 	pBasePool->SetSearchMask(SFX_STYLE_FAMILY_PARA,
//STRIP001 							 SFXSTYLEBIT_USERDEF | SFXSTYLEBIT_USED);
//STRIP001 }





}
