/*************************************************************************
 *
 *  $RCSfile: sd_fuspell.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:55:43 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #include <bf_svx/outliner.hxx>
// auto strip #ifndef _SFX_BINDINGS_HXX //autogen
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #endif

// auto strip #include "fupoor.hxx"
// auto strip #include "fuspell.hxx"
// auto strip #include "sdoutl.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "drviewsh.hxx"
#include "outlnvsh.hxx"

#include "app.hrc"
namespace binfilter {

class SdView;
class SdViewShell;
class SdWindow;
class SfxRequest;

USHORT SidArraySpell[] = {
				SID_DRAWINGMODE,
				SID_OUTLINEMODE,
				SID_DIAMODE,
				SID_NOTESMODE,
				SID_HANDOUTMODE,
				0 };

//STRIP001 TYPEINIT1( FuSpell, FuPoor );
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuSpell::FuSpell( SdViewShell* pViewSh, SdWindow* pWin, SdView* pView,
//STRIP001 				  SdDrawDocument* pDoc, SfxRequest& rReq )
//STRIP001 	   : FuPoor(pViewSh, pWin, pView, pDoc, rReq),
//STRIP001 	pSdOutliner(NULL),
//STRIP001 	bOwnOutliner(FALSE)
//STRIP001 {
//STRIP001 	pViewShell->GetViewFrame()->GetBindings().Invalidate( SidArraySpell );
//STRIP001 
//STRIP001 	if ( pViewShell->ISA(SdDrawViewShell) )
//STRIP001 	{
//STRIP001 		bOwnOutliner = TRUE;
//STRIP001 		pSdOutliner = new SdOutliner( pDoc, OUTLINERMODE_TEXTOBJECT );
//STRIP001 	}
//STRIP001 	else if ( pViewShell->ISA(SdOutlineViewShell) )
//STRIP001 	{
//STRIP001 		bOwnOutliner = FALSE;
//STRIP001 		pSdOutliner = pDoc->GetOutliner();
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pSdOutliner)
//STRIP001 	   pSdOutliner->PrepareSpelling();
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuSpell::~FuSpell()
//STRIP001 {
//STRIP001 	pDocSh->GetViewShell()->GetViewFrame()->GetBindings().Invalidate( SidArraySpell );
//STRIP001 
//STRIP001 	if (pSdOutliner)
//STRIP001 		pSdOutliner->EndSpelling();
//STRIP001 
//STRIP001 	if (bOwnOutliner)
//STRIP001 		delete pSdOutliner;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Pruefung starten
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuSpell::StartSpelling()
//STRIP001 {
//STRIP001 	pViewShell = PTR_CAST( SdViewShell, SfxViewShell::Current() );
//STRIP001 
//STRIP001 	if( pViewShell )
//STRIP001 	{
//STRIP001 		if ( pSdOutliner && pViewShell->ISA(SdDrawViewShell) && !bOwnOutliner )
//STRIP001 		{
//STRIP001 			pSdOutliner->EndSpelling();
//STRIP001 
//STRIP001 			bOwnOutliner = TRUE;
//STRIP001 			pSdOutliner = new SdOutliner( pDoc, OUTLINERMODE_TEXTOBJECT );
//STRIP001 			pSdOutliner->PrepareSpelling();
//STRIP001 		}
//STRIP001 		else if ( pSdOutliner && pViewShell->ISA(SdOutlineViewShell) && bOwnOutliner )
//STRIP001 		{
//STRIP001 			pSdOutliner->EndSpelling();
//STRIP001 			delete pSdOutliner;
//STRIP001 
//STRIP001 			bOwnOutliner = FALSE;
//STRIP001 			pSdOutliner = pDoc->GetOutliner();
//STRIP001 			pSdOutliner->PrepareSpelling();
//STRIP001 		}
//STRIP001 
//STRIP001 		if (pSdOutliner)
//STRIP001 			pSdOutliner->StartSpelling();
//STRIP001 	}
//STRIP001 }



}
