/*************************************************************************
 *
 *  $RCSfile: sd_futext.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:56:28 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#ifndef _EEITEM_HXX //autogen
#include <bf_svx/eeitem.hxx>
#endif
// auto strip #include <bf_svx/svdetc.hxx>
// auto strip #include <bf_svx/dlgutil.hxx>
// auto strip #ifndef _SVXERR_HXX //autogen
// auto strip #include <bf_svx/svxerr.hxx>
// auto strip #endif
// auto strip #ifndef _OFA_OSPLCFG_HXX //autogen
// auto strip #include <bf_offmgr/osplcfg.hxx>
// auto strip #endif
// auto strip #ifndef _URLOBJ_HXX
// auto strip #include <tools/urlobj.hxx>
// auto strip #endif
// auto strip #ifndef _SV_HELP_HXX //autogen
// auto strip #include <vcl/help.hxx>
// auto strip #endif
// auto strip #ifndef _EDITSTAT_HXX //autogen
// auto strip #include <bf_svx/editstat.hxx>
// auto strip #endif
// auto strip #ifndef _OFF_APP_HXX //autogen
// auto strip #include <bf_offmgr/app.hxx>
// auto strip #endif
// auto strip #ifndef _AEITEM_HXX //autogen
// auto strip #include <svtools/aeitem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXINTITEM_HXX //autogen
// auto strip #include <svtools/intitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOTEXT_HXX //autogen
// auto strip #include <bf_svx/svdotext.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOGROUP_HXX //autogen
// auto strip #include <bf_svx/svdogrp.hxx>
// auto strip #endif

// auto strip #ifndef _PSTM_HXX
// auto strip #include <tools/pstm.hxx>
// auto strip #endif

#ifndef _SFXPOOLITEM_HXX
#include <svtools/poolitem.hxx>
#endif

#ifndef _SVX_ITEMDATA_HXX
#include <bf_svx/itemdata.hxx>
#endif

#ifndef _DATE_HXX
#include <tools/date.hxx>
#endif

#ifndef _TOOLS_TIME_HXX
#include <tools/time.hxx>
#endif

#define ITEMID_FIELD	EE_FEATURE_FIELD
// auto strip #include <bf_svx/flditem.hxx>
// auto strip #ifndef _SFXSTYLE_HXX //autogen
// auto strip #include <svtools/style.hxx>
// auto strip #endif
// auto strip #ifndef _SVDPAGV_HXX //autogen
// auto strip #include <bf_svx/svdpagv.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_BINDINGS_HXX //autogen
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
// auto strip #ifndef _MyEDITENG_HXX //autogen
// auto strip #include <bf_svx/editeng.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOUTL_HXX //autogen
// auto strip #include <bf_svx/svdoutl.hxx>
// auto strip #endif
#include <bf_svx/svxids.hrc>
// auto strip #ifndef _SFXDOCFILE_HXX //autogen
// auto strip #include <bf_sfx2/docfile.hxx>
// auto strip #endif
// auto strip #ifndef _UNO_LINGU_HXX
// auto strip #include <bf_svx/unolingu.hxx>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_LINGUISTIC2_XSPELLCHECKER1_HPP_
// auto strip #include <com/sun/star/linguistic2/XSpellChecker1.hpp>
// auto strip #endif
// auto strip #ifndef _COMPHELPER_PROCESSFACTORY_HXX_
// auto strip #include <comphelper/processfactory.hxx>
// auto strip #endif

// auto strip #ifndef _OUTLOBJ_HXX
// auto strip #include <bf_svx/outlobj.hxx>
// auto strip #endif

// #104122# 
#ifndef _EEITEMID_HXX
#include <bf_svx/eeitemid.hxx>
#endif

// #104122# 
// auto strip #ifndef _SVX_FRMDIRITEM_HXX
// auto strip #include <bf_svx/frmdiritem.hxx>
// auto strip #endif

// auto strip #include "sdresid.hxx"
#include "app.hrc"
#include "res_bmp.hrc"
//STRIP001#include "futext.hxx"
// auto strip #include "viewshel.hxx"
// auto strip #include "sdview.hxx"
#include "sdoutl.hxx"
// auto strip #include "sdwindow.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "sdpage.hxx"
// auto strip #include "sdmod.hxx"
// auto strip #include "frmview.hxx"
// auto strip #include "docshell.hxx"
#include "glob.hrc"
// auto strip #include "pres.hxx"
#include "optsitem.hxx"
namespace binfilter {

using namespace ::rtl;
using namespace ::com::sun::star;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::linguistic2;

static USHORT SidArray[] = {
	SID_STYLE_FAMILY2,                //    5542
	SID_STYLE_FAMILY5,                //    5545
	SID_CUT,                          //    5710
	SID_COPY,                         //    5711
	SID_ATTR_TABSTOP,                 //   10002
	SID_ATTR_CHAR_FONT,               //   10007
	SID_ATTR_CHAR_POSTURE,            //   10008
	SID_ATTR_CHAR_WEIGHT,             //   10009
	SID_ATTR_CHAR_UNDERLINE,          //   10014
	SID_ATTR_CHAR_FONTHEIGHT,         //   10015
	SID_ATTR_CHAR_COLOR,              //   10017
	SID_ATTR_PARA_ADJUST_LEFT,        //   10028
	SID_ATTR_PARA_ADJUST_RIGHT,       //   10029
	SID_ATTR_PARA_ADJUST_CENTER,      //   10030
	SID_ATTR_PARA_ADJUST_BLOCK,       //   10031
	SID_ATTR_PARA_LINESPACE_10,       //   10034
	SID_ATTR_PARA_LINESPACE_15,       //   10035
	SID_ATTR_PARA_LINESPACE_20,       //   10036
	SID_ATTR_PARA_LRSPACE,            //   10043
	SID_OUTLINE_UP,                   //   10150
	SID_OUTLINE_DOWN,                 //   10151
	SID_OUTLINE_LEFT,                 //   10152
	SID_OUTLINE_RIGHT,                //   10153
	SID_FORMTEXT_STYLE,               //   10257
	SID_SET_SUPER_SCRIPT,             //   10294
	SID_SET_SUB_SCRIPT,               //   10295
	SID_HYPERLINK_GETLINK,            //   10361
	SID_TEXTDIRECTION_LEFT_TO_RIGHT,  //   10907
	SID_TEXTDIRECTION_TOP_TO_BOTTOM,  //   10908
    SID_ATTR_PARA_LEFT_TO_RIGHT,      //   10950
    SID_ATTR_PARA_RIGHT_TO_LEFT,      //   10951
	FN_NUM_BULLET_ON,                 //   20138
	SID_BULLET,                       //   27019
	SID_PARASPACE_INCREASE,           //   27346
	SID_PARASPACE_DECREASE,           //   27347
							0 };

//STRIP001/*N*/ TYPEINIT1( FuText, FuConstruct );
//STRIP001 
//STRIP001 #include <stdio.h>
//STRIP001 
//STRIP001 static BOOL bTestText = 0;
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Basisklasse fuer Textfunktionen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuText::FuText(SdViewShell* pViewSh, SdWindow* pWin, SdView* pView,
//STRIP001 			   SdDrawDocument* pDoc, SfxRequest& rReq) :
//STRIP001 	FuConstruct(pViewSh, pWin, pView, pDoc, rReq),
//STRIP001 	pTextObj(NULL),
//STRIP001 	bFirstObjCreated(FALSE),
//STRIP001 	rRequest (rReq)
//STRIP001 {}
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuText::~FuText()
//STRIP001 {
//STRIP001 	if (pView->EndTextEdit() == SDRENDTEXTEDIT_DELETED)
//STRIP001 	{
//STRIP001 		pTextObj = NULL;
//STRIP001 	}
//STRIP001 
//STRIP001 	// die RequestHandler der benutzten Outliner zuruecksetzen auf den
//STRIP001 	// Handler am Dokument
//STRIP001 	Outliner* pOutliner = pView->GetTextEditOutliner();
//STRIP001 
//STRIP001 	if (pOutliner)
//STRIP001 	{
//STRIP001 		pOutliner->SetStyleSheetPool((SfxStyleSheetPool*)
//STRIP001 					pDoc->GetStyleSheetPool());
//STRIP001 		pOutliner->SetMinDepth(0);
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Execute functionality of this class:
//STRIP001 |*
//STRIP001 |* #71422: Start the functionality of this class in this method
//STRIP001 |* and not in the ctor.
//STRIP001 |* If you construct an object of this class and you put the
//STRIP001 |* address of this object to pFuActual you've got a problem,
//STRIP001 |* because some methods inside DoExecute use the pFuActual-Pointer.
//STRIP001 |* If the code inside DoExecute is executed inside the ctor,
//STRIP001 |* the value of pFuActual is not right. And the value will not
//STRIP001 |* be right until the ctor finished !!!
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 void FuText::DoExecute ()
//STRIP001 {
//STRIP001 	pViewShell->SwitchObjectBar(RID_DRAW_TEXT_TOOLBOX);
//STRIP001 	pView->SetCurrentObj(OBJ_TEXT);
//STRIP001 	pView->SetEditMode(SDREDITMODE_EDIT);
//STRIP001 
//STRIP001 	SdrViewEvent aVEvt;
//STRIP001 	MouseEvent aMEvt(pWindow->GetPointerPosPixel());
//STRIP001 
//STRIP001 	if (nSlotId == SID_TEXTEDIT)
//STRIP001 	{
//STRIP001 		// Try to select an object
//STRIP001 		SdrPageView* pPV = pView->GetPageViewPvNum(0);
//STRIP001 		SdrViewEvent aVEvt;
//STRIP001 		SdrHitKind eHit = pView->PickAnything(aMEvt, SDRMOUSEBUTTONDOWN, aVEvt);
//STRIP001 		pView->MarkObj(aVEvt.pRootObj, pPV);
//STRIP001 
//STRIP001 		if (aVEvt.pObj && aVEvt.pObj->ISA(SdrTextObj))
//STRIP001 		{
//STRIP001 			pTextObj = (SdrTextObj*) aVEvt.pObj;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if (pView->HasMarkedObj())
//STRIP001 	{
//STRIP001 		const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 
//STRIP001 		if (rMarkList.GetMarkCount() == 1)
//STRIP001 		{
//STRIP001 			SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001 
//STRIP001 			if (pObj->ISA(SdrTextObj))
//STRIP001 			{
//STRIP001 				pTextObj = (SdrTextObj*) pObj;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	BOOL bQuickDrag = TRUE;
//STRIP001 
//STRIP001 	const SfxItemSet* pArgs = rRequest.GetArgs();
//STRIP001 
//STRIP001 	if (pArgs 
//STRIP001 		
//STRIP001 		// #98198# test for type before using
//STRIP001 		&& SID_TEXTEDIT == nSlotId
//STRIP001 		&& SFX_ITEM_SET == pArgs->GetItemState(SID_TEXTEDIT)
//STRIP001 
//STRIP001 		&& (UINT16)((SfxUInt16Item&)pArgs->Get(SID_TEXTEDIT)).GetValue() == 2)
//STRIP001 	{
//STRIP001 		// Selection by doubleclick -> don't allow QuickDrag
//STRIP001 		bQuickDrag = FALSE;
//STRIP001 	}
//STRIP001 
//STRIP001 	SetInEditMode(aMEvt, bQuickDrag);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonDown-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuText::MouseButtonDown(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	bMBDown = TRUE;
//STRIP001 
//STRIP001 	BOOL bReturn = FuDraw::MouseButtonDown(rMEvt);
//STRIP001 
//STRIP001 	// Fuer PopupMenu (vorher DrawViewShell)
//STRIP001 	if ((rMEvt.GetButtons() == MOUSE_RIGHT) && rMEvt.GetClicks() == 1 &&
//STRIP001 		pView->IsTextEdit())
//STRIP001 	{
//STRIP001 		return (TRUE);
//STRIP001 	}
//STRIP001 
//STRIP001 	pView->SetMarkHdlWhenTextEdit(TRUE);
//STRIP001 	SdrViewEvent aVEvt;
//STRIP001 	SdrHitKind eHit = pView->PickAnything(rMEvt, SDRMOUSEBUTTONDOWN, aVEvt);
//STRIP001 
//STRIP001 	if (eHit == SDRHIT_TEXTEDIT)
//STRIP001 	{
//STRIP001 		// Text getroffen -> Event von SdrView auswerten lassen
//STRIP001 		if (pView->MouseButtonDown(rMEvt, pWindow))
//STRIP001 			return (TRUE);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (rMEvt.GetClicks() == 1)
//STRIP001 	{
//STRIP001 		if (pView->IsTextEdit() && eHit != SDRHIT_MARKEDOBJECT && eHit != SDRHIT_HANDLE)
//STRIP001 		{
//STRIP001 			// Texteingabe beenden
//STRIP001 			if (pView->EndTextEdit() == SDRENDTEXTEDIT_DELETED)
//STRIP001 			{
//STRIP001 				// Bugfix von MBA: bei Doppelclick auf der Wiese im Modus Text wird
//STRIP001 				// beim zweiten Click eHit = SDRHIT_TEXTEDITOBJ erhalten, weil ja der
//STRIP001 				// zweite Click auf das im ersten Click angelegte TextObject geht.
//STRIP001 				// Dieses wird aber in EndTextEdit entfernt, weil es leer ist. Es
//STRIP001 				// befindet sich aber noch in der Mark-Liste und der Aufruf MarkObj
//STRIP001 				// weiter unten greift dann auf das tote Object zu.
//STRIP001 				// Als einfacher Fix wird nach EndTextEdit noch einmal eHit ermittelt,
//STRIP001 				// was dann SDRHIT_NONE liefert.
//STRIP001 				pTextObj = NULL;
//STRIP001 				eHit = pView->PickAnything(rMEvt, SDRMOUSEBUTTONDOWN, aVEvt);
//STRIP001 			}
//STRIP001 
//STRIP001 			pView->SetCurrentObj(OBJ_TEXT);
//STRIP001 			pView->SetEditMode(SDREDITMODE_EDIT);
//STRIP001 		}
//STRIP001 
//STRIP001 		if (rMEvt.IsLeft())
//STRIP001 		{
//STRIP001 			pWindow->CaptureMouse();
//STRIP001 			SdrObject* pObj;
//STRIP001 			SdrPageView* pPV = pView->GetPageViewPvNum(0);
//STRIP001 
//STRIP001 			if (eHit == SDRHIT_TEXTEDIT)
//STRIP001 			{
//STRIP001 				SetInEditMode(rMEvt, FALSE);
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				BOOL bMacro = FALSE;
//STRIP001 
//STRIP001 				if (bMacro && pView->PickObj(aMDPos,pObj,pPV,SDRSEARCH_PICKMACRO))
//STRIP001 				{
//STRIP001 					// Makro
//STRIP001 					USHORT nHitLog = USHORT ( pWindow->PixelToLogic(Size(HITPIX,0)).Width() );
//STRIP001 					pView->BegMacroObj(aMDPos,nHitLog,pObj,pPV,pWindow);
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					if (eHit != SDRHIT_HANDLE)
//STRIP001 					{
//STRIP001 						// Selektion aufheben
//STRIP001 						if (!rMEvt.IsShift() && eHit == SDRHIT_TEXTEDITOBJ)
//STRIP001 						{
//STRIP001 							pView->UnmarkAll();
//STRIP001 							pView->SetDragMode(SDRDRAG_MOVE);
//STRIP001 						}
//STRIP001 					}
//STRIP001 
//STRIP001 					if ( aVEvt.eEvent == SDREVENT_EXECUTEURL                   ||
//STRIP001 						 eHit == SDRHIT_HANDLE                                 ||
//STRIP001 						 eHit == SDRHIT_MARKEDOBJECT                           ||
//STRIP001 						 eHit == SDRHIT_TEXTEDITOBJ                            ||
//STRIP001 						 ( eHit == SDRHIT_UNMARKEDOBJECT && bFirstObjCreated &&
//STRIP001 						   !bPermanent ) )
//STRIP001 					{
//STRIP001 						/**********************************************************
//STRIP001 						* Handle, markiertes oder unmarkiertes Objekt getroffen
//STRIP001 						**********************************************************/
//STRIP001 						if (eHit == SDRHIT_TEXTEDITOBJ)
//STRIP001 						{
//STRIP001 							/******************************************************
//STRIP001 							* Text eines unmarkierten Objekts getroffen:
//STRIP001 							* Objekt wird selektiert und in EditMode versetzt
//STRIP001 							******************************************************/
//STRIP001 							pView->MarkObj(aVEvt.pRootObj, pPV);
//STRIP001 
//STRIP001 							if (aVEvt.pObj && aVEvt.pObj->ISA(SdrTextObj))
//STRIP001 							{
//STRIP001 								pTextObj = (SdrTextObj*) aVEvt.pObj;
//STRIP001 							}
//STRIP001 
//STRIP001 							SetInEditMode(rMEvt, TRUE);
//STRIP001 						}
//STRIP001 						else if (aVEvt.eEvent == SDREVENT_EXECUTEURL && !rMEvt.IsMod2())
//STRIP001 						{
//STRIP001 							/******************************************************
//STRIP001 							* URL ausfuehren
//STRIP001 							******************************************************/
//STRIP001 							pWindow->ReleaseMouse();
//STRIP001 							SfxStringItem aStrItem(SID_FILE_NAME, aVEvt.pURLField->GetURL());
//STRIP001 							SfxStringItem aReferer(SID_REFERER, pDocSh->GetMedium()->GetName());
//STRIP001 							SfxBoolItem aBrowseItem( SID_BROWSE, TRUE );
//STRIP001 							SfxViewFrame* pFrame = pViewShell->GetViewFrame();
//STRIP001 							pWindow->ReleaseMouse();
//STRIP001 
//STRIP001 							if (rMEvt.IsMod1())
//STRIP001 							{
//STRIP001 								// Im neuen Frame oeffnen
//STRIP001 								pFrame->GetDispatcher()->Execute(SID_OPENDOC, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD,
//STRIP001 											&aStrItem, &aBrowseItem, &aReferer, 0L);
//STRIP001 							}
//STRIP001 							else
//STRIP001 							{
//STRIP001 								// Im aktuellen Frame oeffnen
//STRIP001 								SfxFrameItem aFrameItem(SID_DOCFRAME, pFrame);
//STRIP001 								pFrame->GetDispatcher()->Execute(SID_OPENDOC, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD,
//STRIP001 											&aStrItem, &aFrameItem, &aBrowseItem, &aReferer, 0L);
//STRIP001 							}
//STRIP001 						}
//STRIP001 						else
//STRIP001 						{
//STRIP001 							/******************************************************
//STRIP001 							* Objekt oder Handle draggen
//STRIP001 							******************************************************/
//STRIP001 							if (!aVEvt.pHdl)
//STRIP001 							{
//STRIP001 								if( eHit == SDRHIT_UNMARKEDOBJECT )
//STRIP001 								{
//STRIP001 									if ( !rMEvt.IsShift() )
//STRIP001 										pView->UnmarkAll();
//STRIP001 
//STRIP001 									pView->MarkObj(aVEvt.pRootObj, pPV);
//STRIP001 								}
//STRIP001 
//STRIP001 								// Objekt draggen
//STRIP001 								bFirstMouseMove = TRUE;
//STRIP001 								aDragTimer.Start();
//STRIP001 							}
//STRIP001 
//STRIP001 							Outliner* pOutl = pView->GetTextEditOutliner();
//STRIP001 
//STRIP001 							if (pTextObj && (pTextObj->GetOutlinerParaObject() ||
//STRIP001 								(pOutl && pOutl->GetText(pOutl->GetParagraph( 0 )).Len() != 0)))
//STRIP001 							{
//STRIP001 								pView->EndTextEdit();
//STRIP001 							}
//STRIP001 
//STRIP001 							USHORT nDrgLog = USHORT ( pWindow->PixelToLogic(Size(DRGPIX,0)).Width() );
//STRIP001 							pView->BegDragObj(aMDPos, (OutputDevice*) NULL, aVEvt.pHdl, nDrgLog);
//STRIP001 						}
//STRIP001 					}
//STRIP001 					else if ( nSlotId != SID_TEXTEDIT &&
//STRIP001 							  (bPermanent || !bFirstObjCreated) )
//STRIP001 					{
//STRIP001 						/**********************************************************
//STRIP001 						* Objekt erzeugen
//STRIP001 						**********************************************************/
//STRIP001 						pView->SetCurrentObj(OBJ_TEXT);
//STRIP001 						pView->SetEditMode(SDREDITMODE_CREATE);
//STRIP001 						USHORT nDrgLog = USHORT ( pWindow->PixelToLogic(Size(DRGPIX,0)).Width() );
//STRIP001 						pView->BegCreateObj(aMDPos, (OutputDevice*) NULL, nDrgLog);
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{
//STRIP001 						/**********************************************************
//STRIP001 						* Selektieren
//STRIP001 						**********************************************************/
//STRIP001 						if( !rMEvt.IsShift() )
//STRIP001 							pView->UnmarkAll();
//STRIP001 
//STRIP001 						pView->BegMarkObj( aMDPos );
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if ( rMEvt.GetClicks() == 2 && !pView->IsTextEdit() )
//STRIP001 	{
//STRIP001 		MouseEvent aMEvt( pWindow->GetPointerPosPixel() );
//STRIP001 		SetInEditMode( aMEvt, FALSE );
//STRIP001 	}
//STRIP001 
//STRIP001 	if (!bIsInDragMode)
//STRIP001 	{
//STRIP001 		ForcePointer(&rMEvt);
//STRIP001 		pViewShell->GetViewFrame()->GetBindings().Invalidate(SidArray);
//STRIP001 	}
//STRIP001 
//STRIP001 	return (bReturn);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseMove-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuText::MouseMove(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FuDraw::MouseMove(rMEvt);
//STRIP001 
//STRIP001 	if (aDragTimer.IsActive() )
//STRIP001 	{
//STRIP001 		if( bFirstMouseMove )
//STRIP001 			bFirstMouseMove = FALSE;
//STRIP001 		else
//STRIP001 			aDragTimer.Stop();
//STRIP001 	}
//STRIP001 
//STRIP001 	if (!bReturn && pView->IsAction() && !pDocSh->IsReadOnly())
//STRIP001 	{
//STRIP001 		Point aPix(rMEvt.GetPosPixel());
//STRIP001 		Point aPnt(pWindow->PixelToLogic(aPix));
//STRIP001 
//STRIP001 		ForceScroll(aPix);
//STRIP001 		pView->MovAction(aPnt);
//STRIP001 	}
//STRIP001 
//STRIP001 	ForcePointer(&rMEvt);
//STRIP001 
//STRIP001 	return (bReturn);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonUp-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 // #97016#
//STRIP001 void FuText::ImpSetAttributesForNewTextObject(SdrTextObj* pTxtObj)
//STRIP001 {
//STRIP001 	if(pDoc->GetDocumentType() == DOCUMENT_TYPE_IMPRESS)
//STRIP001 	{
//STRIP001 		if( nSlotId == SID_ATTR_CHAR )
//STRIP001 		{
//STRIP001 			// Impress-Textobjekt wird erzeugt (faellt auf Zeilenhoehe zusammen)
//STRIP001 			// Damit das Objekt beim anschliessenden Erzeugen gleich die richtige
//STRIP001 			// Hoehe bekommt (sonst wird zuviel gepainted)
//STRIP001 			SfxItemSet aSet(pViewShell->GetPool());
//STRIP001 			aSet.Put(SdrTextMinFrameHeightItem(0));
//STRIP001 			aSet.Put(SdrTextAutoGrowWidthItem(FALSE));
//STRIP001 			aSet.Put(SdrTextAutoGrowHeightItem(TRUE));
//STRIP001 			pTxtObj->SetItemSet(aSet);
//STRIP001 			pTxtObj->AdjustTextFrameWidthAndHeight();
//STRIP001 			aSet.Put(SdrTextMaxFrameHeightItem(pTxtObj->GetLogicRect().GetSize().Height()));
//STRIP001 			pTxtObj->SetItemSet(aSet);
//STRIP001 		}
//STRIP001 		else if( nSlotId == SID_ATTR_CHAR_VERTICAL )
//STRIP001 		{
//STRIP001 			SfxItemSet aSet(pViewShell->GetPool());
//STRIP001 			aSet.Put(SdrTextMinFrameWidthItem(0));
//STRIP001 			aSet.Put(SdrTextAutoGrowWidthItem(TRUE));
//STRIP001 			aSet.Put(SdrTextAutoGrowHeightItem(FALSE));
//STRIP001 
//STRIP001 			// #91853# Needs to be set since default is SDRTEXTHORZADJUST_BLOCK
//STRIP001 			aSet.Put(SdrTextHorzAdjustItem(SDRTEXTHORZADJUST_RIGHT));
//STRIP001 			
//STRIP001 			pTxtObj->SetItemSet(aSet);
//STRIP001 			pTxtObj->AdjustTextFrameWidthAndHeight();
//STRIP001 			aSet.Put(SdrTextMaxFrameWidthItem(pTxtObj->GetLogicRect().GetSize().Width()));
//STRIP001 			pTxtObj->SetItemSet(aSet);
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		if( nSlotId == SID_ATTR_CHAR_VERTICAL )
//STRIP001 		{
//STRIP001 			// draw text object, needs to be initialized when vertical text is used
//STRIP001 			SfxItemSet aSet(pViewShell->GetPool());
//STRIP001 
//STRIP001 			// #91510#
//STRIP001 			aSet.Put(SdrTextAutoGrowWidthItem(TRUE));
//STRIP001 			aSet.Put(SdrTextAutoGrowHeightItem(FALSE));
//STRIP001 
//STRIP001 			// #91508#
			//aSet.Put(SdrTextVertAdjustItem(SDRTEXTVERTADJUST_TOP));
			//aSet.Put(SdrTextHorzAdjustItem(SDRTEXTHORZADJUST_RIGHT));

			// #107235#
			// Set defaults for vertical klick-n'drag text object, pool defaults are:
			// SdrTextVertAdjustItem: SDRTEXTVERTADJUST_TOP
			// SdrTextHorzAdjustItem: SDRTEXTHORZADJUST_BLOCK
			// Analog to that (thus, #91508# was not completely correct):
//STRIP001 			aSet.Put(SdrTextVertAdjustItem(SDRTEXTVERTADJUST_BLOCK));
//STRIP001 			aSet.Put(SdrTextHorzAdjustItem(SDRTEXTHORZADJUST_RIGHT));
//STRIP001 
//STRIP001 			pTxtObj->SetItemSet(aSet);
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 // #97016#
//STRIP001 void FuText::ImpSetAttributesFitToSize(SdrTextObj* pTxtObj)
//STRIP001 {
//STRIP001 	// FitToSize (An Rahmen anpassen)
//STRIP001 	SfxItemSet aSet(pViewShell->GetPool(), SDRATTR_TEXT_AUTOGROWHEIGHT, SDRATTR_TEXT_AUTOGROWWIDTH);
//STRIP001 	SdrFitToSizeType eFTS = SDRTEXTFIT_PROPORTIONAL;
//STRIP001 	aSet.Put(SdrTextFitToSizeTypeItem(eFTS));
//STRIP001 	aSet.Put(SdrTextAutoGrowHeightItem(FALSE));
//STRIP001 	aSet.Put(SdrTextAutoGrowWidthItem(FALSE));
//STRIP001 	pTxtObj->SetItemSet(aSet);
//STRIP001 	pTxtObj->AdjustTextFrameWidthAndHeight();
//STRIP001 }
//STRIP001 
//STRIP001 // #97016#
//STRIP001 void FuText::ImpSetAttributesFitToSizeVertical(SdrTextObj* pTxtObj)
//STRIP001 {
//STRIP001 	SfxItemSet aSet(pViewShell->GetPool(),
//STRIP001 		SDRATTR_TEXT_AUTOGROWHEIGHT, SDRATTR_TEXT_AUTOGROWWIDTH);
//STRIP001 	SdrFitToSizeType eFTS = SDRTEXTFIT_PROPORTIONAL;
//STRIP001 	aSet.Put(SdrTextFitToSizeTypeItem(eFTS));
//STRIP001 	aSet.Put(SdrTextAutoGrowHeightItem(FALSE));
//STRIP001 	aSet.Put(SdrTextAutoGrowWidthItem(FALSE));
//STRIP001 	pTxtObj->SetItemSet(aSet);
//STRIP001 	pTxtObj->AdjustTextFrameWidthAndHeight();
//STRIP001 }
//STRIP001 
//STRIP001 // #97016#
//STRIP001 void FuText::ImpSetAttributesFitCommon(SdrTextObj* pTxtObj)
//STRIP001 {
//STRIP001 	// Normales Textobjekt
//STRIP001 	if (pDoc->GetDocumentType() == DOCUMENT_TYPE_IMPRESS)
//STRIP001 	{
//STRIP001 		if( nSlotId == SID_ATTR_CHAR )
//STRIP001 		{
//STRIP001 			// Impress-Textobjekt (faellt auf Zeilenhoehe zusammen)
//STRIP001 			SfxItemSet aSet(pViewShell->GetPool());
//STRIP001 			aSet.Put(SdrTextMinFrameHeightItem(0));
//STRIP001 			aSet.Put(SdrTextMaxFrameHeightItem(0));
//STRIP001 			aSet.Put(SdrTextAutoGrowHeightItem(TRUE));
//STRIP001 			aSet.Put(SdrTextAutoGrowWidthItem(FALSE));
//STRIP001 			pTxtObj->SetItemSet(aSet);
//STRIP001 		}
//STRIP001 		else if( nSlotId == SID_ATTR_CHAR_VERTICAL )
//STRIP001 		{
//STRIP001 			SfxItemSet aSet(pViewShell->GetPool());
//STRIP001 			aSet.Put(SdrTextMinFrameWidthItem(0));
//STRIP001 			aSet.Put(SdrTextMaxFrameWidthItem(0));
//STRIP001 			aSet.Put(SdrTextAutoGrowWidthItem(TRUE));
//STRIP001 			aSet.Put(SdrTextAutoGrowHeightItem(FALSE));
//STRIP001 			pTxtObj->SetItemSet(aSet);
//STRIP001 		}
//STRIP001 
//STRIP001 		pTxtObj->AdjustTextFrameWidthAndHeight();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 BOOL FuText::MouseButtonUp(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 
//STRIP001 	if (aDragTimer.IsActive())
//STRIP001 	{
//STRIP001 		aDragTimer.Stop();
//STRIP001 		bIsInDragMode = FALSE;
//STRIP001 	}
//STRIP001 
//STRIP001 	pViewShell->GetViewFrame()->GetBindings().Invalidate( SidArray );
//STRIP001 
//STRIP001 	Point aPnt( pWindow->PixelToLogic( rMEvt.GetPosPixel() ) );
//STRIP001 
//STRIP001 	if (pView->MouseButtonUp(rMEvt, pWindow) || rMEvt.GetClicks() == 2 )
//STRIP001 		return (TRUE); // Event von der SdrView ausgewertet
//STRIP001 
//STRIP001 	BOOL bEmptyTextObj = FALSE;
//STRIP001 
//STRIP001 	if (pTextObj)
//STRIP001 	{
//STRIP001 		const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 
//STRIP001 		if (rMarkList.GetMarkCount() == 1 
//STRIP001             && ( rMarkList.GetMark(0)->GetObj() == pTextObj) )
//STRIP001 		{
//STRIP001 			// Ist pTextObj wirklich noch gueltig?
//STRIP001 			// (Im FontWork wird z.B. das Objekt ausgetauscht!)
//STRIP001 			if (!pTextObj->GetOutlinerParaObject())
//STRIP001 				bEmptyTextObj = TRUE;
//STRIP001 			else
//STRIP001 				bFirstObjCreated = TRUE;
//STRIP001 		}
//STRIP001 		else
//STRIP001 			pTextObj = NULL;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pView->IsDragObj())
//STRIP001 	{
//STRIP001 		/**********************************************************************
//STRIP001 		* Objekt wurde verschoben
//STRIP001 		**********************************************************************/
//STRIP001 		FrameView* pFrameView = pViewShell->GetFrameView();
//STRIP001 		BOOL bDragWithCopy = (rMEvt.IsMod1() && pFrameView->IsDragWithCopy());
//STRIP001 
//STRIP001 		if (bDragWithCopy)
//STRIP001 		{
//STRIP001 			bDragWithCopy = !pView->IsPresObjSelected(FALSE, TRUE);
//STRIP001 		}
//STRIP001 
//STRIP001 		pView->SetDragWithCopy(bDragWithCopy);
//STRIP001 		pView->EndDragObj( pView->IsDragWithCopy() );
//STRIP001 		pView->ForceMarkedToAnotherPage();
//STRIP001 		pView->SetCurrentObj(OBJ_TEXT);
//STRIP001 	}
//STRIP001 	else if (pView->IsCreateObj() && rMEvt.IsLeft())
//STRIP001 	{
//STRIP001 		/**********************************************************************
//STRIP001 		* Objekt wurde erzeugt
//STRIP001 		**********************************************************************/
//STRIP001 		pTextObj = (SdrTextObj*) pView->GetCreateObj();
//STRIP001 
//STRIP001 		//AW outliner needs to be set to vertical when there is no
//STRIP001 		// outliner object up to now; also it needs to be set back to not
//STRIP001 		// vertical when there was a vertical one used last time.
//STRIP001 		OutlinerParaObject* pOPO = pTextObj->GetOutlinerParaObject();
//STRIP001 		SdrOutliner& rOutl = pTextObj->GetModel()->GetDrawOutliner(pTextObj);
//STRIP001 		BOOL bVertical((pOPO && pOPO->IsVertical())
//STRIP001 			|| nSlotId == SID_ATTR_CHAR_VERTICAL
//STRIP001 			|| nSlotId == SID_TEXT_FITTOSIZE_VERTICAL);
//STRIP001 		rOutl.SetVertical(bVertical);
//STRIP001 
//STRIP001 		// #91508# and #91510#
//STRIP001 		if(pTextObj)
//STRIP001 		{
//STRIP001 			// #107235#
//STRIP001 			// Before ImpSetAttributesForNewTextObject the vertical writing mode
//STRIP001 			// needs to be set at the object. This is done here at the OutlinerParaObject
//STRIP001 			// directly to not mirror the layout text items involved. These items will be set
//STRIP001 			// from ImpSetAttributesForNewTextObject and below.
//STRIP001 			OutlinerParaObject* pPara = pTextObj->GetOutlinerParaObject();
//STRIP001 
//STRIP001 			if(!pPara)
//STRIP001 			{
//STRIP001 				pTextObj->ForceOutlinerParaObject();
//STRIP001 				pPara = pTextObj->GetOutlinerParaObject();
//STRIP001 			}
//STRIP001 
//STRIP001 			if(pPara && bVertical != pPara->IsVertical())
//STRIP001 			{
//STRIP001 				// set ParaObject orientation accordingly
//STRIP001 				pPara->SetVertical(bVertical);
//STRIP001 			}
//STRIP001 
//STRIP001 			// #97016#
//STRIP001 			ImpSetAttributesForNewTextObject(pTextObj);
//STRIP001 		}
//STRIP001 
//STRIP001 		if (!pView->EndCreateObj(SDRCREATE_FORCEEND))
//STRIP001 		{
//STRIP001 			// Textobjekt konnte nicht erzeugt werden
//STRIP001 			pTextObj = NULL;
//STRIP001 		}
//STRIP001 		else if (nSlotId == SID_TEXT_FITTOSIZE)
//STRIP001 		{
//STRIP001 			// #97016#
//STRIP001 			ImpSetAttributesFitToSize(pTextObj);
//STRIP001 
//STRIP001 			SetInEditMode(rMEvt, FALSE);
//STRIP001 		}
//STRIP001 		else if ( nSlotId == SID_TEXT_FITTOSIZE_VERTICAL )
//STRIP001 		{
//STRIP001 			// #97016#
//STRIP001 			ImpSetAttributesFitToSizeVertical(pTextObj);
//STRIP001 			
//STRIP001 			SetInEditMode(rMEvt, FALSE);
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			// #97016#
//STRIP001 			ImpSetAttributesFitCommon(pTextObj);
//STRIP001 
//STRIP001 			// Damit die Handles und der graue Rahmen stimmen
//STRIP001 			pView->AdjustMarkHdl();
//STRIP001 			pView->HitHandle(aPnt, *pWindow);
//STRIP001 			SetInEditMode(rMEvt, FALSE);
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if (pView->IsAction())
//STRIP001 	{
//STRIP001 		pView->EndAction();
//STRIP001 	}
//STRIP001 
//STRIP001 	ForcePointer(&rMEvt);
//STRIP001 	pWindow->ReleaseMouse();
//STRIP001 	USHORT nDrgLog = USHORT ( pWindow->PixelToLogic(Size(DRGPIX,0)).Width() );
//STRIP001 
//STRIP001 	if ( !pView->HasMarkedObj() &&
//STRIP001 		 Abs(aMDPos.X() - aPnt.X()) < nDrgLog &&
//STRIP001 		 Abs(aMDPos.Y() - aPnt.Y()) < nDrgLog &&
//STRIP001 		 !rMEvt.IsShift() && !rMEvt.IsMod2() )
//STRIP001 	{
//STRIP001 		SdrPageView* pPV = pView->GetPageViewPvNum(0);
//STRIP001 		SdrViewEvent aVEvt;
//STRIP001 		SdrHitKind eHit = pView->PickAnything(rMEvt, SDRMOUSEBUTTONDOWN, aVEvt);
//STRIP001 		pView->MarkObj(aVEvt.pRootObj, pPV);
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( !pTextObj )
//STRIP001 	{
//STRIP001 		if ( ( (!bEmptyTextObj   &&  bPermanent) ||
//STRIP001 			 (!bFirstObjCreated && !bPermanent) ) &&
//STRIP001 			  !pDocSh->IsReadOnly()               &&
//STRIP001 			  nSlotId != SID_TEXTEDIT )
//STRIP001 		{
//STRIP001 			/**********************************************************************
//STRIP001 			* Mengentext (linksbuendiges AutoGrow)
//STRIP001 			**********************************************************************/
//STRIP001 			pView->SetCurrentObj(OBJ_TEXT);
//STRIP001 			pView->SetEditMode(SDREDITMODE_CREATE);
//STRIP001 			USHORT nDrgLog = USHORT ( pWindow->PixelToLogic(Size(DRGPIX,0)).Width() );
//STRIP001 			pView->BegCreateObj(aMDPos, (OutputDevice*) NULL, nDrgLog);
//STRIP001 
//STRIP001 			BOOL bSnapEnabled = pView->IsSnapEnabled();
//STRIP001 
//STRIP001 			if (bSnapEnabled)
//STRIP001 				pView->SetSnapEnabled(FALSE);
//STRIP001 
//STRIP001 			aPnt.X() += nDrgLog + nDrgLog;
//STRIP001 			aPnt.Y() += nDrgLog + nDrgLog;
//STRIP001 			pView->MovAction(aPnt);
//STRIP001 
//STRIP001 			pTextObj = (SdrTextObj*) pView->GetCreateObj();
//STRIP001 
//STRIP001 			if (pTextObj)
//STRIP001 			{
//STRIP001 				pTextObj->SetDisableAutoWidthOnDragging(TRUE);
//STRIP001 			}
//STRIP001 
//STRIP001 			if (!pView->EndCreateObj(SDRCREATE_FORCEEND))
//STRIP001 			{
//STRIP001 				pTextObj = NULL;
//STRIP001 			}
//STRIP001 
//STRIP001 			if (bSnapEnabled)
//STRIP001 				pView->SetSnapEnabled(bSnapEnabled);
//STRIP001 
//STRIP001 			if (pTextObj)
//STRIP001 			{
//STRIP001 				SfxItemSet aSet(pViewShell->GetPool());
//STRIP001 				aSet.Put(SdrTextMinFrameHeightItem(0));
//STRIP001 				aSet.Put(SdrTextMinFrameWidthItem(0));
//STRIP001 				aSet.Put(SdrTextAutoGrowHeightItem(TRUE));
//STRIP001 				aSet.Put(SdrTextAutoGrowWidthItem(TRUE));
//STRIP001 				
//STRIP001 				// #91508#
//STRIP001 				if(nSlotId == SID_ATTR_CHAR_VERTICAL)
//STRIP001 				{
//STRIP001 					// #107235#
//STRIP001 					//
//STRIP001 					// Here, all items which need to be different from pool default need to be set
//STRIP001 					// again on the newly created text object.
//STRIP001 					// Since this is a simple klick text object, it is first created, then SetVertical() 
//STRIP001 					// is used, then ImpSetAttributesForNewTextObject is called and then the object is
//STRIP001 					// deleted again since not the minimum drag distance was travelled. Then, a new
//STRIP001 					// klick text object is created and thus all that stuff needs to be set again here.
//STRIP001 					//
//STRIP001 					// Before using the new object the vertical writing mode
//STRIP001 					// needs to be set. This is done here at the OutlinerParaObject
//STRIP001 					// directly to not mirror the layout text items involved. These items will be set
//STRIP001 					// below.
//STRIP001 					OutlinerParaObject* pPara = pTextObj->GetOutlinerParaObject();
//STRIP001 
//STRIP001 					if(!pPara)
//STRIP001 					{
//STRIP001 						pTextObj->ForceOutlinerParaObject();
//STRIP001 						pPara = pTextObj->GetOutlinerParaObject();
//STRIP001 					}
//STRIP001 
//STRIP001 					if(pPara && sal_True != pPara->IsVertical())
//STRIP001 					{
//STRIP001 						// set ParaObject orientation accordingly
//STRIP001 						pPara->SetVertical(sal_True);
//STRIP001 					}
//STRIP001 
//STRIP001 					// #91508#
//STRIP001 					// aSet.Put(SdrTextVertAdjustItem(SDRTEXTVERTADJUST_TOP));
//STRIP001 					aSet.Put(SdrTextHorzAdjustItem(SDRTEXTHORZADJUST_RIGHT));
//STRIP001 
//STRIP001 					// #107235#
//STRIP001 					// Analog to the else case below, for vertical simple click texts
//STRIP001 					// one of the defaulted setted items from ImpSetAttributesForNewTextObject
//STRIP001 					// needs to be adapted to non-block mode. This could have been done with the
//STRIP001 					// #104122#, but was obviously overseen.
//STRIP001 					const SfxItemSet& rSet = pView->GetDefaultAttr();
//STRIP001 					SvxFrameDirection eDirection = (SvxFrameDirection)((SvxFrameDirectionItem&)rSet.Get(EE_PARA_WRITINGDIR)).GetValue();
//STRIP001 
//STRIP001 					if(FRMDIR_HORI_RIGHT_TOP == eDirection || FRMDIR_VERT_TOP_RIGHT == eDirection)
//STRIP001 					{
//STRIP001 	                    aSet.Put(SdrTextVertAdjustItem(SDRTEXTVERTADJUST_BOTTOM));
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{
//STRIP001 	                    aSet.Put(SdrTextVertAdjustItem(SDRTEXTVERTADJUST_TOP));
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					// #104122# This is for Format/Page settings. Since this also leads
//STRIP001 					// to the object defaults to be changed, i think this code can be
//STRIP001 					// removed. CL. wanted to take a look before adding this.
//STRIP001                     //const SdrTextHorzAdjust eHA = ( ( pDoc && pDoc->GetDefaultWritingMode() == ::com::sun::star::text::WritingMode_RL_TB ) ? 
//STRIP001                     //                                SDRTEXTHORZADJUST_RIGHT : SDRTEXTHORZADJUST_LEFT );
//STRIP001                     //aSet.Put( SdrTextHorzAdjustItem( eHA ) );
//STRIP001 
//STRIP001 					// #104122# Look in the object defaults if left-to-right is wanted. If
//STRIP001 					// yes, set text anchoring to right to let the box grow to left.
//STRIP001 					const SfxItemSet& rSet = pView->GetDefaultAttr();
//STRIP001 					SvxFrameDirection eDirection = (SvxFrameDirection)((SvxFrameDirectionItem&)rSet.Get(EE_PARA_WRITINGDIR)).GetValue();
//STRIP001 
//STRIP001 					if(FRMDIR_HORI_RIGHT_TOP == eDirection)
//STRIP001 					{
//STRIP001 	                    aSet.Put(SdrTextHorzAdjustItem(SDRTEXTHORZADJUST_RIGHT));
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{
//STRIP001 	                    aSet.Put(SdrTextHorzAdjustItem(SDRTEXTHORZADJUST_LEFT));
//STRIP001 					}
//STRIP001 				}
//STRIP001 				
//STRIP001 				pTextObj->SetItemSet(aSet);
//STRIP001 
//STRIP001 				pTextObj->SetDisableAutoWidthOnDragging(TRUE);
//STRIP001 				SetInEditMode(rMEvt, FALSE);
//STRIP001 			}
//STRIP001 
//STRIP001 			bFirstObjCreated = TRUE;
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			// In die Fkt. Selektion wechseln
//STRIP001 			if (pView->EndTextEdit() == SDRENDTEXTEDIT_DELETED)
//STRIP001 			{
//STRIP001 				pTextObj = NULL;
//STRIP001 			}
//STRIP001 
//STRIP001 			pViewShell->GetViewFrame()->GetDispatcher()->Execute( SID_OBJECT_SELECT,
//STRIP001 									  SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	bMBDown = FALSE;
//STRIP001 	FuConstruct::MouseButtonUp(rMEvt);
//STRIP001 	return (bReturn);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Tastaturereignisse bearbeiten
//STRIP001 |*
//STRIP001 |* Wird ein KeyEvent bearbeitet, so ist der Return-Wert TRUE, andernfalls
//STRIP001 |* FALSE.
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuText::KeyInput(const KeyEvent& rKEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 	pView->SetMarkHdlWhenTextEdit(TRUE);
//STRIP001 
//STRIP001 	KeyCode nCode = rKEvt.GetKeyCode();
//STRIP001 	BOOL bShift = nCode.IsShift();
//STRIP001 
//STRIP001 	// #97016# IV
//STRIP001 	if(pTextObj)
//STRIP001 	{
//STRIP001 		// maybe object is deleted, test if it's equal to the selected object
//STRIP001 		const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 		SdrObject* pSelectedObj = 0L;
//STRIP001 		
//STRIP001 		if(1 == rMarkList.GetMarkCount())
//STRIP001 		{
//STRIP001 			SdrMark* pMark = rMarkList.GetMark(0);
//STRIP001 			pSelectedObj = pMark->GetObj();
//STRIP001 		}
//STRIP001 
//STRIP001 		if(pTextObj != pSelectedObj)
//STRIP001 		{
//STRIP001 			pTextObj = 0L;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( pTextObj && pTextObj->GetObjInventor() == SdrInventor &&
//STRIP001 		 pTextObj->GetObjIdentifier() == OBJ_TITLETEXT
//STRIP001 		 && rKEvt.GetKeyCode().GetCode() == KEY_RETURN )
//STRIP001 	{
//STRIP001 		// Titeltext-Objekt: immer "weiche" Umbrueche
//STRIP001 		bShift = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	USHORT nKey = nCode.GetCode();
//STRIP001 	KeyCode aKeyCode (nKey, bShift, nCode.IsMod1(), nCode.IsMod2() );
//STRIP001 	KeyEvent aKEvt(rKEvt.GetCharCode(), aKeyCode);
//STRIP001 
//STRIP001 	BOOL bOK = TRUE;
//STRIP001 
//STRIP001 	if (pDocSh->IsReadOnly())
//STRIP001 	{
//STRIP001 		bOK = !EditEngine::DoesKeyChangeText(aKEvt);
//STRIP001 	}
//STRIP001 	if( aKeyCode.GetCode() == KEY_PAGEUP || aKeyCode.GetCode() == KEY_PAGEDOWN )
//STRIP001 	{
//STRIP001 		bOK = FALSE;   // default handling in base class
//STRIP001 	}
//STRIP001 
//STRIP001 	if (bOK && pView->KeyInput(aKEvt, pWindow) )
//STRIP001 	{
//STRIP001 		bReturn = TRUE;
//STRIP001 
//STRIP001 		pViewShell->GetViewFrame()->GetBindings().Invalidate( SidArray );
//STRIP001 
//STRIP001 //		if ( pTextObj )
//STRIP001 //			pTextObj->SetEmptyPresObj(FALSE);
//STRIP001 	}
//STRIP001 	else if (aKeyCode == KEY_ESCAPE)
//STRIP001 	{
//STRIP001 		bReturn = cancel();
//STRIP001 	}
//STRIP001 
//STRIP001 	if( bPermanent )
//STRIP001 	{
//STRIP001 		pView->SetCurrentObj(OBJ_TEXT);
//STRIP001 		pView->SetEditMode(SDREDITMODE_CREATE);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (!bReturn)
//STRIP001 	{
//STRIP001 		bReturn = FuDraw::KeyInput(aKEvt);
//STRIP001 	}
//STRIP001 
//STRIP001 	return (bReturn);
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function aktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuText::Activate()
//STRIP001 {
//STRIP001 	pView->SetQuickTextEditMode(pViewShell->GetFrameView()->IsQuickEdit());
//STRIP001 
//STRIP001 	pView->SetHitTolerancePixel( 4 * HITPIX );
//STRIP001 
//STRIP001 	OutlinerView* pOLV = pView->GetTextEditOutlinerView();
//STRIP001 
//STRIP001 	if (pOLV)
//STRIP001 		pOLV->ShowCursor();
//STRIP001 
//STRIP001 	FuConstruct::Activate();
//STRIP001 
//STRIP001 	if( pOLV )
//STRIP001 		pView->SetEditMode(SDREDITMODE_EDIT);
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function deaktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuText::Deactivate()
//STRIP001 {
//STRIP001 	OutlinerView* pOLV = pView->GetTextEditOutlinerView();
//STRIP001 
//STRIP001 	if (pOLV)
//STRIP001 		pOLV->HideCursor();
//STRIP001 
//STRIP001 	pView->SetHitTolerancePixel( HITPIX );
//STRIP001 
//STRIP001 	FuConstruct::Deactivate();
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Objekt in Edit-Mode setzen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuText::SetInEditMode(const MouseEvent& rMEvt, BOOL bQuickDrag)
//STRIP001 {
//STRIP001 	SdrPageView* pPV = pView->GetPageViewPvNum(0);
//STRIP001 	if( pTextObj && pTextObj->GetPage() == pPV->GetPage() )
//STRIP001 	{
//STRIP001 		pView->SetCurrentObj(OBJ_TEXT);
//STRIP001 
//STRIP001 		if( bPermanent )
//STRIP001 		{
//STRIP001 			pView->SetCurrentObj(OBJ_TEXT);
//STRIP001 			pView->SetEditMode(SDREDITMODE_CREATE);
//STRIP001 		}
//STRIP001 		else
//STRIP001 			pView->SetEditMode(SDREDITMODE_EDIT);
//STRIP001 
//STRIP001 		BOOL bEmptyOutliner = FALSE;
//STRIP001 
//STRIP001 		if (!pTextObj->GetOutlinerParaObject() && pView->GetTextEditOutliner())
//STRIP001 		{
//STRIP001 			Outliner* pOutl = pView->GetTextEditOutliner();
//STRIP001 			ULONG nParaAnz = pOutl->GetParagraphCount();
//STRIP001 			Paragraph* p1stPara = pOutl->GetParagraph( 0 );
//STRIP001 
//STRIP001 			if (nParaAnz==1 && p1stPara)
//STRIP001 			{
//STRIP001 				// Bei nur einem Pararaph
//STRIP001 				if (pOutl->GetText(p1stPara).Len() == 0)
//STRIP001 				{
//STRIP001 					bEmptyOutliner = TRUE;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		if (pTextObj != pView->GetTextEditObject() || bEmptyOutliner)
//STRIP001 		{
//STRIP001 			UINT32 nInv = pTextObj->GetObjInventor();
//STRIP001 			UINT16 nSdrObjKind = pTextObj->GetObjIdentifier();
//STRIP001 
//STRIP001 			if (nInv == SdrInventor && pTextObj->HasTextEdit() &&
//STRIP001 				(nSdrObjKind == OBJ_TEXT ||
//STRIP001 			 	nSdrObjKind == OBJ_TITLETEXT ||
//STRIP001 			 	nSdrObjKind == OBJ_OUTLINETEXT ||
//STRIP001 			 	(pTextObj->ISA(SdrTextObj) && !pTextObj->IsEmptyPresObj())))
//STRIP001 			{
//STRIP001 				// Neuen Outliner machen (gehoert der SdrObjEditView)
//STRIP001 				SdrOutliner* pOutl = SdrMakeOutliner( OUTLINERMODE_OUTLINEOBJECT, pDoc );
//STRIP001 				pOutl->SetMinDepth(0);
//STRIP001 				pOutl->SetStyleSheetPool((SfxStyleSheetPool*) pDoc->GetStyleSheetPool());
//STRIP001 				pOutl->SetCalcFieldValueHdl(LINK(SD_MOD(), SdModule, CalcFieldValueHdl));
//STRIP001 				ULONG nCntrl = pOutl->GetControlWord();
//STRIP001 				nCntrl |= EE_CNTRL_ALLOWBIGOBJS;
//STRIP001 				nCntrl |= EE_CNTRL_URLSFXEXECUTE;
//STRIP001 				nCntrl |= EE_CNTRL_MARKFIELDS;
//STRIP001 				nCntrl |= EE_CNTRL_AUTOCORRECT;
//STRIP001 
//STRIP001 				nCntrl &= ~EE_CNTRL_ULSPACESUMMATION;
//STRIP001 				if ( pDoc->IsSummationOfParagraphs() )
//STRIP001 				    nCntrl |= EE_CNTRL_ULSPACESUMMATION;
//STRIP001 
//STRIP001 				SetSpellOptions( nCntrl );
//STRIP001 
//STRIP001 				pOutl->SetControlWord(nCntrl);
//STRIP001 
//STRIP001 	            Reference< XSpellChecker1 > xSpellChecker( LinguMgr::GetSpellChecker() );
//STRIP001 	            if ( xSpellChecker.is() )
//STRIP001 		            pOutl->SetSpeller( xSpellChecker );
//STRIP001 
//STRIP001 	            Reference< XHyphenator > xHyphenator( LinguMgr::GetHyphenator() );
//STRIP001 	            if( xHyphenator.is() )
//STRIP001 		            pOutl->SetHyphenator( xHyphenator );
//STRIP001 
//STRIP001 				pOutl->SetDefaultLanguage( Application::GetSettings().GetLanguage() );
//STRIP001 
//STRIP001 				// in einem Gliederungstext darf nicht auf die 0-te
//STRIP001 				// Ebene ausgerueckt werden
//STRIP001 				if (pTextObj->GetObjInventor() == SdrInventor &&
//STRIP001 					pTextObj->GetObjIdentifier() == OBJ_OUTLINETEXT)
//STRIP001 				{
//STRIP001 					pOutl->SetMinDepth(1);
//STRIP001 				}
//STRIP001 
//STRIP001 				if (bEmptyOutliner)
//STRIP001 				{
//STRIP001 					pView->EndTextEdit(TRUE);
//STRIP001 				}
//STRIP001 
//STRIP001 				FASTBOOL bNewObj = TRUE;
//STRIP001 
//STRIP001 				OutlinerParaObject* pOPO = pTextObj->GetOutlinerParaObject();
//STRIP001 				if( ( pOPO && pOPO->IsVertical() ) ||
//STRIP001 				    nSlotId == SID_ATTR_CHAR_VERTICAL ||
//STRIP001 					nSlotId == SID_TEXT_FITTOSIZE_VERTICAL )
//STRIP001 					pOutl->SetVertical( TRUE );
//STRIP001 
//STRIP001 
//STRIP001 				if (pView->BegTextEdit(pTextObj, pPV, pWindow, bNewObj, pOutl) &&
//STRIP001 					pTextObj->GetObjInventor() == SdrInventor)
//STRIP001 				{
//STRIP001 					bFirstObjCreated = TRUE;
//STRIP001 					DeleteDefaultText();
//STRIP001 
//STRIP001 					OutlinerView* pOLV = pView->GetTextEditOutlinerView();
//STRIP001 
//STRIP001 					UINT16 nSdrObjKind = pTextObj->GetObjIdentifier();
//STRIP001 
//STRIP001 					SdrViewEvent aVEvt;
//STRIP001 					SdrHitKind eHit = pView->PickAnything(rMEvt, SDRMOUSEBUTTONDOWN, aVEvt);
//STRIP001 
//STRIP001 					if (eHit == SDRHIT_TEXTEDIT)
//STRIP001 					{
//STRIP001 						// Text getroffen
//STRIP001 						if (nSdrObjKind == OBJ_TEXT ||
//STRIP001 							nSdrObjKind == OBJ_TITLETEXT ||
//STRIP001 							nSdrObjKind == OBJ_OUTLINETEXT ||
//STRIP001 							nSlotId == SID_TEXTEDIT ||
//STRIP001 							!bQuickDrag)
//STRIP001 						{
//STRIP001 							pOLV->MouseButtonDown(rMEvt);
//STRIP001 							pOLV->MouseMove(rMEvt);
//STRIP001 							pOLV->MouseButtonUp(rMEvt);
//STRIP001 						}
//STRIP001 
//STRIP001 						if (pViewShell->GetFrameView()->IsQuickEdit() &&
//STRIP001 							bQuickDrag && pTextObj->GetOutlinerParaObject())
//STRIP001 						{
//STRIP001 							pOLV->MouseButtonDown(rMEvt);
//STRIP001 						}
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{
//STRIP001 						// #98198# Move cursor to end of text
//STRIP001 						ESelection aNewSelection(EE_PARA_NOT_FOUND, EE_INDEX_NOT_FOUND, EE_PARA_NOT_FOUND, EE_INDEX_NOT_FOUND);
//STRIP001 						pOLV->SetSelection(aNewSelection);
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					RestoreDefaultText();
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 		pTextObj = NULL;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Texteingabe wird beendet, ggf. Default-Text setzen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuText::RestoreDefaultText()
//STRIP001 {
//STRIP001 	BOOL bRestored = FALSE;
//STRIP001 
//STRIP001 	if ( pTextObj && (pTextObj == pView->GetTextEditObject()) )
//STRIP001 	{
//STRIP001 		if( !pTextObj->HasText() )
//STRIP001 		{
//STRIP001 			SdPage* pPage = (SdPage*) pTextObj->GetPage();
//STRIP001 
//STRIP001 			if (pPage)
//STRIP001 			{
//STRIP001 				PresObjKind ePresObjKind = pPage->GetPresObjKind(pTextObj);
//STRIP001 
//STRIP001 				if (ePresObjKind == PRESOBJ_TITLE   ||
//STRIP001 					ePresObjKind == PRESOBJ_OUTLINE ||
//STRIP001 					ePresObjKind == PRESOBJ_NOTES   ||
//STRIP001 					ePresObjKind == PRESOBJ_TEXT)
//STRIP001 				{
//STRIP001 					String aString = pPage->GetPresObjText(ePresObjKind);
//STRIP001 
//STRIP001 					if (aString.Len())
//STRIP001 					{
//STRIP001 						SdOutliner* pInternalOutl = pDoc->GetInternalOutliner();
//STRIP001 						pInternalOutl->SetMinDepth(0);
//STRIP001 
//STRIP001 						BOOL bVertical = FALSE;
//STRIP001 						OutlinerParaObject* pOldPara = pTextObj->GetOutlinerParaObject();
//STRIP001 						if( pOldPara )
//STRIP001 							bVertical = pOldPara->IsVertical();  // is old para object vertical?
//STRIP001 
//STRIP001 						pPage->SetObjText( pTextObj, pInternalOutl, ePresObjKind, aString );
//STRIP001 
//STRIP001 						if( pOldPara )
//STRIP001 						{
//STRIP001 							//pTextObj->SetVerticalWriting( bVertical );
//STRIP001 							//
//STRIP001 							// #94826# Here, only the vertical flag for the
//STRIP001 							// OutlinerParaObjects needs to be changed. The
//STRIP001 							// AutoGrowWidth/Height items still exist in the
//STRIP001 							// not changed object.
//STRIP001 							if(pTextObj 
//STRIP001 								&& pTextObj->GetOutlinerParaObject()
//STRIP001 								&& pTextObj->GetOutlinerParaObject()->IsVertical() != bVertical)
//STRIP001 							{
//STRIP001 								Rectangle aObjectRect = pTextObj->GetSnapRect();
//STRIP001 								pTextObj->GetOutlinerParaObject()->SetVertical(bVertical);
//STRIP001 								pTextObj->SetSnapRect(aObjectRect);
//STRIP001 							}
//STRIP001 						}
//STRIP001 
//STRIP001 						SdrOutliner* pOutliner = pView->GetTextEditOutliner();
//STRIP001 						pTextObj->SetTextEditOutliner( NULL );  // to make stylesheet settings work
//STRIP001 						pTextObj->NbcSetStyleSheet( pPage->GetStyleSheetForPresObj(ePresObjKind), TRUE );
//STRIP001 						pTextObj->SetTextEditOutliner( pOutliner );
//STRIP001 
//STRIP001 						pInternalOutl->Clear();
//STRIP001 						OutlinerParaObject* pParaObj = pTextObj->GetOutlinerParaObject();
//STRIP001 
//STRIP001 						if (pOutliner)
//STRIP001 							pOutliner->SetText(*pParaObj);
//STRIP001 
//STRIP001 						pTextObj->SetEmptyPresObj(TRUE);
//STRIP001 						bRestored = TRUE;
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return(bRestored);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Texteingabe wird gestartet, ggf. Default-Text loeschen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuText::DeleteDefaultText()
//STRIP001 {
//STRIP001 	BOOL bDeleted = FALSE;
//STRIP001 
//STRIP001 	if ( pTextObj && pTextObj->IsEmptyPresObj() )
//STRIP001 	{
//STRIP001 		String aString;
//STRIP001 		SdPage* pPage = (SdPage*) pTextObj->GetPage();
//STRIP001 
//STRIP001 		if (pPage)
//STRIP001 		{
//STRIP001 			PresObjKind ePresObjKind = pPage->GetPresObjKind(pTextObj);
//STRIP001 
//STRIP001 			if ( (ePresObjKind == PRESOBJ_TITLE   ||
//STRIP001 				  ePresObjKind == PRESOBJ_OUTLINE ||
//STRIP001 				  ePresObjKind == PRESOBJ_NOTES   ||
//STRIP001 				  ePresObjKind == PRESOBJ_TEXT) &&
//STRIP001 				  !pPage->IsMasterPage() )
//STRIP001 			{
//STRIP001 				Outliner* pOutliner = pView->GetTextEditOutliner();
//STRIP001 				SfxStyleSheet* pSheet = pOutliner->GetStyleSheet( 0 );
//STRIP001 				pOutliner->SetText( String(), pOutliner->GetParagraph( 0 ) );
//STRIP001 
//STRIP001 				if (pSheet &&
//STRIP001 					(ePresObjKind == PRESOBJ_NOTES || ePresObjKind == PRESOBJ_TEXT))
//STRIP001 					pOutliner->SetStyleSheet(0, pSheet);
//STRIP001 
//STRIP001 				pTextObj->SetEmptyPresObj(TRUE);
//STRIP001 				bDeleted = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return(bDeleted);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Objekt wurde veraendert
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuText::ObjectChanged()
//STRIP001 {
//STRIP001 	if (pTextObj)
//STRIP001 		pTextObj->SetEmptyPresObj(FALSE);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Command-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuText::Command(const CommandEvent& rCEvt)
//STRIP001 {
//STRIP001 	return( FuPoor::Command(rCEvt) );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Help-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuText::RequestHelp(const HelpEvent& rHEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 
//STRIP001 	OutlinerView* pOLV = pView->GetTextEditOutlinerView();
//STRIP001 
//STRIP001 	if ((Help::IsBalloonHelpEnabled() || Help::IsQuickHelpEnabled()) &&
//STRIP001 		pTextObj && pOLV && pOLV->GetFieldUnderMousePointer())
//STRIP001 	{
//STRIP001 		String aHelpText;
//STRIP001 		const SvxFieldItem* pFieldItem = pOLV->GetFieldUnderMousePointer();
//STRIP001 		const SvxFieldData* pField = pFieldItem->GetField();
//STRIP001 
//STRIP001 		if (pField && pField->ISA(SvxURLField))
//STRIP001 		{
//STRIP001 			/******************************************************************
//STRIP001 			* URL-Field
//STRIP001 			******************************************************************/
//STRIP001 			aHelpText = INetURLObject::decode( ((const SvxURLField*)pField)->GetURL(), '%', INetURLObject::DECODE_WITH_CHARSET );
//STRIP001 		}
//STRIP001 		if (aHelpText.Len())
//STRIP001 		{
//STRIP001 			Rectangle aLogicPix = pWindow->LogicToPixel(pTextObj->GetLogicRect());
//STRIP001 			Rectangle aScreenRect(pWindow->OutputToScreenPixel(aLogicPix.TopLeft()),
//STRIP001 								  pWindow->OutputToScreenPixel(aLogicPix.BottomRight()));
//STRIP001 
//STRIP001 			if (Help::IsBalloonHelpEnabled())
//STRIP001 			{
//STRIP001 				bReturn = Help::ShowBalloon( (Window*)pWindow, rHEvt.GetMousePosPixel(), aScreenRect, aHelpText);
//STRIP001 			}
//STRIP001 			else if (Help::IsQuickHelpEnabled())
//STRIP001 			{
//STRIP001 				bReturn = Help::ShowQuickHelp( (Window*)pWindow, aScreenRect, aHelpText);
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if (!bReturn)
//STRIP001 	{
//STRIP001 		bReturn = FuConstruct::RequestHelp(rHEvt);
//STRIP001 	}
//STRIP001 
//STRIP001 	return(bReturn);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Request verarbeiten
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuText::ReceiveRequest(SfxRequest& rReq)
//STRIP001 {
//STRIP001 	nSlotId = rReq.GetSlot();
//STRIP001 
//STRIP001 	// Dann Basisklasse rufen (dort wird u.a. nSlotId NICHT gesetzt)
//STRIP001 	FuPoor::ReceiveRequest(rReq);
//STRIP001 
//STRIP001 	SdrViewEvent aVEvt;
//STRIP001 
//STRIP001 	if (nSlotId == SID_TEXTEDIT || pViewShell->GetFrameView()->IsQuickEdit() || /*#95971#*/ SID_ATTR_CHAR == nSlotId)
//STRIP001 	{
//STRIP001 		MouseEvent aMEvt(pWindow->GetPointerPosPixel());
//STRIP001 
//STRIP001 		pTextObj = NULL;
//STRIP001 
//STRIP001 		if (nSlotId == SID_TEXTEDIT)
//STRIP001 		{
//STRIP001 			// Wird gerade editiert?
//STRIP001 			if(!bTestText)
//STRIP001 				pTextObj = (SdrTextObj*) pView->GetTextEditObject();
//STRIP001 
//STRIP001 			if (!pTextObj)
//STRIP001 			{
//STRIP001 				// Versuchen, ein Obj zu selektieren
//STRIP001 				SdrPageView* pPV = pView->GetPageViewPvNum(0);
//STRIP001 				SdrViewEvent aVEvt;
//STRIP001 				SdrHitKind eHit = pView->PickAnything(aMEvt, SDRMOUSEBUTTONDOWN, aVEvt);
//STRIP001 				pView->MarkObj(aVEvt.pRootObj, pPV);
//STRIP001 
//STRIP001 				if (aVEvt.pObj && aVEvt.pObj->ISA(SdrTextObj))
//STRIP001 				{
//STRIP001 					pTextObj = (SdrTextObj*) aVEvt.pObj;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else if (pView->HasMarkedObj())
//STRIP001 		{
//STRIP001 			const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 
//STRIP001 			if (rMarkList.GetMarkCount() == 1)
//STRIP001 			{
//STRIP001 				SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001 
//STRIP001 				if (pObj->ISA(SdrTextObj))
//STRIP001 				{
//STRIP001 					pTextObj = (SdrTextObj*) pObj;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		BOOL bQuickDrag = TRUE;
//STRIP001 
//STRIP001 		const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 
//STRIP001 		if (pArgs
//STRIP001 
//STRIP001 			// #98198# test for type before using
//STRIP001 			&& SID_TEXTEDIT == nSlotId
//STRIP001 			&& SFX_ITEM_SET == pArgs->GetItemState(SID_TEXTEDIT)
//STRIP001 			
//STRIP001 			&& (UINT16) ((SfxUInt16Item&) pArgs->Get(SID_TEXTEDIT)).GetValue() == 2)
//STRIP001 		{
//STRIP001 			// Anwahl per Doppelklick -> kein QuickDrag zulassen
//STRIP001 			bQuickDrag = FALSE;
//STRIP001 		}
//STRIP001 
//STRIP001 		SetInEditMode(aMEvt, bQuickDrag);
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* SpellChecker: Error-LinkHdl
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK( FuText, SpellError, void *, nLang )
//STRIP001 {
//STRIP001 	String aError( ::GetLanguageString( (LanguageType)(ULONG)nLang ) );
//STRIP001 	ErrorHandler::HandleError(* new StringErrorInfo(
//STRIP001 								ERRCODE_SVX_LINGU_LANGUAGENOTEXISTS, aError) );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Reaktion auf Doppelklick
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 void FuText::DoubleClick(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	// Nichts zu tun
//STRIP001 }
//STRIP001 
//STRIP001 /** #97016#
//STRIP001     #105815# Removed the insertion of default text and putting a new text
//STRIP001     object directly into edit mode.
//STRIP001 */
//STRIP001 SdrObject* FuText::CreateDefaultObject(const sal_uInt16 nID, const Rectangle& rRectangle)
//STRIP001 {
//STRIP001 	// case SID_TEXTEDIT:	// BASIC ???
//STRIP001 	// case SID_ATTR_CHAR:
//STRIP001 	// case SID_ATTR_CHAR_VERTICAL:
//STRIP001 	// case SID_TEXT_FITTOSIZE:
//STRIP001 	// case SID_TEXT_FITTOSIZE_VERTICAL:
//STRIP001 
//STRIP001 	SdrObject* pObj = SdrObjFactory::MakeNewObject(
//STRIP001 		pView->GetCurrentObjInventor(), pView->GetCurrentObjIdentifier(),
//STRIP001 		0L, pDoc);
//STRIP001 
//STRIP001 	if(pObj)
//STRIP001 	{
//STRIP001 		if(pObj->ISA(SdrTextObj))
//STRIP001 		{
//STRIP001 			SdrTextObj* pText = (SdrTextObj*)pObj;
//STRIP001 			pText->SetLogicRect(rRectangle);
//STRIP001 
//STRIP001 			sal_Bool bVertical = (SID_ATTR_CHAR_VERTICAL == nID || SID_TEXT_FITTOSIZE_VERTICAL == nID);
//STRIP001 			pText->SetVerticalWriting(bVertical);
//STRIP001 
//STRIP001 			// #97016#
//STRIP001 			ImpSetAttributesForNewTextObject(pText);
//STRIP001 
//STRIP001 			if (nSlotId == SID_TEXT_FITTOSIZE)
//STRIP001 			{
//STRIP001 				// #97016#
//STRIP001 				ImpSetAttributesFitToSize(pText);
//STRIP001 			}
//STRIP001 			else if ( nSlotId == SID_TEXT_FITTOSIZE_VERTICAL )
//STRIP001 			{
//STRIP001 				// #97016#
//STRIP001 				ImpSetAttributesFitToSizeVertical(pText);
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				// #97016#
//STRIP001 				ImpSetAttributesFitCommon(pText);
//STRIP001 			}
//STRIP001 
//STRIP001             // Put text object into edit mode.
//STRIP001             SdrPageView* pPV = pView->GetPageViewPvNum(0);
//STRIP001             pView->BegTextEdit (pText, pPV);
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			DBG_ERROR("Object is NO text object");
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return pObj;
//STRIP001 }

/** is called when the currenct function should be aborted. <p>
	This is used when a function gets a KEY_ESCAPE but can also
	be called directly.

	@returns true if a active function was aborted
*/
//STRIP001 bool FuText::cancel()
//STRIP001 {
//STRIP001 	if ( pView->IsTextEdit() )
//STRIP001 	{
//STRIP001 		if (pView->EndTextEdit() == SDRENDTEXTEDIT_DELETED)
//STRIP001 		{
//STRIP001 			pTextObj = NULL;
//STRIP001 		}
//STRIP001 
//STRIP001 		pView->SetCurrentObj(OBJ_TEXT);
//STRIP001 		pView->SetEditMode(SDREDITMODE_EDIT);
//STRIP001 		return true;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		return false;
//STRIP001 	}
//STRIP001 }
}
