/*************************************************************************
 *
 *  $RCSfile: futext.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:02:25 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SD_FUTEXT_HXX
#define _SD_FUTEXT_HXX

// auto strip #ifndef _EDITDATA_HXX
// auto strip #include <bf_svx/editdata.hxx>
// auto strip #endif
// auto strip #ifndef _SD_FUCONSTR_HXX
// auto strip #include "fuconstr.hxx"
// auto strip #endif
namespace binfilter {

struct StyleRequestData;
class SdrTextObj;
class OutlinerParaObject;

/*************************************************************************
|*
|* Basisklasse fuer Textfunktionen
|*
\************************************************************************/
//STRIP001class FuText : public FuConstruct
//STRIP001{
//STRIP001 	// #97016#
//STRIP001 	void ImpSetAttributesForNewTextObject(SdrTextObj* pTxtObj);
//STRIP001 	void ImpSetAttributesFitToSize(SdrTextObj* pTxtObj);
//STRIP001 	void ImpSetAttributesFitToSizeVertical(SdrTextObj* pTxtObj);
//STRIP001 	void ImpSetAttributesFitCommon(SdrTextObj* pTxtObj);
//STRIP001 
//STRIP001  protected:
//STRIP001 	SdrTextObj* 		pTextObj;
//STRIP001 	Link                aOldLink;
//STRIP001 	BOOL                bFirstObjCreated;
//STRIP001 
//STRIP001 	SfxRequest&			rRequest;
//STRIP001 
//STRIP001 public:
//STRIP001	TYPEINFO();

//STRIP001 	FuText(SdViewShell* pViewSh, SdWindow* pWin, SdView* pView,
//STRIP001 		   SdDrawDocument* pDoc, SfxRequest& rReq);
//STRIP001 
//STRIP001 	virtual ~FuText();
//STRIP001 
//STRIP001 	virtual BOOL KeyInput(const KeyEvent& rKEvt);
//STRIP001 	virtual BOOL MouseMove(const MouseEvent& rMEvt);
//STRIP001 	virtual BOOL MouseButtonUp(const MouseEvent& rMEvt);
//STRIP001 	virtual BOOL MouseButtonDown(const MouseEvent& rMEvt);
//STRIP001 	virtual BOOL Command(const CommandEvent& rCEvt);
//STRIP001 	virtual BOOL RequestHelp(const HelpEvent& rHEvt);
//STRIP001 	virtual void ReceiveRequest(SfxRequest& rReq);
//STRIP001 	virtual void DoubleClick(const MouseEvent& rMEvt);
//STRIP001 
//STRIP001 	virtual void Activate();		   // Function aktivieren
//STRIP001 	virtual void Deactivate();		   // Function deaktivieren
//STRIP001 
//STRIP001 	void    SetInEditMode(const MouseEvent& rMEvt, BOOL bQuickDrag);
//STRIP001 	BOOL	DeleteDefaultText();
//STRIP001 	BOOL	RestoreDefaultText();
//STRIP001 	void	ObjectChanged();
//STRIP001 	SdrTextObj* GetTextObj() { return pTextObj; }
//STRIP001 	void	SetSpellOptions( ULONG& rCntrl );

	// #71422: Start the functionality of this class in this method
	// and not in the ctor.
	// If you construct an object of this class and you put the
	// address of this object to pFuActual you got a problem,
	// because some methods inside DoExecute use the pFuActual-Pointer.
	// If the code inside DoExecute is executed inside the ctor,
	// the value of pFuActual is not right. And the value will not
	// be right until the ctor finished !!!
//STRIP001 	void		DoExecute ();

//STRIP001 	DECL_LINK(SpellError, void* );

	// #97016#
//STRIP001 	virtual SdrObject* CreateDefaultObject(const sal_uInt16 nID, const Rectangle& rRectangle);

	/** is called when the currenct function should be aborted. <p>
		This is used when a function gets a KEY_ESCAPE but can also
		be called directly.

		@returns true if a active function was aborted
	*/
//STRIP001 	virtual bool cancel();
//STRIP001};



} //namespace binfilter
#endif		// _SD_FUTEXT_HXX
