/*************************************************************************
 *
 *  $RCSfile: undopage.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hjs $ $Date: 2003/10/01 12:19:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

//STRIP001 #ifndef _SD_UNDOPAGE_HXX
//STRIP001 #define _SD_UNDOPAGE_HXX

//STRIP001 #ifndef _GEN_HXX //autogen
//STRIP001 #include <tools/gen.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SV_PRNTYPES_HXX //autogen
//STRIP001 #include <vcl/prntypes.hxx>
//STRIP001 #endif

//STRIP001 #include "sdundo.hxx"

//STRIP001 class SdDrawDocument;
//STRIP001 class SdPage;

/************************************************************************/

//STRIP001 class SdPageFormatUndoAction : public SdUndoAction
//STRIP001 {
//STRIP001 	SdPage*     pPage;
//STRIP001 
//STRIP001 	Size        aOldSize;
//STRIP001 	INT32       nOldLeft;
//STRIP001 	INT32       nOldRight;
//STRIP001 	INT32       nOldUpper;
//STRIP001 	INT32       nOldLower;
//STRIP001 	BOOL        bOldScale;
//STRIP001 	Orientation eOldOrientation;
//STRIP001 	USHORT      nOldPaperBin;
//STRIP001 	BOOL        bOldFullSize;
//STRIP001 
//STRIP001 	Size        aNewSize;
//STRIP001 	INT32       nNewLeft;
//STRIP001 	INT32       nNewRight;
//STRIP001 	INT32       nNewUpper;
//STRIP001 	INT32       nNewLower;
//STRIP001 	BOOL        bNewScale;
//STRIP001 	Orientation eNewOrientation;
//STRIP001 	USHORT      nNewPaperBin;
//STRIP001 	BOOL        bNewFullSize;
//STRIP001 
//STRIP001 public:
//STRIP001 	TYPEINFO();
//STRIP001 	SdPageFormatUndoAction(	SdDrawDocument*	pDoc,
//STRIP001 							SdPage*			pThePage,
//STRIP001 							const Size&		rOldSz,
//STRIP001 							INT32			nOldLft,
//STRIP001 							INT32			nOldRgt,
//STRIP001 							INT32			nOldUpr,
//STRIP001 							INT32			nOldLwr,
//STRIP001 							BOOL            bOldScl,
//STRIP001 							Orientation     eOldOrient,
//STRIP001 							USHORT      	nOPaperBin,
//STRIP001 							BOOL        	bOFullSize,
//STRIP001 
//STRIP001 							const Size&     rNewSz,
//STRIP001 							INT32			nNewLft,
//STRIP001 							INT32			nNewRgt,
//STRIP001 							INT32			nNewUpr,
//STRIP001 							INT32           nNewLwr,
//STRIP001 							BOOL            bNewScl,
//STRIP001 							Orientation     eNewOrient,
//STRIP001 							USHORT      	nNPaperBin,
//STRIP001 							BOOL        	bNFullSize
//STRIP001 							) :
//STRIP001 		SdUndoAction(pDoc),
//STRIP001 		pPage		(pThePage),
//STRIP001 		aOldSize	(rOldSz),
//STRIP001 		nOldLeft	(nOldLft),
//STRIP001 		nOldRight	(nOldRgt),
//STRIP001 		nOldUpper	(nOldUpr),
//STRIP001 		nOldLower	(nOldLwr),
//STRIP001 		bOldScale   (bOldScl),
//STRIP001 		eOldOrientation(eOldOrient),
//STRIP001 		nOldPaperBin (nOPaperBin),
//STRIP001 		bOldFullSize (bOFullSize),
//STRIP001 
//STRIP001 
//STRIP001 		aNewSize	(rNewSz),
//STRIP001 		nNewLeft	(nNewLft),
//STRIP001 		nNewRight	(nNewRgt),
//STRIP001 		nNewUpper	(nNewUpr),
//STRIP001 		nNewLower   (nNewLwr),
//STRIP001 		bNewScale   (bNewScl),
//STRIP001 		eNewOrientation(eNewOrient),
//STRIP001 		nNewPaperBin (nNPaperBin),
//STRIP001 		bNewFullSize (bNFullSize)
//STRIP001 
//STRIP001 		{}
//STRIP001 	virtual ~SdPageFormatUndoAction();
//STRIP001 
//STRIP001 	virtual void Undo();
//STRIP001 	virtual void Redo();
//STRIP001 	virtual void Repeat();
//STRIP001 };

/************************************************************************/

//STRIP001 class SdPageLRUndoAction : public SdUndoAction
//STRIP001 {
//STRIP001 	SdPage*	pPage;
//STRIP001 
//STRIP001 	INT32	nOldLeft;
//STRIP001 	INT32	nOldRight;
//STRIP001 	INT32	nNewLeft;
//STRIP001 	INT32	nNewRight;
//STRIP001 
//STRIP001 public:
//STRIP001 	TYPEINFO();
//STRIP001 	SdPageLRUndoAction( SdDrawDocument* pDoc, SdPage* pThePage,
//STRIP001 						INT32 nOldLft, INT32 nOldRgt,
//STRIP001 						INT32 nNewLft, INT32 nNewRgt ) :
//STRIP001 		SdUndoAction(pDoc),
//STRIP001 		pPage		(pThePage),
//STRIP001 		nOldLeft	(nOldLft),
//STRIP001 		nOldRight	(nOldRgt),
//STRIP001 		nNewLeft	(nNewLft),
//STRIP001 		nNewRight	(nNewRgt)
//STRIP001 		{}
//STRIP001 	virtual ~SdPageLRUndoAction();
//STRIP001 
//STRIP001 	virtual void Undo();
//STRIP001 	virtual void Redo();
//STRIP001 	virtual void Repeat();
//STRIP001 };

/************************************************************************/

//STRIP001 class SdPageULUndoAction : public SdUndoAction
//STRIP001 {
//STRIP001 	SdPage*	pPage;
//STRIP001 
//STRIP001 	INT32	nOldUpper;
//STRIP001 	INT32	nOldLower;
//STRIP001 	INT32	nNewUpper;
//STRIP001 	INT32	nNewLower;
//STRIP001 
//STRIP001 public:
//STRIP001 	TYPEINFO();
//STRIP001 	SdPageULUndoAction( SdDrawDocument* pDoc, SdPage* pThePage,
//STRIP001 						INT32 nOldUpr, INT32 nOldLwr,
//STRIP001 						INT32 nNewUpr, INT32 nNewLwr ) :
//STRIP001 		SdUndoAction(pDoc),
//STRIP001 		pPage		(pThePage),
//STRIP001 		nOldUpper	(nOldUpr),
//STRIP001 		nOldLower	(nOldLwr),
//STRIP001 		nNewUpper	(nNewUpr),
//STRIP001 		nNewLower	(nNewLwr)
//STRIP001 		{}
//STRIP001 	virtual ~SdPageULUndoAction();
//STRIP001 
//STRIP001 	virtual void Undo();
//STRIP001 	virtual void Redo();
//STRIP001 	virtual void Repeat();
//STRIP001 };



//STRIP001 #endif		// _SD_UNDOPAGE_HXX

