/*************************************************************************
 *
 *  $RCSfile: sfx2_imagemgr.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:28:36 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// includes --------------------------------------------------------------
#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif
//#ifndef _COM_SUN_STAR_FRAME_XCONTROLLER_HPP_
//#include <com/sun/star/frame/XController.hpp>
//#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAME_HPP_
#include <com/sun/star/frame/XFrame.hpp>
#endif

//#include <tools/urlobj.hxx>
//#include <svtools/imagemgr.hxx>
//#include <comphelper/processfactory.hxx>

#include "imgmgr.hxx"
//#include "app.hxx"
//#include "unoctitm.hxx"
//#include "dispatch.hxx"
//#include "msg.hxx"
//#include "msgpool.hxx"
//#include "viewfrm.hxx"
//#include "module.hxx"
//#include "objsh.hxx"

//#ifndef _LEGACYBINFILTERMGR_HXX
//#include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
//#endif

#ifndef _TOOLS_DEBUG_HXX
#include <tools/debug.hxx>
#endif

namespace binfilter {

//using namespace ::com::sun::star::uno;
//using namespace ::com::sun::star::frame;
//using namespace ::com::sun::star::lang;
//using namespace ::com::sun::star::util;

/*N*/ Image SAL_CALL GetImage( ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame >& rFrame, const ::rtl::OUString& aURL, BOOL bBig, BOOL bHiContrast )
/*N*/ {DBG_BF_ASSERT(0, "STRIP"); return Image(); //STRIP001 
//STRIP001     INetURLObject aObj( aURL );
//STRIP001     INetProtocol nProtocol = aObj.GetProtocol();
//STRIP001     switch ( nProtocol )
//STRIP001     {
//STRIP001         case INET_PROT_UNO :
//STRIP001         case INET_PROT_SLOT :
//STRIP001         {
//STRIP001             URL aTargetURL;
//STRIP001             aTargetURL.Complete = aURL;
//STRIP001             Reference < XURLTransformer > xTrans( ::legacy_binfilters::getLegacyProcessServiceFactory()->createInstance( ::rtl::OUString::createFromAscii("com.sun.star.util.URLTransformer" )), UNO_QUERY );
//STRIP001             xTrans->parseStrict( aTargetURL );
//STRIP001 
//STRIP001             SfxViewFrame* pViewFrame = NULL;
//STRIP001             Reference < XController > xController;
//STRIP001             if ( rFrame.is() )
//STRIP001                 xController = rFrame->getController();
//STRIP001 
//STRIP001             Reference < XDispatchProvider > xProvider( xController, UNO_QUERY );
//STRIP001             if ( xProvider.is() )
//STRIP001             {
//STRIP001                 Reference < XDispatch > xDisp = xProvider->queryDispatch( aTargetURL, ::rtl::OUString(), 0 );
//STRIP001                 if ( xDisp.is() )
//STRIP001                 {
//STRIP001                     Reference< XUnoTunnel > xTunnel( xDisp, UNO_QUERY );
//STRIP001                     SfxOfficeDispatch* pDisp = NULL;
//STRIP001                     if ( xTunnel.is() )
//STRIP001                     {
//STRIP001                         sal_Int64 nImplementation = xTunnel->getSomething(SfxOfficeDispatch::impl_getStaticIdentifier());
//STRIP001                         pDisp = (SfxOfficeDispatch*)(nImplementation);
//STRIP001                     }
//STRIP001 
//STRIP001                     if ( pDisp )
//STRIP001                         pViewFrame = pDisp->GetDispatcher_Impl()->GetFrame();
//STRIP001                 }
//STRIP001             }
//STRIP001 
//STRIP001             USHORT nId = 0;
//STRIP001             if ( nProtocol == INET_PROT_UNO )
//STRIP001             {
//STRIP001                 SfxSlotPool& rPool = SFX_APP()->GetSlotPool( pViewFrame );
//STRIP001                 const SfxSlot* pSlot = rPool.GetUnoSlot( aTargetURL.Path );
//STRIP001                 if ( pSlot )
//STRIP001                     nId = pSlot->GetSlotId();
//STRIP001             }
//STRIP001             else
//STRIP001                 nId = ( USHORT ) aTargetURL.Path.toInt32();
//STRIP001 
//STRIP001             SfxModule* pModule = pViewFrame ? pViewFrame->GetObjectShell()->GetModule() : NULL;
//STRIP001             if ( nId )
//STRIP001             {
//STRIP001                 if ( pViewFrame )
//STRIP001                     return pViewFrame->GetImageManager()->GetImage( nId, pModule, bBig, bHiContrast );
//STRIP001                 else
//STRIP001                 {
//STRIP001                     return SFX_APP()->GetImageManager_Impl()->GetImage( nId, NULL, bBig, bHiContrast );
//STRIP001                 }
//STRIP001             }
//STRIP001             break;
//STRIP001         }
//STRIP001 
//STRIP001         case INET_PROT_NOT_VALID :
//STRIP001         {
//STRIP001             return Image();
//STRIP001             break;
//STRIP001         }
//STRIP001     }
//STRIP001 
//STRIP001     return SvFileInformationManager::GetImageNoDefault( aObj, bBig, bHiContrast );
/*N*/ }

}
