/*************************************************************************
 *
 *  $RCSfile: sfx2_sfxhelp2.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:38:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <sfxhelp.hxx>
#include <sfxhelp2.hxx>
#include <sfxsids.hrc>

#ifndef _SV_TOOLBOX_HXX //autogen
#include <vcl/toolbox.hxx>
#endif
#ifndef _SV_WRKWIN_HXX //autogen
#include <vcl/wrkwin.hxx>
#endif

#include <dispatch.hxx>
namespace binfilter {


//STRIP001 SFX_IMPL_TOOLBOX_CONTROL( HelpFileBoxControl, SfxStringItem );
//STRIP001 
//STRIP001 HelpFileBoxControl::HelpFileBoxControl( USHORT nId, ToolBox& rTbx, SfxBindings& rBind )
//STRIP001 	: SfxToolBoxControl( nId, rTbx, rBind )
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 HelpFileBoxControl::~HelpFileBoxControl()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 void HelpFileBoxControl::StateChanged( USHORT nSID, SfxItemState eState, const SfxPoolItem* pState )
//STRIP001 {
//STRIP001 	HelpFileBox* pBox = (HelpFileBox*) GetToolBox().GetItemWindow( GetId() );
//STRIP001 
//STRIP001 	DBG_ASSERT( pBox, "Box not found" );
//STRIP001 	if ( !pBox )
//STRIP001 		return;
//STRIP001 
//STRIP001 	if ( eState != SFX_ITEM_AVAILABLE )
//STRIP001 		pBox->Disable();
//STRIP001 	else
//STRIP001 	{
//STRIP001 		pBox->Enable();
//STRIP001 
//STRIP001 		if ( pState->ISA(SfxStringItem) )
//STRIP001 			pBox->Update( (const SfxStringItem*)pState );
//STRIP001 		else
//STRIP001 			pBox->Update( NULL );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 Window* HelpFileBoxControl::CreateItemWindow( Window *pParent )
//STRIP001 {
//STRIP001 	return new HelpFileBox( pParent );
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 HelpFileBox::HelpFileBox( Window* pParent ) :
//STRIP001 
//STRIP001 	ListBox( pParent, WinBits( WB_BORDER | WB_DROPDOWN | WB_SORT ) )
//STRIP001 
//STRIP001 {
//STRIP001 	FillBox();
//STRIP001 	bIgnoreSelect = TRUE;	// Select von 0 noch nicht weiterleiten
//STRIP001 	SelectEntryPos( 0 );
//STRIP001 	aCurText = GetEntry( 0 );
//STRIP001 	SetSizePixel( Size( 165, 200 ) );
//STRIP001 	bIgnoreSelect = FALSE;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 HelpFileBox::~HelpFileBox()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 void HelpFileBox::Update( const SfxStringItem* pItem )
//STRIP001 {
//STRIP001 	if ( !pItem  || !pItem->GetValue().Len() )
//STRIP001 		FillBox();
//STRIP001 
//STRIP001 	if ( pItem )
//STRIP001 		aCurText = pItem->GetValue();
//STRIP001 
//STRIP001 	if ( GetSelectEntry() != aCurText )
//STRIP001 		SelectEntry( aCurText );
//STRIP001 }
//STRIP001 
//STRIP001 void HelpFileBox::ReleaseFocus()
//STRIP001 {
//STRIP001 	SfxViewShell* pCurSh = SfxViewShell::Current();
//STRIP001 	DBG_ASSERT( pCurSh, "Current ViewShell not found!" );
//STRIP001 
//STRIP001 	if ( pCurSh )
//STRIP001 	{
//STRIP001 		Window* pShellWin = pCurSh->GetWindow();
//STRIP001         if ( pShellWin )       // sonst werde ich ihn nicht los
//STRIP001             pShellWin->GrabFocus();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void HelpFileBox::FillBox( BOOL bSelect )
//STRIP001 {
//STRIP001 	SetUpdateMode( FALSE );
//STRIP001 	bIgnoreSelect = TRUE;
//STRIP001 
//STRIP001 	aCurText = GetSelectEntry();
//STRIP001 	USHORT nCurPos = GetSelectEntryPos();
//STRIP001 
//STRIP001 	SelectEntryPos( 0 );
//STRIP001 	Clear();
//STRIP001 
//STRIP001 	USHORT nFiles = SfxHelp::GetHelpFileInfoCount();
//STRIP001 	for ( USHORT n = 0; n < nFiles; n++ )
//STRIP001 	{
//STRIP001 		HelpFileInfo* pInf = SfxHelp::GetHelpFileInfo( n );
//STRIP001 		String aFileName( pInf->aFileName );
//STRIP001 		aFileName.ToLowerAscii();
//STRIP001 		if ( aFileName.SearchAscii( "tips.svh" ) == STRING_NOTFOUND )
//STRIP001 			InsertEntry( pInf->aTitle, LISTBOX_APPEND );
//STRIP001 	}
//STRIP001 
//STRIP001 	SetUpdateMode( TRUE );
//STRIP001 
//STRIP001 	if ( bSelect )
//STRIP001 	{
//STRIP001 		SelectEntry( aCurText );
//STRIP001 		if ( !GetSelectEntryCount() )
//STRIP001 		{
//STRIP001 			SelectEntryPos( GetEntryCount() );	// gibst es nicht => leer?
//STRIP001 			aCurText = GetSelectEntry();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	bIgnoreSelect = FALSE;
//STRIP001 }
//STRIP001 
//STRIP001 long HelpFileBox::PreNotify( NotifyEvent& rNEvt )
//STRIP001 {
//STRIP001 	long nDone = 0;
//STRIP001 	if( rNEvt.GetType() == EVENT_KEYINPUT )
//STRIP001 	{
//STRIP001 		KeyEvent aKeyEvt = *rNEvt.GetKeyEvent();
//STRIP001 		USHORT nKeyCode = aKeyEvt.GetKeyCode().GetCode();
//STRIP001 		switch( nKeyCode )
//STRIP001 		{
//STRIP001 			case KEY_RETURN:
//STRIP001 			{
//STRIP001 				NotifyHelpShell();
//STRIP001 				nDone = 1;
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case KEY_ESCAPE:
//STRIP001 			{
//STRIP001 				SelectEntry( aCurText );
//STRIP001 				ReleaseFocus();
//STRIP001 				nDone = 1;
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return nDone ? nDone : ListBox::PreNotify( rNEvt );
//STRIP001 }
//STRIP001 
//STRIP001 void HelpFileBox::Select()
//STRIP001 {
//STRIP001 	if ( !IsTravelSelect() )
//STRIP001 	{
//STRIP001 		if ( !bIgnoreSelect )
//STRIP001 			NotifyHelpShell();
//STRIP001 		else
//STRIP001 			SelectEntry( aCurText );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void HelpFileBox::NotifyHelpShell()
//STRIP001 {
//STRIP001 	SfxStringItem aTitle( SID_HELP_HELPFILEBOX_SELECTED, GetSelectEntry() );
//STRIP001     SFX_APP()->GetDispatcher_Impl()->Execute( SID_HELP_HELPFILEBOX, SFX_CALLMODE_ASYNCHRON, &aTitle, 0L );
//STRIP001 	ReleaseFocus();
//STRIP001 }


}
