/*************************************************************************
 *
 *  $RCSfile: ipenv.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:39:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SFX_IPENV_HXX
#define _SFX_IPENV_HXX

#ifndef _IPENV_HXX //autogen
#include <so3/ipenv.hxx>
#endif
#include <sfx.hrc>
#include "childwin.hxx"
#include "workwin.hxx"
namespace binfilter {

//=========================================================================

//STRIP001 class SvInPlaceMenuBar;
//STRIP001 class SfxToolBoxManager;
//STRIP001 class SfxMenuBarManager;
//STRIP001 class SfxAcceleratorManager;
//STRIP001 class SfxConfigManager;
//STRIP001 class SfxInPlaceObject;
//STRIP001 class SfxInPlaceFrame;

//=========================================================================

//STRIP001 class SfxInPlaceEnv_Impl: public SvInPlaceEnvironment

/*	[Beschreibung]

	Eine Instanz dieser (SFx-internen) Klasse wird auf der Seite des Servers
	vom <SfxInPlaceFrame> erzeugt, wenn ein Objekt (genauer ein
	<SfxInPlaceObject>) In-Place aktiviert wird. Dar"uber wird die Kommnikation
	bez"uglich der Tools (Menu etc.) abgewickelt.
*/

//STRIP001 {
//STRIP001 	SfxInPlaceFrame*		pFrame;
//STRIP001 	SvInPlaceMenuBar*		pMenuBar;
//STRIP001 	SfxWorkWindow*			pWorkWin;
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual MenuBar*	QueryMenu( USHORT * nCount1, USHORT * nCount2,
//STRIP001 									USHORT * nCount3 );
//STRIP001 	virtual void		ShowUITools( BOOL bShow );
//STRIP001 	virtual void		TopWinResize();
//STRIP001 	virtual BOOL		DispatchAccel( const KeyCode & );
//STRIP001 	virtual void		RectsChangedPixel( const Rectangle & rObjRect,
//STRIP001 										   const Rectangle & rClipRect );
//STRIP001 
//STRIP001 public:
//STRIP001 						SfxInPlaceEnv_Impl( SfxInPlaceObject *pObj,
//STRIP001 											SfxInPlaceFrame *pIPFrame );
//STRIP001 						~SfxInPlaceEnv_Impl();
//STRIP001 
//STRIP001 	void				TopWinActivate( BOOL bActivate );
//STRIP001 	void				DocWinActivate( BOOL bActivate );
//STRIP001 	void				UIActivate( BOOL bActivate );
//STRIP001 	SfxWorkWindow*		GetWorkWindow()
//STRIP001 						{ return pWorkWin; }
//STRIP001 	virtual void		QueryObjAreaPixel( Rectangle& rRect ) const;
//STRIP001 	DECL_LINK(			DummyMenuHdl, Menu*);
//STRIP001 	BOOL				IsInternalInPlace() const;
//STRIP001 };

}//end of namespace binfilter
#endif

