/*************************************************************************
 *
 *  $RCSfile: svx_relfld.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:42:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#pragma hdrstop

#include <tools/ref.hxx>
#include "relfld.hxx"
namespace binfilter {

// -----------------------------------------------------------------------

//STRIP001 SvxRelativeField::SvxRelativeField( Window* pParent, WinBits nWinSize ) :
//STRIP001 	MetricField( pParent, nWinSize )
//STRIP001 {
//STRIP001 #if SUPD>629
//STRIP001     bNegativeEnabled = FALSE;
//STRIP001 #endif
//STRIP001     bRelativeMode = FALSE;
//STRIP001 	bRelative 	  = FALSE;
//STRIP001 
//STRIP001 	SetDecimalDigits( 2 );
//STRIP001 	SetMin( 0 );
//STRIP001 	SetMax( 9999 );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 SvxRelativeField::SvxRelativeField( Window* pParent, const ResId& rResId ) :
//STRIP001 	MetricField( pParent, rResId )
//STRIP001 {
//STRIP001 #if SUPD>629
//STRIP001     bNegativeEnabled = FALSE;
//STRIP001 #endif
//STRIP001     bRelativeMode = FALSE;
//STRIP001 	bRelative	  = FALSE;
//STRIP001 
//STRIP001 	SetDecimalDigits( 2 );
//STRIP001 	SetMin( 0 );
//STRIP001 	SetMax( 9999 );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SvxRelativeField::Modify()
//STRIP001 {
//STRIP001 	MetricField::Modify();
//STRIP001 
//STRIP001 	if ( bRelativeMode )
//STRIP001 	{
//STRIP001 		String  aStr = GetText();
//STRIP001 		BOOL    bNewMode = bRelative;
//STRIP001 
//STRIP001 		if ( bRelative )
//STRIP001 		{
//STRIP001 			const sal_Unicode* pStr = aStr.GetBuffer();
//STRIP001 
//STRIP001 			while ( *pStr )
//STRIP001 			{
//STRIP001 				if( ( ( *pStr < sal_Unicode( '0' ) ) || ( *pStr > sal_Unicode( '9' ) ) ) &&
//STRIP001 					( *pStr != sal_Unicode( '%' ) ) )
//STRIP001 				{
//STRIP001 					bNewMode = FALSE;
//STRIP001 					break;
//STRIP001 				}
//STRIP001 				pStr++;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			xub_StrLen nPos = aStr.Search( sal_Unicode( '%' ) );
//STRIP001 
//STRIP001 			if ( nPos != STRING_NOTFOUND )
//STRIP001 				bNewMode = TRUE;
//STRIP001 		}
//STRIP001 
//STRIP001 		if ( bNewMode != bRelative )
//STRIP001 			SetRelative( bNewMode );
//STRIP001 
//STRIP001 		MetricField::Modify();
//STRIP001 	}
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SvxRelativeField::EnableRelativeMode( USHORT nMin,
//STRIP001 										   USHORT nMax, USHORT nStep )
//STRIP001 {
//STRIP001 	bRelativeMode = TRUE;
//STRIP001 	nRelMin       = nMin;
//STRIP001 	nRelMax       = nMax;
//STRIP001 	nRelStep      = nStep;
//STRIP001 	SetUnit( FUNIT_CM );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SvxRelativeField::SetRelative( BOOL bNewRelative )
//STRIP001 {
//STRIP001 	Selection aSelection = GetSelection();
//STRIP001 	String aStr = GetText();
//STRIP001 
//STRIP001 	if ( bNewRelative )
//STRIP001 	{
//STRIP001 		bRelative = TRUE;
//STRIP001 		SetDecimalDigits( 0 );
//STRIP001 		SetMin( nRelMin );
//STRIP001 		SetMax( nRelMax );
//STRIP001 		SetCustomUnitText( String( sal_Unicode( '%' ) ) );
//STRIP001 		SetUnit( FUNIT_CUSTOM );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		bRelative = FALSE;
//STRIP001 		SetDecimalDigits( 2 );
//STRIP001 #if SUPD>629
//STRIP001         SetMin( bNegativeEnabled ? -9999 : 0 );
//STRIP001 #else
//STRIP001         SetMin( 0 );
//STRIP001 #endif
//STRIP001         SetMax( 9999 );
//STRIP001 		SetUnit( FUNIT_CM );
//STRIP001 	}
//STRIP001 
//STRIP001 	SetText( aStr );
//STRIP001 	SetSelection( aSelection );
//STRIP001 }


}
