/*************************************************************************
 *
 *  $RCSfile: svx_msoleexp.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:45:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
#include <com/sun/star/uno/Reference.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif
#ifndef _COM_SUN_STAR_UNO_ANY_HXX_
#include <com/sun/star/uno/Any.hxx>
#endif
#ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#endif
#ifndef _COM_SUN_STAR_CONTAINER_XNAMEACCESS_HPP_
#include <com/sun/star/container/XNameAccess.hpp>
#endif

#ifndef _SO_CLSIDS_HXX
#include <so3/clsids.hxx>
#endif
#ifndef _SFX_OBJSH_HXX
#include <bf_sfx2/objsh.hxx>
#endif
#ifndef _SFX_INTERNO_HXX
#include <bf_sfx2/interno.hxx>
#endif
#ifndef _SFX_OBJFAC_HXX
#include <bf_sfx2/docfac.hxx>
#endif
#ifndef _SFX_DOCFILT_HACK_HXX
#include <bf_sfx2/docfilt.hxx>
#endif
#ifndef _SFXDOCFILE_HXX
#include <bf_sfx2/docfile.hxx>
#endif
#ifndef _SFX_FCONTNR_HXX
#include <bf_sfx2/fcontnr.hxx>
#endif
#ifndef _SOT_FORMATS_HXX
#include <sot/formats.hxx>
#endif
#ifndef _COMPHELPER_PROCESSFACTORY_HXX_
#include <comphelper/processfactory.hxx>
#endif

#include "msoleexp.hxx"

#ifndef _LEGACYBINFILTERMGR_HXX
#include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
#endif
namespace binfilter {

//STRIP001 #define CREATE_CONST_ASC(s) String::CreateFromAscii( \
//STRIP001     RTL_CONSTASCII_STRINGPARAM(s))
//STRIP001 
//STRIP001 using namespace ::com::sun::star;
//STRIP001 
//STRIP001 SvGlobalName GetEmbeddedVersion( const SvGlobalName& aAppName )
//STRIP001 {
//STRIP001 	if ( aAppName == SvGlobalName( BF_SO3_SM_CLASSID_60 ) )
//STRIP001 			return SvGlobalName( BF_SO3_SM_OLE_EMBED_CLASSID_60 );
//STRIP001 	else if ( aAppName == SvGlobalName( BF_SO3_SW_CLASSID_60 ) )
//STRIP001 			return SvGlobalName( BF_SO3_SW_OLE_EMBED_CLASSID_60 );
//STRIP001 	else if ( aAppName == SvGlobalName( BF_SO3_SC_CLASSID_60 ) )
//STRIP001 			return SvGlobalName( BF_SO3_SC_OLE_EMBED_CLASSID_60 );
//STRIP001 	else if ( aAppName == SvGlobalName( BF_SO3_SDRAW_CLASSID_60 ) )
//STRIP001 			return SvGlobalName( BF_SO3_SDRAW_OLE_EMBED_CLASSID_60 );
//STRIP001 	else if ( aAppName == SvGlobalName( BF_SO3_SIMPRESS_CLASSID_60 ) )
//STRIP001 			return SvGlobalName( BF_SO3_SIMPRESS_OLE_EMBED_CLASSID_60 );
//STRIP001 	else if ( aAppName == SvGlobalName( BF_SO3_SCH_CLASSID_60 ) )
//STRIP001 			return SvGlobalName( BF_SO3_SCH_OLE_EMBED_CLASSID_60 );
//STRIP001 
//STRIP001 	return SvGlobalName();
//STRIP001 }
//STRIP001 
//STRIP001 String GetStorageType( const SvGlobalName& aEmbName )
//STRIP001 {
//STRIP001 	if ( aEmbName == SvGlobalName( BF_SO3_SM_OLE_EMBED_CLASSID_60 ) )
//STRIP001 			return String::CreateFromAscii( "soffice.StarMathDocument.6" );
//STRIP001 	else if ( aEmbName == SvGlobalName( BF_SO3_SW_OLE_EMBED_CLASSID_60 ) )
//STRIP001 			return String::CreateFromAscii( "soffice.StarWriterDocument.6" );
//STRIP001 	else if ( aEmbName == SvGlobalName( BF_SO3_SC_OLE_EMBED_CLASSID_60 ) )
//STRIP001 			return String::CreateFromAscii( "soffice.StarCalcDocument.6" );
//STRIP001 	else if ( aEmbName == SvGlobalName( BF_SO3_SDRAW_OLE_EMBED_CLASSID_60 ) )
//STRIP001 			return String::CreateFromAscii( "soffice.StarDrawDocument.6" );
//STRIP001 	else if ( aEmbName == SvGlobalName( BF_SO3_SIMPRESS_OLE_EMBED_CLASSID_60 ) )
//STRIP001 			return String::CreateFromAscii( "soffice.StarImpressDocument.6" );
//STRIP001 	else if ( aEmbName == SvGlobalName( BF_SO3_SCH_OLE_EMBED_CLASSID_60 ) )
//STRIP001 			return String::CreateFromAscii( "soffice.StarChartDocument.6" );
//STRIP001 
//STRIP001 	return String();
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool UseOldMSExport()
//STRIP001 {
//STRIP001     uno::Reference< lang::XMultiServiceFactory > xFactory = ::legacy_binfilters::getLegacyProcessServiceFactory();
//STRIP001 
//STRIP001 	if ( xFactory.is() )
//STRIP001 	{
//STRIP001 		uno::Reference< lang::XMultiServiceFactory > xProvider( xFactory->createInstance(
//STRIP001                     ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( "com.sun.star.configuration.ConfigurationProvider"))),
//STRIP001                 	uno::UNO_QUERY);
//STRIP001 		if ( xProvider.is() )
//STRIP001 		{
//STRIP001 			try {
//STRIP001 				uno::Sequence< uno::Any > aArg( 1 );
//STRIP001 				aArg[0] <<= ::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( "/org.openoffice.Office.Common/InternalMSExport") );
//STRIP001 				uno::Reference< container::XNameAccess > xNameAccess( 
//STRIP001 					xProvider->createInstanceWithArguments( 
//STRIP001 						::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( "com.sun.star.configuration.ConfigurationUpdateAccess" ) ),
//STRIP001 						aArg ),
//STRIP001 					uno::UNO_QUERY );
//STRIP001 				if ( xNameAccess.is() )
//STRIP001 				{
//STRIP001 					uno::Any aResult = xNameAccess->getByName( 
//STRIP001 									::rtl::OUString( RTL_CONSTASCII_USTRINGPARAM( "UseOldExport" ) ) );
//STRIP001 
//STRIP001 					sal_Bool bResult;
//STRIP001 					if ( aResult >>= bResult )
//STRIP001 						return bResult;
//STRIP001 				}
//STRIP001 			}
//STRIP001 			catch( uno::Exception& )
//STRIP001 			{
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	OSL_ENSURE( sal_False, "Could not get access to configuration entry!\n" );
//STRIP001 	return sal_False;
//STRIP001 }
//STRIP001 
//STRIP001 void SvxMSExportOLEObjects::ExportOLEObject( SvInPlaceObject& rObj,
//STRIP001 												SvStorage& rDestStg )
//STRIP001 {
//STRIP001 	SvGlobalName aOwnGlobalName;
//STRIP001 	const SfxFilter* pExpFilter = NULL;
//STRIP001 	SfxInPlaceObjectRef xSfxIPObj( &rObj );
//STRIP001 	if( xSfxIPObj.Is() && xSfxIPObj->GetObjectShell() )
//STRIP001 	{
//STRIP001 		static struct _ObjExpType {
//STRIP001 			UINT32 nFlag;
//STRIP001 			const char* pFilterNm;
//STRIP001 			// GlobalNameId
//STRIP001 			struct _GlobalNameIds {
//STRIP001 				UINT32 n1;
//STRIP001 				USHORT n2, n3;
//STRIP001 				BYTE b8, b9, b10, b11, b12, b13, b14, b15;
//STRIP001             } aGlNmIds[4];
//STRIP001 		} aArr[] = {
//STRIP001 			{ OLE_STARMATH_2_MATHTYPE, "MathType 3.x",
//STRIP001                 {BF_SO3_SM_CLASSID_60, BF_SO3_SM_CLASSID_50,
//STRIP001                  BF_SO3_SM_CLASSID_40, BF_SO3_SM_CLASSID_30 }},
//STRIP001 			{ OLE_STARWRITER_2_WINWORD, "MS Word 97",
//STRIP001                 {BF_SO3_SW_CLASSID_60, BF_SO3_SW_CLASSID_50,
//STRIP001                  BF_SO3_SW_CLASSID_40, BF_SO3_SW_CLASSID_30 }},
//STRIP001 			{ OLE_STARCALC_2_EXCEL, "MS Excel 97",
//STRIP001                 {BF_SO3_SC_CLASSID_60, BF_SO3_SC_CLASSID_50,
//STRIP001                  BF_SO3_SC_CLASSID_40, BF_SO3_SC_CLASSID_30 }},
//STRIP001 			{ OLE_STARIMPRESS_2_POWERPOINT, "MS PowerPoint 97",
//STRIP001                 {BF_SO3_SIMPRESS_CLASSID_60, BF_SO3_SIMPRESS_CLASSID_50,
//STRIP001                  BF_SO3_SIMPRESS_CLASSID_40, BF_SO3_SIMPRESS_CLASSID_30 }},
//STRIP001 			{ 0, "",
//STRIP001 				{BF_SO3_SCH_CLASSID_60, BF_SO3_SCH_CLASSID_50,
//STRIP001 				 BF_SO3_SCH_CLASSID_40, BF_SO3_SCH_CLASSID_30 }},
//STRIP001 			{ 0, "",
//STRIP001 				{BF_SO3_SDRAW_CLASSID_60, BF_SO3_SDRAW_CLASSID_50,	// SJ: !!!! BF_SO3_SDRAW_CLASSID is only available up from
//STRIP001 				 BF_SO3_SDRAW_CLASSID_60, BF_SO3_SDRAW_CLASSID_50 }}, // ver 5.0, it is purpose to have double entrys here.
//STRIP001 			{ 0xffff,0 }
//STRIP001 		};
//STRIP001 		for( const _ObjExpType* pArr = aArr; !pExpFilter && ( pArr->nFlag != 0xffff ); ++pArr )
//STRIP001 		{
//STRIP001             for ( int n = 0; n < 4; ++n )
//STRIP001 			{
//STRIP001 				const _ObjExpType::_GlobalNameIds& rId = pArr->aGlNmIds[ n ];
//STRIP001 				SvGlobalName aGlbNm( rId.n1, rId.n2, rId.n3,
//STRIP001 							rId.b8, rId.b9, rId.b10, rId.b11,
//STRIP001 							rId.b12, rId.b13, rId.b14, rId.b15 );
//STRIP001 				if( *xSfxIPObj->GetSvFactory() == aGlbNm )
//STRIP001 				{
//STRIP001 					aOwnGlobalName = aGlbNm;
//STRIP001 						
//STRIP001 					if( GetFlags() & pArr->nFlag )
//STRIP001 					{
//STRIP001 						const SfxObjectFactory& rFact = xSfxIPObj->
//STRIP001 												GetObjectShell()->GetFactory();
//STRIP001 						if( rFact.GetFilterContainer() )
//STRIP001 							pExpFilter = rFact.GetFilterContainer()->
//STRIP001 								GetFilter4FilterName( String::CreateFromAscii(
//STRIP001 												pArr->pFilterNm ));
//STRIP001 						break;
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if( pExpFilter )				        // use this filter for the export
//STRIP001 	{
//STRIP001 		SfxMedium aMed( &rDestStg, FALSE );
//STRIP001 		aMed.SetFilter( pExpFilter );
//STRIP001 		xSfxIPObj->GetObjectShell()->ConvertTo( aMed );
//STRIP001 	}
//STRIP001 	else if( aOwnGlobalName != SvGlobalName() )
//STRIP001 	{
//STRIP001 		SvGlobalName aEmbName = GetEmbeddedVersion( aOwnGlobalName );
//STRIP001 		if ( aEmbName != SvGlobalName() && !UseOldMSExport() )
//STRIP001 		{
//STRIP001 			// this is a StarOffice 6.1 embedded object
//STRIP001 			rDestStg.SetVersion( SOFFICE_FILEFORMAT_31 );
//STRIP001 			rDestStg.SetClass( aEmbName, 
//STRIP001 								SOT_FORMATSTR_ID_EMBEDDED_OBJ_OLE, 
//STRIP001 								GetStorageType( aEmbName ) );
//STRIP001 			SotStorageStreamRef xExtStm = rDestStg.OpenSotStream(
//STRIP001 											String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "properties_stream" ) ),
//STRIP001 											STREAM_STD_READWRITE );
//STRIP001 
//STRIP001 			sal_Bool bExtentSuccess = sal_False;
//STRIP001 			if( !xExtStm->GetError() )
//STRIP001 			{
//STRIP001 				// write extent
//STRIP001 				Rectangle aVisArea = xSfxIPObj->GetVisArea( ASPECT_CONTENT );
//STRIP001 				sal_Int32 pRect[4];
//STRIP001 				pRect[0] = aVisArea.Left();
//STRIP001 				pRect[1] = aVisArea.Right();
//STRIP001 				pRect[2] = aVisArea.Top();
//STRIP001 				pRect[3] = aVisArea.Bottom();
//STRIP001 
//STRIP001 				sal_Int8 aWriteSet[16];
//STRIP001 				for ( int ind = 0; ind < 4; ind++ )
//STRIP001 				{
//STRIP001 					sal_Int32 nVal = pRect[ind];
//STRIP001 					for ( int nByte = 0; nByte < 4; nByte++ )
//STRIP001 					{
//STRIP001 						aWriteSet[ind*4+nByte] = nVal % 0x100;
//STRIP001 						nVal /= 0x100;
//STRIP001 					}
//STRIP001 				}
//STRIP001 				bExtentSuccess = ( xExtStm->Write( aWriteSet, 16 ) == 16 );
//STRIP001 			}
//STRIP001 
//STRIP001 			if ( bExtentSuccess )
//STRIP001 			{
//STRIP001 				SotStorageStreamRef xEmbStm = rDestStg.OpenSotStream(
//STRIP001 												String::CreateFromAscii( RTL_CONSTASCII_STRINGPARAM( "package_stream" ) ),
//STRIP001 												STREAM_STD_READWRITE );
//STRIP001 
//STRIP001 				if( !xEmbStm->GetError() )
//STRIP001 				{
//STRIP001 					SvStorageRef xEmbStor = new SvStorage( sal_True, *xEmbStm );
//STRIP001 					if( !xEmbStor->GetError() )
//STRIP001 					{
//STRIP001 						rObj.DoSaveAs( &xEmbStor );
//STRIP001 						rObj.DoSaveCompleted();
//STRIP001 						xEmbStor->Commit();
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			rDestStg.SetVersion( SOFFICE_FILEFORMAT_50 );
//STRIP001 			rObj.DoSaveAs( &rDestStg );
//STRIP001 			rObj.DoSaveCompleted();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		rDestStg.SetVersion( SOFFICE_FILEFORMAT_31 );
//STRIP001 		rObj.DoSaveAs( &rDestStg );
//STRIP001 		rObj.DoSaveCompleted();
//STRIP001 	}
//STRIP001     //We never need this stream: See #99809# and #i2179#
//STRIP001     rDestStg.Remove(CREATE_CONST_ASC(SVEXT_PERSIST_STREAM));
//STRIP001 }



}
