/*************************************************************************
 *
 *  $RCSfile: svx_svdfmtf.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 16:21:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #include "svdfmtf.hxx"
// auto strip #include "editdata.hxx"
#include <math.h>
// auto strip #include "xpoly.hxx"

// auto strip #ifndef _SV_SVAPP_HXX
// auto strip #include <vcl/svapp.hxx>
// auto strip #endif

#ifndef _EEITEMID_HXX //autogen
#include <eeitemid.hxx>
#endif

#ifndef _EEITEM_HXX
#include <eeitem.hxx>
#endif

// auto strip #ifndef _SVX_FHGTITEM_HXX //autogen
// auto strip #include <fhgtitem.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_WGHTITEM_HXX //autogen
// auto strip #include <wghtitem.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_POSTITEM_HXX //autogen
// auto strip #include <postitem.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_UDLNITEM_HXX //autogen
// auto strip #include <udlnitem.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_CRSDITEM_HXX //autogen
// auto strip #include <crsditem.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_SHDDITEM_HXX //autogen
// auto strip #include <shdditem.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_XLNCLIT_HXX //autogen
// auto strip #include <xlnclit.hxx>
// auto strip #endif

#ifndef _SVX_XLNWTIT_HXX //autogen
#include <xlnwtit.hxx>
#endif

// auto strip #ifndef _SVX_XFLCLIT_HXX //autogen
// auto strip #include <xflclit.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_XGRAD_HXX //autogen
// auto strip #include <xgrad.hxx>
// auto strip #endif

#ifndef _XDEF_HXX
#include <xdef.hxx>
#endif

// auto strip #ifndef _SVX_XFLGRIT_HXX //autogen
// auto strip #include <xflgrit.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_FONTITEM_HXX //autogen
// auto strip #include <fontitem.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_AKRNITEM_HXX //autogen
// auto strip #include <akrnitem.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_WRLMITEM_HXX //autogen
// auto strip #include <wrlmitem.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_ITEM_HXX //autogen
// auto strip #include <cntritem.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_COLRITEM_HXX //autogen
// auto strip #include <colritem.hxx>
// auto strip #endif

// auto strip #ifndef _SV_METRIC_HXX //autogen
// auto strip #include <vcl/metric.hxx>
// auto strip #endif

// auto strip #include <charscaleitem.hxx>

// auto strip #include "xflhtit.hxx"
// auto strip #include "svdattr.hxx"
// auto strip #include "svdmodel.hxx"
// auto strip #include "svdpage.hxx"
// auto strip #include "svdobj.hxx"
// auto strip #include "svditext.hxx"
// auto strip #include "svdotext.hxx"
// auto strip #include "svdorect.hxx"
// auto strip #include "svdocirc.hxx"
// auto strip #include "svdograf.hxx"
// auto strip #include "svdopath.hxx"
// auto strip #include "svdetc.hxx"
namespace binfilter {

////////////////////////////////////////////////////////////////////////////////////////////////////

//STRIP001 ImpSdrGDIMetaFileImport::ImpSdrGDIMetaFileImport(SdrModel& rModel):
//STRIP001 	nMapScalingOfs(0),
//STRIP001 	pLineAttr(NULL),pFillAttr(NULL),pTextAttr(NULL),pPage(NULL),pModel(NULL),nLayer(0),bFntDirty(TRUE),
//STRIP001 	bLastObjWasPolyWithoutLine(FALSE),bNoLine(FALSE),bNoFill(FALSE),bLastObjWasLine(FALSE),nLineWidth(0)
//STRIP001 {
//STRIP001 	aVD.EnableOutput(FALSE);
//STRIP001 	aOldLineColor.SetRed( aVD.GetLineColor().GetRed() + 1 ); // invalidate old line color
//STRIP001 	pLineAttr=new SfxItemSet(rModel.GetItemPool(),XATTR_LINE_FIRST,XATTR_LINE_LAST);
//STRIP001 	pFillAttr=new SfxItemSet(rModel.GetItemPool(),XATTR_FILL_FIRST,XATTR_FILL_LAST);
//STRIP001 	pTextAttr=new SfxItemSet(rModel.GetItemPool(),EE_ITEMS_START,EE_ITEMS_END);
//STRIP001 	pModel=&rModel;
//STRIP001 }
//STRIP001 
//STRIP001 ImpSdrGDIMetaFileImport::~ImpSdrGDIMetaFileImport()
//STRIP001 {
//STRIP001 	delete pLineAttr;
//STRIP001 	delete pFillAttr;
//STRIP001 	delete pTextAttr;
//STRIP001 }
//STRIP001 
//STRIP001 ULONG ImpSdrGDIMetaFileImport::DoImport(const GDIMetaFile& rMtf,
//STRIP001 	SdrObjList& rOL,
//STRIP001 	ULONG nInsPos,
//STRIP001 	SvdProgressInfo *pProgrInfo)
//STRIP001 {
//STRIP001 	pPage = rOL.GetPage();
//STRIP001 	GDIMetaFile* pTmpMtf=NULL;
//STRIP001 	GDIMetaFile* pMtf = (GDIMetaFile*) &rMtf;
//STRIP001 	ULONG nActionAnz=pMtf->GetActionCount();
//STRIP001 	sal_Bool bError = sal_False;
//STRIP001 
//STRIP001 
//STRIP001 	// setup some global scale parameter
//STRIP001 	// fScaleX, fScaleY, aScaleX, aScaleY, bMov, bSize
//STRIP001     fScaleX = fScaleY = 1.0;
//STRIP001 	Size  aMtfSize( pMtf->GetPrefSize() );
//STRIP001 	if ( aMtfSize.Width() & aMtfSize.Height() && ( aScaleRect.IsEmpty() == sal_False ) )
//STRIP001     {
//STRIP001 		aOfs = aScaleRect.TopLeft();
//STRIP001         if ( aMtfSize.Width() != ( aScaleRect.GetWidth() - 1 ) )
//STRIP001             fScaleX = (double)( aScaleRect.GetWidth() - 1 ) / (double)aMtfSize.Width();
//STRIP001         if ( aMtfSize.Height() != ( aScaleRect.GetHeight() - 1 ) )
//STRIP001             fScaleY = (double)( aScaleRect.GetHeight() - 1 ) / (double)aMtfSize.Height();
//STRIP001     }
//STRIP001 
//STRIP001 	bMov = aOfs.X()!=0 || aOfs.Y()!=0;
//STRIP001     bSize = sal_False;	
//STRIP001 
//STRIP001 	aScaleX = Fraction( 1, 1 );
//STRIP001 	aScaleY = Fraction( 1, 1 );
//STRIP001     if ( aMtfSize.Width() != ( aScaleRect.GetWidth() - 1 ) )
//STRIP001     {
//STRIP001         aScaleX = Fraction( aScaleRect.GetWidth() - 1, aMtfSize.Width() );
//STRIP001         bSize = sal_True;
//STRIP001     }
//STRIP001     if ( aMtfSize.Height() != ( aScaleRect.GetHeight() - 1 ) )
//STRIP001     {
//STRIP001         aScaleY = Fraction( aScaleRect.GetHeight() - 1, aMtfSize.Height() );
//STRIP001         bSize = sal_True;
//STRIP001     }
//STRIP001 
//STRIP001 	if(65000 < nActionAnz)
//STRIP001 	{
//STRIP001 		nActionAnz = 65000;
//STRIP001 		bError = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if(pProgrInfo)
//STRIP001 		pProgrInfo->SetActionCount(nActionAnz);
//STRIP001 
//STRIP001 	ULONG nActionsToReport = 0;
//STRIP001 
//STRIP001 	for( MetaAction* pAct = pMtf->FirstAction(); pAct; pAct = pMtf->NextAction() )
//STRIP001 	{
//STRIP001 		switch (pAct->GetType()) 
//STRIP001 		{
//STRIP001 			case META_PIXEL_ACTION          : DoAction((MetaPixelAction          &)*pAct); break;
//STRIP001 			case META_POINT_ACTION          : DoAction((MetaPointAction          &)*pAct); break;
//STRIP001 			case META_LINE_ACTION           : DoAction((MetaLineAction           &)*pAct); break;
//STRIP001 			case META_RECT_ACTION           : DoAction((MetaRectAction           &)*pAct); break;
//STRIP001 			case META_ROUNDRECT_ACTION      : DoAction((MetaRoundRectAction      &)*pAct); break;
//STRIP001 			case META_ELLIPSE_ACTION        : DoAction((MetaEllipseAction        &)*pAct); break;
//STRIP001 			case META_ARC_ACTION            : DoAction((MetaArcAction            &)*pAct); break;
//STRIP001 			case META_PIE_ACTION            : DoAction((MetaPieAction            &)*pAct); break;
//STRIP001 			case META_CHORD_ACTION          : DoAction((MetaChordAction          &)*pAct); break;
//STRIP001 			case META_POLYLINE_ACTION	    : DoAction((MetaPolyLineAction		 &)*pAct); break;
//STRIP001 			case META_POLYGON_ACTION        : DoAction((MetaPolygonAction        &)*pAct); break;
//STRIP001 			case META_POLYPOLYGON_ACTION    : DoAction((MetaPolyPolygonAction    &)*pAct); break;
//STRIP001 			case META_TEXT_ACTION           : DoAction((MetaTextAction           &)*pAct); break;
//STRIP001 			case META_TEXTARRAY_ACTION      : DoAction((MetaTextArrayAction      &)*pAct); break;
//STRIP001 			case META_STRETCHTEXT_ACTION    : DoAction((MetaStretchTextAction    &)*pAct); break;
//STRIP001 			case META_BMP_ACTION			: DoAction((MetaBmpAction			 &)*pAct); break;
//STRIP001 			case META_BMPSCALE_ACTION		: DoAction((MetaBmpScaleAction		 &)*pAct); break;
//STRIP001 			case META_BMPEX_ACTION			: DoAction((MetaBmpExAction			 &)*pAct); break;
//STRIP001 			case META_BMPEXSCALE_ACTION		: DoAction((MetaBmpExScaleAction	 &)*pAct); break;
//STRIP001 			case META_LINECOLOR_ACTION      : DoAction((MetaLineColorAction      &)*pAct); break;
//STRIP001 			case META_FILLCOLOR_ACTION      : DoAction((MetaFillColorAction      &)*pAct); break;
//STRIP001 			case META_TEXTCOLOR_ACTION      : DoAction((MetaTextColorAction      &)*pAct); break;
//STRIP001 			case META_TEXTFILLCOLOR_ACTION  : DoAction((MetaTextFillColorAction  &)*pAct); break;
//STRIP001 			case META_FONT_ACTION           : DoAction((MetaFontAction           &)*pAct); break;
//STRIP001 			case META_TEXTALIGN_ACTION		: DoAction((MetaTextAlignAction		 &)*pAct); break;
//STRIP001 			case META_MAPMODE_ACTION        : DoAction((MetaMapModeAction        &)*pAct); break;
//STRIP001 			case META_CLIPREGION_ACTION     : DoAction((MetaClipRegionAction     &)*pAct); break;
//STRIP001 			case META_MOVECLIPREGION_ACTION : DoAction((MetaMoveClipRegionAction &)*pAct); break;
//STRIP001 			case META_ISECTRECTCLIPREGION_ACTION: DoAction((MetaISectRectClipRegionAction&)*pAct); break;
//STRIP001 			case META_ISECTREGIONCLIPREGION_ACTION: DoAction((MetaISectRegionClipRegionAction&)*pAct); break;
//STRIP001 			case META_RASTEROP_ACTION       : DoAction((MetaRasterOpAction       &)*pAct); break;
//STRIP001 			case META_PUSH_ACTION           : DoAction((MetaPushAction           &)*pAct); break;
//STRIP001 			case META_POP_ACTION            : DoAction((MetaPopAction            &)*pAct); break;
//STRIP001 			case META_HATCH_ACTION			: DoAction((MetaHatchAction          &)*pAct); break;
//STRIP001 			case META_COMMENT_ACTION		: DoAction((MetaCommentAction        &)*pAct, pMtf); break;
//STRIP001 
//STRIP001 		}
//STRIP001 
//STRIP001 		if(pProgrInfo != NULL)
//STRIP001 		{
//STRIP001 		  nActionsToReport++;
//STRIP001 		  if(nActionsToReport >= 16) // Alle 16 Action updaten
//STRIP001 		  {
//STRIP001 			if(!pProgrInfo->ReportActions(nActionsToReport))
//STRIP001 			  break;
//STRIP001 			nActionsToReport = 0;
//STRIP001 		  }
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if(pProgrInfo != NULL)
//STRIP001 	{
//STRIP001 		pProgrInfo->ReportActions(nActionsToReport);
//STRIP001 		nActionsToReport = 0;
//STRIP001 	}
//STRIP001 
//STRIP001 	// MapMode-Scaling  vornehmen
//STRIP001 	MapScaling();
//STRIP001 	// Objekte in vorgegebenes Rechteck hineinskalieren
//STRIP001 	ULONG nAnz=aTmpList.GetObjCount();
//STRIP001 
//STRIP001 	// Beim berechnen der Fortschrittsanzeige wird GetActionCount()*3 benutzt.
//STRIP001 	// Da in aTmpList allerdings weniger eintraege als GetActionCount()
//STRIP001 	// existieren koennen, muessen hier die zuviel vermuteten Actionen wieder
//STRIP001 	// hinzugefuegt werden.
//STRIP001 	nActionsToReport = (pMtf->GetActionCount() - nAnz)*2;
//STRIP001 
//STRIP001 
//STRIP001 	// Alle noch nicht gemeldeten Rescales melden
//STRIP001 	if(pProgrInfo)
//STRIP001 	{
//STRIP001 		pProgrInfo->ReportRescales(nActionsToReport);
//STRIP001 		pProgrInfo->SetInsertCount(nAnz);
//STRIP001 	}
//STRIP001 	nActionsToReport = 0;
//STRIP001 
//STRIP001 	// alle in aTmpList zwischengespeicherten Objekte nun in rOL ab der Position nInsPos einfuegen
//STRIP001 	if (nInsPos>rOL.GetObjCount()) nInsPos=rOL.GetObjCount();
//STRIP001 	SdrInsertReason aReason(SDRREASON_VIEWCALL);
//STRIP001 	for (ULONG i=0; i<nAnz; i++)
//STRIP001 	{
//STRIP001 		 SdrObject* pObj=aTmpList.GetObj(i);
//STRIP001 		 rOL.NbcInsertObject(pObj,nInsPos,&aReason);
//STRIP001 		 nInsPos++;
//STRIP001 
//STRIP001 		if(pProgrInfo != NULL)
//STRIP001 		{
//STRIP001 			nActionsToReport++;
//STRIP001 			if(nActionsToReport >= 32) // Alle 32 Action updaten
//STRIP001 			{
//STRIP001 				pProgrInfo->ReportInserts(nActionsToReport);
//STRIP001 				nActionsToReport = 0;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	if (pTmpMtf!=NULL) delete pTmpMtf;
//STRIP001 
//STRIP001 	// ein letztesmal alle verbliebennen Inserts reporten
//STRIP001 	if(pProgrInfo != NULL)
//STRIP001 	{
//STRIP001 		pProgrInfo->ReportInserts(nActionsToReport);
//STRIP001 		if(bError)
//STRIP001 			pProgrInfo->ReportError();
//STRIP001 	}
//STRIP001 
//STRIP001 	return aTmpList.GetObjCount();
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::SetAttributes(SdrObject* pObj, FASTBOOL bForceTextAttr)
//STRIP001 {
//STRIP001 	bNoLine = FALSE; bNoFill = FALSE;
//STRIP001 	FASTBOOL bLine=TRUE && !bForceTextAttr;
//STRIP001 	FASTBOOL bFill=pObj==NULL || pObj->IsClosedObj() && !bForceTextAttr;
//STRIP001 	FASTBOOL bText=bForceTextAttr || (pObj!=NULL && pObj->GetOutlinerParaObject()!=NULL);
//STRIP001 
//STRIP001 	if ( bLine )
//STRIP001 	{
//STRIP001 		if ( nLineWidth )
//STRIP001 			pLineAttr->Put( XLineWidthItem( nLineWidth ) );
//STRIP001 		aOldLineColor = aVD.GetLineColor();
//STRIP001 		if( aVD.IsLineColor() )
//STRIP001 		{
//STRIP001 			pLineAttr->Put(XLineStyleItem(XLINE_SOLID));
//STRIP001 			pLineAttr->Put(XLineColorItem(String(), aVD.GetLineColor()));
//STRIP001 		}
//STRIP001 		else
//STRIP001 			pLineAttr->Put(XLineStyleItem(XLINE_NONE));
//STRIP001 	} 
//STRIP001 	else 
//STRIP001 		bNoLine = TRUE;
//STRIP001 
//STRIP001 	if ( bFill )
//STRIP001 	{
//STRIP001 		if( aVD.IsFillColor() )
//STRIP001 		{
//STRIP001 			pFillAttr->Put(XFillStyleItem(XFILL_SOLID));
//STRIP001 			pFillAttr->Put(XFillColorItem(String(), aVD.GetFillColor()));
//STRIP001 		}
//STRIP001 		else
//STRIP001 			pFillAttr->Put(XFillStyleItem(XFILL_NONE));
//STRIP001 	} 
//STRIP001 	else 
//STRIP001 		bNoFill = TRUE;
//STRIP001 
//STRIP001 	if ( bText && bFntDirty ) 
//STRIP001 	{
//STRIP001 		Font aFnt(aVD.GetFont());
//STRIP001 		pTextAttr->Put( SvxFontItem( aFnt.GetFamily(), aFnt.GetName(), aFnt.GetStyleName(),
//STRIP001 							aFnt.GetPitch(), aFnt.GetCharSet(), EE_CHAR_FONTINFO ) );
//STRIP001 		pTextAttr->Put( SvxFontItem( aFnt.GetFamily(), aFnt.GetName(), aFnt.GetStyleName(),
//STRIP001 							aFnt.GetPitch(), aFnt.GetCharSet(), EE_CHAR_FONTINFO_CJK ) );
//STRIP001 		pTextAttr->Put( SvxFontItem( aFnt.GetFamily(), aFnt.GetName(), aFnt.GetStyleName(),
//STRIP001 							aFnt.GetPitch(), aFnt.GetCharSet(), EE_CHAR_FONTINFO_CTL ) );
//STRIP001 		pTextAttr->Put(SvxPostureItem(aFnt.GetItalic()));
//STRIP001 		pTextAttr->Put(SvxWeightItem(aFnt.GetWeight()));
//STRIP001 		sal_uInt32 nHeight = aFnt.GetSize().Height() * fScaleY;
//STRIP001 		pTextAttr->Put( SvxFontHeightItem( nHeight, 100, EE_CHAR_FONTHEIGHT ) );
//STRIP001 		pTextAttr->Put( SvxFontHeightItem( nHeight, 100, EE_CHAR_FONTHEIGHT_CJK ) );
//STRIP001 		pTextAttr->Put( SvxFontHeightItem( nHeight, 100, EE_CHAR_FONTHEIGHT_CTL ) );
//STRIP001 		pTextAttr->Put(SvxCharScaleWidthItem(100));
//STRIP001 		pTextAttr->Put(SvxUnderlineItem(aFnt.GetUnderline()));
//STRIP001 		pTextAttr->Put(SvxCrossedOutItem(aFnt.GetStrikeout()));
//STRIP001 		pTextAttr->Put(SvxShadowedItem(aFnt.IsShadow()));
//STRIP001 		pTextAttr->Put(SvxAutoKernItem(aFnt.IsKerning()));
//STRIP001 		pTextAttr->Put(SvxWordLineModeItem(aFnt.IsWordLineMode()));
//STRIP001 		pTextAttr->Put(SvxContourItem(aFnt.IsOutline()));
//STRIP001 		pTextAttr->Put(SvxColorItem(aFnt.GetColor()));
//STRIP001 		//... svxfont textitem svditext
//STRIP001 		bFntDirty=FALSE;
//STRIP001 	}
//STRIP001 	if (pObj!=NULL) 
//STRIP001 	{
//STRIP001 		pObj->SetLayer(nLayer);
//STRIP001 		if (bLine) pObj->SetItemSet(*pLineAttr);
//STRIP001 		if (bFill) pObj->SetItemSet(*pFillAttr);
//STRIP001 		if (bText)
//STRIP001 		{
//STRIP001 			pObj->SetItemSet(*pTextAttr);
//STRIP001 			pObj->SetItem( SdrTextHorzAdjustItem( SDRTEXTHORZADJUST_LEFT ) );
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::InsertObj( SdrObject* pObj, sal_Bool bScale )
//STRIP001 {
//STRIP001 	if ( bScale && !aScaleRect.IsEmpty() )
//STRIP001     {
//STRIP001 		if ( bSize )
//STRIP001 			pObj->NbcResize( Point(), aScaleX, aScaleY );
//STRIP001 		if ( bMov )
//STRIP001 			pObj->NbcMove( Size( aOfs.X(), aOfs.Y() ) );
//STRIP001 	}
//STRIP001 
//STRIP001 	aTmpList.InsertObject( pObj );
//STRIP001 	if ( HAS_BASE( SdrPathObj, pObj ) )
//STRIP001 	{
//STRIP001 		FASTBOOL bClosed=pObj->IsClosedObj();
//STRIP001 		bLastObjWasPolyWithoutLine=bNoLine && bClosed;
//STRIP001 		bLastObjWasLine=!bClosed;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		bLastObjWasPolyWithoutLine = FALSE;
//STRIP001 		bLastObjWasLine = FALSE;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /**************************************************************************************************/
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaPixelAction& rAct)
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaPointAction& rAct)
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaLineAction& rAct)
//STRIP001 {
//STRIP001 	XPolygon aXP( 2 );
//STRIP001 	aXP[ 0 ] = rAct.GetStartPoint();
//STRIP001 	aXP[ 1 ] = rAct.GetEndPoint();
//STRIP001 	aXP.Scale( fScaleX, fScaleY );
//STRIP001 	aXP.Translate( aOfs );
//STRIP001 
//STRIP001 	const LineInfo& rLineInfo = rAct.GetLineInfo();
//STRIP001 	sal_Int32 nNewLineWidth = rLineInfo.GetWidth();
//STRIP001 	sal_Bool bCreateLineObject = sal_True;
//STRIP001 
//STRIP001 	if ( bLastObjWasLine && ( nNewLineWidth == nLineWidth ) && CheckLastLineMerge( aXP ) )
//STRIP001 		bCreateLineObject = sal_False;
//STRIP001 
//STRIP001 	nLineWidth = nNewLineWidth;
//STRIP001 
//STRIP001 	if ( bCreateLineObject )
//STRIP001 	{
//STRIP001 		SdrPathObj* pPath = new SdrPathObj( OBJ_LINE, XPolyPolygon( aXP ) );
//STRIP001 		SetAttributes( pPath );
//STRIP001 		InsertObj( pPath, sal_False );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaRectAction& rAct)
//STRIP001 {
//STRIP001 	SdrRectObj* pRect=new SdrRectObj(rAct.GetRect());
//STRIP001 	SetAttributes(pRect);
//STRIP001 	InsertObj(pRect);
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaRoundRectAction& rAct)
//STRIP001 {
//STRIP001 	SdrRectObj* pRect=new SdrRectObj(rAct.GetRect());
//STRIP001 	SetAttributes(pRect);
//STRIP001 	long nRad=(rAct.GetHorzRound()+rAct.GetVertRound())/2;
//STRIP001 	if (nRad!=0) {
//STRIP001 		SfxItemSet aSet(*pLineAttr->GetPool(),SDRATTR_ECKENRADIUS,SDRATTR_ECKENRADIUS);
//STRIP001 		aSet.Put(SdrEckenradiusItem(nRad));
//STRIP001 		pRect->SetItemSet(aSet);
//STRIP001 	}
//STRIP001 	InsertObj(pRect);
//STRIP001 }
//STRIP001 
//STRIP001 /**************************************************************************************************/
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaEllipseAction& rAct)
//STRIP001 {
//STRIP001 	SdrCircObj* pCirc=new SdrCircObj(OBJ_CIRC,rAct.GetRect());
//STRIP001 	SetAttributes(pCirc);
//STRIP001 	InsertObj(pCirc);
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaArcAction& rAct)
//STRIP001 {
//STRIP001 	Point aCenter(rAct.GetRect().Center());
//STRIP001 	long nStart=GetAngle(rAct.GetStartPoint()-aCenter);
//STRIP001 	long nEnd=GetAngle(rAct.GetEndPoint()-aCenter);
//STRIP001 	SdrCircObj* pCirc=new SdrCircObj(OBJ_CARC,rAct.GetRect(),nStart,nEnd);
//STRIP001 	SetAttributes(pCirc);
//STRIP001 	InsertObj(pCirc);
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaPieAction& rAct)
//STRIP001 {
//STRIP001 	Point aCenter(rAct.GetRect().Center());
//STRIP001 	long nStart=GetAngle(rAct.GetStartPoint()-aCenter);
//STRIP001 	long nEnd=GetAngle(rAct.GetEndPoint()-aCenter);
//STRIP001 	SdrCircObj* pCirc=new SdrCircObj(OBJ_SECT,rAct.GetRect(),nStart,nEnd);
//STRIP001 	SetAttributes(pCirc);
//STRIP001 	InsertObj(pCirc);
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaChordAction& rAct)
//STRIP001 {
//STRIP001 	Point aCenter(rAct.GetRect().Center());
//STRIP001 	long nStart=GetAngle(rAct.GetStartPoint()-aCenter);
//STRIP001 	long nEnd=GetAngle(rAct.GetEndPoint()-aCenter);
//STRIP001 	SdrCircObj* pCirc=new SdrCircObj(OBJ_CCUT,rAct.GetRect(),nStart,nEnd);
//STRIP001 	SetAttributes(pCirc);
//STRIP001 	InsertObj(pCirc);
//STRIP001 }
//STRIP001 
//STRIP001 /**************************************************************************************************/
//STRIP001 
//STRIP001 sal_Bool ImpSdrGDIMetaFileImport::CheckLastLineMerge(const XPolygon& rSrcPoly)
//STRIP001 {
//STRIP001 	if ( bLastObjWasLine && ( aOldLineColor == aVD.GetLineColor() ) && rSrcPoly.GetPointCount() )
//STRIP001 	{
//STRIP001 		SdrObject*  pTmpObj  = aTmpList.GetObj( aTmpList.GetObjCount() - 1 );
//STRIP001 		SdrPathObj* pLastPoly=PTR_CAST(SdrPathObj,pTmpObj);
//STRIP001 		if ( pLastPoly ) 
//STRIP001 		{
//STRIP001 			if (pLastPoly->GetPathPoly().Count()==1)
//STRIP001 			{
//STRIP001 				sal_Bool bOk = sal_False;
//STRIP001 				XPolygon aDstPoly(pLastPoly->GetPathPoly()[0]);
//STRIP001 				sal_uInt16 i, nMaxDstPnt=aDstPoly.GetPointCount();
//STRIP001 				if (nMaxDstPnt!=0)
//STRIP001 				{
//STRIP001 					nMaxDstPnt--;
//STRIP001 					sal_uInt16 nMaxSrcPnt = sal_uInt16( rSrcPoly.GetPointCount() - 1 );
//STRIP001 					if (aDstPoly[nMaxDstPnt]==rSrcPoly[0])
//STRIP001 					{
//STRIP001 						aDstPoly.Remove(nMaxDstPnt,1); // der ist sonst doppelt
//STRIP001 						aDstPoly.Insert(nMaxDstPnt,rSrcPoly);
//STRIP001 						bOk = sal_True;
//STRIP001 					}
//STRIP001 					else if (aDstPoly[0]==rSrcPoly[nMaxSrcPnt])
//STRIP001 					{
//STRIP001 						aDstPoly.Remove(0,1); // der ist sonst doppelt
//STRIP001 						aDstPoly.Insert(0,rSrcPoly);
//STRIP001 						bOk = sal_True;
//STRIP001 					}
//STRIP001 					else if (aDstPoly[0]==rSrcPoly[0])
//STRIP001 					{
//STRIP001 						for ( i = 1; i <= nMaxSrcPnt; i++ )
//STRIP001 						{
//STRIP001 							aDstPoly.Insert(0,rSrcPoly[i],rSrcPoly.GetFlags(i));
//STRIP001 						}
//STRIP001 						bOk = sal_True;
//STRIP001 					}
//STRIP001 					else if (aDstPoly[nMaxDstPnt]==rSrcPoly[nMaxSrcPnt])
//STRIP001 					{
//STRIP001 						for ( i = 0; i<nMaxSrcPnt; i++ )
//STRIP001 						{
//STRIP001 							aDstPoly.Insert(nMaxDstPnt+1,rSrcPoly[i],rSrcPoly.GetFlags(i));
//STRIP001 						}
//STRIP001 						bOk = sal_True;
//STRIP001 					}
//STRIP001 				}
//STRIP001 				if ( bOk )
//STRIP001 				{
//STRIP001 					pLastPoly->NbcSetPathPoly(XPolyPolygon(aDstPoly));
//STRIP001 				}
//STRIP001 				return bOk;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return FALSE;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool ImpSdrGDIMetaFileImport::CheckLastPolyLineAndFillMerge( const XPolyPolygon& rPoly )
//STRIP001 {
//STRIP001 	if ( bLastObjWasPolyWithoutLine )
//STRIP001 	{
//STRIP001 		SdrObject* pTmpObj=aTmpList.GetObj(aTmpList.GetObjCount()-1);
//STRIP001 		SdrPathObj* pLastPoly=PTR_CAST(SdrPathObj,pTmpObj);
//STRIP001 		if ( pLastPoly )
//STRIP001 		{
//STRIP001 			if (pLastPoly->GetPathPoly()==rPoly)
//STRIP001 			{
//STRIP001 				SetAttributes(NULL);
//STRIP001 				if (!bNoLine && bNoFill)
//STRIP001 				{
//STRIP001 					pLastPoly->SetItemSet(*pLineAttr);
//STRIP001 					return sal_True;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return sal_False;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction( MetaPolyLineAction& rAct )
//STRIP001 {
//STRIP001 	XPolygon aXP( rAct.GetPolygon() );
//STRIP001 	aXP.Scale( fScaleX, fScaleY );
//STRIP001 	aXP.Translate( aOfs );
//STRIP001 
//STRIP001 	const LineInfo& rLineInfo = rAct.GetLineInfo();
//STRIP001 	sal_Int32 nNewLineWidth = rLineInfo.GetWidth();
//STRIP001 	sal_Bool bCreateLineObject = sal_True;
//STRIP001 
//STRIP001 	if ( bLastObjWasLine && ( nNewLineWidth == nLineWidth ) && CheckLastLineMerge( aXP ) )
//STRIP001 		bCreateLineObject = sal_False;
//STRIP001 	else if ( bLastObjWasPolyWithoutLine && CheckLastPolyLineAndFillMerge( XPolyPolygon( aXP ) ) ) 
//STRIP001 		bCreateLineObject = sal_False;
//STRIP001 	
//STRIP001 	nLineWidth = nNewLineWidth;
//STRIP001 
//STRIP001 	if ( bCreateLineObject )
//STRIP001 	{
//STRIP001 		SdrPathObj* pPath = new SdrPathObj( OBJ_PLIN, XPolyPolygon( aXP ) );
//STRIP001 		SetAttributes( pPath );
//STRIP001 		InsertObj( pPath, sal_False );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction( MetaPolygonAction& rAct )
//STRIP001 {
//STRIP001 	XPolygon aXP( rAct.GetPolygon() );
//STRIP001 	if ( aXP.GetPointCount() != 0 )
//STRIP001 	{
//STRIP001 		aXP.Scale( fScaleX, fScaleY );
//STRIP001 		aXP.Translate( aOfs );
//STRIP001 
//STRIP001 		if ( !bLastObjWasPolyWithoutLine || !CheckLastPolyLineAndFillMerge( XPolyPolygon( aXP ) ) )
//STRIP001 		{
//STRIP001 			SdrPathObj* pPath = new SdrPathObj( OBJ_POLY, XPolyPolygon( aXP ) );
//STRIP001 			SetAttributes( pPath );
//STRIP001 			InsertObj( pPath, sal_False );
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaPolyPolygonAction& rAct)
//STRIP001 {
//STRIP001 	XPolyPolygon aXPP( rAct.GetPolyPolygon() );
//STRIP001 	sal_uInt16 nPolyNum, nPolyAnz = aXPP.Count();
//STRIP001 	for ( nPolyNum = nPolyAnz; nPolyNum > 0; )
//STRIP001 	{
//STRIP001 		nPolyNum--;
//STRIP001 		sal_uInt16 nPntAnz = aXPP[ nPolyNum ].GetPointCount();
//STRIP001 		if ( !nPntAnz )
//STRIP001 			aXPP.Remove( nPolyNum ); // leere Polys entfernen
//STRIP001 	}
//STRIP001 	if ( aXPP.Count() )
//STRIP001 	{
//STRIP001 		aXPP.Scale( fScaleX, fScaleY );
//STRIP001 		aXPP.Translate( aOfs );
//STRIP001 		if ( !bLastObjWasPolyWithoutLine || !CheckLastPolyLineAndFillMerge( XPolyPolygon( aXPP ) ) )
//STRIP001 		{
//STRIP001 			SdrPathObj* pPath = new SdrPathObj( OBJ_POLY, aXPP );
//STRIP001 			SetAttributes( pPath );
//STRIP001 			InsertObj( pPath, sal_False );
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /**************************************************************************************************/
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::ImportText( const Point& rPos, const XubString& rStr, const MetaAction& rAct )
//STRIP001 {
//STRIP001 	// calc text box size, add 5% to make it fit safely
//STRIP001 
//STRIP001 	FontMetric aFontMetric( aVD.GetFontMetric() );
//STRIP001 	Font aFnt( aVD.GetFont() );
//STRIP001 	FontAlign eAlg( aFnt.GetAlign() );
//STRIP001 
//STRIP001     sal_Int32 nTextWidth = (sal_Int32)( aVD.GetTextWidth( rStr ) * fScaleX );
//STRIP001     sal_Int32 nTextHeight = (sal_Int32)( aVD.GetTextHeight() * fScaleY );
//STRIP001 	sal_Int32 nDxWidth = 0;
//STRIP001 	sal_Int32 nLen = rStr.Len();
//STRIP001 
//STRIP001 	Point aPos( rPos.X() * fScaleX + aOfs.X(), rPos.Y() * fScaleY + aOfs.Y() );
//STRIP001     Size aSize( nTextWidth, nTextHeight );
//STRIP001 	
//STRIP001 	if ( eAlg == ALIGN_BASELINE )
//STRIP001 		aPos.Y() -= aFontMetric.GetAscent() * fScaleY;
//STRIP001 	else if ( eAlg == ALIGN_BOTTOM )
//STRIP001 		aPos.Y() -= nTextHeight;
//STRIP001 
//STRIP001 	Rectangle aTextRect( aPos, aSize );
//STRIP001 	SdrRectObj* pText =new SdrRectObj( OBJ_TEXT, aTextRect );
//STRIP001 	
//STRIP001 	if ( aFnt.GetWidth() || ( rAct.GetType() == META_STRETCHTEXT_ACTION ) )
//STRIP001 	{
//STRIP001 		pText->ClearItem( SDRATTR_TEXT_AUTOGROWWIDTH );
//STRIP001 		pText->SetItem( SdrTextAutoGrowHeightItem( FALSE ) );
//STRIP001 		pText->SetItem( SdrTextFitToSizeTypeItem( SDRTEXTFIT_ALLLINES ) );
//STRIP001 	}
//STRIP001 	else
//STRIP001 		pText->SetItem( SdrTextAutoGrowWidthItem( sal_True ) );
//STRIP001 
//STRIP001 	pText->SetModel( pModel );
//STRIP001 	pText->SetLayer( nLayer );
//STRIP001 	pText->NbcSetText( rStr );
//STRIP001 	SetAttributes( pText, TRUE );
//STRIP001 	pText->SetSnapRect( aTextRect );
//STRIP001 	
//STRIP001 	if (!aFnt.IsTransparent())
//STRIP001 	{
//STRIP001 		SfxItemSet aAttr(*pFillAttr->GetPool(),XATTR_FILL_FIRST,XATTR_FILL_LAST);
//STRIP001 		pFillAttr->Put(XFillStyleItem(XFILL_SOLID));
//STRIP001 		pFillAttr->Put(XFillColorItem(String(), aFnt.GetFillColor()));
//STRIP001 		pText->SetItemSet(aAttr);
//STRIP001 	}
//STRIP001 	sal_uInt32 nWink = aFnt.GetOrientation();
//STRIP001 	if ( nWink )
//STRIP001 	{
//STRIP001 		nWink*=10;
//STRIP001 		double a=nWink*nPi180;
//STRIP001 		double nSin=sin(a);
//STRIP001 		double nCos=cos(a);
//STRIP001 		pText->NbcRotate(aPos,nWink,nSin,nCos);
//STRIP001 	}
//STRIP001 	InsertObj( pText, sal_False );
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaTextAction& rAct)
//STRIP001 {
//STRIP001 	XubString aStr(rAct.GetText());
//STRIP001 	aStr.Erase(0,rAct.GetIndex());
//STRIP001 	aStr.Erase(rAct.GetLen());
//STRIP001 	ImportText( rAct.GetPoint(), aStr, rAct );
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaTextArrayAction& rAct)
//STRIP001 {
//STRIP001 	XubString aStr(rAct.GetText());
//STRIP001 	aStr.Erase(0,rAct.GetIndex());
//STRIP001 	aStr.Erase(rAct.GetLen());
//STRIP001 	ImportText( rAct.GetPoint(), aStr, rAct );
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaStretchTextAction& rAct)
//STRIP001 {
//STRIP001 	XubString aStr(rAct.GetText());
//STRIP001 	aStr.Erase(0,rAct.GetIndex());
//STRIP001 	aStr.Erase(rAct.GetLen());
//STRIP001 	ImportText( rAct.GetPoint(), aStr, rAct );
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaBmpAction& rAct)
//STRIP001 {
//STRIP001 	Rectangle aRect(rAct.GetPoint(),rAct.GetBitmap().GetSizePixel());
//STRIP001 	aRect.Right()++; aRect.Bottom()++;
//STRIP001 	SdrGrafObj* pGraf=new SdrGrafObj(Graphic(rAct.GetBitmap()),aRect);
//STRIP001 	InsertObj(pGraf);
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaBmpScaleAction& rAct)
//STRIP001 {
//STRIP001 	Rectangle aRect(rAct.GetPoint(),rAct.GetSize());
//STRIP001 	aRect.Right()++; aRect.Bottom()++;
//STRIP001 	SdrGrafObj* pGraf=new SdrGrafObj(Graphic(rAct.GetBitmap()),aRect);
//STRIP001 	InsertObj(pGraf);
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaBmpExAction& rAct)
//STRIP001 {
//STRIP001 	Rectangle aRect(rAct.GetPoint(),rAct.GetBitmapEx().GetSizePixel());
//STRIP001 	aRect.Right()++; aRect.Bottom()++;
//STRIP001 	SdrGrafObj* pGraf=new SdrGrafObj( rAct.GetBitmapEx(), aRect );
//STRIP001 	InsertObj(pGraf);
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaBmpExScaleAction& rAct)
//STRIP001 {
//STRIP001 	Rectangle aRect(rAct.GetPoint(),rAct.GetSize());
//STRIP001 	aRect.Right()++; aRect.Bottom()++;
//STRIP001 	SdrGrafObj* pGraf=new SdrGrafObj( rAct.GetBitmapEx(), aRect );
//STRIP001 	InsertObj(pGraf);
//STRIP001 }
//STRIP001 
//STRIP001 ////////////////////////////////////////////////////////////////////////////////////////////////////
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction( MetaHatchAction& rAct )
//STRIP001 {
//STRIP001 	XPolyPolygon aXPP(rAct.GetPolyPolygon());
//STRIP001 	sal_uInt16 nPolyNum, nPolyAnz=aXPP.Count();
//STRIP001 	for ( nPolyNum = nPolyAnz; nPolyNum > 0; )
//STRIP001 	{
//STRIP001 		nPolyNum--;
//STRIP001 		sal_uInt16 nPntAnz = aXPP[ nPolyNum ].GetPointCount();
//STRIP001 		if ( nPntAnz > 0 ) 
//STRIP001 		{
//STRIP001 			Point aPt( aXPP[ nPolyNum ][ 0 ] );
//STRIP001 			if ( aPt == aXPP[ nPolyNum ][ nPntAnz - 1 ] ) 
//STRIP001 			{	// close polygon
//STRIP001 				aXPP[nPolyNum].Insert(nPntAnz,aPt,XPOLY_NORMAL);
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else 
//STRIP001 		{
//STRIP001 			aXPP.Remove( nPolyNum ); // leere Polys entfernen
//STRIP001 		}
//STRIP001 	}
//STRIP001 	if( aXPP.Count() )
//STRIP001 	{
//STRIP001 		aXPP.Scale( fScaleX, fScaleY );
//STRIP001 		aXPP.Translate( aOfs );
//STRIP001 
//STRIP001 		if ( !bLastObjWasPolyWithoutLine || !CheckLastPolyLineAndFillMerge( XPolyPolygon( aXPP ) ) )
//STRIP001 		{
//STRIP001 			const Hatch&	rHatch = rAct.GetHatch();
//STRIP001 			SdrPathObj*		pPath = new SdrPathObj( OBJ_POLY, aXPP );
//STRIP001 			SfxItemSet		aHatchAttr( pModel->GetItemPool(),
//STRIP001 										XATTR_FILLSTYLE, XATTR_FILLSTYLE,
//STRIP001 										XATTR_FILLHATCH, XATTR_FILLHATCH, 0 );
//STRIP001 			XHatchStyle		eStyle;
//STRIP001 
//STRIP001 			switch( rHatch.GetStyle() )
//STRIP001 			{
//STRIP001 				case( HATCH_TRIPLE ): eStyle = XHATCH_TRIPLE; break;
//STRIP001 				case( HATCH_DOUBLE ): eStyle = XHATCH_DOUBLE; break;
//STRIP001 				default: eStyle = XHATCH_SINGLE; break;
//STRIP001 			}
//STRIP001 
//STRIP001 			SetAttributes( pPath );
//STRIP001 			aHatchAttr.Put( XFillStyleItem( XFILL_HATCH ) );
//STRIP001 			aHatchAttr.Put( XFillHatchItem( &pModel->GetItemPool(), XHatch( rHatch.GetColor(), eStyle,
//STRIP001 															  rHatch.GetDistance(), rHatch.GetAngle() ) ) );
//STRIP001 			pPath->SetItemSet( aHatchAttr );
//STRIP001 			InsertObj( pPath, sal_False );
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 ////////////////////////////////////////////////////////////////////////////////////////////////////
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaLineColorAction& rAct)
//STRIP001 {
//STRIP001 	rAct.Execute(&aVD);
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction(MetaMapModeAction& rAct)
//STRIP001 {
//STRIP001 	MapScaling();
//STRIP001 	rAct.Execute(&aVD);
//STRIP001 	bLastObjWasPolyWithoutLine=FALSE;
//STRIP001 	bLastObjWasLine=FALSE;
//STRIP001 }
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::MapScaling()
//STRIP001 {
//STRIP001 	sal_uInt32 i, nAnz = aTmpList.GetObjCount();
//STRIP001 	const MapMode& rMap = aVD.GetMapMode();
//STRIP001 	Point aMapOrg( rMap.GetOrigin() );
//STRIP001 	sal_Bool bMov = aMapOrg.X() != 0 || aMapOrg.Y() != 0;
//STRIP001 	if ( bMov )
//STRIP001     {
//STRIP001 		for ( i = nMapScalingOfs; i < nAnz; i++ )
//STRIP001         {
//STRIP001 			SdrObject* pObj = aTmpList.GetObj(i);
//STRIP001 			if ( bMov )
//STRIP001 				pObj->NbcMove( Size( aMapOrg.X(), aMapOrg.Y() ) );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	nMapScalingOfs = nAnz;
//STRIP001 }
//STRIP001 
//STRIP001 ////////////////////////////////////////////////////////////////////////////////////////////////////
//STRIP001 
//STRIP001 void ImpSdrGDIMetaFileImport::DoAction( MetaCommentAction& rAct, GDIMetaFile* pMtf )
//STRIP001 {
//STRIP001 	ByteString aSkipComment;
//STRIP001 
//STRIP001 	if( rAct.GetComment().CompareIgnoreCaseToAscii( "XGRAD_SEQ_BEGIN" ) == COMPARE_EQUAL )
//STRIP001 	{
//STRIP001 		MetaGradientExAction* pAct = (MetaGradientExAction*) pMtf->NextAction();
//STRIP001 
//STRIP001 		if( pAct && pAct->GetType() == META_GRADIENTEX_ACTION )
//STRIP001 		{
//STRIP001 			XPolyPolygon	aXPP(pAct->GetPolyPolygon());
//STRIP001 			USHORT			nPolyAnz=aXPP.Count();
//STRIP001 			
//STRIP001 			for( USHORT nPolyNum= nPolyAnz; nPolyNum > 0; ) 
//STRIP001 			{
//STRIP001 				nPolyNum--;
//STRIP001 				USHORT nPntAnz=aXPP[nPolyNum].GetPointCount();
//STRIP001 				if (nPntAnz>0) 
//STRIP001 				{
//STRIP001 					Point aPt(aXPP[nPolyNum][0]);
//STRIP001 					if (aPt==aXPP[nPolyNum][nPntAnz-1]) 
//STRIP001 						aXPP[nPolyNum].Insert(nPntAnz,aPt,XPOLY_NORMAL);
//STRIP001 				}
//STRIP001 				else 
//STRIP001 					aXPP.Remove(nPolyNum);
//STRIP001 			}
//STRIP001 			
//STRIP001 			if( aXPP.Count()!=0 )
//STRIP001 			{
//STRIP001 				if (!bLastObjWasPolyWithoutLine || !CheckLastPolyLineAndFillMerge(XPolyPolygon(aXPP)))
//STRIP001 				{
//STRIP001 					const Gradient&	rGrad = pAct->GetGradient();
//STRIP001 					SdrPathObj*		pPath=new SdrPathObj(OBJ_POLY,aXPP);
//STRIP001 					SfxItemSet		aGradAttr( pModel->GetItemPool(), 
//STRIP001 											   XATTR_FILLSTYLE, XATTR_FILLSTYLE,
//STRIP001 											   XATTR_FILLGRADIENT, XATTR_FILLGRADIENT, 0 );
//STRIP001 					XGradient		aXGradient;
//STRIP001 
//STRIP001 					aXGradient.SetGradientStyle((XGradientStyle)rGrad.GetStyle());
//STRIP001 					aXGradient.SetStartColor(rGrad.GetStartColor());
//STRIP001 					aXGradient.SetEndColor(rGrad.GetEndColor());
//STRIP001 					aXGradient.SetAngle((USHORT)rGrad.GetAngle());
//STRIP001 					aXGradient.SetBorder(rGrad.GetBorder());
//STRIP001 					aXGradient.SetXOffset(rGrad.GetOfsX());
//STRIP001 					aXGradient.SetYOffset(rGrad.GetOfsY());
//STRIP001 					aXGradient.SetStartIntens(rGrad.GetStartIntensity());
//STRIP001 					aXGradient.SetEndIntens(rGrad.GetEndIntensity());
//STRIP001 					aXGradient.SetSteps(rGrad.GetSteps());
//STRIP001 					SetAttributes( pPath );
//STRIP001 					aGradAttr.Put( XFillStyleItem( XFILL_GRADIENT ) );
//STRIP001 					aGradAttr.Put( XFillGradientItem( &pModel->GetItemPool(), aXGradient ) );
//STRIP001 					pPath->SetItemSet(aGradAttr);
//STRIP001 					InsertObj(pPath);
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			aSkipComment = "XGRAD_SEQ_END";
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if(aSkipComment.Len())
//STRIP001 	{
//STRIP001 		MetaAction* pSkipAct = pMtf->NextAction();
//STRIP001 
//STRIP001 		while( pSkipAct 
//STRIP001 			&& ((pSkipAct->GetType() != META_COMMENT_ACTION ) 
//STRIP001 				|| (((MetaCommentAction*)pSkipAct)->GetComment().CompareIgnoreCaseToAscii(aSkipComment.GetBuffer()) != COMPARE_EQUAL)))
//STRIP001 		{
//STRIP001 			pSkipAct = pMtf->NextAction();
//STRIP001 		}
//STRIP001 	}
//STRIP001 }

}
