/*************************************************************************
 *
 *  $RCSfile: svx_tbxalign.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 16:37:54 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SFXENUMITEM_HXX
#include <svtools/eitem.hxx>
#endif
#pragma hdrstop

// auto strip #include "dialmgr.hxx"
#include "dialogs.hrc"

#include "tbxalign.hxx"

#ifndef _SVTOOLS_IMGDEF_HXX
#include <svtools/imgdef.hxx>
#endif

#include "tbxdraw.hxx"
#include "tbxdraw.hrc"

// auto strip #ifndef _SHL_HXX //autogen
// auto strip #include <tools/shl.hxx>
// auto strip #endif
namespace binfilter {

/*N*/ SFX_IMPL_TOOLBOX_CONTROL(SvxTbxCtlAlign, SfxEnumItem);

/*************************************************************************
|*
|* Klasse fuer SwToolbox
|*
\************************************************************************/

/*?*/ SvxTbxCtlAlign::SvxTbxCtlAlign( USHORT nId, ToolBox& rTbx, SfxBindings& rBindings ) :
/*?*/ 
/*?*/ 	SfxToolBoxControl( nId, rTbx, rBindings )
/*?*/ 
/*?*/ {
/*?*/ }

//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Wenn man ein PopupWindow erzeugen will
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SfxPopupWindowType SvxTbxCtlAlign::GetPopupWindowType() const
//STRIP001 {
//STRIP001 	return(SFX_POPUPWINDOW_ONCLICK);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Hier wird das Fenster erzeugt
//STRIP001 |* Lage der Toolbox mit GetToolBox() abfragbar
//STRIP001 |* rItemRect sind die Screen-Koordinaten
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SfxPopupWindow*	SvxTbxCtlAlign::CreatePopupWindow()
//STRIP001 {
//STRIP001 	if ( GetId() == SID_OBJECT_ALIGN )
//STRIP001 	{
//STRIP001 		SvxPopupWindowTbxMgr* pWin =
//STRIP001 			new SvxPopupWindowTbxMgr( GetId(), this,
//STRIP001 									  SVX_RES( RID_SVXTBX_ALIGNMENT ),
//STRIP001 									  SVX_RES( TBX_ALIGNMENT ),
//STRIP001 									  GetBindings() );
//STRIP001 		pWin->StartPopupMode( &GetToolBox(), TRUE );
//STRIP001 		pWin->StartSelection();
//STRIP001 		pWin->Show();
//STRIP001 		return pWin;
//STRIP001 	}
//STRIP001 	return NULL;
//STRIP001 }


}
