/*************************************************************************
 *
 *  $RCSfile: sw_edfcol.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 17:20:12 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#include <hintids.hxx>

// auto strip #ifndef _SVX_BRKITEM_HXX //autogen
// auto strip #include <bf_svx/brkitem.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #ifndef _EDITSH_HXX
// auto strip #include <editsh.hxx>
// auto strip #endif
// auto strip #ifndef _DOC_HXX
// auto strip #include <doc.hxx>		// fuer SwTxtFmtColls
// auto strip #endif
#ifndef _EDIMP_HXX
#include <edimp.hxx>	// fuer MACROS
#endif
// auto strip #ifndef _FMTCOL_HXX
// auto strip #include <fmtcol.hxx>	// fuer SwXXXFmtColl
// auto strip #endif
// auto strip #ifndef _NDTXT_HXX
// auto strip #include <ndtxt.hxx>
// auto strip #endif
// auto strip #ifndef _PARATR_HXX
// auto strip #include <paratr.hxx>
// auto strip #endif
// auto strip #ifndef _FMTPDSC_HXX //autogen
// auto strip #include <fmtpdsc.hxx>
// auto strip #endif
namespace binfilter {

/*************************************
 * FormatColl
 *************************************/
// TXT


//STRIP001 SwTxtFmtColl& SwEditShell::GetDfltTxtFmtColl() const
//STRIP001 {
//STRIP001 	return *((SwTxtFmtColl*) (GetDoc()->GetDfltTxtFmtColl()));
//STRIP001 }


//STRIP001 USHORT SwEditShell::GetTxtFmtCollCount() const
//STRIP001 {
//STRIP001 	return GetDoc()->GetTxtFmtColls()->Count();
//STRIP001 }


//STRIP001 SwTxtFmtColl& SwEditShell::GetTxtFmtColl( USHORT nFmtColl) const
//STRIP001 {
//STRIP001 	return *((*(GetDoc()->GetTxtFmtColls()))[nFmtColl]);
//STRIP001 }


//STRIP001 void SwEditShell::SetTxtFmtColl(SwTxtFmtColl *pFmt)
//STRIP001 {
//STRIP001 	SwTxtFmtColl *pLocal = pFmt? pFmt: (*GetDoc()->GetTxtFmtColls())[0];
//STRIP001 	StartAllAction();
//STRIP001 	GetDoc()->StartUndo();
//STRIP001 	FOREACHPAM_START(this)
//STRIP001 
//STRIP001 		if( !PCURCRSR->HasReadonlySel() )
//STRIP001 			GetDoc()->SetTxtFmtColl(*PCURCRSR, pLocal);
//STRIP001 
//STRIP001 	FOREACHPAM_END()
//STRIP001 	GetDoc()->EndUndo();
//STRIP001 	EndAllAction();
//STRIP001 
//STRIP001 }


//STRIP001 SwTxtFmtColl* SwEditShell::MakeTxtFmtColl(const String& rFmtCollName,
//STRIP001 		SwTxtFmtColl* pParent)
//STRIP001 {
//STRIP001 	SwTxtFmtColl *pColl;
//STRIP001 	if ( pParent == 0 )
//STRIP001 		pParent = &GetTxtFmtColl(0);
//STRIP001 	if (  (pColl=GetDoc()->MakeTxtFmtColl(rFmtCollName, pParent)) == 0 )
//STRIP001 		ASSERT( FALSE, "MakeTxtFmtColl failed" );
//STRIP001 	return pColl;
//STRIP001 
//STRIP001 }


//STRIP001 void SwEditShell::FillByEx(SwTxtFmtColl* pColl, BOOL bReset)
//STRIP001 {
//STRIP001 	if( bReset )
//STRIP001 		pColl->ResetAllAttr();
//STRIP001 
//STRIP001 	const SfxItemSet* pSet = GetCrsr()->GetCntntNode()->GetpSwAttrSet();
//STRIP001 	if( pSet )
//STRIP001 	{
//STRIP001 		// JP 05.10.98: falls eines der Attribute Break/PageDesc/NumRule(auto)
//STRIP001 		//		im ItemSet steht, so entferne die VORM setzen an der Collection.
//STRIP001 		//		Ansonst wird zu viel gemacht oder falsche gemacht (NumRules!)
//STRIP001 		//		Bug 57568
//STRIP001 
//STRIP001 		// AutoNumRules NICHT in die Vorlagen uebernehmen
//STRIP001 		const SfxPoolItem* pItem;
//STRIP001 		const SwNumRule* pRule = 0;
//STRIP001 		if( SFX_ITEM_SET == pSet->GetItemState( RES_BREAK, FALSE ) ||
//STRIP001 			SFX_ITEM_SET == pSet->GetItemState( RES_PAGEDESC,FALSE ) ||
//STRIP001 			( SFX_ITEM_SET == pSet->GetItemState( RES_PARATR_NUMRULE,
//STRIP001 				FALSE, &pItem ) && 0 != (pRule = GetDoc()->FindNumRulePtr(
//STRIP001 				((SwNumRuleItem*)pItem)->GetValue() )) &&
//STRIP001 				pRule && pRule->IsAutoRule() )
//STRIP001 			)
//STRIP001 		{
//STRIP001 			SfxItemSet aSet( *pSet );
//STRIP001 			aSet.ClearItem( RES_BREAK );
//STRIP001 			aSet.ClearItem( RES_PAGEDESC );
//STRIP001 
//STRIP001 			if( pRule || (SFX_ITEM_SET == pSet->GetItemState( RES_PARATR_NUMRULE,
//STRIP001 				FALSE, &pItem ) && 0 != (pRule = GetDoc()->FindNumRulePtr(
//STRIP001 				((SwNumRuleItem*)pItem)->GetValue() )) &&
//STRIP001 				pRule && pRule->IsAutoRule() ))
//STRIP001 				aSet.ClearItem( RES_PARATR_NUMRULE );
//STRIP001 
//STRIP001 			if( aSet.Count() )
//STRIP001 				pColl->SetAttr( aSet );
//STRIP001 		}
//STRIP001 		else
//STRIP001 			pColl->SetAttr( *pSet );
//STRIP001 	}
//STRIP001 }




}
