/*************************************************************************
 *
 *  $RCSfile: sw_unbkmk.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 18:03:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif
// auto strip #include "doc.hxx"
// auto strip #include "docary.hxx"
#include "swundo.hxx"			// fuer die UndoIds
#ifndef _ERRHDL_HXX
#include <errhdl.hxx>
#endif
// auto strip #include "pam.hxx"

#include "undobj.hxx"
#include "bookmrk.hxx"
#include "rolbck.hxx"
namespace binfilter {



//STRIP001 inline SwDoc& SwUndoIter::GetDoc() const { return *pAktPam->GetDoc(); }


/*N*/ SwUndoBookmark::SwUndoBookmark( USHORT nUndoId, const SwBookmark& rBkmk )
/*N*/ 	: SwUndo( nUndoId )
/*N*/ {
/*N*/ 	int nType = SwHstryBookmark::BKMK_POS;
/*N*/ 	if( rBkmk.GetOtherPos() )
/*?*/ 		nType |= SwHstryBookmark::BKMK_OTHERPOS;
/*N*/ 	pHBookmark = new SwHstryBookmark( rBkmk, nType );
/*N*/ }



/*N*/ SwUndoBookmark::~SwUndoBookmark()
/*N*/ {
/*N*/ 	delete pHBookmark;
/*N*/ }


//STRIP001 void SwUndoBookmark::SetInDoc( SwDoc* pDoc )
//STRIP001 {
//STRIP001 	pHBookmark->SetInDoc( pDoc, FALSE );
//STRIP001 }


//STRIP001 void SwUndoBookmark::ResetInDoc( SwDoc* pDoc )
//STRIP001 {
//STRIP001 	const SwBookmarks& rBkmkTbl = pDoc->GetBookmarks();
//STRIP001 	for( USHORT n = 0; n < rBkmkTbl.Count(); ++n )
//STRIP001 		if( pHBookmark->IsEqualBookmark( *rBkmkTbl[ n ] ) )
//STRIP001 		{
//STRIP001 				pDoc->DelBookmark( n );
//STRIP001 				break;
//STRIP001 		}
//STRIP001 }



//STRIP001 SwUndoDelBookmark::SwUndoDelBookmark( const SwBookmark& rBkmk )
//STRIP001 	: SwUndoBookmark( UNDO_DELBOOKMARK, rBkmk )
//STRIP001 {
//STRIP001 }


//STRIP001 void SwUndoDelBookmark::Undo( SwUndoIter& rUndoIter )
//STRIP001 {
//STRIP001 	SetInDoc( &rUndoIter.GetDoc() );
//STRIP001 }


//STRIP001 void SwUndoDelBookmark::Redo( SwUndoIter& rUndoIter )
//STRIP001 {
//STRIP001 	ResetInDoc( &rUndoIter.GetDoc() );
//STRIP001 }


/*N*/ SwUndoInsBookmark::SwUndoInsBookmark( const SwBookmark& rBkmk )
/*N*/ 	: SwUndoBookmark( UNDO_INSBOOKMARK, rBkmk )
/*N*/ {
/*N*/ }


//STRIP001 void SwUndoInsBookmark::Undo( SwUndoIter& rUndoIter )
//STRIP001 {
//STRIP001 	ResetInDoc( &rUndoIter.GetDoc() );
//STRIP001 }


//STRIP001 void SwUndoInsBookmark::Redo( SwUndoIter& rUndoIter )
//STRIP001 {
//STRIP001 	SetInDoc( &rUndoIter.GetDoc() );
//STRIP001 }


}
