/*************************************************************************
 *
 *  $RCSfile: envlop.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 18:57:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _ENVLOP_HXX
#define _ENVLOP_HXX

#ifndef _SV_MEDIT_HXX
#include <svtools/svmedit.hxx>
#endif

// auto strip #ifndef _SFXTABDLG_HXX //autogen
// auto strip #include <bf_sfx2/tabdlg.hxx>
// auto strip #endif

// auto strip #ifndef _FIXED_HXX //autogen
// auto strip #include <vcl/fixed.hxx>
// auto strip #endif

// auto strip #ifndef _EDIT_HXX //autogen
// auto strip #include <vcl/edit.hxx>
// auto strip #endif

// auto strip #ifndef _LSTBOX_HXX //autogen
// auto strip #include <vcl/lstbox.hxx>
// auto strip #endif

// auto strip #ifndef _IMAGEBTN_HXX //autogen
// auto strip #include <vcl/imagebtn.hxx>
// auto strip #endif

// auto strip #include "envimg.hxx"
class Printer; 
namespace binfilter {

#define GetFldVal(rField)         (rField).Denormalize((rField).GetValue(FUNIT_TWIP))
#define SetFldVal(rField, lValue) (rField).SetValue((rField).Normalize(lValue), FUNIT_TWIP)

class SwEnvPage;
class SwEnvFmtPage;
class SwWrtShell;


// class SwEnvPreview ---------------------------------------------------------

//STRIP001 class SwEnvPreview : public Window
//STRIP001 {
//STRIP001 	void Paint(const Rectangle&);
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 	 SwEnvPreview(SfxTabPage* pParent, const ResId& rResID);
//STRIP001 	~SwEnvPreview();
//STRIP001 
//STRIP001 protected:
//STRIP001     virtual void DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 };

// class SwEnvDlg -----------------------------------------------------------

//STRIP001 class SwEnvDlg : public SfxTabDialog
//STRIP001 {
//STRIP001 friend class SwEnvPage;
//STRIP001 friend class SwEnvFmtPage;
//STRIP001 friend class SwEnvPrtPage;
//STRIP001 friend class SwEnvPreview;

//STRIP001 	String			sInsert;
//STRIP001 	String 			sChange;
//STRIP001 	SwEnvItem		aEnvItem;
//STRIP001 	SwWrtShell		*pSh;
//STRIP001 	Printer			*pPrinter;
//STRIP001 	SfxItemSet		*pAddresseeSet;
//STRIP001 	SfxItemSet		*pSenderSet;

//STRIP001 	virtual void	PageCreated( USHORT nId, SfxTabPage &rPage );
//STRIP001 	virtual short	Ok();

//STRIP001 public:
//STRIP001 	 SwEnvDlg(Window* pParent, const SfxItemSet& rSet, SwWrtShell* pWrtSh, Printer* pPrt, BOOL bInsert);
//STRIP001 	~SwEnvDlg();
//STRIP001 };

// class SwEnvPage ----------------------------------------------------------

//STRIP001 class SwEnvPage : public SfxTabPage
//STRIP001 {
//STRIP001 	FixedText     aAddrText;
//STRIP001 	MultiLineEdit aAddrEdit;
//STRIP001 	FixedText	  aDatabaseFT;
//STRIP001 	ListBox 	  aDatabaseLB;
//STRIP001 	FixedText	  aTableFT;
//STRIP001 	ListBox 	  aTableLB;
//STRIP001 	ImageButton   aInsertBT;
//STRIP001 	FixedText	  aDBFieldFT;
//STRIP001 	ListBox 	  aDBFieldLB;
//STRIP001 	CheckBox      aSenderBox;
//STRIP001 	MultiLineEdit aSenderEdit;
//STRIP001 	SwEnvPreview  aPreview;
//STRIP001 
//STRIP001 	SwWrtShell*   pSh;
//STRIP001 	String        sActDBName;

//STRIP001 	 SwEnvPage(Window* pParent, const SfxItemSet& rSet);
//STRIP001 	~SwEnvPage();

//STRIP001 	DECL_LINK( DatabaseHdl, ListBox * );
//STRIP001 	DECL_LINK( FieldHdl, Button * );
//STRIP001 	DECL_LINK( SenderHdl, Button * );

//STRIP001 	void InitDatabaseBox();

//STRIP001 	SwEnvDlg* GetParent() {return (SwEnvDlg*) SfxTabPage::GetParent()->GetParent();}

//STRIP001 public:

//STRIP001 	static SfxTabPage* Create(Window* pParent, const SfxItemSet& rSet);

//STRIP001 	virtual void ActivatePage(const SfxItemSet& rSet);
//STRIP001 	virtual int  DeactivatePage(SfxItemSet* pSet = 0);
//STRIP001 			void FillItem(SwEnvItem& rItem);
//STRIP001 	virtual BOOL FillItemSet(SfxItemSet& rSet);
//STRIP001 	virtual void Reset(const SfxItemSet& rSet);
//STRIP001 };

} //namespace binfilter
#endif


