/*************************************************************************
 *
 *  $RCSfile: linenum.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:55:25 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SWLINENUM_HXX
#define _SWLINENUM_HXX

#ifndef _BASEDLGS_HXX //autogen
#include <bf_sfx2/basedlgs.hxx>
#endif

#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif

#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif
#ifndef _NUMBERINGTYPELISTBOX_HXX
#include <numberingtypelistbox.hxx>
#endif

#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
class Window; 
class SfxItemSet; 

namespace binfilter {

class SwView;
class SwWrtShell;

/*--------------------------------------------------------------------
   Beschreibung: SingleTabDialog
 --------------------------------------------------------------------*/

//STRIP001 class SwLineNumberingDlg : public SfxSingleTabDialog
//STRIP001 {
//STRIP001 	SwWrtShell* pSh;
//STRIP001 
//STRIP001 	DECL_LINK( OKHdl, Button * );
//STRIP001 
//STRIP001 public:
//STRIP001 	inline SwWrtShell* GetWrtShell() const { return pSh; }
//STRIP001 
//STRIP001 	 SwLineNumberingDlg(SwView *pVw);
//STRIP001 	~SwLineNumberingDlg();
//STRIP001 };

/*--------------------------------------------------------------------
   Beschreibung: TabPage
 --------------------------------------------------------------------*/

//STRIP001 class SwLineNumberingPage : public SfxTabPage
//STRIP001 {
//STRIP001 	CheckBox		aNumberingOnCB;
//STRIP001 	FixedText		aCharStyleFT;
//STRIP001 	ListBox			aCharStyleLB;
//STRIP001 	FixedText		aFormatFT;
//STRIP001 	SwNumberingTypeListBox	 aFormatLB;
//STRIP001 	FixedText		aPosFT;
//STRIP001 	ListBox			aPosLB;
//STRIP001 	FixedText		aOffsetFT;
//STRIP001 	MetricField		aOffsetMF;
//STRIP001 	FixedText		aNumIntervalFT;
//STRIP001 	NumericField	aNumIntervalNF;
//STRIP001 	FixedText		aNumRowsFT;
//STRIP001     FixedLine        aDisplayFL;
//STRIP001 	FixedText		aDivisorFT;
//STRIP001 	Edit			aDivisorED;
//STRIP001 	FixedText		aDivIntervalFT;
//STRIP001 	NumericField	aDivIntervalNF;
//STRIP001 	FixedText		aDivRowsFT;
//STRIP001     FixedLine        aDivisorFL;
//STRIP001 	CheckBox		aCountEmptyLinesCB;
//STRIP001 	CheckBox		aCountFrameLinesCB;
//STRIP001 	CheckBox		aRestartEachPageCB;
//STRIP001     FixedLine        aCountFL;
//STRIP001 
//STRIP001 	SwWrtShell*		pSh;
//STRIP001 
//STRIP001 	SwLineNumberingPage( Window* pParent, const SfxItemSet& rSet );
//STRIP001 	~SwLineNumberingPage();
//STRIP001 
//STRIP001 	DECL_LINK( LineOnOffHdl, CheckBox *pCB = 0 );
//STRIP001 	DECL_LINK( ModifyHdl, Edit *pED = 0 );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rAttrSet );
//STRIP001 
//STRIP001 	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual	void 		Reset( const SfxItemSet& rSet );
//STRIP001 };

} //namespace binfilter
#endif


