/*************************************************************************
 *
 *  $RCSfile: sw_textidx.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 19:20:52 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop
// auto strip #include <hintids.hxx>
#include <uiparam.hxx>
// auto strip #ifndef _MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
// auto strip #ifndef _SFXITEMSET_HXX //autogen
// auto strip #include <svtools/itemset.hxx>
// auto strip #endif
#ifndef _SFXVIEWFRM_HXX //autogen
#include <bf_sfx2/viewfrm.hxx>
#endif
// auto strip #ifndef _SFXSTRITEM_HXX //autogen
// auto strip #include <svtools/stritem.hxx>
// auto strip #endif

// auto strip #ifndef _OFF_APP_HXX //autogen
// auto strip #include <bf_offmgr/app.hxx>
// auto strip #endif
#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif
// auto strip #ifndef _SVX_SIZEITEM_HXX //autogen
// auto strip #include <bf_svx/sizeitem.hxx>
// auto strip #endif
// auto strip #ifndef _FMTFSIZE_HXX //autogen
// auto strip #include <fmtfsize.hxx>
// auto strip #endif
// auto strip #ifndef _FLDBAS_HXX
// auto strip #include <fldbas.hxx>
// auto strip #endif
// auto strip #ifndef _UIITEMS_HXX
// auto strip #include <uiitems.hxx>
// auto strip #endif
#include "viewopt.hxx"
#include "cmdid.h"
#include "view.hxx"

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

#include "wrtsh.hxx"
// auto strip #include "swundo.hxx"               	// fuer Undo-Ids
#include "textsh.hxx"
#include "idxmrk.hxx"
// auto strip #include "multmrk.hxx"
#include "cnttab.hxx"
// auto strip #include "toxmgr.hxx"
namespace binfilter {

// STATIC DATA -----------------------------------------------------------

//STRIP001 void SwTextShell::ExecIdx(SfxRequest &rReq)
//STRIP001 {
//STRIP001 	const SfxItemSet *pArgs = rReq.GetArgs();
//STRIP001 	const SfxPoolItem* pItem = 0;
//STRIP001 	USHORT nSlot = rReq.GetSlot();
//STRIP001 	if(pArgs)
//STRIP001 	   pArgs->GetItemState(nSlot, FALSE, &pItem );
//STRIP001 
//STRIP001 	SfxViewFrame* pVFrame = GetView().GetViewFrame();
//STRIP001 	Window *pMDI = &pVFrame->GetWindow();
//STRIP001 
//STRIP001 	switch( nSlot )
//STRIP001 	{
//STRIP001 		case FN_EDIT_AUTH_ENTRY_DLG :
//STRIP001 		{
//STRIP001 			SwAuthMarkModalDlg* pDlg = new SwAuthMarkModalDlg(pMDI, GetShell());
//STRIP001 			pDlg->Execute();
//STRIP001 			delete pDlg;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_INSERT_AUTH_ENTRY_DLG:
//STRIP001 		{
//STRIP001 			// no BASIC support
//STRIP001 			pVFrame->ToggleChildWindow(FN_INSERT_AUTH_ENTRY_DLG);
//STRIP001 
//STRIP001 			SwInsertAuthMarkWrapper *pAuthMrk = (SwInsertAuthMarkWrapper*)
//STRIP001 								pVFrame->GetChildWindow(FN_INSERT_AUTH_ENTRY_DLG);
//STRIP001 
//STRIP001 			Invalidate(rReq.GetSlot());
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_INSERT_IDX_ENTRY_DLG:
//STRIP001 		{
//STRIP001 			pVFrame->ToggleChildWindow(FN_INSERT_IDX_ENTRY_DLG);
//STRIP001 			Invalidate(rReq.GetSlot());
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_EDIT_IDX_ENTRY_DLG:
//STRIP001 		{
//STRIP001 			SwTOXMgr aMgr(GetShellPtr());
//STRIP001 			USHORT nRet = RET_OK;
//STRIP001 			if(aMgr.GetTOXMarkCount() > 1)
//STRIP001 			{	// Mehrere Marken, welche solls denn sein ?
//STRIP001 				//
//STRIP001 				SwMultiTOXMarkDlg* pMultDlg = new SwMultiTOXMarkDlg(pMDI, aMgr);
//STRIP001 				nRet = pMultDlg->Execute();
//STRIP001 				delete pMultDlg;
//STRIP001 			}
//STRIP001 			if(	nRet == RET_OK)
//STRIP001 			{
//STRIP001                 SwIndexMarkModalDlg* pDlg = new SwIndexMarkModalDlg(pMDI, GetShell(), aMgr.GetCurTOXMark());
//STRIP001 				pDlg->Execute();
//STRIP001 				delete pDlg;
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 		case FN_IDX_MARK_TO_IDX:
//STRIP001 		{
//STRIP001 			GetShell().GotoTOXMarkBase();
//STRIP001 			break;
//STRIP001 		}
//STRIP001 		case FN_INSERT_MULTI_TOX:
//STRIP001 		{
//STRIP001 			SfxItemSet aSet(GetPool(),
//STRIP001 							RES_COL, RES_COL,
//STRIP001 							RES_BACKGROUND, RES_BACKGROUND,
//STRIP001 							RES_FRM_SIZE, RES_FRM_SIZE,
//STRIP001 							SID_ATTR_PAGE_SIZE, SID_ATTR_PAGE_SIZE,
//STRIP001 							RES_LR_SPACE, RES_LR_SPACE,
//STRIP001 							FN_PARAM_TOX_TYPE, FN_PARAM_TOX_TYPE,
//STRIP001 							0	);
//STRIP001 			SwWrtShell& rSh = GetShell();
//STRIP001 			SwRect aRect;
//STRIP001 			rSh.CalcBoundRect(aRect, FLY_IN_CNTNT);
//STRIP001 
//STRIP001 			long nWidth = aRect.Width();
//STRIP001 			aSet.Put(SwFmtFrmSize(ATT_VAR_SIZE, nWidth));
//STRIP001 			// Hoehe=Breite fuer konsistentere Vorschau (analog zu Bereich bearbeiten)
//STRIP001 			aSet.Put(SvxSizeItem(SID_ATTR_PAGE_SIZE, Size(nWidth, nWidth)));
//STRIP001 			const SwTOXBase* pCurTOX = 0;
//STRIP001 			BOOL bGlobal = FALSE;
//STRIP001 			if(pItem)
//STRIP001 			{
//STRIP001 				pCurTOX = (const SwTOXBase* )((SwPtrItem*)pItem)->GetValue();
//STRIP001 				bGlobal = TRUE;
//STRIP001 			}
//STRIP001 			else
//STRIP001 				pCurTOX = rSh.GetCurTOX();
//STRIP001 			if(pCurTOX)
//STRIP001 			{
//STRIP001 				const SfxItemSet* pSet = pCurTOX->GetAttrSet();
//STRIP001 				if(pSet)
//STRIP001 					aSet.Put(*pSet);
//STRIP001 			}
//STRIP001 
//STRIP001 			SwMultiTOXTabDialog* pDlg = new SwMultiTOXTabDialog(pMDI, aSet, rSh, (SwTOXBase* )pCurTOX,
//STRIP001 																			USHRT_MAX, bGlobal);
//STRIP001 			pDlg->Execute();
//STRIP001 			delete pDlg;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_REMOVE_CUR_TOX:
//STRIP001 		{
//STRIP001 			SwWrtShell& rSh = GetShell();
//STRIP001 			const SwTOXBase* pBase = rSh.GetCurTOX();
//STRIP001 			DBG_ASSERT(pBase, "no TOXBase to remove")
//STRIP001 			if( pBase )
//STRIP001 				rSh.DeleteTOX(*pBase, TRUE);
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		default:
//STRIP001 			ASSERT(!this, falscher Dispatcher);
//STRIP001 			return;
//STRIP001 	}
//STRIP001 }


/*N*/ void SwTextShell::GetIdxState(SfxItemSet &rSet)
/*N*/ {
/*N*/ 	SwWrtShell& rSh = GetShell();
/*N*/ 	SfxViewFrame* pVFrame = GetView().GetViewFrame();
/*N*/ 	SwInsertIdxMarkWrapper *pIdxMrk = (SwInsertIdxMarkWrapper*)
/*N*/ 						pVFrame->GetChildWindow(FN_INSERT_IDX_ENTRY_DLG);
/*N*/ 
/*N*/ 	SfxChildWindow* pAuthMark = pVFrame->GetChildWindow(FN_INSERT_AUTH_ENTRY_DLG);
/*N*/ 
/*N*/ 	const BOOL bHtmlMode = 0 != ::binfilter::GetHtmlMode( GetView().GetDocShell() );
/*N*/ 	const SwTOXBase* pBase = 0;
/*N*/ 	if( bHtmlMode || 0 != ( pBase = rSh.GetCurTOX()) )
/*N*/ 	{
/*N*/ 		USHORT nBase = 0;
/*N*/ 		if( pBase )
/*N*/ 		{
/*N*/ 			if(pBase->IsTOXBaseInReadonly())
/*N*/ 			{
/*?*/ 				rSet.DisableItem( FN_INSERT_MULTI_TOX );
/*N*/ 			}
/*N*/ 		}
/*N*/ 
/*N*/ 		rSet.DisableItem( FN_EDIT_IDX_ENTRY_DLG );
/*N*/ 		rSet.DisableItem( FN_EDIT_AUTH_ENTRY_DLG );
/*N*/ 
/*N*/ 		if(!pIdxMrk)
/*N*/ 			rSet.DisableItem( FN_INSERT_IDX_ENTRY_DLG );
/*N*/ 		else
/*?*/ 			rSet.Put(SfxBoolItem(FN_INSERT_IDX_ENTRY_DLG, TRUE));
/*N*/ 
/*N*/ 		if(!pAuthMark)
/*N*/ 			rSet.DisableItem( FN_INSERT_AUTH_ENTRY_DLG );
/*N*/ 		else
/*?*/ 			rSet.Put(SfxBoolItem(FN_INSERT_AUTH_ENTRY_DLG, TRUE));
/*N*/ 
/*N*/ 	}
/*N*/ 	else //if( SFX_ITEM_UNKNOWN != rSet.GetItemState( FN_EDIT_IDX_ENTRY_DLG ))
/*N*/ 	{
/*N*/ 
/*N*/ 		BOOL bEnableEdit = TRUE;
/*N*/ 		BOOL bInReadonly = rSh.HasReadonlySel();
/*N*/ 		if( rSh.HasSelection() || bInReadonly)
/*N*/ 			bEnableEdit = FALSE;
/*N*/ 		else
/*N*/ 		{
/*N*/ 			SwTOXMarks aArr;
/*N*/ 			rSh.GetCurTOXMarks( aArr );
/*N*/ 			if( !aArr.Count())
/*N*/ 				bEnableEdit = FALSE;
/*N*/ 		}
/*N*/ 
/*N*/ 		if(!bEnableEdit)
/*N*/ 			rSet.DisableItem( FN_EDIT_IDX_ENTRY_DLG );
/*N*/ 
/*N*/ 		if(bInReadonly)
/*N*/ 		{
/*?*/ 			rSet.DisableItem(FN_INSERT_IDX_ENTRY_DLG);
/*?*/ 			rSet.DisableItem( FN_INSERT_MULTI_TOX );
/*N*/ 		}
/*N*/ 		else
/*N*/ 			rSet.Put(SfxBoolItem(FN_INSERT_IDX_ENTRY_DLG,
/*N*/ 									0 != pIdxMrk));
/*N*/ 
/*N*/ 
/*N*/ 		SwField* pField = rSh.GetCurFld();
/*N*/ 
/*N*/ 		if(bInReadonly)
/*?*/ 			rSet.DisableItem(FN_INSERT_AUTH_ENTRY_DLG);
/*N*/ 		else
/*N*/ 			rSet.Put(SfxBoolItem(FN_INSERT_AUTH_ENTRY_DLG, 0 != pAuthMark));
/*N*/ 
/*N*/ 		if(	bInReadonly || !pField ||
/*N*/ 			pField->GetTyp()->Which() != RES_AUTHORITY)
/*N*/ 			rSet.DisableItem(FN_EDIT_AUTH_ENTRY_DLG);
/*N*/ 		rSet.DisableItem(FN_REMOVE_CUR_TOX);
/*N*/ 	}
/*N*/ }

// -----------------------------------------------------------------------

}
