/*************************************************************************
 *
 *  $RCSfile: sw_txtnum.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:57:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {


//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #include <hintids.hxx>
//STRIP001 #ifndef _MSGBOX_HXX //autogen
//STRIP001 #include <vcl/msgbox.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFXREQUEST_HXX //autogen
//STRIP001 #include <bf_sfx2/request.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFXENUMITEM_HXX //autogen
//STRIP001 #include <svtools/eitem.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFXSTRITEM_HXX //autogen
//STRIP001 #include <svtools/stritem.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SVX_NUMITEM_HXX //autogen
//STRIP001 #include <bf_svx/numitem.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SVX_BRSHITEM_HXX //autogen wg. SvxBrushItem
//STRIP001 #include <bf_svx/brshitem.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #include "cmdid.h"
//STRIP001 #include "wrtsh.hxx"
//STRIP001 #include "view.hxx"
//STRIP001 #include "viewopt.hxx"
//STRIP001 #include "wdocsh.hxx"
//STRIP001 #include "textsh.hxx"
//STRIP001 #include "uiitems.hxx"
//STRIP001 #include "num.hxx"
//STRIP001 
//STRIP001 void SwTextShell::ExecEnterNum(SfxRequest &rReq)
//STRIP001 {
//STRIP001 	//wg. Aufzeichnung schon vor dem evtl. Shellwechsel
//STRIP001 	switch(rReq.GetSlot())
//STRIP001 	{
//STRIP001 	case FN_NUM_NUMBERING_ON:
//STRIP001 	{
//STRIP001         SFX_REQUEST_ARG( rReq, pItem, SfxBoolItem, FN_PARAM_1 , sal_False );
//STRIP001         BOOL bMode = !GetShell().GetCurNumRule();
//STRIP001         if ( pItem )
//STRIP001             bMode = pItem->GetValue();
//STRIP001         else
//STRIP001             rReq.AppendItem( SfxBoolItem( FN_PARAM_1, bMode ) );
//STRIP001         if ( bMode != (GetShell().GetCurNumRule()!=NULL) )
//STRIP001         {
//STRIP001             rReq.Done();
//STRIP001             if( bMode )
//STRIP001                 GetShell().NumOn();
//STRIP001             else
//STRIP001                 GetShell().DelNumRules();
//STRIP001         }
//STRIP001 	}
//STRIP001 	break;
//STRIP001 	case FN_NUM_BULLET_ON:
//STRIP001 	{
//STRIP001         SFX_REQUEST_ARG( rReq, pItem, SfxBoolItem, FN_PARAM_1 , sal_False );
//STRIP001         BOOL bMode = !GetShell().GetCurNumRule();
//STRIP001         if ( pItem )
//STRIP001             bMode = pItem->GetValue();
//STRIP001         else
//STRIP001             rReq.AppendItem( SfxBoolItem( FN_PARAM_1, bMode ) );
//STRIP001         if ( bMode != (GetShell().GetCurNumRule()!=NULL) )
//STRIP001         {
//STRIP001             rReq.Done();
//STRIP001             if( bMode )
//STRIP001                 GetShell().BulletOn();
//STRIP001             else
//STRIP001                 GetShell().DelNumRules();
//STRIP001         }
//STRIP001 	}
//STRIP001 	break;
//STRIP001 	case FN_NUMBER_BULLETS:
//STRIP001 	{
//STRIP001 		// per default TRUE, damit die Schleife im Dialog richtig arbeitet!
//STRIP001 		BOOL bHasChild = TRUE;
//STRIP001 		SfxItemSet aSet(GetPool(),
//STRIP001 				SID_HTML_MODE, SID_HTML_MODE,
//STRIP001 				SID_ATTR_NUMBERING_RULE, SID_PARAM_CUR_NUM_LEVEL,
//STRIP001 				0 );
//STRIP001 		SwDocShell* pDocSh = GetView().GetDocShell();
//STRIP001 		BOOL bHtml = 0 != PTR_CAST(SwWebDocShell, pDocSh);
//STRIP001 		const SwNumRule* pCurRule = GetShell().GetCurNumRule();
//STRIP001 		if( pCurRule )
//STRIP001 		{
//STRIP001 			SvxNumRule aRule = pCurRule->MakeSvxNumRule();
//STRIP001 
//STRIP001 			//convert type of linked bitmaps from SVX_NUM_BITMAP to (SVX_NUM_BITMAP|LINK_TOKEN)
//STRIP001 			for(USHORT i = 0; i < aRule.GetLevelCount(); i++)
//STRIP001 			{
//STRIP001 				SvxNumberFormat aFmt(aRule.GetLevel(i));
//STRIP001 				if(SVX_NUM_BITMAP == aFmt.GetNumberingType())
//STRIP001 				{
//STRIP001 					const SvxBrushItem* pBrush = aFmt.GetBrush();
//STRIP001 					const String* pLinkStr;
//STRIP001 					if(pBrush &&
//STRIP001 						0 != (pLinkStr = pBrush->GetGraphicLink()) &&
//STRIP001 							pLinkStr->Len())
//STRIP001 						aFmt.SetNumberingType(SvxExtNumType(SVX_NUM_BITMAP|LINK_TOKEN));
//STRIP001 					aRule.SetLevel(i, aFmt, aRule.Get(i) != 0);
//STRIP001 				}
//STRIP001 			}
//STRIP001 			if(bHtml)
//STRIP001 				aRule.SetFeatureFlag(NUM_ENABLE_EMBEDDED_BMP, FALSE);
//STRIP001 
//STRIP001 			aSet.Put(SvxNumBulletItem(aRule));
//STRIP001 			USHORT nLevel = GetShell().GetNumLevel( &bHasChild ) & ~NO_NUMLEVEL;
//STRIP001 			if( nLevel < MAXLEVEL )
//STRIP001 			{
//STRIP001 				nLevel = 1<<nLevel;
//STRIP001 				aSet.Put( SfxUInt16Item( SID_PARAM_CUR_NUM_LEVEL, nLevel ));
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			SwNumRule aRule( GetShell().GetUniqueNumRuleName() );
//STRIP001 			SvxNumRule aSvxRule = aRule.MakeSvxNumRule();
//STRIP001 			if(bHtml)
//STRIP001 			{
//STRIP001 				for( BYTE n = 1; n < MAXLEVEL; ++n )
//STRIP001 				{
//STRIP001 					SvxNumberFormat aFmt( aSvxRule.GetLevel( n ) );
//STRIP001 					// 1/2" fuer HTML
//STRIP001 					aFmt.SetLSpace(720);
//STRIP001 					aFmt.SetAbsLSpace(n * 720);
//STRIP001 					aSvxRule.SetLevel( n, aFmt, FALSE );
//STRIP001 				}
//STRIP001 				aSvxRule.SetFeatureFlag(NUM_ENABLE_EMBEDDED_BMP, FALSE);
//STRIP001 			}
//STRIP001 			aSet.Put(SvxNumBulletItem(aSvxRule));
//STRIP001 		}
//STRIP001 
//STRIP001 		aSet.Put( SfxBoolItem( SID_PARAM_CHILD_LEVELS, bHasChild ));
//STRIP001 		aSet.Put( SfxBoolItem( SID_PARAM_NUM_PRESET,FALSE ));
//STRIP001 
//STRIP001 		// vor dem Dialog wird der HtmlMode an der DocShell versenkt
//STRIP001 		pDocSh->PutItem(SfxUInt16Item(SID_HTML_MODE, ::binfilter::GetHtmlMode(pDocSh)));
//STRIP001 
//STRIP001 		SwSvxNumBulletTabDialog* pDlg = new SwSvxNumBulletTabDialog(
//STRIP001 							GetView().GetWindow(), &aSet, GetShell() );
//STRIP001 
//STRIP001 		USHORT nRet = pDlg->Execute();
//STRIP001 		const SfxPoolItem* pItem;
//STRIP001 		if( RET_OK == nRet )
//STRIP001 		{
//STRIP001 			if( SFX_ITEM_SET == pDlg->GetOutputItemSet()->GetItemState( SID_ATTR_NUMBERING_RULE, FALSE, &pItem ))
//STRIP001 			{
//STRIP001 				rReq.AppendItem(*pItem);
//STRIP001 				rReq.Done();
//STRIP001 				SvxNumRule* pSetRule = ((SvxNumBulletItem*)pItem)->GetNumRule();
//STRIP001 				pSetRule->UnLinkGraphics();
//STRIP001 				SwNumRule aSetRule( pCurRule
//STRIP001 										? pCurRule->GetName()
//STRIP001 										: GetShell().GetUniqueNumRuleName());
//STRIP001 				aSetRule.SetSvxRule( *pSetRule, GetShell().GetDoc());
//STRIP001 				aSetRule.SetAutoRule( TRUE );
//STRIP001 				GetShell().SetCurNumRule( aSetRule );
//STRIP001 			}
//STRIP001 			// wenn der Dialog mit OK verlassen wurde, aber nichts ausgewaehlt
//STRIP001 			// wurde dann muss die Numerierung zumindest eingeschaltet werden,
//STRIP001 			// wenn sie das noch nicht ist
//STRIP001 			else if( !pCurRule && SFX_ITEM_SET == aSet.GetItemState( SID_ATTR_NUMBERING_RULE, FALSE, &pItem ))
//STRIP001 			{
//STRIP001 				rReq.AppendItem( *pItem );
//STRIP001 				rReq.Done();
//STRIP001 				SvxNumRule* pSetRule = ((SvxNumBulletItem*)pItem)->GetNumRule();
//STRIP001 				SwNumRule aSetRule(GetShell().GetUniqueNumRuleName());
//STRIP001 				aSetRule.SetSvxRule(*pSetRule, GetShell().GetDoc());
//STRIP001 				aSetRule.SetAutoRule( TRUE );
//STRIP001 				GetShell().SetCurNumRule( aSetRule );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else if(RET_USER == nRet)
//STRIP001 			GetShell().DelNumRules();
//STRIP001 
//STRIP001 		delete pDlg;
//STRIP001 /*
//STRIP001 #else
//STRIP001 		SfxItemSet aSet(GetPool(),
//STRIP001 				SID_HTML_MODE, SID_HTML_MODE,
//STRIP001 				FN_PARAM_ACT_NUMBER,	FN_PARAM_ACT_NUMBER,
//STRIP001 				FN_PARAM_CHILD_LEVELS,	FN_PARAM_CHILD_LEVELS,
//STRIP001 				FN_PARAM_NUM_PRESET,	FN_PARAM_NUM_PRESET,
//STRIP001 				FN_PARAM_ACT_NUMLEVEL,	FN_PARAM_ACT_NUMLEVEL,
//STRIP001 				0 );
//STRIP001 
//STRIP001 		// per default TRUE, damit die Schleife im num.cxx richtig arbeitet!
//STRIP001 		BOOL bHasChild = TRUE;
//STRIP001 		const SwNumRule* pCurRule = GetShell().GetCurNumRule();
//STRIP001 		if( pCurRule )
//STRIP001 		{
//STRIP001 			aSet.Put( SwUINumRuleItem( *pCurRule ));
//STRIP001 			USHORT nLevel = GetShell().GetNumLevel( &bHasChild ) & ~NO_NUMLEVEL;
//STRIP001 			if( nLevel < MAXLEVEL )
//STRIP001 			{
//STRIP001 				nLevel = 1<<nLevel;
//STRIP001 				aSet.Put( SfxUInt16Item( FN_PARAM_ACT_NUMLEVEL, nLevel ));
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			SwNumRule aRule( GetShell().GetUniqueNumRuleName() );
//STRIP001 			SwDocShell* pDocSh = GetView().GetDocShell();
//STRIP001 			BOOL bHtml = 0 != PTR_CAST(SwWebDocShell, pDocSh);
//STRIP001 			for( BYTE n = 0; n < MAXLEVEL; ++n )
//STRIP001 			{
//STRIP001 				SwNumFmt aFmt( aRule.Get( n ) );
//STRIP001 				if(bHtml && n)
//STRIP001 				{
//STRIP001 					// 1/2" fuer HTML
//STRIP001 					aFmt.SetLSpace(720);
//STRIP001 					aFmt.SetAbsLSpace(n * 720);
//STRIP001 				}
//STRIP001 				aRule.Set( n, aFmt );
//STRIP001 			}
//STRIP001 			aSet.Put( SwUINumRuleItem( aRule ));
//STRIP001 		}
//STRIP001 
//STRIP001 		aSet.Put( SfxBoolItem( FN_PARAM_CHILD_LEVELS, bHasChild ));
//STRIP001 		aSet.Put( SfxBoolItem( FN_PARAM_NUM_PRESET,FALSE ));
//STRIP001 
//STRIP001 		SwNumBulletTabDialog* pDlg = new SwNumBulletTabDialog(
//STRIP001 							GetView().GetWindow(), &aSet, GetShell() );
//STRIP001 
//STRIP001 		if(RET_OK == pDlg->Execute() )
//STRIP001 		{
//STRIP001 			const SfxPoolItem* pItem;
//STRIP001 			if( SFX_ITEM_SET == pDlg->GetOutputItemSet()->GetItemState(
//STRIP001 									FN_PARAM_ACT_NUMBER, FALSE, &pItem ))
//STRIP001 			{
//STRIP001 				SwNumRule* pSetRule = ((SwUINumRuleItem*)pItem)->GetNumRule();
//STRIP001 				pSetRule->SetAutoRule( TRUE );
//STRIP001 				GetShell().SetCurNumRule( *pSetRule );
//STRIP001 			}
//STRIP001 			else
//STRIP001 				GetShell().DelNumRules();
//STRIP001 		}
//STRIP001 
//STRIP001 		delete pDlg;
//STRIP001 #endif
//STRIP001 */
//STRIP001 	}
//STRIP001 	break;
//STRIP001 	default:
//STRIP001 		ASSERT(FALSE,  falscher Dispatcher);
//STRIP001 		return;
//STRIP001 	}
//STRIP001 }


}
