/*************************************************************************
 *
 *  $RCSfile: mgetempl.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 20:58:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SFX_MGETEMPL_HXX
#define _SFX_MGETEMPL_HXX

#ifndef _SV_EDIT_HXX
#include <vcl/edit.hxx>
#endif
#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_LSTBOX_HXX
#include <vcl/lstbox.hxx>
#endif
#ifndef _STDCTRL_HXX
#include <svtools/stdctrl.hxx>
#endif
#ifndef _SV_MEDIT_HXX
#include <svtools/svmedit.hxx>
#endif

// auto strip #include <bf_sfx2/tabdlg.hxx>
class SfxStyleSheetBase;
namespace binfilter {

/* erwartet:
	SID_TEMPLATE_NAME   : 	In: StringItem, Name der Vorlage
	SID_TEMPLATE_FAMILY :	In: Familie der Vorlage
*/

class SfxStyleFamilies;
class SfxStyleFamilyItem;

#ifdef _SFXDLG_HXX
#define FixedInfo FixedText
#endif

//STRIP001 class SfxManageStyleSheetPage : public SfxTabPage
//STRIP001 {
//STRIP001 	FixedText aNameFt;
//STRIP001 	Edit aNameEd;
//STRIP001 	CheckBox	aAutoCB;
//STRIP001 
//STRIP001 	FixedText aFollowFt;
//STRIP001 	ListBox aFollowLb;
//STRIP001 
//STRIP001 	FixedText aBaseFt;
//STRIP001 	ListBox aBaseLb;
//STRIP001 
//STRIP001 	FixedText aFilterFt;
//STRIP001 	ListBox aFilterLb;
//STRIP001 
//STRIP001 	FixedInfo aDescFt;
//STRIP001 	MultiLineEdit aDescED;
//STRIP001     FixedLine aDescGb;
//STRIP001 
//STRIP001 	SfxStyleSheetBase *pStyle;
//STRIP001 	SfxStyleFamilies *pFamilies;
//STRIP001 	const SfxStyleFamilyItem *pItem;
//STRIP001 	String aBuf;
//STRIP001 	BOOL bModified;
//STRIP001 
//STRIP001 		// initiale Daten des Styles
//STRIP001 	String aName;
//STRIP001 	String aFollow;
//STRIP001 	String aParent;
//STRIP001 	USHORT nFlags;
//STRIP001 
//STRIP001 private:
//STRIP001 friend class SfxStyleDialog;
//STRIP001 
//STRIP001 #if _SOLAR__PRIVATE
//STRIP001 	DECL_LINK( GetFocusHdl, Edit * );
//STRIP001 	DECL_LINK( LoseFocusHdl, Edit * );
//STRIP001 
//STRIP001 	void	UpdateName_Impl(ListBox *, const String &rNew);
//STRIP001 	void	SetDescriptionText_Impl();
//STRIP001 #endif
//STRIP001 
//STRIP001 	SfxManageStyleSheetPage(Window *pParent, const SfxItemSet &rAttrSet );
//STRIP001 	~SfxManageStyleSheetPage();
//STRIP001 
//STRIP001 	static SfxTabPage*	Create(Window *pParent, const SfxItemSet &rAttrSet );
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual BOOL		FillItemSet(SfxItemSet &);
//STRIP001 	virtual void		Reset(const SfxItemSet &);
//STRIP001 
//STRIP001 	virtual void		ActivatePage(const SfxItemSet &);
//STRIP001 	virtual int			DeactivatePage(SfxItemSet * = 0);
//STRIP001 };

#ifdef FixedInfo
#undef FixedInfo
#endif

}//end of namespace binfilter
#endif

