/*************************************************************************
 *
 *  $RCSfile: orgmgr.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:00:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SFX_ORGMGR_HXX
#define _SFX_ORGMGR_HXX

// auto strip #ifndef _SVARRAY_HXX //autogen
// auto strip #include <svtools/svarray.hxx>
// auto strip #endif
namespace binfilter {

//STRIP001 class SfxDocumentTemplates;
//STRIP001 class SfxOrganizeListBox_Impl;
//STRIP001 class SfxObjectShell;
//STRIP001 struct _FileListEntry;

//=========================================================================

//STRIP001 SV_DECL_PTRARR_SORT(_SfxObjectList, _FileListEntry*, 1, 4)

//STRIP001 class SfxObjectList: public _SfxObjectList
//STRIP001 {
//STRIP001 public:
//STRIP001 	SfxObjectList();
//STRIP001 	~SfxObjectList();
//STRIP001 
//STRIP001 	const String&	GetBaseName( USHORT nId ) const;
//STRIP001 	const String&	GetFileName( USHORT nId ) const;
//STRIP001 };

//STRIP001 class IntlWrapper;
//STRIP001 struct SfxOrganizeMgr_Impl
//STRIP001 {
//STRIP001 	SfxObjectList*		pDocList;
//STRIP001 	IntlWrapper*		pIntlWrapper;
//STRIP001 
//STRIP001 	SfxOrganizeMgr_Impl() :  pDocList( NULL ), pIntlWrapper( NULL ) {}
//STRIP001 };

//=========================================================================

//STRIP001 class SfxOrganizeMgr
//STRIP001 {
//STRIP001 private:
//STRIP001 	SfxOrganizeMgr_Impl*		pImpl;
//STRIP001 	SfxDocumentTemplates* 		pTemplates;
//STRIP001 	SfxOrganizeListBox_Impl* 	pLeftBox;
//STRIP001 	SfxOrganizeListBox_Impl* 	pRightBox;
//STRIP001 	BOOL						bDeleteTemplates	:1;
//STRIP001 	BOOL						bModified			:1;
//STRIP001 
//STRIP001 	SfxOrganizeListBox_Impl*	GetOther( SfxOrganizeListBox_Impl* );
//STRIP001 
//STRIP001 public:
//STRIP001 	SfxOrganizeMgr( SfxOrganizeListBox_Impl* pLeft,
//STRIP001 					SfxOrganizeListBox_Impl* pRight,
//STRIP001 					SfxDocumentTemplates* pTempl = NULL );
//STRIP001 	~SfxOrganizeMgr();
//STRIP001 
//STRIP001 	BOOL	Copy( USHORT nTargetRegion, USHORT nTargetIdx, USHORT nSourceRegion, USHORT nSourceIdx );
//STRIP001 	BOOL	Move( USHORT nTargetRegion, USHORT nTargetIdx, USHORT nSourceRegion, USHORT nSourceIdx );
//STRIP001 	BOOL	Delete( SfxOrganizeListBox_Impl* pCaller, USHORT nRegion, USHORT nIdx );
//STRIP001 	BOOL	InsertDir( SfxOrganizeListBox_Impl* pCaller, const String& rName, USHORT nRegion );
//STRIP001 	BOOL	SetName( const String& rName, USHORT nRegion, USHORT nIdx = USHRT_MAX );
//STRIP001 	BOOL	CopyTo( USHORT nRegion, USHORT nIdx, const String& rName ) const;
//STRIP001 	BOOL	CopyFrom( SfxOrganizeListBox_Impl* pCaller, USHORT nRegion, USHORT nIdx, String& rName );
//STRIP001 
//STRIP001 	BOOL	Rescan();
//STRIP001 	BOOL	InsertFile( SfxOrganizeListBox_Impl* pCaller, const String& rFileName );
//STRIP001 
//STRIP001 	BOOL	IsModified() const { return bModified ? TRUE : FALSE; }
//STRIP001 
//STRIP001 	const SfxDocumentTemplates*	GetTemplates() const { return pTemplates; }
//STRIP001 	SfxObjectList&				GetObjectList() { return *pImpl->pDocList; }
//STRIP001 	const SfxObjectList&		GetObjectList() const { return *pImpl->pDocList; }
//STRIP001 
//STRIP001 	SfxObjectShellRef	CreateObjectShell( USHORT nIdx );
//STRIP001 	SfxObjectShellRef	CreateObjectShell( USHORT nRegion, USHORT nIdx );
//STRIP001 	BOOL				DeleteObjectShell( USHORT );
//STRIP001 	BOOL				DeleteObjectShell( USHORT, USHORT );
//STRIP001 	void				SaveAll( Window* pParent );
//STRIP001 };

}//end of namespace binfilter
#endif // #ifndef _SFX_ORGMGR_HXX


