/*************************************************************************
 *
 *  $RCSfile: fontlb.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:15:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SVX_FONTLB_HXX
#define	SVX_FONTLB_HXX

// auto strip #ifndef _SVTABBOX_HXX
// auto strip #include <svtools/svtabbx.hxx>
// auto strip #endif
// auto strip #ifndef _SV_VIRDEV_HXX
// auto strip #include <vcl/virdev.hxx>
// auto strip #endif
namespace binfilter {

// ============================================================================

/** A list box string item which stores its text and font. */
//STRIP001 class SvLBoxFontString : public SvLBoxString
//STRIP001 {
//STRIP001 private:
//STRIP001     Font                        maFont;     /// The font used by this item.
//STRIP001     bool                        mbUseColor; /// true = use font color, false = default listbox color.
//STRIP001 
//STRIP001 public:
//STRIP001                                 SvLBoxFontString();
//STRIP001                                 SvLBoxFontString(
//STRIP001                                     SvLBoxEntry* pEntry,
//STRIP001                                     sal_uInt16 nFlags,
//STRIP001                                     const XubString& rString,
//STRIP001                                     const Font& rFont,
//STRIP001                                     const Color* pColor = NULL );
//STRIP001 
//STRIP001     virtual                     ~SvLBoxFontString();
//STRIP001 
//STRIP001     /** Creates a new empty list box item. */
//STRIP001     virtual SvLBoxItem*         Create() const;
//STRIP001 
//STRIP001     void            InitViewData( SvLBox*,SvLBoxEntry*,SvViewDataItem* );
//STRIP001 
//STRIP001     /** Paints this entry to the specified position, using the own font settings. */
//STRIP001     void                        Paint(
//STRIP001                                     const Point& rPos,
//STRIP001                                     SvLBox& rDev,
//STRIP001                                     sal_uInt16 nFlags,
//STRIP001                                     SvLBoxEntry* pEntry );
//STRIP001 };

// ============================================================================

/** A list box supporting formatted string entries. */
//STRIP001 class SvxFontListBox : public SvTabListBox
//STRIP001 {
//STRIP001 private:
//STRIP001     Font                        maStdFont;      /// Used for entries without specific font.
//STRIP001 
//STRIP001     // The following members are used to store additional parameters for InitEntry().
//STRIP001     Font                        maEntryFont;    /// Current entry font used in InitEntry().
//STRIP001     const Color*                mpEntryColor;   /// Current entry color used in InitEntry().
//STRIP001     bool                        mbUseFont;      /// true = Use maEntryFont/mpEntryColor in InitEntry().
//STRIP001 
//STRIP001 public:
//STRIP001                                 SvxFontListBox( Window* pParent, const ResId& rResId );
//STRIP001 
//STRIP001     /** Inserts a list entry and sets the font used for this entry.
//STRIP001         @param pColor  The font color. NULL = use default listbox text color. */
//STRIP001     void                        InsertFontEntry(
//STRIP001                                     const String& rString, const Font& rFont, const Color* pColor = NULL );
//STRIP001 
//STRIP001     /** Selects/deselects an entry specified by its position in the list box. */
//STRIP001     void                        SelectEntryPos( sal_uInt16 nPos, bool bSelect = true );
//STRIP001     /** Removes a selection. */
//STRIP001     void                        SetNoSelection();
//STRIP001 
//STRIP001     /** Returns the position of the entry currently selected or LIST_ENTRY_NOTFOUND. */
//STRIP001     sal_uInt32                  GetSelectEntryPos() const;
//STRIP001     /** Returns the text of the selected entry or an empty string. */
//STRIP001     XubString                   GetSelectEntry() const;
//STRIP001 
//STRIP001 protected:
//STRIP001     /** Initializes a new SvLBoxFontString entry.
//STRIP001         @descr  Uses current value of maEntryFont to set the entry font (if mbUseFont is true). */
//STRIP001     virtual void                InitEntry(
//STRIP001                                     SvLBoxEntry* pEntry,
//STRIP001                                     const XubString& rEntryText,
//STRIP001                                     const Image& rCollImg,
//STRIP001                                     const Image& rExpImg );
//STRIP001 };

// ============================================================================

}//end of namespace binfilter
#endif

