/*************************************************************************
 *
 *  $RCSfile: itemwin.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:17:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_ITEMWIN_HXX
#define _SVX_ITEMWIN_HXX

#ifndef _SV_BITMAP_HXX 
#include <vcl/bitmap.hxx>
#endif

// auto strip #include <bf_svx/dlgctrl.hxx>
namespace binfilter {

// forward ---------------------------------------------------------------

class XLineColorItem;
class XLineWidthItem;
class SfxObjectShell;

// class SvxLineBox ------------------------------------------------------

//STRIP001 class SvxLineBox : public LineLB
//STRIP001 {
//STRIP001 	BmpColorMode	meBmpMode;
//STRIP001 	USHORT			nCurPos;
//STRIP001 	Timer			aDelayTimer;
//STRIP001     Size            aLogicalSize;
//STRIP001     SfxBindings&    rBindings;
//STRIP001     BOOL            bRelease;
//STRIP001 	SfxObjectShell* mpSh;
//STRIP001 
//STRIP001 #ifdef _SVX_ITEMWIN_CXX
//STRIP001 					DECL_LINK( DelayHdl_Impl, Timer * );
//STRIP001 
//STRIP001 	void			ReleaseFocus_Impl();
//STRIP001 #endif
//STRIP001 public:
//STRIP001 	SvxLineBox( Window* pParent, SfxBindings& rBind,
//STRIP001 				WinBits nBits = WB_BORDER | WB_DROPDOWN | WB_AUTOHSCROLL );
//STRIP001 	~SvxLineBox();
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void 	Select();
//STRIP001 	virtual long	PreNotify( NotifyEvent& rNEvt );
//STRIP001 	virtual long	Notify( NotifyEvent& rNEvt );
//STRIP001     virtual void    DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 
//STRIP001 	void FillControl();
//STRIP001 
//STRIP001 };

// class SvxColorBox -----------------------------------------------------

//STRIP001 class SvxColorBox : public ColorLB
//STRIP001 {
//STRIP001 	USHORT			nCurPos;
//STRIP001 	USHORT			nId;
//STRIP001 	Timer			aDelayTimer;
//STRIP001     Size            aLogicalSize;
//STRIP001     SfxBindings&    rBindings;
//STRIP001     BOOL            bRelease;
//STRIP001 
//STRIP001 #ifdef _SVX_ITEMWIN_CXX
//STRIP001 					DECL_LINK( DelayHdl_Impl, Timer * );
//STRIP001 
//STRIP001 	void			ReleaseFocus_Impl();
//STRIP001 #endif
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxColorBox( Window* pParent, USHORT nSID, SfxBindings& rBind,
//STRIP001 				 WinBits nBits = WB_BORDER | WB_DROPDOWN | WB_AUTOHSCROLL );
//STRIP001 	~SvxColorBox();
//STRIP001 
//STRIP001 	void			Update( const XLineColorItem* pItem );
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void 	Select();
//STRIP001 	virtual long	PreNotify( NotifyEvent& rNEvt );
//STRIP001 	virtual long	Notify( NotifyEvent& rNEvt );
//STRIP001     virtual void    DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 
//STRIP001 };

// class SvxMetricField --------------------------------------------------

//STRIP001 class SvxMetricField : public MetricField
//STRIP001 {
//STRIP001 	String			aCurTxt;
//STRIP001 	SfxMapUnit		ePoolUnit;
//STRIP001 	FieldUnit		eDlgUnit;
//STRIP001 	SfxBindings&	rBindings;
//STRIP001     Size            aLogicalSize;
//STRIP001 
//STRIP001 #ifdef _SVX_ITEMWIN_CXX
//STRIP001 	void			ReleaseFocus_Impl();
//STRIP001 #endif
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void 	Modify();
//STRIP001 	virtual void    Down();
//STRIP001 	virtual void    Up();		// Nur zur Sicherheit
//STRIP001 
//STRIP001 	virtual long	PreNotify( NotifyEvent& rNEvt );
//STRIP001 	virtual long	Notify( NotifyEvent& rNEvt );
//STRIP001     virtual void    DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxMetricField( Window* pParent, SfxBindings& rBind,
//STRIP001 					WinBits nBits = WB_BORDER | WB_SPIN | WB_REPEAT );
//STRIP001 	~SvxMetricField();
//STRIP001 
//STRIP001 	void			Update( const XLineWidthItem* pItem );
//STRIP001 	void			SetCoreUnit( SfxMapUnit eUnit );
//STRIP001 	void			RefreshDlgUnit();
//STRIP001 };

// class SvxFillTypeBox --------------------------------------------------

//STRIP001 class SvxFillTypeBox : public FillTypeLB
//STRIP001 {
//STRIP001 public:
//STRIP001 	SvxFillTypeBox( Window* pParent, WinBits nBits = WB_BORDER | WB_DROPDOWN | WB_AUTOHSCROLL );
//STRIP001 	~SvxFillTypeBox();
//STRIP001 
//STRIP001 	void			Selected() { bSelect = TRUE; }
//STRIP001     BOOL            IsRelease() { return bRelease;}
//STRIP001 
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual long	PreNotify( NotifyEvent& rNEvt );
//STRIP001 	virtual long	Notify( NotifyEvent& rNEvt );
//STRIP001 
//STRIP001 private:
//STRIP001 	USHORT			nCurPos;
//STRIP001 	BOOL			bSelect;
//STRIP001     BOOL            bRelease;
//STRIP001 
//STRIP001 #ifdef _SVX_ITEMWIN_CXX
//STRIP001 	void			ReleaseFocus_Impl();
//STRIP001 #endif
//STRIP001 };

// class SvxFillAttrBox --------------------------------------------------

//STRIP001 class SvxFillAttrBox : public FillAttrLB
//STRIP001 {
//STRIP001 public:
//STRIP001 	SvxFillAttrBox( Window* pParent, WinBits nBits = WB_BORDER | WB_DROPDOWN | WB_AUTOHSCROLL );
//STRIP001 	~SvxFillAttrBox();
//STRIP001 
//STRIP001     BOOL            IsRelease() { return bRelease;}
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual long	PreNotify( NotifyEvent& rNEvt );
//STRIP001 	virtual long	Notify( NotifyEvent& rNEvt );
//STRIP001 	virtual void	Select();
//STRIP001 
//STRIP001 private:
//STRIP001 	USHORT			nCurPos;
//STRIP001     BOOL            bRelease;
//STRIP001 
//STRIP001 #ifdef _SVX_ITEMWIN_CXX
//STRIP001 	void			ReleaseFocus_Impl();
//STRIP001 #endif
//STRIP001 };

}//end of namespace binfilter
#endif // #ifndef _SVX_ITEMWIN_HXX

