/*************************************************************************
 *
 *  $RCSfile: msdffdef.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:19:09 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _MSDFFDEF_HXX
#define _MSDFFDEF_HXX

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif
// auto strip #ifndef _STREAM_HXX
// auto strip #include <tools/stream.hxx>
// auto strip #endif
// auto strip #ifndef _TABLE_HXX
// auto strip #include <tools/table.hxx>
// auto strip #endif
// auto strip #ifndef _STRING_HXX
// auto strip #include <tools/string.hxx>
// auto strip #endif
// auto strip #ifndef _GEN_HXX
// auto strip #include <tools/gen.hxx>
// auto strip #endif
//STRIP001 class SfxItemSet;
namespace binfilter {

//STRIP001 #define DFF_COMMON_RECORD_HEADER_SIZE			8

//STRIP001 #define DFF_PSFLAG_CONTAINER 0x0F         // If the version field of a record
										  //  header takes on this value, the
										  //  record header marks the start of
										  //  a container.

//STRIP001 #define DFF_PST_Unknown                        0
//STRIP001 #define DFF_PST_SubContainerCompleted          1
//STRIP001 #define DFF_PST_IRRAtom                        2
//STRIP001 #define DFF_PST_PSS                            3
//STRIP001 #define DFF_PST_SubContainerException          4
//STRIP001 #define DFF_PST_ClientSignal1                  6
//STRIP001 #define DFF_PST_ClientSignal2                  7
//STRIP001 #define DFF_PST_PowerPointStateInfoAtom       10
//STRIP001 #define DFF_PST_Document                    1000
//STRIP001 #define DFF_PST_DocumentAtom                1001
//STRIP001 #define DFF_PST_EndDocument                 1002
//STRIP001 #define DFF_PST_SlidePersist                1003
//STRIP001 #define DFF_PST_SlideBase                   1004
//STRIP001 #define DFF_PST_SlideBaseAtom               1005
//STRIP001 #define DFF_PST_Slide                       1006
//STRIP001 #define DFF_PST_SlideAtom                   1007
//STRIP001 #define DFF_PST_Notes                       1008
//STRIP001 #define DFF_PST_NotesAtom                   1009
//STRIP001 #define DFF_PST_Environment                 1010
//STRIP001 #define DFF_PST_SlidePersistAtom            1011
//STRIP001 #define DFF_PST_Scheme                      1012
//STRIP001 #define DFF_PST_SchemeAtom                  1013
//STRIP001 #define DFF_PST_DocViewInfo                 1014
//STRIP001 #define DFF_PST_SslideLayoutAtom            1015
//STRIP001 #define DFF_PST_MainMaster                  1016
//STRIP001 #define DFF_PST_SSSlideInfoAtom             1017
//STRIP001 #define DFF_PST_SlideViewInfo               1018
//STRIP001 #define DFF_PST_GuideAtom                   1019
//STRIP001 #define DFF_PST_ViewInfo                    1020
//STRIP001 #define DFF_PST_ViewInfoAtom                1021
//STRIP001 #define DFF_PST_SlideViewInfoAtom           1022
//STRIP001 #define DFF_PST_VBAInfo                     1023
//STRIP001 #define DFF_PST_VBAInfoAtom                 1024
//STRIP001 #define DFF_PST_SSDocInfoAtom               1025
//STRIP001 #define DFF_PST_Summary                     1026
//STRIP001 #define DFF_PST_Texture                     1027
//STRIP001 #define DFF_PST_VBASlideInfo                1028
//STRIP001 #define DFF_PST_VBASlideInfoAtom            1029
//STRIP001 #define DFF_PST_DocRoutingSlip              1030
//STRIP001 #define DFF_PST_OutlineViewInfo             1031
//STRIP001 #define DFF_PST_SorterViewInfo              1032
//STRIP001 #define DFF_PST_ExObjList                   1033
//STRIP001 #define DFF_PST_ExObjListAtom               1034
//STRIP001 #define DFF_PST_PPDrawingGroup              1035
//STRIP001 #define DFF_PST_PPDrawing                   1036
//STRIP001 #define DFF_PST_NamedShows                  1040
//STRIP001 #define DFF_PST_NamedShow                   1041
//STRIP001 #define DFF_PST_NamedShowSlides             1042
//STRIP001 #define DFF_PST_List                        2000
//STRIP001 #define DFF_PST_FontCollection              2005
//STRIP001 #define DFF_PST_ListPlaceholder             2017
//STRIP001 #define DFF_PST_BookmarkCollection          2019
//STRIP001 #define DFF_PST_SoundCollection             2020
//STRIP001 #define DFF_PST_SoundCollAtom               2021
//STRIP001 #define DFF_PST_Sound                       2022
//STRIP001 #define DFF_PST_SoundData                   2023
//STRIP001 #define DFF_PST_BookmarkSeedAtom            2025
//STRIP001 #define DFF_PST_GuideList                   2026
//STRIP001 #define DFF_PST_RunArray                    2028
//STRIP001 #define DFF_PST_RunArrayAtom                2029
//STRIP001 #define DFF_PST_ArrayElementAtom            2030
//STRIP001 #define DFF_PST_Int4ArrayAtom               2031
//STRIP001 #define DFF_PST_ColorSchemeAtom             2032
//STRIP001 #define DFF_PST_OEShape                     3008
//STRIP001 #define DFF_PST_ExObjRefAtom                3009
//STRIP001 #define DFF_PST_OEPlaceholderAtom           3011
//STRIP001 #define DFF_PST_GrColor                     3020
//STRIP001 #define DFF_PST_GrectAtom                   3025
//STRIP001 #define DFF_PST_GratioAtom                  3031
//STRIP001 #define DFF_PST_Gscaling                    3032
//STRIP001 #define DFF_PST_GpointAtom                  3034
//STRIP001 #define DFF_PST_OEShapeAtom                 3035
//STRIP001 #define DFF_PST_OutlineTextRefAtom          3998
//STRIP001 #define DFF_PST_TextHeaderAtom              3999
//STRIP001 #define DFF_PST_TextCharsAtom               4000
//STRIP001 #define DFF_PST_StyleTextPropAtom           4001
//STRIP001 #define DFF_PST_BaseTextPropAtom            4002
//STRIP001 #define DFF_PST_TxMasterStyleAtom           4003
//STRIP001 #define DFF_PST_TxCFStyleAtom               4004
//STRIP001 #define DFF_PST_TxPFStyleAtom               4005
//STRIP001 #define DFF_PST_TextRulerAtom               4006
//STRIP001 #define DFF_PST_TextBookmarkAtom            4007
//STRIP001 #define DFF_PST_TextBytesAtom               4008
//STRIP001 #define DFF_PST_TxSIStyleAtom               4009
//STRIP001 #define DFF_PST_TextSpecInfoAtom            4010
//STRIP001 #define DFF_PST_DefaultRulerAtom            4011
//STRIP001 #define DFF_PST_FontEntityAtom              4023
//STRIP001 #define DFF_PST_FontEmbedData               4024
//STRIP001 #define DFF_PST_TypeFace                    4025
//STRIP001 #define DFF_PST_CString                     4026
//STRIP001 #define DFF_PST_ExternalObject              4027
//STRIP001 #define DFF_PST_MetaFile                    4033
//STRIP001 #define DFF_PST_ExOleObj                    4034
//STRIP001 #define DFF_PST_ExOleObjAtom                4035
//STRIP001 #define DFF_PST_ExPlainLinkAtom             4036
//STRIP001 #define DFF_PST_CorePict                    4037
//STRIP001 #define DFF_PST_CorePictAtom                4038
//STRIP001 #define DFF_PST_ExPlainAtom                 4039
//STRIP001 #define DFF_PST_SrKinsoku                   4040
//STRIP001 #define DFF_PST_Handout                     4041
//STRIP001 #define DFF_PST_ExEmbed                     4044
//STRIP001 #define DFF_PST_ExEmbedAtom                 4045
//STRIP001 #define DFF_PST_ExLink                      4046
//STRIP001 #define DFF_PST_ExLinkAtom_old              4047
//STRIP001 #define DFF_PST_BookmarkEntityAtom          4048
//STRIP001 #define DFF_PST_ExLinkAtom                  4049
//STRIP001 #define DFF_PST_SrKinsokuAtom               4050
//STRIP001 #define DFF_PST_ExHyperlinkAtom             4051
//STRIP001 #define DFF_PST_ExPlain                     4053
//STRIP001 #define DFF_PST_ExPlainLink                 4054
//STRIP001 #define DFF_PST_ExHyperlink                 4055
//STRIP001 #define DFF_PST_SlideNumberMCAtom           4056
//STRIP001 #define DFF_PST_HeadersFooters              4057
//STRIP001 #define DFF_PST_HeadersFootersAtom          4058
//STRIP001 #define DFF_PST_RecolorEntryAtom            4062
//STRIP001 #define DFF_PST_TxInteractiveInfoAtom       4063
//STRIP001 #define DFF_PST_EmFormatAtom                4065
//STRIP001 #define DFF_PST_CharFormatAtom              4066
//STRIP001 #define DFF_PST_ParaFormatAtom              4067
//STRIP001 #define DFF_PST_MasterText                  4068
//STRIP001 #define DFF_PST_RecolorInfoAtom             4071
//STRIP001 #define DFF_PST_ExQuickTime                 4073
//STRIP001 #define DFF_PST_ExQuickTimeMovie            4074
//STRIP001 #define DFF_PST_ExQuickTimeMovieData        4075
//STRIP001 #define DFF_PST_ExSubscription              4076
//STRIP001 #define DFF_PST_ExSubscriptionSection       4077
//STRIP001 #define DFF_PST_ExControl                   4078
//STRIP001 #define DFF_PST_ExControlAtom               4091
//STRIP001 #define DFF_PST_SlideListWithText           4080
//STRIP001 #define DFF_PST_AnimationInfoAtom           4081
//STRIP001 #define DFF_PST_InteractiveInfo             4082
//STRIP001 #define DFF_PST_InteractiveInfoAtom         4083
//STRIP001 #define DFF_PST_SlideList                   4084
//STRIP001 #define DFF_PST_UserEditAtom                4085
//STRIP001 #define DFF_PST_CurrentUserAtom             4086
//STRIP001 #define DFF_PST_DateTimeMCAtom              4087
//STRIP001 #define DFF_PST_GenericDateMCAtom           4088
//STRIP001 #define DFF_PST_HeaderMCAtom                4089
//STRIP001 #define DFF_PST_FooterMCAtom                4090
//STRIP001 #define DFF_PST_ExMediaAtom                 4100
//STRIP001 #define DFF_PST_ExVideo                     4101
//STRIP001 #define DFF_PST_ExAviMovie                  4102
//STRIP001 #define DFF_PST_ExMCIMovie                  4103
//STRIP001 #define DFF_PST_ExMIDIAudio                 4109
//STRIP001 #define DFF_PST_ExCDAudio                   4110
//STRIP001 #define DFF_PST_ExWAVAudioEmbedded          4111
//STRIP001 #define DFF_PST_ExWAVAudioLink              4112
//STRIP001 #define DFF_PST_ExOleObjStg                 4113
//STRIP001 #define DFF_PST_ExCDAudioAtom               4114
//STRIP001 #define DFF_PST_ExWAVAudioEmbeddedAtom      4115
//STRIP001 #define DFF_PST_AnimationInfo               4116
//STRIP001 #define DFF_PST_RTFDateTimeMCAtom           4117
//STRIP001 #define DFF_PST_ProgTags                    5000
//STRIP001 #define DFF_PST_ProgStringTag               5001
//STRIP001 #define DFF_PST_ProgBinaryTag               5002
//STRIP001 #define DFF_PST_BinaryTagData               5003
//STRIP001 #define DFF_PST_PrintOptions                6000
//STRIP001 #define DFF_PST_PersistPtrFullBlock         6001
//STRIP001 #define DFF_PST_PersistPtrIncrementalBlock  6002
//STRIP001 #define DFF_PST_RulerIndentAtom            10000
//STRIP001 #define DFF_PST_GscalingAtom               10001
//STRIP001 #define DFF_PST_GrColorAtom                10002
//STRIP001 #define DFF_PST_GLPointAtom                10003
//STRIP001 #define DFF_PST_GlineAtom                  10004

//      Record Name                 FBT-Value Instance                  Contents                                                          Wrd Exl Ppt Ver

//STRIP001 #define DFF_msofbtDggContainer      0xF000 //                           per-document data                                                  X   X   X
//STRIP001 #define   DFF_msofbtDgg             0xF006 //                           an FDGG and several FIDCLs                                         X   X   X   0
//STRIP001 #define   DFF_msofbtCLSID           0xF016 //                           the CLSID of the application that put the data on the clipboard    C   C   C   0
//STRIP001 #define   DFF_msofbtOPT             0xF00B // count of properties       the document-wide default shape properties                         X   X   X   3
//STRIP001 #define   DFF_msofbtColorMRU        0xF11A // count of colors           the colors in the MRU swatch                                       X   X   X   0
//STRIP001 #define   DFF_msofbtSplitMenuColors 0xF11E // count of colors           the colors in the top-level split menus                            X   X   X   0
//STRIP001 #define   DFF_msofbtBstoreContainer 0xF001 // count of BLIPs            all images in the document (JPEGs, metafiles, etc.)                X   X   X
//STRIP001 #define     DFF_msofbtBSE           0xF007 // BLIP type                 an FBSE (one per BLIP)                                             X   X   X   2
//STRIP001 #define     DFF_msofbtBlipFirst     0xF018 //                           range of fbts reserved for various kinds of BLIPs                  X   X   X
//STRIP001 #define     DFF_msofbtBlipLast      0xF117 //                           range of fbts reserved for various kinds of BLIPs                  X   X   X

//STRIP001 #define DFF_msofbtDgContainer       0xF002 //                           per-sheet/page/slide data                                          X   X   X
//STRIP001 #define   DFF_msofbtDg              0xF008 // drawing ID                an FDG                                                             X   X   X   0
//STRIP001 #define   DFF_msofbtRegroupItems    0xF118 // count of regroup entries  several FRITs                                                      X   X   X   0
//STRIP001 #define   DFF_msofbtColorScheme     0xF120 // count of colors           the colors of the source host's color scheme                           C   C   0
//STRIP001 #define   DFF_msofbtSpgrContainer   0xF003 //                           several SpContainers, the first of which is the group shape itself X   X   X
//STRIP001 #define   DFF_msofbtSpContainer     0xF004 //                           a shape                                                            X   X   X
//STRIP001 #define     DFF_msofbtSpgr          0xF009 //                           an FSPGR; only present if the shape is a group shape               X   X   X   1
//STRIP001 #define     DFF_msofbtSp            0xF00A // shape type                an FSP                                                             X   X   X   2
//STRIP001 //efine     DFF_msofbtOPT           0xF00B // count of properties       a shape property table                                             X   X   X   3
//STRIP001 #define     DFF_msofbtTextbox       0xF00C //                           RTF text                                                           C   C   C   0
//STRIP001 #define     DFF_msofbtClientTextbox 0xF00D // host-defined              the text in the textbox, in host-defined format                    X   X   X
//STRIP001 #define     DFF_msofbtAnchor        0xF00E //                           a RECT, in 100000ths of an inch                                    C   C   C   0
//STRIP001 #define     DFF_msofbtChildAnchor   0xF00F //                           a RECT, in units relative to the parent group                      X   X   X   0
//STRIP001 #define     DFF_msofbtClientAnchor  0xF010 // host-defined              the location of the shape, in a host-defined format                X   X   X
//STRIP001 #define     DFF_msofbtClientData    0xF011 // host-defined              host-specific data                                                 X   X   X
//STRIP001 #define     DFF_msofbtOleObject     0xF11F //                           a serialized IStorage for an OLE object                            C   C   C   0
//STRIP001 #define     DFF_msofbtDeletedPspl   0xF11D //                           an FPSPL; only present in top-level deleted shapes                 X           0
//STRIP001 #define     DFF_msofbtUDefProp      0xF122 //                           range of fbts reserved for various kinds of BLIPs                  X   X   X
//STRIP001 #define   DFF_msofbtSolverContainer 0xF005 // count of rules            the rules governing shapes                                         X   X   X
//STRIP001 #define     DFF_msofbtConnectorRule 0xF012 //                           an FConnectorRule                                                      X   X   1
//STRIP001 #define     DFF_msofbtAlignRule     0xF013 //                           an FAlignRule                                                      X   X   X   0
//STRIP001 #define     DFF_msofbtArcRule       0xF014 //                           an FARCRU                                                          X   X   X   0
//STRIP001 #define     DFF_msofbtClientRule    0xF015 // host-defined              host-defined
//STRIP001 #define     DFF_msofbtCalloutRule   0xF017 //                           an FCORU                                                           X   X   X   0

//STRIP001 #define DFF_msofbtSelection         0xF119 //                           an FDGSL followed by the SPIDs of the shapes in the selection              X   0

//#define DFF_EscherF002                    0xF002
//#define DFF_EscherObjList                 0xF003
//#define DFF_EscherObject                  0xF004
//#define DFF_EscherF00A                    0xF00A
//#define DFF_EscherProperties              0xF00B
//#define DFF_EscherObjText                 0xF00D
//#define DFF_EscherPosSize                 0xF010

// Werte fuer den ULONG im DFF_PST_TextHeaderAtom
//STRIP001 enum DFF_TextHeader {
//STRIP001 	DFFTH_TITLE,
//STRIP001 	DFFTH_BODY,
//STRIP001 	DFFTH_NOTES,
//STRIP001 	DFFTH_NOTUSED,
//STRIP001 	DFFTH_OTHER,       // Text in a Shape
//STRIP001 	DFFTH_CENTERBODY,  // Subtitle in Title-Slide
//STRIP001 	DFFTH_CENTERTITLE, // Title in Title-Slide
//STRIP001 	DFFTH_HALFBODY,    // Body in two-column slide
//STRIP001 	DFFTH_QUARTERBODY  // Body in four-body slide
//STRIP001 };

// Shape Properties
// 1pt = 12700 EMU (English Metric Units)
// 1pt = 20 Twip = 20/1440" = 1/72"
// 1twip=635 EMU
// 1" = 12700*72 = 914400 EMU
// 1" = 25.4mm
// 1mm = 36000 EMU
// Transform
//STRIP001 #define DFF_Prop_Rotation                      4  //  Fixed Point 16.16 degrees
// Protection
//STRIP001 #define DFF_Prop_LockRotation                119  //  BOOL              No rotation
//STRIP001 #define DFF_Prop_LockAspectRatio             120  //  BOOL              Don't allow changes in aspect ratio
//STRIP001 #define DFF_Prop_LockPosition                121  //  BOOL              Don't allow the shape to be moved
//STRIP001 #define DFF_Prop_LockAgainstSelect           122  //  BOOL              Shape may not be selected
//STRIP001 #define DFF_Prop_LockCropping                123  //  BOOL              No cropping this shape
//STRIP001 #define DFF_Prop_LockVertices                124  //  BOOL              Edit Points not allowed
//STRIP001 #define DFF_Prop_LockText                    125  //  BOOL              Do not edit text
//STRIP001 #define DFF_Prop_LockAdjustHandles           126  //  BOOL              Do not adjust
//STRIP001 #define DFF_Prop_LockAgainstGrouping         127  //  BOOL              Do not group this shape
// Text
//STRIP001 #define DFF_Prop_lTxid                       128  //  LONG              id for the text, value determined by the host
//STRIP001 #define DFF_Prop_dxTextLeft                  129  //  LONG              margins relative to shape's inscribed text rectangle (in EMUs)
//STRIP001 #define DFF_Prop_dyTextTop                   130  //  LONG
//STRIP001 #define DFF_Prop_dxTextRight                 131  //  LONG
//STRIP001 #define DFF_Prop_dyTextBottom                132  //  LONG
//STRIP001 #define DFF_Prop_WrapText                    133  //  MSO_WRAPMODE       Wrap text at shape margins
//STRIP001 #define DFF_Prop_scaleText                   134  //  LONG              Text zoom/scale (used if fFitTextToShape)
//STRIP001 #define DFF_Prop_anchorText                  135  //  MSO_ANCHOR         How to anchor the text
//STRIP001 #define DFF_Prop_txflTextFlow                136  //  MSO_TXFL           Text flow
//STRIP001 #define DFF_Prop_cdirFont                    137  //  MSO_CDIR           Font rotation
//STRIP001 #define DFF_Prop_hspNext                     138  //  MSO_HSP            ID of the next shape (used by Word for linked textboxes)
//STRIP001 #define DFF_Prop_txdir                       139  //  MSO_TXDIR          Bi-Di Text direction
//STRIP001 #define DFF_Prop_SelectText                  187  //  BOOL              TRUE if single click selects text, FALSE if two clicks
//STRIP001 #define DFF_Prop_AutoTextMargin              188  //  BOOL              use host's margin calculations
//STRIP001 #define DFF_Prop_RotateText                  189  //  BOOL              Rotate text with shape
//STRIP001 #define DFF_Prop_FitShapeToText              190  //  BOOL              Size shape to fit text size
//STRIP001 #define DFF_Prop_FitTextToShape              191  //  BOOL              Size text to fit shape size
// GeoText
//STRIP001 #define DFF_Prop_gtextUNICODE                192  //  WCHAR*            UNICODE text string
//STRIP001 #define DFF_Prop_gtextRTF                    193  //  char*             RTF text string
//STRIP001 #define DFF_Prop_gtextAlign                  194  //  MSO_GEOTEXTALIGN   alignment on curve
//STRIP001 #define DFF_Prop_gtextSize                   195  //  LONG              default point size
//STRIP001 #define DFF_Prop_gtextSpacing                196  //  LONG              fixed point 16.16
//STRIP001 #define DFF_Prop_gtextFont                   197  //  WCHAR*            font family name
//STRIP001 #define DFF_Prop_gtextFReverseRows           240  //  BOOL  8000        Reverse row order
//STRIP001 #define DFF_Prop_fGtext                      241  //  BOOL  4000        Has text effect
//STRIP001 #define DFF_Prop_gtextFVertical              242  //  BOOL  2000        Rotate characters
//STRIP001 #define DFF_Prop_gtextFKern                  243  //  BOOL  1000        Kern characters
//STRIP001 #define DFF_Prop_gtextFTight                 244  //  BOOL   800        Tightening or tracking
//STRIP001 #define DFF_Prop_gtextFStretch               245  //  BOOL   400        Stretch to fit shape
//STRIP001 #define DFF_Prop_gtextFShrinkFit             246  //  BOOL   200        Char bounding box
//STRIP001 #define DFF_Prop_gtextFBestFit               247  //  BOOL   100        Scale text-on-path
//STRIP001 #define DFF_Prop_gtextFNormalize             248  //  BOOL    80        Stretch char height
//STRIP001 #define DFF_Prop_gtextFDxMeasure             249  //  BOOL    40        Do not measure along path
//STRIP001 #define DFF_Prop_gtextFBold                  250  //  BOOL    20        Bold font
//STRIP001 #define DFF_Prop_gtextFItalic                251  //  BOOL    10        Italic font
//STRIP001 #define DFF_Prop_gtextFUnderline             252  //  BOOL     8        Underline font
//STRIP001 #define DFF_Prop_gtextFShadow                253  //  BOOL     4        Shadow font
//STRIP001 #define DFF_Prop_gtextFSmallcaps             254  //  BOOL     2        Small caps font
//STRIP001 #define DFF_Prop_gtextFStrikethrough         255  //  BOOL     1        Strike through font
// Blip
//STRIP001 #define DFF_Prop_cropFromTop                 256  //  LONG              16.16 fraction times total image width or height, as appropriate.
//STRIP001 #define DFF_Prop_cropFromBottom              257  //  LONG
//STRIP001 #define DFF_Prop_cropFromLeft                258  //  LONG
//STRIP001 #define DFF_Prop_cropFromRight               259  //  LONG
//STRIP001 #define DFF_Prop_pib                         260  //  IMsoBlip*         Blip to display
//STRIP001 #define DFF_Prop_pibName                     261  //  WCHAR*            Blip file name
//STRIP001 #define DFF_Prop_pibFlags                    262  //  MSO_BLIPFLAGS      Blip flags
//STRIP001 #define DFF_Prop_pictureTransparent          263  //  LONG              transparent color (none if ~0UL)
//STRIP001 #define DFF_Prop_pictureContrast             264  //  LONG              contrast setting
//STRIP001 #define DFF_Prop_pictureBrightness           265  //  LONG              brightness setting
//STRIP001 #define DFF_Prop_pictureGamma                266  //  LONG              16.16 gamma
//STRIP001 #define DFF_Prop_pictureId                   267  //  LONG              Host-defined ID for OLE objects (usually a pointer)
//STRIP001 #define DFF_Prop_pictureDblCrMod             268  //  MSO_CLR            Modification used if shape has double shadow
//STRIP001 #define DFF_Prop_pictureFillCrMod            269  //  MSO_CLR
//STRIP001 #define DFF_Prop_pictureLineCrMod            270  //  MSO_CLR
//STRIP001 #define DFF_Prop_pibPrint                    271  //  IMsoBlip*         Blip to display when printing
//STRIP001 #define DFF_Prop_pibPrintName                272  //  WCHAR*            Blip file name
//STRIP001 #define DFF_Prop_pibPrintFlags               273  //  MSO_BLIPFLAGS      Blip flags
//STRIP001 #define DFF_Prop_fNoHitTestPicture           316  //  BOOL              Do not hit test the picture
//STRIP001 #define DFF_Prop_pictureGray                 317  //  BOOL              grayscale display
//STRIP001 #define DFF_Prop_pictureBiLevel              318  //  BOOL              bi-level display
//STRIP001 #define DFF_Prop_pictureActive               319  //  BOOL              Server is active (OLE objects only)
// Geometry
//STRIP001 #define DFF_Prop_geoLeft                     320  //  LONG              Defines the G (geometry) coordinate space.
//STRIP001 #define DFF_Prop_geoTop                      321  //  LONG
//STRIP001 #define DFF_Prop_geoRight                    322  //  LONG
//STRIP001 #define DFF_Prop_geoBottom                   323  //  LONG
//STRIP001 #define DFF_Prop_shapePath                   324  //  MSO_SHAPEPATH
//STRIP001 #define DFF_Prop_pVertices                   325  //  IMsoArray         An array of points, in G units.
//STRIP001 #define DFF_Prop_pSegmentInfo                326  //  IMsoArray
//STRIP001 #define DFF_Prop_adjustValue                 327  //  LONG              Adjustment values corresponding to the positions of the
//STRIP001 #define DFF_Prop_adjust2Value                328  //  LONG              adjust handles of the shape. The number of values used
//STRIP001 #define DFF_Prop_adjust3Value                329  //  LONG              and their allowable ranges vary from shape type to shape type.
//STRIP001 #define DFF_Prop_adjust4Value                330  //  LONG
//STRIP001 #define DFF_Prop_adjust5Value                331  //  LONG
//STRIP001 #define DFF_Prop_adjust6Value                332  //  LONG
//STRIP001 #define DFF_Prop_adjust7Value                333  //  LONG
//STRIP001 #define DFF_Prop_adjust8Value                334  //  LONG
//STRIP001 #define DFF_Prop_adjust9Value                335  //  LONG
//STRIP001 #define DFF_Prop_adjust10Value               336  //  LONG
//STRIP001 #define DFF_Prop_fShadowOK                   378  //  BOOL              Shadow may be set
//STRIP001 #define DFF_Prop_f3DOK                       379  //  BOOL              3D may be set
//STRIP001 #define DFF_Prop_fLineOK                     380  //  BOOL              Line style may be set
//STRIP001 #define DFF_Prop_fGtextOK                    381  //  BOOL              Text effect (WordArt) supported
//STRIP001 #define DFF_Prop_fFillShadeShapeOK           382  //  BOOL
//STRIP001 #define DFF_Prop_fFillOK                     383  //  BOOL              OK to fill the shape through the UI or VBA?
// FillStyle
//STRIP001 #define DFF_Prop_fillType                    384  //  MSO_FILLTYPE       Type of fill
//STRIP001 #define DFF_Prop_fillColor                   385  //  MSO_CLR            Foreground color
//STRIP001 #define DFF_Prop_fillOpacity                 386  //  LONG              Fixed 16.16
//STRIP001 #define DFF_Prop_fillBackColor               387  //  MSO_CLR            Background color
//STRIP001 #define DFF_Prop_fillBackOpacity             388  //  LONG              Shades only
//STRIP001 #define DFF_Prop_fillCrMod                   389  //  MSO_CLR            Modification for BW views
//STRIP001 #define DFF_Prop_fillBlip                    390  //  IMsoBlip*         Pattern/texture
//STRIP001 #define DFF_Prop_fillBlipName                391  //  WCHAR*            Blip file name
//STRIP001 #define DFF_Prop_fillBlipFlags               392  //  MSO_BLIPFLAGS      Blip flags
//STRIP001 #define DFF_Prop_fillWidth                   393  //  LONG              How big (A units) to make a metafile texture.
//STRIP001 #define DFF_Prop_fillHeight                  394  //  LONG
//STRIP001 #define DFF_Prop_fillAngle                   395  //  LONG              Fade angle - degrees in 16.16
//STRIP001 #define DFF_Prop_fillFocus                   396  //  LONG              Linear shaded fill focus percent
//STRIP001 #define DFF_Prop_fillToLeft                  397  //  LONG              Fraction 16.16
//STRIP001 #define DFF_Prop_fillToTop                   398  //  LONG              Fraction 16.16
//STRIP001 #define DFF_Prop_fillToRight                 399  //  LONG              Fraction 16.16
//STRIP001 #define DFF_Prop_fillToBottom                400  //  LONG              Fraction 16.16
//STRIP001 #define DFF_Prop_fillRectLeft                401  //  LONG              For shaded fills, use the specified rectangle instead of the shape's bounding rect to define how large the fade is going to be.
//STRIP001 #define DFF_Prop_fillRectTop                 402  //  LONG
//STRIP001 #define DFF_Prop_fillRectRight               403  //  LONG
//STRIP001 #define DFF_Prop_fillRectBottom              404  //  LONG
//STRIP001 #define DFF_Prop_fillDztype                  405  //  MSO_DZTYPE
//STRIP001 #define DFF_Prop_fillShadePreset             406  //  LONG              Special shades
//STRIP001 #define DFF_Prop_fillShadeColors             407  //  IMsoArray         a preset array of colors
//STRIP001 #define DFF_Prop_fillOriginX                 408  //  LONG
//STRIP001 #define DFF_Prop_fillOriginY                 409  //  LONG
//STRIP001 #define DFF_Prop_fillShapeOriginX            410  //  LONG
//STRIP001 #define DFF_Prop_fillShapeOriginY            411  //  LONG
//STRIP001 #define DFF_Prop_fillShadeType               412  //  MSO_SHADETYPE      Type of shading, if a shaded (gradient) fill.
//STRIP001 #define DFF_Prop_fFilled                     443  //  BOOL              Is shape filled?
//STRIP001 #define DFF_Prop_fHitTestFill                444  //  BOOL              Should we hit test fill?
//STRIP001 #define DFF_Prop_fillShape                   445  //  BOOL              Register pattern on shape
//STRIP001 #define DFF_Prop_fillUseRect                 446  //  BOOL              Use the large rect?
//STRIP001 #define DFF_Prop_fNoFillHitTest              447  //  BOOL              Hit test a shape as though filled
// LineStyle
//STRIP001 #define DFF_Prop_lineColor                   448  //  MSO_CLR            Color of line
//STRIP001 #define DFF_Prop_lineOpacity                 449  //  LONG              Not implemented
//STRIP001 #define DFF_Prop_lineBackColor               450  //  MSO_CLR            Background color
//STRIP001 #define DFF_Prop_lineCrMod                   451  //  MSO_CLR            Modification for BW views
//STRIP001 #define DFF_Prop_lineType                    452  //  MSO_LINETYPE       Type of line
//STRIP001 #define DFF_Prop_lineFillBlip                453  //  IMsoBlip*         Pattern/texture
//STRIP001 #define DFF_Prop_lineFillBlipName            454  //  WCHAR*            Blip file name
//STRIP001 #define DFF_Prop_lineFillBlipFlags           455  //  MSO_BLIPFLAGS      Blip flags
//STRIP001 #define DFF_Prop_lineFillWidth               456  //  LONG              How big (A units) to make a metafile texture.
//STRIP001 #define DFF_Prop_lineFillHeight              457  //  LONG
//STRIP001 #define DFF_Prop_lineFillDztype              458  //  MSO_DZTYPE         How to interpret fillWidth/Height numbers.
//STRIP001 #define DFF_Prop_lineWidth                   459  //  LONG              A units; 1pt == 12700 EMUs
//STRIP001 #define DFF_Prop_lineMiterLimit              460  //  LONG              ratio (16.16) of width
//STRIP001 #define DFF_Prop_lineStyle                   461  //  MSO_LINESTYLE      Draw parallel lines?
//STRIP001 #define DFF_Prop_lineDashing                 462  //  MSO_LINEDASHING    Can be overridden by:
//STRIP001 #define DFF_Prop_lineDashStyle               463  //  IMsoArray         As Win32 ExtCreatePen
//STRIP001 #define DFF_Prop_lineStartArrowhead          464  //  MSO_LINEEND        Arrow at start
//STRIP001 #define DFF_Prop_lineEndArrowhead            465  //  MSO_LINEEND        Arrow at end
//STRIP001 #define DFF_Prop_lineStartArrowWidth         466  //  MSO_LINEENDWIDTH   Arrow at start
//STRIP001 #define DFF_Prop_lineStartArrowLength        467  //  MSO_LINEENDLENGTH  Arrow at end
//STRIP001 #define DFF_Prop_lineEndArrowWidth           468  //  MSO_LINEENDWIDTH   Arrow at start
//STRIP001 #define DFF_Prop_lineEndArrowLength          469  //  MSO_LINEENDLENGTH  Arrow at end
//STRIP001 #define DFF_Prop_lineJoinStyle               470  //  MSO_LINEJOIN       How to join lines
//STRIP001 #define DFF_Prop_lineEndCapStyle             471  //  MSO_LINECAP        How to end lines
//STRIP001 #define DFF_Prop_fArrowheadsOK               507  //  BOOL              Allow arrowheads if prop. is set
//STRIP001 #define DFF_Prop_fLine                       508  //  BOOL              Any line?
//STRIP001 #define DFF_Prop_fHitTestLine                509  //  BOOL              Should we hit test lines?
//STRIP001 #define DFF_Prop_lineFillShape               510  //  BOOL              Register pattern on shape
//STRIP001 #define DFF_Prop_fNoLineDrawDash             511  //  BOOL              Draw a dashed line if no line
// ShadowStyle
//STRIP001 #define DFF_Prop_shadowType                  512  //  MSO_SHADOWTYPE     Type of effect
//STRIP001 #define DFF_Prop_shadowColor                 513  //  MSO_CLR            Foreground color
//STRIP001 #define DFF_Prop_shadowHighlight             514  //  MSO_CLR            Embossed color
//STRIP001 #define DFF_Prop_shadowCrMod                 515  //  MSO_CLR            Modification for BW views
//STRIP001 #define DFF_Prop_shadowOpacity               516  //  LONG              Fixed 16.16
//STRIP001 #define DFF_Prop_shadowOffsetX               517  //  LONG              Offset shadow
//STRIP001 #define DFF_Prop_shadowOffsetY               518  //  LONG              Offset shadow
//STRIP001 #define DFF_Prop_shadowSecondOffsetX         519  //  LONG              Double offset shadow
//STRIP001 #define DFF_Prop_shadowSecondOffsetY         520  //  LONG              Double offset shadow
//STRIP001 #define DFF_Prop_shadowScaleXToX             521  //  LONG              16.16
//STRIP001 #define DFF_Prop_shadowScaleYToX             522  //  LONG              16.16
//STRIP001 #define DFF_Prop_shadowScaleXToY             523  //  LONG              16.16
//STRIP001 #define DFF_Prop_shadowScaleYToY             524  //  LONG              16.16
//STRIP001 #define DFF_Prop_shadowPerspectiveX          525  //  LONG              16.16 / weight
//STRIP001 #define DFF_Prop_shadowPerspectiveY          526  //  LONG              16.16 / weight
//STRIP001 #define DFF_Prop_shadowWeight                527  //  LONG              scaling factor
//STRIP001 #define DFF_Prop_shadowOriginX               528  //  LONG
//STRIP001 #define DFF_Prop_shadowOriginY               529  //  LONG
//STRIP001 #define DFF_Prop_fShadow                     574  //  BOOL              Any shadow?
//STRIP001 #define DFF_Prop_fshadowObscured             575  //  BOOL              Excel5-style shadow
// PerspectiveStyle
//STRIP001 #define DFF_Prop_perspectiveType             576  //  MSO_XFORMTYPE      Where transform applies
//STRIP001 #define DFF_Prop_perspectiveOffsetX          577  //  LONG              The LONG values define a transformation matrix, effectively, each value is scaled by the perspectiveWeight parameter.
//STRIP001 #define DFF_Prop_perspectiveOffsetY          578  //  LONG
//STRIP001 #define DFF_Prop_perspectiveScaleXToX        579  //  LONG
//STRIP001 #define DFF_Prop_perspectiveScaleYToX        580  //  LONG
//STRIP001 #define DFF_Prop_perspectiveScaleXToY        581  //  LONG
//STRIP001 #define DFF_Prop_perspectiveScaleYToY        582  //  LONG
//STRIP001 #define DFF_Prop_perspectivePerspectiveX     583  //  LONG
//STRIP001 #define DFF_Prop_perspectivePerspectiveY     584  //  LONG
//STRIP001 #define DFF_Prop_perspectiveWeight           585  //  LONG              Scaling factor
//STRIP001 #define DFF_Prop_perspectiveOriginX          586  //  LONG
//STRIP001 #define DFF_Prop_perspectiveOriginY          587  //  LONG
//STRIP001 #define DFF_Prop_fPerspective                639  //  BOOL              On/off
// 3D Object
//STRIP001 #define DFF_Prop_c3DSpecularAmt              640  //  LONG         Fixed-point 16.16
//STRIP001 #define DFF_Prop_c3DDiffuseAmt               641  //  LONG         Fixed-point 16.16
//STRIP001 #define DFF_Prop_c3DShininess                642  //  LONG         Default gives OK results
//STRIP001 #define DFF_Prop_c3DEdgeThickness            643  //  LONG         Specular edge thickness
//STRIP001 #define DFF_Prop_c3DExtrudeForward           644  //  LONG         Distance of extrusion in EMUs
//STRIP001 #define DFF_Prop_c3DExtrudeBackward          645  //  LONG
//STRIP001 #define DFF_Prop_c3DExtrudePlane             646  //  LONG         Extrusion direction
//STRIP001 #define DFF_Prop_c3DExtrusionColor           647  //  MSO_CLR       Basic color of extruded part of shape; the lighting model used will determine the exact shades used when rendering.
//STRIP001 #define DFF_Prop_c3DCrMod                    648  //  MSO_CLR       Modification for BW views
//STRIP001 #define DFF_Prop_f3D                         700  //  BOOL         Does this shape have a 3D effect?
//STRIP001 #define DFF_Prop_fc3DMetallic                701  //  BOOL         Use metallic specularity?
//STRIP001 #define DFF_Prop_fc3DUseExtrusionColor       702  //  BOOL
//STRIP001 #define DFF_Prop_fc3DLightFace               703  //  BOOL
// 3D Style
//STRIP001 #define DFF_Prop_c3DYRotationAngle           704  //  LONG            degrees (16.16) about y axis
//STRIP001 #define DFF_Prop_c3DXRotationAngle           705  //  LONG            degrees (16.16) about x axis
//STRIP001 #define DFF_Prop_c3DRotationAxisX            706  //  LONG            These specify the rotation axis; only their relative magnitudes matter.
//STRIP001 #define DFF_Prop_c3DRotationAxisY            707  //  LONG
//STRIP001 #define DFF_Prop_c3DRotationAxisZ            708  //  LONG
//STRIP001 #define DFF_Prop_c3DRotationAngle            709  //  LONG            degrees (16.16) about axis
//STRIP001 #define DFF_Prop_c3DRotationCenterX          710  //  LONG            rotation center x (16.16 or g-units)
//STRIP001 #define DFF_Prop_c3DRotationCenterY          711  //  LONG            rotation center y (16.16 or g-units)
//STRIP001 #define DFF_Prop_c3DRotationCenterZ          712  //  LONG            rotation center z (absolute (emus))
//STRIP001 #define DFF_Prop_c3DRenderMode               713  //  MSO_3DRENDERMODE Full,wireframe, or bcube
//STRIP001 #define DFF_Prop_c3DTolerance                714  //  LONG            pixels (16.16)
//STRIP001 #define DFF_Prop_c3DXViewpoint               715  //  LONG            X view point (emus)
//STRIP001 #define DFF_Prop_c3DYViewpoint               716  //  LONG            Y view point (emus)
//STRIP001 #define DFF_Prop_c3DZViewpoint               717  //  LONG            Z view distance (emus)
//STRIP001 #define DFF_Prop_c3DOriginX                  718  //  LONG
//STRIP001 #define DFF_Prop_c3DOriginY                  719  //  LONG
//STRIP001 #define DFF_Prop_c3DSkewAngle                720  //  LONG            degree (16.16) skew angle
//STRIP001 #define DFF_Prop_c3DSkewAmount               721  //  LONG            Percentage skew amount
//STRIP001 #define DFF_Prop_c3DAmbientIntensity         722  //  LONG            Fixed point intensity
//STRIP001 #define DFF_Prop_c3DKeyX                     723  //  LONG            Key light source direc-
//STRIP001 #define DFF_Prop_c3DKeyY                     724  //  LONG            tion; only their relative
//STRIP001 #define DFF_Prop_c3DKeyZ                     725  //  LONG            magnitudes matter
//STRIP001 #define DFF_Prop_c3DKeyIntensity             726  //  LONG            Fixed point intensity
//STRIP001 #define DFF_Prop_c3DFillX                    727  //  LONG            Fill light source direc-
//STRIP001 #define DFF_Prop_c3DFillY                    728  //  LONG            tion; only their relative
//STRIP001 #define DFF_Prop_c3DFillZ                    729  //  LONG            magnitudes matter
//STRIP001 #define DFF_Prop_c3DFillIntensity            730  //  LONG            Fixed point intensity
//STRIP001 #define DFF_Prop_fc3DConstrainRotation       763  //  BOOL
//STRIP001 #define DFF_Prop_fc3DRotationCenterAuto      764  //  BOOL
//STRIP001 #define DFF_Prop_fc3DParallel                765  //  BOOL            Parallel projection?
//STRIP001 #define DFF_Prop_fc3DKeyHarsh                766  //  BOOL            Is key lighting harsh?
//STRIP001 #define DFF_Prop_fc3DFillHarsh               767  //  BOOL            Is fill lighting harsh?
// Shape
//STRIP001 #define DFF_Prop_hspMaster                   769  //  MSO_HSP          master shape
//STRIP001 #define DFF_Prop_cxstyle                     771  //  MSO_CXSTYLE      Type of connector
//STRIP001 #define DFF_Prop_bWMode                      772  //  MSO_BWMODE       Settings for modifications to be made when in different forms of black-and-white mode.
//STRIP001 #define DFF_Prop_bWModePureBW                773  //  MSO_BWMODE
//STRIP001 #define DFF_Prop_bWModeBW                    774  //  MSO_BWMODE
//STRIP001 #define DFF_Prop_fOleIcon                    826  //  BOOL            For OLE objects, whether the object is in icon form
//STRIP001 #define DFF_Prop_fPreferRelativeResize       827  //  BOOL            For UI only. Prefer relative resizing.
//STRIP001 #define DFF_Prop_fLockShapeType              828  //  BOOL            Lock the shape type (don't allow Change Shape)
//STRIP001 #define DFF_Prop_fDeleteAttachedObject       830  //  BOOL
//STRIP001 #define DFF_Prop_fBackground                 831  //  BOOL            If TRUE, this is the background shape.

// Callout
//STRIP001 #define DFF_Prop_spcot                       832  //  MSO_SPCOT        Callout type
//STRIP001 #define DFF_Prop_dxyCalloutGap               833  //  LONG            Distance from box to first point.(EMUs)
//STRIP001 #define DFF_Prop_spcoa                       834  //  MSO_SPCOA        Callout angle
//STRIP001 #define DFF_Prop_spcod                       835  //  MSO_SPCOD        Callout drop type
//STRIP001 #define DFF_Prop_dxyCalloutDropSpecified     836  //  LONG            if mso_spcodSpecified, the actual drop distance
//STRIP001 #define DFF_Prop_dxyCalloutLengthSpecified   837  //  LONG            if fCalloutLengthSpecified, the actual distance
//STRIP001 #define DFF_Prop_fCallout                    889  //  BOOL            Is the shape a callout?
//STRIP001 #define DFF_Prop_fCalloutAccentBar           890  //  BOOL            does callout have accent bar
//STRIP001 #define DFF_Prop_fCalloutTextBorder          891  //  BOOL            does callout have a text border
//STRIP001 #define DFF_Prop_fCalloutMinusX              892  //  BOOL
//STRIP001 #define DFF_Prop_fCalloutMinusY              893  //  BOOL
//STRIP001 #define DFF_Prop_fCalloutDropAuto            894  //  BOOL            If true, then we occasionally invert the drop distance
//STRIP001 #define DFF_Prop_fCalloutLengthSpecified     895  //  BOOL            if true, we look at dxyCalloutLengthSpecified

// GroupShape
//STRIP001 #define DFF_Prop_wzName                      896  //  WCHAR*          Shape Name (present only if explicitly set)
//STRIP001 #define DFF_Prop_wzDescription               897  //  WCHAR*          alternate text
//STRIP001 #define DFF_Prop_pihlShape                   898  //  IHlink*         The hyperlink in the shape.
//STRIP001 #define DFF_Prop_pWrapPolygonVertices        899  //  IMsoArray       The polygon that text will be wrapped around (Word)
//STRIP001 #define DFF_Prop_dxWrapDistLeft              900  //  LONG            Left wrapping distance from text (Word)
//STRIP001 #define DFF_Prop_dyWrapDistTop               901  //  LONG            Top wrapping distance from text (Word)
//STRIP001 #define DFF_Prop_dxWrapDistRight             902  //  LONG            Right wrapping distance from text (Word)
//STRIP001 #define DFF_Prop_dyWrapDistBottom            903  //  LONG            Bottom wrapping distance from text (Word)
//STRIP001 #define DFF_Prop_lidRegroup                  904  //  LONG            Regroup ID
//STRIP001 #define DFF_Prop_fEditedWrap                 953  //  BOOL            Has the wrap polygon been edited?
//STRIP001 #define DFF_Prop_fBehindDocument             954  //  BOOL            Word-only (shape is behind text)
//STRIP001 #define DFF_Prop_fOnDblClickNotify           955  //  BOOL            Notify client on a double click
//STRIP001 #define DFF_Prop_fIsButton                   956  //  BOOL            A button shape (i.e., clicking performs an action). Set for shapes with attached hyperlinks or macros.
//STRIP001 #define DFF_Prop_fOneD                       957  //  BOOL            1D adjustment
//STRIP001 #define DFF_Prop_fHidden                     958  //  BOOL            Do not display
//STRIP001 #define DFF_Prop_fPrint                      959  //  BOOL            Print this shape
// entsprechende BitFlags
//STRIP001 #define DFF_PBit_EditedWrap			0x00000040
//STRIP001 #define DFF_PBit_BehindDocument		0x00000020
//STRIP001 #define DFF_PBit_OnDblClickNotify	0x00000010
//STRIP001 #define DFF_PBit_IsButton			0x00000008
//STRIP001 #define DFF_PBit_OneD				0x00000004
//STRIP001 #define DFF_PBit_Hidden				0x00000002
//STRIP001 #define DFF_PBit_Print				0x00000001

// verschiedene enums aus der OfficeDraw-Doku, Appendix D - Anfang
//
// beachte: in Abweichung von der MS-Doku beginnen alle
// mit "mso_" statt mit "mso"
//
//STRIP001 enum MSO_ShapePath {
//STRIP001    mso_shapeLines,        // A line of straight segments
//STRIP001    mso_shapeLinesClosed,  // A closed polygonal object
//STRIP001    mso_shapeCurves,       // A line of Bezier curve segments
//STRIP001    mso_shapeCurvesClosed, // A closed shape with curved edges
//STRIP001    mso_shapeComplex       // pSegmentInfo must be non-empty
//STRIP001 };

//STRIP001 enum MSO_WrapMode {
//STRIP001    mso_wrapSquare,
//STRIP001    mso_wrapByPoints,
//STRIP001    mso_wrapNone,
//STRIP001    mso_wrapTopBottom,
//STRIP001    mso_wrapThrough
//STRIP001 };

//STRIP001 enum MSO_BWMode {
//STRIP001    mso_bwColor,          // only used for predefined shades
//STRIP001    mso_bwAutomatic,      // depends on object type
//STRIP001    mso_bwGrayScale,      // shades of gray only
//STRIP001    mso_bwLightGrayScale, // shades of light gray only
//STRIP001    mso_bwInverseGray,    // dark gray mapped to light gray, etc.
//STRIP001    mso_bwGrayOutline,    // pure gray and white
//STRIP001    mso_bwBlackTextLine,  // black text and lines, all else grayscale
//STRIP001    mso_bwHighContrast,   // pure black and white mode (no grays)
//STRIP001    mso_bwBlack,          // solid black
//STRIP001    mso_bwWhite,          // solid white
//STRIP001    mso_bwDontShow,       // object not drawn
//STRIP001    mso_bwNumModes        // number of Black and white modes
//STRIP001 };

//STRIP001 enum MSO_Anchor {
//STRIP001    mso_anchorTop,
//STRIP001    mso_anchorMiddle,
//STRIP001    mso_anchorBottom,
//STRIP001    mso_anchorTopCentered,
//STRIP001    mso_anchorMiddleCentered,
//STRIP001    mso_anchorBottomCentered,
//STRIP001    mso_anchorTopBaseline,
//STRIP001    mso_anchorBottomBaseline,
//STRIP001    mso_anchorTopCenteredBaseline,
//STRIP001    mso_anchorBottomCenteredBaseline
//STRIP001 };

//STRIP001 enum MSO_CDir {
//STRIP001    mso_cdir0,       // Right
//STRIP001    mso_cdir90,      // Down
//STRIP001    mso_cdir180,     // Left
//STRIP001    mso_cdir270      // Up
//STRIP001 };

// connector style
//STRIP001 enum MSO_ConnectorStyle {
//STRIP001    mso_cxstyleStraight = 0,
//STRIP001    mso_cxstyleBent,
//STRIP001    mso_cxstyleCurved,
//STRIP001    mso_cxstyleNone
//STRIP001 };

// MSO_TXFL -- text flow
//STRIP001 enum MSO_TextFlow {
//STRIP001    mso_txflHorzN,           // Horizontal non-@
//STRIP001    mso_txflTtoBA,           // Top to Bottom @-font
//STRIP001    mso_txflBtoT,            // Bottom to Top non-@
//STRIP001    mso_txflTtoBN,           // Top to Bottom non-@
//STRIP001    mso_txflHorzA,           // Horizontal @-font
//STRIP001    mso_txflVertN           // Vertical, non-@
//STRIP001 };

// MSO_TXDIR - text direction (needed for Bi-Di support)
//STRIP001 enum MSO_TextDir {
//STRIP001    mso_txdirLTR,            // left-to-right text direction
//STRIP001    mso_txdirRTL,            // right-to-left text direction
//STRIP001    mso_txdirContext        // context text direction
//STRIP001 };

// MSO_SPCOT -- Callout Type
//STRIP001 enum MSO_SPCalloutType {
//STRIP001    mso_spcotRightAngle = 1,
//STRIP001    mso_spcotOneSegment = 2,
//STRIP001    mso_spcotTwoSegment = 3,
//STRIP001    mso_spcotThreeSegment = 4
//STRIP001 };

// MSO_SPCOA -- Callout Angle
//STRIP001 enum MSO_SPCalloutAngle {
//STRIP001    mso_spcoaAny,
//STRIP001    mso_spcoa30,
//STRIP001    mso_spcoa45,
//STRIP001    mso_spcoa60,
//STRIP001    mso_spcoa90,
//STRIP001    mso_spcoa0
//STRIP001 };

// MSO_SPCOD -- Callout Drop
//STRIP001 enum MSO_SPCalloutDrop {
//STRIP001    mso_spcodTop,
//STRIP001    mso_spcodCenter,
//STRIP001    mso_spcodBottom,
//STRIP001    mso_spcodSpecified
//STRIP001 };

// MSO_GEOTEXTALIGN - WordArt alignment
//STRIP001 enum MSO_GeoTextAlign {
//STRIP001    mso_alignTextStretch,      /* Stretch each line of text to fit width. */
//STRIP001    mso_alignTextCenter,       /* Center text on width. */
//STRIP001    mso_alignTextLeft,         /* Left justify. */
//STRIP001    mso_alignTextRight,        /* Right justify. */
//STRIP001    mso_alignTextLetterJust,   /* Spread letters out to fit width. */
//STRIP001    mso_alignTextWordJust,     /* Spread words out to fit width. */
//STRIP001    mso_alignTextInvalid       /* Invalid */
//STRIP001 };

// MSO_BLIPFLAGS - flags for pictures
//STRIP001 enum MSO_BlipFlags {
//STRIP001    mso_blipflagDefault = 0,
//STRIP001    mso_blipflagComment = 0,   // Blip name is a comment
//STRIP001    mso_blipflagFile,          // Blip name is a file name
//STRIP001    mso_blipflagURL,           // Blip name is a full URL
//STRIP001    mso_blipflagType = 3,      // Mask to extract type
//STRIP001    /* Or the following flags with any of the above. */
//STRIP001    mso_blipflagDontSave = 4,  // A "dont" is the depression in the metal
//STRIP001 							 // body work of an automobile caused when a
//STRIP001 							 // cyclist violently thrusts his or her nose
//STRIP001 							 // at it, thus a DontSave is another name for
//STRIP001 							 // a cycle lane.
//STRIP001    mso_blipflagDoNotSave = 4, // For those who prefer English
//STRIP001    mso_blipflagLinkToFile = 8
//STRIP001 };

//STRIP001 enum MSO_3DRenderMode {
//STRIP001    mso_FullRender,      // Generate a full rendering
//STRIP001    mso_Wireframe,       // Generate a wireframe
//STRIP001    mso_BoundingCube    // Generate a bounding cube
//STRIP001 };

//STRIP001 enum MSO_XFormType {
//STRIP001    mso_xformAbsolute,   // Apply transform in absolute space centered on shape
//STRIP001    mso_xformShape,      // Apply transform to shape geometry
//STRIP001    mso_xformDrawing     // Apply transform in drawing space
//STRIP001 };

//STRIP001 enum MSO_ShadowType {
//STRIP001    mso_shadowOffset,    // N pixel offset shadow
//STRIP001    mso_shadowDouble,    // Use second offset too
//STRIP001    mso_shadowRich,      // Rich perspective shadow (cast relative to shape)
//STRIP001    mso_shadowShape,     // Rich perspective shadow (cast in shape space)
//STRIP001    mso_shadowDrawing,   // Perspective shadow cast in drawing space
//STRIP001    mso_shadowEmbossOrEngrave
//STRIP001 };

// MSO_DZTYPE - the type of a (length) measurement
//STRIP001 enum MSO_DZType {
//STRIP001    mso_dztypeMin          = 0,
//STRIP001    mso_dztypeDefault      = 0,  // Default size, ignore the values
//STRIP001    mso_dztypeA            = 1,  // Values are in EMUs
//STRIP001    mso_dztypeV            = 2,  // Values are in pixels
//STRIP001    mso_dztypeShape        = 3,  // Values are 16.16 fractions of shape size
//STRIP001    mso_dztypeFixedAspect  = 4,  // Aspect ratio is fixed
//STRIP001    mso_dztypeAFixed       = 5,  // EMUs, fixed aspect ratio
//STRIP001    mso_dztypeVFixed       = 6,  // Pixels, fixed aspect ratio
//STRIP001    mso_dztypeShapeFixed   = 7,  // Proportion of shape, fixed aspect ratio
//STRIP001    mso_dztypeFixedAspectEnlarge
//STRIP001 						 = 8,  // Aspect ratio is fixed, favor larger size
//STRIP001    mso_dztypeAFixedBig    = 9,  // EMUs, fixed aspect ratio
//STRIP001    mso_dztypeVFixedBig    = 10, // Pixels, fixed aspect ratio
//STRIP001    mso_dztypeShapeFixedBig= 11, // Proportion of shape, fixed aspect ratio
//STRIP001    mso_dztypeMax          = 11
//STRIP001 };

//STRIP001 enum MSO_FillType {
//STRIP001    mso_fillSolid,             // Fill with a solid color
//STRIP001    mso_fillPattern,           // Fill with a pattern (bitmap)
//STRIP001    mso_fillTexture,           // A texture (pattern with its own color map)
//STRIP001    mso_fillPicture,           // Center a picture in the shape
//STRIP001    mso_fillShade,             // Shade from start to end points
//STRIP001    mso_fillShadeCenter,       // Shade from bounding rectangle to end point
//STRIP001    mso_fillShadeShape,        // Shade from shape outline to end point
//STRIP001    mso_fillShadeScale,        // Similar to mso_fillShade, but the fillAngle
//STRIP001 							 // is additionally scaled by the aspect ratio of
//STRIP001 							 // the shape. If shape is square, it is the
//STRIP001 							 // same as mso_fillShade.
//STRIP001    mso_fillShadeTitle,        // special type - shade to title ---  for PP
//STRIP001    mso_fillBackground         // Use the background fill color/pattern
//STRIP001 };

// MSO_SHADETYPE - how to interpret the colors in a shaded fill.
//STRIP001 enum MSO_ShadeType {
//STRIP001    mso_shadeNone  = 0,        // Interpolate without correction between RGBs
//STRIP001    mso_shadeGamma = 1,        // Apply gamma correction to colors
//STRIP001    mso_shadeSigma = 2,        // Apply a sigma transfer function to position
//STRIP001    mso_shadeBand  = 4,        // Add a flat band at the start of the shade
//STRIP001    mso_shadeOneColor = 8,     // This is a one color shade
//STRIP001 
//STRIP001    /* A parameter for the band or sigma function can be stored in the top
//STRIP001 	  16 bits of the value - this is a proportion of *each* band of the
//STRIP001 	  shade to make flat (or the approximate equal value for a sigma
//STRIP001 	  function).  NOTE: the parameter is not used for the sigma function,
//STRIP001 	  instead a built in value is used.  This value should not be changed
//STRIP001 	  from the default! */
//STRIP001    mso_shadeParameterShift = 16,
//STRIP001    mso_shadeParameterMask  = 0xffff0000,
//STRIP001 
//STRIP001    mso_shadeDefault = (mso_shadeGamma|mso_shadeSigma|
//STRIP001 					 (16384<<mso_shadeParameterShift))
//STRIP001 };

// MSOLINESTYLE - compound line style
//STRIP001 enum MSO_LineStyle {
//STRIP001    mso_lineSimple,			// Single line (of width lineWidth)
//STRIP001    mso_lineDouble,			// Double lines of equal width
//STRIP001    mso_lineThickThin,		// Double lines, one thick, one thin
//STRIP001    mso_lineThinThick,		// Double lines, reverse order
//STRIP001    mso_lineTriple			// Three lines, thin, thick, thin
//STRIP001 };

// MSO_LINETYPE - how to "fill" the line contour
//STRIP001 enum MSO_LineType {
//STRIP001    mso_lineSolidType,         // Fill with a solid color
//STRIP001    mso_linePattern,           // Fill with a pattern (bitmap)
//STRIP001    mso_lineTexture,           // A texture (pattern with its own color map)
//STRIP001    mso_linePicture            // Center a picture in the shape
//STRIP001 };

// MSO_LINEDASHING - dashed line style
//STRIP001 enum MSO_LineDashing {
//STRIP001    mso_lineSolid,              // Solid (continuous) pen
//STRIP001    mso_lineDashSys,            // PS_DASH system   dash style
//STRIP001    mso_lineDotSys,             // PS_DOT system   dash style
//STRIP001    mso_lineDashDotSys,         // PS_DASHDOT system dash style
//STRIP001    mso_lineDashDotDotSys,      // PS_DASHDOTDOT system dash style
//STRIP001    mso_lineDotGEL,             // square dot style
//STRIP001    mso_lineDashGEL,            // dash style
//STRIP001    mso_lineLongDashGEL,        // long dash style
//STRIP001    mso_lineDashDotGEL,         // dash short dash
//STRIP001    mso_lineLongDashDotGEL,     // long dash short dash
//STRIP001    mso_lineLongDashDotDotGEL   // long dash short dash short dash
//STRIP001 };

// MSO_LINEEND - line end effect
//STRIP001 enum MSO_LineEnd {
//STRIP001    mso_lineNoEnd,
//STRIP001    mso_lineArrowEnd,
//STRIP001    mso_lineArrowStealthEnd,
//STRIP001    mso_lineArrowDiamondEnd,
//STRIP001    mso_lineArrowOvalEnd,
//STRIP001    mso_lineArrowOpenEnd
//STRIP001 };

// MSO_LINEENDWIDTH - size of arrowhead
//STRIP001 enum MSO_LineEndWidth {
//STRIP001    mso_lineNarrowArrow,
//STRIP001    mso_lineMediumWidthArrow,
//STRIP001    mso_lineWideArrow
//STRIP001 };

// MSO_LINEENDLENGTH - size of arrowhead
//STRIP001 enum MSO_LineEndLength {
//STRIP001    mso_lineShortArrow,
//STRIP001    mso_lineMediumLenArrow,
//STRIP001    mso_lineLongArrow
//STRIP001 };

// MSO_LINEJOIN - line join style.
//STRIP001 enum MSO_LineJoin {
//STRIP001    mso_lineJoinBevel,     // Join edges by a straight line
//STRIP001    mso_lineJoinMiter,     // Extend edges until they join
//STRIP001    mso_lineJoinRound      // Draw an arc between the two edges
//STRIP001 };

// MSO_LINECAP - line cap style (applies to ends of dash segments too).
//STRIP001 enum MSO_LineCap {
//STRIP001    mso_lineEndCapRound,   // Rounded ends - the default
//STRIP001    mso_lineEndCapSquare,  // Square protrudes by half line width
//STRIP001    mso_lineEndCapFlat     // Line ends at end point
//STRIP001 };
// verschiedene enums aus der OfficeDraw-Doku, Appendix D - Ende

// BStore-Container
// FBSE - File Blip Store Entry
//STRIP001 typedef struct _MSOF_BSE {
//STRIP001    BYTE      btWin32;    // Required type on Win32
//STRIP001    BYTE      btMacOS;    // Required type on Mac
//STRIP001    BYTE      rgbUid[16]; // Identifier of blip
//STRIP001    USHORT    tag;        // currently unused
//STRIP001    ULONG     size;       // Blip size in stream
//STRIP001    ULONG     cRef;       // Reference count on the blip
//STRIP001    ULONG /*MSOFO*/ foDelay;    // File offset in the delay stream
//STRIP001    BYTE      usage;      // How this blip is used (MSOBLIPUSAGE)
//STRIP001    BYTE      cbName;     // length of the blip name
//STRIP001    BYTE      unused2;    // for the future
//STRIP001    BYTE      unused3;    // for the future
//STRIP001 } MSO_FBSE;

//STRIP001 typedef enum {
//STRIP001    mso_blipUsageDefault,  // All non-texture fill blips get this.
//STRIP001    mso_blipUsageTexture,
//STRIP001    mso_blipUsageMax = 255 // Since this is stored in a byte
//STRIP001 } MSO_BLIPUSAGE;

//STRIP001 typedef enum {                          // GEL provided types...
//STRIP001    mso_blipERROR = 0,          // An error occured during loading
//STRIP001    mso_blipUNKNOWN,            // An unknown blip type
//STRIP001    mso_blipEMF,                // Windows Enhanced Metafile
//STRIP001    mso_blipWMF,                // Windows Metafile
//STRIP001    mso_blipPICT,               // Macintosh PICT
//STRIP001    mso_blipJPEG,               // JFIF
//STRIP001    mso_blipPNG,                // PNG
//STRIP001    mso_blipDIB,                // Windows DIB
//STRIP001    mso_blipFirstClient = 32,   // First client defined blip type
//STRIP001    mso_blipLastClient  = 255   // Last client defined blip type
//STRIP001 } MSO_BLIPTYPE;

//STRIP001 typedef enum {
//STRIP001    mso_biUNKNOWN = 0,
//STRIP001    mso_biWMF  = 0x216,      // Metafile header then compressed WMF
//STRIP001    mso_biEMF  = 0x3D4,      // Metafile header then compressed EMF
//STRIP001    mso_biPICT = 0x542,      // Metafile header then compressed PICT
//STRIP001    mso_biPNG  = 0x6E0,      // One byte tag then PNG data
//STRIP001    mso_biJFIF = 0x46A,      // One byte tag then JFIF data
//STRIP001    mso_biJPEG = mso_biJFIF,
//STRIP001    mso_biDIB  = 0x7A8,      // One byte tag then DIB data
//STRIP001    mso_biClient=0x800       // Clients should set this bit
//STRIP001 } MSO_BI;                     // Blip signature as encoded in the MSO_FBH.inst

//STRIP001 typedef enum {
//STRIP001    mso_compressionDeflate = 0,
//STRIP001    mso_compressionNone = 254,    // Used only if compression fails
//STRIP001    mso_compressionTest = 255     // For testing only
//STRIP001 } MSO_BLIPCOMPRESSION;

//STRIP001 typedef enum {
//STRIP001    mso_filterAdaptive = 0,       // PNG type - not used/supported for metafile
//STRIP001    mso_filterNone = 254,
//STRIP001    mso_filterTest = 255          // For testing only
//STRIP001 } MSO_BLIPFILTER;

//STRIP001 #ifdef Hier_noch_was_aus_der_Doku
/* The secondary, or data, UID - should always be set. */
//STRIP001 BYTE  m_rgbUid[16];
/* The primary UID - this defaults to 0, in which case the primary ID is
   that of the internal data. NOTE!: The primary UID is only saved to disk
   if (blip_instance ^ blip_signature == 1). Blip_instance is MSO_FBH.inst and
   blip_signature is one of the values defined in MSO_BI */
//STRIP001 BYTE  m_rgbUidPrimary[16]; // optional based on the above check

/* Metafile Blip overhead = 34 bytes. m_cb gives the number of
   bytes required to store an uncompressed version of the file, m_cbSave
   is the compressed size.  m_mfBounds gives the boundary of all the
   drawing calls within the metafile (this may just be the bounding box
   or it may allow some whitespace, for a WMF this comes from the
   SetWindowOrg and SetWindowExt records of the metafile). */
//STRIP001 int           m_cb;           // Cache of the metafile size
//STRIP001 RECT          m_rcBounds;     // Boundary of metafile drawing commands
//STRIP001 POINT         m_ptSize;       // Size of metafile in EMUs
//STRIP001 int           m_cbSave;       // Cache of saved size (size of m_pvBits)
//STRIP001 BYTE          m_fCompression; // MSO_BLIPCOMPRESSION
//STRIP001 BYTE          m_fFilter;      // always mso_filterNone
//STRIP001 void         *m_pvBits;       // Compressed bits of metafile.

/* The secondary, or data, UID - should always be set. */
//STRIP001 BYTE  m_rgbUid[16];
/* The primary UID - this defaults to 0, in which case the primary ID is
   that of the internal data. NOTE!: The primary UID is only saved to disk
   if (blip_instance ^ blip_signature == 1). Blip_instance is MSO_FBH.finst and
   blip_signature is one of the values defined in MSO_BI*/
//STRIP001 BYTE  m_rgbUidPrimary[16];    // optional based on the above check
//STRIP001 BYTE  m_bTag;
//STRIP001 void  *m_pvBits;              // raster bits of the blip.
//STRIP001 #endif

//STRIP001 class DffRecordHeader
//STRIP001 {
//STRIP001 
//STRIP001 public:
//STRIP001 	BYTE    nRecVer; // may be DFF_PSFLAG_CONTAINER
//STRIP001 	UINT16  nRecInstance;
//STRIP001 	UINT16  nImpVerInst;
//STRIP001 	UINT16  nRecType;
//STRIP001 	UINT32  nRecLen;
//STRIP001 	ULONG	nFilePos;
//STRIP001 public:
//STRIP001 	FASTBOOL IsContainer() const { return nRecVer == DFF_PSFLAG_CONTAINER; }
//STRIP001 	ULONG    GetRecBegFilePos() const { return nFilePos; }
//STRIP001 	ULONG    GetRecEndFilePos() const { return nFilePos + DFF_COMMON_RECORD_HEADER_SIZE + nRecLen; }
//STRIP001 	void SeekToEndOfRecord(SvStream& rIn) const { rIn.Seek(nFilePos + DFF_COMMON_RECORD_HEADER_SIZE + nRecLen ); }
//STRIP001 	void SeekToContent(    SvStream& rIn) const { rIn.Seek(nFilePos + DFF_COMMON_RECORD_HEADER_SIZE ); }
//STRIP001 	void SeekToBegOfRecord(SvStream& rIn) const { rIn.Seek( nFilePos ); }
//STRIP001 
//STRIP001 	friend SvStream& operator>>(SvStream& rIn, DffRecordHeader& rRec);
//STRIP001 
//STRIP001 };

//STRIP001 struct DffPropFlags
//STRIP001 {
//STRIP001 	BYTE	bSet		: 1;
//STRIP001 	BYTE	bComplex	: 1;
//STRIP001 	BYTE	bBlip		: 1;
//STRIP001 	BYTE	bSoftAttr	: 1;
//STRIP001 };

//STRIP001 class SvxMSDffManager;

//STRIP001 class DffPropSet : public Table
//STRIP001 {
//STRIP001 	protected :
//STRIP001 
//STRIP001 		UINT32			mpContents[ 1024 ];
//STRIP001 		DffPropFlags	mpFlags[ 1024 ];
//STRIP001 
//STRIP001 	public :
//STRIP001 
//STRIP001 		DffPropSet( BOOL bInitialize = FALSE ){ if ( bInitialize )
//STRIP001 												memset( mpFlags, 0, 0x400 * sizeof( DffPropFlags ) ); };
//STRIP001 
//STRIP001 		inline BOOL	IsProperty( UINT32 nRecType ) const { return ( mpFlags[ nRecType & 0x3ff ].bSet ); };
//STRIP001 		BOOL		IsHardAttribute( UINT32 nId ) const;
//STRIP001 		UINT32		GetPropertyValue( UINT32 nId, UINT32 nDefault = 0 ) const;
//STRIP001 		void		SetPropertyValue( UINT32 nId, UINT32 nValue ) const;
//STRIP001 		BOOL		SeekToContent( UINT32 nRecType, SvStream& rSt ) const;
//STRIP001 		void		Merge( DffPropSet& rMasterPropSet ) const;
//STRIP001 		void		InitializePropSet() const;
//STRIP001 		friend SvStream& operator>>( SvStream& rIn, DffPropSet& rPropSet );
//STRIP001 };

//STRIP001 class SdrObject;

//STRIP001 class DffPropertyReader : public DffPropSet
//STRIP001 {
//STRIP001 	const SvxMSDffManager&	rManager;
//STRIP001 	DffPropSet*				pDefaultPropSet;
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 	INT32					mnFix16Angle;
//STRIP001 
//STRIP001 	DffPropertyReader( const SvxMSDffManager& rManager );
//STRIP001 	~DffPropertyReader();
//STRIP001 	INT32		Fix16ToAngle( INT32 nAngle ) const;
//STRIP001 
//STRIP001 #ifdef DBG_AUTOSHAPE
//STRIP001 	void		ReadPropSet( SvStream& rIn, void* pClientData, UINT32 nShapeType = 0 ) const;
//STRIP001 #else
//STRIP001 	void		ReadPropSet( SvStream& rIn, void* pClientData ) const;
//STRIP001 #endif
//STRIP001 
//STRIP001 	void		SetDefaultPropSet( SvStream& rIn, UINT32 nOffDgg ) const;
//STRIP001 	void		ApplyAttributes( SvStream& rIn, SfxItemSet& rSet, SdrObject* pObj = NULL ) const;
//STRIP001 };

}//end of namespace binfilter
#endif
