/*************************************************************************
 *
 *  $RCSfile: numvset.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:20:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_NUMVSET_HXX
#define _SVX_NUMVSET_HXX

// include ---------------------------------------------------------------

// auto strip #ifndef _VALUESET_HXX //autogen
// auto strip #include <svtools/valueset.hxx>
// auto strip #endif
#include <limits.h>
#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_
#include <com/sun/star/uno/Reference.h>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_H_
#include <com/sun/star/uno/Sequence.h>
#endif
// auto strip #ifndef _COM_SUN_STAR_LANG_LOCALE_HPP_
// auto strip #include <com/sun/star/lang/Locale.hpp>
// auto strip #endif
namespace binfilter {

namespace com{namespace sun{ namespace star{
	namespace container{
		class XIndexAccess;
	}
	namespace beans{
		struct PropertyValue;
	}
	namespace text{
		class XNumberingFormatter;
	}
}}}

//STRIP001 class SvxBrushItem;
//STRIP001 class SvxNumRule;
//STRIP001 struct SvxBmpItemInfo
//STRIP001 {
//STRIP001 	SvxBrushItem* 	pBrushItem;
//STRIP001 	USHORT 			nItemId;
//STRIP001 };

/*-----------------09/09/97 01:05pm-----------------

--------------------------------------------------*/
//STRIP001 class SvxNumValueSet : public ValueSet
//STRIP001 {
//STRIP001 	Color 			aLineColor;
//STRIP001 	USHORT 			nPageType;
//STRIP001 	BOOL			bHTMLMode;
//STRIP001 	Rectangle		aOrgRect;
//STRIP001 	VirtualDevice* 	pVDev;
//STRIP001 
//STRIP001 	::com::sun::star::uno::Reference< ::com::sun::star::text::XNumberingFormatter> xFormatter;
//STRIP001 	::com::sun::star::lang::Locale aLocale;
//STRIP001 
//STRIP001 	::com::sun::star::uno::Sequence<
//STRIP001 		::com::sun::star::uno::Sequence<
//STRIP001 			::com::sun::star::beans::PropertyValue> > aNumSettings;
//STRIP001 
//STRIP001 	::com::sun::star::uno::Sequence<
//STRIP001 		::com::sun::star::uno::Reference<
//STRIP001 			::com::sun::star::container::XIndexAccess> > aOutlineSettings;
//STRIP001 	public:
//STRIP001 		SvxNumValueSet( Window* pParent, const ResId& rResId, USHORT nType );
//STRIP001 		~SvxNumValueSet();
//STRIP001 
//STRIP001 	virtual void	UserDraw( const UserDrawEvent& rUDEvt );
//STRIP001 
//STRIP001 	void			SetHTMLMode(BOOL bSet) {bHTMLMode = bSet;}
//STRIP001 	void			SetNumberingSettings(
//STRIP001 		const ::com::sun::star::uno::Sequence<
//STRIP001 			::com::sun::star::uno::Sequence<
//STRIP001 				::com::sun::star::beans::PropertyValue> >& aNum,
//STRIP001 		::com::sun::star::uno::Reference< ::com::sun::star::text::XNumberingFormatter>& xFormatter,
//STRIP001 		const ::com::sun::star::lang::Locale& rLocale	);
//STRIP001 
//STRIP001 	void			SetOutlineNumberingSettings(
//STRIP001 			::com::sun::star::uno::Sequence<
//STRIP001 				::com::sun::star::uno::Reference<
//STRIP001 					::com::sun::star::container::XIndexAccess> >& rOutline,
//STRIP001 			::com::sun::star::uno::Reference< ::com::sun::star::text::XNumberingFormatter>& xFormatter,
//STRIP001 			const ::com::sun::star::lang::Locale& rLocale);
//STRIP001 };

/*-----------------13.02.97 09.32-------------------

--------------------------------------------------*/

//STRIP001 class SvxBmpNumValueSet : public SvxNumValueSet
//STRIP001 {
//STRIP001     String      sBullets;
//STRIP001 	Timer 		aFormatTimer;
//STRIP001 	BOOL		bGrfNotFound;
//STRIP001 
//STRIP001 	protected:
//STRIP001 		DECL_LINK(FormatHdl_Impl, Timer*);
//STRIP001 
//STRIP001 	void			SetGrfNotFound(BOOL bSet) {bGrfNotFound = bSet;}
//STRIP001 	BOOL			IsGrfNotFound()const {return bGrfNotFound;}
//STRIP001 
//STRIP001 	Timer&			GetFormatTimer() {return aFormatTimer;}
//STRIP001 
//STRIP001 	public:
//STRIP001         SvxBmpNumValueSet( Window* pParent, const ResId& rResId/*, const List& rStrNames*/);
//STRIP001 		~SvxBmpNumValueSet();
//STRIP001 
//STRIP001 	virtual void	UserDraw( const UserDrawEvent& rUDEvt );
//STRIP001 
//STRIP001 };
/*-----------------02.12.97 10:31-------------------

--------------------------------------------------*/

//STRIP001 class SvxNumberingPreview : public Window
//STRIP001 {
//STRIP001 	const SvxNumRule* 	pActNum;
//STRIP001 	Font 				aStdFont;
//STRIP001 	long				nPageWidth;
//STRIP001 	const String* 		pOutlineNames;
//STRIP001 	BOOL				bPosition;
//STRIP001 	UINT16 				nActLevel;
//STRIP001 
//STRIP001 	protected:
//STRIP001 		virtual void		Paint( const Rectangle& rRect );
//STRIP001 
//STRIP001 	public:
//STRIP001 		SvxNumberingPreview(Window* pParent, const ResId& rResId ) :
//STRIP001 			Window(pParent, rResId),
//STRIP001             pActNum(0),nPageWidth(0), pOutlineNames(0), bPosition(FALSE), nActLevel(USHRT_MAX)
//STRIP001             { SetBorderStyle( WINDOW_BORDER_MONO ); }
//STRIP001 
//STRIP001 		void	SetNumRule(const SvxNumRule* pNum)
//STRIP001 					{pActNum = pNum; Invalidate();};
//STRIP001 		void	SetPageWidth(long nPgWidth)
//STRIP001 								{nPageWidth = nPgWidth;}
//STRIP001 		void	SetOutlineNames(const String* pNames)
//STRIP001 						{pOutlineNames = pNames;}
//STRIP001 		void	SetPositionMode()
//STRIP001 						{ bPosition = TRUE;}
//STRIP001 		void	SetLevel(USHORT nSet) {nActLevel = nSet;}
//STRIP001 
//STRIP001 };

}//end of namespace binfilter
#endif

