/*************************************************************************
 *
 *  $RCSfile: svdfppt.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: aw $ $Date: 2004/02/13 14:31:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SVDFPPT_HXX
#define _SVDFPPT_HXX

#ifndef SVX_LIGHT

#ifndef _SOLAR_H
#include <tools/solar.h>
#endif

#ifndef _SVARRAY_HXX
#include <svtools/svarray.hxx>
#endif

#ifndef _STRING_HXX
#include <tools/string.hxx>
#endif
#ifndef _GEN_HXX
#include <tools/gen.hxx>
#endif
#ifndef _COLOR_HXX
#include <tools/color.hxx>
#endif

#ifndef _SVDOBJ_HXX
#include <bf_svx/svdobj.hxx>
#endif

#ifndef _SVX_NUMITEM_HXX
#include <bf_svx/numitem.hxx>
#endif

#ifndef _MyEDITDATA_HXX
#include <bf_svx/editdata.hxx>
#endif

#ifndef _MSDFFIMP_HXX
#include <bf_svx/msdffimp.hxx>			//	Escher-Grafikimport
#endif
#ifndef _MSOCXIMEX_HXX
#include <bf_svx/msocximex.hxx>
#endif
//STRIP001 class SvStorage;
//STRIP001 class SvStream;
//STRIP001 class SfxItemSet;
namespace binfilter {

////////////////////////////////////////////////////////////////////////////////////////////////////


//STRIP001 class SdrModel;
//STRIP001 class SdPage;
//STRIP001 class SdrPage;
//STRIP001 class SdrObject;
//STRIP001 class Polygon;
//STRIP001 class PolyPolygon;
//STRIP001 class XPolygon;
//STRIP001 class XPolyPolygon;
//STRIP001 class Outliner;
//STRIP001 class Graphic;
//STRIP001 class SvxMSDffManager;
//STRIP001 class PptTextMetaCharList;
//STRIP001 class DffRecordHeader;
//STRIP001 struct PptCharAttrSet;
//STRIP001 class SvxBulletItem;
//STRIP001 
//STRIP001 #define PPT_IMPORTFLAGS_NO_TEXT_ASSERT  1
//STRIP001 
//STRIP001 struct PowerPointImportParam
//STRIP001 {
//STRIP001     SvStream&   rDocStream;
//STRIP001     sal_uInt32  nImportFlags;
//STRIP001 
//STRIP001     PowerPointImportParam( SvStream& rDocStream, sal_uInt32 nImportFlags );
//STRIP001 };
//STRIP001 
//STRIP001 struct SdHyperlinkEntry
//STRIP001 {
//STRIP001 	sal_uInt32  nIndex;
//STRIP001 	sal_Int32   nPrivate1;
//STRIP001 	sal_Int32   nPrivate2;
//STRIP001 	sal_Int32   nPrivate3;
//STRIP001 	sal_Int32   nInfo;
//STRIP001 	String		aTarget;
//STRIP001 	String		aSubAdress;
//STRIP001 
//STRIP001 	sal_Int32   nStartPos;
//STRIP001 	sal_Int32   nEndPos;
//STRIP001 	
//STRIP001 	String	    aConvSubString;
//STRIP001 	ESelection	aESelection;
//STRIP001 	sal_Bool    bSelection;
//STRIP001 };
//STRIP001 
//STRIP001 // Hilfsklasse zum Einlesen der PPT InteractiveInfoAtom
//STRIP001 struct PptInteractiveInfoAtom
//STRIP001 {
//STRIP001 	UINT32			nSoundRef;
//STRIP001 	UINT32			nExHyperlinkId;
//STRIP001 	UINT8			nAction;
//STRIP001 	UINT8			nOleVerb;
//STRIP001 	UINT8			nJump;
//STRIP001 	UINT8			nFlags;
//STRIP001 	UINT8			nHyperlinkType;
//STRIP001 
//STRIP001 	// unknown, da Gesamtgroesse 16 ist
//STRIP001 	UINT8			nUnknown1;
//STRIP001 	UINT8			nUnknown2;
//STRIP001 	UINT8			nUnknown3;
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001     friend SvStream& operator>>( SvStream& rIn, PptInteractiveInfoAtom& rAtom );
//STRIP001 };
//STRIP001 
//STRIP001 enum PptPageKind { PPT_MASTERPAGE, PPT_SLIDEPAGE, PPT_NOTEPAGE };
//STRIP001 
//STRIP001 enum PptPageFormat
//STRIP001 {	PPTPF_SCREEN,   //
//STRIP001     PPTPF_USLETTER, // 8.5x11"
//STRIP001     PPTPF_A4,       // 210x297mm
//STRIP001     PPTPF_35MMDIA,  // DIA
//STRIP001     PPTPF_OVERHEAD, //
//STRIP001     PPTPF_CUSTOM
//STRIP001 };
//STRIP001 
//STRIP001 // Werte fuer den ULONG im PPT_PST_TextHeaderAtom
//STRIP001 enum PPT_TextHeader
//STRIP001 {
//STRIP001 	PPTTH_TITLE,
//STRIP001     PPTTH_BODY,
//STRIP001     PPTTH_NOTES,
//STRIP001     PPTTH_NOTUSED,
//STRIP001     PPTTH_OTHER,       // Text in a Shape
//STRIP001     PPTTH_CENTERBODY,  // Subtitle in Title-Slide
//STRIP001     PPTTH_CENTERTITLE, // Title in Title-Slide
//STRIP001     PPTTH_HALFBODY,    // Body in two-column slide
//STRIP001     PPTTH_QUARTERBODY  // Body in four-body slide
//STRIP001 };
//STRIP001 
//STRIP001 #define	TSS_TYPE_PAGETITLE		(0)
//STRIP001 #define	TSS_TYPE_BODY			(1)
//STRIP001 #define	TSS_TYPE_NOTES			(2)
//STRIP001 #define	TSS_TYPE_UNUSED			(3)
//STRIP001 #define	TSS_TYPE_TEXT_IN_SHAPE	(4)
//STRIP001 #define	TSS_TYPE_SUBTITLE		(5)
//STRIP001 #define	TSS_TYPE_TITLE			(6)
//STRIP001 #define	TSS_TYPE_HALFBODY		(7)
//STRIP001 #define	TSS_TYPE_QUARTERBODY	(8)
//STRIP001 
//STRIP001 // Inventor-Id fuer PPT UserData
//STRIP001 const UINT32 PPTInventor =UINT32('P')*0x00000001+
//STRIP001 						  UINT32('P')*0x00000100+
//STRIP001 						  UINT32('T')*0x00010000+
//STRIP001 						  UINT32('0')*0x01000000;
//STRIP001 
//STRIP001 // Object-Ids fuer StarDraw UserData
//STRIP001 #define PPT_OBJECTINFO_ID		(1)
//STRIP001 
//STRIP001 struct PptDocumentAtom
//STRIP001 {
//STRIP001     Size			aSlidesPageSize;					// Seitengroesse der Slides in 576DPI
//STRIP001     Size			aNotesPageSize;						// Seitengroesse der Notes in 576DPI
//STRIP001     // RatioAtom erstmal weggelassen
//STRIP001     UINT32			nNotesMasterPersist;				// 0=nicht vorhanden
//STRIP001     UINT32			nHandoutMasterPersist;				// 0=nicht vorhanden
//STRIP001     UINT16			n1stPageNumber;						// Seitennummer des ersten Slides
//STRIP001     PptPageFormat	eSlidesPageFormat;					// Seitenformat der Slides
//STRIP001     sal_Bool		bEmbeddedTrueType			: 1;	// TrueType direkt im File?
//STRIP001     sal_Bool		bTitlePlaceholdersOmitted	: 1;
//STRIP001     sal_Bool		bRightToLeft				: 1;
//STRIP001     sal_Bool		bShowComments				: 1;
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001     Size	GetPageSize( const Size& rSiz ) const;
//STRIP001     Size	GetSlidesPageSize() const { return GetPageSize( aSlidesPageSize ); }
//STRIP001     Size	GetNotesPageSize() const { return GetPageSize( aNotesPageSize ); }
//STRIP001 
//STRIP001     friend SvStream& operator>>( SvStream& rIn, PptDocumentAtom& rAtom );
//STRIP001 };
//STRIP001 
//STRIP001 struct PptSlideLayoutAtom
//STRIP001 {
//STRIP001     INT32				eLayout;				// 0..18
//STRIP001     BYTE				aPlaceholderId[ 8 ];
//STRIP001     ULONG				aPlacementId[ 8 ];
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 						PptSlideLayoutAtom() { Clear(); }
//STRIP001     void				Clear();
//STRIP001 
//STRIP001     // Das SlideLayoutAtom wird ohne Header eingelesen!
//STRIP001     friend SvStream& operator>>( SvStream& rIn, PptSlideLayoutAtom& rAtom );
//STRIP001 };
//STRIP001 
//STRIP001 struct PptSlideAtom
//STRIP001 {
//STRIP001     PptSlideLayoutAtom	aLayout;
//STRIP001     UINT32				nMasterId;
//STRIP001     UINT32				nNotesId;
//STRIP001     UINT16				nFlags;
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 						PptSlideAtom() { Clear(); }
//STRIP001     void				Clear();
//STRIP001 
//STRIP001     friend SvStream& operator>>(SvStream& rIn, PptSlideAtom& rAtom);
//STRIP001 };
//STRIP001 
//STRIP001 struct PptSlidePersistAtom
//STRIP001 {
//STRIP001     UINT32				nPsrReference;
//STRIP001     UINT32				nFlags;
//STRIP001     UINT32				nNumberTexts;
//STRIP001     UINT32				nSlideId;
//STRIP001     UINT32				nReserved;					// we will use nReserved temporarly to set the offset to SSSlideInfoAtom ( if possible )
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 						PptSlidePersistAtom() { Clear(); }
//STRIP001     void				Clear();
//STRIP001 
//STRIP001     friend SvStream& operator>>(SvStream& rIn, PptSlidePersistAtom& rAtom);
//STRIP001 };
//STRIP001 
//STRIP001 struct PptNotesAtom
//STRIP001 {
//STRIP001     UINT32				nSlideId;
//STRIP001     UINT16				nFlags;
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 						PptNotesAtom() { Clear(); }
//STRIP001     void				Clear();
//STRIP001 
//STRIP001     friend SvStream& operator>>(SvStream& rIn, PptNotesAtom& rAtom);
//STRIP001 };
//STRIP001 
//STRIP001 struct PptColorSchemeAtom
//STRIP001 {
//STRIP001     BYTE				aData[32];
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001     Color				GetColor( USHORT nNum ) const;
//STRIP001 
//STRIP001     friend SvStream& operator>>(SvStream& rIn, PptColorSchemeAtom& rAtom);
//STRIP001 };
//STRIP001 
//STRIP001 struct PptFontEntityAtom
//STRIP001 {
//STRIP001     String				aName;
//STRIP001     double              fScaling;
//STRIP001 	sal_uInt8			lfClipPrecision;
//STRIP001 	sal_uInt8			lfQuality;
//STRIP001 
//STRIP001 	sal_uInt32			nUniqueFontId;          // not used anymore
//STRIP001 	CharSet				eCharSet;
//STRIP001 	FontFamily			eFamily;
//STRIP001 	FontPitch			ePitch;
//STRIP001 	sal_Bool			bAvailable;
//STRIP001 
//STRIP001     friend SvStream& operator>>(SvStream& rIn, PptFontEntityAtom& rAtom);
//STRIP001 };
//STRIP001 
//STRIP001 class PptFontCollection;
//STRIP001 struct PptUserEditAtom
//STRIP001 {
//STRIP001     INT32				nLastSlideID;            // ID of last visible slide
//STRIP001     UINT32				nVersion;                // This is major/minor/build which did the edit
//STRIP001     UINT32				nOffsetLastEdit;         // File offset of prev PptUserEditAtom
//STRIP001     UINT32				nOffsetPersistDirectory; // Offset to PersistPtrs for this file version.
//STRIP001     UINT32				nDocumentRef;
//STRIP001     UINT32				nMaxPersistWritten;      // Gesamtanzahl der Persisteintraege bis hierher.
//STRIP001     INT16				eLastViewType;           // enum view type
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001     friend SvStream& operator>>( SvStream& rIn, PptUserEditAtom& rAtom );
//STRIP001 };
//STRIP001 
//STRIP001 struct PptOEPlaceholderAtom
//STRIP001 {
//STRIP001     UINT32				nPlacementId;
//STRIP001     BYTE				nPlaceholderId;
//STRIP001     BYTE				nPlaceholderSize; // 0=Full size, 1=Half size, 2=Quarter of Slide
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 						PptOEPlaceholderAtom() { Clear(); }
//STRIP001     void				Clear();
//STRIP001 
//STRIP001     friend SvStream& operator>>( SvStream& rIn, PptOEPlaceholderAtom& rAtom );
//STRIP001 };
//STRIP001 
//STRIP001 struct ProcessData;
//STRIP001 struct PPTStyleSheet;
//STRIP001 struct HeaderFooterEntry;
//STRIP001 struct PptSlidePersistEntry
//STRIP001 {
//STRIP001     PptSlidePersistAtom aPersistAtom;
//STRIP001     PptSlideAtom        aSlideAtom;
//STRIP001     PptNotesAtom        aNotesAtom;
//STRIP001 	PptColorSchemeAtom	aColorScheme;			// each slide includes this colorscheme atom
//STRIP001     PPTStyleSheet*      pStyleSheet;            // stylesheet of this page ( only in masterpages ), since XP supports more than one masterpage
//STRIP001 
//STRIP001 	HeaderFooterEntry*	pHeaderFooterEntry;
//STRIP001 	SvxMSDffSolverContainer* pSolverContainer;
//STRIP001 	sal_uInt32			nSlidePersistStartOffset;// is an array to the end of the SlidePersistAtom of this page, TextHeaderAtom is following
//STRIP001 	sal_uInt32			nSlidePersistEndOffset;
//STRIP001 	sal_uInt32			nBackgroundOffset;		// fileoffset
//STRIP001 	sal_uInt32			nDrawingDgId;			// valid, if not -1
//STRIP001 	sal_uInt32*			pPresentationObjects;	// if valid, this is a pointer to an array that includes the offsets to the presentation objects 
//STRIP001 												// on this masterpage for each instance ( 0 - 8 );
//STRIP001     SdrObject*			pBObj;
//STRIP001 	sal_Bool			bBObjIsTemporary;
//STRIP001 
//STRIP001     void*               pDummy2;
//STRIP001 	PptPageKind			ePageKind;				//
//STRIP001 
//STRIP001     sal_Bool			bNotesMaster	: 1;	// fuer NotesMaster
//STRIP001     sal_Bool			bHandoutMaster	: 1;	// fuer HandoutMaster
//STRIP001     sal_Bool			bStarDrawFiller : 1;	// speziell fuer StarDraw
//STRIP001 public:
//STRIP001 						PptSlidePersistEntry();
//STRIP001 						~PptSlidePersistEntry();
//STRIP001     UINT32				GetSlideId() const { return aPersistAtom.nSlideId; }
//STRIP001 };
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 SV_DECL_PTRARR_DEL(_PptSlidePersistList,PptSlidePersistEntry*,16,16)//STRIP008 ;
//STRIP001 
//STRIP001 #define PPTSLIDEPERSIST_ENTRY_NOTFOUND 0xFFFF
//STRIP001 
//STRIP001 class PptSlidePersistList: public _PptSlidePersistList
//STRIP001 {
//STRIP001 
//STRIP001 	public:
//STRIP001 
//STRIP001 		USHORT			FindPage( UINT32 nId ) const;
//STRIP001 };
//STRIP001 
//STRIP001 class  SfxObjectShell;
//STRIP001 struct PPTOleEntry
//STRIP001 {
//STRIP001 	sal_uInt32				nId;						// OleId
//STRIP001 	sal_uInt32				nPersistPtr;				// PersistPtr
//STRIP001 	sal_uInt32				nRecHdOfs;					// points to the record header: ExObjListHd
//STRIP001 	SfxObjectShell*			pShell;
//STRIP001 	sal_uInt16				nType;						// maybe PPT_PST_ExEmbed or PPT_PST_ExControl
//STRIP001 
//STRIP001 	PPTOleEntry( sal_uInt32 nid, sal_uInt32 nOfs, SfxObjectShell* pSh, sal_uInt16 nT ) : 
//STRIP001 		nId				( nid ),
//STRIP001 		nRecHdOfs		( nOfs ),
//STRIP001 		pShell			( pSh ),
//STRIP001 		nType			( nT ) {}
//STRIP001 };
//STRIP001 
//STRIP001 struct PptExOleObjAtom
//STRIP001 {
//STRIP001 	UINT32	nDummy0;
//STRIP001 	UINT32	nDummy1;
//STRIP001 	UINT32	nId;
//STRIP001 	UINT32	nDummy2;
//STRIP001 	UINT32	nPersistPtr;
//STRIP001 	UINT32	nDummy4;
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001     friend SvStream& operator>>( SvStream& rIn, PptExOleObjAtom& rAtom );
//STRIP001 };
//STRIP001 
//STRIP001 class PPTExtParaProv;
//STRIP001 class SdrEscherImport : public SvxMSDffManager
//STRIP001 {
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	friend class PPTTextObj;
//STRIP001 	friend class PPTPortionObj;
//STRIP001 	friend struct PPTStyleTextPropReader;
//STRIP001 
//STRIP001     PptDocumentAtom		aDocAtom;
//STRIP001 	DffRecordManager	aPptRecManager;							// contains all first level container and atoms 
//STRIP001 	DffRecordManager	aDocRecManager;							// contains all first level container and atoms of the document container
//STRIP001 
//STRIP001 	List				aHFMasterList;
//STRIP001 	List				aOleObjectList;							// contains	PPTOleEntrys
//STRIP001 
//STRIP001     PptFontCollection*	pFonts;
//STRIP001 
//STRIP001     sal_uInt32			nStreamLen;
//STRIP001 	sal_uInt16			nTextStylesIndex;
//STRIP001 
//STRIP001     CharSet				eCharSetSystem;
//STRIP001 
//STRIP001 	sal_Bool			bWingdingsChecked		: 1;
//STRIP001     sal_Bool			bWingdingsAvailable		: 1;
//STRIP001     sal_Bool			bMonotypeSortsChecked	: 1;
//STRIP001     sal_Bool			bMonotypeSortsAvailable	: 1;
//STRIP001     sal_Bool			bTimesNewRomanChecked	: 1;
//STRIP001     sal_Bool			bTimesNewRomanAvailable	: 1;
//STRIP001 
//STRIP001 	sal_Bool			ReadString( String& rStr ) const;
//STRIP001     // nur fuer PowerPoint-Filter:
//STRIP001     virtual const PptSlideLayoutAtom* GetSlideLayoutAtom() const;
//STRIP001     void				CheckWingdings() const;
//STRIP001     void				CheckMonotypeSorts() const;
//STRIP001 	void				CheckTimesNewRoman() const;
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001     PowerPointImportParam& rImportParam;
//STRIP001 
//STRIP001 	void*				pSdrEscherDummy1;
//STRIP001 	void*				pSdrEscherDummy2;
//STRIP001 	void*				pSdrEscherDummy3;
//STRIP001 	void*				pSdrEscherDummy4;
//STRIP001 
//STRIP001 						SdrEscherImport( PowerPointImportParam& );
//STRIP001     virtual				~SdrEscherImport();
//STRIP001     virtual	FASTBOOL	GetColorFromPalette( USHORT nNum, Color& rColor ) const;
//STRIP001 	virtual BOOL		SeekToShape( SvStream& rSt, void* pClientData, UINT32 nId ) const;
//STRIP001 	PptFontEntityAtom*	GetFontEnityAtom( UINT32 nNum ) const;
//STRIP001 	CharSet				GetCharSet( UINT32 nNum ) const;
//STRIP001 	BOOL				IsFontAvailable( UINT32 nNum ) const;
//STRIP001 	void				RecolorGraphic( SvStream& rSt, sal_uInt32 nRecLen, Graphic& rGraph );
//STRIP001     virtual SdrObject*	ReadObjText( PPTTextObj* pTextObj, SdrObject* pObj, SdPage* pPage ) const;
//STRIP001 	virtual SdrObject*	ProcessObj( SvStream& rSt, DffObjData& rData, void* pData, Rectangle& rTextRect, SdrObject* pObj );
//STRIP001 	virtual void		ProcessClientAnchor2( SvStream& rSt, DffRecordHeader& rHd, void* pData, DffObjData& rObj );
//STRIP001     void				ImportHeaderFooterContainer( DffRecordHeader& rHeader, HeaderFooterEntry& rEntry );
//STRIP001 };
//STRIP001 
//STRIP001 ////////////////////////////////////////////////////////////////////////////////////////////////////
//STRIP001 
//STRIP001 #define	SD_HEADERFOOTER_DATE		1
//STRIP001 #define	SD_HEADERFOOTER_TODAYDATE	2
//STRIP001 #define	SD_HEADERFOOTER_USERDATE	4
//STRIP001 #define	SD_HEADERFOOTER_SLIDENUMBER	8
//STRIP001 #define	SD_HEADERFOOTER_HEADER		16
//STRIP001 #define	SD_HEADERFOOTER_FOOTER		32
//STRIP001 
//STRIP001 class SvxFieldItem;
//STRIP001 struct PPTFieldEntry
//STRIP001 {
//STRIP001 	UINT16		  	nPos;
//STRIP001 	UINT16			nTextRangeEnd;
//STRIP001 	SvxFieldItem*	pField1;
//STRIP001 	SvxFieldItem*	pField2;
//STRIP001 	String*			pString;
//STRIP001 
//STRIP001 	PPTFieldEntry() : pField1( NULL ), pField2( NULL ), pString( NULL ), nPos( 0 ), nTextRangeEnd( 0 ) {};
//STRIP001 	~PPTFieldEntry();
//STRIP001 
//STRIP001 	void			SetDateTime( UINT32 nType );
//STRIP001 };
//STRIP001 
//STRIP001 struct HeaderFooterMaster
//STRIP001 {
//STRIP001 	UINT32					nDirtyInstance;
//STRIP001 	UINT32					pOfs[ 4 ];
//STRIP001 	List					aHeaderFooterEntryList;		// a list of HeaderFooterEntry's
//STRIP001 
//STRIP001 							HeaderFooterMaster();
//STRIP001 							~HeaderFooterMaster();
//STRIP001 
//STRIP001 	UINT32					NeedToImportInstance( UINT32 nInstance, HeaderFooterEntry& rE );
//STRIP001 };
//STRIP001 
//STRIP001 struct HeaderFooterEntry
//STRIP001 {
//STRIP001 	HeaderFooterMaster&	rMaster;
//STRIP001 	SdPage*				pSdPage;
//STRIP001 
//STRIP001 	UINT32				nAtom;
//STRIP001 	SdrObject*			pSdrObject[ 4 ];
//STRIP001 	String				pPlaceholder[ 4 ];
//STRIP001 	UINT32				nInstanceCount;
//STRIP001 	UINT32				pInstanceOrder[ 4 ];
//STRIP001 	UINT32				pPageIndex[ 4 ];
//STRIP001 	BOOL				bMaster;
//STRIP001 
//STRIP001 	UINT32				GetMaskForInstance( UINT32 nInstance );
//STRIP001 	UINT32				IsToDisplay( UINT32 nInstance );
//STRIP001 						HeaderFooterEntry( HeaderFooterEntry& rE, SdPage* pPage );
//STRIP001 						HeaderFooterEntry( HeaderFooterMaster& rM, SdPage* pPage );
//STRIP001 						~HeaderFooterEntry();
//STRIP001 };
//STRIP001 
//STRIP001 struct ProcessData
//STRIP001 {
//STRIP001 	PptSlidePersistEntry&	rPersistEntry;
//STRIP001 	SdPage*					pPage;
//STRIP001 	List*					pBackgroundColoredObjects;
//STRIP001 	sal_uInt32				nGroupingFlags;				// a special textgrouping happened
//STRIP001 
//STRIP001 	ProcessData( PptSlidePersistEntry& rP, SdPage* pP ) :
//STRIP001 		rPersistEntry				( rP ),
//STRIP001 		pPage						( pP ),
//STRIP001 		pBackgroundColoredObjects	( NULL ) {};
//STRIP001 	~ProcessData() { delete pBackgroundColoredObjects; };
//STRIP001 };
//STRIP001 
//STRIP001 ////////////////////////////////////////////////////////////////////////////////////////////////////
//STRIP001 
//STRIP001 class SdrTextObj;
//STRIP001 class SfxObjectShell;
//STRIP001 class SdrPowerPointImport : public SdrEscherImport
//STRIP001 {
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	friend class PPTTextObj;
//STRIP001 	friend class PPTExtParaProv;
//STRIP001 	friend struct PPTStyleSheet;
//STRIP001 	friend class PPTNumberFormatCreator;
//STRIP001 
//STRIP001 	BOOL				bOk;
//STRIP001     PptUserEditAtom		aUserEditAtom;
//STRIP001     PptColorSchemeAtom	aPageColors;
//STRIP001 	List				aHyperList;
//STRIP001     UINT32*				pPersistPtr;
//STRIP001     ULONG				nPersistPtrAnz;
//STRIP001 
//STRIP001 	const PPTStyleSheet* pPPTStyleSheet;    // this is the current stylesheet;
//STRIP001     const PPTStyleSheet* pDefaultSheet;     // this is a sheet we are using if no masterpage can be found, but that should
//STRIP001                                             // never happen just preventing a crash
//STRIP001     PptSlidePersistList* pMasterPages;
//STRIP001     PptSlidePersistList* pSlidePages;
//STRIP001     PptSlidePersistList* pNotePages;
//STRIP001     USHORT				nAktPageNum;
//STRIP001     ULONG				nDocStreamPos;
//STRIP001     USHORT				nPageColorsNum;
//STRIP001     PptPageKind			ePageColorsKind;
//STRIP001 	PptPageKind			eAktPageKind;
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001     sal_Bool    SeekToAktPage(DffRecordHeader* pRecHd=NULL) const;
//STRIP001     sal_Bool    SeekToDocument(DffRecordHeader* pRecHd=NULL) const;
//STRIP001     sal_Bool    SeekToContentOfProgTag( sal_Int32 nVersion, SvStream& rSt, const DffRecordHeader& rProgTagBinaryDataHd,
//STRIP001                                             DffRecordHeader& rContentHd );
//STRIP001 	virtual	SdrObject* ApplyTextObj( PPTTextObj* pTextObj, SdrTextObj* pText, SdPage* pPage, SfxStyleSheet*, SfxStyleSheet** ) const;
//STRIP001     virtual SdrObject* ReadObjText( PPTTextObj* pTextObj, SdrObject* pObj, SdPage* pPage ) const;
//STRIP001 	virtual SdrObject* ImportOLE( long nOLEId, const Graphic& rGraf, const Rectangle& rBoundRect ) const;
//STRIP001 	SvMemoryStream*	ImportExOleObjStg( UINT32 nPersistPtr, UINT32& nOleId ) const;
//STRIP001     SdrPage*   MakeBlancPage(sal_Bool bMaster) const;
//STRIP001     sal_Bool   ReadFontCollection();
//STRIP001     sal_Bool   ForceFontCollection() const { return pFonts!=NULL?TRUE:((SdrPowerPointImport*)this)->ReadFontCollection(); }
//STRIP001     PptSlidePersistList* GetPageList(PptPageKind ePageKind) const;
//STRIP001 	UINT32	   GetAktPageId();
//STRIP001     UINT32     GetMasterPageId(USHORT nPageNum, PptPageKind ePageKind) const;
//STRIP001     UINT32     GetNotesPageId(USHORT nPageNum ) const;
//STRIP001 	SdrOutliner* GetDrawOutliner( SdrTextObj* pSdrText ) const;
//STRIP001 	void		SeekOle( SfxObjectShell* pShell, sal_uInt32 nFilterOptions );
//STRIP001 
//STRIP001 public:
//STRIP001 				SdrPowerPointImport( PowerPointImportParam& );
//STRIP001     virtual		~SdrPowerPointImport();
//STRIP001     USHORT		GetPageCount( PptPageKind eKind = PPT_SLIDEPAGE ) const;
//STRIP001     void		SetPageNum( USHORT nPageNum, PptPageKind = PPT_SLIDEPAGE );
//STRIP001     USHORT		GetPageNum() const { return nAktPageNum; }
//STRIP001     PptPageKind	GetPageKind() const { return eAktPageKind; }
//STRIP001     Size		GetPageSize() const;
//STRIP001     SdrObject*	ImportPageBackgroundObject( const SdrPage& rPage, sal_uInt32& nBgFileOffset, sal_Bool bForce );
//STRIP001     sal_Bool	IsNoteOrHandout( USHORT nPageNum, PptPageKind ePageKind ) const;
//STRIP001     sal_Bool	HasMasterPage( USHORT nPageNum, PptPageKind ePageKind = PPT_SLIDEPAGE ) const;
//STRIP001     USHORT		GetMasterPageIndex( USHORT nPageNum, PptPageKind ePageKind = PPT_SLIDEPAGE ) const;
//STRIP001 
//STRIP001     void        ImportPage( SdrPage* pPage, const PptSlidePersistEntry* pMasterPersist = NULL );
//STRIP001     virtual FASTBOOL	GetColorFromPalette(USHORT nNum, Color& rColor) const;
//STRIP001 	virtual BOOL		SeekToShape( SvStream& rSt, void* pClientData, UINT32 nId ) const;
//STRIP001 	sal_Unicode			PPTSubstitute( UINT16 nFont, sal_Unicode nChar,
//STRIP001 										UINT32& nMappedFontId, Font& rFont, char nDefault ) const;
//STRIP001     const PptDocumentAtom&				GetDocumentAtom() const { return aDocAtom; }
//STRIP001     virtual const PptSlideLayoutAtom*	GetSlideLayoutAtom() const;
//STRIP001 };
//STRIP001 
//STRIP001 ////////////////////////////////////////////////////////////////////////////////////////////////////
//STRIP001 
//STRIP001 struct PPTTextParagraphStyleAtomInterpreter
//STRIP001 {
//STRIP001     sal_Bool        bValid;
//STRIP001     sal_Bool        bForbiddenRules;
//STRIP001     sal_Bool        bHangingPunctuation;
//STRIP001     sal_Bool        bLatinTextWrap;
//STRIP001 
//STRIP001                     PPTTextParagraphStyleAtomInterpreter();
//STRIP001                     ~PPTTextParagraphStyleAtomInterpreter();
//STRIP001 
//STRIP001     sal_Bool        Read( SvStream& rIn, const DffRecordHeader& rRecHd );
//STRIP001 };
//STRIP001 
//STRIP001 struct PPTTextSpecInfo
//STRIP001 {
//STRIP001 	sal_uInt32		nCharIdx;
//STRIP001 	sal_uInt16		nLanguage[ 3 ];
//STRIP001 	sal_uInt16		nDontKnow;
//STRIP001 
//STRIP001 	PPTTextSpecInfo( sal_uInt32 nCharIdx );
//STRIP001 	~PPTTextSpecInfo();
//STRIP001 };
//STRIP001 
//STRIP001 struct  PPTTextSpecInfoAtomInterpreter
//STRIP001 {
//STRIP001 	sal_Bool		bValid;
//STRIP001 	List			aList;
//STRIP001 
//STRIP001 					PPTTextSpecInfoAtomInterpreter();
//STRIP001 					~PPTTextSpecInfoAtomInterpreter();
//STRIP001 
//STRIP001 	sal_Bool		Read( SvStream& rIn, const DffRecordHeader& rRecHd,
//STRIP001 							sal_uInt16 nRecordType, const PPTTextSpecInfo* pTextSpecDefault = NULL );
//STRIP001 
//STRIP001 };
//STRIP001 
//STRIP001 ////////////////////////////////////////////////////////////////////////////////////////////////////
//STRIP001 
//STRIP001 #define PPT_STYLESHEETENTRYS	9
//STRIP001 
//STRIP001 struct PPTExtParaLevel
//STRIP001 {
//STRIP001 		UINT32	nBuFlags;
//STRIP001 		UINT32	nNumberingType;
//STRIP001 		UINT16	nBuStart;
//STRIP001 		UINT16	nBuInstance;
//STRIP001 		BOOL 	bSet;
//STRIP001 
//STRIP001 		PPTExtParaLevel();
//STRIP001 	    friend SvStream& operator>>( SvStream& rIn, PPTExtParaLevel& rL );
//STRIP001 };
//STRIP001 
//STRIP001 struct PPTExtParaSheet
//STRIP001 {
//STRIP001 		PPTExtParaLevel	aExtParaLevel[ 5 ];
//STRIP001 };
//STRIP001 
//STRIP001 struct PPTBuGraEntry
//STRIP001 {
//STRIP001 	UINT32		nInstance;
//STRIP001 	Graphic		aBuGra;	
//STRIP001 
//STRIP001 				PPTBuGraEntry( Graphic& rGraphic, UINT32 nInstance );
//STRIP001 };
//STRIP001 
//STRIP001 class PPTExtParaProv
//STRIP001 {
//STRIP001 		List				aBuGraList;
//STRIP001 
//STRIP001 	public :
//STRIP001 		BOOL				bStyles;
//STRIP001 		BOOL				bGraphics;
//STRIP001 		DffRecordManager	aExtendedPresRules;
//STRIP001 
//STRIP001 		PPTExtParaSheet		aExtParaSheet[ PPT_STYLESHEETENTRYS ];
//STRIP001 
//STRIP001 		BOOL				GetGraphic( UINT32 nInstance, Graphic& rGraphic ) const;
//STRIP001 
//STRIP001 							PPTExtParaProv( SdrPowerPointImport& rManager, SvStream& rSt, 
//STRIP001 												const DffRecordHeader* pMainMasterHd );
//STRIP001 							~PPTExtParaProv();
//STRIP001 };
//STRIP001 
//STRIP001 ////////////////////////////////////////////////////////////////////////////////////////////////////
//STRIP001 
//STRIP001 struct PPTCharLevel
//STRIP001 {
//STRIP001 	Color		mnFontColorInStyleSheet;
//STRIP001 	sal_uInt32	mnFontColor;
//STRIP001 	sal_uInt16	mnFlags;
//STRIP001 	sal_uInt16	mnFont;
//STRIP001 	sal_uInt16	mnAsianOrComplexFont;
//STRIP001 	sal_uInt16	mnFontHeight;
//STRIP001 	sal_uInt16	mnEscapement;
//STRIP001 };
//STRIP001 
//STRIP001 struct PPTCharSheet
//STRIP001 {
//STRIP001 				PPTCharLevel	maCharLevel[ 5 ];
//STRIP001 
//STRIP001 				PPTCharSheet( sal_uInt32 nInstance );
//STRIP001 				PPTCharSheet( const PPTCharSheet& rCharSheet );
//STRIP001 
//STRIP001 	void		Read( SvStream& rIn, sal_Bool bMasterStyle, sal_uInt32 nLevel, sal_Bool bFirst );
//STRIP001 };
//STRIP001 
//STRIP001 struct PPTParaLevel
//STRIP001 {
//STRIP001 	sal_uInt16  mnBuFlags;
//STRIP001 	sal_uInt16  mnBulletChar;
//STRIP001 	sal_uInt16  mnBulletFont;
//STRIP001 	sal_uInt16  mnBulletHeight;
//STRIP001 	sal_uInt32  mnBulletColor;
//STRIP001 
//STRIP001 	sal_uInt16  mnAdjust;
//STRIP001 	sal_uInt16  mnLineFeed;
//STRIP001 	sal_uInt16  mnUpperDist;
//STRIP001 	sal_uInt16  mnLowerDist;
//STRIP001 	sal_uInt16  mnTextOfs;
//STRIP001 	sal_uInt16  mnBulletOfs;
//STRIP001 	sal_uInt16  mnDefaultTab;
//STRIP001     sal_uInt16  mnAsianLineBreak;   // bit0:    use asian rules for first and last character
//STRIP001                                     //    1:    do not wrap latin text in the middle of the word
//STRIP001                                     //    2:    allow hanging punctuation
//STRIP001 	sal_uInt16	mnBiDi;
//STRIP001 };
//STRIP001 
//STRIP001 struct PPTParaSheet
//STRIP001 {
//STRIP001 	public:
//STRIP001 
//STRIP001 				PPTParaLevel	maParaLevel[ 5 ];
//STRIP001 
//STRIP001 				PPTParaSheet( sal_uInt32 nInstance );
//STRIP001 				PPTParaSheet( const PPTParaSheet& rParaSheet );
//STRIP001 
//STRIP001 	void		Read( SdrPowerPointImport& rMan, SvStream& rIn, sal_Bool bMasterStyle,
//STRIP001                         sal_uInt32 nLevel, sal_Bool bFirst );
//STRIP001 };
//STRIP001 
//STRIP001 ////////////////////////////////////////////////////////////////////////////////////////////////////
//STRIP001 
//STRIP001 
//STRIP001 class PPTParagraphObj;
//STRIP001 class PPTNumberFormatCreator
//STRIP001 {		
//STRIP001 		UINT32 nIsBullet;
//STRIP001 		UINT32 nBulletChar;
//STRIP001 		UINT32 nBulletFont;
//STRIP001 		UINT32 nBulletHeight;
//STRIP001 		UINT32 nBulletColor;
//STRIP001 		UINT32 nTextOfs;
//STRIP001 		UINT32 nBulletOfs;
//STRIP001 
//STRIP001 		void	ImplGetNumberFormat( SdrPowerPointImport& rMan, SvxNumberFormat& rNumberFormat, UINT32 nLevel );
//STRIP001 		BOOL	ImplGetExtNumberFormat( SdrPowerPointImport& rMan, SvxNumberFormat& rNumberFormat, UINT32 nLevel,
//STRIP001 							UINT32 nInstance, UINT32 nInstanceInSheet, UINT32 nFontHeight, PPTParagraphObj* pPara );
//STRIP001 
//STRIP001     protected :
//STRIP001 
//STRIP001         PPTNumberFormatCreator( PPTExtParaProv* );
//STRIP001         ~PPTNumberFormatCreator();
//STRIP001 
//STRIP001 	public :
//STRIP001 
//STRIP001         PPTExtParaProv*	 pExtParaProv;
//STRIP001 	
//STRIP001 		void	GetNumberFormat(  SdrPowerPointImport& rMan, SvxNumberFormat& rNumberFormat, UINT32 nLevel,
//STRIP001 					const PPTParaLevel& rParaLevel, const PPTCharLevel& rCharLevel, UINT32 nInstance );
//STRIP001 
//STRIP001 		BOOL	GetNumberFormat(  SdrPowerPointImport& rMan, SvxNumberFormat& rNumberFormat,
//STRIP001 					PPTParagraphObj* pPara, UINT32 nInstanceInSheet );
//STRIP001 };
//STRIP001 
//STRIP001 
//STRIP001 ////////////////////////////////////////////////////////////////////////////////////////////////////
//STRIP001 
//STRIP001 class SvxNumBulletItem;
//STRIP001 struct PPTStyleSheet : public PPTNumberFormatCreator
//STRIP001 {
//STRIP001 	PPTTextSpecInfo		maTxSI;
//STRIP001 	PPTCharSheet*		mpCharSheet[ PPT_STYLESHEETENTRYS ];
//STRIP001 	PPTParaSheet*		mpParaSheet[ PPT_STYLESHEETENTRYS ];
//STRIP001 	SvxNumBulletItem*	mpNumBulletItem[ PPT_STYLESHEETENTRYS ];
//STRIP001     void*               mpDummy;
//STRIP001 
//STRIP001 				PPTStyleSheet( const DffRecordHeader& rSlideHd, SvStream& rSt, SdrPowerPointImport&,
//STRIP001                                 const PPTTextParagraphStyleAtomInterpreter&, const PPTTextSpecInfo& );
//STRIP001 				~PPTStyleSheet();
//STRIP001 };
//STRIP001 
//STRIP001 ////////////////////////////////////////////////////////////////////////////////////////////////////
//STRIP001 
//STRIP001 struct ImplPPTParaPropSet
//STRIP001 {
//STRIP001 	sal_uInt32  mnRefCount;
//STRIP001 
//STRIP001 	sal_uInt16  mnDepth;
//STRIP001 	sal_uInt32  mnAttrSet;
//STRIP001 	sal_uInt32  mnBulletColor;
//STRIP001 	sal_uInt16  mpArry[ 22 ];
//STRIP001 
//STRIP001 	sal_uInt32  nBuFlags;
//STRIP001 	sal_uInt32  nNumberingType;
//STRIP001 	sal_uInt16  nBuStart;
//STRIP001 	sal_uInt16  nBuInstance;
//STRIP001 
//STRIP001 #ifdef DBG_EXTRACT_BUDATA
//STRIP001 	sal_uInt16	mnEntryCount;
//STRIP001 #endif
//STRIP001 
//STRIP001 			ImplPPTParaPropSet(){ mnRefCount = 1; mnAttrSet = 0; nBuFlags = 0; mnDepth = 0; };
//STRIP001 };
//STRIP001 
//STRIP001 struct PPTParaPropSet
//STRIP001 {
//STRIP001 	sal_uInt32			mnOriginalTextPos;
//STRIP001 	ImplPPTParaPropSet*	pParaSet;
//STRIP001 
//STRIP001 #ifdef DBG_EXTRACT_BUDATA
//STRIP001 	sal_uInt16			mnCharacters;
//STRIP001 #endif
//STRIP001 						PPTParaPropSet();
//STRIP001 						PPTParaPropSet( PPTParaPropSet& rParaPropSet );
//STRIP001 						~PPTParaPropSet();
//STRIP001 
//STRIP001 	PPTParaPropSet&		operator=( PPTParaPropSet& rParaPropSet );
//STRIP001 };
//STRIP001 
//STRIP001 struct ImplPPTCharPropSet
//STRIP001 {
//STRIP001 	sal_uInt32	mnRefCount;
//STRIP001 
//STRIP001 	sal_uInt32	mnAttrSet;
//STRIP001 	sal_uInt16	mnFlags;
//STRIP001 	sal_uInt32	mnColor;
//STRIP001 	sal_uInt16	mnFont;
//STRIP001 	sal_uInt16	mnAsianOrComplexFont;
//STRIP001 	sal_uInt16	mnUnknown2;
//STRIP001 	sal_uInt16	mnFontHeight;
//STRIP001 	sal_uInt16	mnEscapement;
//STRIP001 	sal_uInt16	mnSymbolFont;
//STRIP001 
//STRIP001 #ifdef DBG_EXTRACT_BUDATA
//STRIP001 	sal_uInt16	mnEntryCount;
//STRIP001 #endif
//STRIP001 
//STRIP001 	ImplPPTCharPropSet(){ mnRefCount = 1; mnAttrSet = 0; };
//STRIP001 };
//STRIP001 
//STRIP001 struct PPTCharPropSet
//STRIP001 {
//STRIP001 
//STRIP001 	sal_uInt32			mnOriginalTextPos;
//STRIP001 	sal_uInt32			mnParagraph;
//STRIP001 	String				maString;
//STRIP001 	SvxFieldItem*		mpFieldItem;
//STRIP001 	sal_uInt16			mnLanguage[ 3 ];
//STRIP001 
//STRIP001 	ImplPPTCharPropSet*	pCharSet;
//STRIP001 
//STRIP001 #ifdef DBG_EXTRACT_BUDATA
//STRIP001 	sal_uInt16			mnCharacters;
//STRIP001 #endif
//STRIP001 
//STRIP001 	void				SetFont( UINT16 nFont );
//STRIP001 	void				SetColor( sal_uInt32 nColor );
//STRIP001 
//STRIP001 						PPTCharPropSet( sal_uInt32 nParagraph );
//STRIP001 						PPTCharPropSet( PPTCharPropSet& rCharPropSet );
//STRIP001 						PPTCharPropSet( PPTCharPropSet& rCharPropSet, sal_uInt32 nParagraph );
//STRIP001 						~PPTCharPropSet();
//STRIP001 
//STRIP001 	PPTCharPropSet&		operator=( PPTCharPropSet& rCharPropSet );
//STRIP001 
//STRIP001 	private :
//STRIP001 
//STRIP001 		void			ImplMakeUnique();
//STRIP001 };
//STRIP001 
//STRIP001 ////////////////////////////////////////////////////////////////////////////////////////////////////
//STRIP001 
//STRIP001 struct PPTTabEntry
//STRIP001 {
//STRIP001 	sal_uInt16	nOffset;
//STRIP001 	sal_uInt16	nStyle;
//STRIP001 };
//STRIP001 
//STRIP001 struct PPTRuler
//STRIP001 {
//STRIP001 		UINT32			nRefCount;
//STRIP001 
//STRIP001 		INT32			nFlags;
//STRIP001 		UINT16			nDefaultTab;
//STRIP001 		UINT16			nTextOfs[ 5 ];
//STRIP001 		UINT16			nBulletOfs[ 5 ];
//STRIP001 		PPTTabEntry*	pTab;
//STRIP001 		UINT16			nTabCount;
//STRIP001 
//STRIP001 		PPTRuler();
//STRIP001 		~PPTRuler();
//STRIP001 };
//STRIP001 
//STRIP001 struct PPTTextRulerInterpreter
//STRIP001 {
//STRIP001 		PPTRuler	*mpImplRuler;
//STRIP001 
//STRIP001 					PPTTextRulerInterpreter();
//STRIP001 					PPTTextRulerInterpreter( PPTTextRulerInterpreter& rRuler );
//STRIP001 					PPTTextRulerInterpreter( UINT32 nFileOfs, SdrPowerPointImport&, DffRecordHeader& rHd, SvStream& rIn );
//STRIP001 					~PPTTextRulerInterpreter();
//STRIP001 
//STRIP001 		sal_uInt16	GetTabOffsetByIndex( sal_uInt16 nIndex ) const { return mpImplRuler->pTab[ nIndex ].nOffset; };
//STRIP001 		sal_uInt16	GetTabStyleByIndex( sal_uInt16 nIndex ) const { return mpImplRuler->pTab[ nIndex ].nStyle; };
//STRIP001 		UINT16		GetTabCount() const { return mpImplRuler->nTabCount; };
//STRIP001 		BOOL		GetDefaultTab( UINT32 nLevel, UINT16& nValue ) const;
//STRIP001 		BOOL		GetTextOfs( UINT32 nLevel, UINT16& nValue ) const;
//STRIP001 		BOOL		GetBulletOfs( UINT32 nLevel, UINT16& nValue ) const;
//STRIP001 
//STRIP001 		PPTTextRulerInterpreter& operator=( PPTTextRulerInterpreter& rRuler );
//STRIP001 };
//STRIP001 
//STRIP001 ////////////////////////////////////////////////////////////////////////////////////////////////////
//STRIP001 
//STRIP001 #define PPT_SPEC_NEWLINE			0x10000
//STRIP001 #define PPT_SPEC_SYMBOL				0x20000
//STRIP001 #define PPT_SPEC_USE_STARBATS		0x40000
//STRIP001 
//STRIP001 struct PPTStyleTextPropReader
//STRIP001 {
//STRIP001 	List		aSpecMarkerList;			// hiword -> Flags, loword -> Position
//STRIP001 	List		aParaPropList;
//STRIP001 	List		aCharPropList;
//STRIP001 
//STRIP001 				PPTStyleTextPropReader( SvStream& rIn, SdrPowerPointImport&, const DffRecordHeader& rClientTextBoxHd, 
//STRIP001 					PPTTextRulerInterpreter& rInterpreter, const DffRecordHeader& rExtParaHd, sal_uInt32 nTextInstance );
//STRIP001 
//STRIP001 				~PPTStyleTextPropReader();
//STRIP001 };
//STRIP001 
//STRIP001 ////////////////////////////////////////////////////////////////////////////////////////////////////
//STRIP001 
//STRIP001 class SvxFieldItem;
//STRIP001 class PPTPortionObj : public PPTCharPropSet
//STRIP001 {
//STRIP001 
//STRIP001 	friend class PPTParagraphObj;
//STRIP001 
//STRIP001 		const PPTStyleSheet&	mrStyleSheet;
//STRIP001 		UINT32					mnInstance;
//STRIP001 		UINT32					mnDepth;
//STRIP001 
//STRIP001 	public :
//STRIP001 
//STRIP001 		BOOL			GetAttrib( UINT32 nAttr, UINT32& nVal, UINT32 nInstanceInSheet );
//STRIP001 		SvxFieldItem*	GetTextField();
//STRIP001 
//STRIP001 						PPTPortionObj( const PPTStyleSheet&, UINT32 nInstance, UINT32 nDepth );
//STRIP001 						PPTPortionObj( PPTCharPropSet&, const PPTStyleSheet&, UINT32 nInstance, UINT32 nDepth );
//STRIP001 						PPTPortionObj( PPTPortionObj& );
//STRIP001 						~PPTPortionObj();
//STRIP001 
//STRIP001 		// the following function should be removed during next full update
//STRIP001 		void			ApplyTo( SfxItemSet& rSet, SdrPowerPointImport& rManager, UINT32 nInstanceInSheet );
//STRIP001 		void			ApplyTo( SfxItemSet& rSet, SdrPowerPointImport& rManager, UINT32 nInstanceInSheet, const PPTTextObj* pTextObj );
//STRIP001 		UINT32			Count() const { return ( mpFieldItem ) ? 1 : maString.Len(); };
//STRIP001 		BOOL			HasTabulator();
//STRIP001 };
//STRIP001 
//STRIP001 class PPTParagraphObj : public PPTParaPropSet, public PPTNumberFormatCreator, public PPTTextRulerInterpreter
//STRIP001 {
//STRIP001 	friend class PPTTextObj;
//STRIP001 	friend class PPTNumberFormatCreator;
//STRIP001 
//STRIP001 		const PPTStyleSheet&	mrStyleSheet;
//STRIP001 		UINT32					mnInstance;
//STRIP001 
//STRIP001 	protected :
//STRIP001 
//STRIP001 		void					ImplClear();
//STRIP001 
//STRIP001 	public :
//STRIP001 
//STRIP001 		BOOL					mbTab;			// if true, this paragraph has tabulators in text
//STRIP001 
//STRIP001 		UINT32					mnCurrentObject;
//STRIP001 		UINT32					mnPortionCount;
//STRIP001 		PPTPortionObj**			mpPortionList;
//STRIP001 
//STRIP001 
//STRIP001 		void					UpdateBulletRelSize( sal_uInt32& nBulletRelSize ) const;
//STRIP001 		BOOL					GetAttrib( UINT32 nAttr, UINT32& nVal, UINT32 nInstanceInSheet );
//STRIP001 
//STRIP001 								PPTParagraphObj( const PPTStyleSheet&, UINT32 nInstance, UINT16 nDepth );
//STRIP001 								PPTParagraphObj( PPTStyleTextPropReader&, const PPTStyleSheet&, UINT32 nInstance, PPTTextRulerInterpreter& rRuler );
//STRIP001 								~PPTParagraphObj();
//STRIP001 
//STRIP001 		UINT32					GetTextSize();
//STRIP001 		UINT16					GetLevel();
//STRIP001 		PPTPortionObj*			First();
//STRIP001 		PPTPortionObj*			Next();
//STRIP001 
//STRIP001 		void					AppendPortion( PPTPortionObj& rPortion );
//STRIP001 		void					ApplyTo( SfxItemSet& rSet, SdrPowerPointImport& rManager, UINT32 nInstanceInSheet, const PPTParagraphObj* pPrev );
//STRIP001 };
//STRIP001 
//STRIP001 #define PPT_TEXTOBJ_FLAGS_PARA_ALIGNMENT_USED_LEFT      1
//STRIP001 #define PPT_TEXTOBJ_FLAGS_PARA_ALIGNMENT_USED_CENTER    2
//STRIP001 #define PPT_TEXTOBJ_FLAGS_PARA_ALIGNMENT_USED_RIGHT     4
//STRIP001 #define PPT_TEXTOBJ_FLAGS_PARA_ALIGNMENT_USED_BLOCK     8
//STRIP001 #define PPT_TEXTOBJ_FLAGS_VERTICAL                      16
//STRIP001 
//STRIP001 struct ImplPPTTextObj
//STRIP001 {
//STRIP001 	UINT32						mnRefCount;
//STRIP001 	UINT32						mnShapeId;
//STRIP001 	UINT32						mnShapeMaster;
//STRIP001 	PptOEPlaceholderAtom*		mpPlaceHolderAtom;
//STRIP001 	UINT16						mnInstance;
//STRIP001 	UINT16						mnMappedInstance;
//STRIP001 	MSO_SPT						meShapeType;
//STRIP001 
//STRIP001 	UINT32						mnCurrentObject;
//STRIP001 	UINT32						mnParagraphCount;
//STRIP001 	PPTParagraphObj**			mpParagraphList;
//STRIP001 	PptSlidePersistEntry&		mrPersistEntry;
//STRIP001 
//STRIP001 	sal_uInt32                  mnTextFlags;
//STRIP001 
//STRIP001 	ImplPPTTextObj( PptSlidePersistEntry& rPersistEntry ) : mrPersistEntry ( rPersistEntry ) {};
//STRIP001 };
//STRIP001 
//STRIP001 class PPTTextObj
//STRIP001 {		
//STRIP001 		ImplPPTTextObj*			mpImplTextObj;
//STRIP001 		void					ImplClear();
//STRIP001 
//STRIP001 								PPTTextObj(){};
//STRIP001 	public :
//STRIP001 								PPTTextObj( SvStream& rSt, SdrPowerPointImport&, PptSlidePersistEntry&, DffObjData* );
//STRIP001 								PPTTextObj( PPTTextObj& rTextObj );
//STRIP001 								~PPTTextObj();
//STRIP001 
//STRIP001 		UINT32					GetCurrentIndex() const { return mpImplTextObj->mnCurrentObject; };
//STRIP001 		UINT32					Count() const { return mpImplTextObj->mnParagraphCount; };
//STRIP001 		PPTParagraphObj*		First();
//STRIP001 		PPTParagraphObj*		Next();
//STRIP001 		MSO_SPT					GetShapeType() const { return mpImplTextObj->meShapeType; };
//STRIP001 		UINT32					GetInstance() const { return mpImplTextObj->mnInstance; };
//STRIP001 		void					SetInstance( UINT16 nInstance ) { mpImplTextObj->mnInstance = nInstance; };
//STRIP001 		UINT32					GetMappedInstance() const { return mpImplTextObj->mnMappedInstance; };
//STRIP001 		void					SetMappedInstance( UINT16 nInstance ) { mpImplTextObj->mnMappedInstance = nInstance; };
//STRIP001 		PptOEPlaceholderAtom*	GetOEPlaceHolderAtom() const { return mpImplTextObj->mpPlaceHolderAtom; };
//STRIP001         sal_uInt32              GetTextFlags() const { return mpImplTextObj->mnTextFlags; };
//STRIP001 		void					SetVertical( sal_Bool bVertical )
//STRIP001                                 {
//STRIP001                                     if ( bVertical )
//STRIP001                                         mpImplTextObj->mnTextFlags |= PPT_TEXTOBJ_FLAGS_VERTICAL;
//STRIP001                                     else
//STRIP001                                         mpImplTextObj->mnTextFlags &= ~PPT_TEXTOBJ_FLAGS_VERTICAL;
//STRIP001                                 }
//STRIP001 		sal_Bool				GetVertical() const { return ( mpImplTextObj->mnTextFlags & PPT_TEXTOBJ_FLAGS_VERTICAL ) != 0; };
//STRIP001 		const SfxItemSet*		GetBackground() const;
//STRIP001 
//STRIP001 		PPTTextObj&			operator=( PPTTextObj& rTextObj );
//STRIP001 };
//STRIP001 
//STRIP001 class PPTConvertOCXControls : public SvxMSConvertOCXControls
//STRIP001 {
//STRIP001 		virtual const	::com::sun::star::uno::Reference< ::com::sun::star::drawing::XDrawPage > & GetDrawPage();
//STRIP001 		PptPageKind		ePageKind;
//STRIP001 	public :
//STRIP001 
//STRIP001 		PPTConvertOCXControls( SfxObjectShell* pDSh, PptPageKind ePKind ) :
//STRIP001 			SvxMSConvertOCXControls	( pDSh, NULL ),
//STRIP001 			ePageKind				( ePKind ){};
//STRIP001 
//STRIP001 		virtual sal_Bool InsertControl(
//STRIP001 			const ::com::sun::star::uno::Reference< 
//STRIP001 			::com::sun::star::form::XFormComponent > &rFComp,
//STRIP001 			const ::com::sun::star::awt::Size& rSize,
//STRIP001 			::com::sun::star::uno::Reference< ::com::sun::star::drawing::XShape > *pShape,
//STRIP001 			BOOL bFloatingCtrl );
//STRIP001 };
//STRIP001 
//STRIP001 
//STRIP001 ////////////////////////////////////////////////////////////////////////////////////////////////////
//STRIP001 
//STRIP001 // Powerpoint Recordtypen
//STRIP001 #define PPT_PST_Unknown							0
//STRIP001 #define PPT_PST_SubContainerCompleted			1
//STRIP001 #define PPT_PST_IRRAtom							2
//STRIP001 #define PPT_PST_PSS								3
//STRIP001 #define PPT_PST_SubContainerException			4
//STRIP001 #define PPT_PST_ClientSignal1					6
//STRIP001 #define PPT_PST_ClientSignal2					7
//STRIP001 #define PPT_PST_PowerPointStateInfoAtom			10
//STRIP001 #define PPT_PST_Document						1000
//STRIP001 #define PPT_PST_DocumentAtom					1001
//STRIP001 #define PPT_PST_EndDocument						1002
//STRIP001 #define PPT_PST_SlidePersist					1003
//STRIP001 #define PPT_PST_SlideBase						1004
//STRIP001 #define PPT_PST_SlideBaseAtom					1005
//STRIP001 #define PPT_PST_Slide							1006
//STRIP001 #define PPT_PST_SlideAtom						1007
//STRIP001 #define PPT_PST_Notes							1008
//STRIP001 #define PPT_PST_NotesAtom						1009
//STRIP001 #define PPT_PST_Environment						1010
//STRIP001 #define PPT_PST_SlidePersistAtom				1011
//STRIP001 #define PPT_PST_Scheme							1012
//STRIP001 #define PPT_PST_SchemeAtom						1013
//STRIP001 #define PPT_PST_DocViewInfo						1014
//STRIP001 #define PPT_PST_SslideLayoutAtom				1015
//STRIP001 #define PPT_PST_MainMaster						1016
//STRIP001 #define PPT_PST_SSSlideInfoAtom					1017
//STRIP001 #define PPT_PST_SlideViewInfo					1018
//STRIP001 #define PPT_PST_GuideAtom						1019
//STRIP001 #define PPT_PST_ViewInfo						1020
//STRIP001 #define PPT_PST_ViewInfoAtom					1021
//STRIP001 #define PPT_PST_SlideViewInfoAtom				1022
//STRIP001 #define PPT_PST_VBAInfo							1023
//STRIP001 #define PPT_PST_VBAInfoAtom						1024
//STRIP001 #define PPT_PST_SSDocInfoAtom					1025
//STRIP001 #define PPT_PST_Summary							1026
//STRIP001 #define PPT_PST_Texture							1027
//STRIP001 #define PPT_PST_VBASlideInfo					1028
//STRIP001 #define PPT_PST_VBASlideInfoAtom				1029
//STRIP001 #define PPT_PST_DocRoutingSlip					1030
//STRIP001 #define PPT_PST_OutlineViewInfo					1031
//STRIP001 #define PPT_PST_SorterViewInfo					1032
//STRIP001 #define PPT_PST_ExObjList						1033
//STRIP001 #define PPT_PST_ExObjListAtom					1034
//STRIP001 #define PPT_PST_PPDrawingGroup					1035
//STRIP001 #define PPT_PST_PPDrawing						1036
//STRIP001 #define PPT_PST_NewlyAddedAtomByXP1037 	        1037
//STRIP001 #define PPT_PST_NamedShows						1040
//STRIP001 #define PPT_PST_NamedShow						1041
//STRIP001 #define PPT_PST_NamedShowSlides					1042
//STRIP001 #define PPT_PST_List							2000
//STRIP001 #define PPT_PST_FontCollection					2005
//STRIP001 #define PPT_PST_ListPlaceholder					2017
//STRIP001 #define PPT_PST_BookmarkCollection				2019
//STRIP001 #define PPT_PST_SoundCollection					2020
//STRIP001 #define PPT_PST_SoundCollAtom					2021
//STRIP001 #define PPT_PST_Sound							2022
//STRIP001 #define PPT_PST_SoundData						2023
//STRIP001 #define PPT_PST_BookmarkSeedAtom				2025
//STRIP001 #define PPT_PST_GuideList						2026
//STRIP001 #define PPT_PST_RunArray						2028
//STRIP001 #define PPT_PST_RunArrayAtom					2029
//STRIP001 #define PPT_PST_ArrayElementAtom				2030
//STRIP001 #define PPT_PST_Int4ArrayAtom					2031
//STRIP001 #define PPT_PST_ColorSchemeAtom					2032
//STRIP001 
//STRIP001 // these atoms first was seen in ppt2000 in a private Tag atom
//STRIP001 #define PPT_PST_ExtendedBuGraContainer			2040	// consist of 4041
//STRIP001 #define PPT_PST_ExtendedBuGraAtom				2041	// the instance of this atom indices the current graphic
//STRIP001 
//STRIP001 
//STRIP001 #define PPT_PST_OEShape							3008
//STRIP001 #define PPT_PST_ExObjRefAtom					3009
//STRIP001 #define PPT_PST_OEPlaceholderAtom				3011
//STRIP001 #define PPT_PST_GrColor							3020
//STRIP001 #define PPT_PST_GrectAtom						3025
//STRIP001 #define PPT_PST_GratioAtom						3031
//STRIP001 #define PPT_PST_Gscaling						3032
//STRIP001 #define PPT_PST_GpointAtom						3034
//STRIP001 #define PPT_PST_OEShapeAtom						3035
//STRIP001 #define PPT_PST_OutlineTextRefAtom				3998
//STRIP001 #define PPT_PST_TextHeaderAtom					3999
//STRIP001 #define PPT_PST_TextCharsAtom					4000
//STRIP001 #define PPT_PST_StyleTextPropAtom				4001
//STRIP001 #define PPT_PST_BaseTextPropAtom				4002
//STRIP001 #define PPT_PST_TxMasterStyleAtom				4003
//STRIP001 #define PPT_PST_TxCFStyleAtom					4004
//STRIP001 #define PPT_PST_TxPFStyleAtom					4005
//STRIP001 #define PPT_PST_TextRulerAtom					4006
//STRIP001 #define PPT_PST_TextBookmarkAtom				4007
//STRIP001 #define PPT_PST_TextBytesAtom					4008
//STRIP001 #define PPT_PST_TxSIStyleAtom					4009
//STRIP001 #define PPT_PST_TextSpecInfoAtom				4010
//STRIP001 #define PPT_PST_DefaultRulerAtom				4011
//STRIP001 
//STRIP001 // these atoms first was seen in ppt2000 in a private Tag atom
//STRIP001 #define PPT_PST_ExtendedParagraphAtom			4012
//STRIP001 #define PPT_PST_ExtendedParagraphMasterAtom		4013
//STRIP001 #define PPT_PST_ExtendedPresRuleContainer		4014	// consist of 4012, 4015, 
//STRIP001 #define PPT_PST_ExtendedParagraphHeaderAtom		4015	// the instance of this atom indices the current presobj
//STRIP001 														// the first UINT32 in this atom indices the current slideId
//STRIP001 #define PPT_PST_NewlyAddedAtom4016              4016
//STRIP001 
//STRIP001 #define PPT_PST_FontEntityAtom					4023
//STRIP001 #define PPT_PST_FontEmbedData					4024
//STRIP001 #define PPT_PST_TypeFace						4025
//STRIP001 #define PPT_PST_CString							4026
//STRIP001 #define PPT_PST_ExternalObject					4027
//STRIP001 #define PPT_PST_MetaFile						4033
//STRIP001 #define PPT_PST_ExOleObj						4034
//STRIP001 #define PPT_PST_ExOleObjAtom					4035
//STRIP001 #define PPT_PST_ExPlainLinkAtom					4036
//STRIP001 #define PPT_PST_CorePict						4037
//STRIP001 #define PPT_PST_CorePictAtom					4038
//STRIP001 #define PPT_PST_ExPlainAtom						4039
//STRIP001 #define PPT_PST_SrKinsoku						4040
//STRIP001 #define PPT_PST_Handout							4041
//STRIP001 #define PPT_PST_ExEmbed							4044
//STRIP001 #define PPT_PST_ExEmbedAtom						4045
//STRIP001 #define PPT_PST_ExLink							4046
//STRIP001 #define PPT_PST_ExLinkAtom_old					4047
//STRIP001 #define PPT_PST_BookmarkEntityAtom				4048
//STRIP001 #define PPT_PST_ExLinkAtom						4049
//STRIP001 #define PPT_PST_SrKinsokuAtom					4050
//STRIP001 #define PPT_PST_ExHyperlinkAtom					4051
//STRIP001 #define PPT_PST_ExPlain							4053
//STRIP001 #define PPT_PST_ExPlainLink						4054
//STRIP001 #define PPT_PST_ExHyperlink						4055
//STRIP001 #define PPT_PST_SlideNumberMCAtom				4056
//STRIP001 #define PPT_PST_HeadersFooters					4057
//STRIP001 #define PPT_PST_HeadersFootersAtom				4058
//STRIP001 #define PPT_PST_RecolorEntryAtom				4062
//STRIP001 #define PPT_PST_TxInteractiveInfoAtom			4063
//STRIP001 #define PPT_PST_EmFormatAtom					4065
//STRIP001 #define PPT_PST_CharFormatAtom					4066
//STRIP001 #define PPT_PST_ParaFormatAtom					4067
//STRIP001 #define PPT_PST_MasterText						4068
//STRIP001 #define PPT_PST_RecolorInfoAtom					4071
//STRIP001 #define PPT_PST_ExQuickTime						4073
//STRIP001 #define PPT_PST_ExQuickTimeMovie				4074
//STRIP001 #define PPT_PST_ExQuickTimeMovieData			4075
//STRIP001 #define PPT_PST_ExSubscription					4076
//STRIP001 #define PPT_PST_ExSubscriptionSection			4077
//STRIP001 #define PPT_PST_ExControl						4078
//STRIP001 #define PPT_PST_ExControlAtom					4091
//STRIP001 #define PPT_PST_SlideListWithText				4080
//STRIP001 #define PPT_PST_AnimationInfoAtom				4081
//STRIP001 #define PPT_PST_InteractiveInfo					4082
//STRIP001 #define PPT_PST_InteractiveInfoAtom				4083
//STRIP001 #define PPT_PST_SlideList						4084
//STRIP001 #define PPT_PST_UserEditAtom					4085
//STRIP001 #define PPT_PST_CurrentUserAtom					4086
//STRIP001 #define PPT_PST_DateTimeMCAtom					4087
//STRIP001 #define PPT_PST_GenericDateMCAtom				4088
//STRIP001 #define PPT_PST_HeaderMCAtom					4089
//STRIP001 #define PPT_PST_FooterMCAtom					4090
//STRIP001 #define PPT_PST_ExMediaAtom						4100
//STRIP001 #define PPT_PST_ExVideo							4101
//STRIP001 #define PPT_PST_ExAviMovie						4102
//STRIP001 #define PPT_PST_ExMCIMovie						4103
//STRIP001 #define PPT_PST_ExMIDIAudio						4109
//STRIP001 #define PPT_PST_ExCDAudio						4110
//STRIP001 #define PPT_PST_ExWAVAudioEmbedded				4111
//STRIP001 #define PPT_PST_ExWAVAudioLink					4112
//STRIP001 #define PPT_PST_ExOleObjStg						4113
//STRIP001 #define PPT_PST_ExCDAudioAtom					4114
//STRIP001 #define PPT_PST_ExWAVAudioEmbeddedAtom			4115
//STRIP001 #define PPT_PST_AnimationInfo               4116
//STRIP001 #define PPT_PST_RTFDateTimeMCAtom	        4117
//STRIP001 #define PPT_PST_ProgTags                    5000
//STRIP001 #define PPT_PST_ProgStringTag               5001
//STRIP001 #define PPT_PST_ProgBinaryTag               5002
//STRIP001 #define PPT_PST_BinaryTagData               5003
//STRIP001 #define PPT_PST_PrintOptions                6000
//STRIP001 #define PPT_PST_PersistPtrFullBlock         6001
//STRIP001 #define PPT_PST_PersistPtrIncrementalBlock  6002
//STRIP001 
//STRIP001 // these atoms first was seen in ppt2000 in a private Tag atom
//STRIP001 #define PPT_PST_NewlyAddedAtomByPPT2000_6010    6010
//STRIP001 #define PPT_PST_NewlyAddedAtomByPPT2000_6011    6011
//STRIP001 
//STRIP001 
//STRIP001 #define PPT_PST_RulerIndentAtom            10000
//STRIP001 #define PPT_PST_GscalingAtom               10001
//STRIP001 #define PPT_PST_GrColorAtom                10002
//STRIP001 #define PPT_PST_GLPointAtom                10003
//STRIP001 #define PPT_PST_GlineAtom                  10004
//STRIP001 
//STRIP001 #define PPT_PST_NewlyAddedAtomByXP11008     11008
//STRIP001 #define PPT_PST_NewlyAddedAtomByXP11010     11010
//STRIP001 #define PPT_PST_NewlyAddedAtomByXP12004     12004
//STRIP001 #define PPT_PST_NewlyAddedAtomByXP12010     12010
//STRIP001 #define PPT_PST_NewlyAddedAtomByXP12011     12011
//STRIP001 #define PPT_PST_NewlyAddedAtomByXP14001     14001
//STRIP001 
//STRIP001 
//STRIP001 // Attribute fuer PptTextStyleSheet
//STRIP001 #define PPT_ParaAttr_BulletOn		0	//00000001
//STRIP001 #define PPT_ParaAttr_BuHardFont		1	//00000002
//STRIP001 #define PPT_ParaAttr_BuHardColor	2	//00000004
//STRIP001 #define PPT_ParaAttr_BuHardHeight	3	//00000008
//STRIP001 #define PPT_ParaAttr_BulletChar		7	//00000080 hier hat Mickysoft mal
//STRIP001 #define PPT_ParaAttr_BulletFont		4	//00000010 wieder die Reihenfolge
//STRIP001 #define PPT_ParaAttr_BulletHeight	6	//00000040 v o e l l i g willenlos
//STRIP001 #define PPT_ParaAttr_BulletColor	5	//00000020 durcheinandergewuerfelt
//STRIP001 
//STRIP001 #define PPT_ParaAttr_DontKnow1		8	//00000100
//STRIP001 #define PPT_ParaAttr_DontKnow2		9	//00000200
//STRIP001 #define PPT_ParaAttr_DontKnow3		10	//00000400
//STRIP001 #define PPT_ParaAttr_Adjust			11	//00000800 0000=Left, 0001=Center, 0002=Right, 0003=Block
//STRIP001 
//STRIP001 #define PPT_ParaAttr_LineFeed		12	//00001000
//STRIP001 #define PPT_ParaAttr_UpperDist		13	//00002000 ist bei Textframes default immer auf 0032 gesetzt
//STRIP001 #define PPT_ParaAttr_LowerDist		14	//00004000
//STRIP001 #define PPT_ParaAttr_TextOfs		15	//00008000
//STRIP001 
//STRIP001 #define PPT_ParaAttr_BulletOfs		16	//00010000
//STRIP001 #define PPT_ParaAttr_DefaultTab		17	//00020000
//STRIP001 #define PPT_ParaAttr_AsianLB_1      18
//STRIP001 #define PPT_ParaAttr_AsianLB_2      19
//STRIP001 #define PPT_ParaAttr_AsianLB_3      20
//STRIP001 #define PPT_ParaAttr_BiDi			21  //00200000
//STRIP001 
//STRIP001 #define PPT_CharAttr_Bold				0	//00000001
//STRIP001 #define PPT_CharAttr_Italic				1	//00000002
//STRIP001 #define PPT_CharAttr_Underline			2	//00000004
//STRIP001 #define PPT_CharAttr_Shadow				4	//00000010
//STRIP001 #define PPT_CharAttr_Strikeout			8	//00000100
//STRIP001 #define PPT_CharAttr_Embossed			9	//00000200
//STRIP001 #define PPT_CharAttr_ResetNumbering     10  //00000400
//STRIP001 #define PPT_CharAttr_EnableNumbering1   11  //00000800
//STRIP001 #define PPT_CharAttr_EnableNumbering2   12  //00001000
//STRIP001 #define PPT_CharAttr_Font				16	//00010000
//STRIP001 #define PPT_CharAttr_AsianOrComplexFont	21	//00200000
//STRIP001 #define PPT_CharAttr_Unknown2			22	//00400000
//STRIP001 #define PPT_CharAttr_Symbol				23	//00800000
//STRIP001 #define PPT_CharAttr_FontHeight			17	//00020000
//STRIP001 #define PPT_CharAttr_FontColor			18	//00040000
//STRIP001 #define PPT_CharAttr_Escapement			19	//00080000
//STRIP001 
//STRIP001 // Werte fuer PptSlideLayoutAtom.eLayout
//STRIP001 #define PPT_LAYOUT_TITLESLIDE				0	// The slide is a title slide
//STRIP001 #define PPT_LAYOUT_TITLEANDBODYSLIDE		1	// Title and body slide
//STRIP001 #define PPT_LAYOUT_TITLEMASTERSLIDE			2	// Title master slide
//STRIP001 #define PPT_LAYOUT_MASTERSLIDE				3	// Master slide layout
//STRIP001 #define PPT_LAYOUT_MASTERNOTES				4	// Master notes layout
//STRIP001 #define PPT_LAYOUT_NOTESTITLEBODY			5	// Notes title/body layout
//STRIP001 #define PPT_LAYOUT_HANDOUTLAYOUT			6	// Handout layout, therefore it doesn't have placeholders except header, footer, and date
//STRIP001 #define PPT_LAYOUT_ONLYTITLE				7	// Only title placeholder
//STRIP001 #define PPT_LAYOUT_2COLUMNSANDTITLE			8	// Body of the slide has 2 columns and a title
//STRIP001 #define PPT_LAYOUT_2ROWSANDTITLE			9	// Slide's body has 2 rows and a title
//STRIP001 #define PPT_LAYOUT_RIGHTCOLUMN2ROWS			10	// Body contains 2 columns, right column has 2 rows
//STRIP001 #define PPT_LAYOUT_LEFTCOLUMN2ROWS			11	// Body contains 2 columns, left column has 2 rows
//STRIP001 #define PPT_LAYOUT_BOTTOMROW2COLUMNS		12	// Body contains 2 rows, bottom row has 2 columns
//STRIP001 #define PPT_LAYOUT_TOPROW2COLUMN			13	// Body contains 2 rows, top row has 2 columns
//STRIP001 #define PPT_LAYOUT_4OBJECTS					14	// 4 objects
//STRIP001 #define PPT_LAYOUT_BIGOBJECT				15	// Big object
//STRIP001 #define PPT_LAYOUT_BLANCSLIDE				16	// Blank slide
//STRIP001 #define PPT_LAYOUT_TITLERIGHTBODYLEFT		17	// Vertical title on the right, body on the left
//STRIP001 #define PPT_LAYOUT_TITLERIGHT2BODIESLEFT	18	// Vertical title on the right, body on the left split into 2 rows
//STRIP001 
//STRIP001 // Werte fuer PptSlideLayoutAtom.aPlaceholderId[]
//STRIP001 #define PPT_PLACEHOLDER_NONE						//	0 None
//STRIP001 #define PPT_PLACEHOLDER_MASTERTITLE					//  1 Master title
//STRIP001 #define PPT_PLACEHOLDER_MASTERBODY					//  2 Master body
//STRIP001 #define PPT_PLACEHOLDER_MASTERCENTEREDTITLE			//  3 Master centered title
//STRIP001 #define PPT_PLACEHOLDER_MASTERNOTESSLIDEIMAGE	5	//  4 Master notes slide image
//STRIP001 #define PPT_PLACEHOLDER_MASTERNOTESBODYIMAGE	6	//  5 Master notes body image
//STRIP001 #define PPT_PLACEHOLDER_MASTERDATE				7	//  6 Master date
//STRIP001 #define PPT_PLACEHOLDER_MASTERSLIDENUMBER		8	//  7 Master slide number
//STRIP001 #define PPT_PLACEHOLDER_MASTERFOOTER			9	//  8 Master footer
//STRIP001 #define PPT_PLACEHOLDER_MASTERHEADER			10	//  9 Master header
//STRIP001 #define PPT_PLACEHOLDER_MASTERSUBTITLE				// 10 Master subtitle
//STRIP001 #define PPT_PLACEHOLDER_GENERICTEXTOBJECT			// 11 Generic text object
//STRIP001 #define PPT_PLACEHOLDER_TITLE					13	// 12 Title
//STRIP001 #define PPT_PLACEHOLDER_BODY					14	// 13 Body
//STRIP001 #define PPT_PLACEHOLDER_NOTESBODY				12	// 14 Notes body
//STRIP001 #define PPT_PLACEHOLDER_CENTEREDTITLE			15	// 15 Centered title
//STRIP001 #define PPT_PLACEHOLDER_SUBTITLE				16	// 16 Subtitle
//STRIP001 #define PPT_PLACEHOLDER_VERTICALTEXTTITLE		17	// 17 Vertical text title
//STRIP001 #define PPT_PLACEHOLDER_VERTICALTEXTBODY		18	// 18 Vertical text body
//STRIP001 #define PPT_PLACEHOLDER_NOTESSLIDEIMAGE			11	// 19 Notes slide image
//STRIP001 #define PPT_PLACEHOLDER_OBJECT					19	// 20 Object (no matter the size)
//STRIP001 #define PPT_PLACEHOLDER_GRAPH					20	// 21 Graph
//STRIP001 #define PPT_PLACEHOLDER_TABLE					21	// 22 Table
//STRIP001 #define PPT_PLACEHOLDER_CLIPART					22	// 23 Clip Art
//STRIP001 #define PPT_PLACEHOLDER_ORGANISZATIONCHART		23	// 24 Organization Chart
//STRIP001 #define PPT_PLACEHOLDER_MEDIACLIP				24	// 25 Media Clip

////////////////////////////////////////////////////////////////////////////////////////////////////

#endif // SVX_LIGHT

}//end of namespace binfilter
#endif //_SVDFPPT_HXX

