/*************************************************************************
 *
 *  $RCSfile: offmgr_appstat.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 10:56:18 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PRECOMPILED
#include "ofapch.hxx"
#endif

#pragma hdrstop

#ifndef _SFXITEMSET_HXX
#include <svtools/itemset.hxx>
#endif
#ifndef _SFX_WHITER_HXX
#include <svtools/whiter.hxx>
#endif
#ifndef _SFXVIEWSH_HXX
#include <bf_sfx2/viewsh.hxx>
#endif

#ifndef _SVX_LANGITEM_HXX
#define ITEMID_LANGUAGE SID_ATTR_LANGUAGE
#include <bf_svx/langitem.hxx>
#endif

#ifndef _UNO_LINGU_HXX
#include <bf_svx/unolingu.hxx>
#endif
#ifndef _LINGU_LNGPROPS_HHX_
#include <bf_linguistic/lngprops.hxx>
#endif

#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif

#include <comphelper/processfactory.hxx>

#include "app.hxx"

#include "sbasltid.hrc"
namespace binfilter {

using namespace comphelper;
using namespace rtl;
using namespace ::com::sun::star;
//using namespace ::com::sun::star::util;
using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::beans;


// ------------------------------------------------------------------------

/*N*/ void OfficeApplication::GetState_Impl( SfxItemSet& rState )
/*N*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
//STRIP001 	SfxWhichIter aIter( rState );
//STRIP001 	sal_uInt16 nWhich = aIter.FirstWhich();
//STRIP001 	SfxBoolItem aBool;
//STRIP001 
//STRIP001 	while ( nWhich )
//STRIP001 	{
//STRIP001 		switch ( nWhich )
//STRIP001 		{
//STRIP001 			case SID_ATTR_LANGUAGE:
//STRIP001 			{
//STRIP001 				Reference< XPropertySet >  xProp( SvxGetLinguPropertySet() );
//STRIP001 
//STRIP001 				Language nDefaultLang = LANGUAGE_NONE;
//STRIP001 				if (xProp.is())
//STRIP001 				{
//STRIP001 					xProp->getPropertyValue(
//STRIP001 								String::CreateFromAscii(UPN_DEFAULT_LANGUAGE) )
//STRIP001 							>>= nDefaultLang;
//STRIP001 				}
//STRIP001 				rState.Put( SvxLanguageItem(nDefaultLang), nWhich );
//STRIP001 				nWhich = 0;
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		if ( nWhich )
//STRIP001 		{
//STRIP001 			aBool.SetWhich( nWhich );
//STRIP001 			rState.Put( aBool );
//STRIP001 		}
//STRIP001 		nWhich = aIter.NextWhich();
//STRIP001 	}
/*N*/ }


}
