/*************************************************************************
 *
 *  $RCSfile: offmgr_opthtml.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:25:47 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {

// include ---------------------------------------------------------------

//STRIP001 #ifdef PRECOMPILED
//STRIP001 #include "ofapch.hxx"
//STRIP001 #endif
//STRIP001 
//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #ifndef PRECOMPILED
//STRIP001 #ifndef _SFXSH_HXX
//STRIP001 //#include <sfxsh.hxx>
//STRIP001 #endif
//STRIP001 #endif
//STRIP001 
//STRIP001 #include "app.hxx"
//STRIP001 #include "htmlcfg.hxx"
//STRIP001 #include "resid.hxx"
//STRIP001 #include "opthtml.hxx"
//STRIP001 
//STRIP001 #include "app.hrc"
//STRIP001 #include "opthtml.hrc"
//STRIP001 
//STRIP001 // Umwandlung der Modi zu den Positionen in der Listbox
//STRIP001 const USHORT aPosToExportArr[] =
//STRIP001 {
//STRIP001 	HTML_CFG_HTML32,
//STRIP001 	HTML_CFG_MSIE_40,
//STRIP001 	HTML_CFG_NS40,
//STRIP001 	HTML_CFG_WRITER
//STRIP001 };
//STRIP001 
//STRIP001 //#define DEPRECATED_ENTRY	0xFFFF
//STRIP001 
//STRIP001 const USHORT aExportToPosArr[] =
//STRIP001 {
//STRIP001 	0,	//HTML 3.2
//STRIP001 	1,	//MS Internet Explorer 4.0
//STRIP001     3,	//StarWriter
//STRIP001     2	//Netscape Navigator 4.0
//STRIP001 };
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 OfaHtmlTabPage::OfaHtmlTabPage(Window* pParent, const SfxItemSet& rSet) :
//STRIP001 		SfxTabPage( pParent, OffResId( RID_OFAPAGE_HTMLOPT), rSet ),
//STRIP001 	aFontSizeGB		( this, ResId( GB_FONTSIZE	   ) ),
//STRIP001 	aSize1FT        ( this, ResId( FT_SIZE1	       ) ),
//STRIP001 	aSize1NF        ( this, ResId( NF_SIZE1	       ) ),
//STRIP001 	aSize2FT        ( this, ResId( FT_SIZE2	       ) ),
//STRIP001 	aSize2NF        ( this, ResId( NF_SIZE2	       ) ),
//STRIP001 	aSize3FT        ( this, ResId( FT_SIZE3	       ) ),
//STRIP001 	aSize3NF        ( this, ResId( NF_SIZE3	       ) ),
//STRIP001 	aSize4FT        ( this, ResId( FT_SIZE4	       ) ),
//STRIP001 	aSize4NF        ( this, ResId( NF_SIZE4	       ) ),
//STRIP001 	aSize5FT        ( this, ResId( FT_SIZE5	       ) ),
//STRIP001 	aSize5NF        ( this, ResId( NF_SIZE5	       ) ),
//STRIP001 	aSize6FT        ( this, ResId( FT_SIZE6	       ) ),
//STRIP001 	aSize6NF        ( this, ResId( NF_SIZE6	       ) ),
//STRIP001 	aSize7FT        ( this, ResId( FT_SIZE7	       ) ),
//STRIP001 	aSize7NF        ( this, ResId( NF_SIZE7	       ) ),
//STRIP001 	aImportGB       ( this, ResId( GB_IMPORT	   ) ),
//STRIP001 	aUnknownTagCB	( this, ResId( CB_UNKNOWN_TAGS ) ),
//STRIP001 	aIgnoreFontNamesCB( this, ResId( CB_IGNORE_FONTNAMES ) ),
//STRIP001 	aExportGB		( this, ResId( GB_EXPORT       ) ),
//STRIP001 	aExportLB       ( this, ResId( LB_EXPORT       ) ),
//STRIP001 	aPrintExtensionCB( this,ResId(CB_PRINT_EXTENSION )),
//STRIP001 	aStarBasicCB	( this, ResId( CB_STARBASIC    ) ),
//STRIP001 	aStarBasicWarningCB(this, ResId( CB_STARBASIC_WARNING    ) ),
//STRIP001 	aSaveGrfLocalCB ( this, ResId( CB_LOCAL_GRF    ) ),
//STRIP001 	aCharSetFT		( this, ResId( FT_CHARSET      ) ),
//STRIP001 	aCharSetLB		( this, ResId( LB_CHARSET      ) )
//STRIP001 
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 	aExportLB.SetSelectHdl(LINK(this, OfaHtmlTabPage, ExportHdl_Impl));
//STRIP001 	aStarBasicCB.SetClickHdl(LINK(this, OfaHtmlTabPage, CheckBoxHdl_Impl));
//STRIP001 
//STRIP001 	// initialize the characterset listbox
//STRIP001 	aCharSetLB.FillWithMimeAndSelectBest();
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------02.09.96 13.47-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 
//STRIP001 OfaHtmlTabPage::~OfaHtmlTabPage()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------02.09.96 13.47-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 
//STRIP001 SfxTabPage*	OfaHtmlTabPage::Create( Window* pParent,
//STRIP001 								const SfxItemSet& rAttrSet )
//STRIP001 {
//STRIP001 	return new OfaHtmlTabPage(pParent, rAttrSet);
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------02.09.96 13.47-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 
//STRIP001 BOOL OfaHtmlTabPage::FillItemSet( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	OfaHtmlOptions* pHtmlOpt = ((OfficeApplication*)
//STRIP001 									SFX_APP())->GetHtmlOptions();
//STRIP001 	if(aSize1NF.GetSavedValue() != aSize1NF.GetText())
//STRIP001 		pHtmlOpt->SetFontSize(0, (USHORT)aSize1NF.GetValue());
//STRIP001 	if(aSize2NF.GetSavedValue() != aSize2NF.GetText())
//STRIP001 		pHtmlOpt->SetFontSize(1, (USHORT)aSize2NF.GetValue());
//STRIP001 	if(aSize3NF.GetSavedValue() != aSize3NF.GetText())
//STRIP001 		pHtmlOpt->SetFontSize(2, (USHORT)aSize3NF.GetValue());
//STRIP001 	if(aSize4NF.GetSavedValue() != aSize4NF.GetText())
//STRIP001 		pHtmlOpt->SetFontSize(3, (USHORT)aSize4NF.GetValue());
//STRIP001 	if(aSize5NF.GetSavedValue() != aSize5NF.GetText())
//STRIP001 		pHtmlOpt->SetFontSize(4, (USHORT)aSize5NF.GetValue());
//STRIP001 	if(aSize6NF.GetSavedValue() != aSize6NF.GetText())
//STRIP001 		pHtmlOpt->SetFontSize(5, (USHORT)aSize6NF.GetValue());
//STRIP001 	if(aSize7NF.GetSavedValue() != aSize7NF.GetText())
//STRIP001 		pHtmlOpt->SetFontSize(6, (USHORT)aSize7NF.GetValue());
//STRIP001 
//STRIP001 	if(aUnknownTagCB.IsChecked() != aUnknownTagCB.GetSavedValue())
//STRIP001 		pHtmlOpt->SetImportUnknown(aUnknownTagCB.IsChecked());
//STRIP001 
//STRIP001 	if(aIgnoreFontNamesCB.IsChecked() != aIgnoreFontNamesCB.GetSavedValue())
//STRIP001 		pHtmlOpt->SetIgnoreFontFamily(aIgnoreFontNamesCB.IsChecked());
//STRIP001 
//STRIP001 	if(aExportLB.GetSelectEntryPos() != aExportLB.GetSavedValue())
//STRIP001 		pHtmlOpt->SetExportMode(aPosToExportArr[aExportLB.GetSelectEntryPos()]);
//STRIP001 
//STRIP001 	if(aStarBasicCB.IsChecked() != aStarBasicCB.GetSavedValue())
//STRIP001 		pHtmlOpt->SetStarBasic(aStarBasicCB.IsChecked());
//STRIP001 
//STRIP001 	if(aStarBasicWarningCB.IsChecked() != aStarBasicWarningCB.GetSavedValue())
//STRIP001 		pHtmlOpt->SetStarBasicWarning(aStarBasicWarningCB.IsChecked());
//STRIP001 
//STRIP001 	if(aSaveGrfLocalCB.IsChecked() != aSaveGrfLocalCB.GetSavedValue())
//STRIP001 		pHtmlOpt->SetSaveGraphicsLocal(aSaveGrfLocalCB.IsChecked());
//STRIP001 
//STRIP001 	if(aPrintExtensionCB.IsChecked() != aPrintExtensionCB.GetSavedValue())
//STRIP001 		pHtmlOpt->SetPrintLayoutExtension(aPrintExtensionCB.IsChecked());
//STRIP001 
//STRIP001 	if( aCharSetLB.GetSelectTextEncoding() != pHtmlOpt->GetTextEncoding() )
//STRIP001 		pHtmlOpt->SetTextEncoding( aCharSetLB.GetSelectTextEncoding() );
//STRIP001 
//STRIP001 	return FALSE;
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------02.09.96 13.47-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 
//STRIP001 void OfaHtmlTabPage::Reset( const SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	const OfaHtmlOptions* pHtmlOpt = ((OfficeApplication*)
//STRIP001 									SFX_APP())->GetHtmlOptions();
//STRIP001 	aSize1NF.SetValue(pHtmlOpt->GetFontSize(0));
//STRIP001 	aSize2NF.SetValue(pHtmlOpt->GetFontSize(1));
//STRIP001 	aSize3NF.SetValue(pHtmlOpt->GetFontSize(2));
//STRIP001 	aSize4NF.SetValue(pHtmlOpt->GetFontSize(3));
//STRIP001 	aSize5NF.SetValue(pHtmlOpt->GetFontSize(4));
//STRIP001 	aSize6NF.SetValue(pHtmlOpt->GetFontSize(5));
//STRIP001 	aSize7NF.SetValue(pHtmlOpt->GetFontSize(6));
//STRIP001 	aUnknownTagCB.Check(pHtmlOpt->IsImportUnknown());
//STRIP001 	aIgnoreFontNamesCB.Check(pHtmlOpt->IsIgnoreFontFamily());
//STRIP001 	USHORT nExport = pHtmlOpt->GetExportMode();
//STRIP001 	if( nExport >= ( sizeof( aExportToPosArr ) / sizeof( USHORT ) ) )
//STRIP001 		nExport = 4;	// default for bad config entry is NS 4.0
//STRIP001 	USHORT nPosArr = aExportToPosArr[ nExport ];
//STRIP001 //	if( nPosArr == DEPRECATED_ENTRY )
//STRIP001 //		nPosArr = aExportToPosArr[ 4 ];		// again: NS 4.0 is default
//STRIP001 	aExportLB.SelectEntryPos( nPosArr );
//STRIP001 	aExportLB.SaveValue();
//STRIP001 
//STRIP001 	ExportHdl_Impl(&aExportLB);
//STRIP001 
//STRIP001 	aStarBasicCB .Check(pHtmlOpt->IsStarBasic());
//STRIP001 	aStarBasicWarningCB .Check(pHtmlOpt->IsStarBasicWarning());
//STRIP001 	aStarBasicWarningCB.Enable(!aStarBasicCB.IsChecked());
//STRIP001 	aSaveGrfLocalCB.Check(pHtmlOpt->IsSaveGraphicsLocal());
//STRIP001 	aPrintExtensionCB.Check(pHtmlOpt->IsPrintLayoutExtension());
//STRIP001 
//STRIP001 	aPrintExtensionCB.SaveValue();
//STRIP001 	aStarBasicCB .SaveValue();
//STRIP001 	aStarBasicWarningCB .SaveValue();
//STRIP001 	aSaveGrfLocalCB.SaveValue();
//STRIP001 	aSize1NF.SaveValue();
//STRIP001 	aSize2NF.SaveValue();
//STRIP001 	aSize3NF.SaveValue();
//STRIP001 	aSize4NF.SaveValue();
//STRIP001 	aSize5NF.SaveValue();
//STRIP001 	aSize6NF.SaveValue();
//STRIP001 	aSize7NF.SaveValue();
//STRIP001 	aUnknownTagCB.SaveValue();
//STRIP001 	aIgnoreFontNamesCB.SaveValue();
//STRIP001 
//STRIP001     if( !pHtmlOpt->IsDefaultTextEncoding() &&
//STRIP001         aCharSetLB.GetSelectTextEncoding() != pHtmlOpt->GetTextEncoding() )
//STRIP001 		aCharSetLB.SelectTextEncoding( pHtmlOpt->GetTextEncoding() );
//STRIP001 }
//STRIP001 
//STRIP001 /*-----------------16.04.98 16:03-------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 IMPL_LINK(OfaHtmlTabPage, ExportHdl_Impl, ListBox*, pBox)
//STRIP001 {
//STRIP001 	USHORT nExport = aPosToExportArr[ pBox->GetSelectEntryPos() ];
//STRIP001 	switch( nExport )
//STRIP001 	{
//STRIP001 		case HTML_CFG_MSIE_40:
//STRIP001 		case HTML_CFG_NS40  :
//STRIP001 		case HTML_CFG_WRITER :
//STRIP001 			aPrintExtensionCB.Enable(TRUE);
//STRIP001 		break;
//STRIP001 		default: aPrintExtensionCB.Enable(FALSE);
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 /* -----------------05.02.99 09:17-------------------
//STRIP001  *
//STRIP001  * --------------------------------------------------*/
//STRIP001 IMPL_LINK(OfaHtmlTabPage, CheckBoxHdl_Impl, CheckBox*, pBox)
//STRIP001 {
//STRIP001 	aStarBasicWarningCB.Enable(!pBox->IsChecked());
//STRIP001 	return 0;
//STRIP001 }


}
