/*************************************************************************
 *
 *  $RCSfile: sc_fuconpol.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:52:18 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif


#pragma hdrstop

//------------------------------------------------------------------------

// TOOLS
#define _BIGINT_HXX
#define _SFXMULTISEL_HXX
#define _STACK_HXX
#define _QUEUE_HXX
#define _DYNARR_HXX
#define _TREELIST_HXX
#define _CACHESTR_HXX
#define _NEW_HXX
//#define _SHL_HXX
//#define _LINK_HXX
//#define _ERRCODE_HXX
//#define _GEN_HXX
//#define _FRACT_HXX
//#define _STRING_HXX
//#define _MTF_HXX
//#define _CONTNR_HXX
//#define _LIST_HXX
//#define _TABLE_HXX
#define _DYNARY_HXX
//#define _UNQIDX_HXX
#define _SVMEMPOOL_HXX
//#define _UNQID_HXX
//#define _DEBUG_HXX
//#define _DATE_HXX
//#define _TIME_HXX
//#define _DATETIME_HXX
//#define _INTN_HXX
//#define _WLDCRD_HXX
//#define _FSYS_HXX
//#define _STREAM_HXX
#define _CACHESTR_HXX
#define _SV_MULTISEL_HXX

//SV
//#define _CLIP_HXX ***
#define _CONFIG_HXX
#define _CURSOR_HXX
#define _FONTDLG_HXX
#define _PRVWIN_HXX
//#define _COLOR_HXX
//#define _PAL_HXX
//#define _BITMAP_HXX
//#define _GDIOBJ_HXX
//#define _POINTR_HXX
//#define _ICON_HXX
//#define _IMAGE_HXX
//#define _KEYCOD_HXX
//#define _EVENT_HXX
#define _HELP_HXX
//#define _APP_HXX
//#define _MDIAPP_HXX
//#define _TIMER_HXX
//#define _METRIC_HXX
//#define _REGION_HXX
//#define _OUTDEV_HXX
//#define _SYSTEM_HXX
//#define _VIRDEV_HXX
//#define _JOBSET_HXX
//#define _PRINT_HXX
//#define _WINDOW_HXX
//#define _SYSWIN_HXX
//#define _WRKWIN_HXX
#define _MDIWIN_HXX
//#define _FLOATWIN_HXX
//#define _DOCKWIN_HXX
//#define _CTRL_HXX
//#define _SCRBAR_HXX
//#define _BUTTON_HXX
//#define _IMAGEBTN_HXX
//#define _FIXED_HXX
//#define _GROUP_HXX
//#define _EDIT_HXX
//#define _COMBOBOX_HXX
//#define _LSTBOX_HXX
//#define _SELENG_HXX ***
//#define _SPLIT_HXX
#define _SPIN_HXX
//#define _FIELD_HXX
//#define _MOREBTN_HXX ***
//#define _TOOLBOX_HXX
//#define _STATUS_HXX ***
//#define _DIALOG_HXX
//#define _MSGBOX_HXX
//#define _SYSDLG_HXX
//#define _FILDLG_HXX
//#define _PRNDLG_HXX
#define _COLDLG_HXX
//#define _TABDLG_HXX
//#define _MENU_HXX
//#define _GDIMTF_HXX
//#define _POLY_HXX
//#define _ACCEL_HXX
//#define _GRAPH_HXX
#define _SOUND_HXX

//------------------------------------------------------------------------

// auto strip #include <bf_svx/svdview.hxx>
// auto strip #ifndef _SVDOBJ_HXX
// auto strip #include <bf_svx/svdobj.hxx>
// auto strip #endif

// auto strip #include "fuconpol.hxx"
// auto strip #include "tabvwsh.hxx"
#include "bf_sc.hrc"

// #98185# Create default drawing objects via keyboard
// auto strip #ifndef _SVDOPATH_HXX
// auto strip #include <bf_svx/svdopath.hxx>
// auto strip #endif

//	Pixelabstand zum Schliessen von Freihand-Zeichnungen

#ifndef CLOSE_PIXDIST
#define CLOSE_PIXDIST 5
#endif
namespace binfilter {
//------------------------------------------------------------------------

/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

//STRIP001 FuConstPolygon::FuConstPolygon(ScTabViewShell* pViewSh, Window* pWin, SdrView* pView,
//STRIP001 				   SdrModel* pDoc, SfxRequest& rReq)
//STRIP001 	: FuConstruct(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

//STRIP001 FuConstPolygon::~FuConstPolygon()
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|* MouseButtonDown-event
|*
\************************************************************************/

//STRIP001 BOOL __EXPORT FuConstPolygon::MouseButtonDown(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	// #95491# remember button state for creation of own MouseEvents
//STRIP001 	SetMouseButtonCode(rMEvt.GetButtons());
//STRIP001 
//STRIP001 	BOOL bReturn = FuConstruct::MouseButtonDown(rMEvt);
//STRIP001 
//STRIP001 	SdrViewEvent aVEvt;
//STRIP001 	SdrHitKind eHit = pView->PickAnything(rMEvt, SDRMOUSEBUTTONDOWN, aVEvt);
//STRIP001 	if (aVEvt.eEvent == SDREVENT_BEGTEXTEDIT)
//STRIP001 	{
//STRIP001 		// Texteingabe hier nicht zulassen
//STRIP001 		aVEvt.eEvent = SDREVENT_BEGDRAGOBJ;
//STRIP001 		pView->EnableExtendedMouseEventDispatcher(FALSE);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		pView->EnableExtendedMouseEventDispatcher(TRUE);
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( pView->MouseButtonDown(rMEvt, pWindow) )
//STRIP001 		bReturn = TRUE;
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }

/*************************************************************************
|*
|* MouseMove-event
|*
\************************************************************************/

//STRIP001 BOOL __EXPORT FuConstPolygon::MouseMove(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	pView->MouseMove(rMEvt, pWindow);
//STRIP001 	BOOL bReturn = FuConstruct::MouseMove(rMEvt);
//STRIP001 	return bReturn;
//STRIP001 }

/*************************************************************************
|*
|* MouseButtonUp-event
|*
\************************************************************************/

//STRIP001 BOOL __EXPORT FuConstPolygon::MouseButtonUp(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	// #95491# remember button state for creation of own MouseEvents
//STRIP001 	SetMouseButtonCode(rMEvt.GetButtons());
//STRIP001 
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 	BOOL bSimple = FALSE;
//STRIP001 
//STRIP001 	SdrViewEvent aVEvt;
//STRIP001 	SdrHitKind eHit = pView->PickAnything(rMEvt, SDRMOUSEBUTTONUP, aVEvt);
//STRIP001 
//STRIP001 	pView->MouseButtonUp(rMEvt, pWindow);
//STRIP001 
//STRIP001 	if (aVEvt.eEvent == SDREVENT_ENDCREATE)
//STRIP001 	{
//STRIP001 		bReturn = TRUE;
//STRIP001 		bSimple = TRUE;			// Doppelklick nicht weiterreichen
//STRIP001 	}
//STRIP001 
//STRIP001 	BOOL bParent;
//STRIP001 	if (bSimple)
//STRIP001 		bParent = FuConstruct::SimpleMouseButtonUp(rMEvt);
//STRIP001 	else
//STRIP001 		bParent = FuConstruct::MouseButtonUp(rMEvt);
//STRIP001 
//STRIP001 	return (bParent || bReturn);
//STRIP001 }

/*************************************************************************
|*
|* Tastaturereignisse bearbeiten
|*
|* Wird ein KeyEvent bearbeitet, so ist der Return-Wert TRUE, andernfalls
|* FALSE.
|*
\************************************************************************/

//STRIP001 BOOL __EXPORT FuConstPolygon::KeyInput(const KeyEvent& rKEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FuConstruct::KeyInput(rKEvt);
//STRIP001 
//STRIP001 	return(bReturn);
//STRIP001 }

/*************************************************************************
|*
|* Function aktivieren
|*
\************************************************************************/

//STRIP001 void FuConstPolygon::Activate()
//STRIP001 {
//STRIP001 	pView->EnableExtendedMouseEventDispatcher(TRUE);
//STRIP001 
//STRIP001 	SdrObjKind eKind;
//STRIP001 
//STRIP001 	switch (GetSlotID())
//STRIP001 	{
//STRIP001 		case SID_DRAW_POLYGON_NOFILL:
//STRIP001 		case SID_DRAW_XPOLYGON_NOFILL:
//STRIP001 		{
//STRIP001 			eKind = OBJ_PLIN;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAW_POLYGON:
//STRIP001 		case SID_DRAW_XPOLYGON:
//STRIP001 		{
//STRIP001 			eKind = OBJ_POLY;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAW_BEZIER_NOFILL:
//STRIP001 		{
//STRIP001 			eKind = OBJ_PATHLINE;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAW_BEZIER_FILL:
//STRIP001 		{
//STRIP001 			eKind = OBJ_PATHFILL;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAW_FREELINE_NOFILL:
//STRIP001 		{
//STRIP001 			eKind = OBJ_FREELINE;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAW_FREELINE:
//STRIP001 		{
//STRIP001 			eKind = OBJ_FREEFILL;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		default:
//STRIP001 		{
//STRIP001 			eKind = OBJ_PATHLINE;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 	pView->SetCurrentObj(eKind);
//STRIP001 
//STRIP001 	pView->SetEditMode(SDREDITMODE_CREATE);
//STRIP001 
//STRIP001 	FuConstruct::Activate();
//STRIP001 
//STRIP001 	aNewPointer = Pointer( POINTER_DRAW_POLYGON );
//STRIP001 	aOldPointer = pWindow->GetPointer();
//STRIP001 	pViewShell->SetActivePointer( aNewPointer );
//STRIP001 }

/*************************************************************************
|*
|* Function deaktivieren
|*
\************************************************************************/

//STRIP001 void FuConstPolygon::Deactivate()
//STRIP001 {
//STRIP001 	pView->SetEditMode(SDREDITMODE_EDIT);
//STRIP001 
//STRIP001 	pView->EnableExtendedMouseEventDispatcher(FALSE);
//STRIP001 
//STRIP001 	FuConstruct::Deactivate();
//STRIP001 
//STRIP001 	pViewShell->SetActivePointer( aOldPointer );
//STRIP001 }

// #98185# Create default drawing objects via keyboard
//STRIP001 SdrObject* FuConstPolygon::CreateDefaultObject(const sal_uInt16 nID, const Rectangle& rRectangle)
//STRIP001 {
//STRIP001 	// case SID_DRAW_POLYGON:
//STRIP001 	// case SID_DRAW_POLYGON_NOFILL:
//STRIP001 	// case SID_DRAW_BEZIER_NOFILL:
//STRIP001 	// case SID_DRAW_FREELINE_NOFILL:
//STRIP001 
//STRIP001 	SdrObject* pObj = SdrObjFactory::MakeNewObject(
//STRIP001 		pView->GetCurrentObjInventor(), pView->GetCurrentObjIdentifier(),
//STRIP001 		0L, pDrDoc);
//STRIP001 
//STRIP001 	if(pObj)
//STRIP001 	{
//STRIP001 		if(pObj->ISA(SdrPathObj))
//STRIP001 		{
//STRIP001 			XPolyPolygon aPoly;
//STRIP001 
//STRIP001 			switch(nID)
//STRIP001 			{
//STRIP001 				case SID_DRAW_BEZIER_NOFILL:
//STRIP001 				{
//STRIP001 					XPolygon aInnerPoly;
//STRIP001 					aInnerPoly[0] = rRectangle.BottomLeft();
//STRIP001 					aInnerPoly[1] = rRectangle.BottomCenter();
//STRIP001 					aInnerPoly[2] = rRectangle.BottomCenter();
//STRIP001 					aInnerPoly[3] = rRectangle.Center();
//STRIP001 					aInnerPoly[4] = rRectangle.TopCenter();
//STRIP001 					aInnerPoly[5] = rRectangle.TopCenter();
//STRIP001 					aInnerPoly[6] = rRectangle.TopRight();
//STRIP001 					
//STRIP001 					aInnerPoly.SetFlags(1, XPOLY_CONTROL);
//STRIP001 					aInnerPoly.SetFlags(2, XPOLY_CONTROL);
//STRIP001 					aInnerPoly.SetFlags(3, XPOLY_SYMMTR);
//STRIP001 					aInnerPoly.SetFlags(4, XPOLY_CONTROL);
//STRIP001 					aInnerPoly.SetFlags(5, XPOLY_CONTROL);
//STRIP001 
//STRIP001 					aPoly.Insert(aInnerPoly);
//STRIP001 					break;
//STRIP001 				}
//STRIP001 				case SID_DRAW_FREELINE_NOFILL:
//STRIP001 				{
//STRIP001 					XPolygon aInnerPoly;
//STRIP001 					aInnerPoly[0] = rRectangle.BottomLeft();
//STRIP001 					aInnerPoly[1] = rRectangle.TopLeft();
//STRIP001 					aInnerPoly[2] = rRectangle.TopCenter();
//STRIP001 					aInnerPoly[3] = rRectangle.Center();
//STRIP001 					aInnerPoly[4] = rRectangle.BottomCenter();
//STRIP001 					aInnerPoly[5] = rRectangle.BottomRight();
//STRIP001 					aInnerPoly[6] = rRectangle.TopRight();
//STRIP001 					
//STRIP001 					aInnerPoly.SetFlags(1, XPOLY_CONTROL);
//STRIP001 					aInnerPoly.SetFlags(2, XPOLY_CONTROL);
//STRIP001 					aInnerPoly.SetFlags(3, XPOLY_SMOOTH);
//STRIP001 					aInnerPoly.SetFlags(4, XPOLY_CONTROL);
//STRIP001 					aInnerPoly.SetFlags(5, XPOLY_CONTROL);
//STRIP001 
//STRIP001 					if(SID_DRAW_FREELINE == nID)
//STRIP001 					{
//STRIP001 						aInnerPoly[7] = rRectangle.BottomRight();
//STRIP001 					}
//STRIP001 					
//STRIP001 					aPoly.Insert(aInnerPoly);
//STRIP001 					break;
//STRIP001 				}
//STRIP001 				case SID_DRAW_POLYGON:
//STRIP001 				case SID_DRAW_POLYGON_NOFILL:
//STRIP001 				{
//STRIP001 					XPolygon aInnerPoly;
//STRIP001 					sal_Int32 nWdt(rRectangle.GetWidth());
//STRIP001 					sal_Int32 nHgt(rRectangle.GetHeight());
//STRIP001 					
//STRIP001 					aInnerPoly[0] = rRectangle.BottomLeft();
//STRIP001 					aInnerPoly[1] = rRectangle.TopLeft() + Point((nWdt * 30) / 100, (nHgt * 70) / 100);
//STRIP001 					aInnerPoly[2] = rRectangle.TopLeft() + Point(0, (nHgt * 15) / 100);
//STRIP001 					aInnerPoly[3] = rRectangle.TopLeft() + Point((nWdt * 65) / 100, 0);
//STRIP001 					aInnerPoly[4] = rRectangle.TopLeft() + Point(nWdt, (nHgt * 30) / 100);
//STRIP001 					aInnerPoly[5] = rRectangle.TopLeft() + Point((nWdt * 80) / 100, (nHgt * 50) / 100);
//STRIP001 					aInnerPoly[6] = rRectangle.TopLeft() + Point((nWdt * 80) / 100, (nHgt * 75) / 100);
//STRIP001 					aInnerPoly[7] = rRectangle.BottomRight();
//STRIP001 					
//STRIP001 					if(SID_DRAW_POLYGON_NOFILL == nID)
//STRIP001 					{
//STRIP001 						aInnerPoly[8] = rRectangle.BottomCenter();
//STRIP001 					}
//STRIP001 
//STRIP001 					aPoly.Insert(aInnerPoly);
//STRIP001 					break;
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			((SdrPathObj*)pObj)->SetPathPoly(aPoly);
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			DBG_ERROR("Object is NO path object");
//STRIP001 		}
//STRIP001 
//STRIP001 		pObj->SetLogicRect(rRectangle);
//STRIP001 	}
//STRIP001 
//STRIP001 	return pObj;
//STRIP001 }



}
