/*************************************************************************
 *
 *  $RCSfile: sc_reffact.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:34:25 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

// INCLUDE ---------------------------------------------------------------

#include <bf_sfx2/app.hxx>
// auto strip #include <bf_sfx2/basedlgs.hxx>
// auto strip #include <bf_sfx2/viewfrm.hxx>

#include "reffact.hxx"
// auto strip #include "tabvwsh.hxx"
#include "bf_sc.hrc"
// auto strip #include "acredlin.hxx"
#include "simpref.hxx"
// auto strip #include "scmod.hxx"
namespace binfilter {

// -----------------------------------------------------------------------

/*N*/ SFX_IMPL_MODELESSDIALOG(ScNameDlgWrapper, FID_DEFINE_NAME )
/*N*/ SFX_IMPL_MODELESSDIALOG(ScSolverDlgWrapper, SID_OPENDLG_SOLVE )
/*N*/ SFX_IMPL_MODELESSDIALOG(ScPivotLayoutWrapper, SID_OPENDLG_PIVOTTABLE )
/*N*/ SFX_IMPL_MODELESSDIALOG(ScTabOpDlgWrapper, SID_OPENDLG_TABOP )
/*N*/ SFX_IMPL_MODELESSDIALOG(ScFilterDlgWrapper, SID_FILTER )
/*N*/ SFX_IMPL_MODELESSDIALOG(ScSpecialFilterDlgWrapper, SID_SPECIAL_FILTER )
/*N*/ SFX_IMPL_MODELESSDIALOG(ScDbNameDlgWrapper, SID_DEFINE_DBNAME )
/*N*/ SFX_IMPL_MODELESSDIALOG(ScConsolidateDlgWrapper, SID_OPENDLG_CONSOLIDATE )
/*N*/ SFX_IMPL_MODELESSDIALOG(ScChartDlgWrapper, SID_OPENDLG_CHART )
/*N*/ SFX_IMPL_MODELESSDIALOG(ScPrintAreasDlgWrapper, SID_OPENDLG_EDIT_PRINTAREA )
/*N*/ SFX_IMPL_MODELESSDIALOG(ScCondFormatDlgWrapper, SID_OPENDLG_CONDFRMT )
/*N*/ SFX_IMPL_MODELESSDIALOG(ScColRowNameRangesDlgWrapper, SID_DEFINE_COLROWNAMERANGES )
/*N*/ SFX_IMPL_MODELESSDIALOG(ScFormulaDlgWrapper, SID_OPENDLG_FUNCTION )
/*N*/ SFX_IMPL_MODELESSDIALOG(ScAcceptChgDlgWrapper, FID_CHG_ACCEPT )
/*N*/ SFX_IMPL_MODELESSDIALOG(ScHighlightChgDlgWrapper, FID_CHG_SHOW )
/*N*/ SFX_IMPL_MODELESSDIALOG(ScSimpleRefDlgWrapper, WID_SIMPLE_REF )
/*!!! dafuer muss der Funktionsautopilot noch umgebaut werden
SFX_IMPL_CHILDWINDOW(ScFunctionDlgWrapper, SID_OPENDLG_FUNCTION )
SFX_IMPL_CHILDWINDOW(ScEditFunctionDlgWrapper, SID_OPENDLG_EDITFUNCTION )
SFX_IMPL_CHILDWINDOW(ScArgumentDlgWrapper, SID_OPENDLG_ARGUMENT )
*/

#define IMPL_CHILD_CTOR(Class,sid) \
	Class::Class( Window*  	 			pParent,					\
					USHORT		 		nId,						\
					SfxBindings*		p,							\
					SfxChildWinInfo*	pInfo )						\
		: SfxChildWindow(pParent, nId)								\
	{DBG_BF_ASSERT(0, "STRIP");} //STRIP001 															\
//STRIP001 		ScTabViewShell* pViewShell =								\
//STRIP001 			PTR_CAST( ScTabViewShell, SfxViewShell::Current() );	\
//STRIP001 		DBG_ASSERT( pViewShell, "missing view shell :-(" );			\
//STRIP001 		pWindow = pViewShell ?										\
//STRIP001 			pViewShell->CreateRefDialog( p, this, pInfo, pParent, sid ) : NULL;	\
//STRIP001 		if (pViewShell && !pWindow)												\
//STRIP001 			pViewShell->GetViewFrame()->SetChildWindow( nId, FALSE );			\
//STRIP001 	}


//=========================================================================

//-------------------------------------------------------------------------
// ScNameDlgWrapper
//-------------------------------------------------------------------------

IMPL_CHILD_CTOR( ScNameDlgWrapper, FID_DEFINE_NAME )

//-------------------------------------------------------------------------
// ScSolverDlgWrapper
//-------------------------------------------------------------------------

IMPL_CHILD_CTOR( ScSolverDlgWrapper, SID_OPENDLG_SOLVE )

//-------------------------------------------------------------------------
// ScPivotLayoutWrapper
//-------------------------------------------------------------------------

IMPL_CHILD_CTOR( ScPivotLayoutWrapper, SID_OPENDLG_PIVOTTABLE )

//-------------------------------------------------------------------------
// ScTabOpDlgWrapper
//-------------------------------------------------------------------------

IMPL_CHILD_CTOR( ScTabOpDlgWrapper, SID_OPENDLG_TABOP )

//-------------------------------------------------------------------------
// ScFilterDlgWrapper
//-------------------------------------------------------------------------

IMPL_CHILD_CTOR( ScFilterDlgWrapper, SID_FILTER )

//-------------------------------------------------------------------------
// ScSpecialFilterDlgWrapper
//-------------------------------------------------------------------------

IMPL_CHILD_CTOR( ScSpecialFilterDlgWrapper, SID_SPECIAL_FILTER )

//-------------------------------------------------------------------------
// ScDbNameDlgWrapper
//-------------------------------------------------------------------------

IMPL_CHILD_CTOR( ScDbNameDlgWrapper, SID_DEFINE_DBNAME )

//-------------------------------------------------------------------------
// ScColRowNameRangesDlgWrapper
//-------------------------------------------------------------------------

IMPL_CHILD_CTOR( ScColRowNameRangesDlgWrapper, SID_DEFINE_COLROWNAMERANGES )

//-------------------------------------------------------------------------
// ScConsolidateDlgWrapper
//-------------------------------------------------------------------------

IMPL_CHILD_CTOR( ScConsolidateDlgWrapper, SID_OPENDLG_CONSOLIDATE )

//-------------------------------------------------------------------------
// ScChartDlgWrapper
//-------------------------------------------------------------------------

IMPL_CHILD_CTOR( ScChartDlgWrapper, SID_OPENDLG_CHART )

//-------------------------------------------------------------------------
// ScPrintAreasDlgWrapper
//-------------------------------------------------------------------------

IMPL_CHILD_CTOR( ScPrintAreasDlgWrapper, SID_OPENDLG_EDIT_PRINTAREA )

//-------------------------------------------------------------------------
// ScCondFormatDlgWrapper
//-------------------------------------------------------------------------

IMPL_CHILD_CTOR( ScCondFormatDlgWrapper, SID_OPENDLG_CONDFRMT )

//-------------------------------------------------------------------------
// ScFormulaDlgWrapper
//-------------------------------------------------------------------------

IMPL_CHILD_CTOR( ScFormulaDlgWrapper, SID_OPENDLG_FUNCTION )


//-------------------------------------------------------------------------
// ScSimpleRefDlgWrapper
//-------------------------------------------------------------------------

static BOOL		bScSimpleRefFlag;
static long		nScSimpleRefHeight;
static long		nScSimpleRefWidth;
static long		nScSimpleRefX;
static long		nScSimpleRefY;
static BOOL		bAutoReOpen=TRUE;

//STRIP001 ScSimpleRefDlgWrapper::ScSimpleRefDlgWrapper( Window* pParent,
//STRIP001 								USHORT		 		nId,
//STRIP001 								SfxBindings*		p,
//STRIP001 								SfxChildWinInfo*	pInfo )
//STRIP001 		: SfxChildWindow(pParent, nId)
//STRIP001 {
//STRIP001 	ScTabViewShell* pViewShell =
//STRIP001 		PTR_CAST( ScTabViewShell, SfxViewShell::Current() );
//STRIP001 	DBG_ASSERT( pViewShell, "missing view shell :-(" );
//STRIP001 
//STRIP001 	if(pInfo!=NULL && bScSimpleRefFlag)
//STRIP001 	{
//STRIP001 		pInfo->aPos.X()=nScSimpleRefX;
//STRIP001 		pInfo->aPos.Y()=nScSimpleRefY;
//STRIP001 		pInfo->aSize.Height()=nScSimpleRefHeight;
//STRIP001 		pInfo->aSize.Width()=nScSimpleRefWidth;
//STRIP001 	}
//STRIP001 	pWindow = NULL;
//STRIP001 
//STRIP001 	if(bAutoReOpen)
//STRIP001 		pWindow = pViewShell->CreateRefDialog( p, this, pInfo, pParent, WID_SIMPLE_REF);
//STRIP001 
//STRIP001 	if (!pWindow)
//STRIP001 	{
//STRIP001 		SC_MOD()->SetRefDialog( nId, FALSE );
//STRIP001 	}
//STRIP001 }

//STRIP001 void ScSimpleRefDlgWrapper::SetDefaultPosSize(Point aPos, Size aSize, BOOL bSet)
//STRIP001 {
//STRIP001 	bScSimpleRefFlag=bSet;
//STRIP001 	if(bScSimpleRefFlag)
//STRIP001 	{
//STRIP001 		nScSimpleRefX=aPos.X();
//STRIP001 		nScSimpleRefY=aPos.Y();
//STRIP001 		nScSimpleRefHeight=aSize.Height();
//STRIP001 		nScSimpleRefWidth=aSize.Width();
//STRIP001 	}
//STRIP001 }


//STRIP001 String ScSimpleRefDlgWrapper::GetRefString()
//STRIP001 {
//STRIP001 	String aResult;
//STRIP001 	if(pWindow!=NULL)
//STRIP001 	{
//STRIP001 		aResult=((ScSimpleRefDlg*)pWindow)->GetRefString();
//STRIP001 	}
//STRIP001 	return aResult;
//STRIP001 }

//STRIP001 void ScSimpleRefDlgWrapper::SetAutoReOpen(BOOL bFlag)
//STRIP001 {
//STRIP001 	bAutoReOpen=bFlag;
//STRIP001 }

//STRIP001 void ScSimpleRefDlgWrapper::SetRefString(const String& rStr)
//STRIP001 {
//STRIP001 	if(pWindow!=NULL)
//STRIP001 	{
//STRIP001 		((ScSimpleRefDlg*)pWindow)->SetRefString(rStr);
//STRIP001 	}
//STRIP001 }

//STRIP001 void ScSimpleRefDlgWrapper::SetCloseHdl( const Link& rLink )
//STRIP001 {
//STRIP001 	if(pWindow!=NULL)
//STRIP001 	{
//STRIP001 		((ScSimpleRefDlg*)pWindow)->SetCloseHdl( rLink );
//STRIP001 	}
//STRIP001 }

//STRIP001 void ScSimpleRefDlgWrapper::SetUnoLinks( const Link& rDone,
//STRIP001 					const Link& rAbort, const Link& rChange )
//STRIP001 {
//STRIP001 	if(pWindow!=NULL)
//STRIP001 	{
//STRIP001 		((ScSimpleRefDlg*)pWindow)->SetUnoLinks( rDone, rAbort, rChange );
//STRIP001 	}
//STRIP001 }

//STRIP001 void ScSimpleRefDlgWrapper::SetFlags( BOOL bCloseOnButtonUp )
//STRIP001 {
//STRIP001 	if(pWindow!=NULL)
//STRIP001 	{
//STRIP001 		((ScSimpleRefDlg*)pWindow)->SetFlags( bCloseOnButtonUp );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void ScSimpleRefDlgWrapper::StartRefInput()
//STRIP001 {
//STRIP001 	if(pWindow!=NULL)
//STRIP001 	{
//STRIP001 		((ScSimpleRefDlg*)pWindow)->StartRefInput();
//STRIP001 	}
//STRIP001 }



//-------------------------------------------------------------------------
// ScAcceptChgDlgWrapper //Kommentar: sollte in die ViewShell
//-------------------------------------------------------------------------

//STRIP001 ScAcceptChgDlgWrapper::ScAcceptChgDlgWrapper(	Window* pParent,
//STRIP001 											USHORT nId,
//STRIP001 											SfxBindings* pBindings,
//STRIP001 											SfxChildWinInfo* pInfo ) :
//STRIP001 											SfxChildWindow( pParent, nId )
//STRIP001 {
//STRIP001 		ScTabViewShell* pViewShell =
//STRIP001 			PTR_CAST( ScTabViewShell, SfxViewShell::Current() );
//STRIP001 		DBG_ASSERT( pViewShell, "missing view shell :-(" );
//STRIP001 		pWindow = new ScAcceptChgDlg( pBindings, this, pParent, pViewShell->GetViewData() );
//STRIP001 		if(pWindow!=NULL)
//STRIP001 		{
//STRIP001 			((ScAcceptChgDlg*)pWindow)->Initialize( pInfo );
//STRIP001 		}
//STRIP001 		if (pViewShell && !pWindow)
//STRIP001 			pViewShell->GetViewFrame()->SetChildWindow( nId, FALSE );
//STRIP001 }

//STRIP001 void ScAcceptChgDlgWrapper::ReInitDlg()
//STRIP001 {
//STRIP001 	ScTabViewShell* pViewShell =
//STRIP001 		PTR_CAST( ScTabViewShell, SfxViewShell::Current() );
//STRIP001 	DBG_ASSERT( pViewShell, "missing view shell :-(" );
//STRIP001 
//STRIP001 	if(pWindow!=NULL)
//STRIP001 	{
//STRIP001 		((ScAcceptChgDlg*)pWindow)->ReInit(pViewShell->GetViewData());
//STRIP001 	}
//STRIP001 }

//-------------------------------------------------------------------------
// ScHighlightChgDlgWrapper
//-------------------------------------------------------------------------

IMPL_CHILD_CTOR( ScHighlightChgDlgWrapper, FID_CHG_SHOW )

/*------------------------------------------------------------------------*/
/*@@@
		//-------------------------------------------------------------------------
		// ScFunctionDlgWrapper
		//-------------------------------------------------------------------------

		IMPL_CHILD_CTOR( ScFunctionDlgWrapper, SID_OPENDLG_FUNCTION )

		//-------------------------------------------------------------------------
		// ScEditFunctionDlgWrapper
		//-------------------------------------------------------------------------

		IMPL_CHILD_CTOR( ScEditFunctionDlgWrapper, SID_OPENDLG_EDITFUNCTION )

		//-------------------------------------------------------------------------
		// ScArgumentDlgWrapper
		//-------------------------------------------------------------------------

		IMPL_CHILD_CTOR( ScArgumentDlgWrapper, SID_OPENDLG_ARGUMENT )
@@@*/
/*------------------------------------------------------------------------*/


}
