/*************************************************************************
 *
 *  $RCSfile: sc_tabview4.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:36:13 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

//------------------------------------------------------------------

#define _MACRODLG_HXX
#define _BIGINT_HXX
#define _SVCONTNR_HXX
#define BASIC_NODIALOGS
#define _SFXMNUITEM_HXX
#define _SVDXOUT_HXX
#define _SVDATTR_HXX
#define _SFXMNUITEM_HXX
#define _DLGCFG_HXX
#define _SFXMNUMGR_HXX
#define _SFXBASIC_HXX
#define _MODALDLG_HXX
#define _SFX_TEMPLDLG_HXX
#define _SFXSTBMGR_HXX
#define _SFXTBXMGR_HXX
#define _BASE_DLGS_HXX
#define _SFXIMGMGR_HXX
#define _SFXMNUMGR_HXX
#define _SFXSTBITEM_HXX
#define _SFXTBXCTRL_HXX
#define _PASSWD_HXX
//#define _SFXFILEDLG_HXX
//#define _SFXREQUEST_HXX
#define _SFXOBJFACE_HXX

// INCLUDE ---------------------------------------------------------------

// auto strip #include <vcl/help.hxx>

#include "tabview.hxx"
// auto strip #include "document.hxx"
#include "docsh.hxx"
#include "scmod.hxx"
// auto strip #include "gridwin.hxx"
#include "globstr.hrc"
#include "cell.hxx"
#include "dociter.hxx"
namespace binfilter {

extern USHORT nScFillModeMouseModifier;				// global.cxx

// STATIC DATA -----------------------------------------------------------

//==================================================================

//
// ---	Referenz-Eingabe / Fill-Cursor
//

//STRIP001 void ScTabView::HideTip()
//STRIP001 {
//STRIP001 	if ( nTipVisible )
//STRIP001 	{
//STRIP001 		Help::HideTip( nTipVisible );
//STRIP001 		nTipVisible = 0;
//STRIP001 	}
//STRIP001 }

//STRIP001 void ScTabView::ShowRefTip()
//STRIP001 {
//STRIP001 	BOOL bDone = FALSE;
//STRIP001 	if ( aViewData.GetRefType() == SC_REFTYPE_REF && Help::IsQuickHelpEnabled() )
//STRIP001 	{
//STRIP001 		USHORT nStartX = aViewData.GetRefStartX();
//STRIP001 		USHORT nStartY = aViewData.GetRefStartY();
//STRIP001 		USHORT nEndX   = aViewData.GetRefEndX();
//STRIP001 		USHORT nEndY   = aViewData.GetRefEndY();
//STRIP001 		if ( nEndX != nStartX || nEndY != nStartY )		// nicht fuer einzelne Zelle
//STRIP001 		{
//STRIP001 			BOOL bLeft = ( nEndX < nStartX );
//STRIP001 			BOOL bTop  = ( nEndY < nStartY );
//STRIP001 			PutInOrder( nStartX, nEndX );
//STRIP001 			PutInOrder( nStartY, nEndY );
//STRIP001 			USHORT nCols = nEndX+1-nStartX;
//STRIP001 			USHORT nRows = nEndY+1-nStartY;
//STRIP001 
//STRIP001 			String aHelp = ScGlobal::GetRscString( STR_QUICKHELP_REF );
//STRIP001 			aHelp.SearchAndReplace( String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("%1")),
//STRIP001 									String::CreateFromInt32(nRows) );
//STRIP001 			aHelp.SearchAndReplace( String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("%2")),
//STRIP001 									String::CreateFromInt32(nCols) );
//STRIP001 
//STRIP001 			ScSplitPos eWhich = aViewData.GetActivePart();
//STRIP001 			Window* pWin = pGridWin[eWhich];
//STRIP001 			if ( pWin )
//STRIP001 			{
//STRIP001 				Point aStart = aViewData.GetScrPos( nStartX, nStartY, eWhich );
//STRIP001 				Point aEnd = aViewData.GetScrPos( nEndX+1, nEndY+1, eWhich );
//STRIP001 
//STRIP001 				Point aPos( bLeft ? aStart.X() : ( aEnd.X() + 3 ),
//STRIP001 							bTop ? aStart.Y() : ( aEnd.Y() + 3 ) );
//STRIP001 				USHORT nFlags = ( bLeft ? QUICKHELP_RIGHT : QUICKHELP_LEFT ) |
//STRIP001 								( bTop ? QUICKHELP_BOTTOM : QUICKHELP_TOP );
//STRIP001 
//STRIP001 				// nicht ueber die editierte Formel
//STRIP001 				if ( !bTop && aViewData.HasEditView( eWhich ) &&
//STRIP001 						nEndY+1 == aViewData.GetEditViewRow() )
//STRIP001 				{
//STRIP001 					//	dann an der oberen Kante der editierten Zelle ausrichten
//STRIP001 					aPos.Y() -= 2;		// die 3 von oben
//STRIP001 					nFlags = ( nFlags & ~QUICKHELP_TOP ) | QUICKHELP_BOTTOM;
//STRIP001 				}
//STRIP001 
//STRIP001 				Rectangle aRect( pWin->OutputToScreenPixel( aPos ), Size(1,1) );
//STRIP001 
//STRIP001 				//!	Test, ob geaendert ??
//STRIP001 
//STRIP001 				HideTip();
//STRIP001 				nTipVisible = Help::ShowTip( pWin, aRect, aHelp, nFlags );
//STRIP001 				bDone = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if (!bDone)
//STRIP001 		HideTip();
//STRIP001 }

//STRIP001 void ScTabView::StopRefMode()
//STRIP001 {
//STRIP001 	if (aViewData.IsRefMode())
//STRIP001 	{
//STRIP001 		aViewData.SetRefMode( FALSE, SC_REFTYPE_NONE );
//STRIP001 
//STRIP001 		HideTip();
//STRIP001 
//STRIP001 		if ( aViewData.GetTabNo() >= aViewData.GetRefStartZ() &&
//STRIP001 				aViewData.GetTabNo() <= aViewData.GetRefEndZ() )
//STRIP001 		{
//STRIP001 			ScDocument* pDoc = aViewData.GetDocument();
//STRIP001 			USHORT nStartX = aViewData.GetRefStartX();
//STRIP001 			USHORT nStartY = aViewData.GetRefStartY();
//STRIP001 			USHORT nEndX = aViewData.GetRefEndX();
//STRIP001 			USHORT nEndY = aViewData.GetRefEndY();
//STRIP001 			if ( nStartX == nEndX && nStartY == nEndY )
//STRIP001 				pDoc->ExtendMerge( nStartX, nStartY, nEndX, nEndY, aViewData.GetTabNo() );
//STRIP001 
//STRIP001 			PaintArea( nStartX,nStartY,nEndX,nEndY, SC_UPDATE_MARKS );
//STRIP001 		}
//STRIP001 
//STRIP001 		pSelEngine->Reset();
//STRIP001 		pSelEngine->SetAddMode( FALSE );		//! sollte das nicht bei Reset passieren?
//STRIP001 
//STRIP001 		ScSplitPos eOld = pSelEngine->GetWhich();
//STRIP001 		ScSplitPos eNew = aViewData.GetActivePart();
//STRIP001 		if ( eNew != eOld )
//STRIP001 		{
//STRIP001 			pSelEngine->SetWindow( pGridWin[ eNew ] );
//STRIP001 			pSelEngine->SetWhich( eNew );
//STRIP001 			pSelEngine->SetVisibleArea( Rectangle(Point(),
//STRIP001 										pGridWin[eNew]->GetOutputSizePixel()) );
//STRIP001 			pGridWin[eOld]->MoveMouseStatus(*pGridWin[eNew]);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	//	AlignToCursor(SC_FOLLOW_NONE): Only switch active part.
//STRIP001 	//	This must also be done if no RefMode was active (for RangeFinder dragging),
//STRIP001 	//	but if RefMode was set, AlignToCursor must be after SelectionEngine reset,
//STRIP001 	//	so the SelectionEngine SetWindow call from AlignToCursor doesn't capture
//STRIP001 	//	the mouse again when called from Tracking/MouseButtonUp (#94562#).
//STRIP001 	AlignToCursor( aViewData.GetCurX(), aViewData.GetCurY(), SC_FOLLOW_NONE );
//STRIP001 }

//STRIP001 void ScTabView::DoneRefMode( BOOL bContinue )
//STRIP001 {
//STRIP001 	ScDocument* pDoc = aViewData.GetDocument();
//STRIP001 	if ( aViewData.GetRefType() == SC_REFTYPE_REF && bContinue )
//STRIP001 		SC_MOD()->AddRefEntry();
//STRIP001 
//STRIP001 	BOOL bWasRef = aViewData.IsRefMode();
//STRIP001 	aViewData.SetRefMode( FALSE, SC_REFTYPE_NONE );
//STRIP001 
//STRIP001 	HideTip();
//STRIP001 
//STRIP001 	//	Paint:
//STRIP001 	if ( bWasRef && aViewData.GetTabNo() >= aViewData.GetRefStartZ() &&
//STRIP001 					aViewData.GetTabNo() <= aViewData.GetRefEndZ() )
//STRIP001 	{
//STRIP001 		USHORT nStartX = aViewData.GetRefStartX();
//STRIP001 		USHORT nStartY = aViewData.GetRefStartY();
//STRIP001 		USHORT nEndX = aViewData.GetRefEndX();
//STRIP001 		USHORT nEndY = aViewData.GetRefEndY();
//STRIP001 		if ( nStartX == nEndX && nStartY == nEndY )
//STRIP001 			pDoc->ExtendMerge( nStartX, nStartY, nEndX, nEndY, aViewData.GetTabNo() );
//STRIP001 
//STRIP001 		PaintArea( nStartX,nStartY,nEndX,nEndY, SC_UPDATE_MARKS );
//STRIP001 	}
//STRIP001 }

//STRIP001 void ScTabView::UpdateRef( USHORT nCurX, USHORT nCurY, USHORT nCurZ )
//STRIP001 {
//STRIP001 	ScDocument* pDoc = aViewData.GetDocument();
//STRIP001 
//STRIP001 	if (!aViewData.IsRefMode())
//STRIP001 	{
//STRIP001 		//	Das kommt vor, wenn bei einem Referenz-Dialog als erstes mit Control in die
//STRIP001 		//	die Tabelle geklickt wird. Dann die neue Referenz an den alten Inhalt anhaengen:
//STRIP001 
//STRIP001 		ScModule* pScMod = SC_MOD();
//STRIP001 		if (pScMod->IsFormulaMode())
//STRIP001 			pScMod->AddRefEntry();
//STRIP001 
//STRIP001 		InitRefMode( nCurX, nCurY, nCurZ, SC_REFTYPE_REF );
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( nCurX != aViewData.GetRefEndX() || nCurY != aViewData.GetRefEndY() ||
//STRIP001 		 nCurZ != aViewData.GetRefEndZ() )
//STRIP001 	{
//STRIP001 		ScMarkData& rMark = aViewData.GetMarkData();
//STRIP001 		USHORT nTab = aViewData.GetTabNo();
//STRIP001 
//STRIP001 		USHORT nStartX = aViewData.GetRefStartX();
//STRIP001 		USHORT nStartY = aViewData.GetRefStartY();
//STRIP001 		USHORT nEndX = aViewData.GetRefEndX();
//STRIP001 		USHORT nEndY = aViewData.GetRefEndY();
//STRIP001 		if ( nStartX == nEndX && nStartY == nEndY )
//STRIP001 			pDoc->ExtendMerge( nStartX, nStartY, nEndX, nEndY, nTab );
//STRIP001 		ScUpdateRect aRect( nStartX, nStartY, nEndX, nEndY );
//STRIP001 
//STRIP001 		aViewData.SetRefEnd( nCurX, nCurY, nCurZ );
//STRIP001 
//STRIP001 		nStartX = aViewData.GetRefStartX();
//STRIP001 		nStartY = aViewData.GetRefStartY();
//STRIP001 		nEndX = aViewData.GetRefEndX();
//STRIP001 		nEndY = aViewData.GetRefEndY();
//STRIP001 		if ( nStartX == nEndX && nStartY == nEndY )
//STRIP001 			pDoc->ExtendMerge( nStartX, nStartY, nEndX, nEndY, nTab );
//STRIP001 		aRect.SetNew( nStartX, nStartY, nEndX, nEndY );
//STRIP001 
//STRIP001 		ScRefType eType = aViewData.GetRefType();
//STRIP001 		if ( eType == SC_REFTYPE_REF )
//STRIP001 		{
//STRIP001 			ScRange aRef(
//STRIP001 					aViewData.GetRefStartX(), aViewData.GetRefStartY(), aViewData.GetRefStartZ(),
//STRIP001 					aViewData.GetRefEndX(), aViewData.GetRefEndY(), aViewData.GetRefEndZ() );
//STRIP001 			SC_MOD()->SetReference( aRef, pDoc, &rMark );
//STRIP001 			ShowRefTip();
//STRIP001 		}
//STRIP001 		else if ( eType == SC_REFTYPE_EMBED_LT || eType == SC_REFTYPE_EMBED_RB )
//STRIP001 		{
//STRIP001 			PutInOrder(nStartX,nEndX);
//STRIP001 			PutInOrder(nStartY,nEndY);
//STRIP001 			pDoc->SetEmbedded( ScTripel(nStartX,nStartY,nTab), ScTripel(nEndX,nEndY,nTab) );
//STRIP001 			ScDocShell* pDocSh = aViewData.GetDocShell();
//STRIP001 			pDocSh->UpdateOle( &aViewData, TRUE );
//STRIP001 			pDocSh->SetDocumentModified();
//STRIP001 		}
//STRIP001 
//STRIP001 		USHORT nPaintStartX;
//STRIP001 		USHORT nPaintStartY;
//STRIP001 		USHORT nPaintEndX;
//STRIP001 		USHORT nPaintEndY;
//STRIP001 		if (aRect.GetDiff( nPaintStartX, nPaintStartY, nPaintEndX, nPaintEndY ))
//STRIP001 			PaintArea( nPaintStartX, nPaintStartY, nPaintEndX, nPaintEndY, SC_UPDATE_MARKS );
//STRIP001 	}
//STRIP001 
//STRIP001 	//	Tip-Hilfe fuer Auto-Fill
//STRIP001 
//STRIP001 	if ( aViewData.GetRefType() == SC_REFTYPE_FILL && Help::IsQuickHelpEnabled() )
//STRIP001 	{
//STRIP001 		String aHelpStr;
//STRIP001 		ScRange aMarkRange;
//STRIP001 		aViewData.GetSimpleArea( aMarkRange );
//STRIP001 		USHORT nEndX = aViewData.GetRefEndX();
//STRIP001 		USHORT nEndY = aViewData.GetRefEndY();
//STRIP001 		ScRange aDelRange;
//STRIP001 		if ( aViewData.GetFillMode() == SC_FILL_MATRIX && !(nScFillModeMouseModifier & KEY_MOD1) )
//STRIP001 		{
//STRIP001 			aHelpStr = ScGlobal::GetRscString( STR_TIP_RESIZEMATRIX );
//STRIP001 			USHORT nCols = nEndX + 1 - aViewData.GetRefStartX();	// Reihenfolge ist richtig
//STRIP001 			USHORT nRows = nEndY + 1 - aViewData.GetRefStartY();
//STRIP001 			aHelpStr.SearchAndReplace( String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("%1")),
//STRIP001 									   String::CreateFromInt32(nRows) );
//STRIP001 			aHelpStr.SearchAndReplace( String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("%2")),
//STRIP001 									   String::CreateFromInt32(nCols) );
//STRIP001 		}
//STRIP001 		else if ( aViewData.GetDelMark( aDelRange ) )
//STRIP001 			aHelpStr = ScGlobal::GetRscString( STR_QUICKHELP_DELETE );
//STRIP001 		else if ( nEndX != aMarkRange.aEnd.Col() || nEndY != aMarkRange.aEnd.Row() )
//STRIP001 			aHelpStr = pDoc->GetAutoFillPreview( aMarkRange, nEndX, nEndY );
//STRIP001 
//STRIP001 		//	je nach Richtung die obere oder untere Ecke:
//STRIP001 		USHORT nAddX = ( nEndX >= aMarkRange.aEnd.Col() ) ? 1 : 0;
//STRIP001 		USHORT nAddY = ( nEndY >= aMarkRange.aEnd.Row() ) ? 1 : 0;
//STRIP001 		Point aPos = aViewData.GetScrPos( nEndX+nAddX, nEndY+nAddY, aViewData.GetActivePart() );
//STRIP001 		aPos.X() += 8;
//STRIP001 		aPos.Y() += 4;
//STRIP001 		Window* pWin = GetActiveWin();
//STRIP001 		if ( pWin )
//STRIP001 			aPos = pWin->OutputToScreenPixel( aPos );
//STRIP001 		Rectangle aRect( aPos, aPos );
//STRIP001 		USHORT nAlign = QUICKHELP_LEFT|QUICKHELP_TOP;
//STRIP001 		Help::ShowQuickHelp(pWin, aRect, aHelpStr, nAlign);
//STRIP001 	}
//STRIP001 }

//STRIP001 void ScTabView::InitRefMode( USHORT nCurX, USHORT nCurY, USHORT nCurZ, ScRefType eType, BOOL bPaint )
//STRIP001 {
//STRIP001 	ScDocument* pDoc = aViewData.GetDocument();
//STRIP001 	ScMarkData& rMark = aViewData.GetMarkData();
//STRIP001 	if (!aViewData.IsRefMode())
//STRIP001 	{
//STRIP001 		aViewData.SetRefMode( TRUE, eType );
//STRIP001 		aViewData.SetRefStart( nCurX, nCurY, nCurZ );
//STRIP001 		aViewData.SetRefEnd( nCurX, nCurY, nCurZ );
//STRIP001 
//STRIP001 		if (nCurZ == aViewData.GetTabNo() && bPaint)
//STRIP001 		{
//STRIP001 			USHORT nStartX = nCurX;
//STRIP001 			USHORT nStartY = nCurY;
//STRIP001 			USHORT nEndX = nCurX;
//STRIP001 			USHORT nEndY = nCurY;
//STRIP001 			pDoc->ExtendMerge( nStartX, nStartY, nEndX, nEndY, aViewData.GetTabNo() );
//STRIP001 
//STRIP001 			//!	nur Markierung ueber Inhalte zeichnen!
//STRIP001 			PaintArea( nStartX,nStartY,nEndX,nEndY, SC_UPDATE_MARKS );
//STRIP001 
//STRIP001 			//	SetReference ohne Merge-Anpassung
//STRIP001 			ScRange aRef( nCurX,nCurY,nCurZ, nCurX,nCurY,nCurZ );
//STRIP001 			SC_MOD()->SetReference( aRef, pDoc, &rMark );
//STRIP001 		}
//STRIP001 	}
//STRIP001 }

//STRIP001 void ScTabView::EndSelection()
//STRIP001 {
//STRIP001 	ScModule* pScMod = SC_MOD();
//STRIP001 	BOOL bRefMode = pScMod->IsFormulaMode();
//STRIP001 	if ( bRefMode )
//STRIP001 		pScMod->EndReference();
//STRIP001 }

//	UpdateScrollBars - sichtbaren Bereich und Scrollweite der Scrollbars einstellen

/*N*/ long lcl_UpdateBar( ScrollBar& rScroll, USHORT nSize )		// Size = (komplette) Zellen
/*N*/ {
/*N*/ 	long nOldPos;
/*N*/ 	long nNewPos;
/*N*/ 
/*N*/ 	nOldPos = rScroll.GetThumbPos();
/*N*/ 	rScroll.SetPageSize( nSize );
/*N*/ 	nNewPos = rScroll.GetThumbPos();
/*N*/ #ifndef UNX
/*N*/ 	rScroll.SetPageSize( 1 );				// immer moeglich !
/*N*/ #endif
/*N*/ 
/*N*/ 	return nNewPos - nOldPos;
/*N*/ }

/*N*/ void lcl_SetScrollRange( ScrollBar& rBar, USHORT nDocEnd, USHORT nPos, USHORT nVis,
/*N*/ 							USHORT nMax, USHORT nStart )
/*N*/ {
/*N*/ 	++nVis;
/*N*/ 	++nMax;		// fuer teilweise sichtbare Zellen
/*N*/ 	USHORT nEnd = Max(nDocEnd, (USHORT)(nPos+nVis)) + nVis;
/*N*/ 	if (nEnd > nMax)
/*N*/ 		nEnd = nMax;
/*N*/ 
/*N*/ 	rBar.SetRangeMax( nEnd - nStart );		// RangeMin muss selber verwaltet werden
/*N*/ }

/*N*/ void ScTabView::UpdateScrollBars()
/*N*/ {
/*N*/ 	long		nDiff;
/*N*/ 	BOOL		bTop =   ( aViewData.GetVSplitMode() != SC_SPLIT_NONE );
/*N*/ 	BOOL		bRight = ( aViewData.GetHSplitMode() != SC_SPLIT_NONE );
/*N*/ 	ScDocument*	pDoc = aViewData.GetDocument();
/*N*/ 	USHORT		nTab = aViewData.GetTabNo();
/*N*/ 	USHORT		nUsedX;
/*N*/ 	USHORT		nUsedY;
/*N*/ 	pDoc->GetTableArea( nTab, nUsedX, nUsedY );		//! cachen !!!!!!!!!!!!!!!
/*N*/ 
/*N*/ 	USHORT nVisXL = 0;
/*N*/ 	USHORT nVisXR = 0;
/*N*/ 	USHORT nVisYB = 0;
/*N*/ 	USHORT nVisYT = 0;
/*N*/ 
/*N*/ 	USHORT nStartX = 0;
/*N*/ 	USHORT nStartY = 0;
/*N*/ 	if (aViewData.GetHSplitMode()==SC_SPLIT_FIX)
/*?*/ 		nStartX = aViewData.GetFixPosX();
/*N*/ 	if (aViewData.GetVSplitMode()==SC_SPLIT_FIX)
/*?*/ 		nStartY = aViewData.GetFixPosY();
/*N*/ 
/*N*/ 	nVisXL = aViewData.VisibleCellsX( SC_SPLIT_LEFT );
/*N*/ 	lcl_SetScrollRange( aHScrollLeft, nUsedX, aViewData.GetPosX(SC_SPLIT_LEFT), nVisXL,
/*N*/ 							MAXCOL, 0 );
/*N*/ 	aHScrollLeft.SetVisibleSize( nVisXL );
/*N*/ 	aHScrollLeft.SetThumbPos( aViewData.GetPosX( SC_SPLIT_LEFT ) );
/*N*/ 
/*N*/ 	nVisYB = aViewData.VisibleCellsY( SC_SPLIT_BOTTOM );
/*N*/ 	lcl_SetScrollRange( aVScrollBottom, nUsedY, aViewData.GetPosY(SC_SPLIT_BOTTOM), nVisYB,
/*N*/ 							MAXROW, nStartY );
/*N*/ 	aVScrollBottom.SetVisibleSize( nVisYB );
/*N*/ 	aVScrollBottom.SetThumbPos( aViewData.GetPosY( SC_SPLIT_BOTTOM ) - nStartY );
/*N*/ 
/*N*/ 	if (bRight)
/*N*/ 	{
/*?*/ 		nVisXR = aViewData.VisibleCellsX( SC_SPLIT_RIGHT );
/*?*/ 		lcl_SetScrollRange( aHScrollRight, nUsedX, aViewData.GetPosX(SC_SPLIT_RIGHT), nVisXR,
/*?*/ 							MAXCOL, nStartX );
/*?*/ 		aHScrollRight.SetVisibleSize( nVisXR );
/*?*/ 		aHScrollRight.SetThumbPos( aViewData.GetPosX( SC_SPLIT_RIGHT ) - nStartX );
/*N*/ 	}
/*N*/ 
/*N*/ 	if (bTop)
/*N*/ 	{
/*?*/ 		nVisYT = aViewData.VisibleCellsY( SC_SPLIT_TOP );
/*?*/ 		lcl_SetScrollRange( aVScrollTop, nUsedY, aViewData.GetPosY(SC_SPLIT_TOP), nVisYT,
/*?*/ 							MAXROW, 0 );
/*?*/ 		aVScrollTop.SetVisibleSize( nVisYT );
/*?*/ 		aVScrollTop.SetThumbPos( aViewData.GetPosY( SC_SPLIT_TOP ) );
/*N*/ 	}
/*N*/ 
/*N*/ 	//		Bereich testen
/*N*/ 
/*N*/ 	nDiff = lcl_UpdateBar( aHScrollLeft, nVisXL );
/*N*/ 	if (nDiff) ScrollX( nDiff, SC_SPLIT_LEFT );
/*N*/ 	if (bRight)
/*N*/ 	{
/*?*/ 		nDiff = lcl_UpdateBar( aHScrollRight, nVisXR );
/*?*/ 		if (nDiff) ScrollX( nDiff, SC_SPLIT_RIGHT );
/*N*/ 	}
/*N*/ 
/*N*/ 	nDiff = lcl_UpdateBar( aVScrollBottom, nVisYB );
/*N*/ 	if (nDiff) ScrollY( nDiff, SC_SPLIT_BOTTOM );
/*N*/ 	if (bTop)
/*N*/ 	{
/*?*/ 		nDiff = lcl_UpdateBar( aVScrollTop, nVisYT );
/*?*/ 		if (nDiff) ScrollY( nDiff, SC_SPLIT_TOP );
/*N*/ 	}
/*N*/ 
/*N*/ 	//		set visible area for online spelling
/*N*/ 
/*N*/ 	if ( aViewData.IsActive() )
/*N*/ 	{
/*N*/ 		ScSplitPos eActive = aViewData.GetActivePart();
/*N*/ 		ScHSplitPos eHWhich = WhichH( eActive );
/*N*/ 		ScVSplitPos eVWhich = WhichV( eActive );
/*N*/ 		USHORT nPosX = aViewData.GetPosX(eHWhich);
/*N*/ 		USHORT nPosY = aViewData.GetPosY(eVWhich);
/*N*/ 		USHORT nEndX = nPosX + ( ( eHWhich == SC_SPLIT_LEFT ) ? nVisXL : nVisXR );
/*N*/ 		USHORT nEndY = nPosY + ( ( eVWhich == SC_SPLIT_TOP ) ? nVisYT : nVisYB );
/*N*/ 		if ( nEndX > MAXCOL ) nEndX = MAXCOL;
/*N*/ 		if ( nEndY > MAXROW ) nEndY = MAXROW;
/*N*/ 		ScRange aVisible( nPosX, nPosY, nTab, nEndX, nEndY, nTab );
/*N*/ 		if ( pDoc->SetVisibleSpellRange( aVisible ) )
/*N*/ 			SC_MOD()->AnythingChanged();				// if visible area has changed
/*N*/ 	}
/*N*/ }

#ifndef HDR_SLIDERSIZE
#define HDR_SLIDERSIZE		2
#endif

//STRIP001 void ScTabView::InvertHorizontal( ScVSplitPos eWhich, long nDragPos )
//STRIP001 {
//STRIP001 	for (USHORT i=0; i<4; i++)
//STRIP001 		if (WhichV((ScSplitPos)i)==eWhich)
//STRIP001 		{
//STRIP001 			ScGridWindow* pWin = pGridWin[i];
//STRIP001 			if (pWin)
//STRIP001 			{
//STRIP001 				Rectangle aRect( 0,nDragPos, pWin->GetOutputSizePixel().Width()-1,nDragPos+HDR_SLIDERSIZE-1 );
//STRIP001 				pWin->Update();
//STRIP001 				pWin->DoInvertRect( aRect );	// Pixel
//STRIP001 			}
//STRIP001 		}
//STRIP001 }

//STRIP001 void ScTabView::InvertVertical( ScHSplitPos eWhich, long nDragPos )
//STRIP001 {
//STRIP001 	for (USHORT i=0; i<4; i++)
//STRIP001 		if (WhichH((ScSplitPos)i)==eWhich)
//STRIP001 		{
//STRIP001 			ScGridWindow* pWin = pGridWin[i];
//STRIP001 			if (pWin)
//STRIP001 			{
//STRIP001 				Rectangle aRect( nDragPos,0, nDragPos+HDR_SLIDERSIZE-1,pWin->GetOutputSizePixel().Height()-1 );
//STRIP001 				pWin->Update();
//STRIP001 				pWin->DoInvertRect( aRect );	// Pixel
//STRIP001 			}
//STRIP001 		}
//STRIP001 }

//==================================================================

/*N*/ void ScTabView::InterpretVisible()
/*N*/ {
/*N*/ 	//	make sure all visible cells are interpreted,
/*N*/ 	//	so the next paint will not execute a macro function
/*N*/ 
/*N*/ 	ScDocument* pDoc = aViewData.GetDocument();
/*N*/ 	if ( !pDoc->GetAutoCalc() )
/*N*/ 		return;
/*N*/ 
/*N*/ 	USHORT nTab = aViewData.GetTabNo();
/*N*/ 	for (USHORT i=0; i<4; i++)
/*N*/ 	{
/*N*/ 		//	rely on gridwin pointers to find used panes
/*N*/ 		//	no IsVisible test in case the whole view is not yet shown
/*N*/ 
/*N*/ 		if (pGridWin[i])
/*N*/ 		{
/*N*/ 			ScHSplitPos eHWhich = WhichH( ScSplitPos(i) );
/*N*/ 			ScVSplitPos eVWhich = WhichV( ScSplitPos(i) );
/*N*/ 
/*N*/ 			USHORT	nX1 = aViewData.GetPosX( eHWhich );
/*N*/ 			USHORT	nY1 = aViewData.GetPosY( eVWhich );
/*N*/ 			USHORT	nX2 = nX1 + aViewData.VisibleCellsX( eHWhich );
/*N*/ 			USHORT	nY2 = nY1 + aViewData.VisibleCellsY( eVWhich );
/*N*/ 
/*N*/ 			if (nX2 > MAXCOL) nX2 = MAXCOL;
/*N*/ 			if (nY2 > MAXROW) nY2 = MAXROW;
/*N*/ 
/*N*/ 			ScCellIterator aIter( pDoc, nX1, nY1, nTab, nX2, nY2, nTab );
/*N*/ 			ScBaseCell* pCell = aIter.GetFirst();
/*N*/ 			while ( pCell )
/*N*/ 			{
/*N*/ 				if ( pCell->GetCellType() == CELLTYPE_FORMULA && ((ScFormulaCell*)pCell)->GetDirty() )
/*N*/ 					((ScFormulaCell*)pCell)->Interpret();
/*N*/ 
/*N*/ 				pCell = aIter.GetNext();
/*N*/ 			}
/*N*/ 		}
/*N*/ 	}
/*N*/ }





}
