/*************************************************************************
 *
 *  $RCSfile: sc_tabvwsh9.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:37:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

// INCLUDE ---------------------------------------------------------------

// auto strip #include <bf_svx/svdmark.hxx>
#include <bf_svx/svdview.hxx>
#include <bf_svx/galbrws.hxx>
// auto strip #include <bf_svx/gallery.hxx>
// auto strip #include <bf_svx/hlnkitem.hxx>
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #include <svtools/whiter.hxx>

#include "tabvwsh.hxx"
// auto strip #include "viewdata.hxx"
// auto strip #include "tabview.hxx"
// auto strip #include "drwlayer.hxx"
#include "userdat.hxx"
#include "docsh.hxx"
namespace binfilter {

// forwards -> galwrap.cxx (wg. CLOOKs)

USHORT	GallerySGA_FORMAT_GRAPHIC();
Graphic GalleryGetGraphic		();
BOOL	GalleryIsLinkage		();
String	GalleryGetFullPath		();
String	GalleryGetFilterName	();

// forwards -> imapwrap.cxx (wg. CLOOKs)

class SvxIMapDlg;

USHORT			ScIMapChildWindowId();
SvxIMapDlg*		ScGetIMapDlg();
const void*		ScIMapDlgGetObj( SvxIMapDlg* pDlg );
const ImageMap&	ScIMapDlgGetMap( SvxIMapDlg* pDlg );

//------------------------------------------------------------------

//STRIP001 void ScTabViewShell::ExecChildWin(SfxRequest& rReq)
//STRIP001 {
//STRIP001 	USHORT nSlot = rReq.GetSlot();
//STRIP001 	switch(nSlot)
//STRIP001 	{
//STRIP001 		case SID_GALLERY:
//STRIP001 		{
//STRIP001 			SfxViewFrame* pThisFrame = GetViewFrame();
//STRIP001 			pThisFrame->ToggleChildWindow( GalleryChildWindow::GetChildWindowId() );
//STRIP001 			pThisFrame->GetBindings().Invalidate( SID_GALLERY );
//STRIP001 			rReq.Ignore();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	}
//STRIP001 }

/*N*/ void ScTabViewShell::GetChildWinState( SfxItemSet& rSet )
/*N*/ {
/*N*/ 	if( SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_GALLERY ) )
/*N*/ 	{
/*N*/ 		USHORT nId = GalleryChildWindow::GetChildWindowId();
/*N*/ 		rSet.Put( SfxBoolItem( SID_GALLERY, GetViewFrame()->HasChildWindow( nId ) ) );
/*N*/ 	}
/*N*/ }

//------------------------------------------------------------------

//STRIP001 void ScTabViewShell::ExecGallery( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 
//STRIP001 	if ( pArgs )
//STRIP001 	{
//STRIP001 		const SfxPoolItem* pItem = NULL;
//STRIP001 		SfxItemState eState = pArgs->GetItemState(SID_GALLERY_FORMATS, TRUE, &pItem);
//STRIP001 		if ( eState == SFX_ITEM_SET )
//STRIP001 		{
//STRIP001 			UINT32 nFormats = ((const SfxUInt32Item*)pItem)->GetValue();
//STRIP001 
			/******************************************************************
			* Graphik einfuegen
			******************************************************************/
//STRIP001 			if ( nFormats & GallerySGA_FORMAT_GRAPHIC() )
//STRIP001 			{
//STRIP001 				MakeDrawLayer();
//STRIP001 
//STRIP001 				Graphic aGraphic = GalleryGetGraphic();
//STRIP001 				Point 	aPos     = GetInsertPos();
//STRIP001 
//STRIP001 				String aPath, aFilter;
//STRIP001 				if ( GalleryIsLinkage() )			// als Link einfuegen?
//STRIP001 				{
//STRIP001 					aPath = GalleryGetFullPath();
//STRIP001 					aFilter = GalleryGetFilterName();
//STRIP001 				}
//STRIP001 
//STRIP001 				PasteGraphic( aPos, aGraphic, aPath, aFilter );
//STRIP001 			}
//STRIP001 			else if ( nFormats & SGA_FORMAT_SOUND )
//STRIP001 			{
//STRIP001 				//	#98115# for sounds (linked or not), insert a hyperlink button,
//STRIP001 				//	like in Impress and Writer
//STRIP001 
//STRIP001 				GalleryExplorer* pGal = SVX_GALLERY();
//STRIP001 				if ( pGal )
//STRIP001 				{
//STRIP001 					String aURL( pGal->GetURL().GetMainURL( INetURLObject::NO_DECODE ) );
//STRIP001 					InsertURL( aURL, aURL, EMPTY_STRING, HLINK_BUTTON );
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }

//STRIP001 void ScTabViewShell::GetGalleryState( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 }

//------------------------------------------------------------------

/*N*/ ScInputHandler* ScTabViewShell::GetInputHandler() const
/*N*/ {
/*N*/ 	return pInputHandler;
/*N*/ }

//------------------------------------------------------------------

//STRIP001 String __EXPORT ScTabViewShell::GetDescription() const
//STRIP001 {
//STRIP001 	return String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM(" ** Test ** "));
//STRIP001 }

//STRIP001 void ScTabViewShell::ExecImageMap( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	USHORT nSlot = rReq.GetSlot();
//STRIP001 	switch(nSlot)
//STRIP001 	{
//STRIP001 		case SID_IMAP:
//STRIP001 		{
//STRIP001 			SfxViewFrame* pThisFrame = GetViewFrame();
//STRIP001 			USHORT nId = ScIMapChildWindowId();
//STRIP001 			pThisFrame->ToggleChildWindow( nId );
//STRIP001 			GetViewFrame()->GetBindings().Invalidate( SID_IMAP );
//STRIP001 
//STRIP001 			if ( pThisFrame->HasChildWindow( nId ) )
//STRIP001 			{
//STRIP001 				SvxIMapDlg*	pDlg = ScGetIMapDlg();
//STRIP001 				if ( pDlg )
//STRIP001 				{
//STRIP001 					SdrView* pDrView = GetSdrView();
//STRIP001 					if ( pDrView )
//STRIP001 					{
//STRIP001 						const SdrMarkList& rMarkList = pDrView->GetMarkList();
//STRIP001 						if ( rMarkList.GetMarkCount() == 1 )
//STRIP001 							UpdateIMap( rMarkList.GetMark( 0 )->GetObj() );
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			rReq.Ignore();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_IMAP_EXEC:
//STRIP001 		{
//STRIP001 			SdrView* pDrView = GetSdrView();
//STRIP001 			SdrMark* pMark = pDrView ? pDrView->GetMarkList().GetMark(0) : 0;
//STRIP001 
//STRIP001 			if ( pMark )
//STRIP001 			{
//STRIP001 				SdrObject*	pSdrObj = pMark->GetObj();
//STRIP001 				SvxIMapDlg*	pDlg = ScGetIMapDlg();
//STRIP001 
//STRIP001 				if ( ScIMapDlgGetObj(pDlg) == (void*) pSdrObj )
//STRIP001 				{
//STRIP001 					const ImageMap&	rImageMap = ScIMapDlgGetMap(pDlg);
//STRIP001 					ScIMapInfo*		pIMapInfo = ScDrawLayer::GetIMapInfo( pSdrObj );
//STRIP001 
//STRIP001 					if ( !pIMapInfo )
//STRIP001 						pSdrObj->InsertUserData( new ScIMapInfo( rImageMap ) );
//STRIP001 					else
//STRIP001 						pIMapInfo->SetImageMap( rImageMap );
//STRIP001 
//STRIP001 	                GetViewData()->GetDocShell()->SetDrawModified();
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	}
//STRIP001 }

//STRIP001 void ScTabViewShell::GetImageMapState( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	SfxWhichIter aIter(rSet);
//STRIP001 	USHORT nWhich = aIter.FirstWhich();
//STRIP001 	while ( nWhich )
//STRIP001 	{
//STRIP001 		switch ( nWhich )
//STRIP001 		{
//STRIP001 			case SID_IMAP:
//STRIP001 				{
//STRIP001 					//	Disabled wird nicht mehr...
//STRIP001 
//STRIP001 					BOOL bThere = FALSE;
//STRIP001 					SfxViewFrame* pThisFrame = GetViewFrame();
//STRIP001 					USHORT nId = ScIMapChildWindowId();
//STRIP001 					if ( pThisFrame->KnowsChildWindow(nId) )
//STRIP001 						if ( pThisFrame->HasChildWindow(nId) )
//STRIP001 							bThere = TRUE;
//STRIP001 
//STRIP001 					ObjectSelectionType eType=GetCurObjectSelectionType();
//STRIP001 					BOOL bEnable=(eType==OST_OleObject) ||(eType==OST_Graphic);
//STRIP001 					if(!bThere && !bEnable)
//STRIP001 					{
//STRIP001 					   rSet.DisableItem( nWhich );
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{
//STRIP001 						rSet.Put( SfxBoolItem( nWhich, bThere ) );
//STRIP001 					}
//STRIP001 				}
//STRIP001 				break;
//STRIP001 
//STRIP001 			case SID_IMAP_EXEC:
//STRIP001 				{
//STRIP001 					BOOL bDisable = TRUE;
//STRIP001 
//STRIP001 					SdrView* pDrView = GetSdrView();
//STRIP001 					if ( pDrView )
//STRIP001 					{
//STRIP001 						const SdrMarkList& rMarkList = pDrView->GetMarkList();
//STRIP001 						if ( rMarkList.GetMarkCount() == 1 )
//STRIP001 							if ( ScIMapDlgGetObj(ScGetIMapDlg()) ==
//STRIP001 										(void*) rMarkList.GetMark(0)->GetObj() )
//STRIP001 								bDisable = FALSE;
//STRIP001 					}
//STRIP001 
//STRIP001 					rSet.Put( SfxBoolItem( SID_IMAP_EXEC, bDisable ) );
//STRIP001 				}
//STRIP001 				break;
//STRIP001 		}
//STRIP001 
//STRIP001 		nWhich = aIter.NextWhich();
//STRIP001 	}
//STRIP001 }




}
