/*************************************************************************
 *
 *  $RCSfile: sd_dlgctrls.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:36:24 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _COM_SUN_STAR_PRESENTATION_FADEEFFECT_HPP_
#include <com/sun/star/presentation/FadeEffect.hpp>
#endif

// auto strip #include <tools/ref.hxx>
// auto strip #ifndef _TOOLS_DEBUG_HXX
// auto strip #include <tools/debug.hxx>
// auto strip #endif

#include "strings.hrc"
// auto strip #include "dlgctrls.hxx"
// auto strip #include "sdresid.hxx"
#include "fadedef.h"
namespace binfilter {

using namespace ::com::sun::star;

// -----------------------
// - FadeEffectPair list -
// -----------------------

//STRIP001 struct FadeEffectPair
//STRIP001 {
//STRIP001 	presentation::FadeEffect	meFE;
//STRIP001 	USHORT						mnResId;
//STRIP001 };
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 static FadeEffectPair aEffects[] = 
//STRIP001 {
//STRIP001 	{ presentation::FadeEffect_NONE, STR_EFFECT_NONE },
//STRIP001 
//STRIP001 	{ presentation::FadeEffect_FADE_FROM_LEFT, STR_EFFECT_FADE_FROM_L },
//STRIP001 	{ presentation::FadeEffect_FADE_FROM_UPPERLEFT, STR_EFFECT_FADE_FROM_UL },
//STRIP001 	{ presentation::FadeEffect_FADE_FROM_TOP, STR_EFFECT_FADE_FROM_T },
//STRIP001 	{ presentation::FadeEffect_FADE_FROM_UPPERRIGHT, STR_EFFECT_FADE_FROM_UR },
//STRIP001 	{ presentation::FadeEffect_FADE_FROM_RIGHT, STR_EFFECT_FADE_FROM_R },
//STRIP001 	{ presentation::FadeEffect_FADE_FROM_LOWERRIGHT, STR_EFFECT_FADE_FROM_LR },
//STRIP001 	{ presentation::FadeEffect_FADE_FROM_BOTTOM, STR_EFFECT_FADE_FROM_B },
//STRIP001 	{ presentation::FadeEffect_FADE_FROM_LOWERLEFT, STR_EFFECT_FADE_FROM_LL },
//STRIP001 
//STRIP001 	{ presentation::FadeEffect_MOVE_FROM_LEFT, STR_EFFECT_DISCARD_FROM_L },
//STRIP001 	{ presentation::FadeEffect_MOVE_FROM_UPPERLEFT, STR_EFFECT_DISCARD_FROM_UL },
//STRIP001 	{ presentation::FadeEffect_MOVE_FROM_TOP, STR_EFFECT_DISCARD_FROM_T },
//STRIP001 	{ presentation::FadeEffect_MOVE_FROM_UPPERRIGHT, STR_EFFECT_DISCARD_FROM_UR },
//STRIP001 	{ presentation::FadeEffect_MOVE_FROM_RIGHT, STR_EFFECT_DISCARD_FROM_R },
//STRIP001 	{ presentation::FadeEffect_MOVE_FROM_LOWERRIGHT, STR_EFFECT_DISCARD_FROM_LR },
//STRIP001 	{ presentation::FadeEffect_MOVE_FROM_BOTTOM, STR_EFFECT_DISCARD_FROM_B },
//STRIP001 	{ presentation::FadeEffect_MOVE_FROM_LOWERLEFT, STR_EFFECT_DISCARD_FROM_LL },
//STRIP001 
//STRIP001 	{ presentation::FadeEffect_UNCOVER_TO_LEFT, STR_EFFECT_UNCOVER_TO_L },
//STRIP001 	{ presentation::FadeEffect_UNCOVER_TO_UPPERLEFT, STR_EFFECT_UNCOVER_TO_UL },
//STRIP001 	{ presentation::FadeEffect_UNCOVER_TO_TOP, STR_EFFECT_UNCOVER_TO_T },
//STRIP001 	{ presentation::FadeEffect_UNCOVER_TO_UPPERRIGHT, STR_EFFECT_UNCOVER_TO_UR },
//STRIP001 	{ presentation::FadeEffect_UNCOVER_TO_RIGHT, STR_EFFECT_UNCOVER_TO_R },
//STRIP001 	{ presentation::FadeEffect_UNCOVER_TO_LOWERRIGHT, STR_EFFECT_UNCOVER_TO_LR },
//STRIP001 	{ presentation::FadeEffect_UNCOVER_TO_BOTTOM, STR_EFFECT_UNCOVER_TO_B },
//STRIP001 	{ presentation::FadeEffect_UNCOVER_TO_LOWERLEFT, STR_EFFECT_UNCOVER_TO_LL },
//STRIP001 
//STRIP001 	{ presentation::FadeEffect_ROLL_FROM_LEFT, STR_EFFECT_ROLL_FROM_L },
//STRIP001 	{ presentation::FadeEffect_ROLL_FROM_TOP, STR_EFFECT_ROLL_FROM_T },
//STRIP001 	{ presentation::FadeEffect_ROLL_FROM_RIGHT, STR_EFFECT_ROLL_FROM_R },
//STRIP001 	{ presentation::FadeEffect_ROLL_FROM_BOTTOM, STR_EFFECT_ROLL_FROM_B },
//STRIP001 
//STRIP001 	{ presentation::FadeEffect_STRETCH_FROM_LEFT, STR_EFFECT_STRETCH_FROM_L },
//STRIP001 	{ presentation::FadeEffect_STRETCH_FROM_TOP, STR_EFFECT_STRETCH_FROM_T },
//STRIP001 	{ presentation::FadeEffect_STRETCH_FROM_RIGHT, STR_EFFECT_STRETCH_FROM_R },
//STRIP001 	{ presentation::FadeEffect_STRETCH_FROM_BOTTOM, STR_EFFECT_STRETCH_FROM_B },
//STRIP001 
//STRIP001 	{ presentation::FadeEffect_WAVYLINE_FROM_LEFT, STR_EFFECT_WAVYLINE_FROM_L },
//STRIP001 	{ presentation::FadeEffect_WAVYLINE_FROM_TOP, STR_EFFECT_WAVYLINE_FROM_T },
//STRIP001 	{ presentation::FadeEffect_WAVYLINE_FROM_RIGHT, STR_EFFECT_WAVYLINE_FROM_R },
//STRIP001 	{ presentation::FadeEffect_WAVYLINE_FROM_BOTTOM, STR_EFFECT_WAVYLINE_FROM_B },
//STRIP001 	
//STRIP001 	{ presentation::FadeEffect_FADE_TO_CENTER, STR_EFFECT_FADE_TO_CENTER },
//STRIP001 	{ presentation::FadeEffect_FADE_FROM_CENTER, STR_EFFECT_FADE_FROM_CENTER },
//STRIP001 	
//STRIP001 	{ presentation::FadeEffect_HORIZONTAL_STRIPES, STR_EFFECT_HORIZONTAL_STRIPES },
//STRIP001 	{ presentation::FadeEffect_VERTICAL_STRIPES, STR_EFFECT_VERTICAL_STRIPES },
//STRIP001 	
//STRIP001 	{ presentation::FadeEffect_HORIZONTAL_LINES, STR_EFFECT_HORIZONTAL_LINES },
//STRIP001 	{ presentation::FadeEffect_VERTICAL_LINES, STR_EFFECT_VERTICAL_LINES },
//STRIP001 	
//STRIP001 	{ presentation::FadeEffect_HORIZONTAL_CHECKERBOARD, STR_EFFECT_HORIZONTAL_CHECKERBOARD },
//STRIP001 	{ presentation::FadeEffect_VERTICAL_CHECKERBOARD, STR_EFFECT_VERTICAL_CHECKERBOARD },
//STRIP001 
//STRIP001 	{ presentation::FadeEffect_CLOCKWISE, STR_EFFECT_CLOCKWISE },
//STRIP001 	{ presentation::FadeEffect_COUNTERCLOCKWISE, STR_EFFECT_COUNTERCLOCKWISE },
//STRIP001 
//STRIP001 	{ presentation::FadeEffect_OPEN_HORIZONTAL, STR_EFFECT_OPEN_HORIZONTAL },
//STRIP001 	{ presentation::FadeEffect_OPEN_VERTICAL, STR_EFFECT_OPEN_VERTICAL },
//STRIP001 
//STRIP001 	{ presentation::FadeEffect_CLOSE_HORIZONTAL, STR_EFFECT_CLOSE_HORIZONTAL },
//STRIP001 	{ presentation::FadeEffect_CLOSE_VERTICAL, STR_EFFECT_CLOSE_VERTICAL },
//STRIP001 
//STRIP001 	{ presentation::FadeEffect_SPIRALIN_LEFT, STR_EFFECT_SPIRALIN_L },
//STRIP001 	{ presentation::FadeEffect_SPIRALIN_RIGHT, STR_EFFECT_SPIRALIN_R },
//STRIP001 	
//STRIP001 	{ presentation::FadeEffect_SPIRALOUT_LEFT, STR_EFFECT_SPIRALOUT_L },
//STRIP001 	{ presentation::FadeEffect_SPIRALOUT_RIGHT, STR_EFFECT_SPIRALOUT_R },
//STRIP001 	
//STRIP001 	{ presentation::FadeEffect_DISSOLVE, STR_EFFECT_DISSOLVE },
//STRIP001 
//STRIP001 	{ presentation::FadeEffect_RANDOM, STR_EFFECT_RANDOM }
//STRIP001 };
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	FadeEffectLB: Fuellt die Listbox mit Strings
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FadeEffectLB::Fill()
//STRIP001 {
//STRIP001 	for( long i = 0, nCount = sizeof( aEffects ) / sizeof( FadeEffectPair ); i < nCount; i++ )
//STRIP001 		InsertEntry( SdResId( aEffects[ i ].mnResId ) );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void FadeEffectLB::SelectEffect( presentation::FadeEffect eFE )
//STRIP001 {
//STRIP001 	BOOL bFound = FALSE;
//STRIP001 
//STRIP001 	for( long i = 0, nCount = sizeof( aEffects ) / sizeof( FadeEffectPair ); ( i < nCount ) && !bFound; i++ )
//STRIP001 	{
//STRIP001 		if( aEffects[ i ].meFE == eFE )
//STRIP001 		{
//STRIP001 			SelectEntryPos( (USHORT) i );
//STRIP001 			bFound = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 presentation::FadeEffect FadeEffectLB::GetSelectedEffect() const
//STRIP001 {
//STRIP001 	presentation::FadeEffect	eFE;
//STRIP001 	const USHORT				nPos = GetSelectEntryPos();
//STRIP001 
//STRIP001 	if( ( LISTBOX_ENTRY_NOTFOUND != nPos ) && ( nPos < ( sizeof( aEffects ) / sizeof( FadeEffectPair ) ) ) )
//STRIP001 		eFE = aEffects[ nPos ].meFE;
//STRIP001 	else
//STRIP001 		eFE = presentation::FadeEffect_FADE_FROM_LEFT;
//STRIP001 
//STRIP001 	return eFE;
//STRIP001 }
}
