#/*************************************************************************
 *
 *  $RCSfile: sd_gluectrl.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:38:19 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#include <string> // HACK: prevent conflict between STLPORT and Workshop headers

#include <bf_svx/dialogs.hrc>
// auto strip #ifndef _SVDGLUE_HXX //autogen
// auto strip #include <bf_svx/svdglue.hxx>
// auto strip #endif
#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif
// auto strip #ifndef _SFXAPP_HXX //autogen
// auto strip #include <bf_sfx2/app.hxx>
// auto strip #endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <bf_sfx2/dispatch.hxx>
#endif
// auto strip #ifndef _SV_TOOLBOX_HXX //autogen
// auto strip #include <vcl/toolbox.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif

#include "strings.hrc"
#include "gluectrl.hxx"
namespace binfilter {
//STRIP001 #include "sdresid.hxx"
//STRIP001 #include "app.hrc"

// z.Z. werden von Joe nur die u.a. Moeglichkeiten unterstuetzt
//STRIP001 #define ESCDIR_COUNT 5
//STRIP001 static UINT16 aEscDirArray[] =
//STRIP001 {
//STRIP001 	SDRESC_SMART,
//STRIP001 	SDRESC_LEFT,
//STRIP001 	SDRESC_RIGHT,
//STRIP001 	SDRESC_TOP,
//STRIP001 	SDRESC_BOTTOM,
//STRIP001 //	SDRESC_LO,
//STRIP001 //	SDRESC_LU,
//STRIP001 //	SDRESC_RO,
//STRIP001 //	SDRESC_RU,
//STRIP001 //	SDRESC_HORZ,
//STRIP001 //	SDRESC_VERT,
//STRIP001 //	SDRESC_ALL
//STRIP001 };



/*N*/ SFX_IMPL_TOOLBOX_CONTROL( SdTbxCtlGlueEscDir, SfxUInt16Item )

//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor fuer Klebepunkt-Autrittsrichtungs-Listbox
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 GlueEscDirLB::GlueEscDirLB( Window* pParent ) :
//STRIP001 		ListBox( pParent, WinBits( WB_BORDER | WB_DROPDOWN ) )
//STRIP001 {
//STRIP001 	String aStr; aStr += sal_Unicode('X');
//STRIP001 	Size aXSize( GetTextWidth( aStr ), GetTextHeight() );
//STRIP001 	//SetPosPixel( Point( aSize.Width(), 0 ) );
//STRIP001 	SetSizePixel( Size( aXSize.Width() * 12, aXSize.Height() * 10 ) );
//STRIP001 	Fill();
//STRIP001 	//SelectEntryPos( 0 );
//STRIP001 	Show();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	Dtor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 GlueEscDirLB::~GlueEscDirLB()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Ermittelt die Austrittsrichtung und verschickt den entspr. Slot
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void GlueEscDirLB::Select()
//STRIP001 {
//STRIP001 	UINT16 nPos = GetSelectEntryPos();
//STRIP001 	SfxUInt16Item aItem( SID_GLUE_ESCDIR, aEscDirArray[ nPos ] );
//STRIP001 
//STRIP001 
//STRIP001 	SfxViewFrame::Current()->GetDispatcher()->Execute( SID_GLUE_ESCDIR, SFX_CALLMODE_ASYNCHRON |
//STRIP001 													   SFX_CALLMODE_RECORD, &aItem, (void*) NULL, 0L );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Fuellen der Listbox mit Strings
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void GlueEscDirLB::Fill()
//STRIP001 {
//STRIP001 	InsertEntry( String( SdResId( STR_GLUE_ESCDIR_SMART ) ) );
//STRIP001 	InsertEntry( String( SdResId( STR_GLUE_ESCDIR_LEFT ) ) );
//STRIP001 	InsertEntry( String( SdResId( STR_GLUE_ESCDIR_RIGHT ) ) );
//STRIP001 	InsertEntry( String( SdResId( STR_GLUE_ESCDIR_TOP ) ) );
//STRIP001 	InsertEntry( String( SdResId( STR_GLUE_ESCDIR_BOTTOM ) ) );
//STRIP001 	/*
//STRIP001 	InsertEntry( String( SdResId( STR_GLUE_ESCDIR_LO ) ) );
//STRIP001 	InsertEntry( String( SdResId( STR_GLUE_ESCDIR_LU ) ) );
//STRIP001 	InsertEntry( String( SdResId( STR_GLUE_ESCDIR_RO ) ) );
//STRIP001 	InsertEntry( String( SdResId( STR_GLUE_ESCDIR_RU ) ) );
//STRIP001 	InsertEntry( String( SdResId( STR_GLUE_ESCDIR_HORZ ) ) );
//STRIP001 	InsertEntry( String( SdResId( STR_GLUE_ESCDIR_VERT ) ) );
//STRIP001 	InsertEntry( String( SdResId( STR_GLUE_ESCDIR_ALL ) ) );
//STRIP001 	*/
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor fuer Klebepunkt-Autrittsrichtungs-Toolbox-Control
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
SdTbxCtlGlueEscDir::SdTbxCtlGlueEscDir( USHORT nId, ToolBox& rTbx,
									SfxBindings& rBindings ) :
		SfxToolBoxControl( nId, rTbx, rBindings )
{DBG_BF_ASSERT(0, "STRIP");
}
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Stellt Status in der Listbox des Controllers dar
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdTbxCtlGlueEscDir::StateChanged( USHORT nSId,
//STRIP001 						SfxItemState eState, const SfxPoolItem* pState )
//STRIP001 {
//STRIP001 	if( eState == SFX_ITEM_AVAILABLE )
//STRIP001 	{
//STRIP001 		GlueEscDirLB* pGlueEscDirLB = (GlueEscDirLB*) ( GetToolBox().
//STRIP001 											GetItemWindow( SID_GLUE_ESCDIR ) );
//STRIP001 		if( pGlueEscDirLB )
//STRIP001 		{
//STRIP001 			if( pState )
//STRIP001 			{
//STRIP001 				pGlueEscDirLB->Enable();
//STRIP001 				if ( IsInvalidItem( pState ) )
//STRIP001 				{
//STRIP001 					pGlueEscDirLB->SetNoSelection();
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					UINT16 nEscDir = ( (const SfxUInt16Item*) pState )->GetValue();
//STRIP001 					pGlueEscDirLB->SelectEntryPos( GetEscDirPos( nEscDir ) );
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				pGlueEscDirLB->Disable();
//STRIP001 				pGlueEscDirLB->SetNoSelection();
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	SfxToolBoxControl::StateChanged( nSId, eState, pState );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* No Comment
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 Window* SdTbxCtlGlueEscDir::CreateItemWindow( Window *pParent )
//STRIP001 {
//STRIP001 	if( GetId() == SID_GLUE_ESCDIR )
//STRIP001 	{
//STRIP001 		return( new GlueEscDirLB( pParent ) );
//STRIP001 	}
//STRIP001 
//STRIP001 	return( NULL );
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Liefert Position im Array fuer EscDir zurueck (Mapping fuer Listbox)
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 UINT16 SdTbxCtlGlueEscDir::GetEscDirPos( UINT16 nEscDir )
//STRIP001 {
//STRIP001 	for( UINT16 i = 0; i < ESCDIR_COUNT; i++ )
//STRIP001 	{
//STRIP001 		if( aEscDirArray[ i ] == nEscDir )
//STRIP001 			return( i );
//STRIP001 	}
//STRIP001 	return( 99 );
//STRIP001 }
}
