/*************************************************************************
 *
 *  $RCSfile: sd_inspage.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:38:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #ifndef _SFXITEMSET_HXX //autogen
// auto strip #include <svtools/itemset.hxx>
// auto strip #endif

#include "strings.hrc"
// auto strip #include "sdattr.hxx"
// auto strip #include "sdresid.hxx"
// auto strip #include "ins_page.hxx"
#include "ins_page.hrc"
namespace binfilter {

/*************************************************************************
|*
|*    SdInsertLayerDlg::SdInsertLayerDlg()
|*
|*    Beschreibung      Dialog-Klasse zum Einfuegen einer Ebene
|*    Ersterstellung    13.10.94
|*    Letzte Aenderung  13.10.94
|*
*************************************************************************/

//STRIP001 SdInsertLayerDlg::SdInsertLayerDlg( Window* pWindow,
//STRIP001 								  const SfxItemSet& rInAttrs,
//STRIP001 								  BOOL bDeletable,
//STRIP001 								  String aStr ) :
//STRIP001 				ModalDialog             ( pWindow, SdResId( DLG_INSERT_LAYER ) ),
//STRIP001 				aFtName                 ( this, SdResId( FT_NAME ) ),
//STRIP001 				aEdtName                ( this, SdResId( EDT_NAME ) ),
//STRIP001 				aCbxVisible             ( this, SdResId( CBX_VISIBLE ) ),
//STRIP001 				aCbxPrintable           ( this, SdResId( CBX_PRINTABLE ) ),
//STRIP001 				aCbxLocked              ( this, SdResId( CBX_LOCKED ) ),
//STRIP001 				//aRbtThisPage          ( this, SdResId( RBT_THISPAGE ) ),
//STRIP001 				//aRbtAllPages          ( this, SdResId( RBT_ALLPAGES ) ),
//STRIP001 				aGrpOptions             ( this, SdResId( GRP_OPTIONS ) ),
//STRIP001 				aBtnOK                  ( this, SdResId( BTN_OK ) ),
//STRIP001 				aBtnCancel              ( this, SdResId( BTN_CANCEL ) ),
//STRIP001 				aBtnHelp                ( this, SdResId( BTN_HELP ) ),
//STRIP001 				aBtnDelete              ( this, SdResId( BTN_DELETE ) ),
//STRIP001 				rOutAttrs               ( rInAttrs )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aBtnDelete.SetClickHdl( LINK ( this, SdInsertLayerDlg, DeleteButtonHdl ) );
//STRIP001 
//STRIP001 	SetText( aStr );
//STRIP001 	if( aStr == String(SdResId( STR_INSERTLAYER )) )
//STRIP001 		aBtnDelete.Hide();
//STRIP001 
//STRIP001 	aEdtName.SetText( ( ( const SdAttrLayerName& ) rOutAttrs.Get( ATTR_LAYER_NAME ) ).GetValue() );
//STRIP001 	aCbxVisible.Check( ( ( const SdAttrLayerVisible& ) rOutAttrs.Get( ATTR_LAYER_VISIBLE ) ).GetValue() );
//STRIP001 	aCbxPrintable.Check( ( ( const SdAttrLayerPrintable& ) rOutAttrs.Get( ATTR_LAYER_PRINTABLE ) ).GetValue() );
//STRIP001 	aCbxLocked.Check( ( ( const SdAttrLayerLocked& ) rOutAttrs.Get( ATTR_LAYER_LOCKED ) ).GetValue() );
//STRIP001 
//STRIP001 	if( !bDeletable )
//STRIP001 	{
//STRIP001 		aFtName.Disable();
//STRIP001 		aEdtName.Disable();
//STRIP001 		aBtnDelete.Disable();
//STRIP001 	}
//STRIP001 	else
//STRIP001 		aBtnDelete.Disable(); // Temporr !!! (wird noch gendert)
//STRIP001 }
//STRIP001 
//STRIP001 #if defined HP9000 || defined SINIX
//STRIP001 SdInsertLayerDlg::SdInsertLayerDlg( Window* pWindow,
//STRIP001 								  const SfxItemSet& rInAttrs,
//STRIP001 								  BOOL bDeletable):
//STRIP001 				ModalDialog             ( pWindow, SdResId( DLG_INSERT_LAYER ) ),
//STRIP001 				aFtName                 ( this, SdResId( FT_NAME ) ),
//STRIP001 				aEdtName                ( this, SdResId( EDT_NAME ) ),
//STRIP001 				aCbxVisible             ( this, SdResId( CBX_VISIBLE ) ),
//STRIP001 				aCbxPrintable           ( this, SdResId( CBX_PRINTABLE ) ),
//STRIP001 				aCbxLocked              ( this, SdResId( CBX_LOCKED ) ),
//STRIP001 				//aRbtThisPage          ( this, SdResId( RBT_THISPAGE ) ),
//STRIP001 				//aRbtAllPages          ( this, SdResId( RBT_ALLPAGES ) ),
//STRIP001 				aGrpOptions             ( this, SdResId( GRP_OPTIONS ) ),
//STRIP001 				aBtnOK                  ( this, SdResId( BTN_OK ) ),
//STRIP001 				aBtnCancel              ( this, SdResId( BTN_CANCEL ) ),
//STRIP001 				aBtnHelp                ( this, SdResId( BTN_HELP ) ),
//STRIP001 				aBtnDelete              ( this, SdResId( BTN_DELETE ) ),
//STRIP001 				rOutAttrs               ( rInAttrs )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aBtnDelete.SetClickHdl( LINK ( this, SdInsertLayerDlg, DeleteButtonHdl ) );
//STRIP001 	String aStr( SdResId( STR_INSERTLAYER ) );
//STRIP001 	SetText( aStr );
//STRIP001 	aBtnDelete.Hide();
//STRIP001 
//STRIP001 	aEdtName.SetText( ( ( const SdAttrLayerName& ) rOutAttrs.Get( ATTR_LAYER_NAME ) ).GetValue() );
//STRIP001 	aCbxVisible.Check( ( ( const SdAttrLayerVisible& ) rOutAttrs.Get( ATTR_LAYER_VISIBLE ) ).GetValue() );
//STRIP001 	aCbxPrintable.Check( ( ( const SdAttrLayerPrintable& ) rOutAttrs.Get( ATTR_LAYER_PRINTABLE ) ).GetValue() );
//STRIP001 	aCbxLocked.Check( ( ( const SdAttrLayerLocked& ) rOutAttrs.Get( ATTR_LAYER_LOCKED ) ).GetValue() );
//STRIP001 
//STRIP001 	if( !bDeletable )
//STRIP001 	{
//STRIP001 		aFtName.Disable();
//STRIP001 		aEdtName.Disable();
//STRIP001 		aBtnDelete.Disable();
//STRIP001 	}
//STRIP001 	else
//STRIP001 		aBtnDelete.Disable(); // Temporr !!! (wird noch gendert)
//STRIP001 }
//STRIP001 
//STRIP001 #endif
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*    SdInsertLayerDlg::GetAttr()
//STRIP001 |*
//STRIP001 |*    Beschreibung      Fuellt uebergebenen Item-Set mit Dialogbox-
//STRIP001 |*                                              Attributen
//STRIP001 |*    Letzte Aenderung  13.10.94
//STRIP001 |*
//STRIP001 *************************************************************************/
//STRIP001 
//STRIP001 void SdInsertLayerDlg::GetAttr( SfxItemSet& rOutAttrs )
//STRIP001 {
//STRIP001 	rOutAttrs.Put( SdAttrLayerName( aEdtName.GetText() ) );
//STRIP001 	rOutAttrs.Put( SdAttrLayerVisible( aCbxVisible.IsChecked() ) );
//STRIP001 	rOutAttrs.Put( SdAttrLayerPrintable( aCbxPrintable.IsChecked() ) );
//STRIP001 	rOutAttrs.Put( SdAttrLayerLocked( aCbxLocked.IsChecked() ) );
//STRIP001 
//STRIP001 	//rOutAttrs.Put( SdAttrLayerThisPage( aRbtThisPage.IsChecked() ) );
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*      Handler: beendet Dialog und liefert
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK_INLINE_START( SdInsertLayerDlg, DeleteButtonHdl, Button *, EMPTYARG )
//STRIP001 {
//STRIP001 	EndDialog( RET_DELETE );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 IMPL_LINK_INLINE_END( SdInsertLayerDlg, DeleteButtonHdl, Button *, EMPTYARG )
}
