/*************************************************************************
 *
 *  $RCSfile: sd_fuchar.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:46:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #include <bf_svx/editdata.hxx>
#include <bf_svx/svxids.hrc>
// auto strip #ifndef _EEITEM_HXX //autogen
// auto strip #include <bf_svx/eeitem.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_BINDINGS_HXX //autogen
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif

// auto strip #include "dlg_char.hxx"
// auto strip #include "sdview.hxx"
// auto strip #include "drawview.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "drviewsh.hxx"
// auto strip #include "viewshel.hxx"
// auto strip #include "docshell.hxx"
// auto strip #include "fuchar.hxx"
namespace binfilter {

//STRIP001 TYPEINIT1( FuChar, FuPoor );
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuChar::FuChar(SdViewShell* pViewSh, SdWindow* pWin, SdView* pView,
//STRIP001 				 SdDrawDocument* pDoc, SfxRequest& rReq)
//STRIP001 	   : FuPoor(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 
//STRIP001 	if( !pArgs )
//STRIP001 	{
//STRIP001 		SfxItemSet aEditAttr( pDoc->GetPool() );
//STRIP001 		pView->GetAttributes( aEditAttr );
//STRIP001 
//STRIP001 		SfxItemSet aNewAttr( pViewSh->GetPool(),
//STRIP001 								EE_ITEMS_START, EE_ITEMS_END );
//STRIP001 		aNewAttr.Put( aEditAttr, FALSE );
//STRIP001 
//STRIP001 		SdCharDlg* pDlg = new SdCharDlg( NULL, &aNewAttr, pDoc->GetDocSh() );
//STRIP001 
//STRIP001 		USHORT nResult = pDlg->Execute();
//STRIP001 
//STRIP001 		switch( nResult )
//STRIP001 		{
//STRIP001 			case RET_OK:
//STRIP001 			{
//STRIP001 				rReq.Done( *( pDlg->GetOutputItemSet() ) );
//STRIP001 
//STRIP001 				pArgs = rReq.GetArgs();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			default:
//STRIP001 			{
//STRIP001 				delete pDlg;
//STRIP001 			}
//STRIP001 			return; // Abbruch
//STRIP001 		}
//STRIP001 		delete( pDlg );
//STRIP001 	}
//STRIP001 	pView->SetAttributes(*pArgs);
//STRIP001 
//STRIP001 	// invalidieren der Slots, die in der DrTxtObjBar auftauchen
//STRIP001 	static USHORT SidArray[] = {
//STRIP001 					SID_ATTR_CHAR_FONT,
//STRIP001 					SID_ATTR_CHAR_POSTURE,
//STRIP001 					SID_ATTR_CHAR_WEIGHT,
//STRIP001 					SID_ATTR_CHAR_UNDERLINE,
//STRIP001 					SID_ATTR_CHAR_FONTHEIGHT,
//STRIP001 					SID_ATTR_CHAR_COLOR,
//STRIP001 					SID_SET_SUPER_SCRIPT,
//STRIP001 					SID_SET_SUB_SCRIPT,
//STRIP001 					0 };
//STRIP001 
//STRIP001 	pViewShell->GetViewFrame()->GetBindings().Invalidate( SidArray );
//STRIP001 
//STRIP001 	if( pDoc->GetOnlineSpell() )
//STRIP001 	{
//STRIP001 		const SfxPoolItem* pItem;
//STRIP001 		if( SFX_ITEM_SET == pArgs->GetItemState(EE_CHAR_LANGUAGE, FALSE, &pItem ) ||
//STRIP001 			SFX_ITEM_SET == pArgs->GetItemState(EE_CHAR_LANGUAGE_CJK, FALSE, &pItem ) ||
//STRIP001 			SFX_ITEM_SET == pArgs->GetItemState(EE_CHAR_LANGUAGE_CTL, FALSE, &pItem ) )
//STRIP001 		{
//STRIP001 			pDoc->StopOnlineSpelling();
//STRIP001 			pDoc->StartOnlineSpelling();
//STRIP001 		}
//STRIP001 	}
//STRIP001 }



}
