/*************************************************************************
 *
 *  $RCSfile: sd_fuconbez.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:46:48 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _AEITEM_HXX //autogen
// auto strip #include <svtools/aeitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOPATH_HXX //autogen
// auto strip #include <bf_svx/svdopath.hxx>
// auto strip #endif
// auto strip #ifndef _SFXINTITEM_HXX //autogen
// auto strip #include <svtools/intitem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOBJ_HXX //autogen
// auto strip #include <bf_svx/svdobj.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_BINDINGS_HXX //autogen
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif

#pragma hdrstop

#include <bf_svx/svxids.hrc>

// auto strip #ifndef _SVDPAGV_HXX //autogen
// auto strip #include <bf_svx/svdpagv.hxx>
// auto strip #endif

#include "app.hrc"
// auto strip #include "viewshel.hxx"
// auto strip #include "sdview.hxx"
// auto strip #include "sdwindow.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "fuconbez.hxx"
#include "res_bmp.hrc"
namespace binfilter {

//STRIP001 TYPEINIT1( FuConstBezPoly, FuConstruct );
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuConstBezPoly::FuConstBezPoly(SdViewShell* pViewSh, SdWindow* pWin,
//STRIP001 							   SdView* pView, SdDrawDocument* pDoc,
//STRIP001 							   SfxRequest& rReq)
//STRIP001 	: FuConstruct(pViewSh, pWin, pView, pDoc, rReq),
//STRIP001 	nEditMode(SID_BEZIER_MOVE)
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuConstBezPoly::~FuConstBezPoly()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonDown-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuConstBezPoly::MouseButtonDown(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FuConstruct::MouseButtonDown(rMEvt);
//STRIP001 
//STRIP001 	SdrViewEvent aVEvt;
//STRIP001 	SdrHitKind eHit = pView->PickAnything(rMEvt, SDRMOUSEBUTTONDOWN, aVEvt);
//STRIP001 
//STRIP001 	if (eHit == SDRHIT_HANDLE || rMEvt.IsMod1())
//STRIP001 	{
//STRIP001 		pView->SetEditMode(SDREDITMODE_EDIT);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		pView->SetEditMode(SDREDITMODE_CREATE);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (aVEvt.eEvent == SDREVENT_BEGTEXTEDIT)
//STRIP001 	{
//STRIP001 		// Texteingabe hier nicht zulassen
//STRIP001 		aVEvt.eEvent = SDREVENT_BEGDRAGOBJ;
//STRIP001 		pView->EnableExtendedMouseEventDispatcher(FALSE);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		pView->EnableExtendedMouseEventDispatcher(TRUE);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (eHit == SDRHIT_MARKEDOBJECT && nEditMode == SID_BEZIER_INSERT)
//STRIP001 	{
//STRIP001 		/******************************************************************
//STRIP001 		* Klebepunkt einfuegen
//STRIP001 		******************************************************************/
//STRIP001 		pView->BegInsObjPoint(aMDPos, rMEvt.IsMod1(), NULL, 0);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		pView->MouseButtonDown(rMEvt, pWindow);
//STRIP001 
//STRIP001 		SdrObject* pObj = pView->GetCreateObj();
//STRIP001 
//STRIP001 		if (pObj)
//STRIP001 		{
//STRIP001 			SfxItemSet aAttr(pDoc->GetPool());
//STRIP001 			SetStyleSheet(aAttr, pObj);
//STRIP001 
//STRIP001 //-/			pObj->NbcSetAttributes(aAttr, FALSE);
//STRIP001 			pObj->SetItemSet(aAttr);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return(bReturn);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseMove-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuConstBezPoly::MouseMove(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FuConstruct::MouseMove(rMEvt);
//STRIP001 	return(bReturn);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonUp-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuConstBezPoly::MouseButtonUp(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 	BOOL bCreated = FALSE;
//STRIP001 
//STRIP001 	SdrViewEvent aVEvt;
//STRIP001 	SdrHitKind eHit = pView->PickAnything(rMEvt, SDRMOUSEBUTTONUP, aVEvt);
//STRIP001 
//STRIP001 	ULONG nCount = pView->GetPageViewPvNum(0)->GetObjList()->GetObjCount();
//STRIP001 
//STRIP001 	if (pView->IsInsObjPoint())
//STRIP001 	{
//STRIP001 		pView->EndInsObjPoint(SDRCREATE_FORCEEND);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		pView->MouseButtonUp(rMEvt, pWindow);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (aVEvt.eEvent == SDREVENT_ENDCREATE)
//STRIP001 	{
//STRIP001 		bReturn = TRUE;
//STRIP001 
//STRIP001 		if (nCount != pView->GetPageViewPvNum(0)->GetObjList()->GetObjCount())
//STRIP001 		{
//STRIP001 			bCreated = TRUE;
//STRIP001 		}
//STRIP001 
//STRIP001 		// Trick, um FuDraw::DoubleClick nicht auszuloesen
//STRIP001 		bMBDown = FALSE;
//STRIP001 
//STRIP001 	}
//STRIP001 
//STRIP001 	bReturn = FuConstruct::MouseButtonUp(rMEvt) || bReturn;
//STRIP001 
//STRIP001 	if (!bPermanent && bCreated)
//STRIP001 		pViewShell->GetViewFrame()->GetDispatcher()->Execute(SID_OBJECT_SELECT, SFX_CALLMODE_ASYNCHRON);
//STRIP001 
//STRIP001 	return(bReturn);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Tastaturereignisse bearbeiten
//STRIP001 |*
//STRIP001 |* Wird ein KeyEvent bearbeitet, so ist der Return-Wert TRUE, andernfalls
//STRIP001 |* FALSE.
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuConstBezPoly::KeyInput(const KeyEvent& rKEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FuConstruct::KeyInput(rKEvt);
//STRIP001 
//STRIP001 	return(bReturn);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function aktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuConstBezPoly::Activate()
//STRIP001 {
//STRIP001 	pView->EnableExtendedMouseEventDispatcher(TRUE);
//STRIP001 
//STRIP001 	SdrObjKind eKind;
//STRIP001 
//STRIP001 	switch (nSlotId)
//STRIP001 	{
//STRIP001 		case SID_DRAW_POLYGON_NOFILL:
//STRIP001 		case SID_DRAW_XPOLYGON_NOFILL:
//STRIP001 		{
//STRIP001 			eKind = OBJ_PLIN;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAW_POLYGON:
//STRIP001 		case SID_DRAW_XPOLYGON:
//STRIP001 		{
//STRIP001 			eKind = OBJ_POLY;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAW_BEZIER_NOFILL:
//STRIP001 		{
//STRIP001 			eKind = OBJ_PATHLINE;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAW_BEZIER_FILL:
//STRIP001 		{
//STRIP001 			eKind = OBJ_PATHFILL;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAW_FREELINE_NOFILL:
//STRIP001 		{
//STRIP001 			eKind = OBJ_FREELINE;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAW_FREELINE:
//STRIP001 		{
//STRIP001 			eKind = OBJ_FREEFILL;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		default:
//STRIP001 		{
//STRIP001 			eKind = OBJ_PATHLINE;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 	pView->SetCurrentObj(eKind);
//STRIP001 
//STRIP001 	FuConstruct::Activate();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function deaktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuConstBezPoly::Deactivate()
//STRIP001 {
//STRIP001 	pView->EnableExtendedMouseEventDispatcher(FALSE);
//STRIP001 
//STRIP001 	FuConstruct::Deactivate();
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Selektion hat sich geaendert
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuConstBezPoly::SelectionHasChanged()
//STRIP001 {
//STRIP001 	FuDraw::SelectionHasChanged();
//STRIP001 
//STRIP001 	/**************************************************************************
//STRIP001 	* ObjectBar einschalten
//STRIP001 	**************************************************************************/
//STRIP001 	USHORT nObjBarId = RID_DRAW_OBJ_TOOLBOX;
//STRIP001 
//STRIP001 	if (pView->GetContext() == SDRCONTEXT_POINTEDIT)
//STRIP001 	{
//STRIP001 		nObjBarId = RID_BEZIER_TOOLBOX;
//STRIP001 	}
//STRIP001 
//STRIP001 	pViewShell->SwitchObjectBar(nObjBarId);
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Aktuellen Bezier-Editmodus setzen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuConstBezPoly::SetEditMode(USHORT nMode)
//STRIP001 {
//STRIP001 	nEditMode = nMode;
//STRIP001 	ForcePointer();
//STRIP001 
//STRIP001 	SfxBindings& rBindings = pViewShell->GetViewFrame()->GetBindings();
//STRIP001 	rBindings.Invalidate(SID_BEZIER_MOVE);
//STRIP001 	rBindings.Invalidate(SID_BEZIER_INSERT);
//STRIP001 }
//STRIP001 
//STRIP001 // #97016#
//STRIP001 SdrObject* FuConstBezPoly::CreateDefaultObject(const sal_uInt16 nID, const Rectangle& rRectangle)
//STRIP001 {
//STRIP001 	// case SID_DRAW_POLYGON:
//STRIP001 	// case SID_DRAW_POLYGON_NOFILL:
//STRIP001 	// case SID_DRAW_XPOLYGON:
//STRIP001 	// case SID_DRAW_XPOLYGON_NOFILL:
//STRIP001 	// case SID_DRAW_FREELINE:
//STRIP001 	// case SID_DRAW_FREELINE_NOFILL:
//STRIP001 	// case SID_DRAW_BEZIER_FILL:          // BASIC
//STRIP001 	// case SID_DRAW_BEZIER_NOFILL:        // BASIC
//STRIP001 
//STRIP001 	SdrObject* pObj = SdrObjFactory::MakeNewObject(
//STRIP001 		pView->GetCurrentObjInventor(), pView->GetCurrentObjIdentifier(),
//STRIP001 		0L, pDoc);
//STRIP001 
//STRIP001 	if(pObj)
//STRIP001 	{
//STRIP001 		if(pObj->ISA(SdrPathObj))
//STRIP001 		{
//STRIP001 			XPolyPolygon aPoly;
//STRIP001 
//STRIP001 			switch(nID)
//STRIP001 			{
//STRIP001 				case SID_DRAW_BEZIER_FILL:
//STRIP001 				{
//STRIP001 					sal_Int32 nWdt(rRectangle.GetWidth() / 2);
//STRIP001 					sal_Int32 nHgt(rRectangle.GetHeight() / 2);
//STRIP001 					
//STRIP001 					XPolygon aInnerPoly(rRectangle.Center(), nWdt, nHgt);
//STRIP001 
//STRIP001 					aPoly.Insert(aInnerPoly);
//STRIP001 					break;
//STRIP001 				}
//STRIP001 				case SID_DRAW_BEZIER_NOFILL:
//STRIP001 				{
//STRIP001 					XPolygon aInnerPoly;
//STRIP001 					aInnerPoly[0] = rRectangle.BottomLeft();
//STRIP001 					aInnerPoly[1] = rRectangle.BottomCenter();
//STRIP001 					aInnerPoly[2] = rRectangle.BottomCenter();
//STRIP001 					aInnerPoly[3] = rRectangle.Center();
//STRIP001 					aInnerPoly[4] = rRectangle.TopCenter();
//STRIP001 					aInnerPoly[5] = rRectangle.TopCenter();
//STRIP001 					aInnerPoly[6] = rRectangle.TopRight();
//STRIP001 					
//STRIP001 					aInnerPoly.SetFlags(1, XPOLY_CONTROL);
//STRIP001 					aInnerPoly.SetFlags(2, XPOLY_CONTROL);
//STRIP001 					aInnerPoly.SetFlags(3, XPOLY_SYMMTR);
//STRIP001 					aInnerPoly.SetFlags(4, XPOLY_CONTROL);
//STRIP001 					aInnerPoly.SetFlags(5, XPOLY_CONTROL);
//STRIP001 
//STRIP001 					aPoly.Insert(aInnerPoly);
//STRIP001 					break;
//STRIP001 				}
//STRIP001 				case SID_DRAW_FREELINE:
//STRIP001 				case SID_DRAW_FREELINE_NOFILL:
//STRIP001 				{
//STRIP001 					XPolygon aInnerPoly;
//STRIP001 					aInnerPoly[0] = rRectangle.BottomLeft();
//STRIP001 					aInnerPoly[1] = rRectangle.TopLeft();
//STRIP001 					aInnerPoly[2] = rRectangle.TopCenter();
//STRIP001 					aInnerPoly[3] = rRectangle.Center();
//STRIP001 					aInnerPoly[4] = rRectangle.BottomCenter();
//STRIP001 					aInnerPoly[5] = rRectangle.BottomRight();
//STRIP001 					aInnerPoly[6] = rRectangle.TopRight();
//STRIP001 					
//STRIP001 					aInnerPoly.SetFlags(1, XPOLY_CONTROL);
//STRIP001 					aInnerPoly.SetFlags(2, XPOLY_CONTROL);
//STRIP001 					aInnerPoly.SetFlags(3, XPOLY_SMOOTH);
//STRIP001 					aInnerPoly.SetFlags(4, XPOLY_CONTROL);
//STRIP001 					aInnerPoly.SetFlags(5, XPOLY_CONTROL);
//STRIP001 
//STRIP001 					if(SID_DRAW_FREELINE == nID)
//STRIP001 					{
//STRIP001 						aInnerPoly[7] = rRectangle.BottomRight();
//STRIP001 					}
//STRIP001 					
//STRIP001 					aPoly.Insert(aInnerPoly);
//STRIP001 					break;
//STRIP001 				}
//STRIP001 				case SID_DRAW_XPOLYGON:
//STRIP001 				case SID_DRAW_XPOLYGON_NOFILL:
//STRIP001 				{
//STRIP001 					XPolygon aInnerPoly;
//STRIP001 					aInnerPoly[0] = rRectangle.BottomLeft();
//STRIP001 					aInnerPoly[1] = rRectangle.TopLeft();
//STRIP001 					aInnerPoly[2] = rRectangle.TopCenter();
//STRIP001 					aInnerPoly[3] = rRectangle.Center();
//STRIP001 					aInnerPoly[4] = rRectangle.RightCenter();
//STRIP001 					aInnerPoly[5] = rRectangle.BottomRight();
//STRIP001 					
//STRIP001 					if(SID_DRAW_XPOLYGON_NOFILL == nID)
//STRIP001 					{
//STRIP001 						aInnerPoly[6] = rRectangle.BottomCenter();
//STRIP001 					}
//STRIP001 
//STRIP001 					aPoly.Insert(aInnerPoly);
//STRIP001 					break;
//STRIP001 				}
//STRIP001 				case SID_DRAW_POLYGON:
//STRIP001 				case SID_DRAW_POLYGON_NOFILL:
//STRIP001 				{
//STRIP001 					XPolygon aInnerPoly;
//STRIP001 					sal_Int32 nWdt(rRectangle.GetWidth());
//STRIP001 					sal_Int32 nHgt(rRectangle.GetHeight());
//STRIP001 					
//STRIP001 					aInnerPoly[0] = rRectangle.BottomLeft();
//STRIP001 					aInnerPoly[1] = rRectangle.TopLeft() + Point((nWdt * 30) / 100, (nHgt * 70) / 100);
//STRIP001 					aInnerPoly[2] = rRectangle.TopLeft() + Point(0, (nHgt * 15) / 100);
//STRIP001 					aInnerPoly[3] = rRectangle.TopLeft() + Point((nWdt * 65) / 100, 0);
//STRIP001 					aInnerPoly[4] = rRectangle.TopLeft() + Point(nWdt, (nHgt * 30) / 100);
//STRIP001 					aInnerPoly[5] = rRectangle.TopLeft() + Point((nWdt * 80) / 100, (nHgt * 50) / 100);
//STRIP001 					aInnerPoly[6] = rRectangle.TopLeft() + Point((nWdt * 80) / 100, (nHgt * 75) / 100);
//STRIP001 					aInnerPoly[7] = rRectangle.BottomRight();
//STRIP001 					
//STRIP001 					if(SID_DRAW_POLYGON_NOFILL == nID)
//STRIP001 					{
//STRIP001 						aInnerPoly[8] = rRectangle.BottomCenter();
//STRIP001 					}
//STRIP001 
//STRIP001 					aPoly.Insert(aInnerPoly);
//STRIP001 					break;
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			((SdrPathObj*)pObj)->SetPathPoly(aPoly);
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			DBG_ERROR("Object is NO path object");
//STRIP001 		}
//STRIP001 
//STRIP001 		pObj->SetLogicRect(rRectangle);
//STRIP001 	}
//STRIP001 
//STRIP001 	return pObj;
//STRIP001 }

}
