/*************************************************************************
 *
 *  $RCSfile: sd_fuconrec.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:47:14 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _SVDPAGV_HXX //autogen
// auto strip #include <bf_svx/svdpagv.hxx>
// auto strip #endif

#pragma hdrstop

#include <bf_svx/svxids.hrc>
#include <bf_svx/dialogs.hrc>
// auto strip #include <bf_svx/dialmgr.hxx>

#include "app.hrc"
// auto strip #ifndef _AEITEM_HXX //autogen
// auto strip #include <svtools/aeitem.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_XLNSTWIT_HXX //autogen
// auto strip #include <bf_svx/xlnstwit.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XLNEDWIT_HXX //autogen
// auto strip #include <bf_svx/xlnedwit.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XLNEDIT_HXX //autogen
// auto strip #include <bf_svx/xlnedit.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XLNSTIT_HXX //autogen
// auto strip #include <bf_svx/xlnstit.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XLNWTIT_HXX //autogen
// auto strip #include <bf_svx/xlnwtit.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif

#ifndef _XDEF_HXX
#include <bf_svx/xdef.hxx>
#endif

// auto strip #ifndef _SDTMFITM_HXX //autogen
// auto strip #include <bf_svx/sdtmfitm.hxx>
// auto strip #endif
// auto strip #ifndef _SXEKITM_HXX //autogen
// auto strip #include <bf_svx/sxekitm.hxx>
// auto strip #endif
// auto strip #ifndef _SDERITM_HXX //autogen
// auto strip #include <bf_svx/sderitm.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOPATH_HXX //autogen
// auto strip #include <bf_svx/svdopath.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOCIRC_HXX //autogen
// auto strip #include <bf_svx/svdocirc.hxx>
// auto strip #endif
// auto strip #ifndef _SFXINTITEM_HXX //autogen
// auto strip #include <svtools/intitem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
#ifndef _EEITEMID_HXX
#include <bf_svx/eeitemid.hxx>
#endif
// auto strip #ifndef _SVX_ADJITEM_HXX
// auto strip #include <bf_svx/adjitem.hxx>
// auto strip #endif
// auto strip #ifndef _XTABLE_HXX 
// auto strip #include <bf_svx/xtable.hxx>
// auto strip #endif

// #88751#
// auto strip #ifndef _SVDCAPT_HXX
// auto strip #include <bf_svx/svdocapt.hxx>
// auto strip #endif

// #97016#
// auto strip #ifndef _SVDOMEAS_HXX
// auto strip #include <bf_svx/svdomeas.hxx>
// auto strip #endif

// auto strip #include "viewshel.hxx"
// auto strip #include "sdresid.hxx"
// auto strip #include "sdview.hxx"
// auto strip #include "sdpage.hxx"
#include "sdwindow.hxx"
// auto strip #include "stlpool.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "fuconrec.hxx"
#include "res_bmp.hrc"
#include "glob.hrc"
namespace binfilter {

//STRIP001 TYPEINIT1( FuConstRectangle, FuConstruct );
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuConstRectangle::FuConstRectangle(SdViewShell* 	pViewSh,
//STRIP001 								   SdWindow*		pWin,
//STRIP001 								   SdView*			pView,
//STRIP001 								   SdDrawDocument*	pDoc,
//STRIP001 								   SfxRequest&		rReq) :
//STRIP001 	  FuConstruct(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	pViewShell->SwitchObjectBar(RID_DRAW_OBJ_TOOLBOX);
//STRIP001 
//STRIP001 	const SfxItemSet *pArgs = rReq.GetArgs ();
//STRIP001 
//STRIP001 	if (pArgs)
//STRIP001 	{
//STRIP001 		switch (nSlotId)
//STRIP001 		{
//STRIP001 			case SID_DRAW_ELLIPSE :
//STRIP001 			{
//STRIP001 				SFX_REQUEST_ARG (rReq, pCenterX, SfxUInt32Item, ID_VAL_CENTER_X, FALSE);
//STRIP001 				SFX_REQUEST_ARG (rReq, pCenterY, SfxUInt32Item, ID_VAL_CENTER_Y, FALSE);
//STRIP001 				SFX_REQUEST_ARG (rReq, pAxisX, SfxUInt32Item, ID_VAL_AXIS_X, FALSE);
//STRIP001 				SFX_REQUEST_ARG (rReq, pAxisY, SfxUInt32Item, ID_VAL_AXIS_Y, FALSE);
//STRIP001 
//STRIP001 				Rectangle	aNewRectangle (pCenterX->GetValue () - pAxisX->GetValue () / 2,
//STRIP001 										   pCenterY->GetValue () - pAxisY->GetValue () / 2,
//STRIP001 										   pCenterX->GetValue () + pAxisX->GetValue () / 2,
//STRIP001 										   pCenterY->GetValue () + pAxisY->GetValue () / 2);
//STRIP001 				SdrCircObj	*pNewCircle = new SdrCircObj (OBJ_CIRC, aNewRectangle);
//STRIP001 				SdrPageView *pPV = pView->GetPageViewPvNum(0);
//STRIP001 
//STRIP001 				pView->InsertObject (pNewCircle, *pPV, SDRINSERT_SETDEFLAYER |
//STRIP001 													   SDRINSERT_SETDEFATTR);
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_DRAW_RECT :
//STRIP001 			{
//STRIP001 				SFX_REQUEST_ARG (rReq, pMouseStartX, SfxUInt32Item, ID_VAL_MOUSESTART_X, FALSE);
//STRIP001 				SFX_REQUEST_ARG (rReq, pMouseStartY, SfxUInt32Item, ID_VAL_MOUSESTART_Y, FALSE);
//STRIP001 				SFX_REQUEST_ARG (rReq, pMouseEndX, SfxUInt32Item, ID_VAL_MOUSEEND_X, FALSE);
//STRIP001 				SFX_REQUEST_ARG (rReq, pMouseEndY, SfxUInt32Item, ID_VAL_MOUSEEND_Y, FALSE);
//STRIP001 
//STRIP001 				Rectangle	aNewRectangle (pMouseStartX->GetValue (),
//STRIP001 										   pMouseStartY->GetValue (),
//STRIP001 										   pMouseEndX->GetValue (),
//STRIP001 										   pMouseEndY->GetValue ());
//STRIP001 				SdrRectObj	*pNewRect = new SdrRectObj (aNewRectangle);
//STRIP001 				SdrPageView *pPV = pView->GetPageViewPvNum (0);
//STRIP001 
//STRIP001 				pView->InsertObject (pNewRect, *pPV, SDRINSERT_SETDEFLAYER |
//STRIP001 													 SDRINSERT_SETDEFATTR);
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if (nSlotId == SID_TOOL_CONNECTOR               ||
//STRIP001 		nSlotId == SID_CONNECTOR_ARROW_START        ||
//STRIP001 		nSlotId == SID_CONNECTOR_ARROW_END          ||
//STRIP001 		nSlotId == SID_CONNECTOR_ARROWS             ||
//STRIP001 		nSlotId == SID_CONNECTOR_CIRCLE_START       ||
//STRIP001 		nSlotId == SID_CONNECTOR_CIRCLE_END         ||
//STRIP001 		nSlotId == SID_CONNECTOR_CIRCLES            ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINE               ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINE_ARROW_START   ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINE_ARROW_END     ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINE_ARROWS        ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINE_CIRCLE_START  ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINE_CIRCLE_END    ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINE_CIRCLES       ||
//STRIP001 		nSlotId == SID_CONNECTOR_CURVE              ||
//STRIP001 		nSlotId == SID_CONNECTOR_CURVE_ARROW_START  ||
//STRIP001 		nSlotId == SID_CONNECTOR_CURVE_ARROW_END    ||
//STRIP001 		nSlotId == SID_CONNECTOR_CURVE_ARROWS       ||
//STRIP001 		nSlotId == SID_CONNECTOR_CURVE_CIRCLE_START ||
//STRIP001 		nSlotId == SID_CONNECTOR_CURVE_CIRCLE_END   ||
//STRIP001 		nSlotId == SID_CONNECTOR_CURVE_CIRCLES      ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINES              ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINES_ARROW_START  ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINES_ARROW_END    ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINES_ARROWS       ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINES_CIRCLE_START ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINES_CIRCLE_END   ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINES_CIRCLES		||
//STRIP001 		nSlotId == SID_LINE_ARROW_START				||
//STRIP001 		nSlotId == SID_LINE_ARROW_END				||
//STRIP001 		nSlotId == SID_LINE_ARROWS					||
//STRIP001 		nSlotId == SID_LINE_ARROW_CIRCLE			||
//STRIP001 		nSlotId == SID_LINE_CIRCLE_ARROW			||
//STRIP001 		nSlotId == SID_LINE_ARROW_SQUARE			||
//STRIP001 		nSlotId == SID_LINE_SQUARE_ARROW )
//STRIP001 	{
//STRIP001 		pView->UnmarkAll();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuConstRectangle::~FuConstRectangle()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonDown-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuConstRectangle::MouseButtonDown(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FuConstruct::MouseButtonDown(rMEvt);
//STRIP001 
//STRIP001 	if ( rMEvt.IsLeft() && !pView->IsAction() )
//STRIP001 	{
//STRIP001 		Point aPnt( pWindow->PixelToLogic( rMEvt.GetPosPixel() ) );
//STRIP001 
//STRIP001 		pWindow->CaptureMouse();
//STRIP001 		USHORT nDrgLog = USHORT ( pWindow->PixelToLogic(Size(DRGPIX,0)).Width() );
//STRIP001 
//STRIP001 		if (pView->GetCurrentObjIdentifier() == OBJ_CAPTION)
//STRIP001 		{
//STRIP001 			Size aCaptionSize(846, 846);    // (4x2)cm
//STRIP001 			bReturn = pView->BegCreateCaptionObj(aPnt, aCaptionSize,
//STRIP001 												 (OutputDevice*) NULL, nDrgLog);
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			pView->BegCreateObj(aPnt, (OutputDevice*) NULL, nDrgLog);
//STRIP001 		}
//STRIP001 
//STRIP001 		SdrObject* pObj = pView->GetCreateObj();
//STRIP001 
//STRIP001 		if (pObj)
//STRIP001 		{
//STRIP001 			SfxItemSet aAttr(pDoc->GetPool());
//STRIP001 			SetStyleSheet(aAttr, pObj);
//STRIP001 			SetAttributes(aAttr, pObj);
//STRIP001 			SetLineEnds(aAttr, pObj);
//STRIP001 
//STRIP001 //-/			pObj->NbcSetAttributes(aAttr, FALSE);
//STRIP001 			pObj->SetItemSet(aAttr);
//STRIP001 
//STRIP001 			if( nSlotId == SID_DRAW_CAPTION_VERTICAL )
//STRIP001 				( (SdrTextObj*) pObj)->SetVerticalWriting( TRUE );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseMove-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuConstRectangle::MouseMove(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	return FuConstruct::MouseMove(rMEvt);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonUp-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuConstRectangle::MouseButtonUp(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 
//STRIP001 	if ( pView->IsCreateObj() && rMEvt.IsLeft() )
//STRIP001 	{
//STRIP001 		SdrObject* pObj = pView->GetCreateObj();
//STRIP001 
//STRIP001 		if (pView->EndCreateObj(SDRCREATE_FORCEEND) &&
//STRIP001 			pObj && nSlotId == SID_DRAW_MEASURELINE)
//STRIP001 		{
//STRIP001 			SdrLayerAdmin& rAdmin = pDoc->GetLayerAdmin();
//STRIP001 			String aStr(SdResId(STR_LAYER_MEASURELINES));
//STRIP001 			pObj->SetLayer(rAdmin.GetLayerID(aStr, FALSE));
//STRIP001 		}
//STRIP001 
//STRIP001 		// #92557# re-get the object pointer, the object may be deleted
//STRIP001 		// in the meantime
//STRIP001 		pObj = pView->GetCreateObj();
//STRIP001 
//STRIP001 		// #88751# init text position when vertica caption object is created
//STRIP001 		if(pObj && pObj->ISA(SdrCaptionObj) && nSlotId == SID_DRAW_CAPTION_VERTICAL)
//STRIP001 		{
//STRIP001 			// draw text object, needs to be initialized when vertical text is used
//STRIP001 			SfxItemSet aSet(pObj->GetItemSet());
//STRIP001 
//STRIP001 			aSet.Put(SdrTextVertAdjustItem(SDRTEXTVERTADJUST_CENTER));
//STRIP001 			aSet.Put(SdrTextHorzAdjustItem(SDRTEXTHORZADJUST_RIGHT));
//STRIP001 
//STRIP001 			pObj->SetItemSet(aSet);
//STRIP001 		}
//STRIP001 
//STRIP001 		bReturn = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	bReturn = FuConstruct::MouseButtonUp (rMEvt) || bReturn;
//STRIP001 
//STRIP001 	if (!bPermanent)
//STRIP001 		pViewShell->GetViewFrame()->GetDispatcher()->Execute(SID_OBJECT_SELECT, SFX_CALLMODE_ASYNCHRON);
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Tastaturereignisse bearbeiten
//STRIP001 |*
//STRIP001 |* Wird ein KeyEvent bearbeitet, so ist der Return-Wert TRUE, andernfalls
//STRIP001 |* FALSE.
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuConstRectangle::KeyInput(const KeyEvent& rKEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FuConstruct::KeyInput(rKEvt);
//STRIP001 	return(bReturn);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function aktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuConstRectangle::Activate()
//STRIP001 {
//STRIP001 	SdrObjKind aObjKind;
//STRIP001 
//STRIP001 	switch (nSlotId)
//STRIP001 	{
//STRIP001 		case SID_LINE_ARROW_START:
//STRIP001 		case SID_LINE_ARROW_END:
//STRIP001 		case SID_LINE_ARROWS:
//STRIP001 		case SID_LINE_ARROW_CIRCLE:
//STRIP001 		case SID_LINE_CIRCLE_ARROW:
//STRIP001 		case SID_LINE_ARROW_SQUARE:
//STRIP001 		case SID_LINE_SQUARE_ARROW:
//STRIP001 			pView->SetGlueVisible();
//STRIP001 			// keine break !
//STRIP001 		case SID_DRAW_LINE :
//STRIP001 		case SID_DRAW_XLINE:
//STRIP001 			aObjKind = OBJ_LINE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_DRAW_MEASURELINE:
//STRIP001 		{
//STRIP001 			aObjKind = OBJ_MEASURE;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAW_RECT             :
//STRIP001 		case SID_DRAW_RECT_NOFILL	   :
//STRIP001 		case SID_DRAW_RECT_ROUND	   :
//STRIP001 		case SID_DRAW_RECT_ROUND_NOFILL:
//STRIP001 		case SID_DRAW_SQUARE		   :
//STRIP001 		case SID_DRAW_SQUARE_NOFILL    :
//STRIP001 		case SID_DRAW_SQUARE_ROUND	   :
//STRIP001 		case SID_DRAW_SQUARE_ROUND_NOFILL:
//STRIP001 		{
//STRIP001 			aObjKind = OBJ_RECT;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAW_ELLIPSE		:
//STRIP001 		case SID_DRAW_ELLIPSE_NOFILL:
//STRIP001 		case SID_DRAW_CIRCLE		:
//STRIP001 		case SID_DRAW_CIRCLE_NOFILL :
//STRIP001 		{
//STRIP001 			aObjKind = OBJ_CIRC;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAW_CAPTION:
//STRIP001 		case SID_DRAW_CAPTION_VERTICAL:
//STRIP001 		{
//STRIP001 			aObjKind = OBJ_CAPTION;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_TOOL_CONNECTOR:
//STRIP001 		case SID_CONNECTOR_ARROW_START:
//STRIP001 		case SID_CONNECTOR_ARROW_END:
//STRIP001 		case SID_CONNECTOR_ARROWS:
//STRIP001 		case SID_CONNECTOR_CIRCLE_START:
//STRIP001 		case SID_CONNECTOR_CIRCLE_END:
//STRIP001 		case SID_CONNECTOR_CIRCLES:
//STRIP001 		case SID_CONNECTOR_LINE:
//STRIP001 		case SID_CONNECTOR_LINE_ARROW_START:
//STRIP001 		case SID_CONNECTOR_LINE_ARROW_END:
//STRIP001 		case SID_CONNECTOR_LINE_ARROWS:
//STRIP001 		case SID_CONNECTOR_LINE_CIRCLE_START:
//STRIP001 		case SID_CONNECTOR_LINE_CIRCLE_END:
//STRIP001 		case SID_CONNECTOR_LINE_CIRCLES:
//STRIP001 		case SID_CONNECTOR_CURVE:
//STRIP001 		case SID_CONNECTOR_CURVE_ARROW_START:
//STRIP001 		case SID_CONNECTOR_CURVE_ARROW_END:
//STRIP001 		case SID_CONNECTOR_CURVE_ARROWS:
//STRIP001 		case SID_CONNECTOR_CURVE_CIRCLE_START:
//STRIP001 		case SID_CONNECTOR_CURVE_CIRCLE_END:
//STRIP001 		case SID_CONNECTOR_CURVE_CIRCLES:
//STRIP001 		case SID_CONNECTOR_LINES:
//STRIP001 		case SID_CONNECTOR_LINES_ARROW_START:
//STRIP001 		case SID_CONNECTOR_LINES_ARROW_END:
//STRIP001 		case SID_CONNECTOR_LINES_ARROWS:
//STRIP001 		case SID_CONNECTOR_LINES_CIRCLE_START:
//STRIP001 		case SID_CONNECTOR_LINES_CIRCLE_END:
//STRIP001 		case SID_CONNECTOR_LINES_CIRCLES:
//STRIP001 		{
//STRIP001 			aObjKind = OBJ_EDGE;
//STRIP001 			pView->SetGlueVisible();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		default:
//STRIP001 		{
//STRIP001 			aObjKind = OBJ_RECT;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 	pView->SetCurrentObj(aObjKind);
//STRIP001 
//STRIP001 	FuConstruct::Activate();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function deaktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuConstRectangle::Deactivate()
//STRIP001 {
//STRIP001 	if( nSlotId == SID_TOOL_CONNECTOR               ||
//STRIP001 		nSlotId == SID_CONNECTOR_ARROW_START        ||
//STRIP001 		nSlotId == SID_CONNECTOR_ARROW_END          ||
//STRIP001 		nSlotId == SID_CONNECTOR_ARROWS             ||
//STRIP001 		nSlotId == SID_CONNECTOR_CIRCLE_START       ||
//STRIP001 		nSlotId == SID_CONNECTOR_CIRCLE_END         ||
//STRIP001 		nSlotId == SID_CONNECTOR_CIRCLES            ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINE               ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINE_ARROW_START   ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINE_ARROW_END     ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINE_ARROWS        ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINE_CIRCLE_START  ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINE_CIRCLE_END    ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINE_CIRCLES       ||
//STRIP001 		nSlotId == SID_CONNECTOR_CURVE              ||
//STRIP001 		nSlotId == SID_CONNECTOR_CURVE_ARROW_START  ||
//STRIP001 		nSlotId == SID_CONNECTOR_CURVE_ARROW_END    ||
//STRIP001 		nSlotId == SID_CONNECTOR_CURVE_ARROWS       ||
//STRIP001 		nSlotId == SID_CONNECTOR_CURVE_CIRCLE_START ||
//STRIP001 		nSlotId == SID_CONNECTOR_CURVE_CIRCLE_END   ||
//STRIP001 		nSlotId == SID_CONNECTOR_CURVE_CIRCLES      ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINES              ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINES_ARROW_START  ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINES_ARROW_END    ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINES_ARROWS       ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINES_CIRCLE_START ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINES_CIRCLE_END   ||
//STRIP001 		nSlotId == SID_CONNECTOR_LINES_CIRCLES		||
//STRIP001 		nSlotId == SID_LINE_ARROW_START				||
//STRIP001 		nSlotId == SID_LINE_ARROW_END				||
//STRIP001 		nSlotId == SID_LINE_ARROWS					||
//STRIP001 		nSlotId == SID_LINE_ARROW_CIRCLE			||
//STRIP001 		nSlotId == SID_LINE_CIRCLE_ARROW			||
//STRIP001 		nSlotId == SID_LINE_ARROW_SQUARE			||
//STRIP001 		nSlotId == SID_LINE_SQUARE_ARROW )
//STRIP001 	{
//STRIP001 		pView->SetGlueVisible( FALSE );
//STRIP001 	}
//STRIP001 	FuConstruct::Deactivate();
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Attribute fuer das zu erzeugende Objekt setzen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuConstRectangle::SetAttributes(SfxItemSet& rAttr, SdrObject* pObj)
//STRIP001 {
//STRIP001 	if (nSlotId == SID_DRAW_RECT_ROUND        ||
//STRIP001 		nSlotId == SID_DRAW_RECT_ROUND_NOFILL ||
//STRIP001 		nSlotId == SID_DRAW_SQUARE_ROUND      ||
//STRIP001 		nSlotId == SID_DRAW_SQUARE_ROUND_NOFILL)
//STRIP001 	{
//STRIP001 		/**********************************************************************
//STRIP001 		* Abgerundete Ecken
//STRIP001 		**********************************************************************/
//STRIP001 		rAttr.Put(SdrEckenradiusItem(500));
//STRIP001 	}
//STRIP001 	else if (nSlotId == SID_CONNECTOR_LINE              ||
//STRIP001 			 nSlotId == SID_CONNECTOR_LINE_ARROW_START  ||
//STRIP001 			 nSlotId == SID_CONNECTOR_LINE_ARROW_END    ||
//STRIP001 			 nSlotId == SID_CONNECTOR_LINE_ARROWS       ||
//STRIP001 			 nSlotId == SID_CONNECTOR_LINE_CIRCLE_START ||
//STRIP001 			 nSlotId == SID_CONNECTOR_LINE_CIRCLE_END   ||
//STRIP001 			 nSlotId == SID_CONNECTOR_LINE_CIRCLES)
//STRIP001 	{
//STRIP001 		/**********************************************************************
//STRIP001 		* Direkt-Verbinder
//STRIP001 		**********************************************************************/
//STRIP001 		rAttr.Put(SdrEdgeKindItem(SDREDGE_ONELINE));
//STRIP001 	}
//STRIP001 	else if (nSlotId == SID_CONNECTOR_LINES              ||
//STRIP001 			 nSlotId == SID_CONNECTOR_LINES_ARROW_START  ||
//STRIP001 			 nSlotId == SID_CONNECTOR_LINES_ARROW_END    ||
//STRIP001 			 nSlotId == SID_CONNECTOR_LINES_ARROWS       ||
//STRIP001 			 nSlotId == SID_CONNECTOR_LINES_CIRCLE_START ||
//STRIP001 			 nSlotId == SID_CONNECTOR_LINES_CIRCLE_END   ||
//STRIP001 			 nSlotId == SID_CONNECTOR_LINES_CIRCLES)
//STRIP001 	{
//STRIP001 		/**********************************************************************
//STRIP001 		* Linien-Verbinder
//STRIP001 		**********************************************************************/
//STRIP001 		rAttr.Put(SdrEdgeKindItem(SDREDGE_THREELINES));
//STRIP001 	}
//STRIP001 	else if (nSlotId == SID_CONNECTOR_CURVE              ||
//STRIP001 			 nSlotId == SID_CONNECTOR_CURVE_ARROW_START  ||
//STRIP001 			 nSlotId == SID_CONNECTOR_CURVE_ARROW_END    ||
//STRIP001 			 nSlotId == SID_CONNECTOR_CURVE_ARROWS       ||
//STRIP001 			 nSlotId == SID_CONNECTOR_CURVE_CIRCLE_START ||
//STRIP001 			 nSlotId == SID_CONNECTOR_CURVE_CIRCLE_END   ||
//STRIP001 			 nSlotId == SID_CONNECTOR_CURVE_CIRCLES)
//STRIP001 	{
//STRIP001 		/**********************************************************************
//STRIP001 		* Kurven-Verbinder
//STRIP001 		**********************************************************************/
//STRIP001 		rAttr.Put(SdrEdgeKindItem(SDREDGE_BEZIER));
//STRIP001 	}
//STRIP001 	else if ( nSlotId == SID_DRAW_CAPTION || nSlotId == SID_DRAW_CAPTION_VERTICAL )
//STRIP001 	{
//STRIP001 		/**********************************************************************
//STRIP001 		* Legendenobjekt
//STRIP001 		**********************************************************************/
//STRIP001 		Size aSize(pObj->GetLogicRect().GetSize());
//STRIP001 		rAttr.Put( SdrTextMinFrameHeightItem( aSize.Height() ) );
//STRIP001 		rAttr.Put( SdrTextMinFrameWidthItem( aSize.Width() ) );
//STRIP001 		rAttr.Put( SdrTextAutoGrowHeightItem( TRUE ) );
//STRIP001 		rAttr.Put( SdrTextAutoGrowWidthItem( TRUE ) );
//STRIP001 
//STRIP001 		// #103516# Support full with for vertical caption objects, too
//STRIP001 		if(SID_DRAW_CAPTION == nSlotId)
//STRIP001 			rAttr.Put( SdrTextHorzAdjustItem( SDRTEXTHORZADJUST_BLOCK ) );
//STRIP001 		else
//STRIP001 			rAttr.Put( SdrTextVertAdjustItem( SDRTEXTVERTADJUST_BLOCK ) );
//STRIP001 
//STRIP001 		rAttr.Put( SvxAdjustItem( SVX_ADJUST_CENTER ) );
//STRIP001 		rAttr.Put( SdrTextLeftDistItem( 100 ) );
//STRIP001 		rAttr.Put( SdrTextRightDistItem( 100 ) );
//STRIP001 		rAttr.Put( SdrTextUpperDistItem( 100 ) );
//STRIP001 		rAttr.Put( SdrTextLowerDistItem( 100 ) );
//STRIP001 	}
//STRIP001 	else if (nSlotId == SID_DRAW_MEASURELINE)
//STRIP001 	{
//STRIP001 		/**********************************************************************
//STRIP001 		* Masslinie
//STRIP001 		**********************************************************************/
//STRIP001 		SdPage* pPage = (SdPage*) pView->GetPageViewPvNum(0)->GetPage();
//STRIP001 		String aName(SdResId(STR_POOLSHEET_MEASURE));
//STRIP001 		SfxStyleSheet* pSheet = (SfxStyleSheet*) pPage->GetModel()->
//STRIP001 									 GetStyleSheetPool()->
//STRIP001 									 Find(aName, SFX_STYLE_FAMILY_PARA);
//STRIP001 		DBG_ASSERT(pSheet, "Objektvorlage nicht gefunden");
//STRIP001 
//STRIP001 		if (pSheet)
//STRIP001 		{
//STRIP001 			pObj->SetStyleSheet(pSheet, FALSE);
//STRIP001 		}
//STRIP001 
//STRIP001 		SdrLayerAdmin& rAdmin = pDoc->GetLayerAdmin();
//STRIP001 		String aStr(SdResId(STR_LAYER_MEASURELINES));
//STRIP001 		pObj->SetLayer(rAdmin.GetLayerID(aStr, FALSE));
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Linienanfaenge und -enden fuer das zu erzeugende Objekt setzen
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 XPolygon getPolygon( sal_uInt16 nResId, SdrModel* pDoc )
//STRIP001 {
//STRIP001 	XPolygon xPolygon;
//STRIP001 
//STRIP001 	XLineEndList* pLineEndList = pDoc->GetLineEndList();
//STRIP001 
//STRIP001 	if( pLineEndList )
//STRIP001 	{
//STRIP001 		String aArrowName( SVX_RES(nResId) );
//STRIP001 		long nCount = pLineEndList->Count();
//STRIP001 		long nIndex;
//STRIP001 		for( nIndex = 0; nIndex < nCount; nIndex++ )
//STRIP001 		{
//STRIP001 			XLineEndEntry* pEntry = pLineEndList->Get(nIndex);
//STRIP001 			if( pEntry->GetName() == aArrowName )
//STRIP001 			{
//STRIP001 				xPolygon = pEntry->GetLineEnd();
//STRIP001 				break;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return xPolygon;
//STRIP001 
//STRIP001 }
//STRIP001 
//STRIP001 void FuConstRectangle::SetLineEnds(SfxItemSet& rAttr, SdrObject* pObj)
//STRIP001 {
//STRIP001 	if ( (pObj->GetObjIdentifier() == OBJ_EDGE &&
//STRIP001 		  nSlotId != SID_TOOL_CONNECTOR        &&
//STRIP001 		  nSlotId != SID_CONNECTOR_LINE        &&
//STRIP001 		  nSlotId != SID_CONNECTOR_LINES       &&
//STRIP001 		  nSlotId != SID_CONNECTOR_CURVE)      ||
//STRIP001 		  nSlotId == SID_LINE_ARROW_START      ||
//STRIP001 		  nSlotId == SID_LINE_ARROW_END        ||
//STRIP001 		  nSlotId == SID_LINE_ARROWS           ||
//STRIP001 		  nSlotId == SID_LINE_ARROW_CIRCLE     ||
//STRIP001 		  nSlotId == SID_LINE_CIRCLE_ARROW     ||
//STRIP001 		  nSlotId == SID_LINE_ARROW_SQUARE     ||
//STRIP001 		  nSlotId == SID_LINE_SQUARE_ARROW )
//STRIP001 	{
//STRIP001 		/**************************************************************
//STRIP001 		* Linienanfaenge und -enden attributieren
//STRIP001 		**************************************************************/
//STRIP001 
//STRIP001 		// Pfeilspitze
//STRIP001 		XPolygon aArrow( getPolygon( RID_SVXSTR_ARROW, pDoc ) );
//STRIP001 		if( 0 == aArrow.GetSize() )
//STRIP001 		{
//STRIP001 			aArrow.SetSize(4);                            //      []
//STRIP001 			aArrow[0]=Point(10,0);                        // 0,4__[]__2,4
//STRIP001 			aArrow[1]=Point(0,30);                        //    \    /
//STRIP001 			aArrow[2]=Point(20,30);                       //     \  /
//STRIP001 			aArrow[3]=Point(10,0);                        //      \/1,0
//STRIP001 		}
//STRIP001 
//STRIP001 		// Kreis
//STRIP001 		XPolygon aCircle( getPolygon( RID_SVXSTR_CIRCLE, pDoc ) );
//STRIP001 
//STRIP001 		if( 0 == aCircle.GetSize() )
//STRIP001 			aCircle = XPolygon( Point(0,0), 250, 250 );
//STRIP001 
//STRIP001 		// Quadrat
//STRIP001 		XPolygon aSquare( getPolygon( RID_SVXSTR_SQUARE, pDoc ) );
//STRIP001 		if( 0 == aSquare.GetSize() )
//STRIP001 		{
//STRIP001 			aSquare.SetSize(4);
//STRIP001 			aSquare[0].X()= 0; aSquare[0].Y()= 0;
//STRIP001 			aSquare[1].X()=10; aSquare[1].Y()= 0;
//STRIP001 			aSquare[2].X()=10; aSquare[2].Y()=10;
//STRIP001 			aSquare[3].X()= 0; aSquare[3].Y()=10;
//STRIP001 		}
//STRIP001 
//STRIP001 		SfxItemSet aSet( pDoc->GetPool() );
//STRIP001 		pView->GetAttributes( aSet );

		// #i3908# Here, the default Line Start/End width for arrow construction is
		// set. To have the same value in all situations (construction) in i3908
		// it was decided to change the default to 0.03 cm for all situations.
//STRIP001 		long nWidth = 300; // (1/100th mm)

//STRIP001 		// Linienstaerke ermitteln und daraus die Linienendenstaerke berechnen
//STRIP001 		if( aSet.GetItemState( XATTR_LINEWIDTH ) != SFX_ITEM_DONTCARE )
//STRIP001 		{
//STRIP001 			long nValue = ( ( const XLineWidthItem& ) aSet.Get( XATTR_LINEWIDTH ) ).GetValue();
//STRIP001 			if( nValue > 0 )
//STRIP001 				nWidth = nValue * 3;
//STRIP001 		}
//STRIP001 
//STRIP001 		switch (nSlotId)
//STRIP001 		{
//STRIP001 			case SID_CONNECTOR_ARROWS:
//STRIP001 			case SID_CONNECTOR_LINE_ARROWS:
//STRIP001 			case SID_CONNECTOR_LINES_ARROWS:
//STRIP001 			case SID_CONNECTOR_CURVE_ARROWS:
//STRIP001 			case SID_LINE_ARROWS:
//STRIP001 			{
//STRIP001 				// Verbinder mit Pfeil-Enden
//STRIP001 				rAttr.Put(XLineStartItem(SVX_RESSTR(RID_SVXSTR_ARROW), aArrow));
//STRIP001 				rAttr.Put(XLineStartWidthItem(nWidth));
//STRIP001 				rAttr.Put(XLineEndItem(SVX_RESSTR(RID_SVXSTR_ARROW), aArrow));
//STRIP001 				rAttr.Put(XLineEndWidthItem(nWidth));
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_CONNECTOR_ARROW_START:
//STRIP001 			case SID_CONNECTOR_LINE_ARROW_START:
//STRIP001 			case SID_CONNECTOR_LINES_ARROW_START:
//STRIP001 			case SID_CONNECTOR_CURVE_ARROW_START:
//STRIP001 			case SID_LINE_ARROW_START:
//STRIP001 			case SID_LINE_ARROW_CIRCLE:
//STRIP001 			case SID_LINE_ARROW_SQUARE:
//STRIP001 			{
//STRIP001 				// Verbinder mit Pfeil-Anfang
//STRIP001 				rAttr.Put(XLineStartItem(SVX_RESSTR(RID_SVXSTR_ARROW), aArrow));
//STRIP001 				rAttr.Put(XLineStartWidthItem(nWidth));
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_CONNECTOR_ARROW_END:
//STRIP001 			case SID_CONNECTOR_LINE_ARROW_END:
//STRIP001 			case SID_CONNECTOR_LINES_ARROW_END:
//STRIP001 			case SID_CONNECTOR_CURVE_ARROW_END:
//STRIP001 			case SID_LINE_ARROW_END:
//STRIP001 			case SID_LINE_CIRCLE_ARROW:
//STRIP001 			case SID_LINE_SQUARE_ARROW:
//STRIP001 			{
//STRIP001 				// Verbinder mit Pfeil-Ende
//STRIP001 				rAttr.Put(XLineEndItem(SVX_RESSTR(RID_SVXSTR_ARROW), aArrow));
//STRIP001 				rAttr.Put(XLineEndWidthItem(nWidth));
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_CONNECTOR_CIRCLES:
//STRIP001 			case SID_CONNECTOR_LINE_CIRCLES:
//STRIP001 			case SID_CONNECTOR_LINES_CIRCLES:
//STRIP001 			case SID_CONNECTOR_CURVE_CIRCLES:
//STRIP001 			{
//STRIP001 				// Verbinder mit Kreis-Enden
//STRIP001 				rAttr.Put(XLineStartItem(SVX_RESSTR(RID_SVXSTR_CIRCLE), aCircle));
//STRIP001 				rAttr.Put(XLineStartWidthItem(nWidth));
//STRIP001 				rAttr.Put(XLineEndItem(SVX_RESSTR(RID_SVXSTR_CIRCLE), aCircle));
//STRIP001 				rAttr.Put(XLineEndWidthItem(nWidth));
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_CONNECTOR_CIRCLE_START:
//STRIP001 			case SID_CONNECTOR_LINE_CIRCLE_START:
//STRIP001 			case SID_CONNECTOR_LINES_CIRCLE_START:
//STRIP001 			case SID_CONNECTOR_CURVE_CIRCLE_START:
//STRIP001 			{
//STRIP001 				// Verbinder mit Kreis-Anfang
//STRIP001 				rAttr.Put(XLineStartItem(SVX_RESSTR(RID_SVXSTR_CIRCLE), aCircle));
//STRIP001 				rAttr.Put(XLineStartWidthItem(nWidth));
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_CONNECTOR_CIRCLE_END:
//STRIP001 			case SID_CONNECTOR_LINE_CIRCLE_END:
//STRIP001 			case SID_CONNECTOR_LINES_CIRCLE_END:
//STRIP001 			case SID_CONNECTOR_CURVE_CIRCLE_END:
//STRIP001 			{
//STRIP001 				// Verbinder mit Kreis-Ende
//STRIP001 				rAttr.Put(XLineEndItem(SVX_RESSTR(RID_SVXSTR_CIRCLE), aCircle));
//STRIP001 				rAttr.Put(XLineEndWidthItem(nWidth));
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		};
//STRIP001 
//STRIP001 		// Und nochmal fuer die noch fehlenden Enden
//STRIP001 		switch (nSlotId)
//STRIP001 		{
//STRIP001 			case SID_LINE_ARROW_CIRCLE:
//STRIP001 			{
//STRIP001 				// Kreis-Ende
//STRIP001 				rAttr.Put(XLineEndItem(SVX_RESSTR(RID_SVXSTR_CIRCLE), aCircle));
//STRIP001 				rAttr.Put(XLineEndWidthItem(nWidth));
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_LINE_CIRCLE_ARROW:
//STRIP001 			{
//STRIP001 				// Kreis-Anfang
//STRIP001 				rAttr.Put(XLineStartItem(SVX_RESSTR(RID_SVXSTR_CIRCLE), aCircle));
//STRIP001 				rAttr.Put(XLineStartWidthItem(nWidth));
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_LINE_ARROW_SQUARE:
//STRIP001 			{
//STRIP001 				// Quadrat-Ende
//STRIP001 				rAttr.Put(XLineEndItem(SVX_RESSTR(RID_SVXSTR_SQUARE), aSquare));
//STRIP001 				rAttr.Put(XLineEndWidthItem(nWidth));
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case SID_LINE_SQUARE_ARROW:
//STRIP001 			{
//STRIP001 				// Quadrat-Anfang
//STRIP001 				rAttr.Put(XLineStartItem(SVX_RESSTR(RID_SVXSTR_SQUARE), aSquare));
//STRIP001 				rAttr.Put(XLineStartWidthItem(nWidth));
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 // #97016#
//STRIP001 SdrObject* FuConstRectangle::CreateDefaultObject(const sal_uInt16 nID, const Rectangle& rRectangle)
//STRIP001 {
//STRIP001 	// case SID_DRAW_LINE:
//STRIP001 	// case SID_DRAW_XLINE:
//STRIP001     // case SID_DRAW_MEASURELINE:
//STRIP001 	// case SID_LINE_ARROW_START:
//STRIP001 	// case SID_LINE_ARROW_END:
//STRIP001 	// case SID_LINE_ARROWS:
//STRIP001 	// case SID_LINE_ARROW_CIRCLE:
//STRIP001 	// case SID_LINE_CIRCLE_ARROW:
//STRIP001 	// case SID_LINE_ARROW_SQUARE:
//STRIP001 	// case SID_LINE_SQUARE_ARROW:
//STRIP001 	// case SID_DRAW_RECT:
//STRIP001 	// case SID_DRAW_RECT_NOFILL:
//STRIP001 	// case SID_DRAW_RECT_ROUND:
//STRIP001 	// case SID_DRAW_RECT_ROUND_NOFILL:
//STRIP001 	// case SID_DRAW_SQUARE:
//STRIP001 	// case SID_DRAW_SQUARE_NOFILL:
//STRIP001 	// case SID_DRAW_SQUARE_ROUND:
//STRIP001 	// case SID_DRAW_SQUARE_ROUND_NOFILL:
//STRIP001 	// case SID_DRAW_ELLIPSE:
//STRIP001 	// case SID_DRAW_ELLIPSE_NOFILL:
//STRIP001 	// case SID_DRAW_CIRCLE:
//STRIP001 	// case SID_DRAW_CIRCLE_NOFILL:
//STRIP001 	// case SID_DRAW_CAPTION:
//STRIP001 	// case SID_DRAW_CAPTION_VERTICAL:
//STRIP001 	// case SID_TOOL_CONNECTOR:
//STRIP001     // case SID_CONNECTOR_ARROW_START:
//STRIP001     // case SID_CONNECTOR_ARROW_END:
//STRIP001     // case SID_CONNECTOR_ARROWS:
//STRIP001     // case SID_CONNECTOR_CIRCLE_START:
//STRIP001     // case SID_CONNECTOR_CIRCLE_END:
//STRIP001     // case SID_CONNECTOR_CIRCLES:
//STRIP001     // case SID_CONNECTOR_LINE:
//STRIP001     // case SID_CONNECTOR_LINE_ARROW_START:
//STRIP001     // case SID_CONNECTOR_LINE_ARROW_END:
//STRIP001     // case SID_CONNECTOR_LINE_ARROWS:
//STRIP001     // case SID_CONNECTOR_LINE_CIRCLE_START:
//STRIP001     // case SID_CONNECTOR_LINE_CIRCLE_END:
//STRIP001     // case SID_CONNECTOR_LINE_CIRCLES:
//STRIP001     // case SID_CONNECTOR_CURVE:
//STRIP001     // case SID_CONNECTOR_CURVE_ARROW_START:
//STRIP001     // case SID_CONNECTOR_CURVE_ARROW_END:
//STRIP001     // case SID_CONNECTOR_CURVE_ARROWS:
//STRIP001     // case SID_CONNECTOR_CURVE_CIRCLE_START:
//STRIP001     // case SID_CONNECTOR_CURVE_CIRCLE_END:
//STRIP001     // case SID_CONNECTOR_CURVE_CIRCLES:
//STRIP001     // case SID_CONNECTOR_LINES:
//STRIP001     // case SID_CONNECTOR_LINES_ARROW_START:
//STRIP001     // case SID_CONNECTOR_LINES_ARROW_END:
//STRIP001     // case SID_CONNECTOR_LINES_ARROWS:
//STRIP001     // case SID_CONNECTOR_LINES_CIRCLE_START:
//STRIP001     // case SID_CONNECTOR_LINES_CIRCLE_END:
//STRIP001     // case SID_CONNECTOR_LINES_CIRCLES:
//STRIP001 
//STRIP001 	SdrObject* pObj = SdrObjFactory::MakeNewObject(
//STRIP001 		pView->GetCurrentObjInventor(), pView->GetCurrentObjIdentifier(),
//STRIP001 		0L, pDoc);
//STRIP001 
//STRIP001 	if(pObj)
//STRIP001 	{
//STRIP001 		Rectangle aRect(rRectangle);
//STRIP001 
//STRIP001 		if(SID_DRAW_SQUARE == nID ||
//STRIP001 			SID_DRAW_SQUARE_NOFILL == nID ||
//STRIP001 			SID_DRAW_SQUARE_ROUND == nID ||
//STRIP001 			SID_DRAW_SQUARE_ROUND_NOFILL == nID ||
//STRIP001 			SID_DRAW_CIRCLE == nID ||
//STRIP001 			SID_DRAW_CIRCLE_NOFILL == nID)
//STRIP001 		{
//STRIP001 			// force quadratic
//STRIP001 			ImpForceQuadratic(aRect);
//STRIP001 		}
//STRIP001 
//STRIP001 		Point aStart = aRect.TopLeft();
//STRIP001 		Point aEnd = aRect.BottomRight();
//STRIP001 
//STRIP001 		switch(nID)
//STRIP001 		{
//STRIP001 			case SID_DRAW_LINE:
//STRIP001 			case SID_DRAW_XLINE:
//STRIP001 			case SID_LINE_ARROW_START:
//STRIP001 			case SID_LINE_ARROW_END:
//STRIP001 			case SID_LINE_ARROWS:
//STRIP001 			case SID_LINE_ARROW_CIRCLE:
//STRIP001 			case SID_LINE_CIRCLE_ARROW:
//STRIP001 			case SID_LINE_ARROW_SQUARE:
//STRIP001 			case SID_LINE_SQUARE_ARROW:
//STRIP001 			{
//STRIP001 				if(pObj->ISA(SdrPathObj))
//STRIP001 				{
//STRIP001 					XPolyPolygon aPoly;
//STRIP001 					aPoly.Insert(XPolygon(2));
//STRIP001 					
//STRIP001 					sal_Int32 nYMiddle((aRect.Top() + aRect.Bottom()) / 2);
//STRIP001 					aPoly[0][0] = Point(aStart.X(), nYMiddle);
//STRIP001 					aPoly[0][1] = Point(aEnd.X(), nYMiddle);
//STRIP001 					
//STRIP001 					((SdrPathObj*)pObj)->SetPathPoly(aPoly);
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					DBG_ERROR("Object is NO line object");
//STRIP001 				}
//STRIP001 
//STRIP001 				break;
//STRIP001 			}
//STRIP001 
//STRIP001 			case SID_DRAW_MEASURELINE:
//STRIP001 			{
//STRIP001 				if(pObj->ISA(SdrMeasureObj))
//STRIP001 				{
//STRIP001 					sal_Int32 nYMiddle((aRect.Top() + aRect.Bottom()) / 2);
//STRIP001 					((SdrMeasureObj*)pObj)->SetPoint(Point(aStart.X(), nYMiddle), 0);
//STRIP001 					((SdrMeasureObj*)pObj)->SetPoint(Point(aEnd.X(), nYMiddle), 1);
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					DBG_ERROR("Object is NO measure object");
//STRIP001 				}
//STRIP001 
//STRIP001 				break;
//STRIP001 			}
//STRIP001 
//STRIP001 			case SID_TOOL_CONNECTOR:
//STRIP001 			case SID_CONNECTOR_ARROW_START:
//STRIP001 			case SID_CONNECTOR_ARROW_END:
//STRIP001 			case SID_CONNECTOR_ARROWS:
//STRIP001 			case SID_CONNECTOR_CIRCLE_START:
//STRIP001 			case SID_CONNECTOR_CIRCLE_END:
//STRIP001 			case SID_CONNECTOR_CIRCLES:
//STRIP001 			case SID_CONNECTOR_LINE:
//STRIP001 			case SID_CONNECTOR_LINE_ARROW_START:
//STRIP001 			case SID_CONNECTOR_LINE_ARROW_END:
//STRIP001 			case SID_CONNECTOR_LINE_ARROWS:
//STRIP001 			case SID_CONNECTOR_LINE_CIRCLE_START:
//STRIP001 			case SID_CONNECTOR_LINE_CIRCLE_END:
//STRIP001 			case SID_CONNECTOR_LINE_CIRCLES:
//STRIP001 			case SID_CONNECTOR_CURVE:
//STRIP001 			case SID_CONNECTOR_CURVE_ARROW_START:
//STRIP001 			case SID_CONNECTOR_CURVE_ARROW_END:
//STRIP001 			case SID_CONNECTOR_CURVE_ARROWS:
//STRIP001 			case SID_CONNECTOR_CURVE_CIRCLE_START:
//STRIP001 			case SID_CONNECTOR_CURVE_CIRCLE_END:
//STRIP001 			case SID_CONNECTOR_CURVE_CIRCLES:
//STRIP001 			case SID_CONNECTOR_LINES:
//STRIP001 			case SID_CONNECTOR_LINES_ARROW_START:
//STRIP001 			case SID_CONNECTOR_LINES_ARROW_END:
//STRIP001 			case SID_CONNECTOR_LINES_ARROWS:
//STRIP001 			case SID_CONNECTOR_LINES_CIRCLE_START:
//STRIP001 			case SID_CONNECTOR_LINES_CIRCLE_END:
//STRIP001 			case SID_CONNECTOR_LINES_CIRCLES:
//STRIP001 			{
//STRIP001 				if(pObj->ISA(SdrEdgeObj))
//STRIP001 				{
//STRIP001 					((SdrEdgeObj*)pObj)->SetTailPoint(FALSE, aStart);
//STRIP001 					((SdrEdgeObj*)pObj)->SetTailPoint(TRUE, aEnd);
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					DBG_ERROR("Object is NO connector object");
//STRIP001 				}
//STRIP001 
//STRIP001 				break;
//STRIP001 			}
//STRIP001 			case SID_DRAW_CAPTION:
//STRIP001 			case SID_DRAW_CAPTION_VERTICAL:
//STRIP001 			{
//STRIP001 				if(pObj->ISA(SdrCaptionObj))
//STRIP001 				{
//STRIP001 					sal_Bool bIsVertical(SID_DRAW_CAPTION_VERTICAL == nID);
//STRIP001 
//STRIP001 					((SdrTextObj*)pObj)->SetVerticalWriting(bIsVertical);
//STRIP001 						
//STRIP001 					if(bIsVertical)
//STRIP001 					{
//STRIP001 						SfxItemSet aSet(pObj->GetItemSet());
//STRIP001 						aSet.Put(SdrTextVertAdjustItem(SDRTEXTVERTADJUST_CENTER));
//STRIP001 						aSet.Put(SdrTextHorzAdjustItem(SDRTEXTHORZADJUST_RIGHT));
//STRIP001 						pObj->SetItemSet(aSet);
//STRIP001 					}
//STRIP001 
                    // For task #105815# the default text is not inserted anymore.
                    //	String aText(SdResId(STR_POOLSHEET_TEXT));
                    //	((SdrCaptionObj*)pObj)->SetText(aText);

//STRIP001 					((SdrCaptionObj*)pObj)->SetLogicRect(aRect);
//STRIP001 					((SdrCaptionObj*)pObj)->SetTailPos(
//STRIP001 						aRect.TopLeft() - Point(aRect.GetWidth() / 2, aRect.GetHeight() / 2));
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					DBG_ERROR("Object is NO caption object");
//STRIP001 				}
//STRIP001 
//STRIP001 				break;
//STRIP001 			}
//STRIP001 			default:
//STRIP001 			{
//STRIP001 				pObj->SetLogicRect(aRect);
//STRIP001 
//STRIP001 				break;
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		SfxItemSet aAttr(pDoc->GetPool());
//STRIP001 		SetStyleSheet(aAttr, pObj);
//STRIP001 		SetAttributes(aAttr, pObj);
//STRIP001 		SetLineEnds(aAttr, pObj);
//STRIP001 		pObj->SetItemSet(aAttr);
//STRIP001 	}
//STRIP001 
//STRIP001 	return pObj;
//STRIP001 }


}
