/*************************************************************************
 *
 *  $RCSfile: sd_outlinfo.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:58:14 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #include <vcl/metric.hxx>
// auto strip #include <bf_svx/outliner.hxx>
// auto strip #include <bf_svx/svdorect.hxx>
// auto strip #include <bf_svx/svdoutl.hxx>
// auto strip #include <bf_svx/svxfont.hxx>
// auto strip #include "drawdoc.hxx"
// auto strip #include "outlinfo.hxx"
#include <algorithm>

// #101500#
// auto strip #ifndef _COM_SUN_STAR_LANG_XMULTISERVICEFACTORY_HPP_
// auto strip #include <com/sun/star/lang/XMultiServiceFactory.hpp>
// auto strip #endif

#ifndef _COM_SUN_STAR_I18N_SCRIPTTYPE_HDL_
#include <com/sun/star/i18n/ScriptType.hdl>
#endif

// auto strip #ifndef _COM_SUN_STAR_I18N_XBREAKITERATOR_HPP_
// auto strip #include <com/sun/star/i18n/XBreakIterator.hpp>
// auto strip #endif

// auto strip #ifndef _COMPHELPER_PROCESSFACTORY_HXX_
// auto strip #include <comphelper/processfactory.hxx>
// auto strip #endif

#ifndef _COM_SUN_STAR_I18N_CHARACTERITERATORMODE_HDL_
#include <com/sun/star/i18n/CharacterIteratorMode.hdl>
#endif

// auto strip #ifndef _UNO_LINGU_HXX
// auto strip #include <bf_svx/unolingu.hxx>
// auto strip #endif

#ifndef _LEGACYBINFILTERMGR_HXX
#include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
#endif
namespace binfilter {

using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::i18n;

// ----------------
// - OutlinerInfo -
// ----------------

//STRIP001 OutlinerInfo::OutlinerInfo() :
//STRIP001 			pParagraphs	( NULL ),
//STRIP001 			nParaCount	( 0UL ),
//STRIP001 			nExtraData	( 0L )
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 OutlinerInfo::~OutlinerInfo()
//STRIP001 {
//STRIP001 	Clear();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void OutlinerInfo::SetTextObj( SdDrawDocument* pDoc, SdrRectObj* pObj, OutputDevice* _pOut )
//STRIP001 {
//STRIP001 	Clear();
//STRIP001 
//STRIP001 	SdrOutliner& rOutliner = pDoc->GetDrawOutliner();
//STRIP001 
//STRIP001 	pOut = _pOut;
//STRIP001 	rOutliner.SetText( *pObj->GetOutlinerParaObject() );
//STRIP001 
//STRIP001 	aObjBound = pObj->GetBoundRect();
//STRIP001 	nParaCount = rOutliner.GetParagraphCount();
//STRIP001 	nExtraData = 0L;
//STRIP001 
//STRIP001 	if( nParaCount )
//STRIP001 	{
//STRIP001 		mbVertical = rOutliner.IsVertical();
//STRIP001 		pObj->TakeTextRect( rOutliner, aParaBound, TRUE );
//STRIP001 		
//STRIP001         if( IsVertical() )
//STRIP001 			aTextOffset = aParaBound.TopRight();
//STRIP001         else
//STRIP001 			aTextOffset = aParaBound.TopLeft();
//STRIP001 
//STRIP001 		nCurPara = 0;
//STRIP001 		bInit = TRUE;
//STRIP001 
//STRIP001 		rOutliner.SetDrawPortionHdl( LINK( this, OutlinerInfo, DrawPortionHdl ) );
//STRIP001 		pParagraphs = new OutlinerParagraph[ nParaCount ];
//STRIP001 		rOutliner.StripPortions();
//STRIP001 		rOutliner.SetDrawPortionHdl( Link() );
//STRIP001 
//STRIP001         if( 1 == nParaCount )
//STRIP001             pParagraphs[ 0 ].aRect = aParaBound;
//STRIP001         else if( IsVertical() )
//STRIP001         {
//STRIP001     		pParagraphs[ 0 ].aRect.Right() = aParaBound.Right();
//STRIP001 
//STRIP001             for( USHORT i = 0; i < nParaCount; i++ )
//STRIP001 			{
//STRIP001 				if( i > 0 )
//STRIP001 					pParagraphs[i].aRect.Right() = pParagraphs[ i - 1 ].aRect.Left();
//STRIP001 
//STRIP001 				pParagraphs[i].aRect.Left() = pParagraphs[i].aRect.Right() - rOutliner.GetTextHeight( i );
//STRIP001 			}
//STRIP001         }
//STRIP001         else
//STRIP001         {
//STRIP001     		pParagraphs[ 0 ].aRect.Top() = aParaBound.Top();
//STRIP001 
//STRIP001             for( USHORT i = 0; i < nParaCount; i++ )
//STRIP001 			{
//STRIP001 				if( i > 0 )
//STRIP001 					pParagraphs[ i ].aRect.Top() = pParagraphs[ i - 1 ].aRect.Bottom();
//STRIP001 
//STRIP001 				pParagraphs[ i ].aRect.Bottom() = pParagraphs[ i ].aRect.Top() + rOutliner.GetTextHeight( i );
//STRIP001 			}
//STRIP001         }
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		pParagraphs = NULL;
//STRIP001 		aParaBound = Rectangle();
//STRIP001 		aTextOffset = Point();
//STRIP001 	}
//STRIP001 
//STRIP001 	nCurPara = 0;
//STRIP001 	bInit = FALSE;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void OutlinerInfo::Clear()
//STRIP001 {
//STRIP001 	for( void* pChar = aCharacterList.First(); pChar; pChar = aCharacterList.Next() )
//STRIP001 		delete (OutlinerCharacter*) pChar;
//STRIP001 	aCharacterList.Clear();
//STRIP001 
//STRIP001 	delete[] pParagraphs;
//STRIP001 	pParagraphs = NULL;
//STRIP001 	
//STRIP001 	nCurPara = nParaCount = 0UL;
//STRIP001 	aObjBound = aParaBound = Rectangle();
//STRIP001 	aTextOffset = Point();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 const Rectangle& OutlinerInfo::GetParaRect( const ULONG nPara ) const
//STRIP001 {
//STRIP001 	DBG_ASSERT( nPara < nParaCount, "Para out of range!" );
//STRIP001 	return pParagraphs[ nPara ].aRect;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL OutlinerInfo::GetParaCharCount( const ULONG nPara ) const
//STRIP001 {
//STRIP001 	DBG_ASSERT( nPara < nParaCount, "Para out of range!" );
//STRIP001 	return (0 != pParagraphs[ nPara ].nCharCount);
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 /*
//STRIP001 IMPL_LINK(OutlinerInfo, DrawPortionHdl, DrawPortionInfo*, pInfo)
//STRIP001 {
//STRIP001 	// #101500#
//STRIP001 	Point aStart;
//STRIP001 	sal_Bool bIsVertical(IsVertical());
//STRIP001 	sal_Bool bUseBreakIterator(sal_False);
//STRIP001 
//STRIP001 	pOut->SetFont((const Font&)pInfo->rFont);
//STRIP001 
//STRIP001 	FontMetric aFontMetric(pOut->GetFontMetric());
//STRIP001 
//STRIP001 	// initialize BreakIterator
//STRIP001 	Reference < ::com::sun::star::i18n::XBreakIterator > xBreak;
//STRIP001 	Reference < XMultiServiceFactory > xMSF = ::legacy_binfilters::getLegacyProcessServiceFactory();
//STRIP001 	Reference < XInterface > xInterface = xMSF->createInstance(::rtl::OUString::createFromAscii("com.sun.star.i18n.BreakIterator"));
//STRIP001 	::com::sun::star::lang::Locale aFontLocale = SvxCreateLocale(pInfo->rFont.GetLanguage());
//STRIP001 	
//STRIP001 	if(xInterface.is())
//STRIP001 	{
//STRIP001 		Any x = xInterface->queryInterface(::getCppuType((const Reference< XBreakIterator >*)0));
//STRIP001 		x >>= xBreak;
//STRIP001 	}
//STRIP001 
//STRIP001 	if(xBreak.is())
//STRIP001 	{
//STRIP001 		bUseBreakIterator = sal_True;
//STRIP001 	}
//STRIP001 
//STRIP001 	if(bIsVertical)
//STRIP001 	{
//STRIP001 		aStart.X() = pInfo->rStartPos.X() + aTextOffset.X() - aFontMetric.GetDescent();
//STRIP001 		aStart.Y() = pInfo->rStartPos.Y() + aTextOffset.Y();
//STRIP001 
//STRIP001         const Point aTopLeft(aStart.X(), aParaBound.Top());
//STRIP001         const Point aBottomRight(aStart.X() + aFontMetric.GetLineHeight(), aParaBound.Bottom());
//STRIP001         const Rectangle aCurRect(aTopLeft, aBottomRight);
//STRIP001 
//STRIP001         if(pInfo->nPara != nCurPara)
//STRIP001 		{
//STRIP001 			nCurPara = pInfo->nPara;
//STRIP001             pParagraphs[nCurPara].aRect = aCurRect;
//STRIP001 		}
//STRIP001         else
//STRIP001 		{
//STRIP001             pParagraphs[nCurPara].aRect.Union(aCurRect);
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aStart.X() = pInfo->rStartPos.X() + aTextOffset.X();
//STRIP001 		aStart.Y() = pInfo->rStartPos.Y() + aTextOffset.Y() - aFontMetric.GetAscent();
//STRIP001 
//STRIP001         const Point aTopLeft(aParaBound.Left(), aStart.Y());
//STRIP001         const Point aBottomRight(aParaBound.Right(), aStart.Y() + aFontMetric.GetLineHeight());
//STRIP001         const Rectangle aCurRect(aTopLeft, aBottomRight);
//STRIP001 
//STRIP001         if(pInfo->nPara != nCurPara)
//STRIP001 		{
//STRIP001 			nCurPara = pInfo->nPara;
//STRIP001             pParagraphs[nCurPara].aRect = aCurRect;
//STRIP001 		}
//STRIP001         else
//STRIP001 		{
//STRIP001             pParagraphs[nCurPara].aRect.Union(aCurRect);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if(pInfo->nTextLen && (0xFFFF != pInfo->nIndex))
//STRIP001 	{
//STRIP001 		pParagraphs[nCurPara].nCharCount += pInfo->nTextLen;
//STRIP001 
//STRIP001 		for(sal_uInt16 nCharIndex(0); nCharIndex < pInfo->nTextLen;)
//STRIP001 		{
//STRIP001 			xub_StrLen nNextGlyphLen(1);
//STRIP001 			sal_Bool bIsSingleSpace(sal_False);
//STRIP001 
//STRIP001 			if(bUseBreakIterator)
//STRIP001 			{
//STRIP001 				sal_Int32 nDone(0L);
//STRIP001 				nNextGlyphLen = (xub_StrLen)xBreak->nextCharacters( pInfo->rText, pInfo->nTextStart, aFontLocale, 
//STRIP001 					CharacterIteratorMode::SKIPCELL, 1, nDone) - (pInfo->nTextStart);
//STRIP001 			}
//STRIP001 
//STRIP001 			if(!bIsSingleSpace)
//STRIP001 			{
//STRIP001 				Rectangle aTextRect;
//STRIP001 				sal_Bool bDidWork = pOut->GetTextBoundRect(aTextRect, pInfo->rText,
//STRIP001 					pInfo->nTextStart, pInfo->nTextStart + nCharIndex, nNextGlyphLen);
//STRIP001 
//STRIP001 				if(bDidWork)
//STRIP001 				{
//STRIP001 //					if(bIsVertical)
//STRIP001 //						aTextRect.SetPos(aStart + Point(-aFontMetric.GetDescent(), 0));
//STRIP001 //					else
//STRIP001 //						aTextRect.SetPos(aStart + Point(0, aFontMetric.GetAscent()));
//STRIP001 					aTextRect.Move(0, aFontMetric.GetAscent());
//STRIP001 					aTextRect.Move(aStart.X(), aStart.Y());
//STRIP001 
//STRIP001 					aCharacterList.Insert(
//STRIP001 						new OutlinerCharacter(
//STRIP001 							aTextRect, 
//STRIP001 							pInfo->nPara,
//STRIP001 							pInfo->rFont.GetColor()
//STRIP001 							// #101500# CharCode is no longer used.
//STRIP001 							//,pInfo->rText.GetChar(nCharIndex + pInfo->nTextStart)
//STRIP001 							), 
//STRIP001 						LIST_APPEND);
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			// use glyph lengh for loop
//STRIP001 			nCharIndex += nNextGlyphLen;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0L;
//STRIP001 }
//STRIP001 */
//STRIP001 
//STRIP001 IMPL_LINK(OutlinerInfo, DrawPortionHdl, DrawPortionInfo*, pInfo)
//STRIP001 {
//STRIP001 	// #101500#
//STRIP001 	Point aStart;
//STRIP001 	sal_Bool bIsVertical(IsVertical());
//STRIP001 	pOut->SetFont((const Font&)pInfo->rFont);
//STRIP001 	FontMetric aFontMetric(pOut->GetFontMetric());
//STRIP001 	sal_Bool bUseBreakIterator(sal_False);
//STRIP001 
//STRIP001 	// initialize BreakIterator
//STRIP001 	Reference < ::com::sun::star::i18n::XBreakIterator > xBreak;
//STRIP001 	Reference < XMultiServiceFactory > xMSF = ::legacy_binfilters::getLegacyProcessServiceFactory();
//STRIP001 	Reference < XInterface > xInterface = xMSF->createInstance(::rtl::OUString::createFromAscii("com.sun.star.i18n.BreakIterator"));
//STRIP001 	::com::sun::star::lang::Locale aFontLocale = SvxCreateLocale(pInfo->rFont.GetLanguage());
//STRIP001 	
//STRIP001 	if(xInterface.is())
//STRIP001 	{
//STRIP001 		Any x = xInterface->queryInterface(::getCppuType((const Reference< XBreakIterator >*)0));
//STRIP001 		x >>= xBreak;
//STRIP001 	}
//STRIP001 
//STRIP001 	if(xBreak.is())
//STRIP001 	{
//STRIP001 		bUseBreakIterator = sal_True;
//STRIP001 	}
//STRIP001 
//STRIP001 	if(bIsVertical)
//STRIP001 	{
//STRIP001 		aStart.X() = pInfo->rStartPos.X() + aTextOffset.X() - aFontMetric.GetDescent();
//STRIP001 		aStart.Y() = pInfo->rStartPos.Y() + aTextOffset.Y();
//STRIP001 
//STRIP001         const Point aTopLeft(aStart.X(), aParaBound.Top());
//STRIP001         const Point aBottomRight(aStart.X() + aFontMetric.GetLineHeight(), aParaBound.Bottom());
//STRIP001         const Rectangle aCurRect(aTopLeft, aBottomRight);
//STRIP001 
//STRIP001         if(pInfo->nPara != nCurPara)
//STRIP001 		{
//STRIP001 			nCurPara = pInfo->nPara;
//STRIP001             pParagraphs[nCurPara].aRect = aCurRect;
//STRIP001 		}
//STRIP001         else
//STRIP001 		{
//STRIP001             pParagraphs[nCurPara].aRect.Union(aCurRect);
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aStart.X() = pInfo->rStartPos.X() + aTextOffset.X();
//STRIP001 		aStart.Y() = pInfo->rStartPos.Y() + aTextOffset.Y() - aFontMetric.GetAscent();
//STRIP001 
//STRIP001         const Point aTopLeft(aParaBound.Left(), aStart.Y());
//STRIP001         const Point aBottomRight(aParaBound.Right(), aStart.Y() + aFontMetric.GetLineHeight());
//STRIP001         const Rectangle aCurRect(aTopLeft, aBottomRight);
//STRIP001 
//STRIP001         if(pInfo->nPara != nCurPara)
//STRIP001 		{
//STRIP001 			nCurPara = pInfo->nPara;
//STRIP001             pParagraphs[nCurPara].aRect = aCurRect;
//STRIP001 		}
//STRIP001         else
//STRIP001 		{
//STRIP001             pParagraphs[nCurPara].aRect.Union(aCurRect);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if(pInfo->nTextLen && (0xFFFF != pInfo->nIndex))
//STRIP001 	{
//STRIP001 		pParagraphs[nCurPara].nCharCount += pInfo->nTextLen;
//STRIP001 		sal_uInt16 nInsertIndex(LIST_APPEND);
//STRIP001 
//STRIP001 		if(pInfo->IsRTL())
//STRIP001 			nInsertIndex = aCharacterList.Count();
//STRIP001 
//STRIP001 		for(sal_uInt16 nCharIndex(0); nCharIndex < pInfo->nTextLen; )
//STRIP001 		{
//STRIP001 			xub_StrLen nNextGlyphLen(1);
//STRIP001 			sal_Bool bIsSingleSpace(sal_False);
//STRIP001 
//STRIP001 			if(bUseBreakIterator)
//STRIP001 			{
//STRIP001 				sal_Int32 nDone(0L);
//STRIP001 				nNextGlyphLen = (xub_StrLen)xBreak->nextCharacters( pInfo->rText, pInfo->nTextStart, aFontLocale, 
//STRIP001 					CharacterIteratorMode::SKIPCELL, 1, nDone) - (pInfo->nTextStart);
//STRIP001 			}
//STRIP001 
//STRIP001 			if(!bIsSingleSpace)
//STRIP001 			{
//STRIP001 				Size aGlyphSize(pInfo->rFont.GetPhysTxtSize(pOut, 
//STRIP001 					pInfo->rText, nCharIndex + pInfo->nTextStart, nNextGlyphLen));
//STRIP001 
//STRIP001 				if(bIsVertical)
//STRIP001 				{
//STRIP001 					::std::swap(aGlyphSize.Width(), aGlyphSize.Height());
//STRIP001 				}
//STRIP001 
//STRIP001 				const Rectangle aRect(aStart, aGlyphSize);
//STRIP001 
//STRIP001 				aCharacterList.Insert(new OutlinerCharacter(
//STRIP001 					aRect, 
//STRIP001 					pInfo->nPara,
//STRIP001 					pInfo->rFont.GetColor()), 
//STRIP001 					nInsertIndex);
//STRIP001 				
//STRIP001 				long dx = 0;
//STRIP001 				if( pInfo->pDXArray )
//STRIP001 					dx = (pInfo->pDXArray)[nCharIndex];
//STRIP001 
//STRIP001 				if(bIsVertical)
//STRIP001     				aStart.Y() = pInfo->rStartPos.Y() + aTextOffset.Y() + dx;
//STRIP001 				else
//STRIP001 					aStart.X() = pInfo->rStartPos.X() + aTextOffset.X() + dx;
//STRIP001 			}
//STRIP001 
//STRIP001 			nCharIndex += nNextGlyphLen;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0L;
//STRIP001 }

// eof
}
