/*************************************************************************
 *
 *  $RCSfile: sfx2_saxnamespacefilter.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:37:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {

//STRIP001 #include <stdio.h>
//STRIP001 
//STRIP001 #include <saxnamespacefilter.hxx>
//STRIP001 #include <attriblist.hxx>
//STRIP001 
//STRIP001 #include <vector>
//STRIP001 
//STRIP001 #ifndef _SV_SVAPP_HXX
//STRIP001 #include <vcl/svapp.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 using namespace ::rtl;
//STRIP001 using namespace ::com::sun::star::xml::sax;
//STRIP001 using namespace ::com::sun::star::uno;
//STRIP001 
//STRIP001 const OUString aXMLAttributeNamespace( RTL_CONSTASCII_USTRINGPARAM( "xmlns" ));
//STRIP001 const OUString aXMLAttributeType( RTL_CONSTASCII_USTRINGPARAM( "CDATA" ));
//STRIP001 
//STRIP001 SaxNamespaceFilter::SaxNamespaceFilter( Reference< XDocumentHandler >& rSax1DocumentHandler ) :
//STRIP001 	xDocumentHandler( rSax1DocumentHandler ),
//STRIP001 	m_xLocator( 0 ),
//STRIP001 	m_nDepth( 0 )
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 SaxNamespaceFilter::~SaxNamespaceFilter()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 Any SAL_CALL SaxNamespaceFilter::queryInterface( const Type & rType ) throw( RuntimeException )
//STRIP001 {
//STRIP001 	Any a = ::cppu::queryInterface(
//STRIP001 				rType ,
//STRIP001 				SAL_STATIC_CAST( XDocumentHandler*, this ));
//STRIP001 	if ( a.hasValue() )
//STRIP001 		return a;
//STRIP001 
//STRIP001 	return OWeakObject::queryInterface( rType );
//STRIP001 }
//STRIP001 
//STRIP001 // XDocumentHandler
//STRIP001 void SAL_CALL SaxNamespaceFilter::startDocument(void)
//STRIP001 	throw (	SAXException, RuntimeException )
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 void SAL_CALL SaxNamespaceFilter::endDocument(void)
//STRIP001 	throw(	SAXException, RuntimeException )
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 void SAL_CALL SaxNamespaceFilter::startElement(
//STRIP001 	const ::rtl::OUString& aName, const Reference< XAttributeList > &xAttribs )
//STRIP001 	throw(	SAXException, RuntimeException )
//STRIP001 {
//STRIP001 	XMLNamespaces aXMLNamespaces;
//STRIP001 	if ( m_aNamespaceStack.size() > 0 )
//STRIP001 		aXMLNamespaces = m_aNamespaceStack.top();
//STRIP001 
//STRIP001 	AttributeListImpl* pNewList = new AttributeListImpl();
//STRIP001 
//STRIP001 	// examine all namespaces for this level
//STRIP001 	::std::vector< int > aAttributeIndexes;
//STRIP001 	{
//STRIP001 		for ( int i=0; i< xAttribs->getLength(); i++ )
//STRIP001 		{
//STRIP001 			OUString aName = xAttribs->getNameByIndex( i );
//STRIP001 			if ( aName.compareTo( aXMLAttributeNamespace, aXMLAttributeNamespace.getLength() ) == 0 )
//STRIP001 				aXMLNamespaces.addNamespace( aName, xAttribs->getValueByIndex( i ));
//STRIP001 			else
//STRIP001 				aAttributeIndexes.push_back( i );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// current namespaces for this level
//STRIP001 	m_aNamespaceStack.push( aXMLNamespaces );
//STRIP001 
//STRIP001 	try
//STRIP001 	{
//STRIP001 		// apply namespaces to all remaing attributes
//STRIP001 		for ( sal_uInt32 i=0; i< aAttributeIndexes.size(); i++ )
//STRIP001 		{
//STRIP001 			OUString aAttributeName			 = xAttribs->getNameByIndex( aAttributeIndexes[i] );
//STRIP001 			OUString aValue					 = xAttribs->getValueByIndex( aAttributeIndexes[i] );
//STRIP001 			OUString aNamespaceAttributeName = aXMLNamespaces.applyNSToAttributeName( aAttributeName );
//STRIP001 			pNewList->addAttribute( aNamespaceAttributeName, aXMLAttributeType, aValue );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	catch ( SAXException& e )
//STRIP001 	{
//STRIP001 		e.Message = OUString( getErrorLineString() + e.Message );
//STRIP001 		throw e;
//STRIP001 	}
//STRIP001 
//STRIP001 	OUString aNamespaceElementName;
//STRIP001 
//STRIP001 	try
//STRIP001 	{
//STRIP001 		 aNamespaceElementName = aXMLNamespaces.applyNSToElementName( aName );
//STRIP001 	}
//STRIP001 	catch ( SAXException& e )
//STRIP001 	{
//STRIP001 		e.Message = OUString( getErrorLineString() + e.Message );
//STRIP001 		throw e;
//STRIP001 	}
//STRIP001 
//STRIP001 	xDocumentHandler->startElement( aNamespaceElementName, pNewList );
//STRIP001 }
//STRIP001 
//STRIP001 void SAL_CALL SaxNamespaceFilter::endElement(const ::rtl::OUString& aName)
//STRIP001 	throw(	SAXException, RuntimeException )
//STRIP001 {
//STRIP001 	XMLNamespaces& aXMLNamespaces = m_aNamespaceStack.top();
//STRIP001 	OUString aNamespaceElementName;
//STRIP001 
//STRIP001 	try
//STRIP001 	{
//STRIP001 		aNamespaceElementName = aXMLNamespaces.applyNSToElementName( aName );
//STRIP001 	}
//STRIP001 	catch ( SAXException& e )
//STRIP001 	{
//STRIP001 		e.Message = OUString( getErrorLineString() + e.Message );
//STRIP001 		throw e;
//STRIP001 	}
//STRIP001 
//STRIP001 	xDocumentHandler->endElement( aNamespaceElementName );
//STRIP001 	m_aNamespaceStack.pop();
//STRIP001 }
//STRIP001 
//STRIP001 void SAL_CALL SaxNamespaceFilter::characters(const ::rtl::OUString& aChars)
//STRIP001 	throw(	SAXException, RuntimeException )
//STRIP001 {
//STRIP001 	xDocumentHandler->characters( aChars );
//STRIP001 }
//STRIP001 
//STRIP001 void SAL_CALL SaxNamespaceFilter::ignorableWhitespace(const ::rtl::OUString& aWhitespaces)
//STRIP001 	throw(	SAXException, RuntimeException )
//STRIP001 {
//STRIP001 	xDocumentHandler->ignorableWhitespace( aWhitespaces );
//STRIP001 }
//STRIP001 
//STRIP001 void SAL_CALL SaxNamespaceFilter::processingInstruction(
//STRIP001 	const ::rtl::OUString& aTarget, const ::rtl::OUString& aData)
//STRIP001 	throw(	SAXException, RuntimeException )
//STRIP001 {
//STRIP001 	xDocumentHandler->processingInstruction( aTarget, aData );
//STRIP001 }
//STRIP001 
//STRIP001 void SAL_CALL SaxNamespaceFilter::setDocumentLocator(
//STRIP001 	const Reference< XLocator > &xLocator)
//STRIP001 	throw(	SAXException, RuntimeException )
//STRIP001 {
//STRIP001 	m_xLocator = xLocator;
//STRIP001 	xDocumentHandler->setDocumentLocator( xLocator );
//STRIP001 }
//STRIP001 
//STRIP001 OUString SaxNamespaceFilter::getErrorLineString()
//STRIP001 {
//STRIP001 	char buffer[32];
//STRIP001 
//STRIP001 	if ( m_xLocator.is() )
//STRIP001 	{
//STRIP001 		snprintf( buffer, sizeof(buffer), "Line: %ld - ", m_xLocator->getLineNumber() );
//STRIP001 		return OUString::createFromAscii( buffer );
//STRIP001 	}
//STRIP001 	else
//STRIP001 		return OUString();
//STRIP001 }
}
