/*************************************************************************
 *
 *  $RCSfile: sfx2_minfitem.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:38:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {

// INCLUDE ---------------------------------------------------------------

//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #include "minfitem.hxx"
//STRIP001 
//STRIP001 // STATIC DATA -----------------------------------------------------------
//STRIP001 
//STRIP001 TYPEINIT1(SfxMacroInfoItem, SfxPoolItem);
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxMacroInfoItem::SfxMacroInfoItem(USHORT nWhich,		// Slot-ID
//STRIP001 								const BasicManager* pMgr,
//STRIP001 								const String &rLibName,
//STRIP001 								const String &rModuleName,
//STRIP001 								const String &rMethodName,
//STRIP001 								const String &rComment) :
//STRIP001 	SfxPoolItem(nWhich),
//STRIP001 	pBasicManager(pMgr),
//STRIP001 	aLibName(rLibName),
//STRIP001 	aModuleName(rModuleName),
//STRIP001 	aMethodName(rMethodName),
//STRIP001 	aCommentText(rComment)
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 // copy ctor
//STRIP001 
//STRIP001 SfxMacroInfoItem::SfxMacroInfoItem(const SfxMacroInfoItem& rCopy):
//STRIP001 	SfxPoolItem(rCopy),
//STRIP001 	pBasicManager(rCopy.pBasicManager),
//STRIP001 	aLibName(rCopy.aLibName),
//STRIP001 	aModuleName(rCopy.aModuleName),
//STRIP001 	aMethodName(rCopy.aMethodName),
//STRIP001 	aCommentText(rCopy.aCommentText)
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 // op ==
//STRIP001 
//STRIP001 int SfxMacroInfoItem::operator==( const SfxPoolItem& rCmp) const
//STRIP001 {
//STRIP001 	return SfxPoolItem::operator==(rCmp) &&
//STRIP001 			pBasicManager == ((const SfxMacroInfoItem&)rCmp).pBasicManager &&
//STRIP001 			aLibName == ((const SfxMacroInfoItem&)rCmp).aLibName &&
//STRIP001 			aModuleName == ((const SfxMacroInfoItem&)rCmp).aModuleName &&
//STRIP001 			aMethodName == ((const SfxMacroInfoItem&)rCmp).aMethodName &&
//STRIP001 			aCommentText == ((const SfxMacroInfoItem&)rCmp).aCommentText;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxPoolItem *SfxMacroInfoItem::Clone( SfxItemPool *) const
//STRIP001 {
//STRIP001 	return new SfxMacroInfoItem(*this);
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 String SfxMacroInfoItem::GetQualifiedName() const
//STRIP001 {
//STRIP001 	String aMacroName = aLibName;
//STRIP001 	aMacroName += '.';
//STRIP001 	aMacroName += aModuleName;
//STRIP001 	aMacroName += '.';
//STRIP001 	aMacroName += aMethodName;
//STRIP001 	return aMacroName;
//STRIP001 }


}
