/*************************************************************************
 *
 *  $RCSfile: cfg.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:39:42 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SFXCFG_HXX
#define _SFXCFG_HXX

#ifndef _SV_LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_GROUP_HXX //autogen
#include <vcl/group.hxx>
#endif
#ifndef _SVTABBX_HXX //autogen
#include <svtools/svtabbx.hxx>
#endif
#ifndef _SVTREEBOX_HXX //autogen
#include <svtools/svtreebx.hxx>
#endif

#define _SVSTDARR_USHORTS
#define _SVSTDARR_STRINGSDTOR
#include <svtools/svstdarr.hxx>		// SvUShorts
#include "minarray.hxx"
#include "tabdlg.hxx"

#include <vector>
namespace binfilter {

class SfxMenuManager;
class SfxAcceleratorManager;
class SfxMacroInfoArr_Impl;
class SfxMacroInfoItem;
class SfxMacroInfo;
class SfxConfigManager;

#define SFX_CFGGROUP_FUNCTION 1
#define SFX_CFGGROUP_BASICMGR 2
#define SFX_CFGGROUP_DOCBASICMGR 3
#define SFX_CFGGROUP_BASICLIB 4
#define SFX_CFGGROUP_BASICMOD 5
#define SFX_CFGFUNCTION_MACRO 6
#define SFX_CFGFUNCTION_SLOT  7

//STRIP001 struct SfxGroupInfo_Impl
//STRIP001 {
//STRIP001 	USHORT 		nKind;
//STRIP001 	USHORT 		nOrd;
//STRIP001 	void*		pObject;
//STRIP001 	BOOL		bWasOpened;
//STRIP001 
//STRIP001 				SfxGroupInfo_Impl( USHORT n, USHORT nr, void* pObj = 0 ) :
//STRIP001 					nKind( n ), nOrd( nr ), pObject( pObj ), bWasOpened(FALSE) {}
//STRIP001 };
//STRIP001 
//STRIP001 typedef SfxGroupInfo_Impl* SfxGroupInfoPtr;
//STRIP001 SV_DECL_PTRARR_DEL(SfxGroupInfoArr_Impl, SfxGroupInfoPtr, 5, 5)//STRIP008 ;
//STRIP001 DECL_2BYTEARRAY(USHORTArr, USHORT, 10, 10)//STRIP008 ;
//STRIP001 
//STRIP001 class SfxConfigFunctionListBox_Impl : public SvTreeListBox
//STRIP001 {
//STRIP001 friend class SfxConfigGroupListBox_Impl;
//STRIP001 	Timer							aTimer;
//STRIP001 	SvLBoxEntry*					pCurEntry;
//STRIP001 	SfxGroupInfoArr_Impl			aArr;
//STRIP001 
//STRIP001 	DECL_LINK(						TimerHdl, Timer* );
//STRIP001 	virtual void 					MouseMove( const MouseEvent& rMEvt );
//STRIP001 
//STRIP001 public:
//STRIP001 									SfxConfigFunctionListBox_Impl( Window*, const ResId& );
//STRIP001 									~SfxConfigFunctionListBox_Impl();
//STRIP001 	void							ClearAll();
//STRIP001 	SvLBoxEntry*					GetEntry_Impl( USHORT nId );
//STRIP001 	SvLBoxEntry*					GetEntry_Impl( const String& );
//STRIP001 	USHORT							GetId( SvLBoxEntry *pEntry );
//STRIP001 	String							GetHelpText( SvLBoxEntry *pEntry );
//STRIP001 	USHORT							GetCurId()
//STRIP001 									{ return GetId( FirstSelected() ); }
//STRIP001 	SfxMacroInfo*					GetMacroInfo();
//STRIP001 	void							FunctionSelected();
//STRIP001 };
//STRIP001 
//STRIP001 class SfxSlotPool;
//STRIP001 class SfxConfigGroupListBox_Impl : public SvTreeListBox
//STRIP001 {
//STRIP001 	SfxConfigFunctionListBox_Impl*	pFunctionListBox;
//STRIP001 	SfxGroupInfoArr_Impl			aArr;
//STRIP001 	ULONG							nMode;
//STRIP001 	String							aScriptType;
//STRIP001 	SfxSlotPool*					pSlotPool;
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void    				RequestingChilds( SvLBoxEntry *pEntry);
//STRIP001 #if SUPD>=527
//STRIP001 	virtual BOOL    				Expand( SvLBoxEntry* pParent );
//STRIP001 #endif
//STRIP001 
//STRIP001 public:
//STRIP001 									SfxConfigGroupListBox_Impl ( Window* pParent,
//STRIP001 										const ResId&, ULONG nConfigMode = 0 );
//STRIP001 									~SfxConfigGroupListBox_Impl();
//STRIP001 	void							ClearAll();
//STRIP001 
//STRIP001 	void							Init( SvStringsDtor *pArr = 0, SfxSlotPool* pSlotPool = 0 );
//STRIP001 	void 							SetFunctionListBox( SfxConfigFunctionListBox_Impl *pBox )
//STRIP001 									{ pFunctionListBox = pBox; }
//STRIP001 	void							Open( SvLBoxEntry*, BOOL );
//STRIP001 	void							GroupSelected();
//STRIP001 	void 							SelectMacro( const SfxMacroInfoItem* );
//STRIP001 	void 							SelectMacro( const String&, const String& );
//STRIP001 	String							GetGroup();
//STRIP001 	void							SetScriptType( const String& rScriptType );
//STRIP001 };
//STRIP001 
//STRIP001 class SfxMenuConfigEntry
//STRIP001 {
//STRIP001 private:
//STRIP001 	USHORT  					nId;
//STRIP001 	BOOL						bPopUp;
//STRIP001 	String  					aHelpText;
//STRIP001 	String  					aStr;
//STRIP001 	String						aCommand;
//STRIP001 	BOOL						bConfigure;
//STRIP001 
//STRIP001 public:
//STRIP001 	SfxMenuConfigEntry( USHORT nInitId, const String& rInitStr,
//STRIP001 						const String& rHelpText, BOOL bPopup = FALSE );
//STRIP001 	SfxMenuConfigEntry() : nId( 0 ), bPopUp( FALSE ), bConfigure( TRUE ) {}
//STRIP001 	~SfxMenuConfigEntry();
//STRIP001 
//STRIP001 	USHORT 						GetId() const { return nId; }
//STRIP001 	void 						SetId( USHORT nNew );
//STRIP001 	void						SetCommand( const String& rCmd ) { aCommand = rCmd; }
//STRIP001 	const String&				GetName() const { return aStr; }
//STRIP001 	void						SetName( const String& rStr ) { aStr = rStr; }
//STRIP001 	const String&				GetHelpText() const { return aHelpText; }
//STRIP001 	void						SetHelpText( const String& rStr ) { aHelpText = rStr; }
//STRIP001 	void 						SetPopup( BOOL bOn = TRUE ) { bPopUp = bOn; }
//STRIP001 	void						SetConfigurable( BOOL bOn = TRUE ) { bConfigure = bOn; }
//STRIP001 	BOOL 						IsBinding() const { return nId != 0 && !bPopUp; }
//STRIP001 	BOOL 						IsSeparator() const { return nId == 0; }
//STRIP001 	BOOL 						IsPopup() const { return bPopUp; }
//STRIP001 	BOOL						IsConfigurable() const { return bConfigure; }
//STRIP001 	const String&				GetCommand() const { return aCommand; }
//STRIP001 };
//STRIP001 
//STRIP001 // class SfxMenuConfigEntryArr *************************************************
//STRIP001 
//STRIP001 SV_DECL_PTRARR_DEL(SfxMenuConfigEntryArr, SfxMenuConfigEntry *, 16, 16)
//STRIP001 
//STRIP001 class SfxMenuConfigPage;
//STRIP001 class SfxMenuCfgTabListBox_Impl : public SvTabListBox
//STRIP001 {
//STRIP001 	SfxMenuConfigPage*			pPage;
//STRIP001 	SfxMenuConfigEntryArr 		aMenuArr;
//STRIP001 	Timer						aTimer;
//STRIP001 	SfxMenuConfigEntry*			pCurEntry;
//STRIP001 
//STRIP001 	DECL_LINK(					TimerHdl, Timer* );
//STRIP001 
//STRIP001 public :
//STRIP001 								SfxMenuCfgTabListBox_Impl( Window *pParent, const ResId& rResId );
//STRIP001 								~SfxMenuCfgTabListBox_Impl();
//STRIP001 
//STRIP001 	virtual long				PreNotify( NotifyEvent& );
//STRIP001 	virtual void				ModelIsRemoving( SvListEntry* pEntry );
//STRIP001 	void						EntryInserted( SvListEntry* pEntry );
//STRIP001 	virtual void				ModelHasCleared();
//STRIP001 	virtual void				EditingRequest( SvLBoxEntry* pEntry,
//STRIP001 												SvLBoxItem* pItem, const Point& rMousePos );
//STRIP001 	virtual BOOL				EditedEntry( SvLBoxEntry* pEntry, const String& rNewText );
//STRIP001 	virtual void 				MouseMove( const MouseEvent& rMEvt );
//STRIP001 	virtual sal_Int8			AcceptDrop( const AcceptDropEvent& rEvt );
//STRIP001 	virtual BOOL    			NotifyMoving(SvLBoxEntry*, SvLBoxEntry*, SvLBoxEntry*&, ULONG& );
//STRIP001 	void						Apply( SfxMenuManager* pMgr, SvLBoxEntry *pParent = NULL );
//STRIP001 };
//STRIP001 
//STRIP001 // class SfxMenuConfigPage -----------------------------------------------
//STRIP001 
//STRIP001 class SfxMenuConfigPage : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	SfxMenuCfgTabListBox_Impl		aEntriesBox;
//STRIP001 	const SfxMacroInfoItem*			m_pMacroInfoItem;
//STRIP001     FixedLine                        aMenuGroup;
//STRIP001 	PushButton   					aNewButton;
//STRIP001 	PushButton   					aNewPopupButton;
//STRIP001 	PushButton   					aChangeButton;
//STRIP001 	PushButton   					aRemoveButton;
//STRIP001 	ImageButton 					aUpButton;
//STRIP001 	ImageButton 					aDownButton;
//STRIP001 	FixedText    					aGroupText;
//STRIP001     SfxConfigGroupListBox_Impl      aGroupLBox;
//STRIP001 	FixedText    					aFunctionText;
//STRIP001 	SfxConfigFunctionListBox_Impl	aFunctionBox;
//STRIP001     FixedLine                       aFunctionsGroup;
//STRIP001 	PushButton						aLoadButton;
//STRIP001 	PushButton						aSaveButton;
//STRIP001 	PushButton	 					aResetButton;
//STRIP001 
//STRIP001 	SfxMenuManager*				pMgr;
//STRIP001 
//STRIP001 	BOOL						bModified;
//STRIP001 	BOOL						bDefault;
//STRIP001 
//STRIP001 	DECL_LINK( 					MoveHdl, Button * );
//STRIP001 	DECL_LINK( 					NewHdl, Button * );
//STRIP001 	DECL_LINK( 					NewPopupHdl, Button * );
//STRIP001 	DECL_LINK( 					ChangeHdl, Button * );
//STRIP001 	DECL_LINK( 					RemoveHdl, Button * );
//STRIP001 	DECL_LINK( 					SelectHdl, Control* );
//STRIP001 
//STRIP001 	void   						CheckEntry( Control* );
//STRIP001 	USHORT 						GetCurId();
//STRIP001 	String 						MakeEntry( const SfxMenuConfigEntry &rEntry ) const;
//STRIP001 	String 						Trim( const String &rStr ) const;
//STRIP001 
//STRIP001 	void 						Init();
//STRIP001 	void 						ResetConfig();
//STRIP001 
//STRIP001 	BOOL						TryMove_Impl( Button*, SvLBoxEntry** pEntry=NULL, ULONG* pPos=NULL );
//STRIP001 
//STRIP001 	DECL_LINK( 					Default, PushButton * );
//STRIP001 	DECL_LINK( 					Save, Button * );
//STRIP001 	DECL_LINK( 					Load, Button * );
//STRIP001 
//STRIP001 public:
//STRIP001 								SfxMenuConfigPage( Window *pParent, const SfxItemSet& rItemSet );
//STRIP001 	virtual 					~SfxMenuConfigPage();
//STRIP001 
//STRIP001 	virtual BOOL				FillItemSet( SfxItemSet& );
//STRIP001 	virtual void				Reset( const SfxItemSet& );
//STRIP001     void                        Apply( SfxMenuManager*, BOOL );
//STRIP001 	void						SetModified( BOOL bSet ) { bModified = bSet; }
//STRIP001 	void						SetDefault( BOOL bSet )	{ bDefault = bSet; }
//STRIP001 
//STRIP001 	void						SelectMacro(const SfxMacroInfoItem*);
//STRIP001 };
//STRIP001 
//STRIP001 
//STRIP001 class SfxAcceleratorManager;
//STRIP001 
//STRIP001 // class SfxAcceleratorConfigListBox *************************************************
//STRIP001 
//STRIP001 class SfxAcceleratorConfigPage;
//STRIP001 class SfxAccCfgTabListBox_Impl : public SfxMenuCfgTabListBox_Impl
//STRIP001 {
//STRIP001 	SfxAcceleratorConfigPage*	m_pAccelConfigPage;
//STRIP001 
//STRIP001 	void 						KeyInput( const KeyEvent &rKEvt );
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void				InitEntry( SvLBoxEntry*, const XubString&, const Image&, const Image& );
//STRIP001 
//STRIP001 public:
//STRIP001 								SfxAccCfgTabListBox_Impl(
//STRIP001 										SfxAcceleratorConfigPage* pAccelConfigPage,
//STRIP001 										Window *pParent,
//STRIP001 										const ResId &rResId ) :
//STRIP001 									SfxMenuCfgTabListBox_Impl( pParent, rResId ),
//STRIP001 									m_pAccelConfigPage( pAccelConfigPage )
//STRIP001 								{}
//STRIP001 
//STRIP001 	void 						ReplaceEntry( USHORT nPos, const String &rStr );
//STRIP001 };
//STRIP001 
//STRIP001 // class SfxAcceleratorConfigPage ----------------------------------------
//STRIP001 struct AccelInfo_Impl
//STRIP001 {
//STRIP001 	SfxAcceleratorManager* 		pMgr;
//STRIP001 	SfxAcceleratorManager* 		pChanged;
//STRIP001 	BOOL						bDefault;
//STRIP001 	BOOL						bModified;
//STRIP001 };
//STRIP001 
//STRIP001 struct AccelBackup
//STRIP001 {
//STRIP001     AccelBackup( const KeyCode& rKeyCode, USHORT nSlotId ) :
//STRIP001         aKeyCode( rKeyCode ), nId( nSlotId ) {}
//STRIP001 
//STRIP001     KeyCode aKeyCode;
//STRIP001     USHORT  nId;
//STRIP001 };
//STRIP001 
//STRIP001 class SfxAcceleratorConfigPage : public SfxTabPage
//STRIP001 {
//STRIP001 	friend SfxAccCfgTabListBox_Impl;
//STRIP001 private:
//STRIP001 	const SfxMacroInfoItem*			m_pMacroInfoItem;
//STRIP001 	SfxAccCfgTabListBox_Impl		aEntriesBox;
//STRIP001     FixedLine                       aKeyboardGroup;
//STRIP001  	RadioButton						aOfficeButton;
//STRIP001 	RadioButton						aModuleButton;
//STRIP001 	PushButton         				aChangeButton;
//STRIP001 	PushButton         				aRemoveButton;
//STRIP001 	FixedText          				aGroupText;
//STRIP001     SfxConfigGroupListBox_Impl      aGroupLBox;
//STRIP001 	FixedText          				aFunctionText;
//STRIP001 	SfxConfigFunctionListBox_Impl	aFunctionBox;
//STRIP001 	FixedText          				aKeyText;
//STRIP001 	ListBox            				aKeyBox;
//STRIP001     FixedLine                       aFunctionsGroup;
//STRIP001 	PushButton						aLoadButton;
//STRIP001 	PushButton						aSaveButton;
//STRIP001 	PushButton		   				aResetButton;
//STRIP001 	std::vector< AccelBackup >      m_aAccelBackup;
//STRIP001 
//STRIP001 	USHORTArr					aConfigCodeArr;
//STRIP001 	USHORTArr					aConfigAccelArr;
//STRIP001 	USHORTArr     				aAccelArr;
//STRIP001 	USHORTArr     				aKeyArr;
//STRIP001 
//STRIP001 	AccelInfo_Impl*				pGlobal;
//STRIP001 	AccelInfo_Impl*				pModule;
//STRIP001 	AccelInfo_Impl*				pAct;
//STRIP001 
//STRIP001 	DECL_LINK( 					ChangeHdl, Button * );
//STRIP001 	DECL_LINK( 					RemoveHdl, Button * );
//STRIP001 	DECL_LINK( 					SelectHdl, Control * );
//STRIP001 	DECL_LINK( 					Save, Button * );
//STRIP001 	DECL_LINK( 					Load, Button * );
//STRIP001 	DECL_LINK( 					Default, PushButton * );
//STRIP001 	DECL_LINK(					RadioHdl, RadioButton* );
//STRIP001 
//STRIP001 	KeyCode 					PosToKeyCode_Config( USHORT nPos ) const;
//STRIP001 	USHORT  					KeyCodeToPos_Config( const KeyCode &rCode ) const;
//STRIP001 
//STRIP001 	KeyCode						PosToKeyCode_All( USHORT nPos ) const;
//STRIP001 	USHORT						KeyCodeToPos_All( const KeyCode& rCode ) const;
//STRIP001 
//STRIP001 	String  					GetFunctionName( KeyFuncType eType )    const;
//STRIP001 
//STRIP001 	void 						Init( SfxAcceleratorManager* pAccMgr );
//STRIP001 	void 						ResetConfig();
//STRIP001 
//STRIP001 	void						CreateCustomItems( SvLBoxEntry* pEntry, const String& aCol1, const String& aCol2 );
//STRIP001 
//STRIP001 public:
//STRIP001 								SfxAcceleratorConfigPage( Window *pParent, const SfxItemSet& rItemSet );
//STRIP001 	virtual 					~SfxAcceleratorConfigPage();
//STRIP001 
//STRIP001 	virtual BOOL				FillItemSet( SfxItemSet& );
//STRIP001 	virtual void				Reset( const SfxItemSet& );
//STRIP001 
//STRIP001 	void						SelectMacro(const SfxMacroInfoItem*);
//STRIP001     void                        Apply( SfxAcceleratorManager*, BOOL );
//STRIP001 };
//STRIP001 
//STRIP001 class SfxConfigDialog : public SfxTabDialog
//STRIP001 {
//STRIP001 	const SfxMacroInfoItem*		pMacroInfo;
//STRIP001 	SfxViewFrame*				pViewFrame;
//STRIP001 	USHORT						nObjectBar;
//STRIP001 
//STRIP001 public:
//STRIP001 								SfxConfigDialog( Window*, const SfxItemSet*, SfxViewFrame* pFrame );
//STRIP001 								~SfxConfigDialog();
//STRIP001 
//STRIP001 	void 						ActivateToolBoxConfig( USHORT nId );
//STRIP001 	void 						ActivateMacroConfig( const SfxMacroInfoItem* );
//STRIP001     void                        ActivateTabPage( USHORT );
//STRIP001 
//STRIP001 	virtual void				PageCreated( USHORT nId, SfxTabPage &rPage );
//STRIP001 	virtual short				Ok();
//STRIP001 
//STRIP001 	static String				FileDialog_Impl( Window *pParent, WinBits nBits, const String& rTitle );
//STRIP001 	static SfxConfigManager*	MakeCfgMgr_Impl( const String& rName, BOOL bWriting, BOOL& bCreated );
//STRIP001 };
//STRIP001 
//STRIP001 class SfxStatusBarManager;
//STRIP001 class SfxStbInfoArr_Impl;
//STRIP001 
//STRIP001 class SfxStatusBarConfigListBox : public SvTreeListBox
//STRIP001 {
//STRIP001 friend class SfxStatusBarConfigPage;
//STRIP001 	SvLBoxButtonData*			pButton;
//STRIP001 	BOOL                		bModified;
//STRIP001 	BOOL						bDefault;
//STRIP001 	SvLBoxEntry*				pCurEntry;
//STRIP001 	Timer						aTimer;
//STRIP001 
//STRIP001 	DECL_LINK(					TimerHdl, Timer* );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 								SfxStatusBarConfigListBox( Window* pParent,
//STRIP001 										const ResId& );
//STRIP001 								~SfxStatusBarConfigListBox();
//STRIP001 
//STRIP001 	virtual BOOL    			NotifyAcceptDrop( SvLBoxEntry* pEntry );
//STRIP001 	virtual BOOL    			NotifyMoving(SvLBoxEntry*,
//STRIP001 									SvLBoxEntry*,SvLBoxEntry*&,ULONG&);
//STRIP001 	virtual void				CheckButtonHdl();
//STRIP001 	virtual void 				MouseMove( const MouseEvent& rMEvt );
//STRIP001 	virtual void				KeyInput( const KeyEvent& rKeyEvent );
//STRIP001 };
//STRIP001 
//STRIP001 // class SfxStatusBarConfigPage ------------------------------------------
//STRIP001 
//STRIP001 class SfxStatusBarConfigPage : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	SfxStatusBarConfigListBox	aEntriesBox;
//STRIP001     FixedLine                   aStatusBarGroup;
//STRIP001 	PushButton					aLoadButton;
//STRIP001 	PushButton					aSaveButton;
//STRIP001 	PushButton					aResetButton;
//STRIP001 
//STRIP001 	SvUShorts					aListOfIds;
//STRIP001 	SfxStatusBarManager*		pMgr;
//STRIP001 	SfxStbInfoArr_Impl* 		pArr;
//STRIP001     BOOL                        bMgrCreated;
//STRIP001 
//STRIP001 	DECL_LINK( 					SelectHdl, SvTreeListBox * );
//STRIP001 	DECL_LINK( 					Save, Button * );
//STRIP001 	DECL_LINK( 					Load, Button * );
//STRIP001 	DECL_LINK( 					Default, PushButton * );
//STRIP001 
//STRIP001 	void 						Init();
//STRIP001 	void 						ResetConfig();
//STRIP001 
//STRIP001 public:
//STRIP001 								SfxStatusBarConfigPage( Window *pParent, const SfxItemSet& rItemSet );
//STRIP001 	virtual 					~SfxStatusBarConfigPage();
//STRIP001 
//STRIP001 	virtual BOOL				FillItemSet( SfxItemSet& );
//STRIP001 	virtual void				Reset( const SfxItemSet& );
//STRIP001     void                        Apply( SfxStatusBarManager*, BOOL );
//STRIP001 };


}//end of namespace binfilter
#endif

