/*************************************************************************
 *
 *  $RCSfile: sfx2_urltrans.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/01/11 11:38:50 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#include <tools/urlobj.hxx>
#include <svtools/urihelper.hxx>

#pragma hdrstop

#include "urltrans.hxx"
#include "so3/staticbaseurl.hxx"
namespace binfilter {

//STRIP001 SFX_IMPL_XINTERFACE_1( SfxURLTransformer, OWeakObject, ::com::sun::star::util::XURLTransformer )
//STRIP001 SFX_IMPL_XTYPEPROVIDER_1( SfxURLTransformer, ::com::sun::star::util::XURLTransformer )
//STRIP001 SFX_IMPL_XSERVICEINFO( SfxURLTransformer, "com.sun.star.util.URLTransformer", "com.sun.star.comp.sfx2.URLTransformer")
//STRIP001 SFX_IMPL_SINGLEFACTORY( SfxURLTransformer )
//STRIP001 
//STRIP001 SfxURLTransformer::SfxURLTransformer( const ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >& xFactory )
//STRIP001 {}
//STRIP001 
//STRIP001 SfxURLTransformer::~SfxURLTransformer()
//STRIP001 {}
//STRIP001 
//STRIP001 sal_Bool SAL_CALL SfxURLTransformer::parseStrict( ::com::sun::star::util::URL& aURL ) throw ( ::com::sun::star::uno::RuntimeException )
//STRIP001 {
//STRIP001 	INetURLObject aObj( aURL.Complete );
//STRIP001 	aURL.Protocol = INetURLObject::GetScheme( aObj.GetProtocol() );
//STRIP001 	aURL.User = aObj.GetUser( INetURLObject::NO_DECODE );
//STRIP001 	aURL.Password = aObj.GetPass( INetURLObject::NO_DECODE );
//STRIP001 	aURL.Server = aObj.GetHost( INetURLObject::NO_DECODE );
//STRIP001 	aURL.Port = aObj.GetPort();
//STRIP001 	aURL.Path = aObj.GetURLPath( INetURLObject::NO_DECODE );
//STRIP001 //	aURL.Name = StringToOUString( aObj.GetName(), CHARSET_SYSTEM );
//STRIP001 	aURL.Arguments = aObj.GetParam( INetURLObject::NO_DECODE );
//STRIP001 	aURL.Mark = aObj.GetMark( INetURLObject::NO_DECODE );
//STRIP001 	aObj.SetMark( String() );
//STRIP001 	aObj.SetParam( String() );
//STRIP001 	aURL.Main = aObj.GetMainURL( INetURLObject::NO_DECODE );
//STRIP001 	return sal_True;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool SfxURLTransformer::parseSmart( ::com::sun::star::util::URL& aURL, const ::rtl::OUString& aSmartProt ) throw ( ::com::sun::star::uno::RuntimeException )
//STRIP001 {
//STRIP001 	String aProt( aSmartProt );
//STRIP001     String aSmartURL = so3::StaticBaseUrl::SmartRelToAbs( aURL.Complete );
//STRIP001 	INetURLObject aObj;
//STRIP001 	aObj.SetSmartProtocol( INetURLObject::CompareProtocolScheme( aProt ) );
//STRIP001 	aObj.SetSmartURL( aSmartURL );
//STRIP001 
//STRIP001 	aURL.Protocol = INetURLObject::GetScheme( aObj.GetProtocol() );
//STRIP001 	aURL.User = aObj.GetUser( INetURLObject::NO_DECODE );
//STRIP001 	aURL.Password = aObj.GetPass( INetURLObject::NO_DECODE );
//STRIP001 	aURL.Server = aObj.GetHost( INetURLObject::NO_DECODE );
//STRIP001 	aURL.Port = aObj.GetPort();
//STRIP001 	aURL.Path = aObj.GetURLPath( INetURLObject::NO_DECODE );
//STRIP001 //	aURL.Name = StringToOUString( aObj.GetName(), CHARSET_SYSTEM );
//STRIP001 	aURL.Arguments = aObj.GetParam( INetURLObject::NO_DECODE );
//STRIP001 	aURL.Mark = aObj.GetMark( INetURLObject::NO_DECODE );
//STRIP001 	aObj.SetMark( String() );
//STRIP001 	aObj.SetParam( String() );
//STRIP001 	aURL.Main = aObj.GetMainURL( INetURLObject::NO_DECODE );
//STRIP001 	return sal_True;
//STRIP001 }
//STRIP001 
//STRIP001 sal_Bool SfxURLTransformer::assemble( ::com::sun::star::util::URL& aURL ) throw ( ::com::sun::star::uno::RuntimeException )
//STRIP001 {
//STRIP001 	INetURLObject aObj;
//STRIP001 
//STRIP001 	aObj.ConcatData( INetURLObject::CompareProtocolScheme( aURL.Protocol ),
//STRIP001 					 aURL.User, aURL.Password, aURL.Server,
//STRIP001 					 aURL.Port, aURL.Path );
//STRIP001 
//STRIP001 	// Zun"achst URL ohne Parameter und Mark
//STRIP001 	aURL.Main = aObj.GetMainURL( INetURLObject::NO_DECODE );
//STRIP001 
//STRIP001 	// Dann Parameter und Mark dazu
//STRIP001 	aObj.SetParam( aURL.Arguments );
//STRIP001 	aObj.SetMark( aURL.Mark );
//STRIP001 	aURL.Complete = aObj.GetMainURL( INetURLObject::NO_DECODE );
//STRIP001 
//STRIP001 	return sal_True;
//STRIP001 }
//STRIP001 
//STRIP001 ::rtl::OUString SfxURLTransformer::getPresentation( const ::com::sun::star::util::URL& aURL, sal_Bool bWithPass) throw ( ::com::sun::star::uno::RuntimeException )
//STRIP001 {
//STRIP001 	return aURL.Complete;
//STRIP001 }

}
