/*************************************************************************
 *
 *  $RCSfile: svx_checklbx.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:42:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#ifndef _SHL_HXX //autogen
#include <tools/shl.hxx>
#endif
#pragma hdrstop

#define _SVX_CHECKLBX_CXX

#include "dialogs.hrc"
#include "checklbx.hrc"

#include "checklbx.hxx"
#include "dialmgr.hxx"
namespace binfilter {

// class SvxCheckListBox -------------------------------------------------

//STRIP001 SvxCheckListBox::SvxCheckListBox( Window* pParent, WinBits nWinStyle ) :
//STRIP001 
//STRIP001 	SvTreeListBox( pParent, nWinStyle )
//STRIP001 
//STRIP001 {
//STRIP001 	Init_Impl();
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 SvxCheckListBox::SvxCheckListBox( Window* pParent, const ResId& rResId ) :
//STRIP001 
//STRIP001 	SvTreeListBox( pParent, rResId )
//STRIP001 
//STRIP001 {
//STRIP001 	Init_Impl();
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 SvxCheckListBox::~SvxCheckListBox()
//STRIP001 {
//STRIP001 	delete pCheckButton;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SvxCheckListBox::Init_Impl()
//STRIP001 {
//STRIP001 	pCheckButton = new SvLBoxButtonData( this );
//STRIP001 	EnableCheckButton( pCheckButton );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SvxCheckListBox::InsertEntry( const String& rStr, USHORT nPos )
//STRIP001 {
//STRIP001 	SvTreeListBox::InsertEntry( rStr, NULL, FALSE, nPos );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SvxCheckListBox::RemoveEntry( USHORT nPos )
//STRIP001 {
//STRIP001 	if ( nPos < GetEntryCount() )
//STRIP001 		SvTreeListBox::GetModel()->Remove( GetEntry( nPos ) );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SvxCheckListBox::SelectEntryPos( USHORT nPos, BOOL bSelect )
//STRIP001 {
//STRIP001 	if ( nPos < GetEntryCount() )
//STRIP001 		Select( GetEntry( nPos ), bSelect );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 USHORT SvxCheckListBox::GetSelectEntryPos() const
//STRIP001 {
//STRIP001 	SvLBoxEntry* pEntry = GetCurEntry();
//STRIP001 
//STRIP001 	if ( pEntry )
//STRIP001 		return (USHORT)GetModel()->GetAbsPos( pEntry );
//STRIP001 	return LISTBOX_ENTRY_NOTFOUND;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 String SvxCheckListBox::GetText( USHORT nPos ) const
//STRIP001 {
//STRIP001 	SvLBoxEntry* pEntry = GetEntry( nPos );
//STRIP001 
//STRIP001 	if ( pEntry )
//STRIP001 		return GetEntryText( pEntry );
//STRIP001 	return String();
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 USHORT SvxCheckListBox::GetCheckedEntryCount() const
//STRIP001 {
//STRIP001 	USHORT nCheckCount = 0;
//STRIP001 	USHORT nCount = (USHORT)GetEntryCount();
//STRIP001 
//STRIP001 	for ( USHORT i = 0; i < nCount; ++i )
//STRIP001 	{
//STRIP001 		if ( IsChecked( i ) )
//STRIP001 			nCheckCount++;
//STRIP001 	}
//STRIP001 	return nCheckCount;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SvxCheckListBox::CheckEntryPos( USHORT nPos, BOOL bCheck )
//STRIP001 {
//STRIP001 	if ( nPos < GetEntryCount() )
//STRIP001 		SetCheckButtonState(
//STRIP001 			GetEntry( nPos ), bCheck ? SvButtonState( SV_BUTTON_CHECKED ) :
//STRIP001 									   SvButtonState( SV_BUTTON_UNCHECKED ) );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 BOOL SvxCheckListBox::IsChecked( USHORT nPos ) const
//STRIP001 {
//STRIP001 	if ( nPos < GetEntryCount() )
//STRIP001 		return (GetCheckButtonState( GetEntry( nPos ) ) == SV_BUTTON_CHECKED);
//STRIP001 	else
//STRIP001 		return FALSE;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void* SvxCheckListBox::SetEntryData	( USHORT nPos, void* pNewData )
//STRIP001 {
//STRIP001 	void* pOld = NULL;
//STRIP001 
//STRIP001 	if ( nPos < GetEntryCount() )
//STRIP001 	{
//STRIP001 		pOld = GetEntry( nPos )->GetUserData();
//STRIP001 		GetEntry( nPos )->SetUserData( pNewData );
//STRIP001 	}
//STRIP001 	return pOld;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void* SvxCheckListBox::GetEntryData( USHORT nPos ) const
//STRIP001 {
//STRIP001 	if ( nPos < GetEntryCount() )
//STRIP001 		return GetEntry( nPos )->GetUserData();
//STRIP001 	else
//STRIP001 		return NULL;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SvxCheckListBox::ToggleCheckButton( SvLBoxEntry* pEntry )
//STRIP001 {
//STRIP001     if ( pEntry )
//STRIP001     {
//STRIP001         if ( !IsSelected( pEntry ) )
//STRIP001             Select( pEntry );
//STRIP001         else
//STRIP001             CheckEntryPos( GetSelectEntryPos(), !IsChecked( GetSelectEntryPos() ) );
//STRIP001     }
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SvxCheckListBox::MouseButtonDown( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	if ( rMEvt.IsLeft() )
//STRIP001 	{
//STRIP001 		Point aPnt = rMEvt.GetPosPixel();
//STRIP001 		SvLBoxEntry* pEntry = GetEntry( aPnt );
//STRIP001 
//STRIP001 		if ( pEntry )
//STRIP001 		{
//STRIP001 			BOOL bCheck = ( GetCheckButtonState( pEntry ) == SV_BUTTON_CHECKED );
//STRIP001 			SvLBoxItem* pItem = GetItem( pEntry, aPnt.X() );
//STRIP001 
//STRIP001 			if ( pItem && pItem->IsA() == SV_ITEM_ID_LBOXBUTTON )
//STRIP001 			{
//STRIP001 				SvTreeListBox::MouseButtonDown( rMEvt );
//STRIP001 				Select( pEntry, TRUE );
//STRIP001 				return;
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				ToggleCheckButton( pEntry );
//STRIP001 				SvTreeListBox::MouseButtonDown( rMEvt );
//STRIP001 				if ( bCheck != ( GetCheckButtonState( pEntry ) == SV_BUTTON_CHECKED ) )
//STRIP001 					CheckButtonHdl();
//STRIP001 				return;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	SvTreeListBox::MouseButtonDown( rMEvt );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SvxCheckListBox::KeyInput( const KeyEvent& rKEvt )
//STRIP001 {
//STRIP001 	const KeyCode& rKey = rKEvt.GetKeyCode();
//STRIP001 
//STRIP001 	if ( rKey.GetCode() == KEY_RETURN || rKey.GetCode() == KEY_SPACE )
//STRIP001 	{
//STRIP001 		SvLBoxEntry* pEntry = GetCurEntry();
//STRIP001 
//STRIP001 		if ( pEntry )
//STRIP001 		{
//STRIP001 			BOOL bCheck = ( GetCheckButtonState( pEntry ) == SV_BUTTON_CHECKED );
//STRIP001 			ToggleCheckButton( pEntry );
//STRIP001 			if ( bCheck != ( GetCheckButtonState( pEntry ) == SV_BUTTON_CHECKED ) )
//STRIP001 				CheckButtonHdl();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if ( GetEntryCount() )
//STRIP001 		SvTreeListBox::KeyInput( rKEvt );
//STRIP001 }

}
