/*************************************************************************
 *
 *  $RCSfile: svx_hlmarkwn.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:42:23 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SV_WRKWIN_HXX
#include <vcl/wrkwin.hxx>
#endif
#ifndef _SVX_DIALMGR_HXX
#include <dialmgr.hxx>
#endif
#ifndef _SFXDOCFILE_HXX
#include <bf_sfx2/docfile.hxx>
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif
#ifndef _SV_SETTINGS_HXX
#include <vcl/settings.hxx>
#endif

// UNO-Stuff
#include <comphelper/processfactory.hxx>

#ifndef _COM_SUN_STAR_AWT_XBITMAP_HPP_
#include <com/sun/star/awt/XBitmap.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XDESKTOP_HPP_
#include <com/sun/star/frame/XDesktop.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XDESKTOP_HPP_
#include <com/sun/star/frame/XDesktop.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XCOMPONENTLOADER_HPP_
#include <com/sun/star/frame/XComponentLoader.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif
#ifndef _COM_SUN_STAR_DOCUMENT_XLINKTARGETSUPPLIER_HPP_
#include <com/sun/star/document/XLinkTargetSupplier.hpp>
#endif
#ifndef _COM_SUN_STAR_BEANS_XPROPERTYSET_HPP_
#include <com/sun/star/beans/XPropertySet.hpp>
#endif

#include <toolkit/unohlp.hxx>

#include "dialogs.hrc"
#include "hlmarkwn.hrc"
#include "hlmarkwn.hxx"
#include "hltpbase.hxx"
#ifndef _LEGACYBINFILTERMGR_HXX
#include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
#endif
namespace binfilter {

using namespace ::com::sun::star;
using namespace ::rtl;

/*************************************************************************
|*
|* Userdata-struct for tree-entries
|*
|************************************************************************/

//STRIP001 struct TargetData
//STRIP001 {
//STRIP001 	OUString		aUStrLinkname;
//STRIP001 	BOOL		bIsTarget;
//STRIP001 
//STRIP001 	TargetData ( OUString aUStrLName, BOOL bTarget )
//STRIP001 		:	bIsTarget ( bTarget )
//STRIP001 	{
//STRIP001 		if ( bIsTarget )
//STRIP001 			aUStrLinkname = aUStrLName;
//STRIP001 	}
//STRIP001 };


//########################################################################
//#                                                                      #
//# Tree-Window 														 #
//#                                                                      #
//########################################################################

//STRIP001 SvxHlmarkTreeLBox::SvxHlmarkTreeLBox( Window* pParent, const ResId& rResId )
//STRIP001 : SvTreeListBox	( pParent, rResId ),
//STRIP001   mpParentWnd	( (SvxHlinkDlgMarkWnd*) pParent )
//STRIP001 {
//STRIP001 	SetNodeDefaultImages();
//STRIP001 }

//STRIP001 void SvxHlmarkTreeLBox::Paint( const Rectangle& rRect )
//STRIP001 {
//STRIP001 	if( mpParentWnd->mnError == LERR_NOERROR )
//STRIP001 	{
//STRIP001 		SvTreeListBox::Paint(rRect);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		Erase();
//STRIP001 
//STRIP001 		Rectangle aDrawRect( Point( 0, 0 ), GetSizePixel() );
//STRIP001 
//STRIP001 		String aStrMessage;
//STRIP001 
//STRIP001 		switch( mpParentWnd->mnError )
//STRIP001 		{
//STRIP001 		case LERR_NOENTRIES :
//STRIP001 			aStrMessage = SVX_RESSTR( RID_SVXSTR_HYPDLG_ERR_LERR_NOENTRIES );
//STRIP001 			break;
//STRIP001 		case LERR_DOCNOTOPEN :
//STRIP001 			aStrMessage = SVX_RESSTR( RID_SVXSTR_HYPDLG_ERR_LERR_DOCNOTOPEN );
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		DrawText( aDrawRect, aStrMessage, TEXT_DRAW_LEFT | TEXT_DRAW_MULTILINE | TEXT_DRAW_WORDBREAK );
//STRIP001 	}
//STRIP001 
//STRIP001 }

//########################################################################
//#                                                                      #
//# Window-Class														 #
//#                                                                      #
//########################################################################

/*************************************************************************
|*
|* Contructor / Destructor
|*
|************************************************************************/

//STRIP001 SvxHlinkDlgMarkWnd::SvxHlinkDlgMarkWnd( SvxHyperlinkTabPageBase *pParent )
//STRIP001 :	ModalDialog( (Window*)pParent, SVX_RES ( RID_SVXFLOAT_HYPERLINK_MARKWND ) ),
//STRIP001 	maBtApply( this, ResId (BT_APPLY) ),
//STRIP001 	maBtClose( this, ResId (BT_CLOSE) ),
//STRIP001 	maLbTree ( this, ResId (TLB_MARK) ),
//STRIP001 	mbUserMoved ( FALSE ),
//STRIP001 	mbFirst	    ( TRUE ),
//STRIP001 	mpParent	( pParent ),
//STRIP001 	mnError		( LERR_NOERROR )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	maBtApply.SetClickHdl		( LINK ( this, SvxHlinkDlgMarkWnd, ClickApplyHdl_Impl ) );
//STRIP001 	maBtClose.SetClickHdl		( LINK ( this, SvxHlinkDlgMarkWnd, ClickCloseHdl_Impl ) );
//STRIP001 	maLbTree.SetDoubleClickHdl	( LINK ( this, SvxHlinkDlgMarkWnd, ClickApplyHdl_Impl ) );
//STRIP001 
//STRIP001 	// Tree-ListBox mit Linien versehen
//STRIP001 	maLbTree.SetWindowBits( WinBits( WB_TABSTOP | WB_BORDER | WB_HASLINES |
//STRIP001 							WB_HASBUTTONS |  //WB_HASLINESATROOT |
//STRIP001 							WB_HSCROLL | WB_HASBUTTONSATROOT ) );
//STRIP001 }

//STRIP001 SvxHlinkDlgMarkWnd::~SvxHlinkDlgMarkWnd()
//STRIP001 {
//STRIP001 	ClearTree();
//STRIP001 }

/*************************************************************************
|*
|* Set an errorstatus
|*
|************************************************************************/

//STRIP001 USHORT SvxHlinkDlgMarkWnd::SetError( USHORT nError)
//STRIP001 {
//STRIP001 	USHORT nOldError = mnError;
//STRIP001 	mnError = nError;
//STRIP001 
//STRIP001 	if( mnError != LERR_NOERROR )
//STRIP001 		ClearTree();
//STRIP001 
//STRIP001 	maLbTree.Invalidate();
//STRIP001 
//STRIP001 	return nOldError;
//STRIP001 }

/*************************************************************************
|*
|* Move window
|*
|************************************************************************/

//STRIP001 const BOOL SvxHlinkDlgMarkWnd::MoveTo ( Point aNewPos )
//STRIP001 {
//STRIP001 	if ( !mbUserMoved )
//STRIP001 	{
//STRIP001 		BOOL bOldStatus = mbUserMoved;
//STRIP001 		SetPosPixel ( aNewPos );
//STRIP001 		mbUserMoved = bOldStatus;
//STRIP001 	}
//STRIP001 
//STRIP001 	return mbUserMoved;
//STRIP001 }

//STRIP001 void SvxHlinkDlgMarkWnd::Move ()
//STRIP001 {
//STRIP001 	Window::Move();
//STRIP001 
//STRIP001 	if ( IsReallyVisible() )
//STRIP001 		mbUserMoved = TRUE;
//STRIP001 }

//STRIP001 const BOOL SvxHlinkDlgMarkWnd::ConnectToDialog( BOOL bDoit )
//STRIP001 {
//STRIP001 	BOOL bOldStatus = mbUserMoved;
//STRIP001 
//STRIP001 	mbUserMoved = !bDoit;
//STRIP001 
//STRIP001 	return bOldStatus;
//STRIP001 }

/*************************************************************************
|*
|* Interface to refresh tree
|*
|************************************************************************/

//STRIP001 void SvxHlinkDlgMarkWnd::RefreshTree ( String aStrURL )
//STRIP001 {
//STRIP001     String aEmptyStr;
//STRIP001 	OUString aUStrURL;
//STRIP001 
//STRIP001 	EnterWait();
//STRIP001 
//STRIP001 	ClearTree();
//STRIP001 
//STRIP001 	int nPos = aStrURL.Search ( sal_Unicode('#') );
//STRIP001 
//STRIP001 	if( nPos != 0 )
//STRIP001 		aUStrURL = ::rtl::OUString( aStrURL );
//STRIP001 
//STRIP001 	if( !RefreshFromDoc ( aUStrURL ) )
//STRIP001 		maLbTree.Invalidate();
//STRIP001 
//STRIP001 	if ( nPos != STRING_NOTFOUND )
//STRIP001 	{
//STRIP001 		String aStrMark = aStrURL.Copy ( nPos+1 );
//STRIP001 		SelectEntry ( aStrMark );
//STRIP001 	}
//STRIP001 
//STRIP001 	LeaveWait();
//STRIP001 
//STRIP001 	maStrLastURL = aStrURL;
//STRIP001 }

/*************************************************************************
|*
|* get links from document
|*
|************************************************************************/

//STRIP001 BOOL SvxHlinkDlgMarkWnd::RefreshFromDoc( OUString aURL )
//STRIP001 {
//STRIP001 	mnError = LERR_NOERROR;
//STRIP001 
//STRIP001 	uno::Reference< lang::XMultiServiceFactory > xFactory( ::legacy_binfilters::getLegacyProcessServiceFactory() );
//STRIP001 	if( xFactory.is() )
//STRIP001 	{
//STRIP001 		uno::Reference< frame::XDesktop > xDesktop( xFactory->createInstance( OUString::createFromAscii( "com.sun.star.frame.Desktop" ) ),
//STRIP001 					uno::UNO_QUERY );
//STRIP001 		if( xDesktop.is() )
//STRIP001 		{
//STRIP001 			uno::Reference< lang::XComponent > xComp;
//STRIP001 
//STRIP001 			if( aURL.getLength() )
//STRIP001 			{
//STRIP001 				// load from url
//STRIP001 				uno::Reference< frame::XComponentLoader > xLoader( xDesktop, uno::UNO_QUERY );
//STRIP001 				if( xLoader.is() )
//STRIP001 				{
//STRIP001 					uno::Sequence< beans::PropertyValue > aArg(1);
//STRIP001 					aArg.getArray()[0].Name = OUString::createFromAscii( "Hidden" );
//STRIP001 					aArg.getArray()[0].Value <<= (sal_Bool) TRUE;
//STRIP001 					xComp = xLoader->loadComponentFromURL( aURL, OUString::createFromAscii( "_blank" ), 0,
//STRIP001 						                                   aArg );
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				// the component with user focus ( current document )
//STRIP001 				xComp = xDesktop->getCurrentComponent();
//STRIP001 			}
//STRIP001 
//STRIP001 			if( xComp.is() )
//STRIP001 			{
//STRIP001 				uno::Reference< document::XLinkTargetSupplier > xLTS( xComp, uno::UNO_QUERY );
//STRIP001 
//STRIP001 				if( xLTS.is() )
//STRIP001 				{
//STRIP001 					if( FillTree( xLTS->getLinks() ) == 0 )
//STRIP001 						mnError = LERR_NOENTRIES;
//STRIP001 				}
//STRIP001 				else
//STRIP001 					mnError = LERR_DOCNOTOPEN;
//STRIP001 
//STRIP001 				if ( aURL.getLength() )
//STRIP001 					xComp->dispose();
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				if( aURL.getLength() )
//STRIP001 					mnError=LERR_DOCNOTOPEN;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return (mnError==0);
//STRIP001 }
/*
void SvxHlinkDlgMarkWnd::Error(int nNr)
{
	switch(nNr)
	{
		case 0:
		{
			Rectangle aDrawRect( Point( 0, 0 ), maLbTree.GetSizePixel() );
			//maLbTree.SetTextColor( Color(COL_BLACK) );
			//maLbTree.DrawText( aDrawRect, "Keine Ziele im Dokument vorhanden.", TEXT_DRAW_LEFT);// | TEXT_DRAW_MULTILINE | TEXT_DRAW_WORDBREAK );
			maLbTree.DrawText( Point(0,0), "Keine Ziele im Dokument vorhanden.");
			maLbTree.DrawLine(aDrawRect.TopLeft(), aDrawRect.BottomRight() );
		}
		break;
		case 1:
			Rectangle aDrawRect( Point( 0, 0 ), maLbTree.GetSizePixel() );
			maLbTree.DrawText( aDrawRect, "Das Dokument konnte nicht geffnet werden.", TEXT_DRAW_LEFT | TEXT_DRAW_MULTILINE | TEXT_DRAW_WORDBREAK );
			break;
	}
}
*/
/*************************************************************************
|*
|* Fill Tree-Control
|*
|************************************************************************/

//STRIP001 int SvxHlinkDlgMarkWnd::FillTree( uno::Reference< container::XNameAccess > xLinks, SvLBoxEntry* pParentEntry )
//STRIP001 {
//STRIP001 	int nEntries=0;
//STRIP001 	const uno::Sequence< OUString > aNames( xLinks->getElementNames() );
//STRIP001 	const ULONG nLinks = aNames.getLength();
//STRIP001 	const OUString* pNames = aNames.getConstArray();
//STRIP001 
//STRIP001     BOOL bHighContrast = Application::GetSettings().GetStyleSettings().GetWindowColor().IsDark();
//STRIP001     Color aMaskColor( COL_LIGHTMAGENTA );
//STRIP001 	const OUString aProp_LinkDisplayName( RTL_CONSTASCII_USTRINGPARAM( "LinkDisplayName" ) );
//STRIP001 	const OUString aProp_LinkTarget( RTL_CONSTASCII_USTRINGPARAM( "com.sun.star.document.LinkTarget" ) );
//STRIP001 	const OUString aProp_LinkDisplayBitmap( RTL_CONSTASCII_USTRINGPARAM( "LinkDisplayBitmap" ) );
//STRIP001 	for( ULONG i = 0; i < nLinks; i++ )
//STRIP001 	{
//STRIP001 		uno::Any aAny;
//STRIP001 		OUString aLink( *pNames++ );
//STRIP001 
//STRIP001 		BOOL bError = FALSE;
//STRIP001 		try
//STRIP001 		{
//STRIP001 			aAny = xLinks->getByName( aLink );
//STRIP001 		}
//STRIP001 		catch(const uno::Exception&)
//STRIP001 		{
//STRIP001 			// if the name of the target was invalid (like empty headings)
//STRIP001 			// no object can be provided
//STRIP001 			bError = TRUE;
//STRIP001 		}
//STRIP001 		if(bError)
//STRIP001 			continue;
//STRIP001 
//STRIP001 		uno::Reference< beans::XPropertySet > xTarget;
//STRIP001 
//STRIP001 		if( aAny >>= xTarget )
//STRIP001 		{
//STRIP001 			try
//STRIP001 			{
//STRIP001 				// get name to display
//STRIP001 				aAny = xTarget->getPropertyValue( aProp_LinkDisplayName );
//STRIP001 				OUString aDisplayName;
//STRIP001 				aAny >>= aDisplayName;
//STRIP001 				String aStrDisplayname ( aDisplayName );
//STRIP001 
//STRIP001 				// is it a target ?
//STRIP001 				uno::Reference< lang::XServiceInfo > xSI( xTarget, uno::UNO_QUERY );
//STRIP001 				BOOL bIsTarget = xSI->supportsService( aProp_LinkTarget );
//STRIP001 
//STRIP001 				// create userdata
//STRIP001 				TargetData *pData = new TargetData ( aLink, bIsTarget );
//STRIP001 
//STRIP001 				SvLBoxEntry* pEntry;
//STRIP001 
//STRIP001 				try
//STRIP001 				{
//STRIP001 					// get bitmap for the tree-entry
//STRIP001 					uno::Any aAny( xTarget->getPropertyValue( aProp_LinkDisplayBitmap ) );
//STRIP001 					uno::Reference< awt::XBitmap > aXBitmap;
//STRIP001 					if( aAny >>= aXBitmap )
//STRIP001 					{
//STRIP001                         Image aBmp( VCLUnoHelper::GetBitmap( aXBitmap ).GetBitmap(), aMaskColor );
//STRIP001                         // insert Displayname into treelist with bitmaps
//STRIP001 						pEntry = maLbTree.InsertEntry ( aStrDisplayname,
//STRIP001                                                         aBmp, aBmp,
//STRIP001 														pParentEntry,
//STRIP001 														FALSE, LIST_APPEND,
//STRIP001 														(void*)pData );
//STRIP001                         maLbTree.SetExpandedEntryBmp( pEntry, aBmp, BMP_COLOR_HIGHCONTRAST );
//STRIP001                         maLbTree.SetCollapsedEntryBmp( pEntry, aBmp, BMP_COLOR_HIGHCONTRAST );
//STRIP001                         nEntries++;
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{
//STRIP001 						// insert Displayname into treelist without bitmaps
//STRIP001 						pEntry = maLbTree.InsertEntry ( aStrDisplayname,
//STRIP001 														pParentEntry,
//STRIP001 														FALSE, LIST_APPEND,
//STRIP001 														(void*)pData );
//STRIP001 						nEntries++;
//STRIP001 					}
//STRIP001 				}
//STRIP001 				catch(const ::com::sun::star::uno::Exception&)
//STRIP001 				{
//STRIP001 					// insert Displayname into treelist without bitmaps
//STRIP001 					pEntry = maLbTree.InsertEntry ( aStrDisplayname,
//STRIP001 													pParentEntry,
//STRIP001 													FALSE, LIST_APPEND,
//STRIP001 													(void*)pData );
//STRIP001 					nEntries++;
//STRIP001 				}
//STRIP001 
//STRIP001 				uno::Reference< document::XLinkTargetSupplier > xLTS( xTarget, uno::UNO_QUERY );
//STRIP001 				if( xLTS.is() )
//STRIP001 					nEntries += FillTree( xLTS->getLinks(), pEntry );
//STRIP001 			}
//STRIP001 			catch(const ::com::sun::star::uno::Exception&)
//STRIP001 			{
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return nEntries;
//STRIP001 }

/*************************************************************************
|*
|* Clear Tree
|*
|************************************************************************/

//STRIP001 void SvxHlinkDlgMarkWnd::ClearTree()
//STRIP001 {
//STRIP001 	SvLBoxEntry* pEntry = maLbTree.First();
//STRIP001 
//STRIP001 	while ( pEntry )
//STRIP001 	{
//STRIP001 		TargetData* pUserData = ( TargetData * ) pEntry->GetUserData();
//STRIP001 		delete pUserData;
//STRIP001 
//STRIP001 		pEntry = maLbTree.Next( pEntry );
//STRIP001 	}
//STRIP001 
//STRIP001 	maLbTree.Clear();
//STRIP001 }

/*************************************************************************
|*
|* Find Entry for Strng
|*
|************************************************************************/

//STRIP001 SvLBoxEntry* SvxHlinkDlgMarkWnd::FindEntry ( String aStrName )
//STRIP001 {
//STRIP001 	BOOL bFound=FALSE;
//STRIP001 	SvLBoxEntry* pEntry = maLbTree.First();
//STRIP001 
//STRIP001 	while ( pEntry && !bFound )
//STRIP001 	{
//STRIP001 		TargetData* pUserData = ( TargetData * ) pEntry->GetUserData ();
//STRIP001 		if ( aStrName == String( pUserData->aUStrLinkname ) )
//STRIP001 			bFound = TRUE;
//STRIP001 		else
//STRIP001 			pEntry = maLbTree.Next( pEntry );
//STRIP001 	}
//STRIP001 
//STRIP001 	return pEntry;
//STRIP001 }

/*************************************************************************
|*
|* Select Entry
|*
|************************************************************************/

//STRIP001 void SvxHlinkDlgMarkWnd::SelectEntry ( String aStrMark )
//STRIP001 {
//STRIP001 	SvLBoxEntry* pEntry = FindEntry ( aStrMark );
//STRIP001 	if ( pEntry )
//STRIP001 	{
//STRIP001 		maLbTree.Select ( pEntry );
//STRIP001 		maLbTree.MakeVisible ( pEntry );
//STRIP001 	}
//STRIP001 }

/*************************************************************************
|*
|* Click on Apply-Button / Doubleclick on item in tree
|*
|************************************************************************/

//STRIP001 IMPL_LINK ( SvxHlinkDlgMarkWnd, ClickApplyHdl_Impl, void *, EMPTYARG )
//STRIP001 {
//STRIP001 	SvLBoxEntry* pEntry = maLbTree.GetCurEntry();
//STRIP001 
//STRIP001 	if ( pEntry )
//STRIP001 	{
//STRIP001 		TargetData *pData = ( TargetData * )pEntry->GetUserData();
//STRIP001 
//STRIP001 		if ( pData->bIsTarget )
//STRIP001 		{
//STRIP001 			String aStrMark ( pData->aUStrLinkname );
//STRIP001 			mpParent->SetMarkStr ( aStrMark );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return( 0L );
//STRIP001 }

/*************************************************************************
|*
|* Click on Close-Button
|*
|************************************************************************/

//STRIP001 IMPL_LINK ( SvxHlinkDlgMarkWnd, ClickCloseHdl_Impl, void *, EMPTYARG )
//STRIP001 {
//STRIP001     Close();
//STRIP001 
//STRIP001 	return( 0L );
//STRIP001 }


}
