/*************************************************************************
 *
 *  $RCSfile: svx_layctrl.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 16:36:36 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#include <string> // HACK: prevent conflict between STLPORT and Workshop headers

//#ifndef _SV_SYSTEM_HXX //autogen
//#include <vcl/system.hxx>
//#endif
// auto strip #ifndef _SV_TOOLBOX_HXX //autogen
// auto strip #include <vcl/toolbox.hxx>
// auto strip #endif
// auto strip #ifndef _SV_BUTTON_HXX //autogen
// auto strip #include <vcl/button.hxx>
// auto strip #endif
#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
#ifndef _SFXAPP_HXX //autogen
#include <bf_sfx2/app.hxx>
#endif
#pragma hdrstop

#include "dialogs.hrc"
#include "layctrl.hxx"
// auto strip #ifndef _SVX_DIALMGR_HXX 
// auto strip #include <dialmgr.hxx>
// auto strip #endif

// auto strip #ifndef INCLUDED_SVTOOLS_COLORCFG_HXX
// auto strip #include <svtools/colorcfg.hxx>
// auto strip #endif
namespace binfilter {


/*N*/ SFX_IMPL_TOOLBOX_CONTROL(SvxTableToolBoxControl,SfxUInt16Item);
/*N*/ SFX_IMPL_TOOLBOX_CONTROL(SvxColumnsToolBoxControl,SfxUInt16Item);

// class TableWindow -----------------------------------------------------

//STRIP001 class TableWindow : public SfxPopupWindow
//STRIP001 {
//STRIP001 private:
//STRIP001 	Color			aLineColor;
//STRIP001 	Color			aHighlightLineColor;
//STRIP001 	Color			aFillColor;
//STRIP001 	Color			aHighlightFillColor;
//STRIP001 	long            nCol;
//STRIP001 	long            nLine;
//STRIP001 	long            nWidth;
//STRIP001 	long            nHeight;
//STRIP001 	long            nMX;
//STRIP001 	long            nMY;
//STRIP001 	long            nTextHeight;
//STRIP001     BOOL            bInitialKeyInput;
//STRIP001     BOOL            m_bMod1;
//STRIP001     ToolBox&        rTbx;
//STRIP001 
//STRIP001     void UpdateSize_Impl( long nNewCol, long nNewLine);
//STRIP001 
//STRIP001 public:
//STRIP001                             TableWindow( USHORT nId, SfxBindings& rBind, ToolBox& rParentTbx );
//STRIP001                             ~TableWindow();
//STRIP001 
//STRIP001     void                    KeyInput( const KeyEvent& rKEvt );
//STRIP001     virtual void            MouseMove( const MouseEvent& rMEvt );
//STRIP001 	virtual void			MouseButtonDown( const MouseEvent& rMEvt );
//STRIP001 	virtual void			MouseButtonUp( const MouseEvent& rMEvt );
//STRIP001 	virtual void    		Paint( const Rectangle& );
//STRIP001 	virtual void    		PopupModeEnd();
//STRIP001 	virtual SfxPopupWindow*	Clone() const;
//STRIP001 
//STRIP001 	USHORT          		GetColCount() const { return (USHORT)nCol; }
//STRIP001 	USHORT          		GetLineCount() const { return (USHORT)nLine; }
//STRIP001 };
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 TableWindow::TableWindow( USHORT nId, SfxBindings& rBind, ToolBox& rParentTbx ) :
//STRIP001 
//STRIP001     SfxPopupWindow( nId, WB_SYSTEMWINDOW, rBind ),
//STRIP001     bInitialKeyInput(TRUE),
//STRIP001     m_bMod1(FALSE),
//STRIP001     rTbx(rParentTbx)
//STRIP001 {
//STRIP001 	const StyleSettings& rStyles = Application::GetSettings().GetStyleSettings();
//STRIP001 	svtools::ColorConfig aColorConfig;
//STRIP001 	aLineColor = Color( aColorConfig.GetColorValue( svtools::FONTCOLOR ).nColor );
//STRIP001 	aHighlightLineColor = rStyles.GetHighlightTextColor();
//STRIP001 	aFillColor = rStyles.GetWindowColor();
//STRIP001 	aHighlightFillColor = rStyles.GetHighlightColor();
//STRIP001 
//STRIP001 	nTextHeight = GetTextHeight()+1;
//STRIP001 	SetBackgroundBrush( Brush( BRUSH_NULL ) );
//STRIP001 	Font aFont = GetFont();
//STRIP001 	aFont.SetColor( aLineColor );
//STRIP001 	aFont.SetFillColor( aFillColor );
//STRIP001 	aFont.SetTransparent( FALSE );
//STRIP001 	SetFont( aFont );
//STRIP001 
//STRIP001 	nCol    = 0;
//STRIP001 	nLine   = 0;
//STRIP001 	nWidth  = 5;
//STRIP001 	nHeight = 5;
//STRIP001 
//STRIP001 	Size aLogicSize = LogicToPixel( Size( 55, 35 ), MapMode( MAP_10TH_MM ) );
//STRIP001 	nMX = aLogicSize.Width();
//STRIP001 	nMY = aLogicSize.Height();
//STRIP001 	SetOutputSizePixel( Size( nMX*nWidth-1, nMY*nHeight-1+nTextHeight ) );
//STRIP001 }
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 TableWindow::~TableWindow()
//STRIP001 {
//STRIP001 }        
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxPopupWindow* TableWindow::Clone() const
//STRIP001 {
//STRIP001     return new TableWindow( GetId(), (SfxBindings&)GetBindings(), rTbx );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void TableWindow::MouseMove( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	SfxPopupWindow::MouseMove( rMEvt );
//STRIP001 	Point aPos = rMEvt.GetPosPixel();
//STRIP001 	Point aMousePos = OutputToScreenPixel( aPos );
//STRIP001 	Point aWinPos = GetPosPixel();
//STRIP001 
//STRIP001 	if ( rMEvt.IsEnterWindow() )
//STRIP001 		CaptureMouse();
//STRIP001 	else if ( aMousePos.X() < aWinPos.X() || aMousePos.Y() < aWinPos.Y() )
//STRIP001 	{
//STRIP001 		nCol = 0;
//STRIP001 		nLine = 0;
//STRIP001 		ReleaseMouse();
//STRIP001 		Invalidate();
//STRIP001 		return;
//STRIP001 	}
//STRIP001 
//STRIP001     long    nNewCol = 0;
//STRIP001 	long    nNewLine = 0;
//STRIP001 
//STRIP001 	if ( aPos.X() > 0 )
//STRIP001 		nNewCol = aPos.X() / nMX + 1;
//STRIP001 	if ( aPos.Y() > 0 )
//STRIP001 		nNewLine = aPos.Y() / nMY + 1;
//STRIP001 
//STRIP001 	if ( nNewCol > 500 )
//STRIP001 		nNewCol = 500;
//STRIP001 	if ( nNewLine > 1000 )
//STRIP001 		nNewLine = 1000;
//STRIP001 
//STRIP001     UpdateSize_Impl( nNewCol, nNewLine);
//STRIP001 
//STRIP001 }
//STRIP001 /* -----------------------------15.05.2002 17:14------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 void TableWindow::UpdateSize_Impl( long nNewCol, long nNewLine)
//STRIP001 {
//STRIP001     Size  aWinSize = GetOutputSizePixel();
//STRIP001     Point aWinPos = GetPosPixel();
//STRIP001     Point aMaxPos = OutputToScreenPixel( GetDesktopRectPixel().BottomRight() );
//STRIP001     if ( (nWidth <= nNewCol) || (nHeight < nNewLine) )
//STRIP001 	{
//STRIP001         long    nOff = 0;
//STRIP001 
//STRIP001 		if ( nWidth <= nNewCol )
//STRIP001 		{
//STRIP001 			nWidth = nNewCol;
//STRIP001 			nWidth++;
//STRIP001 		}
//STRIP001 		if ( nHeight <= nNewLine )
//STRIP001 		{
//STRIP001 			nHeight = nNewLine;
//STRIP001 			nOff = 1;
//STRIP001 		}
//STRIP001 		while ( nWidth > 0 &&
//STRIP001 				(short)(aWinPos.X()+(nMX*nWidth-1)) >= aMaxPos.X()-3 )
//STRIP001 			nWidth--;
//STRIP001 
//STRIP001 		while ( nHeight > 0 &&
//STRIP001 				(short)(aWinPos.Y()+(nMY*nHeight-1+nTextHeight)) >=
//STRIP001 				aMaxPos.Y()-3 )
//STRIP001 			nHeight--;
//STRIP001 
//STRIP001 		if ( nNewCol > nWidth )
//STRIP001 			nNewCol = nWidth;
//STRIP001 
//STRIP001 		if ( nNewLine > nHeight )
//STRIP001 			nNewLine = nHeight;
//STRIP001 
//STRIP001         Size    aWinSize = GetOutputSizePixel();
//STRIP001         Invalidate( Rectangle( 0, aWinSize.Height()-nTextHeight+2-nOff,
//STRIP001 							   aWinSize.Width(), aWinSize.Height() ) );
//STRIP001 		SetOutputSizePixel( Size( nMX*nWidth-1, nMY*nHeight-1+nTextHeight ) );
//STRIP001 	}
//STRIP001     long    nMinCol = 0;
//STRIP001     long    nMaxCol = 0;
//STRIP001     long    nMinLine = 0;
//STRIP001     long    nMaxLine = 0;
//STRIP001     if ( nNewCol < nCol )
//STRIP001 	{
//STRIP001 		nMinCol = nNewCol;
//STRIP001 		nMaxCol = nCol;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		nMinCol = nCol;
//STRIP001 		nMaxCol = nNewCol;
//STRIP001 	}
//STRIP001 	if ( nNewLine < nLine )
//STRIP001 	{
//STRIP001 		nMinLine = nNewLine;
//STRIP001 		nMaxLine = nLine;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		nMinLine = nLine;
//STRIP001 		nMaxLine = nNewLine;
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( (nNewCol != nCol) || (nNewLine != nLine) )
//STRIP001 	{
//STRIP001 		Invalidate( Rectangle( 0, aWinSize.Height()-nTextHeight+2,
//STRIP001 							   aWinSize.Width(), aWinSize.Height() ) );
//STRIP001 
//STRIP001 		if ( nNewCol != nCol )
//STRIP001 		{
//STRIP001 			Invalidate( Rectangle( nMinCol*nMX-1, 0, nMaxCol*nMX+1, nMaxLine*nMY ) );
//STRIP001 			nCol  = nNewCol;
//STRIP001 		}
//STRIP001 		if ( nNewLine != nLine )
//STRIP001 		{
//STRIP001 			Invalidate( Rectangle( 0, nMinLine*nMY-2, nMaxCol*nMX, nMaxLine*nMY+1 ) );
//STRIP001 			nLine = nNewLine;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	Update();
//STRIP001 }
//STRIP001 /* -----------------------------15.05.2002 14:22------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 void TableWindow::KeyInput( const KeyEvent& rKEvt )
//STRIP001 {
//STRIP001     BOOL bHandled = FALSE;
//STRIP001     USHORT nModifier = rKEvt.GetKeyCode().GetModifier();
//STRIP001     USHORT nKey = rKEvt.GetKeyCode().GetCode();
//STRIP001     if(!nModifier)
//STRIP001     {
//STRIP001         if( KEY_UP == nKey || KEY_DOWN == nKey ||
//STRIP001             KEY_LEFT == nKey || KEY_RIGHT == nKey ||
//STRIP001             KEY_ESCAPE == nKey ||KEY_RETURN == nKey )
//STRIP001         {
//STRIP001             bHandled = TRUE;
//STRIP001             long nNewCol = nCol;
//STRIP001             long nNewLine = nLine;
//STRIP001             switch(nKey)
//STRIP001             {
//STRIP001                 case KEY_UP :
//STRIP001                     if(nNewLine > 1)
//STRIP001 					{
//STRIP001                         nNewLine--;
//STRIP001 						break;
//STRIP001 					}
//STRIP001                 //no break;
//STRIP001                 case KEY_ESCAPE:
//STRIP001                     EndPopupMode( FLOATWIN_POPUPMODEEND_CANCEL);
//STRIP001                 break;
//STRIP001                 case KEY_DOWN :
//STRIP001                     nNewLine++;
//STRIP001                 break;
//STRIP001                 case KEY_LEFT :
//STRIP001 
//STRIP001                     if(nNewCol)
//STRIP001                         nNewCol--;
//STRIP001                 break;
//STRIP001                 case KEY_RIGHT :
//STRIP001                     nNewCol++;
//STRIP001                 break;
//STRIP001                 case KEY_RETURN :
//STRIP001                     if(IsMouseCaptured())
//STRIP001                         ReleaseMouse();
//STRIP001                     EndPopupMode(FLOATWIN_POPUPMODEEND_CLOSEALL );
//STRIP001                 break;
//STRIP001             }
//STRIP001             //make sure that a table can initially be created
//STRIP001             if(bInitialKeyInput)
//STRIP001             {
//STRIP001                 bInitialKeyInput = FALSE;
//STRIP001                 if(!nNewLine)
//STRIP001                     nNewLine = 1;
//STRIP001                 if(!nNewCol)
//STRIP001                     nNewCol = 1;
//STRIP001             }
//STRIP001             UpdateSize_Impl( nNewCol, nNewLine);
//STRIP001         }
//STRIP001     }
//STRIP001     else if(KEY_MOD1 == nModifier && KEY_RETURN == nKey)
//STRIP001     {        
//STRIP001         m_bMod1 = TRUE;
//STRIP001         if(IsMouseCaptured())
//STRIP001             ReleaseMouse();
//STRIP001         EndPopupMode(FLOATWIN_POPUPMODEEND_CLOSEALL );
//STRIP001     }
//STRIP001             
//STRIP001     if(!bHandled)
//STRIP001         SfxPopupWindow::KeyInput(rKEvt);
//STRIP001 
//STRIP001 }
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void TableWindow::MouseButtonDown( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	SfxPopupWindow::MouseButtonDown( rMEvt );
//STRIP001 	CaptureMouse();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void TableWindow::MouseButtonUp( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	SfxPopupWindow::MouseButtonUp( rMEvt );
//STRIP001 	ReleaseMouse();
//STRIP001 
//STRIP001 	if ( IsInPopupMode() )
//STRIP001 		EndPopupMode( FLOATWIN_POPUPMODEEND_CLOSEALL );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void TableWindow::Paint( const Rectangle& )
//STRIP001 {
//STRIP001 	long    i;
//STRIP001 	long    nStart;
//STRIP001 	Size    aSize = GetOutputSizePixel();
//STRIP001 
//STRIP001 	SetLineColor();
//STRIP001 	SetFillColor( aHighlightFillColor );
//STRIP001 	DrawRect( Rectangle( 0, 0, nCol*nMX-1, nLine*nMY-1 ) );
//STRIP001 	SetFillColor( aFillColor );
//STRIP001 	DrawRect( Rectangle( nCol*nMX-1, 0,
//STRIP001 						 aSize.Width(), aSize.Height()-nTextHeight+1 ) );
//STRIP001 	DrawRect( Rectangle( 0, nLine*nMY-1,
//STRIP001 						 aSize.Width(), aSize.Height()-nTextHeight+1 ) );
//STRIP001 
//STRIP001 	SetLineColor( aHighlightLineColor );
//STRIP001 	for ( i = 1; i < nCol; i++ )
//STRIP001 		DrawLine( Point( i*nMX-1, 0 ), Point( i*nMX-1, nLine*nMY-1 ) );
//STRIP001 	for ( i = 1; i < nLine; i++ )
//STRIP001 		DrawLine( Point( 0, i*nMY-1 ), Point( nCol*nMX-1, i*nMY-1 ) );
//STRIP001 	SetLineColor( aLineColor );
//STRIP001 	for ( i = 1; i <= nWidth; i++ )
//STRIP001 	{
//STRIP001 		if ( i < nCol )
//STRIP001 			nStart = nLine*nMY-1;
//STRIP001 		else
//STRIP001 			nStart = 0;
//STRIP001 		DrawLine( Point( i*nMX-1, nStart ), Point( i*nMX-1, nHeight*nMY-1 ) );
//STRIP001 	}
//STRIP001 	for ( i = 1; i <= nHeight; i++ )
//STRIP001 	{
//STRIP001 		if ( i < nLine )
//STRIP001 			nStart = nCol*nMX-1;
//STRIP001 		else
//STRIP001 			nStart = 0;
//STRIP001 		DrawLine( Point( nStart, i*nMY-1 ), Point( nWidth*nMX-1, i*nMY-1 ) );
//STRIP001 	}
//STRIP001 
//STRIP001 	SetLineColor();
//STRIP001 	String aText;
//STRIP001 	if ( nCol && nLine )
//STRIP001 	{
//STRIP001 		aText += String::CreateFromInt32( nCol );
//STRIP001 		aText.AppendAscii( " x " );
//STRIP001 		aText += String::CreateFromInt32( nLine );
//STRIP001         if(GetId() == FN_SHOW_MULTIPLE_PAGES)
//STRIP001         {
//STRIP001             aText += ' ';
//STRIP001             aText += String(SVX_RESSTR(RID_SVXSTR_PAGES));
//STRIP001         }        
//STRIP001 
//STRIP001 	}
//STRIP001 	else
//STRIP001 		aText = Button::GetStandardText( BUTTON_CANCEL );
//STRIP001 	Size aTextSize( GetTextWidth( aText ), GetTextHeight() );
//STRIP001 
//STRIP001 	DrawText( Point( (aSize.Width() - aTextSize.Width()) / 2, aSize.Height() - nTextHeight + 2 ), aText );
//STRIP001 	DrawRect( Rectangle( 0, aSize.Height()-nTextHeight+2, (aSize.Width()-aTextSize.Width())/2-1, aSize.Height() ) );
//STRIP001 	DrawRect( Rectangle( (aSize.Width()-aTextSize.Width())/2+aTextSize.Width(), aSize.Height()-nTextHeight+2, aSize.Width(), aSize.Height() ) );
//STRIP001 
//STRIP001 	SetLineColor( aLineColor );
//STRIP001 	SetFillColor();
//STRIP001 	DrawRect( Rectangle( Point(0,0), aSize ) );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void TableWindow::PopupModeEnd()
//STRIP001 {
//STRIP001 	if ( !IsPopupModeCanceled() && nCol && nLine )
//STRIP001 	{
//STRIP001         Window* pParent = rTbx.GetParent();
//STRIP001         USHORT nId = GetId();
//STRIP001         pParent->UserEvent(SVX_EVENT_COLUM_WINDOW_EXECUTE, (void*)nId);
//STRIP001         SfxUInt16Item aCol( SID_ATTR_TABLE_COLUMN, (UINT16)nCol );
//STRIP001 		SfxUInt16Item aRow( SID_ATTR_TABLE_ROW, (UINT16)nLine );
//STRIP001         SfxUInt16Item aModifier(SID_MODIFIER, m_bMod1 ? KEY_MOD1 : 0);
//STRIP001         GetBindings().GetDispatcher()->Execute(
//STRIP001             GetId(), SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD, &aCol, &aRow, &aModifier, 0L );
//STRIP001 	}
//STRIP001 	else if ( IsPopupModeCanceled() )
//STRIP001 		ReleaseMouse();
//STRIP001 	SfxPopupWindow::PopupModeEnd();
//STRIP001 }
//STRIP001 
//STRIP001 // class ColumnsWindow ---------------------------------------------------
//STRIP001 
//STRIP001 class ColumnsWindow : public SfxPopupWindow
//STRIP001 {
//STRIP001 private:
//STRIP001 	Color			aLineColor;
//STRIP001 	Color			aHighlightLineColor;
//STRIP001 	Color			aFillColor;
//STRIP001 	Color			aHighlightFillColor;
//STRIP001 	long            nCol;
//STRIP001 	long            nWidth;
//STRIP001 	long            nMX;
//STRIP001 	long            nTextHeight;
//STRIP001     BOOL            bInitialKeyInput;
//STRIP001     BOOL            m_bMod1;
//STRIP001     ToolBox&        rTbx;
//STRIP001 
//STRIP001     void UpdateSize_Impl( long nNewCol );
//STRIP001 public:
//STRIP001                             ColumnsWindow( USHORT nId, SfxBindings& rBind, ToolBox& rParentTbx );
//STRIP001 
//STRIP001     void                    KeyInput( const KeyEvent& rKEvt );
//STRIP001     virtual void            MouseMove( const MouseEvent& rMEvt );
//STRIP001 	virtual void			MouseButtonDown( const MouseEvent& rMEvt );
//STRIP001 	virtual void			MouseButtonUp( const MouseEvent& rMEvt );
//STRIP001 	virtual void    		Paint( const Rectangle& );
//STRIP001 	virtual void    		PopupModeEnd();
//STRIP001 	virtual SfxPopupWindow*	Clone() const;
//STRIP001 
//STRIP001 	USHORT          		GetColCount() const { return (USHORT)nCol; }
//STRIP001 };
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 ColumnsWindow::ColumnsWindow( USHORT nId, SfxBindings& rBind,
//STRIP001                             ToolBox& rParentTbx ) :
//STRIP001 
//STRIP001     SfxPopupWindow( nId, WB_SYSTEMWINDOW, rBind ),
//STRIP001     bInitialKeyInput(TRUE),
//STRIP001     m_bMod1(FALSE),
//STRIP001     rTbx(rParentTbx)
//STRIP001 
//STRIP001 {
//STRIP001 	const StyleSettings& rStyles = Application::GetSettings().GetStyleSettings();
//STRIP001 	svtools::ColorConfig aColorConfig;
//STRIP001 	aLineColor = Color( aColorConfig.GetColorValue( svtools::FONTCOLOR ).nColor );
//STRIP001 	aHighlightLineColor = rStyles.GetHighlightTextColor();
//STRIP001 	aFillColor = rStyles.GetWindowColor();
//STRIP001 	aHighlightFillColor = rStyles.GetHighlightColor();
//STRIP001 
//STRIP001 	nTextHeight = GetTextHeight()+1;
//STRIP001 	SetBackgroundBrush( Brush( BRUSH_NULL ) );
//STRIP001 	Font aFont( GetFont() );
//STRIP001 	aFont.SetColor( aLineColor );
//STRIP001 	aFont.SetFillColor( aFillColor );
//STRIP001 	aFont.SetTransparent( FALSE );
//STRIP001 	SetFont( aFont );
//STRIP001 
//STRIP001 	nCol        = 0;
//STRIP001 	nWidth      = 4;
//STRIP001 
//STRIP001 	Size aLogicSize = LogicToPixel( Size( 95, 155 ), MapMode( MAP_10TH_MM ) );
//STRIP001 	nMX = aLogicSize.Width();
//STRIP001 	SetOutputSizePixel( Size( nMX*nWidth-1, aLogicSize.Height()+nTextHeight ) );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxPopupWindow* ColumnsWindow::Clone() const
//STRIP001 {
//STRIP001     return new ColumnsWindow( GetId(), (SfxBindings&)GetBindings(), rTbx );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void ColumnsWindow::MouseMove( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	SfxPopupWindow::MouseMove( rMEvt );
//STRIP001 	Point aPos = rMEvt.GetPosPixel();
//STRIP001 	Point aMousePos = OutputToScreenPixel( aPos );
//STRIP001 	Point aWinPos = GetPosPixel();
//STRIP001 
//STRIP001 	if ( rMEvt.IsEnterWindow() )
//STRIP001 		CaptureMouse();
//STRIP001 	else if ( aMousePos.X() < aWinPos.X() || aMousePos.Y() < aWinPos.Y() )
//STRIP001 	{
//STRIP001 		nCol = 0;
//STRIP001 		ReleaseMouse();
//STRIP001 		Invalidate();
//STRIP001 		return;
//STRIP001 	}
//STRIP001 
//STRIP001     long    nNewCol = 0;
//STRIP001     if ( aPos.X() > 0 )
//STRIP001 		nNewCol = aPos.X() / nMX + 1;
//STRIP001     if ( aPos.Y() < 0 )
//STRIP001 		nNewCol = 0;
//STRIP001     if ( nNewCol > 20 )
//STRIP001 		nNewCol = 20;
//STRIP001     UpdateSize_Impl( nNewCol );
//STRIP001 }
//STRIP001 /* -----------------------------21.05.2002 16:16------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 void ColumnsWindow::UpdateSize_Impl( long nNewCol )
//STRIP001 {
//STRIP001     Size    aWinSize = GetOutputSizePixel();
//STRIP001     long    nMinCol = 0;
//STRIP001 	long    nMaxCol = 0;
//STRIP001     Point aWinPos = GetPosPixel();
//STRIP001 
//STRIP001 	if ( nWidth <= nNewCol )
//STRIP001 	{
//STRIP001 		Point aMaxPos = OutputToScreenPixel( GetDesktopRectPixel().BottomRight() );
//STRIP001 
//STRIP001 		if ( nWidth <= nNewCol )
//STRIP001 		{
//STRIP001 			nWidth = nNewCol;
//STRIP001 			nWidth++;
//STRIP001 		}
//STRIP001 
//STRIP001 		while ( nWidth > 0 &&
//STRIP001 				(short)(aWinPos.X()+(nMX*nWidth-1)) >= aMaxPos.X()-3 )
//STRIP001 			nWidth--;
//STRIP001 
//STRIP001 		if ( nNewCol > nWidth )
//STRIP001 			nNewCol = nWidth;
//STRIP001 
//STRIP001 		Invalidate( Rectangle( 0, aWinSize.Height()-nTextHeight+2,
//STRIP001 							   aWinSize.Width(), aWinSize.Height() ) );
//STRIP001 		SetOutputSizePixel( Size( nMX*nWidth-1, aWinSize.Height() ) );
//STRIP001 	}
//STRIP001 
//STRIP001 
//STRIP001 	if ( nNewCol != nCol )
//STRIP001 	{
//STRIP001 		Invalidate( Rectangle( 0, aWinSize.Height()-nTextHeight+2,
//STRIP001 							   aWinSize.Width(), aWinSize.Height() ) );
//STRIP001 
//STRIP001 		if ( nNewCol < nCol )
//STRIP001 		{
//STRIP001 			nMinCol = nNewCol;
//STRIP001 			nMaxCol = nCol;
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			nMinCol = nCol;
//STRIP001 			nMaxCol = nNewCol;
//STRIP001 		}
//STRIP001 
//STRIP001 		Invalidate( Rectangle( nMinCol*nMX-1, 0,
//STRIP001 							   nMaxCol*nMX+1, aWinSize.Height()-nTextHeight+2 ) );
//STRIP001 		nCol  = nNewCol;
//STRIP001 	}
//STRIP001 	Update();
//STRIP001 }
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void ColumnsWindow::MouseButtonDown( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	SfxPopupWindow::MouseButtonDown( rMEvt );
//STRIP001 	CaptureMouse();
//STRIP001 }
//STRIP001 /* -----------------------------21.05.2002 16:11------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 void ColumnsWindow::KeyInput( const KeyEvent& rKEvt )
//STRIP001 {
//STRIP001     BOOL bHandled = FALSE;
//STRIP001     USHORT nModifier = rKEvt.GetKeyCode().GetModifier();
//STRIP001     USHORT nKey = rKEvt.GetKeyCode().GetCode();
//STRIP001     if(!nModifier)
//STRIP001     {
//STRIP001         if( KEY_LEFT == nKey || KEY_RIGHT == nKey ||
//STRIP001             KEY_RETURN == nKey ||KEY_ESCAPE == nKey ||
//STRIP001             KEY_UP == nKey)
//STRIP001         {
//STRIP001             bHandled = TRUE;
//STRIP001             long nNewCol = nCol;
//STRIP001             switch(nKey)
//STRIP001             {
//STRIP001                 case KEY_LEFT :
//STRIP001                     if(nNewCol)
//STRIP001                         nNewCol--;
//STRIP001                 break;
//STRIP001                 case KEY_RIGHT :
//STRIP001                     nNewCol++;
//STRIP001                 break;
//STRIP001                 case KEY_RETURN :
//STRIP001                     if(IsMouseCaptured())
//STRIP001                         ReleaseMouse();
//STRIP001                     EndPopupMode(FLOATWIN_POPUPMODEEND_CLOSEALL );
//STRIP001                 break;
//STRIP001                 case KEY_ESCAPE :
//STRIP001                 case KEY_UP :
//STRIP001                     EndPopupMode( FLOATWIN_POPUPMODEEND_CANCEL);
//STRIP001                 break;
//STRIP001             }
//STRIP001             //make sure that a table can initially be created
//STRIP001             if(bInitialKeyInput)
//STRIP001             {
//STRIP001                 bInitialKeyInput = FALSE;
//STRIP001                 if(!nNewCol)
//STRIP001                     nNewCol = 1;
//STRIP001             }
//STRIP001             UpdateSize_Impl( nNewCol );
//STRIP001         }
//STRIP001     }
//STRIP001     else if(KEY_MOD1 == nModifier && KEY_RETURN == nKey)
//STRIP001     {        
//STRIP001         m_bMod1 = TRUE;
//STRIP001         if(IsMouseCaptured())
//STRIP001             ReleaseMouse();
//STRIP001         EndPopupMode(FLOATWIN_POPUPMODEEND_CLOSEALL );
//STRIP001     }
//STRIP001     if(!bHandled)
//STRIP001         SfxPopupWindow::KeyInput(rKEvt);
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void ColumnsWindow::MouseButtonUp( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	SfxPopupWindow::MouseButtonUp( rMEvt );
//STRIP001 	ReleaseMouse();
//STRIP001 
//STRIP001 	if ( IsInPopupMode() )
//STRIP001 		EndPopupMode( FLOATWIN_POPUPMODEEND_CLOSEALL );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void ColumnsWindow::Paint( const Rectangle& )
//STRIP001 {
//STRIP001 	long    i;
//STRIP001 	long    j;
//STRIP001 	long    nLineWidth;
//STRIP001 	Size    aSize = GetOutputSizePixel();
//STRIP001 
//STRIP001 	for ( i = 0; i < nWidth; i++ )
//STRIP001 	{
//STRIP001 		if ( i < nCol )
//STRIP001 		{
//STRIP001 			SetLineColor( aHighlightLineColor );
//STRIP001 			SetFillColor( aHighlightFillColor );
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			SetLineColor( aLineColor );
//STRIP001 			SetFillColor( aFillColor );
//STRIP001 		}
//STRIP001 
//STRIP001 		DrawRect( Rectangle( i*nMX-1, -1,
//STRIP001 							 i*nMX+nMX, aSize.Height()-nTextHeight+1 ) );
//STRIP001 
//STRIP001 		j = 4;
//STRIP001 		while ( j < aSize.Height()-nTextHeight-4 )
//STRIP001 		{
//STRIP001 			if ( !(j % 16) )
//STRIP001 				nLineWidth = 10;
//STRIP001 			else
//STRIP001 				nLineWidth = 4;
//STRIP001 			DrawLine( Point( i*nMX+4, j ), Point( i*nMX+nMX-nLineWidth-4, j ) );
//STRIP001 			j += 4;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	SetLineColor();
//STRIP001 	SetFillColor( aFillColor );
//STRIP001 	String aText;
//STRIP001 	if ( nCol )
//STRIP001 		aText = String( String::CreateFromInt32(nCol) );
//STRIP001 	else
//STRIP001 		aText = Button::GetStandardText( BUTTON_CANCEL );
//STRIP001 	Size aTextSize(GetTextWidth( aText ), GetTextHeight());
//STRIP001 	DrawText( Point( ( aSize.Width() - aTextSize.Width() ) / 2, aSize.Height() - nTextHeight + 2 ), aText );
//STRIP001 
//STRIP001 	DrawRect( Rectangle( 0, aSize.Height()-nTextHeight+2, (aSize.Width()-aTextSize.Width())/2-1, aSize.Height() ) );
//STRIP001 	DrawRect( Rectangle( (aSize.Width()-aTextSize.Width())/2+aTextSize.Width(), aSize.Height()-nTextHeight+2, aSize.Width(), aSize.Height() ) );
//STRIP001 
//STRIP001 	SetLineColor( aLineColor );
//STRIP001 	SetFillColor();
//STRIP001 	DrawRect( Rectangle( Point(0,0), aSize ) );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void ColumnsWindow::PopupModeEnd()
//STRIP001 {
//STRIP001 	if ( !IsPopupModeCanceled() && nCol )
//STRIP001 	{
//STRIP001         USHORT nId = GetId();
//STRIP001         Window* pParent = rTbx.GetParent();
//STRIP001         pParent->UserEvent(SVX_EVENT_COLUM_WINDOW_EXECUTE, (void*)nId);
//STRIP001 
//STRIP001         SfxUInt16Item aCol( SID_ATTR_COLUMNS, (UINT16)nCol );
//STRIP001         SfxUInt16Item aModifier(SID_MODIFIER, m_bMod1 ? KEY_MOD1 : 0);
//STRIP001         GetBindings().GetDispatcher()->Execute(
//STRIP001             nId, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD, &aCol, &aModifier, 0L );
//STRIP001 	}
//STRIP001 	else if ( IsPopupModeCanceled() )
//STRIP001 		ReleaseMouse();
//STRIP001 	SfxPopupWindow::PopupModeEnd();
//STRIP001 }
//STRIP001 
//STRIP001 // class SvxTableToolBoxControl ------------------------------------------
//STRIP001 
/*?*/ SvxTableToolBoxControl::SvxTableToolBoxControl( USHORT nId, ToolBox& rTbx,
/*?*/ 												SfxBindings& rBind ) :
/*?*/ 
/*?*/ 	SfxToolBoxControl( nId, rTbx, rBind ),
/*?*/ 
/*?*/ 	bEnabled( TRUE )
/*?*/ 
/*?*/ {
/*?*/ }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SvxTableToolBoxControl::~SvxTableToolBoxControl()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxPopupWindowType SvxTableToolBoxControl::GetPopupWindowType() const
//STRIP001 {
//STRIP001 	return SFX_POPUPWINDOW_ONTIMEOUTANDMOVE;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxPopupWindow* SvxTableToolBoxControl::CreatePopupWindow()
//STRIP001 {
//STRIP001 	if ( bEnabled )
//STRIP001 	{
//STRIP001         ToolBox& rTbx = GetToolBox();
//STRIP001         TableWindow* pWin = new TableWindow( GetId(), GetBindings(), rTbx );
//STRIP001         pWin->StartPopupMode( &rTbx, FLOATWIN_POPUPMODE_GRABFOCUS|FLOATWIN_POPUPMODE_NOKEYCLOSE );
//STRIP001 		return pWin;
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxPopupWindow* SvxTableToolBoxControl::CreatePopupWindowCascading()
//STRIP001 {
//STRIP001 	if ( bEnabled )
//STRIP001         return new TableWindow( GetId(), GetBindings(), GetToolBox() );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void SvxTableToolBoxControl::StateChanged(
//STRIP001 
//STRIP001 	USHORT nSID, SfxItemState eState, const SfxPoolItem* pState )
//STRIP001 
//STRIP001 {
//STRIP001 	if ( pState && pState->ISA(SfxUInt16Item) )
//STRIP001 		bEnabled = FALSE;
//STRIP001 	else
//STRIP001 		bEnabled = SFX_ITEM_DISABLED != eState;
//STRIP001 
//STRIP001 	USHORT nId = GetId();
//STRIP001 	ToolBox& rTbx = GetToolBox();
//STRIP001 
//STRIP001 	rTbx.EnableItem( nId, SFX_ITEM_DISABLED != eState );
//STRIP001 	rTbx.SetItemState( nId,
//STRIP001 		( SFX_ITEM_DONTCARE == eState )	? STATE_DONTKNOW : STATE_NOCHECK );
//STRIP001 }
//STRIP001 
//STRIP001 // class SvxColumnsToolBoxControl ------------------------------------------
//STRIP001 
/*?*/ SvxColumnsToolBoxControl::SvxColumnsToolBoxControl( USHORT nId, ToolBox& rTbx,
/*?*/ 													SfxBindings& rBind ):
/*?*/ 
/*?*/ 	SfxToolBoxControl( nId, rTbx, rBind )
/*?*/ {
/*?*/ }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SvxColumnsToolBoxControl::~SvxColumnsToolBoxControl()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxPopupWindowType SvxColumnsToolBoxControl::GetPopupWindowType() const
//STRIP001 {
//STRIP001 	return SFX_POPUPWINDOW_ONTIMEOUTANDMOVE;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxPopupWindow* SvxColumnsToolBoxControl::CreatePopupWindow()
//STRIP001 {
//STRIP001 	ColumnsWindow* pWin = 0;
//STRIP001 	if(bEnabled)
//STRIP001 	{
//STRIP001         pWin = new ColumnsWindow( GetId(), GetBindings(), GetToolBox() );
//STRIP001         pWin->StartPopupMode( &GetToolBox(), 
//STRIP001                     FLOATWIN_POPUPMODE_GRABFOCUS|FLOATWIN_POPUPMODE_NOKEYCLOSE );
//STRIP001 	}
//STRIP001 	return pWin;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxPopupWindow* SvxColumnsToolBoxControl::CreatePopupWindowCascading()
//STRIP001 {
//STRIP001 	ColumnsWindow* pWin = 0;
//STRIP001 	if(bEnabled)
//STRIP001 	{
//STRIP001         pWin = new ColumnsWindow( GetId(), GetBindings(), GetToolBox() );
//STRIP001 	}
//STRIP001 	return pWin;
//STRIP001 }
//STRIP001 /* -----------------18.11.99 16:38-------------------
//STRIP001 
//STRIP001  --------------------------------------------------*/
//STRIP001 void SvxColumnsToolBoxControl::StateChanged( USHORT nSID,
//STRIP001 											  SfxItemState eState,
//STRIP001 											  const SfxPoolItem* pState )
//STRIP001 {
//STRIP001 	bEnabled = SFX_ITEM_DISABLED != eState;
//STRIP001 	SfxToolBoxControl::StateChanged(nSID,	eState, pState );
//STRIP001 }
//STRIP001 
}
