/*************************************************************************
 *
 *  $RCSfile: svx_tbxdraw.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 16:38:06 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#include <string> // HACK: prevent conflict between STLPORT and Workshop headers

// auto strip #ifndef _SFXINTITEM_HXX
// auto strip #include <svtools/intitem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXENUMITEM_HXX
// auto strip #include <svtools/eitem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWSH_HXX
// auto strip #include <bf_sfx2/viewsh.hxx>
// auto strip #endif

#pragma hdrstop

#ifndef _SVTOOLS_IMGDEF_HXX
#include <svtools/imgdef.hxx>
#endif

// auto strip #include "tbxdraw.hxx"
// auto strip #include "tbxctl.hxx"
#include "tbxdraw.hrc"
namespace binfilter {

/*************************************************************************
|*
|*	SvxPopupWindowTbxMgr::Ctor()
|*
\************************************************************************/

//STRIP001 SvxPopupWindowTbxMgr::SvxPopupWindowTbxMgr
//STRIP001 (
//STRIP001 	USHORT nId,
//STRIP001 	SfxToolBoxControl* pTbxCtl,
//STRIP001 	ResId aRIdWin,
//STRIP001 	ResId aRIdTbx,
//STRIP001 	SfxBindings& rBindings
//STRIP001 ) :
//STRIP001 
//STRIP001 	SfxPopupWindow( nId, aRIdWin, rBindings ),
//STRIP001 
//STRIP001 	aTbx		( this, GetBindings(), aRIdTbx ),
//STRIP001 	aRIdWinTemp	( aRIdWin ),
//STRIP001 	aRIdTbxTemp	( aRIdTbx )
//STRIP001 
//STRIP001 {
//STRIP001 	aTbx.UseDefault();
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	if ( pTbxCtl && pTbxCtl->GetToolBox().IsHorizontal() )
//STRIP001 	{
//STRIP001 	   aTbx.GetToolBox().SetAlign( WINDOWALIGN_LEFT );
//STRIP001 	   SetText( String() );
//STRIP001 	}
//STRIP001 
//STRIP001 	Size aSize = aTbx.CalcWindowSizePixel();
//STRIP001 	aTbx.SetPosSizePixel( Point(), aSize );
//STRIP001 	SetOutputSizePixel( aSize );
//STRIP001 	aTbx.GetToolBox().SetSelectHdl(
//STRIP001 		LINK( this, SvxPopupWindowTbxMgr, TbxSelectHdl ) );
//STRIP001 	aTbxClickHdl = aTbx.GetToolBox().GetClickHdl();
//STRIP001 	aTbx.GetToolBox().SetClickHdl(
//STRIP001 		LINK( this, SvxPopupWindowTbxMgr, TbxClickHdl ) );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SvxPopupWindowTbxMgr::SvxPopupWindowTbxMgr
//STRIP001 (
//STRIP001 	USHORT nId,
//STRIP001 	WindowAlign eAlign,
//STRIP001 	ResId aRIdWin,
//STRIP001 	ResId aRIdTbx,
//STRIP001 	SfxBindings& rBindings
//STRIP001 ) :
//STRIP001 
//STRIP001 	SfxPopupWindow( nId, aRIdWin, rBindings),
//STRIP001 
//STRIP001 	aTbx		( this, GetBindings(), aRIdTbx ),
//STRIP001 	aRIdWinTemp	( aRIdWin ),
//STRIP001 	aRIdTbxTemp	( aRIdTbx )
//STRIP001 
//STRIP001 {
//STRIP001 	aTbx.UseDefault();
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aTbx.GetToolBox().SetAlign( eAlign );
//STRIP001 	if ( eAlign == WINDOWALIGN_LEFT )
//STRIP001 	   SetText( String() );
//STRIP001 
//STRIP001 	Size aSize = aTbx.CalcWindowSizePixel();
//STRIP001 	aTbx.SetPosSizePixel( Point(), aSize );
//STRIP001 	SetOutputSizePixel( aSize );
//STRIP001 	aTbx.GetToolBox().SetSelectHdl(
//STRIP001 		LINK( this, SvxPopupWindowTbxMgr, TbxSelectHdl ) );
//STRIP001 	aTbxClickHdl = aTbx.GetToolBox().GetClickHdl();
//STRIP001 	aTbx.GetToolBox().SetClickHdl(
//STRIP001 		LINK( this, SvxPopupWindowTbxMgr, TbxClickHdl ) );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	SvxPopupWindowTbxMgr::Dtor()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SvxPopupWindowTbxMgr::~SvxPopupWindowTbxMgr()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	SvxPopupWindowTbxMgr::Clone()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SfxPopupWindow* SvxPopupWindowTbxMgr::Clone() const
//STRIP001 {
//STRIP001 	return new SvxPopupWindowTbxMgr( GetId(),
//STRIP001 									 aTbx.GetToolBox().GetAlign(),
//STRIP001 									 aRIdWinTemp,
//STRIP001 									 aRIdTbxTemp,
//STRIP001 									 (SfxBindings&)GetBindings() );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	SvxPopupWindowTbxMgr::PopupModeEnd()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SvxPopupWindowTbxMgr::PopupModeEnd()
//STRIP001 {
//STRIP001 	aTbx.GetToolBox().EndSelection();
//STRIP001 	SfxPopupWindow::PopupModeEnd();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	SvxPopupWindowTbxMgr::StartSelection()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SvxPopupWindowTbxMgr::StartSelection()
//STRIP001 {
//STRIP001 	aTbx.GetToolBox().StartSelection();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	SvxPopupWindowTbxMgr::TbxSelectHdl()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK( SvxPopupWindowTbxMgr, TbxSelectHdl, ToolBox*, pBox )
//STRIP001 {
//STRIP001     USHORT nLastSlotId = pBox->GetCurItemId();
//STRIP001     UserEvent(SVX_EVENT_COLUM_WINDOW_EXECUTE, (void*)nLastSlotId);
//STRIP001 
//STRIP001 	if ( IsInPopupMode() )
//STRIP001 		EndPopupMode();
//STRIP001 
//STRIP001 	GetBindings().GetDispatcher()->Execute( nLastSlotId,
//STRIP001                     SFX_CALLMODE_SLOT|SFX_CALLMODE_RECORD, NULL, pBox->GetModifier() );
//STRIP001 
//STRIP001 	if ( pBox->GetModifier() & KEY_MOD1 )
//STRIP001 	{
//STRIP001 		//	#99013# if selected with control key, return focus to current view
//STRIP001 		Window* pShellWnd = SfxViewShell::Current()->GetWindow();
//STRIP001 		if ( pShellWnd )
//STRIP001 			pShellWnd->GrabFocus();
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	SvxPopupWindowTbxMgr::TbxClickHdl()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK( SvxPopupWindowTbxMgr, TbxClickHdl, ToolBox*, pBox )
//STRIP001 {
//STRIP001     USHORT nCurId = pBox->GetCurItemId();
//STRIP001     UserEvent(SVX_EVENT_COLUM_WINDOW_EXECUTE, (void*)nCurId);
//STRIP001     if ( aTbxClickHdl.IsSet() )
//STRIP001 		aTbxClickHdl.Call( pBox );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	SvxPopupWindowTbxMgr::StateChanged()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SvxPopupWindowTbxMgr::StateChanged( USHORT nSID, SfxItemState eState,
//STRIP001 										 const SfxPoolItem* pState )
//STRIP001 {
//STRIP001 	if ( nSID == SID_INSERT_DRAW )
//STRIP001 	{
//STRIP001 		USHORT nActive = 0;
//STRIP001 
//STRIP001 		if ( eState == SFX_ITEM_AVAILABLE )
//STRIP001 			nActive = ((SfxEnumItem*)pState)->GetValue();
//STRIP001 
//STRIP001 		ToolBox& rBox = aTbx.GetToolBox();
//STRIP001 		USHORT nCount = rBox.GetItemCount();
//STRIP001 		BOOL bEnable = eState != SFX_ITEM_DISABLED;
//STRIP001 		BOOL bHiContrast = rBox.GetBackground().GetColor().IsDark();
//STRIP001 
//STRIP001 		for ( USHORT i = 0; i < nCount; i++ )
//STRIP001 		{
//STRIP001 			USHORT nId = rBox.GetItemId(i);
//STRIP001 			rBox.CheckItem( nId, ( nId == nActive ) );
//STRIP001 			rBox.EnableItem( nId, bEnable );
//STRIP001 			if ( nId > 0 )
//STRIP001 				rBox.SetItemImage( nId, GetBindings().GetImageManager()->GetImage( nId, bHiContrast ));
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	SfxPopupWindow::StateChanged( nSID, eState, pState );
//STRIP001 }
//STRIP001 /* -----------------------------05.07.01 15:24--------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 void  SvxPopupWindowTbxMgr::UserEvent( ULONG nEvent, void* pEventData )
//STRIP001 {
//STRIP001     // Der Align- und Bezier-Controller tauscht das Image nicht aus
//STRIP001     USHORT nId = GetId();
//STRIP001     if ( nId != SID_OBJECT_ALIGN && nId != SID_INSERT_DRAW )
//STRIP001 	{
//STRIP001         USHORT nCurrentId = (USHORT)(ULONG)pEventData;
//STRIP001         SfxUInt16Item aItem( nId, nCurrentId );
//STRIP001 		GetBindings().GetDispatcher()->Execute( nId, SFX_CALLMODE_SYNCHRON, &aItem, 0L );
//STRIP001 	}
//STRIP001 }
}
