/*************************************************************************
 *
 *  $RCSfile: sw_edglbldc.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 17:20:48 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #ifndef _DOC_HXX
// auto strip #include <doc.hxx>
// auto strip #endif
#ifndef _EDITSH_HXX
#include <editsh.hxx>
#endif
// auto strip #ifndef _PAM_HXX
// auto strip #include <pam.hxx>
// auto strip #endif
// auto strip #ifndef _NDTXT_HXX
// auto strip #include <ndtxt.hxx>
// auto strip #endif
// auto strip #ifndef _DOCARY_HXX
// auto strip #include <docary.hxx>
// auto strip #endif
// auto strip #ifndef _SWWAIT_HXX
// auto strip #include <swwait.hxx>
// auto strip #endif
// auto strip #ifndef _SWUNDO_HXX
// auto strip #include <swundo.hxx>		// fuer die UndoIds
// auto strip #endif
// auto strip #ifndef _SECTION_HXX
// auto strip #include <section.hxx>
// auto strip #endif
// auto strip #ifndef _DOCTXM_HXX
// auto strip #include <doctxm.hxx>
// auto strip #endif
// auto strip #ifndef _EDGLBLDC_HXX
// auto strip #include <edglbldc.hxx>
// auto strip #endif
namespace binfilter {


//STRIP001 SV_IMPL_OP_PTRARR_SORT( SwGlblDocContents, SwGlblDocContentPtr )

//STRIP001 void SwEditShell::SetGlobalDoc( BOOL bFlag )
//STRIP001 {
//STRIP001 	GetDoc()->SetGlobalDoc( bFlag );
//STRIP001 }

//STRIP001 BOOL SwEditShell::IsGlobalDoc() const
//STRIP001 {
//STRIP001 	return GetDoc()->IsGlobalDoc();
//STRIP001 }

//STRIP001 void SwEditShell::SetGlblDocSaveLinks( BOOL bFlag )
//STRIP001 {
//STRIP001 	GetDoc()->SetGlblDocSaveLinks( bFlag );
//STRIP001 	if( !GetDoc()->IsModified() )	// Bug 57028
//STRIP001 		GetDoc()->SetUndoNoResetModified();
//STRIP001 	GetDoc()->SetModified();
//STRIP001 }

//STRIP001 BOOL SwEditShell::IsGlblDocSaveLinks() const
//STRIP001 {
//STRIP001 	return GetDoc()->IsGlblDocSaveLinks();
//STRIP001 }

//STRIP001 USHORT SwEditShell::GetGlobalDocContent( SwGlblDocContents& rArr ) const
//STRIP001 {
//STRIP001 	if( rArr.Count() )
//STRIP001 		rArr.DeleteAndDestroy( 0, rArr.Count() );
//STRIP001 
//STRIP001 	SwDoc* pDoc = GetDoc();
//STRIP001 	if( !pDoc->IsGlobalDoc() )
//STRIP001 		return 0;
//STRIP001 
//STRIP001 	// dann alle gelinkten Bereiche auf der obersten Ebene
//STRIP001 	const SwSectionFmts& rSectFmts = pDoc->GetSections();
//STRIP001 	for( USHORT n = rSectFmts.Count(); n; )
//STRIP001 	{
//STRIP001 		const SwSection* pSect = rSectFmts[ --n ]->GetGlobalDocSection();
//STRIP001 		if( pSect )
//STRIP001 		{
//STRIP001 			SwGlblDocContentPtr pNew;
//STRIP001 			switch( pSect->GetType() )
//STRIP001 			{
//STRIP001 			case TOX_HEADER_SECTION:	break;		// ignore
//STRIP001 			case TOX_CONTENT_SECTION:
//STRIP001 				ASSERT( pSect->ISA( SwTOXBaseSection ), "keine TOXBaseSection!" );
//STRIP001 				pNew = new SwGlblDocContent( (SwTOXBaseSection*)pSect );
//STRIP001 				break;
//STRIP001 
//STRIP001 			default:
//STRIP001 				pNew = new SwGlblDocContent( pSect );
//STRIP001 				break;
//STRIP001 			}
//STRIP001 			if( !rArr.Insert( pNew ) )
//STRIP001 				delete pNew;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// und als letztes die Dummies (sonstiger Text) einfuegen
//STRIP001 	SwNode* pNd;
//STRIP001 	ULONG nSttIdx = pDoc->GetNodes().GetEndOfExtras().GetIndex() + 2;
//STRIP001 	for( n = 0; n < rArr.Count(); ++n )
//STRIP001 	{
//STRIP001 		const SwGlblDocContent& rNew = *rArr[ n ];
//STRIP001 		// suche von StartPos bis rNew.DocPos nach einem Content Node.
//STRIP001 		// Existiert dieser, so muss ein DummyEintrag eingefuegt werden.
//STRIP001 		for( ; nSttIdx < rNew.GetDocPos(); ++nSttIdx )
//STRIP001 			if( ( pNd = pDoc->GetNodes()[ nSttIdx ])->IsCntntNode()
//STRIP001 				|| pNd->IsSectionNode() || pNd->IsTableNode() )
//STRIP001 			{
//STRIP001 				SwGlblDocContentPtr pNew = new SwGlblDocContent( nSttIdx );
//STRIP001 				if( !rArr.Insert( pNew ) )
//STRIP001 					delete pNew;
//STRIP001 				else
//STRIP001 					++n;		// auf die naechste Position
//STRIP001 				break;
//STRIP001 			}
//STRIP001 
//STRIP001 		// StartPosition aufs Ende setzen
//STRIP001 		nSttIdx = pDoc->GetNodes()[ rNew.GetDocPos() ]->EndOfSectionIndex();
//STRIP001 		++nSttIdx;
//STRIP001 	}
//STRIP001 
//STRIP001 	// sollte man das Ende auch noch setzen??
//STRIP001 	if( rArr.Count() )
//STRIP001 	{
//STRIP001 		ULONG nNdEnd = pDoc->GetNodes().GetEndOfContent().GetIndex();
//STRIP001 		for( ; nSttIdx < nNdEnd; ++nSttIdx )
//STRIP001 			if( ( pNd = pDoc->GetNodes()[ nSttIdx ])->IsCntntNode()
//STRIP001 				|| pNd->IsSectionNode() || pNd->IsTableNode() )
//STRIP001 			{
//STRIP001 				SwGlblDocContentPtr pNew = new SwGlblDocContent( nSttIdx );
//STRIP001 				if( !rArr.Insert( pNew ) )
//STRIP001 					delete pNew;
//STRIP001 				break;
//STRIP001 			}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		SwGlblDocContentPtr pNew = new SwGlblDocContent(
//STRIP001 					pDoc->GetNodes().GetEndOfExtras().GetIndex() + 2 );
//STRIP001 		rArr.Insert( pNew );
//STRIP001 	}
//STRIP001 	return rArr.Count();
//STRIP001 }

//STRIP001 BOOL SwEditShell::InsertGlobalDocContent( const SwGlblDocContent& rInsPos,
//STRIP001 											const SwSection& rNew )
//STRIP001 {
//STRIP001 	SwDoc* pDoc = GetDoc();
//STRIP001 	if( !pDoc->IsGlobalDoc() )
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 	StartAllAction();
//STRIP001 
//STRIP001 	SwPaM* pCrsr = GetCrsr();
//STRIP001 	if( pCrsr->GetNext() != pCrsr || IsTableMode() )
//STRIP001 		ClearMark();
//STRIP001 
//STRIP001 	SwPosition& rPos = *pCrsr->GetPoint();
//STRIP001 	rPos.nNode = rInsPos.GetDocPos();
//STRIP001 
//STRIP001 	BOOL bEndUndo = FALSE;
//STRIP001 	SwTxtNode* pTxtNd = pDoc->GetNodes()[ rPos.nNode ]->GetTxtNode();
//STRIP001 	if( pTxtNd )
//STRIP001 		rPos.nContent.Assign( pTxtNd, 0 );
//STRIP001 	else
//STRIP001 	{
//STRIP001 		bEndUndo = TRUE;
//STRIP001 		pDoc->StartUndo( UNDO_START );
//STRIP001 		rPos.nNode--;
//STRIP001 		pDoc->AppendTxtNode( rPos );
//STRIP001 		pCrsr->SetMark();
//STRIP001 	}
//STRIP001 
//STRIP001 	InsertSection( rNew );
//STRIP001 
//STRIP001 	if( bEndUndo )
//STRIP001 		pDoc->EndUndo( UNDO_END );
//STRIP001 	EndAllAction();
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }

//STRIP001 BOOL SwEditShell::InsertGlobalDocContent( const SwGlblDocContent& rInsPos,
//STRIP001 											const SwTOXBase& rTOX )
//STRIP001 {
//STRIP001 	SwDoc* pDoc = GetDoc();
//STRIP001 	if( !pDoc->IsGlobalDoc() )
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 	StartAllAction();
//STRIP001 
//STRIP001 	SwPaM* pCrsr = GetCrsr();
//STRIP001 	if( pCrsr->GetNext() != pCrsr || IsTableMode() )
//STRIP001 		ClearMark();
//STRIP001 
//STRIP001 	SwPosition& rPos = *pCrsr->GetPoint();
//STRIP001 	rPos.nNode = rInsPos.GetDocPos();
//STRIP001 
//STRIP001 	BOOL bEndUndo = FALSE;
//STRIP001 	SwTxtNode* pTxtNd = rPos.nNode.GetNode().GetTxtNode();
//STRIP001 	if( pTxtNd && pTxtNd->GetTxt().Len() && rPos.nNode.GetIndex() + 1 !=
//STRIP001 		pDoc->GetNodes().GetEndOfContent().GetIndex() )
//STRIP001 		rPos.nContent.Assign( pTxtNd, 0 );
//STRIP001 	else
//STRIP001 	{
//STRIP001 		bEndUndo = TRUE;
//STRIP001 		pDoc->StartUndo( UNDO_START );
//STRIP001 		rPos.nNode--;
//STRIP001 		pDoc->AppendTxtNode( rPos );
//STRIP001 	}
//STRIP001 
//STRIP001 	InsertTableOf( rTOX );
//STRIP001 
//STRIP001 	if( bEndUndo )
//STRIP001 		pDoc->EndUndo( UNDO_END );
//STRIP001 	EndAllAction();
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }

//STRIP001 BOOL SwEditShell::InsertGlobalDocContent( const SwGlblDocContent& rInsPos )
//STRIP001 {
//STRIP001 	SwDoc* pDoc = GetDoc();
//STRIP001 	if( !pDoc->IsGlobalDoc() )
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 	StartAllAction();
//STRIP001 
//STRIP001 	SwPaM* pCrsr = GetCrsr();
//STRIP001 	if( pCrsr->GetNext() != pCrsr || IsTableMode() )
//STRIP001 		ClearMark();
//STRIP001 
//STRIP001 	SwPosition& rPos = *pCrsr->GetPoint();
//STRIP001 	rPos.nNode = rInsPos.GetDocPos() - 1;
//STRIP001 	rPos.nContent.Assign( 0, 0 );
//STRIP001 
//STRIP001 	pDoc->AppendTxtNode( rPos );
//STRIP001 	EndAllAction();
//STRIP001 	return TRUE;
//STRIP001 }

//STRIP001 BOOL SwEditShell::DeleteGlobalDocContent( const SwGlblDocContents& rArr ,
//STRIP001 											USHORT nDelPos )
//STRIP001 {
//STRIP001 	SwDoc* pDoc = GetDoc();
//STRIP001 	if( !pDoc->IsGlobalDoc() )
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 	StartAllAction();
//STRIP001 	StartUndo( UNDO_START );
//STRIP001 
//STRIP001 	SwPaM* pCrsr = GetCrsr();
//STRIP001 	if( pCrsr->GetNext() != pCrsr || IsTableMode() )
//STRIP001 		ClearMark();
//STRIP001 
//STRIP001 	SwPosition& rPos = *pCrsr->GetPoint();
//STRIP001 
//STRIP001 	const SwGlblDocContent& rDelPos = *rArr[ nDelPos ];
//STRIP001 	ULONG nDelIdx = rDelPos.GetDocPos();
//STRIP001 	if( 1 == rArr.Count() )
//STRIP001 	{
//STRIP001 		// ein Node muss aber da bleiben!
//STRIP001 		rPos.nNode = nDelIdx - 1;
//STRIP001 		rPos.nContent.Assign( 0, 0 );
//STRIP001 
//STRIP001 		pDoc->AppendTxtNode( rPos );
//STRIP001 		++nDelIdx;
//STRIP001 	}
//STRIP001 
//STRIP001 	switch( rDelPos.GetType() )
//STRIP001 	{
//STRIP001 	case GLBLDOC_UNKNOWN:
//STRIP001 		{
//STRIP001 			rPos.nNode = nDelIdx;
//STRIP001 			pCrsr->SetMark();
//STRIP001 			if( ++nDelPos < rArr.Count() )
//STRIP001 				rPos.nNode = rArr[ nDelPos ]->GetDocPos();
//STRIP001 			else
//STRIP001 				rPos.nNode = pDoc->GetNodes().GetEndOfContent();
//STRIP001 			rPos.nNode--;
//STRIP001 			if( !pDoc->DelFullPara( *pCrsr ) )
//STRIP001 				Delete();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 	case GLBLDOC_TOXBASE:
//STRIP001 		{
//STRIP001 			SwTOXBaseSection* pTOX = (SwTOXBaseSection*)rDelPos.GetTOX();
//STRIP001 			pDoc->DeleteTOX( *pTOX, TRUE );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 	case GLBLDOC_SECTION:
//STRIP001 		{
//STRIP001 			SwSectionFmt* pSectFmt = (SwSectionFmt*)rDelPos.GetSection()->GetFmt();
//STRIP001 			pDoc->DelSectionFmt( pSectFmt, TRUE );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 	EndUndo( UNDO_END );
//STRIP001 	EndAllAction();
//STRIP001 	return TRUE;
//STRIP001 }

//STRIP001 BOOL SwEditShell::MoveGlobalDocContent( const SwGlblDocContents& rArr ,
//STRIP001 										USHORT nFromPos, USHORT nToPos,
//STRIP001 										USHORT nInsPos )
//STRIP001 {
//STRIP001 	SwDoc* pDoc = GetDoc();
//STRIP001 	if( !pDoc->IsGlobalDoc() ||
//STRIP001 		nFromPos >= rArr.Count() || nToPos > rArr.Count() ||
//STRIP001 		nInsPos > rArr.Count() || nFromPos >= nToPos ||
//STRIP001 		( nFromPos <= nInsPos && nInsPos <= nToPos ) )
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 	StartAllAction();
//STRIP001 
//STRIP001 	SwPaM* pCrsr = GetCrsr();
//STRIP001 	if( pCrsr->GetNext() != pCrsr || IsTableMode() )
//STRIP001 		ClearMark();
//STRIP001 
//STRIP001 	SwNodeRange aRg( pDoc->GetNodes(), rArr[ nFromPos ]->GetDocPos() );
//STRIP001 	if( nToPos < rArr.Count() )
//STRIP001 		aRg.aEnd = rArr[ nToPos ]->GetDocPos();
//STRIP001 	else
//STRIP001 		aRg.aEnd = pDoc->GetNodes().GetEndOfContent();
//STRIP001 
//STRIP001 	SwNodeIndex aInsPos( pDoc->GetNodes() );
//STRIP001 	if( nInsPos < rArr.Count() )
//STRIP001 		aInsPos = rArr[ nInsPos ]->GetDocPos();
//STRIP001 	else
//STRIP001 		aInsPos  = pDoc->GetNodes().GetEndOfContent();
//STRIP001 
//STRIP001 	BOOL bRet = pDoc->Move( aRg, aInsPos, DOC_MOVEALLFLYS );
//STRIP001 
//STRIP001 	EndAllAction();
//STRIP001 	return bRet;
//STRIP001 }

//STRIP001 BOOL SwEditShell::GotoGlobalDocContent( const SwGlblDocContent& rPos )
//STRIP001 {
//STRIP001 	SwDoc* pDoc = GetDoc();
//STRIP001 	if( !pDoc->IsGlobalDoc() )
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 	SttCrsrMove();
//STRIP001 
//STRIP001 	SwPaM* pCrsr = GetCrsr();
//STRIP001 	if( pCrsr->GetNext() != pCrsr || IsTableMode() )
//STRIP001 		ClearMark();
//STRIP001 
//STRIP001 	SwPosition& rCrsrPos = *pCrsr->GetPoint();
//STRIP001 	rCrsrPos.nNode = rPos.GetDocPos();
//STRIP001 
//STRIP001 	SwCntntNode* pCNd = pDoc->GetNodes()[ rCrsrPos.nNode ]->GetCntntNode();
//STRIP001 	if( !pCNd )
//STRIP001 		pCNd = pDoc->GetNodes().GoNext( &rCrsrPos.nNode );
//STRIP001 
//STRIP001 	rCrsrPos.nContent.Assign( pCNd, 0 );
//STRIP001 
//STRIP001 	EndCrsrMove();
//STRIP001 	return TRUE;
//STRIP001 }

// erzeuge Anhand der Outlines Teildokumente
//STRIP001 BOOL SwEditShell::GenerateGlobalDoc( const String& rPath,
//STRIP001 								const SwTxtFmtColl* pSplitColl )
//STRIP001 {
//STRIP001 	SwWait aWait( *GetDoc()->GetDocShell(), TRUE );
//STRIP001 	return GetDoc()->GenerateGlobalDoc( rPath, pSplitColl );
//STRIP001 }

/*  */

//STRIP001 SwGlblDocContent::SwGlblDocContent( ULONG nPos )
//STRIP001 {
//STRIP001 	eType = GLBLDOC_UNKNOWN;
//STRIP001 	PTR.pTOX = 0;
//STRIP001 	nDocPos = nPos;
//STRIP001 }

//STRIP001 SwGlblDocContent::SwGlblDocContent( const SwTOXBaseSection* pTOX )
//STRIP001 {
//STRIP001 	eType = GLBLDOC_TOXBASE;
//STRIP001 	PTR.pTOX = pTOX;
//STRIP001 
//STRIP001 	const SwSectionNode* pSectNd = pTOX->GetFmt()->GetSectionNode();
//STRIP001 	nDocPos = pSectNd ? pSectNd->GetIndex() : 0;
//STRIP001 }

//STRIP001 SwGlblDocContent::SwGlblDocContent( const SwSection* pSect )
//STRIP001 {
//STRIP001 	eType = GLBLDOC_SECTION;
//STRIP001 	PTR.pSect = pSect;
//STRIP001 
//STRIP001 	const SwSectionNode* pSectNd = pSect->GetFmt()->GetSectionNode();
//STRIP001 	nDocPos = pSectNd ? pSectNd->GetIndex() : 0;
//STRIP001 }



}
