/*************************************************************************
 *
 *  $RCSfile: sw_fldfunc.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:54:35 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {


//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #ifndef _SFXAPP_HXX //autogen
//STRIP001 #include <bf_sfx2/app.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _BASMGR_HXX //autogen
//STRIP001 #include <basic/basmgr.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _SB_SBSTAR_HXX //autogen
//STRIP001 #include <basic/sbstar.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _SB_SBMOD_HXX //autogen
//STRIP001 #include <basic/sbmod.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _SWDOCSH_HXX //autogen
//STRIP001 #include <docsh.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SWTYPES_HXX
//STRIP001 #include <swtypes.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _GLOBALS_HRC
//STRIP001 #include <globals.hrc>
//STRIP001 #endif
//STRIP001 #ifndef _FLDBAS_HXX
//STRIP001 #include <fldbas.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _DOCUFLD_HXX
//STRIP001 #include <docufld.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _VIEW_HXX
//STRIP001 #include <view.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _WRTSH_HXX
//STRIP001 #include <wrtsh.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SWMODULE_HXX
//STRIP001 #include <swmodule.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FLDFUNC_HXX
//STRIP001 #include <fldfunc.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FLDDROPDOWN_HXX
//STRIP001 #include <flddropdown.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FLDUI_HRC
//STRIP001 #include <fldui.hrc>
//STRIP001 #endif
//STRIP001 #ifndef _FLDTDLG_HRC
//STRIP001 #include <fldtdlg.hrc>
//STRIP001 #endif
//STRIP001 
//STRIP001 #define USER_DATA_VERSION_1 "1"
//STRIP001 #define USER_DATA_VERSION USER_DATA_VERSION_1
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 SwFldFuncPage::SwFldFuncPage(Window* pParent, const SfxItemSet& rCoreSet ) :
//STRIP001 	SwFldPage( pParent, SW_RES( TP_FLD_FUNC ), rCoreSet ),
//STRIP001 
//STRIP001 	aTypeFT		(this, SW_RES(FT_FUNCTYPE)),
//STRIP001 	aTypeLB		(this, SW_RES(LB_FUNCTYPE)),
//STRIP001 	aSelectionFT(this, SW_RES(FT_FUNCSELECTION)),
//STRIP001 	aSelectionLB(this, SW_RES(LB_FUNCSELECTION)),
//STRIP001 	aFormatFT	(this, SW_RES(FT_FUNCFORMAT)),
//STRIP001 	aFormatLB	(this, SW_RES(LB_FUNCFORMAT)),
//STRIP001 	aNameFT		(this, SW_RES(FT_FUNCNAME)),
//STRIP001 	aNameED		(this, SW_RES(ED_FUNCNAME)),
//STRIP001 	aValueFT	(this, SW_RES(FT_FUNCVALUE)),
//STRIP001 	aValueED	(this, SW_RES(ED_FUNCVALUE)),
//STRIP001 	aCond1FT	(this, SW_RES(FT_FUNCCOND1)),
//STRIP001 	aCond1ED	(this, SW_RES(ED_FUNCCOND1)),
//STRIP001 	aCond2FT	(this, SW_RES(FT_FUNCCOND2)),
//STRIP001 	aCond2ED	(this, SW_RES(ED_FUNCCOND2)),
//STRIP001     aMacroBT    (this, SW_RES(BT_FUNCMACRO)),
//STRIP001     aListItemFT(    this, ResId( FT_LISTITEM    )),
//STRIP001     aListItemED(    this, ResId( ED_LISTITEM    )),
//STRIP001     aListAddPB(     this, ResId( PB_LISTADD     )),
//STRIP001     aListItemsFT(   this, ResId( FT_LISTITEMS   )),
//STRIP001     aListItemsLB(   this, ResId( LB_LISTITEMS   )),
//STRIP001     aListRemovePB(  this, ResId( PB_LISTREMOVE  )),
//STRIP001     aListUpPB(      this, ResId( PB_LISTUP      )),
//STRIP001     aListDownPB(    this, ResId( PB_LISTDOWN    )),
//STRIP001     aListNameFT(    this, ResId( FT_LISTNAME    )),
//STRIP001     aListNameED(    this, ResId( ED_LISTNAME    )),
//STRIP001     bDropDownLBChanged(false)
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aNameED.SetPosPixel(Point(aNameED.GetPosPixel().X(), aFormatLB.GetPosPixel().Y()));
//STRIP001 
//STRIP001 	aNameED.SetModifyHdl(LINK(this, SwFldFuncPage, ModifyHdl));
//STRIP001 
//STRIP001 	sOldValueFT = aValueFT.GetText();
//STRIP001 	sOldNameFT = aNameFT.GetText();
//STRIP001 
//STRIP001 	aCond1ED.ShowBrackets(FALSE);
//STRIP001 	aCond2ED.ShowBrackets(FALSE);
//STRIP001 
//STRIP001 //	SwWrtShell* pSh = (SwWrtShell*)ViewShell::GetCurrShell();
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 SwFldFuncPage::~SwFldFuncPage()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 void SwFldFuncPage::Reset(const SfxItemSet& rSet)
//STRIP001 {
//STRIP001 	SavePos(&aTypeLB);
//STRIP001 	Init();	// Allgemeine initialisierung
//STRIP001 
//STRIP001 	aTypeLB.SetUpdateMode(FALSE);
//STRIP001 	aTypeLB.Clear();
//STRIP001 
//STRIP001 	USHORT nPos, nTypeId;
//STRIP001 	BOOL bPage = FALSE;
//STRIP001 
//STRIP001 	if (!IsFldEdit())
//STRIP001 	{
//STRIP001 		// TypeListBox initialisieren
//STRIP001 		const SwFldGroupRgn& rRg = GetFldMgr().GetGroupRange(IsFldDlgHtmlMode(), GetGroup());
//STRIP001 
//STRIP001 		// Typ-Listbox fuellen
//STRIP001 		for(short i = rRg.nStart; i < rRg.nEnd; ++i)
//STRIP001 		{
//STRIP001 			nTypeId = GetFldMgr().GetTypeId(i);
//STRIP001 			nPos = aTypeLB.InsertEntry(GetFldMgr().GetTypeStr(i));
//STRIP001 			aTypeLB.SetEntryData(nPos, (void*)nTypeId);
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		nTypeId = GetCurField()->GetTypeId();
//STRIP001 		nPos = aTypeLB.InsertEntry(GetFldMgr().GetTypeStr(GetFldMgr().GetPos(nTypeId)));
//STRIP001 		aTypeLB.SetEntryData(nPos, (void*)nTypeId);
//STRIP001 
//STRIP001 		if (nTypeId == TYP_MACROFLD)
//STRIP001 		{
//STRIP001 			String sName(GetCurField()->GetPar1());
//STRIP001 			BasicManager *pBasMgr = 0;
//STRIP001 			GetFldMgr().SetMacroModule(0);
//STRIP001 
//STRIP001 			if (sName.GetToken( 0, '.') == SFX_APP()->GetName())
//STRIP001 				pBasMgr = SFX_APP()->GetBasicManager();
//STRIP001 			else
//STRIP001 			{
//STRIP001 				SwWrtShell *pSh = ::GetActiveView()->GetWrtShellPtr();
//STRIP001 				pBasMgr = pSh->GetView().GetDocShell()->GetBasicManager();
//STRIP001 			}
//STRIP001 
//STRIP001 			if (pBasMgr)
//STRIP001 			{
//STRIP001 				String sLibName(sName.GetToken(1, '.'));
//STRIP001 				StarBASIC* pBasic = pBasMgr->GetLib(sLibName);
//STRIP001 
//STRIP001 				if (pBasic)
//STRIP001 				{
//STRIP001 					SbModule* pModule = pBasic->FindModule( sName.GetToken( 2, '.') );
//STRIP001 					GetFldMgr().SetMacroModule(pModule);
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			if (sName.Len())
//STRIP001 			{
//STRIP001 				// Inhalt von sName umdrehen
//STRIP001 				String sBuf;
//STRIP001 				String sTmp;
//STRIP001 				USHORT nPos = 0;
//STRIP001 				USHORT nCount = sName.GetTokenCount('.');
//STRIP001 
//STRIP001 				for (int i = nCount - 1; i >= nCount - 4; i--)
//STRIP001 				{
//STRIP001 					if (i == nCount - 4)
//STRIP001 					{
//STRIP001 						nPos = 0;
//STRIP001 						sName.GetToken(i, '.', nPos);
//STRIP001 						sTmp = sName.Copy(0, nPos - 1);
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{
//STRIP001 						sTmp = sName.GetToken(i, '.');
//STRIP001 						sTmp += '.';
//STRIP001 					}
//STRIP001 
//STRIP001 					sBuf += sTmp;
//STRIP001 				}
//STRIP001 
//STRIP001 				sName = sBuf;
//STRIP001 			}
//STRIP001 
//STRIP001 			GetFldMgr().SetMacroPath(sName);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// alte Pos selektieren
//STRIP001 	RestorePos(&aTypeLB);
//STRIP001 
//STRIP001 	aTypeLB.SetDoubleClickHdl		(LINK(this, SwFldFuncPage, InsertHdl));
//STRIP001 	aTypeLB.SetSelectHdl			(LINK(this, SwFldFuncPage, TypeHdl));
//STRIP001 	aSelectionLB.SetSelectHdl		(LINK(this, SwFldFuncPage, SelectHdl));
//STRIP001 	aSelectionLB.SetDoubleClickHdl	(LINK(this, SwFldFuncPage, InsertMacroHdl));
//STRIP001 	aFormatLB.SetDoubleClickHdl		(LINK(this, SwFldFuncPage, InsertHdl));
//STRIP001 	aMacroBT.SetClickHdl			(LINK(this, SwFldFuncPage, MacroHdl));
//STRIP001     Link aListModifyLk( LINK(this, SwFldFuncPage, ListModifyHdl));
//STRIP001     aListAddPB.SetClickHdl(aListModifyLk);
//STRIP001     aListRemovePB.SetClickHdl(aListModifyLk);
//STRIP001     aListUpPB.SetClickHdl(aListModifyLk);
//STRIP001     aListDownPB.SetClickHdl(aListModifyLk);
//STRIP001     aListItemED.SetReturnActionLink(aListModifyLk);
//STRIP001     Link aListEnableLk = LINK(this, SwFldFuncPage, ListEnableHdl);
//STRIP001     aListItemED.SetModifyHdl(aListEnableLk);
//STRIP001     aListItemsLB.SetSelectHdl(aListEnableLk);
//STRIP001 
//STRIP001 	if( !IsRefresh() )
//STRIP001 	{
//STRIP001 		String sUserData = GetUserData();
//STRIP001 		if(sUserData.GetToken(0, ';').EqualsIgnoreCaseAscii(USER_DATA_VERSION_1))
//STRIP001 		{
//STRIP001 			String sVal = sUserData.GetToken(1, ';');
//STRIP001 			USHORT nVal = sVal.ToInt32();
//STRIP001 			if(nVal != USHRT_MAX)
//STRIP001 			{
//STRIP001 				for(USHORT i = 0; i < aTypeLB.GetEntryCount(); i++)
//STRIP001 					if(nVal == (USHORT)(ULONG)aTypeLB.GetEntryData(i))
//STRIP001 					{
//STRIP001 						aTypeLB.SelectEntryPos(i);
//STRIP001 						break;
//STRIP001 					}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	TypeHdl(0);
//STRIP001 
//STRIP001 	aTypeLB.SetUpdateMode(TRUE);
//STRIP001 
//STRIP001 	if (IsFldEdit())
//STRIP001 	{
//STRIP001 		aNameED.SaveValue();
//STRIP001 		aValueED.SaveValue();
//STRIP001 		aCond1ED.SaveValue();
//STRIP001 		aCond2ED.SaveValue();
//STRIP001 		nOldFormat = GetCurField()->GetFormat();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SwFldFuncPage, TypeHdl, ListBox *, pBox )
//STRIP001 {
//STRIP001 	// Alte ListBoxPos sichern
//STRIP001 	const USHORT nOld = GetTypeSel();
//STRIP001 
//STRIP001 	// Aktuelle ListBoxPos
//STRIP001 	SetTypeSel(aTypeLB.GetSelectEntryPos());
//STRIP001 
//STRIP001 	if(GetTypeSel() == LISTBOX_ENTRY_NOTFOUND)
//STRIP001 	{
//STRIP001 		SetTypeSel(0);
//STRIP001 		aTypeLB.SelectEntryPos(0);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (nOld != GetTypeSel())
//STRIP001 	{
//STRIP001 		USHORT nTypeId = (USHORT)(ULONG)aTypeLB.GetEntryData(GetTypeSel());
//STRIP001 
//STRIP001 		// Auswahl-Listbox fuellen
//STRIP001 		UpdateSubType();
//STRIP001 
//STRIP001 		// Format-Listbox fuellen
//STRIP001 		aFormatLB.Clear();
//STRIP001 
//STRIP001 		USHORT nSize = GetFldMgr().GetFormatCount(nTypeId, FALSE, IsFldDlgHtmlMode());
//STRIP001 
//STRIP001 		for (USHORT i = 0; i < nSize; i++)
//STRIP001 		{
//STRIP001 			USHORT nPos = aFormatLB.InsertEntry(GetFldMgr().GetFormatStr(nTypeId, i));
//STRIP001 			aFormatLB.SetEntryData( nPos, (void*)GetFldMgr().GetFormatId( nTypeId, i ) );
//STRIP001 		}
//STRIP001 
//STRIP001 		if (nSize)
//STRIP001 		{
//STRIP001 			if (IsFldEdit() && nTypeId == TYP_JUMPEDITFLD)
//STRIP001 				aFormatLB.SelectEntry(SW_RESSTR(FMT_MARK_BEGIN + (USHORT)GetCurField()->GetFormat()));
//STRIP001 
//STRIP001 			if (!aFormatLB.GetSelectEntryCount())
//STRIP001 				aFormatLB.SelectEntryPos(0);
//STRIP001 		}
//STRIP001 
//STRIP001 		BOOL bValue = FALSE, bName = FALSE, bMacro = FALSE, bInsert = TRUE;
//STRIP001 		BOOL bShowSelection = FALSE;
//STRIP001 		BOOL bFormat = nSize != 0;
//STRIP001 
//STRIP001 		// fuer Conditional Text zwei Controls
//STRIP001         BOOL bDropDown = TYP_DROPDOWN == nTypeId;
//STRIP001         BOOL bCondTxtFld = TYP_CONDTXTFLD == nTypeId;
//STRIP001         
//STRIP001         aCond1FT.Show(!bDropDown && bCondTxtFld);
//STRIP001         aCond1ED.Show(!bDropDown && bCondTxtFld);
//STRIP001         aCond2FT.Show(!bDropDown && bCondTxtFld);
//STRIP001         aCond2ED.Show(!bDropDown && bCondTxtFld);
//STRIP001         aValueFT.Show(!bDropDown && !bCondTxtFld);
//STRIP001         aValueED.Show(!bDropDown && !bCondTxtFld);
//STRIP001         aMacroBT.Show(!bDropDown);
//STRIP001 		aNameED.Show(!bDropDown);
//STRIP001 
//STRIP001         aListItemFT.Show(bDropDown);
//STRIP001         aListItemED.Show(bDropDown);
//STRIP001         aListAddPB.Show(bDropDown);
//STRIP001         aListItemsFT.Show(bDropDown);
//STRIP001         aListItemsLB.Show(bDropDown);
//STRIP001         aListRemovePB.Show(bDropDown);
//STRIP001         aListUpPB.Show(bDropDown);
//STRIP001         aListDownPB.Show(bDropDown);
//STRIP001         aListNameFT.Show(bDropDown);
//STRIP001         aListNameED.Show(bDropDown);
//STRIP001         
//STRIP001         aNameED.SetDropEnable(FALSE);
//STRIP001 
//STRIP001 		if (IsFldEdit())
//STRIP001 		{
//STRIP001 			if(bDropDown)
//STRIP001 			{
//STRIP001 				const SwDropDownField* pDrop = (const SwDropDownField*)GetCurField();
//STRIP001                 Sequence<OUString> aItems = pDrop->GetItemSequence();
//STRIP001 				const OUString* pArray = aItems.getConstArray();
//STRIP001                 aListItemsLB.Clear();
//STRIP001                 for(sal_Int32 i = 0; i < aItems.getLength(); i++)
//STRIP001                     aListItemsLB.InsertEntry(pArray[i]);
//STRIP001                 aListItemsLB.SelectEntry(pDrop->GetSelectedItem());
//STRIP001                 aListNameED.SetText(pDrop->GetPar2());
//STRIP001 				aListNameED.SaveValue();
//STRIP001                 bDropDownLBChanged = false;
//STRIP001                 ListEnableHdl(0);
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				aNameED.SetText(GetCurField()->GetPar1());
//STRIP001 				aValueED.SetText(GetCurField()->GetPar2());
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aNameED.SetText(aEmptyStr);
//STRIP001 			aValueED.SetText(aEmptyStr);
//STRIP001 		}
//STRIP001 
//STRIP001 		if( aNameFT.GetText() != sOldNameFT )
//STRIP001 			aNameFT.SetText(sOldNameFT);
//STRIP001 		if (aValueFT.GetText() != sOldValueFT)
//STRIP001 			aValueFT.SetText(sOldValueFT);
//STRIP001 
//STRIP001 		switch (nTypeId)
//STRIP001 		{
//STRIP001 			case TYP_MACROFLD:
//STRIP001 				bMacro = TRUE;
//STRIP001 				bShowSelection = TRUE;
//STRIP001 				if (GetFldMgr().GetMacroPath().Len())
//STRIP001 					bValue = TRUE;
//STRIP001 				else
//STRIP001 					bInsert = FALSE;
//STRIP001 
//STRIP001 				aNameFT.SetText(SW_RESSTR(STR_MACNAME));
//STRIP001 				aValueFT.SetText(SW_RESSTR(STR_PROMPT));
//STRIP001 				aNameED.SetText(aSelectionLB.GetSelectEntry());
//STRIP001 				break;
//STRIP001 
//STRIP001 			case TYP_HIDDENPARAFLD:
//STRIP001 				aNameFT.SetText(SW_RESSTR(STR_COND));
//STRIP001 				aNameED.SetDropEnable(TRUE);
//STRIP001 				bName = TRUE;
//STRIP001 				break;
//STRIP001 
//STRIP001 			case TYP_HIDDENTXTFLD:
//STRIP001 				aNameFT.SetText(SW_RESSTR(STR_COND));
//STRIP001 				aNameED.SetDropEnable(TRUE);
//STRIP001 				aValueFT.SetText(SW_RESSTR(STR_INSTEXT));
//STRIP001 				if (!IsFldEdit() )
//STRIP001 					aValueED.SetText(::GetActiveView()->GetWrtShell().GetSelTxt());
//STRIP001 				bName = bValue = TRUE;
//STRIP001 				break;
//STRIP001 
//STRIP001 			case TYP_CONDTXTFLD:
//STRIP001 				aNameFT.SetText(SW_RESSTR(STR_COND));
//STRIP001 				aNameED.SetDropEnable(TRUE);
//STRIP001 				if (IsFldEdit())
//STRIP001 				{
//STRIP001 					aCond1ED.SetText(GetCurField()->GetPar2().GetToken(0, '|'));
//STRIP001 					aCond2ED.SetText(GetCurField()->GetPar2().GetToken(1, '|'));
//STRIP001 				}
//STRIP001 
//STRIP001 				bName = bValue = TRUE;
//STRIP001 				break;
//STRIP001 
//STRIP001 			case TYP_JUMPEDITFLD:
//STRIP001 				aNameFT.SetText(SW_RESSTR(STR_JUMPEDITFLD));
//STRIP001 				aValueFT.SetText(SW_RESSTR(STR_PROMPT));
//STRIP001 				bName = bValue = TRUE;
//STRIP001 				break;
//STRIP001 
//STRIP001 			case TYP_INPUTFLD:
//STRIP001 				aValueFT.SetText(SW_RESSTR(STR_PROMPT));
//STRIP001 				bValue = TRUE;
//STRIP001 				// bShowSelection = TRUE;
//STRIP001 				break;
//STRIP001 
//STRIP001 			case TYP_COMBINED_CHARS:
//STRIP001 				{
//STRIP001 					aNameFT.SetText(SW_RESSTR(STR_COMBCHRS_FT));
//STRIP001 					aNameED.SetDropEnable(TRUE);
//STRIP001 					bName = TRUE;
//STRIP001 
//STRIP001 					const USHORT nLen = aNameED.GetText().Len();
//STRIP001 					if( !nLen || nLen > MAX_COMBINED_CHARACTERS )
//STRIP001 						bInsert = FALSE;
//STRIP001 				}
//STRIP001 				break;
//STRIP001             case TYP_DROPDOWN :
//STRIP001             break;
//STRIP001 			default:
//STRIP001 				break;
//STRIP001 		}
//STRIP001 
//STRIP001 		if (bShowSelection)
//STRIP001 		{
//STRIP001 			aSelectionLB.Show();
//STRIP001 			aSelectionFT.Show();
//STRIP001 			aFormatLB.Hide();
//STRIP001 			aFormatFT.Hide();
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aFormatLB.Show();
//STRIP001 			aFormatFT.Show();
//STRIP001 			aSelectionLB.Hide();
//STRIP001 			aSelectionFT.Hide();
//STRIP001 		}
//STRIP001 
//STRIP001 		aFormatLB.Enable(bFormat);
//STRIP001 		aFormatFT.Enable(bFormat);
//STRIP001 		aNameFT.Enable(bName);
//STRIP001 		aNameED.Enable(bName);
//STRIP001 		aValueFT.Enable(bValue);
//STRIP001 		aValueED.Enable(bValue);
//STRIP001 		aMacroBT.Enable(bMacro);
//STRIP001 
//STRIP001 		EnableInsert( bInsert );
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SwFldFuncPage, SelectHdl, ListBox *, pBox )
//STRIP001 {
//STRIP001 	USHORT nTypeId = (USHORT)(ULONG)aTypeLB.GetEntryData(GetTypeSel());
//STRIP001 
//STRIP001 	if( TYP_MACROFLD == nTypeId )
//STRIP001 		aNameED.SetText( aSelectionLB.GetSelectEntry() );
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SwFldFuncPage, InsertMacroHdl, ListBox *, pBox )
//STRIP001 {
//STRIP001 	SelectHdl();
//STRIP001 	InsertHdl();
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 /* -----------------16.06.2003 16:24-----------------
//STRIP001 
//STRIP001  --------------------------------------------------*/
//STRIP001 IMPL_LINK( SwFldFuncPage, ListModifyHdl, Control*, pControl)
//STRIP001 {
//STRIP001     aListItemsLB.SetUpdateMode(FALSE);
//STRIP001     if(pControl == &aListAddPB ||
//STRIP001             pControl == &aListItemED && aListAddPB.IsEnabled())
//STRIP001     {        
//STRIP001         String sEntry(aListItemED.GetText());
//STRIP001         aListItemsLB.InsertEntry(sEntry);
//STRIP001         aListItemsLB.SelectEntry(sEntry);
//STRIP001     }
//STRIP001     else if(aListItemsLB.GetSelectEntryCount())
//STRIP001     {        
//STRIP001         USHORT nSelPos = aListItemsLB.GetSelectEntryPos();
//STRIP001         if(pControl == &aListRemovePB)
//STRIP001         {        
//STRIP001             aListItemsLB.RemoveEntry(nSelPos);
//STRIP001             aListItemsLB.SelectEntryPos(nSelPos ? nSelPos - 1 : 0);
//STRIP001         }
//STRIP001         else if(pControl == &aListUpPB)
//STRIP001         {        
//STRIP001             if(nSelPos)
//STRIP001             {        
//STRIP001                 String sEntry = aListItemsLB.GetSelectEntry();
//STRIP001                 aListItemsLB.RemoveEntry(nSelPos);
//STRIP001                 nSelPos--;
//STRIP001                 aListItemsLB.InsertEntry(sEntry, nSelPos);
//STRIP001                 aListItemsLB.SelectEntryPos(nSelPos);
//STRIP001             }
//STRIP001         }
//STRIP001         else if(pControl == &aListDownPB)
//STRIP001         {        
//STRIP001             if(nSelPos < aListItemsLB.GetEntryCount() - 1)
//STRIP001             {        
//STRIP001                 String sEntry = aListItemsLB.GetSelectEntry();
//STRIP001                 aListItemsLB.RemoveEntry(nSelPos);
//STRIP001                 nSelPos++;
//STRIP001                 aListItemsLB.InsertEntry(sEntry, nSelPos);
//STRIP001                 aListItemsLB.SelectEntryPos(nSelPos);
//STRIP001             }
//STRIP001         }
//STRIP001     }
//STRIP001     bDropDownLBChanged = true;
//STRIP001     aListItemsLB.SetUpdateMode(TRUE);
//STRIP001     ListEnableHdl(0);
//STRIP001     return 0;
//STRIP001 }            
//STRIP001 /* -----------------17.06.2003 08:36-----------------
//STRIP001 
//STRIP001  --------------------------------------------------*/
//STRIP001 IMPL_LINK( SwFldFuncPage, ListEnableHdl, void*, EMPTYARG)
//STRIP001 {
//STRIP001     //enable "Add" button when text is in the Edit that's not already member of the box
//STRIP001     aListAddPB.Enable(aListItemED.GetText().Len() && 
//STRIP001                 LISTBOX_ENTRY_NOTFOUND == aListItemsLB.GetEntryPos(aListItemED.GetText()));
//STRIP001     BOOL bEnableButtons = aListItemsLB.GetSelectEntryCount() > 0;
//STRIP001     aListRemovePB.Enable(bEnableButtons);
//STRIP001     aListUpPB.Enable(bEnableButtons && (aListItemsLB.GetSelectEntryPos() > 0));
//STRIP001     aListDownPB.Enable(bEnableButtons && 
//STRIP001                 (aListItemsLB.GetSelectEntryPos() < (aListItemsLB.GetEntryCount() - 1)));
//STRIP001     
//STRIP001     return 0;
//STRIP001 }            
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	 Beschreibung: Typen in der SelectionBox erneuern
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 
//STRIP001 void SwFldFuncPage::UpdateSubType()
//STRIP001 {
//STRIP001 	USHORT nTypeId = (USHORT)(ULONG)aTypeLB.GetEntryData(GetTypeSel());
//STRIP001 
//STRIP001 	// Auswahl-Listbox fuellen
//STRIP001 	aSelectionLB.SetUpdateMode(FALSE);
//STRIP001 	aSelectionLB.Clear();
//STRIP001 
//STRIP001 	SvStringsDtor& rLst = GetFldMgr().GetSubTypes(nTypeId);
//STRIP001 	USHORT nCount = rLst.Count();
//STRIP001 
//STRIP001 	for (USHORT i = 0; i < nCount; ++i)
//STRIP001 	{
//STRIP001 		USHORT nPos = aSelectionLB.InsertEntry(*rLst[i]);
//STRIP001 		aSelectionLB.SetEntryData(nPos, (void*)i);
//STRIP001 	}
//STRIP001 
//STRIP001 	BOOL bEnable = nCount != 0;
//STRIP001 
//STRIP001 	aSelectionLB.Enable( bEnable );
//STRIP001 	aSelectionFT.Enable( bEnable );
//STRIP001 
//STRIP001 	if (bEnable)
//STRIP001 	{
//STRIP001 		if (nTypeId == TYP_MACROFLD)
//STRIP001 		{
//STRIP001 			BOOL bHasMacro = GetFldMgr().GetMacroPath().Len() != 0;
//STRIP001 
//STRIP001 			if (bHasMacro)
//STRIP001 			{
//STRIP001 				aSelectionLB.SelectEntry(GetFldMgr().GetMacroPath());
//STRIP001 				aNameED.SetText(aSelectionLB.GetSelectEntry());
//STRIP001 				aValueFT.Enable();
//STRIP001 				aValueED.Enable();
//STRIP001 			}
//STRIP001 			EnableInsert(bHasMacro);
//STRIP001 		}
//STRIP001 		else
//STRIP001 			aSelectionLB.SelectEntryPos(0);
//STRIP001 	}
//STRIP001 	aSelectionLB.SetUpdateMode(TRUE);
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung: MacroBrowser aufrufen, Listbox mit Macros fuellen
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SwFldFuncPage, MacroHdl, Button *, pBtn )
//STRIP001 {
//STRIP001 	Window* pDefModalDlgParent = Application::GetDefDialogParent();
//STRIP001 	Application::SetDefDialogParent( pBtn );
//STRIP001 
//STRIP001 	String sMacro(TurnMacroString(aNameED.GetText()));
//STRIP001 	while (sMacro.SearchAndReplace('.', ';') != STRING_NOTFOUND);
//STRIP001 
//STRIP001 	if (GetFldMgr().ChooseMacro(sMacro))
//STRIP001 		UpdateSubType();
//STRIP001 
//STRIP001 	Application::SetDefDialogParent( pDefModalDlgParent );
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 BOOL SwFldFuncPage::FillItemSet(SfxItemSet& rSet)
//STRIP001 {
//STRIP001 	BOOL bPage = FALSE;
//STRIP001 	USHORT nTypeId = (USHORT)(ULONG)aTypeLB.GetEntryData(GetTypeSel());
//STRIP001 
//STRIP001 	USHORT nSubType = 0;
//STRIP001 
//STRIP001 	ULONG nFormat = aFormatLB.GetSelectEntryPos();
//STRIP001 
//STRIP001 	if(nFormat == LISTBOX_ENTRY_NOTFOUND)
//STRIP001 		nFormat = 0;
//STRIP001 	else
//STRIP001 		nFormat = (ULONG)aFormatLB.GetEntryData((USHORT)nFormat);
//STRIP001 
//STRIP001 	String aVal(aValueED.GetText());
//STRIP001 	String aName(aNameED.GetText());
//STRIP001 
//STRIP001 	switch(nTypeId)
//STRIP001 	{
//STRIP001 		case TYP_INPUTFLD:
//STRIP001 			nSubType = INP_TXT;
//STRIP001             // to prevent removal of CR/LF restore old content 
//STRIP001             if(!aNameED.IsModified() && IsFldEdit())
//STRIP001                 aName = GetCurField()->GetPar1();
//STRIP001 
//STRIP001 			break;
//STRIP001 
//STRIP001 		case TYP_MACROFLD:
//STRIP001 			aName = TurnMacroString(aName);
//STRIP001 			break;
//STRIP001 
//STRIP001 		case TYP_CONDTXTFLD:
//STRIP001 			aVal = aCond1ED.GetText();
//STRIP001 			aVal += '|';
//STRIP001 			aVal += aCond2ED.GetText();
//STRIP001 			break;
//STRIP001         case TYP_DROPDOWN :
//STRIP001         {    
//STRIP001             aName = aListNameED.GetText();
//STRIP001             for(USHORT i = 0; i < aListItemsLB.GetEntryCount(); i++)
//STRIP001             {
//STRIP001                 if(i)
//STRIP001                     aVal += DB_DELIM;
//STRIP001                 aVal += aListItemsLB.GetEntry(i);
//STRIP001             }
//STRIP001         }
//STRIP001         break;
//STRIP001 		default:
//STRIP001 			break;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (!IsFldEdit() ||
//STRIP001 		aNameED.GetSavedValue() != aNameED.GetText() ||
//STRIP001 		aValueED.GetSavedValue() != aValueED.GetText() ||
//STRIP001 		aCond1ED.GetSavedValue() != aCond1ED.GetText() ||
//STRIP001 		aCond2ED.GetSavedValue() != aCond2ED.GetText() ||
//STRIP001 		aListNameED.GetSavedValue() != aListNameED.GetText() ||
//STRIP001         bDropDownLBChanged ||
//STRIP001 		nOldFormat != nFormat)
//STRIP001 	{
//STRIP001 		InsertFld( nTypeId, nSubType, aName, aVal, nFormat );
//STRIP001 	}
//STRIP001 
//STRIP001 	ModifyHdl();	// Insert ggf enablen/disablen
//STRIP001 
//STRIP001 	return FALSE;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 String SwFldFuncPage::TurnMacroString(const String &rMacro)
//STRIP001 {
//STRIP001 	if (rMacro.Len())
//STRIP001 	{
//STRIP001 		// Inhalt von aName umdrehen
//STRIP001 		String sTmp, sBuf;
//STRIP001 		USHORT nPos = 0;
//STRIP001 
//STRIP001 		for (USHORT i = 0; i < 4 && nPos != STRING_NOTFOUND; i++)
//STRIP001 		{
//STRIP001 			if (i == 3)
//STRIP001 				sTmp = rMacro.Copy(nPos);
//STRIP001 			else
//STRIP001 				sTmp = rMacro.GetToken(0, '.', nPos);
//STRIP001 
//STRIP001 			if( sBuf.Len() )
//STRIP001 				sTmp += '.';
//STRIP001 			sBuf.Insert( sTmp, 0 );
//STRIP001 		}
//STRIP001 		return sBuf;
//STRIP001 	}
//STRIP001 
//STRIP001 	return rMacro;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 SfxTabPage* SwFldFuncPage::Create( 	Window* pParent,
//STRIP001 						const SfxItemSet& rAttrSet )
//STRIP001 {
//STRIP001 	return ( new SwFldFuncPage( pParent, rAttrSet ) );
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 USHORT SwFldFuncPage::GetGroup()
//STRIP001 {
//STRIP001 	return GRP_FKT;
//STRIP001 }
//STRIP001 
//STRIP001 /* -----------------12.01.99 10:09-------------------
//STRIP001  *
//STRIP001  * --------------------------------------------------*/
//STRIP001 void	SwFldFuncPage::FillUserData()
//STRIP001 {
//STRIP001 	String sData( String::CreateFromAscii(
//STRIP001 						RTL_CONSTASCII_STRINGPARAM( USER_DATA_VERSION )));
//STRIP001 	sData += ';';
//STRIP001 	USHORT nTypeSel = aTypeLB.GetSelectEntryPos();
//STRIP001 	if( LISTBOX_ENTRY_NOTFOUND == nTypeSel )
//STRIP001 		nTypeSel = USHRT_MAX;
//STRIP001 	else
//STRIP001 		nTypeSel = (ULONG)aTypeLB.GetEntryData( nTypeSel );
//STRIP001 	sData += String::CreateFromInt32( nTypeSel );
//STRIP001 	SetUserData(sData);
//STRIP001 }
//STRIP001 
//STRIP001 IMPL_LINK( SwFldFuncPage, ModifyHdl, Edit *, EMPTYARG )
//STRIP001 {
//STRIP001 	String aName(aNameED.GetText());
//STRIP001 	const USHORT nLen = aName.Len();
//STRIP001 
//STRIP001 	BOOL bEnable = TRUE;
//STRIP001 	USHORT nTypeId = (USHORT)(ULONG)aTypeLB.GetEntryData(GetTypeSel());
//STRIP001 
//STRIP001 	if( TYP_COMBINED_CHARS == nTypeId &&
//STRIP001 		(!nLen || nLen > MAX_COMBINED_CHARACTERS ))
//STRIP001 		bEnable = FALSE;
//STRIP001 
//STRIP001 	EnableInsert( bEnable );
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
}
