/*************************************************************************
 *
 *  $RCSfile: sw_fldvar.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:54:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {


//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #ifndef _SWTYPES_HXX
//STRIP001 #include <swtypes.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _LINKMGR_HXX //autogen
//STRIP001 #include <so3/linkmgr.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _USRFLD_HXX
//STRIP001 #include <usrfld.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _DOCUFLD_HXX
//STRIP001 #include <docufld.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FLDBAS_HXX
//STRIP001 #include <fldbas.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _EXPFLD_HXX
//STRIP001 #include <expfld.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _DDEFLD_HXX
//STRIP001 #include <ddefld.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _VIEW_HXX
//STRIP001 #include <view.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _WRTSH_HXX
//STRIP001 #include <wrtsh.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _DOC_HXX
//STRIP001 #include <doc.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _DOCARY_HXX
//STRIP001 #include <docary.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SWMODULE_HXX
//STRIP001 #include <swmodule.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FLDVAR_HXX
//STRIP001 #include <fldvar.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _CALC_HXX
//STRIP001 #include <calc.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _ZFORMAT_HXX 
//STRIP001 #include <svtools/zformat.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _GLOBALS_HRC
//STRIP001 #include <globals.hrc>
//STRIP001 #endif
//STRIP001 #ifndef _FLDUI_HRC
//STRIP001 #include <fldui.hrc>
//STRIP001 #endif
//STRIP001 #ifndef _FLDTDLG_HRC
//STRIP001 #include <fldtdlg.hrc>
//STRIP001 #endif
//STRIP001 
//STRIP001 #define USER_DATA_VERSION_1 "1"
//STRIP001 #define USER_DATA_VERSION USER_DATA_VERSION_1
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 SwFldVarPage::SwFldVarPage(Window* pParent, const SfxItemSet& rCoreSet ) :
//STRIP001 	SwFldPage		( pParent, SW_RES( TP_FLD_VAR ), rCoreSet ),
//STRIP001 	aTypeFT			(this, SW_RES(FT_VARTYPE)),
//STRIP001 	aTypeLB			(this, SW_RES(LB_VARTYPE)),
//STRIP001 	aSelectionFT	(this, SW_RES(FT_VARSELECTION)),
//STRIP001 	aSelectionLB	(this, SW_RES(LB_VARSELECTION)),
//STRIP001 	aNameFT			(this, SW_RES(FT_VARNAME)),
//STRIP001 	aNameED			(this, SW_RES(ED_VARNAME)),
//STRIP001 	aValueFT		(this, SW_RES(FT_VARVALUE)),
//STRIP001 	aValueED		(this, SW_RES(ED_VARVALUE)),
//STRIP001 	aFormatFT		(this, SW_RES(FT_VARFORMAT)),
//STRIP001 	aNumFormatLB	(this, SW_RES(LB_VARNUMFORMAT)),
//STRIP001 	aFormatLB		(this, SW_RES(LB_VARFORMAT)),
//STRIP001 	aChapterHeaderFT(this, SW_RES(FT_VARCHAPTERHEADER)),
//STRIP001 	aChapterLevelFT	(this, SW_RES(FT_VARCHAPTERLEVEL)),
//STRIP001 	aChapterLevelLB	(this, SW_RES(LB_VARCHAPTERLEVEL)),
//STRIP001 	aInvisibleCB	(this, SW_RES(CB_VARINVISIBLE)),
//STRIP001 	aSeparatorFT	(this, SW_RES(FT_VARSEPARATOR)),
//STRIP001 	aSeparatorED	(this, SW_RES(ED_VARSEPARATOR)),
//STRIP001 	aNewDelTBX		(this, SW_RES(TBX_VARNEWDEL)),
//STRIP001 	bInit			(TRUE)
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aNewDelTBX.SetSizePixel( aNewDelTBX.CalcWindowSizePixel() );
//STRIP001 
//STRIP001 	long nDelta = ( aValueED.GetSizePixel().Height() -
//STRIP001 					aNewDelTBX.GetSizePixel().Height() ) / 2;
//STRIP001 	Point aNewPnt = aNewDelTBX.GetPosPixel();
//STRIP001 	aNewPnt.Y() += nDelta;
//STRIP001 	aNewDelTBX.SetPosPixel( aNewPnt );
//STRIP001 
//STRIP001 	sOldValueFT = aValueFT.GetText();
//STRIP001 	sOldNameFT = aNameFT.GetText();
//STRIP001 
//STRIP001 	for (USHORT i = 1; i <= MAXLEVEL; i++)
//STRIP001 		aChapterLevelLB.InsertEntry(String::CreateFromInt32(i));
//STRIP001 
//STRIP001 	aChapterLevelLB.SelectEntryPos(0);
//STRIP001     //enable 'active' language selection
//STRIP001     aNumFormatLB.SetShowLanguageControl(TRUE);
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 SwFldVarPage::~SwFldVarPage()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 void SwFldVarPage::Reset(const SfxItemSet& rSet)
//STRIP001 {
//STRIP001 	SavePos(&aTypeLB);
//STRIP001 
//STRIP001 	Init();	// Allgemeine initialisierung
//STRIP001 
//STRIP001 	aTypeLB.SetUpdateMode(FALSE);
//STRIP001 	aTypeLB.Clear();
//STRIP001 
//STRIP001 	USHORT nPos, nTypeId;
//STRIP001 
//STRIP001 	if (!IsFldEdit())
//STRIP001 	{
//STRIP001 		// TypeListBox initialisieren
//STRIP001 		const SwFldGroupRgn& rRg = GetFldMgr().GetGroupRange(IsFldDlgHtmlMode(), GetGroup());
//STRIP001 
//STRIP001 		for (short i = rRg.nStart; i < rRg.nEnd; ++i)
//STRIP001 		{
//STRIP001 			nTypeId = GetFldMgr().GetTypeId(i);
//STRIP001 
//STRIP001 #ifndef DDE_AVAILABLE
//STRIP001 			if (nTypeId != TYP_DDEFLD)
//STRIP001 #endif
//STRIP001 			{	// Nur unter WIN, WNT und OS/2 DDE-Fields
//STRIP001 				nPos = aTypeLB.InsertEntry(GetFldMgr().GetTypeStr(i));
//STRIP001 				aTypeLB.SetEntryData(nPos, (void*)nTypeId);
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001         SwField* pCurField = GetCurField();
//STRIP001         nTypeId = pCurField->GetTypeId();
//STRIP001 		if (nTypeId == TYP_SETINPFLD)
//STRIP001 			nTypeId = TYP_INPUTFLD;
//STRIP001 		nPos = aTypeLB.InsertEntry(GetFldMgr().GetTypeStr(GetFldMgr().GetPos(nTypeId)));
//STRIP001 		aTypeLB.SetEntryData(nPos, (void*)nTypeId);
//STRIP001         aNumFormatLB.SetAutomaticLanguage(pCurField->IsAutomaticLanguage());
//STRIP001         SwWrtShell &rSh = ::GetActiveView()->GetWrtShell();
//STRIP001         const SvNumberformat* pFormat = rSh.GetNumberFormatter()->GetEntry(pCurField->GetFormat());
//STRIP001         if(pFormat)
//STRIP001             aNumFormatLB.SetLanguage(pFormat->GetLanguage());
//STRIP001     }
//STRIP001 
//STRIP001 	// alte Pos selektieren
//STRIP001 	RestorePos(&aTypeLB);
//STRIP001 
//STRIP001 	aTypeLB.SetDoubleClickHdl		(LINK(this, SwFldVarPage, InsertHdl));
//STRIP001 	aTypeLB.SetSelectHdl			(LINK(this, SwFldVarPage, TypeHdl));
//STRIP001 	aSelectionLB.SetSelectHdl		(LINK(this, SwFldVarPage, SubTypeHdl));
//STRIP001 	aSelectionLB.SetDoubleClickHdl	(LINK(this, SwFldVarPage, InsertHdl));
//STRIP001 	aFormatLB.SetDoubleClickHdl		(LINK(this, SwFldVarPage, InsertHdl));
//STRIP001 	aNumFormatLB.SetDoubleClickHdl	(LINK(this, SwFldVarPage, InsertHdl));
//STRIP001 	aNameED.SetModifyHdl			(LINK(this, SwFldVarPage, ModifyHdl));
//STRIP001 	aValueED.SetModifyHdl			(LINK(this, SwFldVarPage, ModifyHdl));
//STRIP001 	aNewDelTBX.SetClickHdl			(LINK(this, SwFldVarPage, TBClickHdl));
//STRIP001 	aChapterLevelLB.SetSelectHdl	(LINK(this, SwFldVarPage, ChapterHdl));
//STRIP001 	aSeparatorED.SetModifyHdl		(LINK(this, SwFldVarPage, SeparatorHdl));
//STRIP001 
//STRIP001 	if( !IsRefresh() )
//STRIP001 	{
//STRIP001 		String sUserData = GetUserData();
//STRIP001 		if(!IsRefresh() && sUserData.GetToken(0, ';').EqualsIgnoreCaseAscii(USER_DATA_VERSION_1))
//STRIP001 		{
//STRIP001 			String sVal = sUserData.GetToken(1, ';');
//STRIP001 			USHORT nVal = (USHORT)sVal.ToInt32();
//STRIP001 			if( USHRT_MAX != nVal )
//STRIP001 			{
//STRIP001 				for(USHORT i = 0; i < aTypeLB.GetEntryCount(); i++)
//STRIP001 					if(nVal == (USHORT)(ULONG)aTypeLB.GetEntryData(i))
//STRIP001 					{
//STRIP001 						aTypeLB.SelectEntryPos(i);
//STRIP001 						break;
//STRIP001 					}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	TypeHdl(0);
//STRIP001 
//STRIP001 	aTypeLB.SetUpdateMode(TRUE);
//STRIP001 
//STRIP001 	if (IsFldEdit())
//STRIP001 	{
//STRIP001 		aSelectionLB.SaveValue();
//STRIP001 		aFormatLB.SaveValue();
//STRIP001 		nOldFormat = aNumFormatLB.GetFormat();
//STRIP001 		aNameED.SaveValue();
//STRIP001 		aValueED.SaveValue();
//STRIP001 		aInvisibleCB.SaveValue();
//STRIP001 		aChapterLevelLB.SaveValue();
//STRIP001 		aSeparatorED.SaveValue();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SwFldVarPage, TypeHdl, ListBox *, pBox )
//STRIP001 {
//STRIP001 	// Alte ListBoxPos sichern
//STRIP001 	const USHORT nOld = GetTypeSel();
//STRIP001 
//STRIP001 	// Aktuelle ListBoxPos
//STRIP001 	SetTypeSel(aTypeLB.GetSelectEntryPos());
//STRIP001 
//STRIP001 	if(GetTypeSel() == LISTBOX_ENTRY_NOTFOUND)
//STRIP001 	{
//STRIP001 		SetTypeSel(0);
//STRIP001 		aTypeLB.SelectEntryPos(0);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (nOld != GetTypeSel() || nOld == LISTBOX_ENTRY_NOTFOUND)
//STRIP001 	{
//STRIP001 		bInit = TRUE;
//STRIP001 		if (nOld != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 		{
//STRIP001 			aNameED.SetText(aEmptyStr);
//STRIP001 			aValueED.SetText(aEmptyStr);
//STRIP001 		}
//STRIP001 
//STRIP001 		aValueED.SetDropEnable(FALSE);
//STRIP001 		UpdateSubType();	// Auswahl-Listboxen initialisieren
//STRIP001 	}
//STRIP001 
//STRIP001 	bInit = FALSE;
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SwFldVarPage, SubTypeHdl, ListBox *, pBox )
//STRIP001 {
//STRIP001 	USHORT nTypeId = (USHORT)(ULONG)aTypeLB.GetEntryData(GetTypeSel());
//STRIP001 	USHORT nSelPos = aSelectionLB.GetSelectEntryPos();
//STRIP001 
//STRIP001 	if (nSelPos != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 		nSelPos = (USHORT)(ULONG)aSelectionLB.GetEntryData(nSelPos);
//STRIP001 
//STRIP001 	if (IsFldEdit() && (!pBox || bInit))
//STRIP001 	{
//STRIP001 		if (nTypeId != TYP_FORMELFLD)
//STRIP001 			aNameED.SetText(GetFldMgr().GetCurFldPar1());
//STRIP001 
//STRIP001 		aValueED.SetText(GetFldMgr().GetCurFldPar2());
//STRIP001 	}
//STRIP001 
//STRIP001 	if (aNameFT.GetText() != sOldNameFT)
//STRIP001 		aNameFT.SetText(sOldNameFT);
//STRIP001 	if (aValueFT.GetText() != sOldValueFT)
//STRIP001 		aValueFT.SetText(sOldValueFT);
//STRIP001 
//STRIP001 	aNumFormatLB.SetUpdateMode(FALSE);
//STRIP001 	aFormatLB.SetUpdateMode(FALSE);
//STRIP001 	FillFormatLB(nTypeId);
//STRIP001 
//STRIP001 	USHORT nSize = aFormatLB.GetEntryCount();
//STRIP001 
//STRIP001 	BOOL bValue = FALSE, bName = FALSE, bNumFmt = FALSE,
//STRIP001 			bInvisible = FALSE, bSeparator = FALSE, bChapterLevel = FALSE;
//STRIP001 	BOOL bFormat = nSize != 0;
//STRIP001 
//STRIP001 	switch (nTypeId)
//STRIP001 	{
//STRIP001 		case TYP_USERFLD:
//STRIP001 		{
//STRIP001 			// Benutzertyp aendern oder anlegen
//STRIP001 			SwUserFieldType* pType = (SwUserFieldType*)
//STRIP001 				GetFldMgr().GetFldType(RES_USERFLD, nSelPos);
//STRIP001 
//STRIP001 			if (pType)
//STRIP001 			{
//STRIP001 				if (!IsFldEdit())
//STRIP001 				{
//STRIP001 					if (pBox || (bInit && !IsRefresh()))	// Nur bei Interaktion mit Maus
//STRIP001 					{
//STRIP001 						aNameED.SetText(pType->GetName());
//STRIP001 
//STRIP001 						if (pType->GetType() == UF_STRING)
//STRIP001 						{
//STRIP001 							aValueED.SetText(pType->GetContent());
//STRIP001 							aNumFormatLB.SelectEntryPos(0);
//STRIP001 						}
//STRIP001 						else
//STRIP001 							aValueED.SetText(pType->GetContent());
//STRIP001 //							aValueED.SetText(pType->GetContent(aNumFormatLB.GetFormat()));
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else
//STRIP001 					aValueED.SetText(pType->GetContent());
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				if (pBox)	// Nur bei Interaktion mit Maus
//STRIP001 				{
//STRIP001 					aNameED.SetText(aEmptyStr);
//STRIP001 					aValueED.SetText(aEmptyStr);
//STRIP001 				}
//STRIP001 			}
//STRIP001 			bValue = bName = bNumFmt = bInvisible = TRUE;
//STRIP001 
//STRIP001 			aValueED.SetDropEnable(TRUE);
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case TYP_SETFLD:
//STRIP001 			bValue = TRUE;
//STRIP001 
//STRIP001 			bNumFmt = bInvisible = TRUE;
//STRIP001 
//STRIP001 			if (!IsFldDlgHtmlMode())
//STRIP001 				bName = TRUE;
//STRIP001 			else
//STRIP001 			{
//STRIP001 				aNumFormatLB.Clear();
//STRIP001 				USHORT nPos = aNumFormatLB.InsertEntry(SW_RESSTR(FMT_SETVAR_TEXT), 0);
//STRIP001 				aNumFormatLB.SetEntryData(nPos, (void *)ULONG_MAX);
//STRIP001 				aNumFormatLB.SelectEntryPos(0);
//STRIP001 			}
//STRIP001 			// gibt es ein entprechendes SetField
//STRIP001 			if (IsFldEdit() || pBox)	// Nur bei Interaktion mit Maus
//STRIP001 			{
//STRIP001 				if (nSelPos != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 				{
//STRIP001 					String sName(aSelectionLB.GetSelectEntry());
//STRIP001 					aNameED.SetText(sName);
//STRIP001 
//STRIP001 					if (!IsFldDlgHtmlMode())
//STRIP001 					{
//STRIP001 						SwSetExpFieldType* pSetTyp = (SwSetExpFieldType*)
//STRIP001 									::GetActiveView()->GetWrtShell().
//STRIP001 									GetFldType(RES_SETEXPFLD, sName);
//STRIP001 
//STRIP001 						if (pSetTyp && pSetTyp->GetType() == GSE_STRING)
//STRIP001 							aNumFormatLB.SelectEntryPos(0);	// Textuell
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 			if (IsFldEdit())
//STRIP001 			{
//STRIP001 				// GetFormula fuehrt bei Datumsformaten zu Problemen,
//STRIP001 				// da nur der numerische Wert ohne Formatierung returned wird.
//STRIP001 				// Muss aber verwendet werden, da sonst bei GetPar2 nur der vom
//STRIP001 				// Kalkulator errechnete Wert angezeigt werden wuerde
//STRIP001 				// (statt test2 = test + 1)
//STRIP001 				aValueED.SetText(((SwSetExpField*)GetCurField())->GetFormula());
//STRIP001 			}
//STRIP001 			aValueED.SetDropEnable(TRUE);
//STRIP001 			break;
//STRIP001 
//STRIP001 		case TYP_FORMELFLD:
//STRIP001 			{
//STRIP001 				bValue = TRUE;
//STRIP001 				bNumFmt = TRUE;
//STRIP001 				aValueFT.SetText(SW_RESSTR(STR_FORMULA));
//STRIP001 				aValueED.SetDropEnable(TRUE);
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case TYP_GETFLD:
//STRIP001 			{
//STRIP001 				if (!IsFldEdit())
//STRIP001 				{
//STRIP001 					aNameED.SetText(aEmptyStr);
//STRIP001 					aValueED.SetText(aEmptyStr);
//STRIP001 				}
//STRIP001 
//STRIP001 				if (nSelPos != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 				{
//STRIP001 					String sName(aSelectionLB.GetSelectEntry());
//STRIP001 					if (!IsFldEdit())
//STRIP001 						aNameED.SetText(sName);
//STRIP001 
//STRIP001 					// gibt es ein entprechendes SetField
//STRIP001 					SwSetExpFieldType* pSetTyp = (SwSetExpFieldType*)
//STRIP001 								::GetActiveView()->GetWrtShell().
//STRIP001 								GetFldType(RES_SETEXPFLD, sName);
//STRIP001 
//STRIP001 					if(pSetTyp)
//STRIP001 					{
//STRIP001 						if (pSetTyp->GetType() & GSE_STRING)	// Textuell?
//STRIP001 							bFormat = TRUE;
//STRIP001 						else					// Numerisch
//STRIP001 							bNumFmt = TRUE;
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else
//STRIP001 					bFormat = FALSE;
//STRIP001 
//STRIP001 				EnableInsert(bFormat|bNumFmt);
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case TYP_INPUTFLD:
//STRIP001 			aValueFT.SetText(SW_RESSTR(STR_PROMPT));
//STRIP001 
//STRIP001 			if (nSelPos != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 			{
//STRIP001 				bValue = bNumFmt = TRUE;
//STRIP001 
//STRIP001 				String sName;
//STRIP001 
//STRIP001 				sName = aSelectionLB.GetSelectEntry();
//STRIP001 				aNameED.SetText( sName );
//STRIP001 
//STRIP001 				// User- oder SetField ?
//STRIP001 				USHORT nInpType = 0;
//STRIP001 				nInpType = GetFldMgr().GetFldType(RES_USERFLD, sName) ? 0 : TYP_SETINPFLD;
//STRIP001 
//STRIP001 				if (nInpType)	// SETEXPFLD
//STRIP001 				{
//STRIP001 					// gibt es ein entprechendes SetField
//STRIP001 					SwSetExpFieldType* pSetTyp = (SwSetExpFieldType*)
//STRIP001 								GetFldMgr().GetFldType(RES_SETEXPFLD, sName);
//STRIP001 
//STRIP001 					if(pSetTyp)
//STRIP001 					{
//STRIP001 						if (pSetTyp->GetType() == GSE_STRING)	// Textuell?
//STRIP001 						{
//STRIP001 							aNumFormatLB.Clear();
//STRIP001 
//STRIP001 							USHORT nPos = aNumFormatLB.InsertEntry(SW_RESSTR(FMT_USERVAR_TEXT), 0);
//STRIP001 							aNumFormatLB.SetEntryData(nPos, (void *)ULONG_MAX);
//STRIP001 							aNumFormatLB.SelectEntryPos(0);
//STRIP001 						}
//STRIP001 					}
//STRIP001 					if (IsFldEdit() && (!pBox || bInit) )
//STRIP001 						aValueED.SetText(((SwSetExpField*)GetCurField())->GetPromptText());
//STRIP001 				}
//STRIP001 				else	// USERFLD
//STRIP001 					bFormat = bNumFmt = FALSE;
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case TYP_DDEFLD:
//STRIP001 			aValueFT.SetText(SW_RESSTR(STR_DDE_CMD));
//STRIP001 
//STRIP001 			if (IsFldEdit() || pBox)	// Nur bei Interaktion mit Maus
//STRIP001 			{
//STRIP001 				if (nSelPos != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 				{
//STRIP001 					SwDDEFieldType* pType =
//STRIP001 						(SwDDEFieldType*) GetFldMgr().GetFldType(RES_DDEFLD, nSelPos);
//STRIP001 
//STRIP001 					if(pType)
//STRIP001 					{
//STRIP001 						aNameED.SetText(pType->GetName());
//STRIP001 
//STRIP001 						//JP 28.08.95: DDE-Topics/-Items koennen Blanks in ihren
//STRIP001 						//				Namen haben! Wird hier noch nicht beachtet
//STRIP001 						String sCmd( pType->GetCmd() );
//STRIP001 						USHORT nTmpPos = sCmd.SearchAndReplace( ::so3::cTokenSeperator, ' ' );
//STRIP001 						sCmd.SearchAndReplace( ::so3::cTokenSeperator, ' ', nTmpPos );
//STRIP001 
//STRIP001 						aValueED.SetText( sCmd );
//STRIP001 						aFormatLB.SelectEntryPos(pType->GetType());
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 			bName = bValue = TRUE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case TYP_SEQFLD:
//STRIP001 			{
//STRIP001 				// aNumRB.Check(TRUE);
//STRIP001 				bName = bValue = bSeparator = bChapterLevel = TRUE;
//STRIP001 
//STRIP001 				SwFieldType* pFldTyp;
//STRIP001 				if( IsFldEdit() )
//STRIP001 					pFldTyp = GetCurField()->GetTyp();
//STRIP001 				else
//STRIP001 				{
//STRIP001 					String sFldTypeName( aSelectionLB.GetEntry( nSelPos ));
//STRIP001 					if( sFldTypeName.Len() )
//STRIP001 						pFldTyp = GetFldMgr().GetFldType( RES_SETEXPFLD,
//STRIP001 														  sFldTypeName );
//STRIP001 					else
//STRIP001 						pFldTyp = 0;
//STRIP001 				}
//STRIP001 
//STRIP001 				if( IsFldEdit() )
//STRIP001 					aValueED.SetText( ((SwSetExpField*)GetCurField())->
//STRIP001 										GetFormula() );
//STRIP001 
//STRIP001 				if( IsFldEdit() || pBox )	// Nur bei Interaktion mit Maus
//STRIP001 					aNameED.SetText( aSelectionLB.GetSelectEntry() );
//STRIP001 
//STRIP001 				if( pFldTyp )
//STRIP001 				{
//STRIP001 					BYTE nLevel = ((SwSetExpFieldType*)pFldTyp)->GetOutlineLvl();
//STRIP001 					if( 0x7f == nLevel )
//STRIP001 						aChapterLevelLB.SelectEntryPos( 0 );
//STRIP001 					else
//STRIP001 						aChapterLevelLB.SelectEntryPos( nLevel + 1 );
//STRIP001 					sal_Unicode cDelim = ((SwSetExpFieldType*)pFldTyp)->GetDelimiter();
//STRIP001 					if(cDelim)
//STRIP001 						aSeparatorED.SetText( cDelim );
//STRIP001 					else
//STRIP001 						aSeparatorED.SetText( aEmptyStr );
//STRIP001 					ChapterHdl();
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case TYP_SETREFPAGEFLD:
//STRIP001 			{
//STRIP001 				bValue = FALSE;
//STRIP001 				aValueFT.SetText( SW_RESSTR( STR_OFFSET ));
//STRIP001 
//STRIP001 				if (IsFldEdit() || pBox)	// Nur bei Interaktion mit Maus
//STRIP001 					aNameED.SetText(aEmptyStr);
//STRIP001 
//STRIP001 				if (nSelPos != 0 && nSelPos != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 				{
//STRIP001 					bValue = TRUE;		// SubType OFF - kennt keinen Offset
//STRIP001 					if (IsFldEdit())
//STRIP001 						aValueED.SetText(String::CreateFromInt32(((SwRefPageSetField*)GetCurField())->GetOffset()));
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case TYP_GETREFPAGEFLD:
//STRIP001 			aNameED.SetText(aEmptyStr);
//STRIP001 			aValueED.SetText(aEmptyStr);
//STRIP001 			break;
//STRIP001 	}
//STRIP001 
//STRIP001 	aNumFormatLB.Show(bNumFmt);
//STRIP001 	aFormatLB.Show(!bNumFmt);
//STRIP001 
//STRIP001 	if (IsFldEdit())
//STRIP001 		bName = FALSE;
//STRIP001 
//STRIP001 	aFormatLB.Enable(bFormat);
//STRIP001 	aFormatFT.Enable(bFormat|bNumFmt);
//STRIP001 	aNameFT.Enable(bName);
//STRIP001 	aNameED.Enable(bName);
//STRIP001 	aValueFT.Enable(bValue);
//STRIP001 	aValueED.Enable(bValue);
//STRIP001 
//STRIP001 	Size aSz(aFormatLB.GetSizePixel());
//STRIP001 
//STRIP001 	if (bChapterLevel)
//STRIP001 		aSz.Height() = aFormatLB.LogicToPixel(Size(1, 94), MAP_APPFONT).Height();
//STRIP001 	else
//STRIP001 		aSz.Height() = aFormatLB.LogicToPixel(Size(1, 123), MAP_APPFONT).Height();
//STRIP001 
//STRIP001 	aFormatLB.SetSizePixel(aSz);
//STRIP001 
//STRIP001 	aInvisibleCB.Show(!bSeparator);
//STRIP001 	aSeparatorFT.Show(bSeparator);
//STRIP001 	aSeparatorED.Show(bSeparator);
//STRIP001 	aChapterHeaderFT.Show(bChapterLevel);
//STRIP001 	aChapterLevelFT.Show(bChapterLevel);
//STRIP001 	aChapterLevelLB.Show(bChapterLevel);
//STRIP001 	aInvisibleCB.Enable(bInvisible);
//STRIP001 
//STRIP001 	ModifyHdl();	// Anwenden/Einfuegen/Loeschen Status update
//STRIP001 
//STRIP001 	aNumFormatLB.SetUpdateMode(TRUE);
//STRIP001 	aFormatLB.SetUpdateMode(TRUE);
//STRIP001 
//STRIP001 	if(aSelectionLB.IsCallAddSelection())
//STRIP001 	{
//STRIP001 		USHORT nTypeId = (USHORT)(ULONG)aTypeLB.GetEntryData(GetTypeSel());
//STRIP001 
//STRIP001 		switch (nTypeId)
//STRIP001 		{
//STRIP001 			case TYP_FORMELFLD:
//STRIP001 				{
//STRIP001 					USHORT nSelPos = aSelectionLB.GetSelectEntryPos();
//STRIP001 
//STRIP001 					if (nSelPos != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 						nSelPos = (USHORT)(ULONG)aSelectionLB.GetEntryData(nSelPos);
//STRIP001 
//STRIP001 					if (nSelPos != LISTBOX_ENTRY_NOTFOUND && pBox && !bInit)
//STRIP001 					{
//STRIP001 						aValueED.ReplaceSelected(aSelectionLB.GetSelectEntry());
//STRIP001 						ModifyHdl();
//STRIP001 					}
//STRIP001 				}
//STRIP001 				break;
//STRIP001 		}
//STRIP001 		aSelectionLB.ResetCallAddSelection();
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	 Beschreibung: Typen in der SelectionBox erneuern
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 void SwFldVarPage::UpdateSubType()
//STRIP001 {
//STRIP001 	String sOldSel;
//STRIP001 	USHORT nTypeId = (USHORT)(ULONG)aTypeLB.GetEntryData(GetTypeSel());
//STRIP001 
//STRIP001 	SetSelectionSel(aSelectionLB.GetSelectEntryPos());
//STRIP001 	if(GetSelectionSel() != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 		sOldSel = aSelectionLB.GetEntry(GetSelectionSel());
//STRIP001 
//STRIP001 	// Auswahl-Listbox fuellen
//STRIP001 	aSelectionLB.SetUpdateMode(FALSE);
//STRIP001 	aSelectionLB.Clear();
//STRIP001 
//STRIP001 	SvStringsDtor& rLst = GetFldMgr().GetSubTypes(nTypeId);
//STRIP001 	USHORT nCount = rLst.Count();
//STRIP001 	USHORT nPos;
//STRIP001 
//STRIP001 	for (USHORT i = 0; i < nCount; ++i)
//STRIP001 	{
//STRIP001 		if (nTypeId != TYP_INPUTFLD || i)
//STRIP001 		{
//STRIP001 			if (!IsFldEdit())
//STRIP001 			{
//STRIP001 				nPos = aSelectionLB.InsertEntry(*rLst[i]);
//STRIP001 				aSelectionLB.SetEntryData(nPos, (void*)i);
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				BOOL bInsert = FALSE;
//STRIP001 
//STRIP001 				switch (nTypeId)
//STRIP001 				{
//STRIP001 					case TYP_INPUTFLD:
//STRIP001 						if (*rLst[i] == GetCurField()->GetPar1())
//STRIP001 							bInsert = TRUE;
//STRIP001 						break;
//STRIP001 
//STRIP001 					case TYP_FORMELFLD:
//STRIP001 						bInsert = TRUE;
//STRIP001 						break;
//STRIP001 
//STRIP001 					case TYP_GETFLD:
//STRIP001 						if (*rLst[i] == ((SwFormulaField*)GetCurField())->GetFormula())
//STRIP001 							bInsert = TRUE;
//STRIP001 						break;
//STRIP001 
//STRIP001 					case TYP_SETFLD:
//STRIP001 					case TYP_USERFLD:
//STRIP001 						if (*rLst[i] == GetCurField()->GetTyp()->GetName())
//STRIP001 						{
//STRIP001 							bInsert = TRUE;
//STRIP001 							if (GetCurField()->GetSubType() & SUB_INVISIBLE)
//STRIP001 								aInvisibleCB.Check();
//STRIP001 						}
//STRIP001 						break;
//STRIP001 
//STRIP001 					case TYP_SETREFPAGEFLD:
//STRIP001 						if ((((SwRefPageSetField*)GetCurField())->IsOn() && i) ||
//STRIP001 							(!((SwRefPageSetField*)GetCurField())->IsOn() && !i))
//STRIP001 							sOldSel = *rLst[i];
//STRIP001 
//STRIP001 						// Alle Eintrge zur Auswahl zulassen:
//STRIP001 						nPos = aSelectionLB.InsertEntry(*rLst[i]);
//STRIP001 						aSelectionLB.SetEntryData(nPos, (void*)i);
//STRIP001 						break;
//STRIP001 
//STRIP001 					default:
//STRIP001 						if (*rLst[i] == GetCurField()->GetPar1())
//STRIP001 							bInsert = TRUE;
//STRIP001 						break;
//STRIP001 				}
//STRIP001 				if (bInsert)
//STRIP001 				{
//STRIP001 					nPos = aSelectionLB.InsertEntry(*rLst[i]);
//STRIP001 					aSelectionLB.SetEntryData(nPos, (void*)i);
//STRIP001 					if (nTypeId != TYP_FORMELFLD)
//STRIP001 						break;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	BOOL bEnable = aSelectionLB.GetEntryCount() != 0;
//STRIP001 	ListBox *pLB = 0;
//STRIP001 
//STRIP001 	if (bEnable)
//STRIP001 	{
//STRIP001 		aSelectionLB.SelectEntry(sOldSel);
//STRIP001 		if (!aSelectionLB.GetSelectEntryCount())
//STRIP001 		{
//STRIP001 			aSelectionLB.SelectEntryPos(0);
//STRIP001 			pLB = &aSelectionLB;	// Alle Controls neu initialisieren
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	aSelectionLB.Enable( bEnable );
//STRIP001 	aSelectionFT.Enable( bEnable );
//STRIP001 
//STRIP001 	SubTypeHdl(pLB);
//STRIP001 	aSelectionLB.SetUpdateMode(TRUE);
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 USHORT SwFldVarPage::FillFormatLB(USHORT nTypeId)
//STRIP001 {
//STRIP001 	String sOldSel, sOldNumSel;
//STRIP001 	ULONG nOldNumFormat = 0;
//STRIP001 
//STRIP001 	USHORT nFormatSel = aFormatLB.GetSelectEntryPos();
//STRIP001 	if (nFormatSel != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 		sOldSel = aFormatLB.GetEntry(nFormatSel);
//STRIP001 
//STRIP001 	USHORT nNumFormatSel = aNumFormatLB.GetSelectEntryPos();
//STRIP001 	if (nNumFormatSel != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 	{
//STRIP001 		sOldNumSel = aNumFormatLB.GetEntry(nNumFormatSel);
//STRIP001 		nOldNumFormat = aNumFormatLB.GetFormat();
//STRIP001 	}
//STRIP001 
//STRIP001 	// Format-Listbox fuellen
//STRIP001 	aFormatLB.Clear();
//STRIP001 	aNumFormatLB.Clear();
//STRIP001 	BOOL bSpecialFmt = FALSE;
//STRIP001 
//STRIP001 	if( TYP_GETREFPAGEFLD != nTypeId )
//STRIP001 	{
//STRIP001 		if (IsFldEdit())
//STRIP001 		{
//STRIP001             bSpecialFmt = GetCurField()->GetFormat() == ULONG_MAX;
//STRIP001 
//STRIP001 			if (!bSpecialFmt)
//STRIP001 			{
//STRIP001 				aNumFormatLB.SetDefFormat(GetCurField()->GetFormat());
//STRIP001 				sOldNumSel = aEmptyStr;
//STRIP001 			}
//STRIP001 			else
//STRIP001 				if (nTypeId == TYP_GETFLD || nTypeId == TYP_FORMELFLD)
//STRIP001 					aNumFormatLB.SetFormatType(NUMBERFORMAT_NUMBER);
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			if (nOldNumFormat && nOldNumFormat != ULONG_MAX)
//STRIP001 				aNumFormatLB.SetDefFormat(nOldNumFormat);
//STRIP001 			else
//STRIP001 				aNumFormatLB.SetFormatType(NUMBERFORMAT_NUMBER);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	switch (nTypeId)
//STRIP001 	{
//STRIP001 		case TYP_USERFLD:
//STRIP001 		{
//STRIP001 			if (!IsFldEdit() || bSpecialFmt)
//STRIP001 			{
//STRIP001 				USHORT nPos = aNumFormatLB.InsertEntry(SW_RESSTR(FMT_MARK_TEXT), 0);
//STRIP001 				aNumFormatLB.SetEntryData(nPos, (void *)ULONG_MAX);
//STRIP001 				nPos = aNumFormatLB.InsertEntry(SW_RESSTR(FMT_USERVAR_CMD), 1);
//STRIP001 				aNumFormatLB.SetEntryData(nPos, (void *)ULONG_MAX);
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case TYP_SETFLD:
//STRIP001 		{
//STRIP001 			if (!IsFldEdit() || bSpecialFmt)
//STRIP001 			{
//STRIP001 				USHORT nPos = aNumFormatLB.InsertEntry(SW_RESSTR(FMT_SETVAR_TEXT), 0);
//STRIP001 				aNumFormatLB.SetEntryData(nPos, (void *)ULONG_MAX);
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case TYP_FORMELFLD:
//STRIP001 		{
//STRIP001 			USHORT nPos = aNumFormatLB.InsertEntry(SW_RESSTR(FMT_GETVAR_NAME), 0);
//STRIP001 			aNumFormatLB.SetEntryData(nPos, (void *)ULONG_MAX);
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case TYP_GETFLD:
//STRIP001 		{
//STRIP001 			USHORT nPos = aNumFormatLB.InsertEntry(SW_RESSTR(FMT_GETVAR_NAME), 0);
//STRIP001 			aNumFormatLB.SetEntryData(nPos, (void *)ULONG_MAX);
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (IsFldEdit() && bSpecialFmt)
//STRIP001 	{
//STRIP001 		if (nTypeId == TYP_USERFLD && (GetCurField()->GetSubType() & SUB_CMD))
//STRIP001 			aNumFormatLB.SelectEntryPos(1);
//STRIP001 		else
//STRIP001 			aNumFormatLB.SelectEntryPos(0);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		if (!nOldNumFormat && (nNumFormatSel = aNumFormatLB.GetEntryPos(sOldNumSel)) != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 			aNumFormatLB.SelectEntryPos(nNumFormatSel);
//STRIP001 		else if (nOldNumFormat && nOldNumFormat == ULONG_MAX)
//STRIP001 			aNumFormatLB.SelectEntry(sOldSel);
//STRIP001 	}
//STRIP001 
//STRIP001 	USHORT nSize = GetFldMgr().GetFormatCount(nTypeId, FALSE, IsFldDlgHtmlMode());
//STRIP001 
//STRIP001 	for (USHORT i = 0; i < nSize; i++)
//STRIP001 	{
//STRIP001 		USHORT nPos = aFormatLB.InsertEntry(GetFldMgr().GetFormatStr(nTypeId, i));
//STRIP001 		USHORT nFldId = GetFldMgr().GetFormatId( nTypeId, i );
//STRIP001 		aFormatLB.SetEntryData( nPos, (void*)nFldId );
//STRIP001 		if (IsFldEdit() && nFldId == GetCurField()->GetFormat())
//STRIP001 			aFormatLB.SelectEntryPos( nPos );
//STRIP001 	}
//STRIP001 
//STRIP001 	if (nSize && (!IsFldEdit() || !aFormatLB.GetSelectEntryCount()))
//STRIP001 	{
//STRIP001 		aFormatLB.SelectEntry(sOldSel);
//STRIP001 
//STRIP001 		if (!aFormatLB.GetSelectEntryCount())
//STRIP001 		{
//STRIP001 			aFormatLB.SelectEntry(SW_RESSTR(FMT_NUM_PAGEDESC));
//STRIP001 			if (!aFormatLB.GetSelectEntryCount())
//STRIP001 			{
//STRIP001 				aFormatLB.SelectEntry(SW_RESSTR(FMT_NUM_ARABIC));
//STRIP001 				if (!aFormatLB.GetSelectEntryCount())
//STRIP001 					aFormatLB.SelectEntryPos(0);
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return nSize;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung: Modify
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SwFldVarPage, ModifyHdl, Edit *, EMPTYARG )
//STRIP001 {
//STRIP001 	String sValue(aValueED.GetText());
//STRIP001 	BOOL bHasValue = sValue.Len() != 0;
//STRIP001 	USHORT nTypeId = (USHORT)(ULONG)aTypeLB.GetEntryData(GetTypeSel());
//STRIP001 	BOOL bInsert = FALSE, bApply = FALSE, bDelete = FALSE;
//STRIP001 
//STRIP001 	String sName( aNameED.GetText() );
//STRIP001 	xub_StrLen nLen = sName.Len();
//STRIP001 
//STRIP001 	switch( nTypeId )
//STRIP001 	{
//STRIP001 	case TYP_DDEFLD:
//STRIP001 	case TYP_USERFLD:
//STRIP001 	case TYP_SETFLD:
//STRIP001 	case TYP_SEQFLD:
//STRIP001 		SwCalc::IsValidVarName( sName, &sName );
//STRIP001 		if( sName.Len() != nLen )
//STRIP001 		{
//STRIP001 			nLen = sName.Len();
//STRIP001 			Selection aSel(aNameED.GetSelection());
//STRIP001 			aNameED.SetText( sName );
//STRIP001 			aNameED.SetSelection( aSel );	// Cursorpos restaurieren
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 
//STRIP001 	// Buttons ueberpruefen
//STRIP001 	switch (nTypeId)
//STRIP001 	{
//STRIP001 	case TYP_DDEFLD:
//STRIP001 		if( nLen )
//STRIP001 		{
//STRIP001 			// Gibts schon einen entsprechenden Type
//STRIP001 			bInsert = bApply = TRUE;
//STRIP001 
//STRIP001 			SwFieldType* pType = GetFldMgr().GetFldType(RES_DDEFLD, sName);
//STRIP001 
//STRIP001 			if (pType)
//STRIP001 				bDelete = !::GetActiveView()->GetWrtShell().IsUsed( *pType );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 	case TYP_USERFLD:
//STRIP001 		if( nLen )
//STRIP001 		{
//STRIP001 			// Gibts schon einen entsprechenden Type
//STRIP001 			SwFieldType* pType = GetFldMgr().GetFldType(RES_USERFLD, sName);
//STRIP001 
//STRIP001 			if (pType)
//STRIP001 				bDelete = !::GetActiveView()->GetWrtShell().IsUsed( *pType );
//STRIP001 
//STRIP001 			pType = GetFldMgr().GetFldType(RES_SETEXPFLD, sName);
//STRIP001 			if (!pType)	// Kein Namenskonflikt mit Variablen
//STRIP001 			{
//STRIP001 				// Benutzerfelder duerfen auch ohne Inhalt eingefuegt werden!
//STRIP001 				// Bug #56845
//STRIP001 				bInsert = bApply = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 	default:
//STRIP001 		bInsert = TRUE;
//STRIP001 
//STRIP001 		if (nTypeId == TYP_SETFLD || nTypeId == TYP_SEQFLD)
//STRIP001 		{
//STRIP001 			SwSetExpFieldType* pFldType = (SwSetExpFieldType*)
//STRIP001 				GetFldMgr().GetFldType(RES_SETEXPFLD, sName);
//STRIP001 
//STRIP001 			if (pFldType)
//STRIP001 			{
//STRIP001 
//STRIP001 				SwWrtShell &rSh = ::GetActiveView()->GetWrtShell();
//STRIP001 				const SwFldTypes* p = rSh.GetDoc()->GetFldTypes();
//STRIP001 				USHORT i;
//STRIP001 
//STRIP001 				for (i = 0; i < INIT_FLDTYPES; i++)
//STRIP001 				{
//STRIP001 					SwFieldType* pType = (*p)[ i ];
//STRIP001 					if (pType == pFldType)
//STRIP001 						break;
//STRIP001 				}
//STRIP001 
//STRIP001 				if (i >= INIT_FLDTYPES && !rSh.IsUsed(*pFldType))
//STRIP001 					bDelete = TRUE;
//STRIP001 
//STRIP001 				if (nTypeId == TYP_SEQFLD && !(pFldType->GetType() & GSE_SEQ))
//STRIP001 					bInsert = FALSE;
//STRIP001 
//STRIP001 				if (nTypeId == TYP_SETFLD && (pFldType->GetType() & GSE_SEQ))
//STRIP001 					bInsert = FALSE;
//STRIP001 			}
//STRIP001 			if (GetFldMgr().GetFldType(RES_USERFLD, sName))
//STRIP001 				bInsert = FALSE;
//STRIP001 		}
//STRIP001 
//STRIP001 		if( !nLen && ( nTypeId == TYP_SETFLD ||
//STRIP001 						(!IsFldEdit() && nTypeId == TYP_GETFLD ) ) )
//STRIP001 			bInsert = FALSE;
//STRIP001 
//STRIP001 		if( (nTypeId == TYP_SETFLD || nTypeId == TYP_FORMELFLD) &&
//STRIP001 			!bHasValue )
//STRIP001 			bInsert = FALSE;
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 	aNewDelTBX.EnableItem(BT_VARAPPLY, bApply);
//STRIP001 	aNewDelTBX.EnableItem(BT_VARDELETE, bDelete);
//STRIP001 	EnableInsert(bInsert);
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SwFldVarPage, TBClickHdl, ToolBox *, pBox )
//STRIP001 {
//STRIP001 	USHORT nTypeId = (USHORT)(ULONG)aTypeLB.GetEntryData(GetTypeSel());
//STRIP001 
//STRIP001 	switch (pBox->GetCurItemId())
//STRIP001 	{
//STRIP001 		case BT_VARDELETE:
//STRIP001 		{
//STRIP001 			if( nTypeId == TYP_USERFLD )
//STRIP001 				GetFldMgr().RemoveFldType(RES_USERFLD, aSelectionLB.GetSelectEntry());
//STRIP001 			else
//STRIP001 			{
//STRIP001 				USHORT nWhich;
//STRIP001 
//STRIP001 				switch(nTypeId)
//STRIP001 				{
//STRIP001 					case TYP_SETFLD:
//STRIP001 					case TYP_SEQFLD:
//STRIP001 						nWhich = RES_SETEXPFLD;
//STRIP001 						break;
//STRIP001 					default:
//STRIP001 						nWhich = RES_DDEFLD;
//STRIP001 						break;
//STRIP001 				}
//STRIP001 
//STRIP001 				GetFldMgr().RemoveFldType(nWhich, aSelectionLB.GetSelectEntry());
//STRIP001 			}
//STRIP001 
//STRIP001 			UpdateSubType();
//STRIP001 			::GetActiveView()->GetWrtShell().SetModified();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case BT_VARAPPLY:
//STRIP001 		{
//STRIP001 			String sName(aNameED.GetText()), sValue(aValueED.GetText());
//STRIP001 			SwFieldType* pType = 0;
//STRIP001 			USHORT nId;
//STRIP001 			USHORT nNumFormatPos = aNumFormatLB.GetSelectEntryPos();
//STRIP001 
//STRIP001 			switch (nTypeId)
//STRIP001 			{
//STRIP001 				case TYP_USERFLD:	nId = RES_USERFLD;	break;
//STRIP001 				case TYP_DDEFLD:	nId = RES_DDEFLD;	break;
//STRIP001 				case TYP_SETFLD:	nId = RES_SETEXPFLD;break;
//STRIP001 			}
//STRIP001 			pType = GetFldMgr().GetFldType(nId, sName);
//STRIP001 
//STRIP001 			ULONG nFormat = aFormatLB.GetSelectEntryPos();
//STRIP001 			if (nFormat != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 				nFormat = (ULONG)aFormatLB.GetEntryData((USHORT)nFormat);
//STRIP001 
//STRIP001 			if (pType)	// Aendern
//STRIP001 			{
//STRIP001 				SwWrtShell &rSh = ::GetActiveView()->GetWrtShell();
//STRIP001 				rSh.StartAllAction();
//STRIP001 
//STRIP001 				if (nTypeId == TYP_USERFLD)
//STRIP001 				{
//STRIP001 					if (nNumFormatPos != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 					{
//STRIP001 						ULONG nFmt = nNumFormatPos == 0 ? 0 : aNumFormatLB.GetFormat();
//STRIP001 						if (nFmt)
//STRIP001 						{	// Sprache auf Office-Sprache umstellen, da String im Office
//STRIP001 							// Format vom Kalkulator erwartet wird und so in den Dlg
//STRIP001 							// eingegeben werden sollte
//STRIP001 							SvNumberFormatter* pFormatter = rSh.GetNumberFormatter();
//STRIP001 							nFmt = SwValueField::GetSystemFormat(rSh.GetNumberFormatter(), nFmt);
//STRIP001 						}
//STRIP001 						((SwUserFieldType*)pType)->SetContent(aValueED.GetText(), nFmt);
//STRIP001 						((SwUserFieldType*)pType)->SetType(
//STRIP001 							nNumFormatPos == 0 ? GSE_STRING : GSE_EXPR );
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					if (nFormat != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 					{
//STRIP001 						//JP 28.08.95: DDE-Topics/-Items koennen Blanks in ihren
//STRIP001 						//				Namen haben! Wird hier noch nicht beachtet.
//STRIP001 						USHORT nTmpPos = sValue.SearchAndReplace( ' ', ::so3::cTokenSeperator );
//STRIP001 						sValue.SearchAndReplace( ' ', ::so3::cTokenSeperator, nTmpPos );
//STRIP001 						((SwDDEFieldType*)pType)->SetCmd(sValue);
//STRIP001 						((SwDDEFieldType*)pType)->SetType((USHORT)nFormat);
//STRIP001 					}
//STRIP001 				}
//STRIP001 				pType->UpdateFlds();
//STRIP001 
//STRIP001 				::GetActiveView()->GetWrtShell().EndAllAction();
//STRIP001 			}
//STRIP001 			else		// Neu
//STRIP001 			{
//STRIP001 				if(nTypeId == TYP_USERFLD)
//STRIP001 				{
//STRIP001 					SwUserFieldType aType( ::GetActiveView()->GetWrtShellPtr()->GetDoc(), sName );
//STRIP001 
//STRIP001 					if (nNumFormatPos != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 					{
//STRIP001 						aType.SetType(nNumFormatPos == 0 ? GSE_STRING : GSE_EXPR);
//STRIP001 						aType.SetContent( sValue, nNumFormatPos == 0 ? 0 : aNumFormatLB.GetFormat() );
//STRIP001 						aSelectionLB.InsertEntry(sName);
//STRIP001 						aSelectionLB.SelectEntry(sName);
//STRIP001 						GetFldMgr().InsertFldType( aType );	// Userfld Neu
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					if (nFormat != LISTBOX_ENTRY_NOTFOUND)
//STRIP001 					{
//STRIP001 						//JP 28.08.95: DDE-Topics/-Items koennen Blanks in ihren
//STRIP001 						//				Namen haben! Wird hier noch nicht beachtet.
//STRIP001 						USHORT nTmpPos = sValue.SearchAndReplace( ' ', ::so3::cTokenSeperator );
//STRIP001 						sValue.SearchAndReplace( ' ', ::so3::cTokenSeperator, nTmpPos );
//STRIP001 
//STRIP001 						SwDDEFieldType aType(sName, sValue, (USHORT)nFormat);
//STRIP001 						aSelectionLB.InsertEntry(sName);
//STRIP001 						aSelectionLB.SelectEntry(sName);
//STRIP001 						GetFldMgr().InsertFldType(aType);	// DDE-Feld Neu
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 			if (IsFldEdit())
//STRIP001 				GetFldMgr().GetCurFld();	// FieldManager Updaten
//STRIP001 
//STRIP001 			UpdateSubType();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SwFldVarPage, ChapterHdl, ListBox *, pLB )
//STRIP001 {
//STRIP001 	BOOL bEnable = aChapterLevelLB.GetSelectEntryPos() != 0;
//STRIP001 
//STRIP001 	aSeparatorED.Enable(bEnable);
//STRIP001 	aSeparatorFT.Enable(bEnable);
//STRIP001 	SeparatorHdl();
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 IMPL_LINK( SwFldVarPage, SeparatorHdl, Edit *, pED )
//STRIP001 {
//STRIP001 	BOOL bEnable = aSeparatorED.GetText().Len() != 0 ||
//STRIP001 					aChapterLevelLB.GetSelectEntryPos() == 0;
//STRIP001 	EnableInsert(bEnable);
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 BOOL SwFldVarPage::FillItemSet(SfxItemSet& rSet)
//STRIP001 {
//STRIP001 	USHORT nTypeId = (USHORT)(ULONG)aTypeLB.GetEntryData(GetTypeSel());
//STRIP001 
//STRIP001 	String aVal(aValueED.GetText());
//STRIP001 	String aName(aNameED.GetText());
//STRIP001 
//STRIP001 	USHORT nSubType = aSelectionLB.GetSelectEntryPos();
//STRIP001 	if(nSubType == LISTBOX_ENTRY_NOTFOUND)
//STRIP001 		nSubType = 0;
//STRIP001 	else
//STRIP001 		nSubType = (USHORT)(ULONG)aSelectionLB.GetEntryData(nSubType);
//STRIP001 
//STRIP001 	ULONG nFormat;
//STRIP001 
//STRIP001 	if (!aNumFormatLB.IsVisible())
//STRIP001 	{
//STRIP001 		nFormat = aFormatLB.GetSelectEntryPos();
//STRIP001 
//STRIP001 		if(nFormat == LISTBOX_ENTRY_NOTFOUND)
//STRIP001 			nFormat = 0;
//STRIP001 		else
//STRIP001 			nFormat = (ULONG)aFormatLB.GetEntryData((USHORT)nFormat);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		nFormat = aNumFormatLB.GetFormat();
//STRIP001 
//STRIP001 		if (nFormat && nFormat != ULONG_MAX && aNumFormatLB.IsAutomaticLanguage())
//STRIP001 		{
//STRIP001 			// Sprache auf Office-Sprache umstellen, da String im Office-
//STRIP001 			// Format vom Kalkulator erwartet wird und so in den Dlg
//STRIP001 			// eingegeben werden sollte
//STRIP001 			SwWrtShell &rSh = ::GetActiveView()->GetWrtShell();
//STRIP001 			SvNumberFormatter* pFormatter = rSh.GetNumberFormatter();
//STRIP001 
//STRIP001 			nFormat = SwValueField::GetSystemFormat(rSh.GetNumberFormatter(), nFormat);
//STRIP001 		}
//STRIP001 	}
//STRIP001 	sal_Unicode cSeparator = ' ';
//STRIP001 	switch (nTypeId)
//STRIP001 	{
//STRIP001 		case TYP_USERFLD:
//STRIP001 		{
//STRIP001 			nSubType = (nFormat == ULONG_MAX) ? GSE_STRING : GSE_EXPR;
//STRIP001 
//STRIP001 			if (nFormat == ULONG_MAX && aNumFormatLB.GetSelectEntry() == SW_RESSTR(FMT_USERVAR_CMD))
//STRIP001 				nSubType |= SUB_CMD;
//STRIP001 
//STRIP001 			if (aInvisibleCB.IsChecked())
//STRIP001 				nSubType |= SUB_INVISIBLE;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 		case TYP_FORMELFLD:
//STRIP001 		{
//STRIP001 			nSubType = GSE_FORMULA;
//STRIP001 			if (aNumFormatLB.IsVisible() && nFormat == ULONG_MAX)
//STRIP001 				nSubType |= SUB_CMD;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 		case TYP_GETFLD:
//STRIP001 		{
//STRIP001 			nSubType &= 0xff00;
//STRIP001 			if (aNumFormatLB.IsVisible() && nFormat == ULONG_MAX)
//STRIP001 				nSubType |= SUB_CMD;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 		case TYP_INPUTFLD:
//STRIP001 		{
//STRIP001 			SwFieldType* pType = GetFldMgr().GetFldType(RES_USERFLD, aName);
//STRIP001 			nSubType = (nSubType & 0xff00) | ((pType) ? INP_USR : INP_VAR);
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case TYP_SETFLD:
//STRIP001 		{
//STRIP001 			if (IsFldDlgHtmlMode())
//STRIP001 			{
//STRIP001 				nSubType = 0x0100;
//STRIP001 				nSubType = (nSubType & 0xff00) | GSE_STRING;
//STRIP001 			}
//STRIP001 			else
//STRIP001 				nSubType = (nSubType & 0xff00) | ((nFormat == ULONG_MAX) ? GSE_STRING : GSE_EXPR);
//STRIP001 
//STRIP001 			if (aInvisibleCB.IsChecked())
//STRIP001 				nSubType |= SUB_INVISIBLE;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 		case TYP_SEQFLD:
//STRIP001 		{
//STRIP001 			// nSubType = GSE_SEQ;	// GSE_SEQ wird im Fldmgr fest gesetzt, kann also entfallen
//STRIP001 			nSubType = aChapterLevelLB.GetSelectEntryPos();
//STRIP001 			if (nSubType == 0)
//STRIP001 				nSubType = 0x7f;
//STRIP001 			else
//STRIP001 			{
//STRIP001 				nSubType--;
//STRIP001 				String sSeparator(aSeparatorED.GetText().GetChar(0));
//STRIP001 				cSeparator = sSeparator.Len() ? sSeparator.GetChar(0) : ' ';
//STRIP001 				//nSubType |= (USHORT)(((BYTE)) << 8);
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 		case TYP_GETREFPAGEFLD:
//STRIP001 			if( SVX_NUM_CHAR_SPECIAL == nFormat )
//STRIP001 				aVal = aValueED.GetText();
//STRIP001 			break;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (!IsFldEdit() ||
//STRIP001 		aNameED.GetSavedValue() != aNameED.GetText() ||
//STRIP001 		aValueED.GetSavedValue() != aValueED.GetText() ||
//STRIP001 		aSelectionLB.GetSavedValue() != aSelectionLB.GetSelectEntryPos() ||
//STRIP001 		aFormatLB.GetSavedValue() != aFormatLB.GetSelectEntryPos() ||
//STRIP001 		nOldFormat != aNumFormatLB.GetFormat() ||
//STRIP001 		aInvisibleCB.GetState() != aInvisibleCB.GetSavedValue() ||
//STRIP001 		aChapterLevelLB.GetSavedValue() != aChapterLevelLB.GetSelectEntryPos() ||
//STRIP001 		aSeparatorED.GetSavedValue() != aSeparatorED.GetText())
//STRIP001 	{
//STRIP001         InsertFld( nTypeId, nSubType, aName, aVal, nFormat, 
//STRIP001                     cSeparator, aNumFormatLB.IsAutomaticLanguage() );
//STRIP001 	}
//STRIP001 
//STRIP001 	UpdateSubType();
//STRIP001 
//STRIP001 	return FALSE;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 SfxTabPage* SwFldVarPage::Create( 	Window* pParent,
//STRIP001 						const SfxItemSet& rAttrSet )
//STRIP001 {
//STRIP001 	return ( new SwFldVarPage( pParent, rAttrSet ) );
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 USHORT SwFldVarPage::GetGroup()
//STRIP001 {
//STRIP001 	return GRP_VAR;
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 SelectionListBox::SelectionListBox( SwFldVarPage* pDialog, const ResId& rResId ) :
//STRIP001 	ListBox	(pDialog, rResId),
//STRIP001 	pDlg	(pDialog),
//STRIP001 	bCallAddSelection(FALSE)
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 long SelectionListBox::PreNotify( NotifyEvent& rNEvt )
//STRIP001 {
//STRIP001 	long nHandled = ListBox::PreNotify( rNEvt );
//STRIP001 	//BOOL bAddSel = FALSE;
//STRIP001 	if ( rNEvt.GetType() == EVENT_KEYUP )
//STRIP001 	{
//STRIP001 		const KeyEvent* pKEvt = rNEvt.GetKeyEvent();
//STRIP001 		const KeyCode aKeyCode = pKEvt->GetKeyCode();
//STRIP001 		const USHORT nModifier = aKeyCode.GetModifier();
//STRIP001 		if( aKeyCode.GetCode() == KEY_SPACE && !nModifier)
//STRIP001 //			bAddSel = TRUE;
//STRIP001 			bCallAddSelection = TRUE;
//STRIP001 	}
//STRIP001 	if ( rNEvt.GetType() == EVENT_MOUSEBUTTONDOWN )
//STRIP001 	{
//STRIP001 		const MouseEvent* pMEvt = rNEvt.GetMouseEvent();
//STRIP001 
//STRIP001 		if (pMEvt && (pMEvt->IsMod1() || pMEvt->IsMod2()))	// Alt oder Ctrl
//STRIP001 			//bAddSel = TRUE;
//STRIP001 			bCallAddSelection = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 //	if (bAddSel)
//STRIP001 //		pDlg->AddSelection(this);
//STRIP001 
//STRIP001 	return nHandled;
//STRIP001 }
//STRIP001 /* -----------------12.01.99 11:14-------------------
//STRIP001  *
//STRIP001  * --------------------------------------------------*/
//STRIP001 void SwFldVarPage::FillUserData()
//STRIP001 {
//STRIP001 	String sData(String::CreateFromAscii(USER_DATA_VERSION));
//STRIP001 	sData += ';';
//STRIP001 	USHORT nTypeSel = aTypeLB.GetSelectEntryPos();
//STRIP001 	if( LISTBOX_ENTRY_NOTFOUND == nTypeSel )
//STRIP001 		nTypeSel = USHRT_MAX;
//STRIP001 	else
//STRIP001 		nTypeSel = (USHORT)(ULONG)aTypeLB.GetEntryData( nTypeSel );
//STRIP001 	sData += String::CreateFromInt32( nTypeSel );
//STRIP001 	SetUserData(sData);
//STRIP001 }

}
