/*************************************************************************
 *
 *  $RCSfile: sw_inpdlg.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:54:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {


//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #define _INPDLG_CXX
//STRIP001 
//STRIP001 #ifndef _MSGBOX_HXX //autogen
//STRIP001 #include <vcl/msgbox.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _UNOTOOLS_CHARCLASS_HXX
//STRIP001 #include <unotools/charclass.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _UNO_LINGU_HXX
//STRIP001 #include <bf_svx/unolingu.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _WRTSH_HXX
//STRIP001 #include <wrtsh.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FLDBAS_HXX
//STRIP001 #include <fldbas.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _EXPFLD_HXX
//STRIP001 #include <expfld.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _USRFLD_HXX
//STRIP001 #include <usrfld.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _INPDLG_HXX
//STRIP001 #include <inpdlg.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FLDMGR_HXX
//STRIP001 #include <fldmgr.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _FLDUI_HRC
//STRIP001 #include <fldui.hrc>
//STRIP001 #endif
//STRIP001 #ifndef _INPDLG_HRC
//STRIP001 #include <inpdlg.hrc>
//STRIP001 #endif
//STRIP001 
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung: Feldeinfuegen bearbeiten
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 SwFldInputDlg::SwFldInputDlg( Window *pParent, SwWrtShell &rS,
//STRIP001 							  SwField* pField, BOOL bNextButton ) :
//STRIP001 
//STRIP001 	SvxStandardDialog(pParent,	SW_RES(DLG_FLD_INPUT)),
//STRIP001 
//STRIP001 	rSh( rS ),
//STRIP001 	aLabelED	(this, SW_RES(ED_LABEL	)),
//STRIP001 	aEditED		(this, SW_RES(ED_EDIT	)),
//STRIP001     aEditFL     (this, SW_RES(FL_EDIT       )),
//STRIP001 	aOKBT		(this, SW_RES(BT_OK		)),
//STRIP001 	aCancelBT	(this, SW_RES(BT_CANCEL	)),
//STRIP001 	aNextBT		(this, SW_RES(PB_NEXT	)),
//STRIP001 	aHelpBT     (this, SW_RES(PB_HELP    )),
//STRIP001 	pInpFld(0),
//STRIP001 	pSetFld(0),
//STRIP001 	pUsrType(0)
//STRIP001 {
//STRIP001 	// Font fuers Edit umschalten
//STRIP001 	Font aFont(aEditED.GetFont());
//STRIP001 	aFont.SetWeight(WEIGHT_LIGHT);
//STRIP001 	aEditED.SetFont(aFont);
//STRIP001 
//STRIP001 	if( bNextButton )
//STRIP001 	{
//STRIP001 		aNextBT.Show();
//STRIP001 		aNextBT.SetClickHdl(LINK(this, SwFldInputDlg, NextHdl));
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		long nDiff = aCancelBT.GetPosPixel().Y() - aOKBT.GetPosPixel().Y();
//STRIP001 		Point aPos = aHelpBT.GetPosPixel();
//STRIP001 		aPos.Y() -= nDiff;
//STRIP001 		aHelpBT.SetPosPixel(aPos);
//STRIP001 	}
//STRIP001 
//STRIP001 	// Auswertung hier
//STRIP001 	String aStr;
//STRIP001 	if( RES_INPUTFLD == pField->GetTyp()->Which() )
//STRIP001 	{	// Es ist eine Eingabefeld
//STRIP001 		//
//STRIP001 		pInpFld = (SwInputField*)pField;
//STRIP001 		aLabelED.SetText( pInpFld->GetPar2() );
//STRIP001 		USHORT nSubType = pInpFld->GetSubType();
//STRIP001 
//STRIP001 		switch(nSubType & 0xff)
//STRIP001 		{
//STRIP001 			case INP_TXT:
//STRIP001 				aStr = pInpFld->GetPar1();
//STRIP001 				break;
//STRIP001 
//STRIP001 			case INP_USR:
//STRIP001 				// Benutzerfeld
//STRIP001 				if( 0 != ( pUsrType = (SwUserFieldType*)rSh.GetFldType(
//STRIP001 							RES_USERFLD, pInpFld->GetPar1() ) ) )
//STRIP001 					aStr = pUsrType->GetContent();
//STRIP001 				break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		// es ist eine SetExpression
//STRIP001 		pSetFld = (SwSetExpField*)pField;
//STRIP001 		String sFormula(pSetFld->GetFormula());
//STRIP001 		//values are formatted - formulas are not
//STRIP001 		CharClass aCC( SvxCreateLocale( pSetFld->GetLanguage() ));
//STRIP001 		if( aCC.isNumeric( sFormula ))
//STRIP001 			aStr = pSetFld->Expand();
//STRIP001 		else
//STRIP001 			aStr = sFormula;
//STRIP001 		aLabelED.SetText( pSetFld->GetPromptText() );
//STRIP001 	}
//STRIP001 
//STRIP001 	// JP 31.3.00: Inputfields in readonly regions must be allowed to
//STRIP001 	//				input any content. - 74639
//STRIP001 	BOOL bEnable = !rSh.IsCrsrReadonly();
//STRIP001 					/*!rSh.IsReadOnlyAvailable() || !rSh.HasReadonlySel()*/;
//STRIP001 	aOKBT.Enable( bEnable );
//STRIP001 	aEditED.SetReadOnly( !bEnable );
//STRIP001 
//STRIP001 	if( aStr.Len() )
//STRIP001 		aEditED.SetText( aStr.ConvertLineEnd() );
//STRIP001 	aEditED.GrabFocus();
//STRIP001 	FreeResource();
//STRIP001 }
//STRIP001 
//STRIP001 SwFldInputDlg::~SwFldInputDlg()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	 Beschreibung:	Schliessen
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 void SwFldInputDlg::Apply()
//STRIP001 {
//STRIP001 	String aTmp( aEditED.GetText() );
//STRIP001 	aTmp.EraseAllChars( '\r' );
//STRIP001 
//STRIP001 	rSh.StartAllAction();
//STRIP001 	BOOL bModified = FALSE;
//STRIP001 	if(pInpFld)
//STRIP001 	{
//STRIP001 		if(pUsrType)
//STRIP001 		{
//STRIP001 			if( aTmp != pUsrType->GetContent() )
//STRIP001 			{
//STRIP001 				pUsrType->SetContent(aTmp);
//STRIP001 				pUsrType->UpdateFlds();
//STRIP001 				bModified = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else if( aTmp != pInpFld->GetPar1() )
//STRIP001 		{
//STRIP001 			pInpFld->SetPar1(aTmp);
//STRIP001 			rSh.SwEditShell::UpdateFlds(*pInpFld);
//STRIP001 			bModified = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if( aTmp != pSetFld->GetPar2() )
//STRIP001 	{
//STRIP001 		pSetFld->SetPar2(aTmp);
//STRIP001 		rSh.SwEditShell::UpdateFlds(*pSetFld);
//STRIP001 		bModified = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if( bModified )
//STRIP001 		rSh.SetUndoNoResetModified();
//STRIP001 
//STRIP001 	rSh.EndAllAction();
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 IMPL_LINK(SwFldInputDlg, NextHdl, PushButton*, EMPTYARG)
//STRIP001 {
//STRIP001 	EndDialog(RET_OK);
//STRIP001 	return 0;
//STRIP001 }


}
