/*************************************************************************
 *
 *  $RCSfile: sw_rowht.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:57:24 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {


//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #ifndef _SFXINTITEM_HXX //autogen
//STRIP001 #include <svtools/intitem.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFXENUMITEM_HXX //autogen
//STRIP001 #include <svtools/eitem.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFXDISPATCH_HXX //autogen
//STRIP001 #include <bf_sfx2/dispatch.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SVX_DLGUTIL_HXX //autogen
//STRIP001 #include <bf_svx/dlgutil.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 
//STRIP001 #ifndef _FMTFSIZE_HXX //autogen
//STRIP001 #include <fmtfsize.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SWTYPES_HXX
//STRIP001 #include <swtypes.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _ROWHT_HXX
//STRIP001 #include <rowht.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _WRTSH_HXX
//STRIP001 #include <wrtsh.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FRMATR_HXX
//STRIP001 #include <frmatr.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _WDOCSH_HXX
//STRIP001 #include <wdocsh.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _VIEW_HXX
//STRIP001 #include <view.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SWMODULE_HXX
//STRIP001 #include <swmodule.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _USRPREF_HXX
//STRIP001 #include <usrpref.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _CMDID_H
//STRIP001 #include <cmdid.h>
//STRIP001 #endif
//STRIP001 #ifndef _ROWHT_HRC
//STRIP001 #include <rowht.hrc>
//STRIP001 #endif
//STRIP001 #ifndef _TABLE_HRC
//STRIP001 #include <table.hrc>
//STRIP001 #endif
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 void SwTableHeightDlg::Apply()
//STRIP001 {
//STRIP001 	SwTwips nHeight = aHeightEdit.Denormalize(aHeightEdit.GetValue(FUNIT_TWIP));
//STRIP001 	SwFmtFrmSize aSz(ATT_FIX_SIZE, 0, nHeight);
//STRIP001 
//STRIP001 	SwFrmSize eFrmSize = (SwFrmSize) aAutoHeightCB.IsChecked() ?
//STRIP001 		ATT_MIN_SIZE : ATT_FIX_SIZE;
//STRIP001 	if(eFrmSize != aSz.GetSizeType())
//STRIP001 	{
//STRIP001 		aSz.SetSizeType(eFrmSize);
//STRIP001 	}
//STRIP001 	rSh.SetRowHeight( aSz );
//STRIP001 }
//STRIP001 
//STRIP001 // CTOR / DTOR -----------------------------------------------------------
//STRIP001 
//STRIP001 
//STRIP001 SwTableHeightDlg::SwTableHeightDlg( Window *pParent, SwWrtShell &rS ) :
//STRIP001 
//STRIP001 	SvxStandardDialog(pParent, SW_RES(DLG_ROW_HEIGHT)),
//STRIP001 
//STRIP001 	aHeightEdit(this, SW_RES(ED_HEIGHT)),
//STRIP001 	aAutoHeightCB(this, SW_RES(CB_AUTOHEIGHT)),
//STRIP001     aHeightFL(this, SW_RES(FL_HEIGHT)),
//STRIP001 	aOKBtn(this, SW_RES(BT_OK)),
//STRIP001 	aCancelBtn(this, SW_RES(BT_CANCEL)),
//STRIP001 	aHelpBtn( this, SW_RES( BT_HELP ) ),
//STRIP001 	rSh( rS )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	FieldUnit eFieldUnit = SW_MOD()->GetUsrPref( 0 != PTR_CAST( SwWebDocShell,
//STRIP001 								rSh.GetView().GetDocShell() ) )->GetMetric();
//STRIP001 	::SetFieldUnit( aHeightEdit, eFieldUnit );
//STRIP001 
//STRIP001 	aHeightEdit.SetMin(MINLAY, FUNIT_TWIP);
//STRIP001 	if(!aHeightEdit.GetMin())
//STRIP001 		aHeightEdit.SetMin(1);
//STRIP001 	SwFmtFrmSize *pSz;
//STRIP001 	rSh.GetRowHeight( pSz );
//STRIP001 	if ( pSz )
//STRIP001 	{
//STRIP001 		long nHeight = pSz->GetHeight();
//STRIP001 		aAutoHeightCB.Check(pSz->GetSizeType() != ATT_FIX_SIZE);
//STRIP001 		aHeightEdit.SetValue(aHeightEdit.Normalize(nHeight), FUNIT_TWIP);
//STRIP001 
//STRIP001 		delete pSz;
//STRIP001 	}
//STRIP001 }



}
