/*************************************************************************
 *
 *  $RCSfile: sw_bookctrl.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 19:32:17 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #include "hintids.hxx"

#ifndef _SVSTDARR_HXX
#define _SVSTDARR_USHORTS
// auto strip #include <svtools/svstdarr.hxx>
#endif
// auto strip #ifndef _SFXINTITEM_HXX //autogen
// auto strip #include <svtools/intitem.hxx>
// auto strip #endif
#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <bf_sfx2/dispatch.hxx>
#endif
// auto strip #ifndef _EVENT_HXX //autogen
// auto strip #include <vcl/event.hxx>
// auto strip #endif
// auto strip #ifndef _STATUS_HXX //autogen
// auto strip #include <vcl/status.hxx>
// auto strip #endif
// auto strip #ifndef _MENU_HXX //autogen
// auto strip #include <vcl/menu.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif


#include "cmdid.h"
// auto strip #include "errhdl.hxx"
// auto strip #include "swmodule.hxx"

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #include "wrtsh.hxx"
// auto strip #include "bookmrk.hxx"
#include "bookctrl.hxx"
namespace binfilter {


/*N*/ SFX_IMPL_STATUSBAR_CONTROL( SwBookmarkControl, SfxStringItem );

// class BookmarkPopup_Impl --------------------------------------------------

//STRIP001 class BookmarkPopup_Impl : public PopupMenu
//STRIP001 {
//STRIP001 public:
//STRIP001 	BookmarkPopup_Impl();
//STRIP001 
//STRIP001 	USHORT			GetCurId() const { return nCurId; }
//STRIP001 
//STRIP001 private:
//STRIP001 	USHORT			nCurId;
//STRIP001 
//STRIP001 	virtual void    Select();
//STRIP001 };

// -----------------------------------------------------------------------

//STRIP001 BookmarkPopup_Impl::BookmarkPopup_Impl() :
//STRIP001 	PopupMenu(),
//STRIP001 	nCurId(USHRT_MAX)
//STRIP001 {
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void BookmarkPopup_Impl::Select()
//STRIP001 {
//STRIP001 	nCurId = GetCurItemId();
//STRIP001 }

// class SvxZoomStatusBarControl ------------------------------------------

/*N*/ SwBookmarkControl::SwBookmarkControl( USHORT nId,
/*N*/ 												  StatusBar& rStb,
/*N*/ 												  SfxBindings& rBind ) :
/*N*/ 	SfxStatusBarControl( nId, rStb, rBind )
/*N*/ {
/*N*/ }

// -----------------------------------------------------------------------

/*N*/ SwBookmarkControl::~SwBookmarkControl()
/*N*/ {
/*N*/ }

// -----------------------------------------------------------------------

//STRIP001 void SwBookmarkControl::StateChanged( const SfxPoolItem* pState )
//STRIP001 {
//STRIP001 	SfxItemState eState = GetItemState(pState);
//STRIP001 
//STRIP001 	if( eState != SFX_ITEM_AVAILABLE || pState->ISA( SfxVoidItem ) )
//STRIP001 		GetStatusBar().SetItemText( GetId(), String() );
//STRIP001 	else if ( pState->ISA( SfxStringItem ) )
//STRIP001 	{
//STRIP001 		sPageNumber = ((SfxStringItem*)pState)->GetValue();
//STRIP001 		GetStatusBar().SetItemText( GetId(), sPageNumber );
//STRIP001 	}
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SwBookmarkControl::Paint( const UserDrawEvent&  )
//STRIP001 {
//STRIP001 	GetStatusBar().SetItemText( GetId(), sPageNumber );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void SwBookmarkControl::Command( const CommandEvent& rCEvt )
//STRIP001 {
//STRIP001 	if ( rCEvt.GetCommand() == COMMAND_CONTEXTMENU &&
//STRIP001 			GetStatusBar().GetItemText( GetId() ).Len() )
//STRIP001 	{
//STRIP001 		CaptureMouse();
//STRIP001 		BookmarkPopup_Impl aPop;
//STRIP001 		SwWrtShell* pWrtShell = ::GetActiveWrtShell();
//STRIP001 		USHORT nBookCnt;
//STRIP001 		if( pWrtShell && 0 != ( nBookCnt = pWrtShell->GetBookmarkCnt() ) )
//STRIP001 		{
//STRIP001 			SvUShorts aBookArr;
//STRIP001 			for( USHORT nCount = 0; nCount < nBookCnt; ++nCount )
//STRIP001 			{
//STRIP001 				SwBookmark& rBkmk = pWrtShell->GetBookmark( nCount );
//STRIP001 				if( rBkmk.IsBookMark() )
//STRIP001 				{
//STRIP001 					aBookArr.Insert( nCount, aBookArr.Count() );
//STRIP001 					aPop.InsertItem( aBookArr.Count(), rBkmk.GetName() );
//STRIP001 				}
//STRIP001 			}
//STRIP001 			aPop.Execute( &GetStatusBar(), rCEvt.GetMousePosPixel());
//STRIP001 			USHORT nId = aPop.GetCurId();
//STRIP001 			if( nId != USHRT_MAX)
//STRIP001 			{
//STRIP001 				SfxUInt16Item aBookmark( FN_STAT_BOOKMARK, aBookArr[nId-1] );
//STRIP001 				SfxViewFrame::Current()->GetDispatcher()->Execute( 	FN_STAT_BOOKMARK,
//STRIP001 					SFX_CALLMODE_ASYNCHRON|SFX_CALLMODE_RECORD,
//STRIP001 										&aBookmark, 0L );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		ReleaseMouse();
//STRIP001 	}
//STRIP001 }


}
