/*************************************************************************
 *
 *  $RCSfile: paragrph.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 08:28:24 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_PARAGRPH_HXX
#define _SVX_PARAGRPH_HXX

// include ---------------------------------------------------------------

#ifndef _BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif
#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif
#ifndef _SVX_RELFLD_HXX
#include <bf_svx/relfld.hxx>		// SvxRelativeField
#endif
#ifndef _SVX_PARAPREV_HXX
#include <bf_svx/paraprev.hxx>		// Preview
#endif
#ifndef _SVX_FRMDIRLBOX_HXX
#include <bf_svx/frmdirlbox.hxx>
#endif

#ifndef _LSTBOX_HXX //autogen
#include <vcl/lstbox.hxx>
#endif
namespace binfilter {

// define ----------------------------------------------------------------

// 1/2 cm in TWIPS
// wird auch fuer Minimalgrosse der LayFrms aller Arten benutzt
#define MM50   283

// forward ---------------------------------------------------------------

//STRIP001 class SvxLineSpacingItem;
//STRIP001 class SvxParagraphControllerItem;
//STRIP001 
//STRIP001 // class SvxStdParagraphTabPage ------------------------------------------
//STRIP001 
//STRIP001 /* 	{k:\svx\prototyp\dialog\parastd.bmp}
//STRIP001 
//STRIP001 	[Beschreibung]
//STRIP001 	Mit dieser TabPage koennen Standard-Attribute eines Absatzes eingestellt
//STRIP001 	werden (Einzug, Abstand, Ausrichtung, Zeilenabstand).
//STRIP001 
//STRIP001 	[Items]
//STRIP001 	<SvxAdjustItem><SID_ATTR_PARA_ADJUST>
//STRIP001 	<SvxLineSpacingItem><SID_ATTR_PARA_LINESPACE>
//STRIP001 	<SvxULSpaceItem><SID_ATTR_ULSPACE>
//STRIP001 	<SvxLRSpaceItem><SID_ATTR_LRSPACE>
//STRIP001 */
//STRIP001 
//STRIP001 class SvxStdParagraphTabPage: public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	SvxStdParagraphTabPage( Window* pParent, const SfxItemSet& rSet );
//STRIP001 
//STRIP001 	// Einzug
//STRIP001 	FixedText				aLeftLabel;
//STRIP001 	SvxRelativeField		aLeftIndent;
//STRIP001 
//STRIP001 	FixedText				aRightLabel;
//STRIP001 	SvxRelativeField		aRightIndent;
//STRIP001 
//STRIP001 	FixedText				aFLineLabel;
//STRIP001 	SvxRelativeField		aFLineIndent;
//STRIP001 	CheckBox				aAutoCB;
//STRIP001 
//STRIP001     FixedLine               aIndentFrm;
//STRIP001 
//STRIP001 	// Abstaende
//STRIP001 	FixedText				aTopLabel;
//STRIP001 	SvxRelativeField		aTopDist;
//STRIP001 	FixedText				aBottomLabel;
//STRIP001 	SvxRelativeField		aBottomDist;
//STRIP001     FixedLine               aDistFrm;
//STRIP001 
//STRIP001 	// Zeilenabstand
//STRIP001 	ListBox					aLineDist;
//STRIP001 	FixedText				aLineDistAtLabel;
//STRIP001 	MetricField				aLineDistAtPercentBox;
//STRIP001 	MetricField				aLineDistAtMetricBox;
//STRIP001     FixedLine               aLineDistFrm;
//STRIP001 	String 					sAbsDist;
//STRIP001 	SvxParaPrevWindow		aExampleWin;
//STRIP001 
//STRIP001 	//Registerhaltigkeit - nur Writer
//STRIP001 	CheckBox				aRegisterCB;
//STRIP001     FixedLine               aRegisterFL;
//STRIP001 
//STRIP001 	Edit*					pActLineDistFld;
//STRIP001 	long					nAbst;
//STRIP001 	long					nWidth;
//STRIP001 	long 					nMinFixDist;
//STRIP001 	BOOL					bRelativeMode;
//STRIP001     BOOL                    bNegativeIndents;
//STRIP001 
//STRIP001 #ifdef _SVX_PARAGRPH_CXX
//STRIP001 	void					SetLineSpacing_Impl( const SvxLineSpacingItem& rAttr );
//STRIP001 	void					Init_Impl();
//STRIP001 	void					UpdateExample_Impl( BOOL bAll = FALSE );
//STRIP001 
//STRIP001 	DECL_LINK( LineDistHdl_Impl, ListBox* );
//STRIP001 	DECL_LINK( ModifyHdl_Impl, SvxRelativeField* );
//STRIP001 	DECL_LINK( AutoHdl_Impl, CheckBox* );
//STRIP001 #endif
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual int				DeactivatePage( SfxItemSet* pSet = 0 );
//STRIP001 
//STRIP001 public:
//STRIP001 	DECL_LINK( ELRLoseFocusHdl, Edit* );
//STRIP001 
//STRIP001 	static SfxTabPage*		Create( Window* pParent, const SfxItemSet& rSet );
//STRIP001 	static USHORT*			GetRanges();
//STRIP001 
//STRIP001 	virtual BOOL			FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual void			Reset( const SfxItemSet& rSet );
//STRIP001 
//STRIP001 
//STRIP001 	void					SetPageWidth( USHORT nPageWidth );
//STRIP001 	void					SetMaxDistance( USHORT nMaxDist );
//STRIP001 	void					EnableRelativeMode();
//STRIP001 	void 					EnableRegisterMode();
//STRIP001 	void					EnableAutoFirstLine();
//STRIP001 	void					EnableAbsLineDist(long nMinTwip);
//STRIP001 	void					EnableNegativeMode();
//STRIP001 };
//STRIP001 
//STRIP001 // class SvxParaAlignTabPage ------------------------------------------------
//STRIP001 
//STRIP001 class SvxParaAlignTabPage : public SfxTabPage
//STRIP001 {
//STRIP001 	// Ausrichtung
//STRIP001 	FixedLine               aAlignFrm;
//STRIP001 	RadioButton             aLeft;
//STRIP001 	RadioButton				aRight;
//STRIP001 	RadioButton				aCenter;
//STRIP001 	RadioButton				aJustify;
//STRIP001 	FixedText				aLastLineFT;
//STRIP001 	ListBox				    aLastLineLB;
//STRIP001 	CheckBox				aExpandCB;
//STRIP001 
//STRIP001 	CheckBox                aSnapToGridCB;
//STRIP001 
//STRIP001 	//preview
//STRIP001 	SvxParaPrevWindow		aExampleWin;
//STRIP001 	//vertical alignment
//STRIP001 	FixedLine               aVertAlignFL;
//STRIP001 
//STRIP001 	FixedText               aVertAlignFT;
//STRIP001 	ListBox                 aVertAlignLB;
//STRIP001 
//STRIP001     FixedLine               	aPropertiesFL;
//STRIP001     FixedText               	aTextDirectionFT;
//STRIP001     svx::FrameDirectionListBox	aTextDirectionLB;
//STRIP001 
//STRIP001 #ifdef _SVX_PARAGRPH_CXX
//STRIP001 	DECL_LINK( 				AlignHdl_Impl, RadioButton* );
//STRIP001     DECL_LINK( 				LastLineHdl_Impl, ListBox* );
//STRIP001     DECL_LINK( 				TextDirectionHdl_Impl, ListBox* );
//STRIP001 
//STRIP001 	void					UpdateExample_Impl( BOOL bAll = FALSE );
//STRIP001 #endif
//STRIP001 
//STRIP001 							SvxParaAlignTabPage( Window* pParent, const SfxItemSet& rSet );
//STRIP001 	virtual					~SvxParaAlignTabPage();
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual int				DeactivatePage( SfxItemSet* pSet = 0 );
//STRIP001 
//STRIP001 public:
//STRIP001 	static SfxTabPage*		Create( Window* pParent, const SfxItemSet& rSet );
//STRIP001 	static USHORT*			GetRanges();
//STRIP001 
//STRIP001 	virtual BOOL			FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual void			Reset( const SfxItemSet& rSet );
//STRIP001 
//STRIP001 	void					EnableJustifyExt();
//STRIP001 };
//STRIP001 
//STRIP001 // class SvxExtParagraphTabPage ------------------------------------------
//STRIP001 
//STRIP001 /*	{k:\svx\prototyp\dialog\paraext.bmp}
//STRIP001 
//STRIP001 	[Beschreibung]
//STRIP001 	Mit dieser TabPage koennen Spezial-Attribute eines Absatzes eingestellt
//STRIP001 	werden (Silbentrennung, Seitenumbruch, Schusterjungen, Hurenkinder, ...).
//STRIP001 
//STRIP001 	[Items]
//STRIP001 	<SvxHyphenZoneItem><SID_ATTR_PARA_HYPHENZONE>
//STRIP001 	<SvxFmtBreakItem><SID_ATTR_PARA_PAGEBREAK>
//STRIP001 	<SvxFmtSplitItem><SID_ATTR_PARA_SPLIT>
//STRIP001 	<SvxWidowsItem><SID_ATTR_PARA_WIDOWS>
//STRIP001 	<SvxOrphansItem><SID_ATTR_PARA_ORPHANS>
//STRIP001 */
//STRIP001 
//STRIP001 class SvxExtParagraphTabPage: public SfxTabPage
//STRIP001 {
//STRIP001 public:
//STRIP001 	virtual				~SvxExtParagraphTabPage();
//STRIP001 
//STRIP001 	static SfxTabPage*	Create(	Window* pParent,
//STRIP001 								const SfxItemSet& rSet );
//STRIP001 	static USHORT*		GetRanges();
//STRIP001 
//STRIP001 	virtual BOOL		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual void		Reset( const SfxItemSet& rSet );
//STRIP001 
//STRIP001 	void				DisablePageBreak();
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );
//STRIP001 
//STRIP001 private:
//STRIP001 						SvxExtParagraphTabPage( Window* pParent, const SfxItemSet& rSet );
//STRIP001 
//STRIP001 	// Silbentrennung
//STRIP001 	TriStateBox			aHyphenBox;
//STRIP001     FixedText			aBeforeText;
//STRIP001 	NumericField		aExtHyphenBeforeBox;
//STRIP001 //	FixedText			aHyphenBeforeLabel;
//STRIP001     FixedText			aAfterText;
//STRIP001 	NumericField		aExtHyphenAfterBox;
//STRIP001 //	FixedText			aHyphenAfterLabel;
//STRIP001 	FixedText     		aMaxHyphenLabel;
//STRIP001 	NumericField        aMaxHyphenEdit;
//STRIP001     FixedLine           aExtFL;
//STRIP001 
//STRIP001 	// Seitenumbruch
//STRIP001 	FixedLine			aBreaksFL;
//STRIP001 	TriStateBox			aPageBreakBox;
//STRIP001     FixedText           aBreakTypeFT;
//STRIP001     ListBox             aBreakTypeLB;
//STRIP001     FixedText           aBreakPositionFT;
//STRIP001     ListBox             aBreakPositionLB;
//STRIP001 	TriStateBox			aApplyCollBtn;
//STRIP001 	ListBox				aApplyCollBox;
//STRIP001 	FixedText           aPagenumText;
//STRIP001 	NumericField       	aPagenumEdit;
//STRIP001 
//STRIP001     FixedLine           aExtendFL;
//STRIP001 
//STRIP001 	// Absatzteilung
//STRIP001 	TriStateBox			aKeepTogetherBox;
//STRIP001 	TriStateBox			aKeepParaBox;
//STRIP001 
//STRIP001 	// Witwen/Waisen
//STRIP001 	TriStateBox			aOrphanBox;
//STRIP001 	NumericField       	aOrphanRowNo;
//STRIP001 	FixedText			aOrphanRowLabel;
//STRIP001 
//STRIP001 	TriStateBox			aWidowBox;
//STRIP001 	NumericField       	aWidowRowNo;
//STRIP001 	FixedText			aWidowRowLabel;
//STRIP001 
//STRIP001 	BOOL                bPageBreak;
//STRIP001 	BOOL				bHtmlMode;
//STRIP001 	USHORT				nStdPos;
//STRIP001 
//STRIP001 #ifdef _SVX_PARAGRPH_CXX
//STRIP001 	DECL_LINK( PageBreakHdl_Impl, TriStateBox* );
//STRIP001 	DECL_LINK( KeepTogetherHdl_Impl, TriStateBox* );
//STRIP001 	DECL_LINK( WidowHdl_Impl, TriStateBox* );
//STRIP001 	DECL_LINK( OrphanHdl_Impl, TriStateBox* );
//STRIP001 	DECL_LINK( HyphenClickHdl_Impl, TriStateBox* );
//STRIP001 	DECL_LINK( ApplyCollClickHdl_Impl, TriStateBox* );
//STRIP001     DECL_LINK( PageBreakPosHdl_Impl, ListBox* );
//STRIP001     DECL_LINK( PageBreakTypeHdl_Impl, ListBox* );
//STRIP001 #endif
//STRIP001 };
//STRIP001 /* -----------------------------29.11.00 11:33--------------------------------
//STRIP001 
//STRIP001  ---------------------------------------------------------------------------*/
//STRIP001 class SvxAsianTabPage : public SfxTabPage
//STRIP001 {
//STRIP001     FixedLine       aOptionsFL;
//STRIP001 
//STRIP001 	TriStateBox		aForbiddenRulesCB;
//STRIP001 	TriStateBox		aAllowWordBreakCB;
//STRIP001 	TriStateBox		aHangingPunctCB;
//STRIP001 
//STRIP001     FixedLine       aCharDistFL;
//STRIP001 	TriStateBox		aPuntuationCB;
//STRIP001 	TriStateBox		aScriptSpaceCB;
//STRIP001 	TriStateBox		aAdjustNumbersCB;
//STRIP001 
//STRIP001 	SvxAsianTabPage( Window* pParent, const SfxItemSet& rSet );
//STRIP001 
//STRIP001 #ifdef _SVX_PARAGRPH_CXX
//STRIP001 	DECL_LINK( ClickHdl_Impl, TriStateBox* );
//STRIP001 #endif
//STRIP001 public:
//STRIP001 	~SvxAsianTabPage();
//STRIP001 
//STRIP001 
//STRIP001 	static SfxTabPage*	Create(	Window* pParent,
//STRIP001 								const SfxItemSet& rSet );
//STRIP001 	static USHORT*		GetRanges();
//STRIP001 
//STRIP001 	virtual BOOL		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual void		Reset( const SfxItemSet& rSet );
//STRIP001 
//STRIP001 };

}//end of namespace binfilter
#endif // #ifndef _SVX_PARAGRPH_HXX

